/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/uri","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/platform/log/common/log","vs/base/common/resources","vs/base/common/types","vs/base/common/network","vs/base/common/arrays","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/buffer","vs/base/common/objects","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/uuid","vs/base/common/process","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/json","os","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/map","child_process","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/jsonEdit","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","minimist","assert","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(K){for(var e=[],D=0,L=K.length;D<L;D++)e[D]=Z[K[D]];return e};define(Z[90],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(L,R){if(!L)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=D}),define(Z[63],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function L(i){const C=[];for(let f in i)D.call(i,f)&&C.push(i[f]);return C}e.values=L;function R(i,C){for(let f in i)if(D.call(i,f)&&C({key:f,value:i[f]},function(){delete i[f]})===!1)return}e.forEach=R;function T(i,C){const f=Object.create(null);for(const I of i){const u=C(I);let E=f[u];E||(E=f[u]=[]),E.push(I)}return f}e.groupBy=T;function k(i){const C=Object.create(null);return i&&i.forEach((f,I)=>{C[I]=f}),C}e.fromMap=k;function P(i,C){const f=[],I=[];for(let u of i)C.has(u)||f.push(u);for(let u of C)i.has(u)||I.push(u);return{removed:f,added:I}}e.diffSets=P;function y(i,C){const f=[],I=[];for(let[u,E]of i)C.has(u)||f.push(E);for(let[u,E]of C)i.has(u)||I.push(E);return{removed:f,added:I}}e.diffMaps=y;class b{constructor(){this.map=new Map}add(C,f){let I=this.map.get(C);I||(I=new Set,this.map.set(C,I)),I.add(f)}delete(C,f){const I=this.map.get(C);!I||(I.delete(f),I.size===0&&this.map.delete(C))}forEach(C,f){const I=this.map.get(C);!I||I.forEach(f)}}e.SetMap=b}),define(Z[64],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(k){return(P,y,b)=>{let i=null,C=null;if(typeof b.value=="function"?(i="value",C=b.value):typeof b.get=="function"&&(i="get",C=b.get),!C)throw new Error("not supported");b[i]=k(C,y)}}e.createDecorator=D;function L(k,P,y){let b=null,i=null;if(typeof y.value=="function"?(b="value",i=y.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(b="get",i=y.get),!i)throw new Error("not supported");const C=`$memoize$${P}`;y[b]=function(...f){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,f)}),this[C]}}e.memoize=L;function R(k,P,y){return D((b,i)=>{const C=`$debounce$${i}`,f=`$debounce$result$${i}`;return function(...I){this[f]||(this[f]=y?y():void 0),clearTimeout(this[C]),P&&(this[f]=P(this[f],...I),I=[this[f]]),this[C]=setTimeout(()=>{b.apply(this,I),this[f]=y?y():void 0},k)}})}e.debounce=R;function T(k,P,y){return D((b,i)=>{const C=`$throttle$timer$${i}`,f=`$throttle$result$${i}`,I=`$throttle$lastRun$${i}`,u=`$throttle$pending$${i}`;return function(...E){if(this[f]||(this[f]=y?y():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),P&&(this[f]=P(this[f],...E)),this[u])return;const g=this[I]+k;g<=Date.now()?(this[I]=Date.now(),b.apply(this,[this[f]]),this[f]=y?y():void 0):(this[u]=!0,this[C]=setTimeout(()=>{this[u]=!1,this[I]=Date.now(),b.apply(this,[this[f]]),this[f]=y?y():void 0},g-Date.now()))}})}e.throttle=T}),define(Z[9],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=D,e.errorHandler=new D;function L(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=L;function R(a){y(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=R;function T(a){y(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=T;function k(a){if(a instanceof Error){let{name:t,message:s}=a;const n=a.stacktrace||a.stack;return{$isError:!0,name:t,message:s,stack:n}}return a}e.transformErrorForSerialization=k;const P="Canceled";function y(a){return a instanceof Error&&a.name===P&&a.message===P}e.isPromiseCanceledError=y;class b extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=b;function i(){const a=new Error(P);return a.name=a.message,a}e.canceled=i;function C(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=C;function f(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=f;function I(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=I;function u(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function E(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=E;class g extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=g;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class m extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=m;function v(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=v;function o(a,t=Object.create(null)){const s=new Error(a);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=o}),define(Z[18],ee([0,1,9]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(_,Y=0){return _[_.length-(1+Y)]}e.tail=L;function R(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}e.tail2=R;function T(_,Y,G=(te,ne)=>te===ne){if(_===Y)return!0;if(!_||!Y||_.length!==Y.length)return!1;for(let te=0,ne=_.length;te<ne;te++)if(!G(_[te],Y[te]))return!1;return!0}e.equals=T;function k(_,Y,G){let te=0,ne=_.length-1;for(;te<=ne;){const J=(te+ne)/2|0,H=G(_[J],Y);if(H<0)te=J+1;else if(H>0)ne=J-1;else return J}return-(te+1)}e.binarySearch=k;function P(_,Y){let G=0,te=_.length;if(te===0)return 0;for(;G<te;){const ne=Math.floor((G+te)/2);Y(_[ne])?te=ne:G=ne+1}return G}e.findFirstInSorted=P;function y(_,Y,G){if(_=_|0,_>=Y.length)throw new TypeError("invalid index");let te=Y[Math.floor(Y.length*Math.random())],ne=[],J=[],H=[];for(let re of Y){const ie=G(re,te);ie<0?ne.push(re):ie>0?J.push(re):H.push(re)}return _<ne.length?y(_,ne,G):_<ne.length+H.length?H[0]:y(_-(ne.length+H.length),J,G)}e.quickSelect=y;function b(_,Y){const G=[];let te;for(const ne of _.slice(0).sort(Y))!te||Y(te[0],ne)!==0?(te=[ne],G.push(te)):te.push(ne);return G}e.groupBy=b;function i(_,Y,G){const te=[];function ne(re,ie,ce){if(ie===0&&ce.length===0)return;const ue=te[te.length-1];ue&&ue.start+ue.deleteCount===re?(ue.deleteCount+=ie,ue.toInsert.push(...ce)):te.push({start:re,deleteCount:ie,toInsert:ce})}let J=0,H=0;for(;;){if(J===_.length){ne(J,0,Y.slice(H));break}if(H===Y.length){ne(J,_.length-J,[]);break}const re=_[J],ie=Y[H],ce=G(re,ie);ce===0?(J+=1,H+=1):ce<0?(ne(J,1,[]),J+=1):ce>0&&(ne(J,0,[ie]),H+=1)}return te}e.sortedDiff=i;function C(_,Y,G){const te=i(_,Y,G),ne=[],J=[];for(const H of te)ne.push(..._.slice(H.start,H.start+H.deleteCount)),J.push(...H.toInsert);return{removed:ne,added:J}}e.delta=C;function f(_,Y,G){if(G===0)return[];const te=_.slice(0,G).sort(Y);return u(_,Y,te,G,_.length),te}e.top=f;function I(_,Y,G,te,ne){return G===0?Promise.resolve([]):new Promise((J,H)=>{(async()=>{const re=_.length,ie=_.slice(0,G).sort(Y);for(let ce=G,ue=Math.min(G+te,re);ce<re;ce=ue,ue=Math.min(ue+te,re)){if(ce>G&&await new Promise(ye=>setTimeout(ye)),ne&&ne.isCancellationRequested)throw(0,D.canceled)();u(_,Y,ie,ce,ue)}return ie})().then(J,H)})}e.topAsync=I;function u(_,Y,G,te,ne){for(const J=G.length;te<ne;te++){const H=_[te];if(Y(H,G[J-1])<0){G.pop();const re=P(G,ie=>Y(H,ie)<0);G.splice(re,0,H)}}}function E(_){return _.filter(Y=>!!Y)}e.coalesce=E;function g(_){let Y=0;for(let G=0;G<_.length;G++)_[G]&&(_[Y]=_[G],Y+=1);_.length=Y}e.coalesceInPlace=g;function w(_,Y,G){_.splice(G,0,_.splice(Y,1)[0])}e.move=w;function m(_){return!Array.isArray(_)||_.length===0}e.isFalsyOrEmpty=m;function v(_){return Array.isArray(_)&&_.length>0}e.isNonEmptyArray=v;function o(_,Y){if(!Y)return _.filter((te,ne)=>_.indexOf(te)===ne);const G=Object.create(null);return _.filter(te=>{const ne=Y(te);return G[ne]?!1:(G[ne]=!0,!0)})}e.distinct=o;function a(_){const Y=new Set;return _.filter(G=>Y.has(G)?!1:(Y.add(G),!0))}e.distinctES6=a;function t(_){const Y=Object.create(null);return G=>{const te=_(G);return Y[te]?!1:(Y[te]=!0,!0)}}e.uniqueFilter=t;function s(_,Y){for(let G=_.length-1;G>=0;G--){const te=_[G];if(Y(te))return G}return-1}e.lastIndex=s;function n(_,Y){return _.length>0?_[0]:Y}e.firstOrDefault=n;function r(_,Y,G=(te,ne)=>te===ne){let te=0;for(let ne=0,J=Math.min(_.length,Y.length);ne<J&&G(_[ne],Y[ne]);ne++)te++;return te}e.commonPrefixLength=r;function c(_){return[].concat(..._)}e.flatten=c;function l(_,Y){let G=typeof Y=="number"?_:0;typeof Y=="number"?G=_:(G=0,Y=_);const te=[];if(G<=Y)for(let ne=G;ne<Y;ne++)te.push(ne);else for(let ne=G;ne>Y;ne--)te.push(ne);return te}e.range=l;function h(_,Y,G){return _.reduce((te,ne)=>(te[Y(ne)]=G?G(ne):ne,te),Object.create(null))}e.index=h;function d(_,Y){return _.push(Y),()=>p(_,Y)}e.insert=d;function p(_,Y){const G=_.indexOf(Y);if(G>-1)return _.splice(G,1),Y}e.remove=p;function A(_,Y,G){const te=_.slice(0,Y),ne=_.slice(Y);return te.concat(G,ne)}e.arrayInsert=A;function O(_,Y){let G;if(typeof Y=="number"){let te=Y;G=()=>{const ne=Math.sin(te++)*179426549;return ne-Math.floor(ne)}}else G=Math.random;for(let te=_.length-1;te>0;te-=1){const ne=Math.floor(G()*(te+1)),J=_[te];_[te]=_[ne],_[ne]=J}}e.shuffle=O;function S(_,Y){const G=_.indexOf(Y);G>-1&&(_.splice(G,1),_.unshift(Y))}e.pushToStart=S;function U(_,Y){const G=_.indexOf(Y);G>-1&&(_.splice(G,1),_.push(Y))}e.pushToEnd=U;function F(_,Y){return Array.isArray(_)?_.map(Y):Y(_)}e.mapArrayOrNot=F;function z(_){return Array.isArray(_)?_:[_]}e.asArray=z;function j(_){return _[Math.floor(Math.random()*_.length)]}e.getRandomElement=j;function M(_,Y){for(const G of _){const te=Y(G);if(te!==void 0)return te}}e.mapFind=M;function W(_,Y,G){const te=$(_,Y),ne=_.length,J=G.length;_.length=ne+J;for(let H=ne-1;H>=te;H--)_[H+J]=_[H];for(let H=0;H<J;H++)_[H+te]=G[H]}e.insertInto=W;function x(_,Y,G,te){const ne=$(_,Y),J=_.splice(ne,G);return W(_,ne,te),J}e.splice=x;function $(_,Y){return Y<0?Math.max(Y+_.length,0):Math.min(Y,_.length)}function q(_,Y){let G=Number.MAX_SAFE_INTEGER,te=0;return _.forEach((ne,J)=>{const H=Y(ne);H<G&&(G=H,te=J)}),te}e.minIndex=q;function N(_,Y){let G=Number.MIN_SAFE_INTEGER,te=0;return _.forEach((ne,J)=>{const H=Y(ne);H>G&&(G=H,te=J)}),te}e.maxIndex=N;class V{constructor(Y){this.items=Y,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Y){let G=this.firstIdx;for(;G<this.items.length&&Y(this.items[G]);)G++;const te=G===this.firstIdx?null:this.items.slice(this.firstIdx,G);return this.firstIdx=G,te}takeFromEndWhile(Y){let G=this.lastIdx;for(;G>=0&&Y(this.items[G]);)G--;const te=G===this.lastIdx?null:this.items.slice(G+1,this.lastIdx+1);return this.lastIdx=G,te}}e.ArrayQueue=V}),define(Z[65],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(L){const R=this;let T=!1,k;return function(){return T||(T=!0,k=L.apply(R,arguments)),k}}e.once=D}),define(Z[55],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(L){function R(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}L.is=R;const T=Object.freeze([]);function k(){return T}L.empty=k;function*P(a){yield a}L.single=P;function y(a){return a||T}L.from=y;function b(a){return!a||a[Symbol.iterator]().next().done===!0}L.isEmpty=b;function i(a){return a[Symbol.iterator]().next().value}L.first=i;function C(a,t){for(const s of a)if(t(s))return!0;return!1}L.some=C;function f(a,t){for(const s of a)if(t(s))return s}L.find=f;function*I(a,t){for(const s of a)t(s)&&(yield s)}L.filter=I;function*u(a,t){let s=0;for(const n of a)yield t(n,s++)}L.map=u;function*E(...a){for(const t of a)for(const s of t)yield s}L.concat=E;function*g(a){for(const t of a)for(const s of t)yield s}L.concatNested=g;function w(a,t,s){let n=s;for(const r of a)n=t(n,r);return n}L.reduce=w;function*m(a,t,s=a.length){for(t<0&&(t+=a.length),s<0?s+=a.length:s>a.length&&(s=a.length);t<s;t++)yield a[t]}L.slice=m;function v(a,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,a];const n=a[Symbol.iterator]();for(let r=0;r<t;r++){const c=n.next();if(c.done)return[s,L.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return n}}]}L.consume=v;function o(a,t,s=(n,r)=>n===r){const n=a[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const c=n.next(),l=r.next();if(c.done!==l.done)return!1;if(c.done)return!0;if(!s(c.value,l.value))return!1}}L.equals=o})(D=e.Iterable||(e.Iterable={}))}),define(Z[34],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function k(t,s=!1){let n=0,r=t.length,c="",l=0,h=16,d=0;function p(j){let M=0,W=0;for(;M<j;){const x=t.charCodeAt(n);if(x>=48&&x<=57)W=W*16+x-48;else if(x>=65&&x<=70)W=W*16+x-65+10;else if(x>=97&&x<=102)W=W*16+x-97+10;else break;n++,M++}return M<j&&(W=-1),W}function A(j){n=j,c="",l=0,h=16,d=0}function O(){const j=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&b(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&b(t.charCodeAt(n)))for(n++;n<t.length&&b(t.charCodeAt(n));)n++;else return d=3,t.substring(j,n);let M=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&b(t.charCodeAt(n))){for(n++;n<t.length&&b(t.charCodeAt(n));)n++;M=n}else d=3;return t.substring(j,M)}function S(){let j="",M=n;for(;;){if(n>=r){j+=t.substring(M,n),d=2;break}const W=t.charCodeAt(n);if(W===34){j+=t.substring(M,n),n++;break}if(W===92){if(j+=t.substring(M,n),n++,n>=r){d=2;break}switch(t.charCodeAt(n++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:const $=p(4);$>=0?j+=String.fromCharCode($):d=4;break;default:d=5}M=n;continue}if(W>=0&&W<=31)if(y(W)){j+=t.substring(M,n),d=2;break}else d=6;n++}return j}function U(){if(c="",d=0,l=n,n>=r)return l=r,h=17;let j=t.charCodeAt(n);if(P(j)){do n++,c+=String.fromCharCode(j),j=t.charCodeAt(n);while(P(j));return h=15}if(y(j))return n++,c+=String.fromCharCode(j),j===13&&t.charCodeAt(n)===10&&(n++,c+=`
`),h=14;switch(j){case 123:return n++,h=1;case 125:return n++,h=2;case 91:return n++,h=3;case 93:return n++,h=4;case 58:return n++,h=6;case 44:return n++,h=5;case 34:return n++,c=S(),h=10;case 47:const M=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<r&&!y(t.charCodeAt(n));)n++;return c=t.substring(M,n),h=12}if(t.charCodeAt(n+1)===42){n+=2;const W=r-1;let x=!1;for(;n<W;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,d=1),c=t.substring(M,n),h=13}return c+=String.fromCharCode(j),n++,h=16;case 45:if(c+=String.fromCharCode(j),n++,n===r||!b(t.charCodeAt(n)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=O(),h=11;default:for(;n<r&&F(j);)n++,j=t.charCodeAt(n);if(l!==n){switch(c=t.substring(l,n),c){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return c+=String.fromCharCode(j),n++,h=16}}function F(j){if(P(j)||y(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let j;do j=U();while(j>=12&&j<=15);return j}return{setPosition:A,getPosition:()=>n,scan:s?z:U,getToken:()=>h,getTokenValue:()=>c,getTokenOffset:()=>l,getTokenLength:()=>n-l,getTokenError:()=>d}}e.createScanner=k;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function b(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function C(t,s){const n=[],r=new Object;let c;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function d(p,A,O,S){l.value=p,l.offset=A,l.length=O,l.type=S,l.colonOffset=void 0,c=l}try{v(t,{onObjectBegin:(p,A)=>{if(s<=p)throw r;c=void 0,h=s>p,n.push("")},onObjectProperty:(p,A,O)=>{if(s<A||(d(p,A,O,"property"),n[n.length-1]=p,s<=A+O))throw r},onObjectEnd:(p,A)=>{if(s<=p)throw r;c=void 0,n.pop()},onArrayBegin:(p,A)=>{if(s<=p)throw r;c=void 0,n.push(0)},onArrayEnd:(p,A)=>{if(s<=p)throw r;c=void 0,n.pop()},onLiteralValue:(p,A,O)=>{if(s<A||(d(p,A,O,a(p)),s<=A+O))throw r},onSeparator:(p,A,O)=>{if(s<=A)throw r;if(p===":"&&c&&c.type==="property")c.colonOffset=A,h=!1,c=void 0;else if(p===","){const S=n[n.length-1];typeof S=="number"?n[n.length-1]=S+1:(h=!0,n[n.length-1]=""),c=void 0}}})}catch(p){if(p!==r)throw p}return{path:n,previousNode:c,isAtPropertyKey:h,matches:p=>{let A=0;for(let O=0;A<p.length&&O<n.length;O++)if(p[A]===n[O]||p[A]==="*")A++;else if(p[A]!=="**")return!1;return A===p.length}}}e.getLocation=C;function f(t,s=[],n=T.DEFAULT){let r=null,c=[];const l=[];function h(p){Array.isArray(c)?c.push(p):r!==null&&(c[r]=p)}return v(t,{onObjectBegin:()=>{const p={};h(p),l.push(c),c=p,r=null},onObjectProperty:p=>{r=p},onObjectEnd:()=>{c=l.pop()},onArrayBegin:()=>{const p=[];h(p),l.push(c),c=p,r=null},onArrayEnd:()=>{c=l.pop()},onLiteralValue:h,onError:(p,A,O)=>{s.push({error:p,offset:A,length:O})}},n),c[0]}e.parse=f;function I(t,s=[],n=T.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(p){r.type==="property"&&(r.length=p-r.offset,r=r.parent)}function l(p){return r.children.push(p),p}v(t,{onObjectBegin:p=>{r=l({type:"object",offset:p,length:-1,parent:r,children:[]})},onObjectProperty:(p,A,O)=>{r=l({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:p,offset:A,length:O,parent:r})},onObjectEnd:(p,A)=>{r.length=p+A-r.offset,r=r.parent,c(p+A)},onArrayBegin:(p,A)=>{r=l({type:"array",offset:p,length:-1,parent:r,children:[]})},onArrayEnd:(p,A)=>{r.length=p+A-r.offset,r=r.parent,c(p+A)},onLiteralValue:(p,A,O)=>{l({type:a(p),offset:A,length:O,parent:r,value:p}),c(A+O)},onSeparator:(p,A,O)=>{r.type==="property"&&(p===":"?r.colonOffset=A:p===","&&c(A))},onError:(p,A,O)=>{s.push({error:p,offset:A,length:O})}},n);const d=r.children[0];return d&&delete d.parent,d}e.parseTree=I;function u(t,s){if(!t)return;let n=t;for(let r of s)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let c=!1;for(const l of n.children)if(Array.isArray(l.children)&&l.children[0].value===r){n=l.children[1],c=!0;break}if(!c)return}else{const c=r;if(n.type!=="array"||c<0||!Array.isArray(n.children)||c>=n.children.length)return;n=n.children[c]}return n}e.findNodeAtLocation=u;function E(t){if(!t.parent||!t.parent.children)return[];const s=E(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;s.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&s.push(n)}return s}e.getNodePath=E;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":const s=Object.create(null);for(let n of t.children){const r=n.children[1];r&&(s[n.children[0].value]=g(r))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=g;function w(t,s,n=!1){return s>=t.offset&&s<t.offset+t.length||n&&s===t.offset+t.length}e.contains=w;function m(t,s,n=!1){if(w(t,s,n)){const r=t.children;if(Array.isArray(r))for(let c=0;c<r.length&&r[c].offset<=s;c++){const l=m(r[c],s,n);if(l)return l}return t}}e.findNodeAtOffset=m;function v(t,s,n=T.DEFAULT){const r=k(t,!1);function c(G){return G?()=>G(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(G){return G?te=>G(te,r.getTokenOffset(),r.getTokenLength()):()=>!0}const h=c(s.onObjectBegin),d=l(s.onObjectProperty),p=c(s.onObjectEnd),A=c(s.onArrayBegin),O=c(s.onArrayEnd),S=l(s.onLiteralValue),U=l(s.onSeparator),F=c(s.onComment),z=l(s.onError),j=n&&n.disallowComments,M=n&&n.allowTrailingComma;function W(){for(;;){const G=r.scan();switch(r.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:j||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(G){case 12:case 13:j?x(10):F();break;case 16:x(1);break;case 15:case 14:break;default:return G}}}function x(G,te=[],ne=[]){if(z(G),te.length+ne.length>0){let J=r.getToken();for(;J!==17;){if(te.indexOf(J)!==-1){W();break}else if(ne.indexOf(J)!==-1)break;J=W()}}}function $(G){const te=r.getTokenValue();return G?S(te):d(te),W(),!0}function q(){switch(r.getToken()){case 11:let G=0;try{G=JSON.parse(r.getTokenValue()),typeof G!="number"&&(x(2),G=0)}catch(te){x(2)}S(G);break;case 7:S(null);break;case 8:S(!0);break;case 9:S(!1);break;default:return!1}return W(),!0}function N(){return r.getToken()!==10?(x(3,[],[2,5]),!1):($(!1),r.getToken()===6?(U(":"),W(),Y()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function V(){h(),W();let G=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(G||x(4,[],[]),U(","),W(),r.getToken()===2&&M)break}else G&&x(6,[],[]);N()||x(4,[],[2,5]),G=!0}return p(),r.getToken()!==2?x(7,[2],[]):W(),!0}function _(){A(),W();let G=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(G||x(4,[],[]),U(","),W(),r.getToken()===4&&M)break}else G&&x(6,[],[]);Y()||x(4,[],[4,5]),G=!0}return O(),r.getToken()!==4?x(8,[4],[]):W(),!0}function Y(){switch(r.getToken()){case 3:return _();case 1:return V();case 10:return $(!0);default:return q()}}return W(),r.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):Y()?(r.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.visit=v;function o(t,s){let n=k(t),r=[],c,l=0,h;do switch(h=n.getPosition(),c=n.scan(),c){case 12:case 13:case 17:l!==h&&r.push(t.substring(l,h)),s!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,s)),l=n.getPosition();break}while(c!==17);return r.join("")}e.stripComments=o;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(Z[48],ee([0,1,34]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(y,b,i){let C,f,I,u,E;if(b){for(u=b.offset,E=u+b.length,I=u;I>0&&!P(y,I-1);)I--;let l=E;for(;l<y.length&&!P(y,l);)l++;f=y.substring(I,l),C=T(f,i)}else f=y,C=0,I=0,u=0,E=y.length;const g=k(i,y);let w=!1,m=0,v;i.insertSpaces?v=R(" ",i.tabSize||4):v="	";const o=(0,D.createScanner)(f,!1);let a=!1;function t(){return g+R(v,C+m)}function s(){let l=o.scan();for(w=!1;l===15||l===14;)w=w||l===14,l=o.scan();return a=l===16||o.getTokenError()!==0,l}const n=[];function r(l,h,d){!a&&h<E&&d>u&&y.substring(h,d)!==l&&n.push({offset:h,length:d-h,content:l})}let c=s();if(c!==17){const l=o.getTokenOffset()+I,h=R(v,C);r(h,I,l)}for(;c!==17;){let l=o.getTokenOffset()+o.getTokenLength()+I,h=s(),d="";for(;!w&&(h===12||h===13);){const A=o.getTokenOffset()+I;r(" ",l,A),l=o.getTokenOffset()+o.getTokenLength()+I,d=h===12?t():"",h=s()}if(h===2)c!==1&&(m--,d=t());else if(h===4)c!==3&&(m--,d=t());else{switch(c){case 3:case 1:m++,d=t();break;case 5:case 12:d=t();break;case 13:w?d=t():d=" ";break;case 6:d=" ";break;case 10:if(h===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?d=" ":h!==5&&h!==17&&(a=!0);break;case 16:a=!0;break}w&&(h===12||h===13)&&(d=t())}const p=o.getTokenOffset()+I;r(d,l,p),c=h}return n}e.format=L;function R(y,b){let i="";for(let C=0;C<b;C++)i+=y;return i}function T(y,b){let i=0,C=0;const f=b.tabSize||4;for(;i<y.length;){const I=y.charAt(i);if(I===" ")C++;else if(I==="	")C+=f;else break;i++}return Math.floor(C/f)}function k(y,b){for(let i=0;i<b.length;i++){const C=b.charAt(i);if(C==="\r")return i+1<b.length&&b.charAt(i+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=k;function P(y,b){return`\r
`.indexOf(y.charAt(b))!==-1}e.isEOL=P}),define(Z[45],ee([0,1,34,48]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(b,i,C){return T(b,i,void 0,C)}e.removeProperty=R;function T(b,i,C,f,I){const u=i.slice(),E=[],g=(0,D.parseTree)(b,E);let w,m;for(;u.length>0&&(m=u.pop(),w=(0,D.findNodeAtLocation)(g,u),w===void 0&&C!==void 0);)typeof m=="string"?C={[m]:C}:C=[C];if(w)if(w.type==="object"&&typeof m=="string"&&Array.isArray(w.children)){const v=(0,D.findNodeAtLocation)(w,[m]);if(v!==void 0)if(C===void 0){if(!v.parent)throw new Error("Malformed AST");const o=w.children.indexOf(v.parent);let a,t=v.parent.offset+v.parent.length;if(o>0){const s=w.children[o-1];a=s.offset+s.length}else a=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return k(b,{offset:a,length:t-a,content:""},f)}else return k(b,{offset:v.offset,length:v.length,content:JSON.stringify(C)},f);else{if(C===void 0)return[];const o=`${JSON.stringify(m)}: ${JSON.stringify(C)}`,a=I?I(w.children.map(s=>s.children[0].value)):w.children.length;let t;if(a>0){const s=w.children[a-1];t={offset:s.offset+s.length,length:0,content:","+o}}else w.children.length===0?t={offset:w.offset+1,length:0,content:o}:t={offset:w.offset+1,length:0,content:o+","};return k(b,t,f)}}else if(w.type==="array"&&typeof m=="number"&&Array.isArray(w.children))if(C!==void 0){const v=`${JSON.stringify(C)}`;let o;if(w.children.length===0||m===0)o={offset:w.offset+1,length:0,content:w.children.length===0?v:v+","};else{const a=m===-1||m>w.children.length?w.children.length:m,t=w.children[a-1];o={offset:t.offset+t.length,length:0,content:","+v}}return k(b,o,f)}else{const v=m,o=w.children[v];let a;if(w.children.length===1)a={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===v){const t=w.children[v-1],s=t.offset+t.length,n=w.offset+w.length;a={offset:s,length:n-2-s,content:""}}else a={offset:o.offset,length:w.children[v+1].offset-o.offset,content:""};return k(b,a,f)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${w.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return k(b,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(C)},f)}}e.setProperty=T;function k(b,i,C){let f=P(b,i),I=i.offset,u=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;I>0&&!(0,L.isEOL)(f,I-1);)I--;for(;u<f.length&&!(0,L.isEOL)(f,u);)u++}const E=(0,L.format)(f,{offset:I,length:u-I},C);for(let w=E.length-1;w>=0;w--){const m=E[w];f=P(f,m),I=Math.min(I,m.offset),u=Math.max(u,m.offset+m.length),u+=m.content.length-m.length}const g=b.length-(f.length-u)-I;return[{offset:I,length:g,content:f.substring(I,u)}]}e.withFormatting=k;function P(b,i){return b.substring(0,i.offset)+i.content+b.substring(i.offset+i.length)}e.applyEdit=P;function y(b,i){let C=i.slice(0).sort((I,u)=>{const E=I.offset-u.offset;return E===0?I.length-u.length:E}),f=b.length;for(let I=C.length-1;I>=0;I--){let u=C[I];if(u.offset+u.length<=f)b=P(b,u);else throw new Error("Overlapping edit");f=u.offset}return b}e.applyEdits=y}),define(Z[2],ee([0,1,65,55]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let T=null;function k(n){T=n}if(e.setDisposableTracker=k,R){const n="__is_disposable_tracked__";k(new class{trackDisposable(r){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[n]||console.log(c)},3e3)}setParent(r,c){if(r&&r!==m.None)try{r[n]=!0}catch{}}markAsDisposed(r){if(r&&r!==m.None)try{r[n]=!0}catch{}}markAsSingleton(r){}})}function P(n){return T?.trackDisposable(n),n}function y(n){T?.markAsDisposed(n)}function b(n,r){T?.setParent(n,r)}function i(n,r){if(!!T)for(const c of n)T.setParent(c,r)}function C(n){return T?.markAsSingleton(n),n}e.markAsSingleton=C;class f extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=f;function I(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=I;function u(n){if(L.Iterable.is(n)){let r=[];for(const c of n)if(c)try{c.dispose()}catch(l){r.push(l)}if(r.length===1)throw r[0];if(r.length>1)throw new f(r);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=u;function E(...n){const r=g(()=>u(n));return i(n,r),r}e.combinedDisposable=E;function g(n){const r=P({dispose:(0,D.once)(()=>{y(r),n()})});return r}e.toDisposable=g;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return b(r,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new w,P(this),b(this._store,this)}dispose(){y(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class v{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&b(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&b(r,null),r}}e.MutableDisposable=v;class o{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class a{constructor(){this.references=new Map}acquire(r,...c){let l=this.references.get(r);l||(l={counter:0,object:this.createReferencedObject(r,...c)},this.references.set(r,l));const{object:h}=l,d=(0,D.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(r,l.object),this.references.delete(r))});return l.counter++,{object:h,dispose:d}}}e.ReferenceCollection=a;class t{constructor(r){this.referenceCollection=r}async acquire(r,...c){const l=this.referenceCollection.acquire(r,...c);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(h){throw l.dispose(),h}}}e.AsyncReferenceCollection=t;class s{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=s}),define(Z[91],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(T){this.element=T,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class L{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let T=this._first;for(;T!==D.Undefined;){const k=T.next;T.prev=D.Undefined,T.next=D.Undefined,T=k}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,k){const P=new D(T);if(this._first===D.Undefined)this._first=P,this._last=P;else if(k){const b=this._last;this._last=P,P.prev=b,b.next=P}else{const b=this._first;this._first=P,P.next=b,b.prev=P}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==D.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==D.Undefined&&T.next!==D.Undefined){const k=T.prev;k.next=T.next,T.next.prev=k}else T.prev===D.Undefined&&T.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):T.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):T.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==D.Undefined;)yield T.element,T=T.next}}e.LinkedList=L}),function(){function K(R){const T=[];typeof R=="number"&&T.push("code/timeOrigin",R);function k(y){T.push(y,Date.now())}function P(){const y=[];for(let b=0;b<T.length;b+=2)y.push({name:T[b],startTime:T[b+1]});return y}return{mark:k,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const k of performance.getEntriesByType("mark"))T.push({name:k.name,startTime:Math.round(R+k.startTime)});return T}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=D(L))}(),define(Z[4],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let L=!1,R=!1,T=!1,k=!1,P=!1,y=!1,b=!1,i,C=D,f,I;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const E=typeof u?.versions?.electron=="string"&&u.type==="renderer";if(e.isElectronSandboxed=E&&u?.sandboxed,typeof navigator=="object"&&!E)I=navigator.userAgent,L=I.indexOf("Windows")>=0,R=I.indexOf("Macintosh")>=0,b=(I.indexOf("Macintosh")>=0||I.indexOf("iPad")>=0||I.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=I.indexOf("Linux")>=0,y=!0,i=navigator.language,C=i;else if(typeof u=="object"){L=u.platform==="win32",R=u.platform==="darwin",T=u.platform==="linux",k=T&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,i=D,C=D;const n=u.env.VSCODE_NLS_CONFIG;if(n)try{const r=JSON.parse(n),c=r.availableLanguages["*"];i=r.locale,C=c||D,f=r._translationsConfigFile}catch(r){}P=!0}else console.error("Unable to resolve platform.");var g;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function w(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let m=0;R?m=1:L?m=3:T&&(m=2),e.isWindows=L,e.isMacintosh=R,e.isLinux=T,e.isLinuxSnap=k,e.isNative=P,e.isWeb=y,e.isIOS=b,e.platform=m,e.userAgent=I,e.language=C;var v;(function(n){function r(){return e.language}n.value=r;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=c;function l(){return e.language==="en"}n.isDefault=l})(v=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeSetImmediateId)for(let d=0,p=c.length;d<p;d++){const A=c[d];if(A.id===h.data.vscodeSetImmediateId){c.splice(d,1),A.callback();return}}});let l=0;return h=>{const d=++l;c.push({id:d,callback:h}),e.globals.postMessage({vscodeSetImmediateId:d},"*")}}if(typeof u?.nextTick=="function")return u.nextTick.bind(u);const r=Promise.resolve();return c=>r.then(c)}();var o;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||b?2:L?1:3;let a=!0,t=!1;function s(){if(!t){t=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,a=new Uint16Array(n.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=s}),define(Z[31],ee([0,1,4]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const R=D.globals.vscode.process;L={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()},nextTick(T){return(0,D.setImmediate)(T)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}}:L={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},nextTick(R){return(0,D.setImmediate)(R)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(Z[8],ee([0,1,31]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,R=97,T=90,k=122,P=46,y=47,b=92,i=58,C=63;class f extends Error{constructor(o,a,t){let s;typeof a=="string"&&a.indexOf("not ")===0?(s="must not be",a=a.replace(/^not /,"")):s="must be";const n=o.indexOf(".")!==-1?"property":"argument";let r=`The "${o}" ${n} ${s} of type ${a}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function I(v,o){if(typeof v!="string")throw new f(o,"string",v)}function u(v){return v===y||v===b}function E(v){return v===y}function g(v){return v>=L&&v<=T||v>=R&&v<=k}function w(v,o,a,t){let s="",n=0,r=-1,c=0,l=0;for(let h=0;h<=v.length;++h){if(h<v.length)l=v.charCodeAt(h);else{if(t(l))break;l=y}if(t(l)){if(!(r===h-1||c===1))if(c===2){if(s.length<2||n!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const d=s.lastIndexOf(a);d===-1?(s="",n=0):(s=s.slice(0,d),n=s.length-1-s.lastIndexOf(a)),r=h,c=0;continue}else if(s.length!==0){s="",n=0,r=h,c=0;continue}}o&&(s+=s.length>0?`${a}..`:"..",n=2)}else s.length>0?s+=`${a}${v.slice(r+1,h)}`:s=v.slice(r+1,h),n=h-r-1;r=h,c=0}else l===P&&c!==-1?++c:c=-1}return s}function m(v,o){if(o===null||typeof o!="object")throw new f("pathObject","Object",o);const a=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return a?a===o.root?`${a}${t}`:`${a}${v}${t}`:t}e.win32={resolve(...v){let o="",a="",t=!1;for(let s=v.length-1;s>=-1;s--){let n;if(s>=0){if(n=v[s],I(n,"path"),n.length===0)continue}else o.length===0?n=D.cwd():(n=D.env[`=${o}`]||D.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==o.toLowerCase()&&n.charCodeAt(2)===b)&&(n=`${o}\\`));const r=n.length;let c=0,l="",h=!1;const d=n.charCodeAt(0);if(r===1)u(d)&&(c=1,h=!0);else if(u(d))if(h=!0,u(n.charCodeAt(1))){let p=2,A=p;for(;p<r&&!u(n.charCodeAt(p));)p++;if(p<r&&p!==A){const O=n.slice(A,p);for(A=p;p<r&&u(n.charCodeAt(p));)p++;if(p<r&&p!==A){for(A=p;p<r&&!u(n.charCodeAt(p));)p++;(p===r||p!==A)&&(l=`\\\\${O}\\${n.slice(A,p)}`,c=p)}}}else c=1;else g(d)&&n.charCodeAt(1)===i&&(l=n.slice(0,2),c=2,r>2&&u(n.charCodeAt(2))&&(h=!0,c=3));if(l.length>0)if(o.length>0){if(l.toLowerCase()!==o.toLowerCase())continue}else o=l;if(t){if(o.length>0)break}else if(a=`${n.slice(c)}\\${a}`,t=h,h&&o.length>0)break}return a=w(a,!t,"\\",u),t?`${o}\\${a}`:`${o}${a}`||"."},normalize(v){I(v,"path");const o=v.length;if(o===0)return".";let a=0,t,s=!1;const n=v.charCodeAt(0);if(o===1)return E(n)?"\\":v;if(u(n))if(s=!0,u(v.charCodeAt(1))){let c=2,l=c;for(;c<o&&!u(v.charCodeAt(c));)c++;if(c<o&&c!==l){const h=v.slice(l,c);for(l=c;c<o&&u(v.charCodeAt(c));)c++;if(c<o&&c!==l){for(l=c;c<o&&!u(v.charCodeAt(c));)c++;if(c===o)return`\\\\${h}\\${v.slice(l)}\\`;c!==l&&(t=`\\\\${h}\\${v.slice(l,c)}`,a=c)}}}else a=1;else g(n)&&v.charCodeAt(1)===i&&(t=v.slice(0,2),a=2,o>2&&u(v.charCodeAt(2))&&(s=!0,a=3));let r=a<o?w(v.slice(a),!s,"\\",u):"";return r.length===0&&!s&&(r="."),r.length>0&&u(v.charCodeAt(o-1))&&(r+="\\"),t===void 0?s?`\\${r}`:r:s?`${t}\\${r}`:`${t}${r}`},isAbsolute(v){I(v,"path");const o=v.length;if(o===0)return!1;const a=v.charCodeAt(0);return u(a)||o>2&&g(a)&&v.charCodeAt(1)===i&&u(v.charCodeAt(2))},join(...v){if(v.length===0)return".";let o,a;for(let n=0;n<v.length;++n){const r=v[n];I(r,"path"),r.length>0&&(o===void 0?o=a=r:o+=`\\${r}`)}if(o===void 0)return".";let t=!0,s=0;if(typeof a=="string"&&u(a.charCodeAt(0))){++s;const n=a.length;n>1&&u(a.charCodeAt(1))&&(++s,n>2&&(u(a.charCodeAt(2))?++s:t=!1))}if(t){for(;s<o.length&&u(o.charCodeAt(s));)s++;s>=2&&(o=`\\${o.slice(s)}`)}return e.win32.normalize(o)},relative(v,o){if(I(v,"from"),I(o,"to"),v===o)return"";const a=e.win32.resolve(v),t=e.win32.resolve(o);if(a===t||(v=a.toLowerCase(),o=t.toLowerCase(),v===o))return"";let s=0;for(;s<v.length&&v.charCodeAt(s)===b;)s++;let n=v.length;for(;n-1>s&&v.charCodeAt(n-1)===b;)n--;const r=n-s;let c=0;for(;c<o.length&&o.charCodeAt(c)===b;)c++;let l=o.length;for(;l-1>c&&o.charCodeAt(l-1)===b;)l--;const h=l-c,d=r<h?r:h;let p=-1,A=0;for(;A<d;A++){const S=v.charCodeAt(s+A);if(S!==o.charCodeAt(c+A))break;S===b&&(p=A)}if(A!==d){if(p===-1)return t}else{if(h>d){if(o.charCodeAt(c+A)===b)return t.slice(c+A+1);if(A===2)return t.slice(c+A)}r>d&&(v.charCodeAt(s+A)===b?p=A:A===2&&(p=3)),p===-1&&(p=0)}let O="";for(A=s+p+1;A<=n;++A)(A===n||v.charCodeAt(A)===b)&&(O+=O.length===0?"..":"\\..");return c+=p,O.length>0?`${O}${t.slice(c,l)}`:(t.charCodeAt(c)===b&&++c,t.slice(c,l))},toNamespacedPath(v){if(typeof v!="string")return v;if(v.length===0)return"";const o=e.win32.resolve(v);if(o.length<=2)return v;if(o.charCodeAt(0)===b){if(o.charCodeAt(1)===b){const a=o.charCodeAt(2);if(a!==C&&a!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(g(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===b)return`\\\\?\\${o}`;return v},dirname(v){I(v,"path");const o=v.length;if(o===0)return".";let a=-1,t=0;const s=v.charCodeAt(0);if(o===1)return u(s)?v:".";if(u(s)){if(a=t=1,u(v.charCodeAt(1))){let c=2,l=c;for(;c<o&&!u(v.charCodeAt(c));)c++;if(c<o&&c!==l){for(l=c;c<o&&u(v.charCodeAt(c));)c++;if(c<o&&c!==l){for(l=c;c<o&&!u(v.charCodeAt(c));)c++;if(c===o)return v;c!==l&&(a=t=c+1)}}}}else g(s)&&v.charCodeAt(1)===i&&(a=o>2&&u(v.charCodeAt(2))?3:2,t=a);let n=-1,r=!0;for(let c=o-1;c>=t;--c)if(u(v.charCodeAt(c))){if(!r){n=c;break}}else r=!1;if(n===-1){if(a===-1)return".";n=a}return v.slice(0,n)},basename(v,o){o!==void 0&&I(o,"ext"),I(v,"path");let a=0,t=-1,s=!0,n;if(v.length>=2&&g(v.charCodeAt(0))&&v.charCodeAt(1)===i&&(a=2),o!==void 0&&o.length>0&&o.length<=v.length){if(o===v)return"";let r=o.length-1,c=-1;for(n=v.length-1;n>=a;--n){const l=v.charCodeAt(n);if(u(l)){if(!s){a=n+1;break}}else c===-1&&(s=!1,c=n+1),r>=0&&(l===o.charCodeAt(r)?--r==-1&&(t=n):(r=-1,t=c))}return a===t?t=c:t===-1&&(t=v.length),v.slice(a,t)}for(n=v.length-1;n>=a;--n)if(u(v.charCodeAt(n))){if(!s){a=n+1;break}}else t===-1&&(s=!1,t=n+1);return t===-1?"":v.slice(a,t)},extname(v){I(v,"path");let o=0,a=-1,t=0,s=-1,n=!0,r=0;v.length>=2&&v.charCodeAt(1)===i&&g(v.charCodeAt(0))&&(o=t=2);for(let c=v.length-1;c>=o;--c){const l=v.charCodeAt(c);if(u(l)){if(!n){t=c+1;break}continue}s===-1&&(n=!1,s=c+1),l===P?a===-1?a=c:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||s===-1||r===0||r===1&&a===s-1&&a===t+1?"":v.slice(a,s)},format:m.bind(null,"\\"),parse(v){I(v,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return o;const a=v.length;let t=0,s=v.charCodeAt(0);if(a===1)return u(s)?(o.root=o.dir=v,o):(o.base=o.name=v,o);if(u(s)){if(t=1,u(v.charCodeAt(1))){let p=2,A=p;for(;p<a&&!u(v.charCodeAt(p));)p++;if(p<a&&p!==A){for(A=p;p<a&&u(v.charCodeAt(p));)p++;if(p<a&&p!==A){for(A=p;p<a&&!u(v.charCodeAt(p));)p++;p===a?t=p:p!==A&&(t=p+1)}}}}else if(g(s)&&v.charCodeAt(1)===i){if(a<=2)return o.root=o.dir=v,o;if(t=2,u(v.charCodeAt(2))){if(a===3)return o.root=o.dir=v,o;t=3}}t>0&&(o.root=v.slice(0,t));let n=-1,r=t,c=-1,l=!0,h=v.length-1,d=0;for(;h>=t;--h){if(s=v.charCodeAt(h),u(s)){if(!l){r=h+1;break}continue}c===-1&&(l=!1,c=h+1),s===P?n===-1?n=h:d!==1&&(d=1):n!==-1&&(d=-1)}return c!==-1&&(n===-1||d===0||d===1&&n===c-1&&n===r+1?o.base=o.name=v.slice(r,c):(o.name=v.slice(r,n),o.base=v.slice(r,c),o.ext=v.slice(n,c))),r>0&&r!==t?o.dir=v.slice(0,r-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...v){let o="",a=!1;for(let t=v.length-1;t>=-1&&!a;t--){const s=t>=0?v[t]:D.cwd();I(s,"path"),s.length!==0&&(o=`${s}/${o}`,a=s.charCodeAt(0)===y)}return o=w(o,!a,"/",E),a?`/${o}`:o.length>0?o:"."},normalize(v){if(I(v,"path"),v.length===0)return".";const o=v.charCodeAt(0)===y,a=v.charCodeAt(v.length-1)===y;return v=w(v,!o,"/",E),v.length===0?o?"/":a?"./":".":(a&&(v+="/"),o?`/${v}`:v)},isAbsolute(v){return I(v,"path"),v.length>0&&v.charCodeAt(0)===y},join(...v){if(v.length===0)return".";let o;for(let a=0;a<v.length;++a){const t=v[a];I(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(v,o){if(I(v,"from"),I(o,"to"),v===o||(v=e.posix.resolve(v),o=e.posix.resolve(o),v===o))return"";const a=1,t=v.length,s=t-a,n=1,r=o.length-n,c=s<r?s:r;let l=-1,h=0;for(;h<c;h++){const p=v.charCodeAt(a+h);if(p!==o.charCodeAt(n+h))break;p===y&&(l=h)}if(h===c)if(r>c){if(o.charCodeAt(n+h)===y)return o.slice(n+h+1);if(h===0)return o.slice(n+h)}else s>c&&(v.charCodeAt(a+h)===y?l=h:h===0&&(l=0));let d="";for(h=a+l+1;h<=t;++h)(h===t||v.charCodeAt(h)===y)&&(d+=d.length===0?"..":"/..");return`${d}${o.slice(n+l)}`},toNamespacedPath(v){return v},dirname(v){if(I(v,"path"),v.length===0)return".";const o=v.charCodeAt(0)===y;let a=-1,t=!0;for(let s=v.length-1;s>=1;--s)if(v.charCodeAt(s)===y){if(!t){a=s;break}}else t=!1;return a===-1?o?"/":".":o&&a===1?"//":v.slice(0,a)},basename(v,o){o!==void 0&&I(o,"ext"),I(v,"path");let a=0,t=-1,s=!0,n;if(o!==void 0&&o.length>0&&o.length<=v.length){if(o===v)return"";let r=o.length-1,c=-1;for(n=v.length-1;n>=0;--n){const l=v.charCodeAt(n);if(l===y){if(!s){a=n+1;break}}else c===-1&&(s=!1,c=n+1),r>=0&&(l===o.charCodeAt(r)?--r==-1&&(t=n):(r=-1,t=c))}return a===t?t=c:t===-1&&(t=v.length),v.slice(a,t)}for(n=v.length-1;n>=0;--n)if(v.charCodeAt(n)===y){if(!s){a=n+1;break}}else t===-1&&(s=!1,t=n+1);return t===-1?"":v.slice(a,t)},extname(v){I(v,"path");let o=-1,a=0,t=-1,s=!0,n=0;for(let r=v.length-1;r>=0;--r){const c=v.charCodeAt(r);if(c===y){if(!s){a=r+1;break}continue}t===-1&&(s=!1,t=r+1),c===P?o===-1?o=r:n!==1&&(n=1):o!==-1&&(n=-1)}return o===-1||t===-1||n===0||n===1&&o===t-1&&o===a+1?"":v.slice(o,t)},format:m.bind(null,"/"),parse(v){I(v,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return o;const a=v.charCodeAt(0)===y;let t;a?(o.root="/",t=1):t=0;let s=-1,n=0,r=-1,c=!0,l=v.length-1,h=0;for(;l>=t;--l){const d=v.charCodeAt(l);if(d===y){if(!c){n=l+1;break}continue}r===-1&&(c=!1,r=l+1),d===P?s===-1?s=l:h!==1&&(h=1):s!==-1&&(h=-1)}if(r!==-1){const d=n===0&&a?1:n;s===-1||h===0||h===1&&s===r-1&&s===n+1?o.base=o.name=v.slice(d,r):(o.name=v.slice(d,s),o.base=v.slice(d,r),o.ext=v.slice(s,r))}return n>0?o.dir=v.slice(0,n-1):a&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var L in D)(typeof exports=="object"?exports:K)[L]=D[L]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function D(L){if(e[L])return e[L].exports;var R=e[L]={i:L,l:!1,exports:{}};return K[L].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=K,D.c=e,D.d=function(L,R,T){D.o(L,R)||Object.defineProperty(L,R,{enumerable:!0,get:T})},D.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},D.t=function(L,R){if(1&R&&(L=D(L)),8&R||4&R&&typeof L=="object"&&L&&L.__esModule)return L;var T=Object.create(null);if(D.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:L}),2&R&&typeof L!="string")for(var k in L)D.d(T,k,function(P){return L[P]}.bind(null,k));return T},D.n=function(L){var R=L&&L.__esModule?function(){return L.default}:function(){return L};return D.d(R,"a",R),R},D.o=function(L,R){return Object.prototype.hasOwnProperty.call(L,R)},D.p="",D(D.s=0)}([function(K,e,D){(function(L){var R;e=K.exports=ne,R=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var Q=Array.prototype.slice.call(arguments,0);Q.unshift("SEMVER"),console.log.apply(console,Q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],y=e.src=[],b=0,i=b++;y[i]="0|[1-9]\\d*";var C=b++;y[C]="[0-9]+";var f=b++;y[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=b++;y[I]="("+y[i]+")\\.("+y[i]+")\\.("+y[i]+")";var u=b++;y[u]="("+y[C]+")\\.("+y[C]+")\\.("+y[C]+")";var E=b++;y[E]="(?:"+y[i]+"|"+y[f]+")";var g=b++;y[g]="(?:"+y[C]+"|"+y[f]+")";var w=b++;y[w]="(?:-("+y[E]+"(?:\\."+y[E]+")*))";var m=b++;y[m]="(?:-?("+y[g]+"(?:\\."+y[g]+")*))";var v=b++;y[v]="[0-9A-Za-z-]+";var o=b++;y[o]="(?:\\+("+y[v]+"(?:\\."+y[v]+")*))";var a=b++,t="v?"+y[I]+y[w]+"?"+y[o]+"?";y[a]="^"+t+"$";var s="[v=\\s]*"+y[u]+y[m]+"?"+y[o]+"?",n=b++;y[n]="^"+s+"$";var r=b++;y[r]="((?:<|>)?=?)";var c=b++;y[c]=y[C]+"|x|X|\\*";var l=b++;y[l]=y[i]+"|x|X|\\*";var h=b++;y[h]="[v=\\s]*("+y[l]+")(?:\\.("+y[l]+")(?:\\.("+y[l]+")(?:"+y[w]+")?"+y[o]+"?)?)?";var d=b++;y[d]="[v=\\s]*("+y[c]+")(?:\\.("+y[c]+")(?:\\.("+y[c]+")(?:"+y[m]+")?"+y[o]+"?)?)?";var p=b++;y[p]="^"+y[r]+"\\s*"+y[h]+"$";var A=b++;y[A]="^"+y[r]+"\\s*"+y[d]+"$";var O=b++;y[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var S=b++;y[S]="(?:~>?)";var U=b++;y[U]="(\\s*)"+y[S]+"\\s+",P[U]=new RegExp(y[U],"g");var F=b++;y[F]="^"+y[S]+y[h]+"$";var z=b++;y[z]="^"+y[S]+y[d]+"$";var j=b++;y[j]="(?:\\^)";var M=b++;y[M]="(\\s*)"+y[j]+"\\s+",P[M]=new RegExp(y[M],"g");var W=b++;y[W]="^"+y[j]+y[h]+"$";var x=b++;y[x]="^"+y[j]+y[d]+"$";var $=b++;y[$]="^"+y[r]+"\\s*("+s+")$|^$";var q=b++;y[q]="^"+y[r]+"\\s*("+t+")$|^$";var N=b++;y[N]="(\\s*)"+y[r]+"\\s*("+s+"|"+y[h]+")",P[N]=new RegExp(y[N],"g");var V=b++;y[V]="^\\s*("+y[h]+")\\s+-\\s+("+y[h]+")\\s*$";var _=b++;y[_]="^\\s*("+y[d]+")\\s+-\\s+("+y[d]+")\\s*$";var Y=b++;y[Y]="(<|>)?=?\\s*\\*";for(var G=0;G<35;G++)R(G,y[G]),P[G]||(P[G]=new RegExp(y[G]));function te(Q,ae){if(Q instanceof ne)return Q;if(typeof Q!="string"||Q.length>T||!(ae?P[n]:P[a]).test(Q))return null;try{return new ne(Q,ae)}catch(oe){return null}}function ne(Q,ae){if(Q instanceof ne){if(Q.loose===ae)return Q;Q=Q.version}else if(typeof Q!="string")throw new TypeError("Invalid Version: "+Q);if(Q.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof ne))return new ne(Q,ae);R("SemVer",Q,ae),this.loose=ae;var oe=Q.trim().match(ae?P[n]:P[a]);if(!oe)throw new TypeError("Invalid Version: "+Q);if(this.raw=Q,this.major=+oe[1],this.minor=+oe[2],this.patch=+oe[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");oe[4]?this.prerelease=oe[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var Se=+pe;if(Se>=0&&Se<k)return Se}return pe}):this.prerelease=[],this.build=oe[5]?oe[5].split("."):[],this.format()}e.parse=te,e.valid=function(Q,ae){var oe=te(Q,ae);return oe?oe.version:null},e.clean=function(Q,ae){var oe=te(Q.trim().replace(/^[=v]+/,""),ae);return oe?oe.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(Q){return R("SemVer.compare",this.version,this.loose,Q),Q instanceof ne||(Q=new ne(Q,this.loose)),this.compareMain(Q)||this.comparePre(Q)},ne.prototype.compareMain=function(Q){return Q instanceof ne||(Q=new ne(Q,this.loose)),H(this.major,Q.major)||H(this.minor,Q.minor)||H(this.patch,Q.patch)},ne.prototype.comparePre=function(Q){if(Q instanceof ne||(Q=new ne(Q,this.loose)),this.prerelease.length&&!Q.prerelease.length)return-1;if(!this.prerelease.length&&Q.prerelease.length)return 1;if(!this.prerelease.length&&!Q.prerelease.length)return 0;var ae=0;do{var oe=this.prerelease[ae],pe=Q.prerelease[ae];if(R("prerelease compare",ae,oe,pe),oe===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(oe===void 0)return-1;if(oe!==pe)return H(oe,pe)}while(++ae)},ne.prototype.inc=function(Q,ae){switch(Q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var oe=this.prerelease.length;--oe>=0;)typeof this.prerelease[oe]=="number"&&(this.prerelease[oe]++,oe=-2);oe===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+Q)}return this.format(),this.raw=this.version,this},e.inc=function(Q,ae,oe,pe){typeof oe=="string"&&(pe=oe,oe=void 0);try{return new ne(Q,oe).inc(ae,pe).version}catch(Se){return null}},e.diff=function(Q,ae){if(ue(Q,ae))return null;var oe=te(Q),pe=te(ae);if(oe.prerelease.length||pe.prerelease.length){for(var Se in oe)if((Se==="major"||Se==="minor"||Se==="patch")&&oe[Se]!==pe[Se])return"pre"+Se;return"prerelease"}for(var Se in oe)if((Se==="major"||Se==="minor"||Se==="patch")&&oe[Se]!==pe[Se])return Se},e.compareIdentifiers=H;var J=/^[0-9]+$/;function H(Q,ae){var oe=J.test(Q),pe=J.test(ae);return oe&&pe&&(Q=+Q,ae=+ae),oe&&!pe?-1:pe&&!oe?1:Q<ae?-1:Q>ae?1:0}function re(Q,ae,oe){return new ne(Q,oe).compare(new ne(ae,oe))}function ie(Q,ae,oe){return re(Q,ae,oe)>0}function ce(Q,ae,oe){return re(Q,ae,oe)<0}function ue(Q,ae,oe){return re(Q,ae,oe)===0}function ye(Q,ae,oe){return re(Q,ae,oe)!==0}function ge(Q,ae,oe){return re(Q,ae,oe)>=0}function Ie(Q,ae,oe){return re(Q,ae,oe)<=0}function Pe(Q,ae,oe,pe){var Se;switch(ae){case"===":typeof Q=="object"&&(Q=Q.version),typeof oe=="object"&&(oe=oe.version),Se=Q===oe;break;case"!==":typeof Q=="object"&&(Q=Q.version),typeof oe=="object"&&(oe=oe.version),Se=Q!==oe;break;case"":case"=":case"==":Se=ue(Q,oe,pe);break;case"!=":Se=ye(Q,oe,pe);break;case">":Se=ie(Q,oe,pe);break;case">=":Se=ge(Q,oe,pe);break;case"<":Se=ce(Q,oe,pe);break;case"<=":Se=Ie(Q,oe,pe);break;default:throw new TypeError("Invalid operator: "+ae)}return Se}function Ee(Q,ae){if(Q instanceof Ee){if(Q.loose===ae)return Q;Q=Q.value}if(!(this instanceof Ee))return new Ee(Q,ae);R("comparator",Q,ae),this.loose=ae,this.parse(Q),this.semver===Ae?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(Q,ae){return H(ae,Q)},e.major=function(Q,ae){return new ne(Q,ae).major},e.minor=function(Q,ae){return new ne(Q,ae).minor},e.patch=function(Q,ae){return new ne(Q,ae).patch},e.compare=re,e.compareLoose=function(Q,ae){return re(Q,ae,!0)},e.rcompare=function(Q,ae,oe){return re(ae,Q,oe)},e.sort=function(Q,ae){return Q.sort(function(oe,pe){return e.compare(oe,pe,ae)})},e.rsort=function(Q,ae){return Q.sort(function(oe,pe){return e.rcompare(oe,pe,ae)})},e.gt=ie,e.lt=ce,e.eq=ue,e.neq=ye,e.gte=ge,e.lte=Ie,e.cmp=Pe,e.Comparator=Ee;var Ae={};function De(Q,ae){if(Q instanceof De)return Q.loose===ae?Q:new De(Q.raw,ae);if(Q instanceof Ee)return new De(Q.value,ae);if(!(this instanceof De))return new De(Q,ae);if(this.loose=ae,this.raw=Q,this.set=Q.split(/\s*\|\|\s*/).map(function(oe){return this.parseRange(oe.trim())},this).filter(function(oe){return oe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Q);this.format()}function Te(Q){return!Q||Q.toLowerCase()==="x"||Q==="*"}function Ne(Q,ae,oe,pe,Se,Oe,Le,Ue,ke,B,se,le,he){return((ae=Te(oe)?"":Te(pe)?">="+oe+".0.0":Te(Se)?">="+oe+"."+pe+".0":">="+ae)+" "+(Ue=Te(ke)?"":Te(B)?"<"+(+ke+1)+".0.0":Te(se)?"<"+ke+"."+(+B+1)+".0":le?"<="+ke+"."+B+"."+se+"-"+le:"<="+Ue)).trim()}function _e(Q,ae){for(var oe=0;oe<Q.length;oe++)if(!Q[oe].test(ae))return!1;if(ae.prerelease.length){for(oe=0;oe<Q.length;oe++)if(R(Q[oe].semver),Q[oe].semver!==Ae&&Q[oe].semver.prerelease.length>0){var pe=Q[oe].semver;if(pe.major===ae.major&&pe.minor===ae.minor&&pe.patch===ae.patch)return!0}return!1}return!0}function $e(Q,ae,oe){try{ae=new De(ae,oe)}catch(pe){return!1}return ae.test(Q)}function xe(Q,ae,oe,pe){var Se,Oe,Le,Ue,ke;switch(Q=new ne(Q,pe),ae=new De(ae,pe),oe){case">":Se=ie,Oe=Ie,Le=ce,Ue=">",ke=">=";break;case"<":Se=ce,Oe=ge,Le=ie,Ue="<",ke="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(Q,ae,pe))return!1;for(var B=0;B<ae.set.length;++B){var se=ae.set[B],le=null,he=null;if(se.forEach(function(me){me.semver===Ae&&(me=new Ee(">=0.0.0")),le=le||me,he=he||me,Se(me.semver,le.semver,pe)?le=me:Le(me.semver,he.semver,pe)&&(he=me)}),le.operator===Ue||le.operator===ke||(!he.operator||he.operator===Ue)&&Oe(Q,he.semver)||he.operator===ke&&Le(Q,he.semver))return!1}return!0}Ee.prototype.parse=function(Q){var ae=this.loose?P[$]:P[q],oe=Q.match(ae);if(!oe)throw new TypeError("Invalid comparator: "+Q);this.operator=oe[1],this.operator==="="&&(this.operator=""),oe[2]?this.semver=new ne(oe[2],this.loose):this.semver=Ae},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(Q){return R("Comparator.test",Q,this.loose),this.semver===Ae||(typeof Q=="string"&&(Q=new ne(Q,this.loose)),Pe(Q,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(Q,ae){if(!(Q instanceof Ee))throw new TypeError("a Comparator is required");var oe;if(this.operator==="")return oe=new De(Q.value,ae),$e(this.value,oe,ae);if(Q.operator==="")return oe=new De(this.value,ae),$e(Q.semver,oe,ae);var pe=!(this.operator!==">="&&this.operator!==">"||Q.operator!==">="&&Q.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||Q.operator!=="<="&&Q.operator!=="<"),Oe=this.semver.version===Q.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||Q.operator!==">="&&Q.operator!=="<="),Ue=Pe(this.semver,"<",Q.semver,ae)&&(this.operator===">="||this.operator===">")&&(Q.operator==="<="||Q.operator==="<"),ke=Pe(this.semver,">",Q.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(Q.operator===">="||Q.operator===">");return pe||Se||Oe&&Le||Ue||ke},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(Q){return Q.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(Q){var ae=this.loose;Q=Q.trim(),R("range",Q,ae);var oe=ae?P[_]:P[V];Q=Q.replace(oe,Ne),R("hyphen replace",Q),Q=Q.replace(P[N],"$1$2$3"),R("comparator trim",Q,P[N]),Q=(Q=(Q=Q.replace(P[U],"$1~")).replace(P[M],"$1^")).split(/\s+/).join(" ");var pe=ae?P[$]:P[q],Se=Q.split(" ").map(function(Oe){return function(Le,Ue){return R("comp",Le),Le=function(ke,B){return ke.trim().split(/\s+/).map(function(se){return function(le,he){R("caret",le,he);var me=he?P[x]:P[W];return le.replace(me,function(be,ve,we,Ce,Re){var fe;return R("caret",le,be,ve,we,Ce,Re),Te(ve)?fe="":Te(we)?fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":Te(Ce)?fe=ve==="0"?">="+ve+"."+we+".0 <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+".0 <"+(+ve+1)+".0.0":Re?(R("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),fe=ve==="0"?we==="0"?">="+ve+"."+we+"."+Ce+Re+" <"+ve+"."+we+"."+(+Ce+1):">="+ve+"."+we+"."+Ce+Re+" <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+"."+Ce+Re+" <"+(+ve+1)+".0.0"):(R("no pr"),fe=ve==="0"?we==="0"?">="+ve+"."+we+"."+Ce+" <"+ve+"."+we+"."+(+Ce+1):">="+ve+"."+we+"."+Ce+" <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+"."+Ce+" <"+(+ve+1)+".0.0"),R("caret return",fe),fe})}(se,B)}).join(" ")}(Le,Ue),R("caret",Le),Le=function(ke,B){return ke.trim().split(/\s+/).map(function(se){return function(le,he){var me=he?P[z]:P[F];return le.replace(me,function(be,ve,we,Ce,Re){var fe;return R("tilde",le,be,ve,we,Ce,Re),Te(ve)?fe="":Te(we)?fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":Te(Ce)?fe=">="+ve+"."+we+".0 <"+ve+"."+(+we+1)+".0":Re?(R("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),fe=">="+ve+"."+we+"."+Ce+Re+" <"+ve+"."+(+we+1)+".0"):fe=">="+ve+"."+we+"."+Ce+" <"+ve+"."+(+we+1)+".0",R("tilde return",fe),fe})}(se,B)}).join(" ")}(Le,Ue),R("tildes",Le),Le=function(ke,B){return R("replaceXRanges",ke,B),ke.split(/\s+/).map(function(se){return function(le,he){le=le.trim();var me=he?P[A]:P[p];return le.replace(me,function(be,ve,we,Ce,Re,fe){R("xRange",le,be,ve,we,Ce,Re,fe);var Fe=Te(we),Me=Fe||Te(Ce),ze=Me||Te(Re);return ve==="="&&ze&&(ve=""),Fe?be=ve===">"||ve==="<"?"<0.0.0":"*":ve&&ze?(Me&&(Ce=0),ze&&(Re=0),ve===">"?(ve=">=",Me?(we=+we+1,Ce=0,Re=0):ze&&(Ce=+Ce+1,Re=0)):ve==="<="&&(ve="<",Me?we=+we+1:Ce=+Ce+1),be=ve+we+"."+Ce+"."+Re):Me?be=">="+we+".0.0 <"+(+we+1)+".0.0":ze&&(be=">="+we+"."+Ce+".0 <"+we+"."+(+Ce+1)+".0"),R("xRange return",be),be})}(se,B)}).join(" ")}(Le,Ue),R("xrange",Le),Le=function(ke,B){return R("replaceStars",ke,B),ke.trim().replace(P[Y],"")}(Le,Ue),R("stars",Le),Le}(Oe,ae)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(Oe){return!!Oe.match(pe)})),Se=Se.map(function(Oe){return new Ee(Oe,ae)})},De.prototype.intersects=function(Q,ae){if(!(Q instanceof De))throw new TypeError("a Range is required");return this.set.some(function(oe){return oe.every(function(pe){return Q.set.some(function(Se){return Se.every(function(Oe){return pe.intersects(Oe,ae)})})})})},e.toComparators=function(Q,ae){return new De(Q,ae).set.map(function(oe){return oe.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},De.prototype.test=function(Q){if(!Q)return!1;typeof Q=="string"&&(Q=new ne(Q,this.loose));for(var ae=0;ae<this.set.length;ae++)if(_e(this.set[ae],Q))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(Q,ae,oe){var pe=null,Se=null;try{var Oe=new De(ae,oe)}catch(Le){return null}return Q.forEach(function(Le){Oe.test(Le)&&(pe&&Se.compare(Le)!==-1||(Se=new ne(pe=Le,oe)))}),pe},e.minSatisfying=function(Q,ae,oe){var pe=null,Se=null;try{var Oe=new De(ae,oe)}catch(Le){return null}return Q.forEach(function(Le){Oe.test(Le)&&(pe&&Se.compare(Le)!==1||(Se=new ne(pe=Le,oe)))}),pe},e.validRange=function(Q,ae){try{return new De(Q,ae).range||"*"}catch(oe){return null}},e.ltr=function(Q,ae,oe){return xe(Q,ae,"<",oe)},e.gtr=function(Q,ae,oe){return xe(Q,ae,">",oe)},e.outside=xe,e.prerelease=function(Q,ae){var oe=te(Q,ae);return oe&&oe.prerelease.length?oe.prerelease:null},e.intersects=function(Q,ae,oe){return Q=new De(Q,oe),ae=new De(ae,oe),Q.intersects(ae)},e.coerce=function(Q){if(Q instanceof ne)return Q;if(typeof Q!="string")return null;var ae=Q.match(P[O]);return ae==null?null:te((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function(K,e){var D,L,R=K.exports={};function T(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function P(g){if(D===setTimeout)return setTimeout(g,0);if((D===T||!D)&&setTimeout)return D=setTimeout,setTimeout(g,0);try{return D(g,0)}catch(w){try{return D.call(null,g,0)}catch(m){return D.call(this,g,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:T}catch(g){D=T}try{L=typeof clearTimeout=="function"?clearTimeout:k}catch(g){L=k}})();var y,b=[],i=!1,C=-1;function f(){i&&y&&(i=!1,y.length?b=y.concat(b):C=-1,b.length&&I())}function I(){if(!i){var g=P(f);i=!0;for(var w=b.length;w;){for(y=b,b=[];++C<w;)y&&y[C].run();C=-1,w=b.length}y=null,i=!1,function(m){if(L===clearTimeout)return clearTimeout(m);if((L===k||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(m);try{L(m)}catch(v){try{return L.call(null,m)}catch(o){return L.call(this,m)}}}(g)}}function u(g,w){this.fun=g,this.array=w}function E(){}R.nextTick=function(g){var w=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)w[m-1]=arguments[m];b.push(new u(g,w)),b.length!==1||i||P(I)},u.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=E,R.addListener=E,R.once=E,R.off=E,R.removeListener=E,R.removeAllListeners=E,R.emit=E,R.prependListener=E,R.prependOnceListener=E,R.listeners=function(g){return[]},R.binding=function(g){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(g){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Z[92],ee([0,1,4]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=D.globals.performance&&typeof D.globals.performance.now=="function";class R{constructor(k){this._highResolution=L&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new R(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(Z[3],ee([0,1,9,65,2,91,92]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(v){v.None=()=>R.Disposable.None;function o(j){return(M,W=null,x)=>{let $=!1,q;return q=j(N=>{if(!$)return q?q.dispose():$=!0,M.call(W,N)},null,x),$&&q.dispose(),q}}v.once=o;function a(j,M){return l((W,x=null,$)=>j(q=>W.call(x,M(q)),null,$))}v.map=a;function t(j,M){return l((W,x=null,$)=>j(q=>{M(q),W.call(x,q)},null,$))}v.forEach=t;function s(j,M){return l((W,x=null,$)=>j(q=>M(q)&&W.call(x,q),null,$))}v.filter=s;function n(j){return j}v.signal=n;function r(...j){return(M,W=null,x)=>(0,R.combinedDisposable)(...j.map($=>$(q=>M.call(W,q),null,x)))}v.any=r;function c(j,M,W){let x=W;return a(j,$=>(x=M(x,$),x))}v.reduce=c;function l(j){let M;const W=new f({onFirstListenerAdd(){M=j(W.fire,W)},onLastListenerRemove(){M.dispose()}});return W.event}function h(j,M,W=100,x=!1,$){let q,N,V,_=0;const Y=new f({leakWarningThreshold:$,onFirstListenerAdd(){q=j(G=>{_++,N=M(N,G),x&&!V&&(Y.fire(N),N=void 0),clearTimeout(V),V=setTimeout(()=>{const te=N;N=void 0,V=void 0,(!x||_>1)&&Y.fire(te),_=0},W)})},onLastListenerRemove(){q.dispose()}});return Y.event}v.debounce=h;function d(j,M=(W,x)=>W===x){let W=!0,x;return s(j,$=>{const q=W||!M($,x);return W=!1,x=$,q})}v.latch=d;function p(j,M){return[v.filter(j,M),v.filter(j,W=>!M(W))]}v.split=p;function A(j,M=!1,W=[]){let x=W.slice(),$=j(V=>{x?x.push(V):N.fire(V)});const q=()=>{x&&x.forEach(V=>N.fire(V)),x=null},N=new f({onFirstListenerAdd(){$||($=j(V=>N.fire(V)))},onFirstListenerDidAdd(){x&&(M?setTimeout(q):q())},onLastListenerRemove(){$&&$.dispose(),$=null}});return N.event}v.buffer=A;class O{constructor(M){this.event=M}map(M){return new O(a(this.event,M))}forEach(M){return new O(t(this.event,M))}filter(M){return new O(s(this.event,M))}reduce(M,W){return new O(c(this.event,M,W))}latch(){return new O(d(this.event))}debounce(M,W=100,x=!1,$){return new O(h(this.event,M,W,x,$))}on(M,W,x){return this.event(M,W,x)}once(M,W,x){return o(this.event)(M,W,x)}}function S(j){return new O(j)}v.chain=S;function U(j,M,W=x=>x){const x=(...V)=>N.fire(W(...V)),$=()=>j.on(M,x),q=()=>j.removeListener(M,x),N=new f({onFirstListenerAdd:$,onLastListenerRemove:q});return N.event}v.fromNodeEventEmitter=U;function F(j,M,W=x=>x){const x=(...V)=>N.fire(W(...V)),$=()=>j.addEventListener(M,x),q=()=>j.removeEventListener(M,x),N=new f({onFirstListenerAdd:$,onLastListenerRemove:q});return N.event}v.fromDOMEventEmitter=F;function z(j){return new Promise(M=>o(j)(M))}v.toPromise=z})(P=e.Event||(e.Event={}));class y{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${y._idPool++}`}start(o){this._stopWatch=new k.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let b=-1;function i(v){const o=b;return b=v,{dispose(){b=o}}}e.setGlobalLeakWarningThreshold=i;class C{constructor(o,a=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let a=b;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),a<=0||o<a)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(t)||0;if(this._stacks.set(t,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let n,r=0;for(const[c,l]of this._stacks)(!n||r<l)&&(n=c,r=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${r}):`),console.warn(n)}return()=>{const n=this._stacks.get(t)||0;this._stacks.set(t,n-1)}}}class f{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=b>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(o,a,t)=>{this._listeners||(this._listeners=new T.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(a?[o,a]:o);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,a);const r=this._leakageMon?.check(this._listeners.size),c=(0,R.toDisposable)(()=>{r&&r(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof R.DisposableStore?t.add(c):Array.isArray(t)&&t.push(c),c}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,o]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,t]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,t):a[0].call(a[1],t)}catch(s){(0,D.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=f;class I extends f{async fireAsync(o,a,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,o]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[s,n]=this._asyncDeliveryQueue.shift(),r=[],c={...n,waitUntil:l=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");t&&(l=t(l,typeof s=="function"?s:s[0])),r.push(l)}};try{typeof s=="function"?s.call(void 0,c):s[0].call(s[1],c)}catch(l){(0,D.onUnexpectedError)(l);continue}Object.freeze(r),await Promise.allSettled(r).then(l=>{for(const h of l)h.status==="rejected"&&(0,D.onUnexpectedError)(h.reason)})}}}}e.AsyncEmitter=I;class u extends f{constructor(o){super(o);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=u;class E extends u{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=E;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const a={event:o,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const t=()=>{this.hasListeners&&this.unhook(a);const s=this.events.indexOf(a);this.events.splice(s,1)};return(0,R.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(a=>this.emitter.fire(a))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=g;class w{constructor(){this.buffers=[]}wrapEvent(o){return(a,t,s)=>o(n=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>a.call(t,n)):a.call(t,n)},void 0,s)}bufferEvents(o){const a=[];this.buffers.push(a);const t=o();return this.buffers.pop(),a.forEach(s=>s()),t}}e.EventBufferer=w;class m{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=R.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=m}),define(Z[27],ee([0,1,3]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(P,y){const b=setTimeout(P.bind(y),0);return{dispose(){clearTimeout(b)}}});var R;(function(P){function y(b){return b===P.None||b===P.Cancelled||b instanceof T?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}P.isCancellationToken=y,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(R=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=R.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=k}),define(Z[49],ee([0,1,3]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new D.Emitter}add(C){const f=this._icons.get(C.id);f?C.description?f.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new L;e.iconRegistry=R;function T(i,C){return new P(i,C)}e.registerCodicon=T;function k(i){return i?i.replace(/\$\((.*?)\)/g,(C,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=k;class P{constructor(C,f,I){this.id=C,this.definition=f,this.description=I,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function y(i,C){const f=["codicon","codicon-"+i];return C&&f.push("codicon-modifier-"+C),f}e.getClassNamesArray=y;var b;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const C=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function f(E){if(E instanceof P)return["codicon","codicon-"+E.id];const g=C.exec(E.id);if(!g)return f(P.error);let[,w,m]=g;const v=["codicon","codicon-"+w];return m&&v.push("codicon-modifier-"+m.substr(1)),v}i.asClassNameArray=f;function I(E){return f(E).join(" ")}i.asClassName=I;function u(E){return"."+f(E).join(".")}i.asCSSSelector=u})(b=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(Z[50],ee([0,1,9,2]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(v){const o=v;return o?[o.on,o.pause,o.resume,o.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=R;function T(v){const o=v;return o?R(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=T;function k(v,o){return new P(v,o)}e.newWriteableStream=k;class P{constructor(o,a){this.reducer=o,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(a=>a(o))}emitError(o){this.listeners.error.length===0?(0,D.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(a=>a(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,a){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(o,a){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(a);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(v,o){const a=[];let t;for(;(t=v.read())!==null;)a.push(t);return o(a)}e.consumeReadable=y;function b(v,o,a){const t=[];let s;for(;(s=v.read())!==null&&t.length<a;)t.push(s);return s===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const n=s;return s=void 0,n}return v.read()}}}e.peekReadable=b;function i(v,o){return new Promise((a,t)=>{const s=[];C(v,{onData:n=>{o&&s.push(n)},onError:n=>{o?t(n):a(void 0)},onEnd:()=>{a(o?o(s):void 0)}})})}e.consumeStream=i;function C(v,o){v.on("error",a=>o.onError(a)),v.on("end",()=>o.onEnd()),v.on("data",a=>o.onData(a))}e.listenStream=C;function f(v,o){return new Promise((a,t)=>{const s=new L.DisposableStore,n=[],r=h=>{if(n.push(h),n.length>o)return s.dispose(),v.pause(),a({stream:v,buffer:n,ended:!1})},c=h=>t(h),l=()=>a({stream:v,buffer:n,ended:!0});s.add((0,L.toDisposable)(()=>v.removeListener("error",c))),v.on("error",c),s.add((0,L.toDisposable)(()=>v.removeListener("end",l))),v.on("end",l),s.add((0,L.toDisposable)(()=>v.removeListener("data",r))),v.on("data",r)})}e.peekStream=f;function I(v,o){const a=k(o);return a.end(v),a}e.toStream=I;function u(){const v=k(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=u;function E(v){let o=!1;return{read:()=>o?null:(o=!0,v)}}e.toReadable=E;function g(v,o,a){const t=k(a);return C(v,{onData:s=>t.write(o.data(s)),onError:s=>t.error(o.error?o.error(s):s),onEnd:()=>t.end()}),t}e.transform=g;function w(v,o,a){let t=!1;return{read:()=>{const s=o.read();return t?s:(t=!0,s!==null?a([v,s]):v)}}}e.prefixedReadable=w;function m(v,o,a){let t=!1;const s=k(a);return C(o,{onData:n=>t?s.write(n):(t=!0,s.write(a([v,n]))),onError:n=>s.error(n),onEnd:()=>{t||(t=!0,s.write(v)),s.end()}}),s}e.prefixedStream=m}),define(Z[25],ee([0,1,50]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let R,T;class k{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return L?new k(Buffer.allocUnsafe(r)):new k(new Uint8Array(r))}static wrap(r){return L&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new k(r)}static fromString(r,c){return!(c?.dontUseNodeBuffer||!1)&&L?new k(Buffer.from(r)):(R||(R=new TextEncoder),new k(R.encode(r)))}static concat(r,c){if(typeof c=="undefined"){c=0;for(let d=0,p=r.length;d<p;d++)c+=r[d].byteLength}const l=k.alloc(c);let h=0;for(let d=0,p=r.length;d<p;d++){const A=r[d];l.set(A,h),h+=A.byteLength}return l}toString(){return L?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(r,c){return new k(this.buffer.subarray(r,c))}set(r,c){r instanceof k?this.buffer.set(r.buffer,c):this.buffer.set(r,c)}readUInt32BE(r){return b(this.buffer,r)}writeUInt32BE(r,c){i(this.buffer,r,c)}readUInt32LE(r){return C(this.buffer,r)}writeUInt32LE(r,c){f(this.buffer,r,c)}readUInt8(r){return I(this.buffer,r)}writeUInt8(r,c){u(this.buffer,r,c)}}e.VSBuffer=k;function P(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}e.readUInt16LE=P;function y(n,r,c){n[c+0]=r&255,r=r>>>8,n[c+1]=r&255}e.writeUInt16LE=y;function b(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}e.readUInt32BE=b;function i(n,r,c){n[c+3]=r,r=r>>>8,n[c+2]=r,r=r>>>8,n[c+1]=r,r=r>>>8,n[c]=r}e.writeUInt32BE=i;function C(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}e.readUInt32LE=C;function f(n,r,c){n[c+0]=r&255,r=r>>>8,n[c+1]=r&255,r=r>>>8,n[c+2]=r&255,r=r>>>8,n[c+3]=r&255}e.writeUInt32LE=f;function I(n,r){return n[r]}e.readUInt8=I;function u(n,r,c){n[c]=r}e.writeUInt8=u;function E(n){return D.consumeReadable(n,r=>k.concat(r))}e.readableToBuffer=E;function g(n){return D.toReadable(n)}e.bufferToReadable=g;function w(n){return D.consumeStream(n,r=>k.concat(r))}e.streamToBuffer=w;async function m(n){return n.ended?k.concat(n.buffer):k.concat([...n.buffer,await w(n.stream)])}e.bufferedStreamToBuffer=m;function v(n){return D.toStream(n,r=>k.concat(r))}e.bufferToStream=v;function o(n){return D.transform(n,{data:r=>typeof r=="string"?k.fromString(r):k.wrap(r)},r=>k.concat(r))}e.streamToBufferReadableStream=o;function a(n){return D.newWriteableStream(r=>k.concat(r),n)}e.newWriteableBufferStream=a;function t(n,r){return D.prefixedReadable(n,r,c=>k.concat(c))}e.prefixedBufferReadable=t;function s(n,r){return D.prefixedStream(n,r,c=>k.concat(c))}e.prefixedBufferStream=s}),define(Z[24],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(B){return!B||typeof B!="string"?!0:B.trim().length===0}e.isFalsyOrWhitespace=D;const L=/{(\d+)}/g;function R(B,...se){return se.length===0?B:B.replace(L,function(le,he){const me=parseInt(he,10);return isNaN(me)||me<0||me>=se.length?le:se[me]})}e.format=R;const T=/{([^}]+)}/g;function k(B,se){return B.replace(T,(le,he)=>se[he]??le)}e.format2=k;function P(B){return B.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=P;function y(B){return B.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function b(B,se){let le=0;const he=se.charCodeAt(0);for(let me=B.length-1;me>=0;me--)B.charCodeAt(me)===he&&le++;return le}e.count=b;function i(B,se,le="\u2026"){return B.length<=se?B:`${B.substr(0,se)}${le}`}e.truncate=i;function C(B,se=" "){const le=f(B,se);return I(le,se)}e.trim=C;function f(B,se){if(!B||!se)return B;const le=se.length;if(le===0||B.length===0)return B;let he=0;for(;B.indexOf(se,he)===he;)he=he+le;return B.substring(he)}e.ltrim=f;function I(B,se){if(!B||!se)return B;const le=se.length,he=B.length;if(le===0||he===0)return B;let me=he,be=-1;for(;be=B.lastIndexOf(se,me-1),!(be===-1||be+le!==me);){if(be===0)return"";me=be}return B.substring(0,me)}e.rtrim=I;function u(B){return B.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function E(B){return B.replace(/\*/g,"")}e.stripWildcards=E;function g(B,se,le={}){if(!B)throw new Error("Cannot create regex from empty string");se||(B=y(B)),le.wholeWord&&(/\B/.test(B.charAt(0))||(B="\\b"+B),/\B/.test(B.charAt(B.length-1))||(B=B+"\\b"));let he="";return le.global&&(he+="g"),le.matchCase||(he+="i"),le.multiline&&(he+="m"),le.unicode&&(he+="u"),new RegExp(B,he)}e.createRegExp=g;function w(B){return B.source==="^"||B.source==="^$"||B.source==="$"||B.source==="^\\s*$"?!1:!!(B.exec("")&&B.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function m(B){return!!B.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function v(B){return(B.global?"g":"")+(B.ignoreCase?"i":"")+(B.multiline?"m":"")+(B.unicode?"u":"")}e.regExpFlags=v;function o(B){return B.split(/\r\n|\r|\n/)}e.splitLines=o;function a(B){for(let se=0,le=B.length;se<le;se++){const he=B.charCodeAt(se);if(he!==32&&he!==9)return se}return-1}e.firstNonWhitespaceIndex=a;function t(B,se=0,le=B.length){for(let he=se;he<le;he++){const me=B.charCodeAt(he);if(me!==32&&me!==9)return B.substring(se,he)}return B.substring(se,le)}e.getLeadingWhitespace=t;function s(B,se=B.length-1){for(let le=se;le>=0;le--){const he=B.charCodeAt(le);if(he!==32&&he!==9)return le}return-1}e.lastNonWhitespaceIndex=s;function n(B,se){return B<se?-1:B>se?1:0}e.compare=n;function r(B,se,le=0,he=B.length,me=0,be=se.length){for(;le<he&&me<be;le++,me++){let Ce=B.charCodeAt(le),Re=se.charCodeAt(me);if(Ce<Re)return-1;if(Ce>Re)return 1}const ve=he-le,we=be-me;return ve<we?-1:ve>we?1:0}e.compareSubstring=r;function c(B,se){return l(B,se,0,B.length,0,se.length)}e.compareIgnoreCase=c;function l(B,se,le=0,he=B.length,me=0,be=se.length){for(;le<he&&me<be;le++,me++){let Ce=B.charCodeAt(le),Re=se.charCodeAt(me);if(Ce===Re)continue;const fe=Ce-Re;if(!(fe===32&&d(Re))&&!(fe===-32&&d(Ce)))return h(Ce)&&h(Re)?fe:r(B.toLowerCase(),se.toLowerCase(),le,he,me,be)}const ve=he-le,we=be-me;return ve<we?-1:ve>we?1:0}e.compareSubstringIgnoreCase=l;function h(B){return B>=97&&B<=122}e.isLowerAsciiLetter=h;function d(B){return B>=65&&B<=90}e.isUpperAsciiLetter=d;function p(B){return h(B)||d(B)}function A(B,se){return B.length===se.length&&O(B,se)}e.equalsIgnoreCase=A;function O(B,se,le=B.length){for(let he=0;he<le;he++){const me=B.charCodeAt(he),be=se.charCodeAt(he);if(me!==be){if(p(me)&&p(be)){const ve=Math.abs(me-be);if(ve!==0&&ve!==32)return!1}else if(String.fromCharCode(me).toLowerCase()!==String.fromCharCode(be).toLowerCase())return!1}}return!0}function S(B,se){const le=se.length;return se.length>B.length?!1:O(B,se,le)}e.startsWithIgnoreCase=S;function U(B,se){let le,he=Math.min(B.length,se.length);for(le=0;le<he;le++)if(B.charCodeAt(le)!==se.charCodeAt(le))return le;return he}e.commonPrefixLength=U;function F(B,se){let le,he=Math.min(B.length,se.length);const me=B.length-1,be=se.length-1;for(le=0;le<he;le++)if(B.charCodeAt(me-le)!==se.charCodeAt(be-le))return le;return he}e.commonSuffixLength=F;function z(B){return 55296<=B&&B<=56319}e.isHighSurrogate=z;function j(B){return 56320<=B&&B<=57343}e.isLowSurrogate=j;function M(B,se){return(B-55296<<10)+(se-56320)+65536}e.computeCodePoint=M;function W(B,se,le){const he=B.charCodeAt(le);if(z(he)&&le+1<se){const me=B.charCodeAt(le+1);if(j(me))return M(he,me)}return he}e.getNextCodePoint=W;function x(B,se){const le=B.charCodeAt(se-1);if(j(le)&&se>1){const he=B.charCodeAt(se-2);if(z(he))return M(he,le)}return le}function $(B,se){const le=oe.getInstance(),he=se,me=B.length,be=W(B,me,se);se+=be>=65536?2:1;let ve=le.getGraphemeBreakType(be);for(;se<me;){const we=W(B,me,se),Ce=le.getGraphemeBreakType(we);if(Q(ve,Ce))break;se+=we>=65536?2:1,ve=Ce}return se-he}e.nextCharLength=$;function q(B,se){const le=oe.getInstance(),he=se,me=x(B,se);se-=me>=65536?2:1;let be=le.getGraphemeBreakType(me);for(;se>0;){const ve=x(B,se),we=le.getGraphemeBreakType(ve);if(Q(we,be))break;se-=ve>=65536?2:1,be=we}return he-se}e.prevCharLength=q;function N(B,se){const le=oe.getInstance(),he=B.length,me=se,be=W(B,he,se),ve=le.getGraphemeBreakType(be);se+=be>=65536?2:1;let we=ve;for(;se<he;){const Re=W(B,he,se),fe=le.getGraphemeBreakType(Re);if(Q(we,fe))break;se+=Re>=65536?2:1,we=fe}const Ce=se;for(se=me,we=ve;se>0;){const Re=x(B,se),fe=le.getGraphemeBreakType(Re);if(Q(fe,we))break;se-=Re>=65536?2:1,we=fe}return[se,Ce]}function V(B,se){return se>0&&j(B.charCodeAt(se))?N(B,se-1):N(B,se)}e.getCharContainingOffset=V;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Y(B){return _.test(B)}e.containsRTL=Y;const G=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function te(B){return G.test(B)}e.containsEmoji=te;const ne=/^[\t\n\r\x20-\x7E]*$/;function J(B){return ne.test(B)}e.isBasicASCII=J,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(B){return e.UNUSUAL_LINE_TERMINATORS.test(B)}e.containsUnusualLineTerminators=H;function re(B){for(let se=0,le=B.length;se<le;se++)if(ie(B.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=re;function ie(B){return B=+B,B>=11904&&B<=55215||B>=63744&&B<=64255||B>=65281&&B<=65374}e.isFullWidthCharacter=ie;function ce(B){return B>=127462&&B<=127487||B===8986||B===8987||B===9200||B===9203||B>=9728&&B<=10175||B===11088||B===11093||B>=127744&&B<=128591||B>=128640&&B<=128764||B>=128992&&B<=129003||B>=129280&&B<=129535||B>=129648&&B<=129750}e.isEmojiImprecise=ce;function ue(B,se){if(B.length<se)return B;const le=/\b/g;let he=0;for(;le.test(B)&&!(B.length-le.lastIndex<se);)he=le.lastIndex,le.lastIndex+=1;return B.substring(he).replace(/^\s/,"")}e.lcut=ue;const ye=/\x1B\x5B[12]?K/g,ge=/\x1b\[\d+m/g,Ie=/\x1b\[0?m/g;function Pe(B){return B&&(B=B.replace(ye,""),B=B.replace(ge,""),B=B.replace(Ie,"")),B}e.removeAnsiEscapeCodes=Pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(B){return!!(B&&B.length>0&&B.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Ae(B){return Ee(B)?B.substr(1):B}e.stripUTF8BOM=Ae;function De(B,se){if(!B||!se||B.length<se.length)return!1;const le=se.length,he=B.toLowerCase();let me=0,be=-1;for(;me<le;){const ve=he.indexOf(se[me],be+1);if(ve<0)return!1;be=ve,me++}return!0}e.fuzzyContains=De;function Te(B,se=!1){return B?(se&&(B=B.replace(/\\./g,"")),B.toLowerCase()!==B):!1}e.containsUppercaseCharacter=Te;function Ne(B){return B.charAt(0).toUpperCase()+B.slice(1)}e.uppercaseFirstLetter=Ne;function _e(B,se=1){if(se===0)return"";let le=-1;do le=B.indexOf(`
`,le+1),se--;while(se>0&&le>=0);return le===-1?B:(B[le-1]==="\r"&&le--,B.substr(0,le))}e.getNLines=_e;function $e(B){const se=90-65+1;return B=B%(2*se),B<se?String.fromCharCode(97+B):String.fromCharCode(65+B-se)}e.singleLetterHash=$e;function xe(B){return oe.getInstance().getGraphemeBreakType(B)}e.getGraphemeBreakType=xe;function Q(B,se){return B===0?se!==5&&se!==7:B===2&&se===3?!1:B===4||B===2||B===3||se===4||se===2||se===3?!0:!(B===8&&(se===8||se===9||se===11||se===12)||(B===11||B===9)&&(se===9||se===10)||(B===12||B===10)&&se===10||se===5||se===13||se===7||B===1||B===13&&se===14||B===6&&se===6)}e.breakBetweenGraphemeBreakType=Q;var ae;(function(B){B[B.Other=0]="Other",B[B.Prepend=1]="Prepend",B[B.CR=2]="CR",B[B.LF=3]="LF",B[B.Control=4]="Control",B[B.Extend=5]="Extend",B[B.Regional_Indicator=6]="Regional_Indicator",B[B.SpacingMark=7]="SpacingMark",B[B.L=8]="L",B[B.V=9]="V",B[B.T=10]="T",B[B.LV=11]="LV",B[B.LVT=12]="LVT",B[B.ZWJ=13]="ZWJ",B[B.Extended_Pictographic=14]="Extended_Pictographic"})(ae=e.GraphemeBreakType||(e.GraphemeBreakType={}));class oe{constructor(){this._data=pe()}static getInstance(){return oe._INSTANCE||(oe._INSTANCE=new oe),oe._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const le=this._data,he=le.length/3;let me=1;for(;me<=he;)if(se<le[3*me])me=2*me;else if(se>le[3*me+1])me=2*me+1;else return le[3*me+2];return 0}}oe._INSTANCE=null;function pe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(B,se){if(B===0)return 0;const le=Oe(B,se);if(le!==void 0)return le;const he=x(se,B);return B-=Le(he),B}e.getLeftDeleteOffset=Se;function Oe(B,se){let le=x(se,B);for(B-=Le(le);Ue(le)||le===65039||le===8419;){if(B===0)return;le=x(se,B),B-=Le(le)}if(!!ce(le)){if(B>=0){const he=x(se,B);he===8205&&(B-=Le(he))}return B}}function Le(B){return B>=65536?2:1}function Ue(B){return 127995<=B&&B<=127999}var ke;(function(B){B[B.zwj=8205]="zwj",B[B.emojiVariantSelector=65039]="emojiVariantSelector",B[B.enclosingKeyCap=8419]="enclosingKeyCap"})(ke||(ke={}))}),define(Z[16],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(d){return Array.isArray(d)}e.isArray=D;function L(d){return typeof d=="string"}e.isString=L;function R(d){return Array.isArray(d)&&d.every(p=>L(p))}e.isStringArray=R;function T(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=T;function k(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=k;function P(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=P;function y(d){return d===!0||d===!1}e.isBoolean=y;function b(d){return typeof d=="undefined"}e.isUndefined=b;function i(d){return!C(d)}e.isDefined=i;function C(d){return b(d)||d===null}e.isUndefinedOrNull=C;function f(d,p){if(!d)throw new Error(p?`Unexpected type, expected '${p}'`:"Unexpected type")}e.assertType=f;function I(d){if(C(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=I;function u(...d){const p=[];for(let A=0;A<d.length;A++){const O=d[A];if(C(O))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);p.push(O)}return p}e.assertAllDefined=u;const E=Object.prototype.hasOwnProperty;function g(d){if(!T(d))return!1;for(let p in d)if(E.call(d,p))return!1;return!0}e.isEmptyObject=g;function w(d){return typeof d=="function"}e.isFunction=w;function m(...d){return d.length>0&&d.every(w)}e.areFunctions=m;function v(d,p){const A=Math.min(d.length,p.length);for(let O=0;O<A;O++)o(d[O],p[O])}e.validateConstraints=v;function o(d,p){if(L(p)){if(typeof d!==p)throw new Error(`argument does not match constraint: typeof ${p}`)}else if(w(p)){try{if(d instanceof p)return}catch{}if(!C(d)&&d.constructor===p||p.length===1&&p.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function a(d){let p=[],A=Object.getPrototypeOf(d);for(;Object.prototype!==A;)p=p.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return p}e.getAllPropertyNames=a;function t(d){const p=[];for(const A of a(d))typeof d[A]=="function"&&p.push(A);return p}e.getAllMethodNames=t;function s(d,p){const A=S=>function(){const U=Array.prototype.slice.call(arguments,0);return p(S,U)};let O={};for(const S of d)O[S]=A(S);return O}e.createProxyObject=s;function n(d){return d===null?void 0:d}e.withNullAsUndefined=n;function r(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=r;function c(d){return class{constructor(){return new Proxy({},{get(p,A){if(p[A])return p[A];throw new Error(`Not Implemented: ${d}->${String(A)}`)}})}}}e.NotImplementedProxy=c;function l(d,p="Unreachable"){throw new Error(p)}e.assertNever=l;function h(d){return!!d&&typeof d.then=="function"&&typeof d.catch=="function"}e.isPromise=h}),define(Z[39],ee([0,1,8,4,24,16]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(n){return n===47||n===92}e.isPathSeparator=k;function P(n){return n.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function y(n){return n.indexOf("/")===-1&&(n=P(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=y;function b(n,r=D.posix.sep){if(!n)return"";const c=n.length,l=n.charCodeAt(0);if(k(l)){if(k(n.charCodeAt(1))&&!k(n.charCodeAt(2))){let d=3;const p=d;for(;d<c&&!k(n.charCodeAt(d));d++);if(p!==d&&!k(n.charCodeAt(d+1))){for(d+=1;d<c;d++)if(k(n.charCodeAt(d)))return n.slice(0,d+1).replace(/[\\/]/g,r)}}return r}else if(w(l)&&n.charCodeAt(1)===58)return k(n.charCodeAt(2))?n.slice(0,2)+r:n.slice(0,2);let h=n.indexOf("://");if(h!==-1){for(h+=3;h<c;h++)if(k(n.charCodeAt(h)))return n.slice(0,h+1)}return""}e.getRoot=b;function i(n){if(!L.isWindows||!n||n.length<5)return!1;let r=n.charCodeAt(0);if(r!==92||(r=n.charCodeAt(1),r!==92))return!1;let c=2;const l=c;for(;c<n.length&&(r=n.charCodeAt(c),r!==92);c++);return!(l===c||(r=n.charCodeAt(c+1),isNaN(r)||r===92))}e.isUNC=i;const C=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,I=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(n,r=L.isWindows){const c=r?C:f;return!(!n||n.length===0||/^\s+$/.test(n)||(c.lastIndex=0,c.test(n))||r&&I.test(n)||n==="."||n===".."||r&&n[n.length-1]==="."||r&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=u;function E(n,r,c){const l=n===r;return!c||l?l:!n||!r?!1:(0,R.equalsIgnoreCase)(n,r)}e.isEqual=E;function g(n,r,c,l=D.sep){if(n===r)return!0;if(!n||!r||r.length>n.length)return!1;if(c){if(!(0,R.startsWithIgnoreCase)(n,r))return!1;if(r.length===n.length)return!0;let d=r.length;return r.charAt(r.length-1)===l&&d--,n.charAt(d)===l}return r.charAt(r.length-1)!==l&&(r+=l),n.indexOf(r)===0}e.isEqualOrParent=g;function w(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=w;function m(n,r){return L.isWindows&&n.endsWith(":")&&(n+=D.sep),(0,D.isAbsolute)(n)||(n=(0,D.join)(r,n)),n=(0,D.normalize)(n),L.isWindows?(n=(0,R.rtrim)(n,D.sep),n.endsWith(":")&&(n+=D.sep)):(n=(0,R.rtrim)(n,D.sep),n||(n=D.sep)),n}e.sanitizeFilePath=m;function v(n){const r=(0,D.normalize)(n);return L.isWindows?n.length>3?!1:o(r)&&(n.length===2||r.charCodeAt(2)===92):r===D.posix.sep}e.isRootOrDriveLetter=v;function o(n){return L.isWindows?w(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function a(n){return o(n)?n[0]:void 0}e.getDriveLetter=a;function t(n,r,c){return r.length>n.length?-1:n===r?0:(c&&(n=n.toLowerCase(),r=r.toLowerCase()),n.indexOf(r))}e.indexOfPath=t;function s(n){const r=n.split(":");let c,l,h;if(r.forEach(d=>{const p=Number(d);(0,T.isNumber)(p)?l===void 0?l=p:h===void 0&&(h=p):c=c?[c,d].join(":"):d}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:l!==void 0?l:void 0,column:h!==void 0?h:l!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(Z[26],ee([0,1,16]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(E){if(!E||typeof E!="object"||E instanceof RegExp)return E;const g=Array.isArray(E)?[]:{};return Object.keys(E).forEach(w=>{E[w]&&typeof E[w]=="object"?g[w]=L(E[w]):g[w]=E[w]}),g}e.deepClone=L;function R(E){if(!E||typeof E!="object")return E;const g=[E];for(;g.length>0;){const w=g.shift();Object.freeze(w);for(const m in w)if(T.call(w,m)){const v=w[m];typeof v=="object"&&!Object.isFrozen(v)&&g.push(v)}}return E}e.deepFreeze=R;const T=Object.prototype.hasOwnProperty;function k(E,g){return P(E,g,new Set)}e.cloneAndChange=k;function P(E,g,w){if((0,D.isUndefinedOrNull)(E))return E;const m=g(E);if(typeof m!="undefined")return m;if((0,D.isArray)(E)){const v=[];for(const o of E)v.push(P(o,g,w));return v}if((0,D.isObject)(E)){if(w.has(E))throw new Error("Cannot clone recursive data-structure");w.add(E);const v={};for(let o in E)T.call(E,o)&&(v[o]=P(E[o],g,w));return w.delete(E),v}return E}function y(E,g,w=!0){return(0,D.isObject)(E)?((0,D.isObject)(g)&&Object.keys(g).forEach(m=>{m in E?w&&((0,D.isObject)(E[m])&&(0,D.isObject)(g[m])?y(E[m],g[m],w):E[m]=g[m]):E[m]=g[m]}),E):g}e.mixin=y;function b(E,g){if(E===g)return!0;if(E==null||g===null||g===void 0||typeof E!=typeof g||typeof E!="object"||Array.isArray(E)!==Array.isArray(g))return!1;let w,m;if(Array.isArray(E)){if(E.length!==g.length)return!1;for(w=0;w<E.length;w++)if(!b(E[w],g[w]))return!1}else{const v=[];for(m in E)v.push(m);v.sort();const o=[];for(m in g)o.push(m);if(o.sort(),!b(v,o))return!1;for(w=0;w<v.length;w++)if(!b(E[v[w]],g[v[w]]))return!1}return!0}e.equals=b;function i(E){const g=new Set;return JSON.stringify(E,(w,m)=>{if((0,D.isObject)(m)||Array.isArray(m)){if(g.has(m))return"[Circular]";g.add(m)}return m})}e.safeStringify=i;function C(E,g,w){const m=g(E);return typeof m=="undefined"?w:m}e.getOrDefault=C;function f(E,g){const w=Object.create(null);return!E||!g||Object.keys(g).forEach(v=>{const o=E[v],a=g[v];b(o,a)||(w[v]=a)}),w}e.distinct=f;function I(E,g){const w=g.toLowerCase(),m=Object.keys(E).find(v=>v.toLowerCase()===w);return m?E[m]:E[g]}e.getCaseInsensitive=I;function u(E,g){const w=Object.create(null);for(const m of Object.keys(E))g(m,E[m])&&(w[m]=E[m]);return w}e.filter=u}),define(Z[5],ee([0,1,8,4]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,T=/^\//,k=/^\/\//;function P(n,r){if(!n.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!R.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!T.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(n,r){return!n&&!r?"file":n}function b(n,r){switch(n){case"https":case"http":case"file":r?r[0]!==C&&(r=C+r):r=C;break}return r}const i="",C="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class I{constructor(r,c,l,h,d,p=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=y(r,p),this.authority=c||i,this.path=b(this.scheme,l||i),this.query=h||i,this.fragment=d||i,P(this,p))}static isUri(r){return r instanceof I?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return v(this,!1)}with(r){if(!r)return this;let{scheme:c,authority:l,path:h,query:d,fragment:p}=r;return c===void 0?c=this.scheme:c===null&&(c=i),l===void 0?l=this.authority:l===null&&(l=i),h===void 0?h=this.path:h===null&&(h=i),d===void 0?d=this.query:d===null&&(d=i),p===void 0?p=this.fragment:p===null&&(p=i),c===this.scheme&&l===this.authority&&h===this.path&&d===this.query&&p===this.fragment?this:new E(c,l,h,d,p)}static parse(r,c=!1){const l=f.exec(r);return l?new E(l[2]||i,s(l[4]||i),s(l[5]||i),s(l[7]||i),s(l[9]||i),c):new E(i,i,i,i,i)}static file(r){let c=i;if(L.isWindows&&(r=r.replace(/\\/g,C)),r[0]===C&&r[1]===C){const l=r.indexOf(C,2);l===-1?(c=r.substring(2),r=C):(c=r.substring(2,l),r=r.substring(l)||C)}return new E("file",c,r,i,i)}static from(r){const c=new E(r.scheme,r.authority,r.path,r.query,r.fragment);return P(c,!0),c}static joinPath(r,...c){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return L.isWindows&&r.scheme==="file"?l=I.file(D.win32.join(v(r,!0),...c)).path:l=D.posix.join(r.path,...c),r.with({path:l})}toString(r=!1){return o(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof I)return r;{const c=new E(r);return c._formatted=r.external,c._fsPath=r._sep===u?r.fsPath:null,c}}else return r}}e.URI=I;const u=L.isWindows?1:void 0;class E extends I{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(r=!1){return r?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=u),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(n,r){let c,l=-1;for(let h=0;h<n.length;h++){const d=n.charCodeAt(h);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||r&&d===47)l!==-1&&(c+=encodeURIComponent(n.substring(l,h)),l=-1),c!==void 0&&(c+=n.charAt(h));else{c===void 0&&(c=n.substr(0,h));const p=g[d];p!==void 0?(l!==-1&&(c+=encodeURIComponent(n.substring(l,h)),l=-1),c+=p):l===-1&&(l=h)}}return l!==-1&&(c+=encodeURIComponent(n.substring(l))),c!==void 0?c:n}function m(n){let r;for(let c=0;c<n.length;c++){const l=n.charCodeAt(c);l===35||l===63?(r===void 0&&(r=n.substr(0,c)),r+=g[l]):r!==void 0&&(r+=n[c])}return r!==void 0?r:n}function v(n,r){let c;return n.authority&&n.path.length>1&&n.scheme==="file"?c=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?r?c=n.path.substr(1):c=n.path[1].toLowerCase()+n.path.substr(2):c=n.path,L.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=v;function o(n,r){const c=r?m:w;let l="",{scheme:h,authority:d,path:p,query:A,fragment:O}=n;if(h&&(l+=h,l+=":"),(d||h==="file")&&(l+=C,l+=C),d){let S=d.indexOf("@");if(S!==-1){const U=d.substr(0,S);d=d.substr(S+1),S=U.indexOf(":"),S===-1?l+=c(U,!1):(l+=c(U.substr(0,S),!1),l+=":",l+=c(U.substr(S+1),!1)),l+="@"}d=d.toLowerCase(),S=d.indexOf(":"),S===-1?l+=c(d,!1):(l+=c(d.substr(0,S),!1),l+=d.substr(S))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const S=p.charCodeAt(1);S>=65&&S<=90&&(p=`/${String.fromCharCode(S+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const S=p.charCodeAt(0);S>=65&&S<=90&&(p=`${String.fromCharCode(S+32)}:${p.substr(2)}`)}l+=c(p,!0)}return A&&(l+="?",l+=c(A,!1)),O&&(l+="#",l+=r?O:w(O,!1)),l}function a(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+a(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(t)?n.replace(t,r=>a(r)):n}}),define(Z[93],ee([0,1,5]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(b){const i=b;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function R(b){const i=[];let C;try{const f=JSON.parse(b.arguments),I=f[f.length-1];I&&I.__$stack&&(f.pop(),C=I.__$stack),i.push(...f)}catch(f){i.push("Unable to log remote console arguments",b.arguments)}return{args:i,stack:C}}e.parse=R;function T(b){if(typeof b!="string")return T(R(b).stack);const i=b;if(i){const C=k(i),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(f&&f.length===4)return{uri:D.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=T;function k(b){if(!b)return b;const i=b.indexOf(`
`);return i===-1?b:b.substring(0,i)}function P(b,i){const{args:C,stack:f}=R(b),I=typeof C[0]=="string"&&C.length===1;let u=k(f);u&&(u=`(${u.trim()})`);let E=[];if(typeof C[0]=="string"?u&&I?E=[`%c[${i}] %c${C[0]} %c${u}`,y("blue"),y(""),y("grey")]:E=[`%c[${i}] %c${C[0]}`,y("blue"),y(""),...C.slice(1)]:E=[`%c[${i}]%`,y("blue"),...C],u&&!I&&E.push(u),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,E)}e.log=P;function y(b){return`color: ${b}`}});var ht=this&&this.__classPrivateFieldSet||function(K,e,D,L,R){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?R.call(K,D):R?R.value=D:e.set(K,D),D},We=this&&this.__classPrivateFieldGet||function(K,e,D,L){if(D==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!L:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?L:D==="a"?L.call(K):L?L.value:e.get(K)};define(Z[40],ee([0,1,18,24,5]),function(K,e,D,L,R){"use strict";var T,k,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(s,n,r){let c=s.get(n);return c===void 0&&(c=r,s.set(n,c)),c}e.getOrSet=y;function b(s){const n=[];return s.forEach((r,c)=>{n.push(`${c} => ${r}`)}),`Map(${s.size}) {${n.join(", ")}}`}e.mapToString=b;function i(s){const n=[];return s.forEach(r=>{n.push(r)}),`Set(${s.size}) {${n.join(", ")}}`}e.setToString=i;class C{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const r=n.charCodeAt(0),c=this._value.charCodeAt(this._pos);return r-c}value(){return this._value[this._pos]}}e.StringIterator=C;class f{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,L.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=f;class I{constructor(n=!0,r=!0){this._splitOnBackslash=n,this._caseSensitive=r}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,L.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=I;var u;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(u||(u={}));class E{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new I(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,L.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=E;class g{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class w{constructor(n){this._iter=n}static forUris(n=()=>!1){return new w(new E(n))}static forPaths(){return new w(new I)}static forStrings(){return new w(new C)}static forConfigKeys(){return new w(new f)}clear(){this._root=void 0}set(n,r){const c=this._iter.reset(n);let l;for(this._root||(this._root=new g,this._root.segment=c.value()),l=this._root;;){const d=c.cmp(l.segment);if(d>0)l.left||(l.left=new g,l.left.segment=c.value()),l=l.left;else if(d<0)l.right||(l.right=new g,l.right.segment=c.value()),l=l.right;else if(c.hasNext())c.next(),l.mid||(l.mid=new g,l.mid.segment=c.value()),l=l.mid;else break}const h=l.value;return l.value=r,l.key=n,h}fill(n,r){const c=r.slice(0);(0,D.shuffle)(c);for(let l of c)this.set(l,n)}get(n){return this._getNode(n)?.value}_getNode(n){const r=this._iter.reset(n);let c=this._root;for(;c;){const l=r.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else break}return c}has(n){const r=this._getNode(n);return!(r?.value===void 0&&r?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,r){const c=this._iter.reset(n),l=[];let h=this._root;for(;h;){const d=c.cmp(h.segment);if(d>0)l.push([1,h]),h=h.left;else if(d<0)l.push([-1,h]),h=h.right;else if(c.hasNext())c.next(),l.push([0,h]),h=h.mid;else{for(r?(h.left=void 0,h.mid=void 0,h.right=void 0):h.value=void 0;l.length>0&&h.isEmpty();){let[p,A]=l.pop();switch(p){case 1:A.left=void 0;break;case 0:A.mid=void 0;break;case-1:A.right=void 0;break}h=A}break}}}findSubstr(n){const r=this._iter.reset(n);let c=this._root,l;for(;c;){const h=r.cmp(c.segment);if(h>0)c=c.left;else if(h<0)c=c.right;else if(r.hasNext())r.next(),l=c.value||l,c=c.mid;else break}return c&&c.value||l}findSuperstr(n){const r=this._iter.reset(n);let c=this._root;for(;c;){const l=r.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(n){for(const[r,c]of this)n(c,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){if(!n)return;const r=[n];for(;r.length>0;){const c=r.pop();c&&(c.value&&(yield[c.key,c.value]),c.left&&r.push(c.left),c.mid&&r.push(c.mid),c.right&&r.push(c.right))}}}e.TernarySearchTree=w;class m{constructor(n,r){this[T]="ResourceMap",n instanceof m?(this.map=new Map(n.map),this.toKey=r??m.defaultToKey):(this.map=new Map,this.toKey=n??m.defaultToKey)}set(n,r){return this.map.set(this.toKey(n),r),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,r){typeof r!="undefined"&&(n=n.bind(r));for(let[c,l]of this.map)n(l,R.URI.parse(c),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield R.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[R.URI.parse(n[0]),n[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[R.URI.parse(n[0]),n[1]]}}e.ResourceMap=m,m.defaultToKey=s=>s.toString();var v;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class o{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,r=0){const c=this._map.get(n);if(!!c)return r!==0&&this.touch(c,r),c.value}set(n,r,c=0){let l=this._map.get(n);if(l)l.value=r,c!==0&&this.touch(l,c);else{switch(l={key:n,value:r,next:void 0,previous:void 0},c){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(n,l),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this._map.get(n);if(!!r)return this._map.delete(n),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,r){const c=this._state;let l=this._head;for(;l;){if(r?n.bind(r)(l.value,l.key,this):n(l.value,l.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,r=this._state;let c=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:c.key,done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return l}values(){const n=this,r=this._state;let c=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:c.value,done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return l}entries(){const n=this,r=this._state;let c=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:[c.key,c.value],done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return l}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this._head,c=this.size;for(;r&&c>n;)this._map.delete(r.key),r=r.next,c--;this._head=r,this._size=c,r&&(r.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const r=n.next,c=n.previous;if(!r||!c)throw new Error("Invalid list");r.previous=c,c.next=r}n.next=void 0,n.previous=void 0,this._state++}touch(n,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(n===this._head)return;const c=n.next,l=n.previous;n===this._tail?(l.next=void 0,this._tail=l):(c.previous=l,l.next=c),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(r===2){if(n===this._tail)return;const c=n.next,l=n.previous;n===this._head?(c.previous=void 0,this._head=c):(c.previous=l,l.next=c),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((r,c)=>{n.push([c,r])}),n}fromJSON(n){this.clear();for(const[r,c]of n)this.set(r,c)}}e.LinkedMap=o;class a extends o{constructor(n,r=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,r=2){return super.get(n,r)}peek(n){return super.get(n,0)}set(n,r){return super.set(n,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class t{constructor(n){P.set(this,void 0),ht(this,P,n,"f")}get size(){return We(this,P,"f").size}forEach(n,r){We(this,P,"f").forEach(n,r)}get(n){return We(this,P,"f").get(n)}has(n){return We(this,P,"f").has(n)}entries(){return We(this,P,"f").entries()}keys(){return We(this,P,"f").keys()}values(){return We(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return We(this,P,"f").entries()}}e.ReadonlyMapView=t}),define(Z[94],ee([0,1,25,24,5]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(i){return JSON.stringify(i,y)}e.stringify=T;function k(i){let C=JSON.parse(i);return C=b(C),C}e.parse=k;var P;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function y(i,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,L.regExpFlags)(C)}:C}function b(i,C=0){if(!i||C>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return R.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof D.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let f=0;f<i.length;++f)i[f]=b(i[f],C+1);else for(const f in i)Object.hasOwnProperty.call(i,f)&&(i[f]=b(i[f],C+1))}return i}e.revive=b}),define(Z[17],ee([0,1,4,5]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(R=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,b,i){this._hosts[y]=b,this._ports[y]=i}setConnectionToken(y,b){this._connectionTokens[y]=b}rewrite(y){if(this._delegate)return this._delegate(y);const b=y.authority;let i=this._hosts[b];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const C=this._ports[b],f=this._connectionTokens[b];let I=`path=${encodeURIComponent(y.path)}`;return typeof f=="string"&&(I+=`&tkn=${encodeURIComponent(f)}`),L.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${i}:${C}`,path:"/vscode-remote-resource",query:I})}}e.RemoteAuthorities=new T;class k{asBrowserUri(y,b){const i=this.toUri(y,b);return i.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===R.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${R.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?i.with({scheme:R.vscodeFileResource,authority:i.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(y,b){const i=this.toUri(y,b);return i.scheme===R.vscodeFileResource?i.with({scheme:R.file,authority:i.authority!==k.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(y,b){return L.URI.isUri(y)?y:L.URI.parse(b.toUrl(y))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(Z[66],ee([0,1,40]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new D.LRUCache(1e4);function R(b){return y(b,"NFC",L)}e.normalizeNFC=R;const T=new D.LRUCache(1e4);function k(b){return y(b,"NFD",T)}e.normalizeNFD=k;const P=/[^\u0000-\u0080]/;function y(b,i,C){if(!b)return b;const f=C.get(b);if(f)return f;let I;return P.test(b)?I=b.normalize(i):I=b,C.set(b,I),I}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(i){return k(i).replace(b,"")}}()}),define(Z[15],ee([0,1,39,17,8,4,24,5]),function(K,e,D,L,R,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(I){return(0,P.uriToFsPath)(I,!0)}e.originalFSPath=y;class b{constructor(u){this._ignorePathCasing=u}compare(u,E,g=!1){return u===E?0:(0,k.compare)(this.getComparisonKey(u,g),this.getComparisonKey(E,g))}isEqual(u,E,g=!1){return u===E?!0:!u||!E?!1:this.getComparisonKey(u,g)===this.getComparisonKey(E,g)}getComparisonKey(u,E=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,E,g=!1){if(u.scheme===E.scheme){if(u.scheme===L.Schemas.file)return D.isEqualOrParent(y(u),y(E),this._ignorePathCasing(u))&&u.query===E.query&&(g||u.fragment===E.fragment);if((0,e.isEqualAuthority)(u.authority,E.authority))return D.isEqualOrParent(u.path,E.path,this._ignorePathCasing(u),"/")&&u.query===E.query&&(g||u.fragment===E.fragment)}return!1}joinPath(u,...E){return P.URI.joinPath(u,...E)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return R.posix.basename(u.path)}extname(u){return R.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let E;return u.scheme===L.Schemas.file?E=P.URI.file(R.dirname(y(u))).path:(E=R.posix.dirname(u.path),u.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),E="/")),u.with({path:E})}normalizePath(u){if(!u.path.length)return u;let E;return u.scheme===L.Schemas.file?E=P.URI.file(R.normalize(y(u))).path:E=R.posix.normalize(u.path),u.with({path:E})}relativePath(u,E){if(u.scheme!==E.scheme||!(0,e.isEqualAuthority)(u.authority,E.authority))return;if(u.scheme===L.Schemas.file){const m=R.relative(y(u),y(E));return T.isWindows?D.toSlashes(m):m}let g=u.path||"/",w=E.path||"/";if(this._ignorePathCasing(u)){let m=0;for(const v=Math.min(g.length,w.length);m<v&&!(g.charCodeAt(m)!==w.charCodeAt(m)&&g.charAt(m).toLowerCase()!==w.charAt(m).toLowerCase());m++);g=w.substr(0,m)+g.substr(m)}return R.posix.relative(g,w)}resolvePath(u,E){if(u.scheme===L.Schemas.file){const g=P.URI.file(R.resolve(y(u),E));return u.with({authority:g.authority,path:g.path})}return E=D.toPosixPath(E),u.with({path:R.posix.resolve(u.path,E)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,E){return u===E||(0,k.equalsIgnoreCase)(u,E)}hasTrailingPathSeparator(u,E=R.sep){if(u.scheme===L.Schemas.file){const g=y(u);return g.length>D.getRoot(g).length&&g[g.length-1]===E}else{const g=u.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,E=R.sep){return(0,e.hasTrailingPathSeparator)(u,E)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,E=R.sep){let g=!1;if(u.scheme===L.Schemas.file){const w=y(u);g=w!==void 0&&w.length===D.getRoot(w).length&&w[w.length-1]===E}else{E="/";const w=u.path;g=w.length===1&&w.charCodeAt(w.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(u,E)?u.with({path:u.path+"/"}):u}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(I=>I.scheme===L.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new b(I=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(I,u){const E=[];for(let g=0;g<I.length;g++){const w=u(I[g]);I.some((m,v)=>v===g?!1:(0,e.isEqualOrParent)(w,u(m)))||E.push(I[g])}return E}e.distinctParents=i;var C;(function(I){I.META_DATA_LABEL="label",I.META_DATA_DESCRIPTION="description",I.META_DATA_SIZE="size",I.META_DATA_MIME="mime";function u(E){const g=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(v=>{const[o,a]=v.split(":");o&&a&&g.set(o,a)});const m=E.path.substring(0,E.path.indexOf(";"));return m&&g.set(I.META_DATA_MIME,m),g}I.parseMetaData=u})(C=e.DataUri||(e.DataUri={}));function f(I,u,E){if(u){let g=I.path;return g&&g[0]!==R.posix.sep&&(g=R.posix.sep+g),I.with({scheme:E,authority:u,path:g})}return I.with({scheme:E})}e.toLocalResource=f}),define(Z[6],ee([0,1,27,9,3,2,15]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(x){return!!x&&typeof x.then=="function"}e.isThenable=P;function y(x){const $=new D.CancellationTokenSource,q=x($.token),N=new Promise((V,_)=>{const Y=$.token.onCancellationRequested(()=>{Y.dispose(),$.dispose(),_((0,L.canceled)())});Promise.resolve(q).then(G=>{Y.dispose(),$.dispose(),V(G)},G=>{Y.dispose(),$.dispose(),_(G)})});return new class{cancel(){$.cancel()}then(V,_){return N.then(V,_)}catch(V){return this.then(void 0,V)}finally(V){return N.finally(V)}}}e.createCancelablePromise=y;function b(x,$,q){return Promise.race([x,new Promise(N=>$.onCancellationRequested(()=>N(q)))])}e.raceCancellation=b;async function i(x){let $=-1;const q=x.map((V,_)=>V.then(Y=>($=_,Y))),N=await Promise.race(q);return x.forEach((V,_)=>{_!==$&&V.cancel()}),N}e.raceCancellablePromises=i;function C(x,$,q){let N;const V=setTimeout(()=>{N?.(void 0),q?.()},$);return Promise.race([x.finally(()=>clearTimeout(V)),new Promise(_=>N=_)])}e.raceTimeout=C;function f(x){return new Promise(($,q)=>{const N=x();P(N)?N.then($,q):$(N)})}e.asPromise=f;class I{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const q=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(q,q).then(N)})}return new Promise((q,N)=>{this.queuedPromise.then(q,N)})}return this.activePromise=$(),new Promise((q,N)=>{this.activePromise.then(V=>{this.activePromise=null,q(V)},V=>{this.activePromise=null,N(V)})})}}e.Throttler=I;class u{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=u;class E{constructor(){this.promiseMap=new Map}queue($,q){const V=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.promiseMap.get($)===V&&this.promiseMap.delete($)});return this.promiseMap.set($,V),V}}e.SequencerByKey=E;class g{constructor($){this.defaultDelay=$,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,q=this.defaultDelay){return this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((N,V)=>{this.doResolve=N,this.doReject=V}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const N=this.task;return this.task=null,N()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=g;class w{constructor($){this.delayer=new g($),this.throttler=new I}trigger($,q){return this.delayer.trigger(()=>this.throttler.queue($),q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class m{constructor(){this._isOpen=!1,this._promise=new Promise(($,q)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=m;class v extends m{constructor($){super();this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=v;function o(x,$){return $?new Promise((q,N)=>{const V=setTimeout(()=>{_.dispose(),q()},x),_=$.onCancellationRequested(()=>{clearTimeout(V),_.dispose(),N((0,L.canceled)())})}):y(q=>o(x,q))}e.timeout=o;function a(x,$=0){const q=setTimeout(x,$);return(0,T.toDisposable)(()=>clearTimeout(q))}e.disposableTimeout=a;function t(x){const $=[];let q=0;const N=x.length;function V(){return q<N?x[q++]():null}function _(Y){Y!=null&&$.push(Y);const G=V();return G?G.then(_):Promise.resolve($)}return Promise.resolve(null).then(_)}e.sequence=t;function s(x,$=N=>!!N,q=null){let N=0;const V=x.length,_=()=>{if(N>=V)return Promise.resolve(q);const Y=x[N++];return Promise.resolve(Y()).then(te=>$(te)?Promise.resolve(te):_())};return _()}e.first=s;function n(x,$=N=>!!N,q=null){if(x.length===0)return Promise.resolve(q);let N=x.length;const V=()=>{N=-1;for(const _ of x)_.cancel?.()};return new Promise((_,Y)=>{for(const G of x)G.then(te=>{--N>=0&&$(te)?(V(),_(te)):N===0&&_(q)}).catch(te=>{--N>=0&&(V(),Y(te))})})}e.firstParallel=n;class r{constructor($){this._size=0,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue($){return this._size++,new Promise((q,N)=>{this.outstandingPromises.push({factory:$,c:q,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const q=$.factory();q.then($.c,$.e),q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class c extends r{constructor(){super(1)}}e.Queue=c;class l{constructor(){this.queues=new Map}queueFor($,q=k.extUri){const N=q.getComparisonKey($);let V=this.queues.get(N);return V||(V=new c,R.Event.once(V.onFinished)(()=>{V?.dispose(),this.queues.delete(N)}),this.queues.set(N,V)),V}dispose(){this.queues.forEach($=>$.dispose()),this.queues.clear()}}e.ResourceQueue=l;class h{constructor($,q){this._token=-1,typeof $=="function"&&typeof q=="number"&&this.setIfNotSet($,q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},q)}setIfNotSet($,q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},q))}}e.TimeoutTimer=h;class d{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet($,q){this.cancel(),this._token=setInterval(()=>{$()},q)}}e.IntervalTimer=d;class p{constructor($,q){this.timeoutToken=-1,this.runner=$,this.timeout=q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=p;class A{constructor($,q){q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=q,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class O extends p{constructor($,q){super($,q);this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner&&this.runner($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class S extends T.Disposable{constructor($,q,N,V){super();this.maxWorkChunkSize=$,this.maxPendingWork=q,this.throttleDelay=N,this.handler=V,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.maxPendingWork)return!1}else if(this.pending+$.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...$),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new p(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=S,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const x=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=$=>{const q=setTimeout(()=>$(x));let N=!1;return{dispose(){N||(N=!0,clearTimeout(q))}}}}else e.runWhenIdle=(x,$)=>{const q=requestIdleCallback(x,typeof $=="number"?{timeout:$}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(q))}}}}();class U{constructor($){this._didRun=!1,this._executor=()=>{try{this._value=$()}catch(q){this._error=q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=U;async function F(x,$,q){let N;for(let V=0;V<q;V++)try{return await x()}catch(_){N=_,await o($)}throw N}e.retry=F;class z{hasPending($){return this._pending?typeof $=="number"?this._pending.taskId===$:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending($,q,N){return this._pending={taskId:$,cancel:()=>N?.(),promise:q},q.then(()=>this.donePending($),()=>this.donePending($)),q}donePending($){this._pending&&$===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const $=this._next;this._next=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this._next)this._next.run=$;else{let q,N;const V=new Promise((_,Y)=>{q=_,N=Y});this._next={run:$,promise:V,promiseResolve:q,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=z;class j{constructor($){this.interval=$,this.lastIncrementTime=0,this.value=0}increment(){const $=Date.now();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=j;class M{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise(($,q)=>{this.completeCallback=$,this.errorCallback=q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete($){return new Promise(q=>{this.completeCallback($),this.resolved=!0,q()})}error($){return new Promise(q=>{this.errorCallback($),this.rejected=!0,q()})}cancel(){new Promise($=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,$()})}}e.DeferredPromise=M;var W;(function(x){async function $(q){let N;const V=await Promise.all(q.map(_=>_.then(Y=>Y,Y=>{N||(N=Y)})));if(typeof N!="undefined")throw N;return V}x.settled=$})(W=e.Promises||(e.Promises={}))}),define(Z[67],ee([0,1,6,39,40,8,24]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const y="**",b="/",i="[/\\\\]",C="[^/\\\\]",f=/\//g;function I(N){switch(N){case 0:return"";case 1:return`${C}*?`;default:return`(?:${i}|${C}+${i}|${i}${C}+)*?`}}function u(N,V){if(!N)return[];const _=[];let Y=!1,G=!1,te="";for(const ne of N){switch(ne){case V:if(!Y&&!G){_.push(te),te="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":G=!0;break;case"]":G=!1;break}te+=ne}return te&&_.push(te),_}e.splitGlobAware=u;function E(N){if(!N)return"";let V="";const _=u(N,b);if(_.every(Y=>Y===y))V=".*";else{let Y=!1;_.forEach((G,te)=>{if(G===y){Y||(V+=I(2),Y=!0);return}let ne=!1,J="",H=!1,re="";for(const ie of G){if(ie!=="}"&&ne){J+=ie;continue}if(H&&(ie!=="]"||!re)){let ce;ie==="-"?ce=ie:(ie==="^"||ie==="!")&&!re?ce="^":ie===b?ce="":ce=k.escapeRegExpCharacters(ie),re+=ce;continue}switch(ie){case"{":ne=!0;continue;case"[":H=!0;continue;case"}":V+=`(?:${u(J,",").map(ye=>E(ye)).join("|")})`,ne=!1,J="";break;case"]":V+="["+re+"]",H=!1,re="";break;case"?":V+=C;continue;case"*":V+=I(1);continue;default:V+=k.escapeRegExpCharacters(ie)}}te<_.length-1&&(_[te+1]!==y||te+2<_.length)&&(V+=i),Y=!1})}return V}const g=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),s=function(){return!1},n=function(){return null};function r(N,V){if(!N)return n;let _;typeof N!="string"?_=N.pattern:_=N,_=_.trim();const Y=`${_}_${!!V.trimForExclusions}`;let G=t.get(Y);if(G)return c(G,N);let te;if(g.test(_)){const ne=_.substr(4);G=function(J,H){return typeof J=="string"&&J.endsWith(ne)?_:null}}else(te=w.exec(l(_,V)))?G=h(te[1],_):(V.trimForExclusions?v:m).test(_)?G=d(_,V):(te=o.exec(l(_,V)))?G=p(te[1].substr(1),_,!0):(te=a.exec(l(_,V)))?G=p(te[1],_,!1):G=A(_);return t.set(Y,G),c(G,N)}function c(N,V){return typeof V=="string"?N:function(_,Y){return L.isEqualOrParent(_,V.base)?N(T.relative(V.base,_),Y):null}}function l(N,V){return V.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function h(N,V){const _=`/${N}`,Y=`\\${N}`,G=function(ne,J){return typeof ne!="string"?null:J?J===N?V:null:ne===N||ne.endsWith(_)||ne.endsWith(Y)?V:null},te=[N];return G.basenames=te,G.patterns=[V],G.allBasenames=te,G}function d(N,V){const _=q(N.slice(1,-1).split(",").map(J=>r(J,V)).filter(J=>J!==n),N),Y=_.length;if(!Y)return n;if(Y===1)return _[0];const G=function(J,H){for(let re=0,ie=_.length;re<ie;re++)if(_[re](J,H))return N;return null},te=_.find(J=>!!J.allBasenames);te&&(G.allBasenames=te.allBasenames);const ne=_.reduce((J,H)=>H.allPaths?J.concat(H.allPaths):J,[]);return ne.length&&(G.allPaths=ne),G}function p(N,V,_){const Y=T.sep===T.posix.sep,G=Y?N:N.replace(f,T.sep),te=T.sep+G,ne=T.posix.sep+N,J=_?function(H,re){return typeof H=="string"&&(H===G||H.endsWith(te)||!Y&&(H===N||H.endsWith(ne)))?V:null}:function(H,re){return typeof H=="string"&&(H===G||!Y&&H===N)?V:null};return J.allPaths=[(_?"*/":"./")+N],J}function A(N){try{const V=new RegExp(`^${E(N)}$`);return function(_){return V.lastIndex=0,typeof _=="string"&&V.test(_)?N:null}}catch(V){return n}}function O(N,V,_){return!N||typeof V!="string"?!1:S(N)(V,void 0,_)}e.match=O;function S(N,V={}){if(!N)return s;if(typeof N=="string"||j(N)){const _=r(N,V);if(_===n)return s;const Y=function(G,te){return!!_(G,te)};return _.allBasenames&&(Y.allBasenames=_.allBasenames),_.allPaths&&(Y.allPaths=_.allPaths),Y}return x(N,V)}e.parse=S;function U(N){if(!N)return;let V;return _=>(V||(V=(N()||Promise.resolve([])).then(Y=>Y?z(Y):{})),V.then(Y=>!!Y[_]))}e.hasSiblingPromiseFn=U;function F(N){if(!N)return;let V;return _=>{if(!V){const Y=N();V=Y?z(Y):{}}return!!V[_]}}e.hasSiblingFn=F;function z(N){const V={};for(const _ of N)V[_]=!0;return V}function j(N){const V=N;return V&&typeof V.base=="string"&&typeof V.pattern=="string"}e.isRelativePattern=j;function M(N){return N.allBasenames||[]}e.getBasenameTerms=M;function W(N){return N.allPaths||[]}e.getPathTerms=W;function x(N,V){const _=q(Object.getOwnPropertyNames(N).map(J=>$(J,N[J],V)).filter(J=>J!==n)),Y=_.length;if(!Y)return n;if(!_.some(J=>!!J.requiresSiblings)){if(Y===1)return _[0];const J=function(ie,ce){for(let ue=0,ye=_.length;ue<ye;ue++){const ge=_[ue](ie,ce);if(ge)return ge}return null},H=_.find(ie=>!!ie.allBasenames);H&&(J.allBasenames=H.allBasenames);const re=_.reduce((ie,ce)=>ce.allPaths?ie.concat(ce.allPaths):ie,[]);return re.length&&(J.allPaths=re),J}const G=function(J,H,re){let ie;for(let ce=0,ue=_.length;ce<ue;ce++){const ye=_[ce];ye.requiresSiblings&&re&&(H||(H=T.basename(J)),ie||(ie=H.substr(0,H.length-T.extname(J).length)));const ge=ye(J,H,ie,re);if(ge)return ge}return null},te=_.find(J=>!!J.allBasenames);te&&(G.allBasenames=te.allBasenames);const ne=_.reduce((J,H)=>H.allPaths?J.concat(H.allPaths):J,[]);return ne.length&&(G.allPaths=ne),G}function $(N,V,_){if(V===!1)return n;const Y=r(N,_);if(Y===n)return n;if(typeof V=="boolean")return Y;if(V){const G=V.when;if(typeof G=="string"){const te=(ne,J,H,re)=>{if(!re||!Y(ne,J))return null;const ie=G.replace("$(basename)",H),ce=re(ie);return(0,D.isThenable)(ce)?ce.then(ue=>ue?N:null):ce?N:null};return te.requiresSiblings=!0,te}}return Y}function q(N,V){const _=N.filter(J=>!!J.basenames);if(_.length<2)return N;const Y=_.reduce((J,H)=>{const re=H.basenames;return re?J.concat(re):J},[]);let G;if(V){G=[];for(let J=0,H=Y.length;J<H;J++)G.push(V)}else G=_.reduce((J,H)=>{const re=H.patterns;return re?J.concat(re):J},[]);const te=function(J,H){if(typeof J!="string")return null;if(!H){let ie;for(ie=J.length;ie>0;ie--){const ce=J.charCodeAt(ie-1);if(ce===47||ce===92)break}H=J.substr(ie)}const re=Y.indexOf(H);return re!==-1?G[re]:null};te.basenames=Y,te.patterns=G,te.allBasenames=Y;const ne=N.filter(J=>!J.basenames);return ne.push(te),ne}}),define(Z[95],ee([0,1,67,17,8,15,24]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let y=[],b=[],i=[];function C(r,c=!1){const l=f(r);y.push(l),l.userConfigured?i.push(l):b.push(l),c&&!l.userConfigured&&y.forEach(h=>{h.mime===l.mime||h.userConfigured||(l.extension&&h.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&h.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&h.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&h.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=C;function f(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?(0,D.parse)(r.filepattern.toLowerCase()):void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(R.posix.sep)>=0:!1}}function I(r){r?(y=y.filter(c=>!c.userConfigured),i=[]):(y=[],b=[],i=[])}e.clearTextMimes=I;function u(r,c){let l;if(r)switch(r.scheme){case L.Schemas.file:l=r.fsPath;break;case L.Schemas.data:l=T.DataUri.parseMetaData(r).get(T.DataUri.META_DATA_LABEL);break;default:l=r.path}if(!l)return[P.unknown];l=l.toLowerCase();const h=(0,R.basename)(l),d=E(l,h,i);if(d)return[d,P.text];const p=E(l,h,b);if(p)return[p,P.text];if(c){const A=g(c);if(A)return[A,P.text]}return[P.unknown]}e.guessMimeTypes=u;function E(r,c,l){let h=null,d=null,p=null;for(let A=l.length-1;A>=0;A--){const O=l[A];if(c===O.filenameLowercase){h=O;break}if(O.filepattern&&(!d||O.filepattern.length>d.filepattern.length)){const S=O.filepatternOnPath?r:c;O.filepatternLowercase?.(S)&&(d=O)}O.extension&&(!p||O.extension.length>p.extension.length)&&c.endsWith(O.extensionLowercase)&&(p=O)}return h?h.mime:d?d.mime:p?p.mime:null}function g(r){if((0,k.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let c=y.length-1;c>=0;c--){const l=y[c];if(!l.firstline)continue;const h=r.match(l.firstline);if(h&&h.length>0)return l.mime}return null}function w(r){return r?typeof r=="string"?r===P.binary||r===P.text||r===P.unknown:r.length===1&&w(r[0]):!0}e.isUnspecific=w;const m={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},v={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(r){const c=(0,R.extname)(r),l=m[c.toLowerCase()];return l!==void 0?l:a(r)}e.getMediaOrTextMime=o;function a(r){const c=(0,R.extname)(r);return v[c.toLowerCase()]}e.getMediaMime=a;function t(r){for(const c in v)if(v[c]===r)return c}e.getExtensionForMimeType=t;const s=/^(.+)\/(.+?)(;.+)?$/;function n(r,c){const l=s.exec(r);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:c?void 0:r}e.normalizeMimeType=n}),define(Z[96],ee([0,1,5]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class R{constructor(C){this._uriTransformer=C}transformIncoming(C){const f=this._uriTransformer.transformIncoming(C);return f===C?C:L(D.URI.from(f))}transformOutgoing(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:L(D.URI.from(f))}transformOutgoingURI(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:D.URI.from(f)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function T(i,C,f){if(!i||f>200)return null;if(typeof i=="object"){if(i instanceof D.URI)return C.transformOutgoing(i);for(let I in i)if(Object.hasOwnProperty.call(i,I)){const u=T(i[I],C,f+1);u!==null&&(i[I]=u)}}return null}function k(i,C){const f=T(i,C,0);return f===null?i:f}e.transformOutgoingURIs=k;function P(i,C,f,I){if(!i||I>200)return null;if(typeof i=="object"){if(i.$mid===1)return f?D.URI.revive(C.transformIncoming(i)):C.transformIncoming(i);for(let u in i)if(Object.hasOwnProperty.call(i,u)){const E=P(i[u],C,f,I+1);E!==null&&(i[u]=E)}}return null}function y(i,C){const f=P(i,C,!1,0);return f===null?i:f}e.transformIncomingURIs=y;function b(i,C){const f=P(i,C,!0,0);return f===null?i:f}e.transformAndReviveIncomingURIs=b}),define(Z[30],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(y){return D.test(y)}e.isUUID=L;const R=new Uint8Array(16),T=[];for(let y=0;y<256;y++)T.push(y.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(y){for(let b=0;b<y.length;b++)y[b]=Math.floor(Math.random()*256);return y};function P(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let y=0,b="";return b+=T[R[y++]],b+=T[R[y++]],b+=T[R[y++]],b+=T[R[y++]],b+="-",b+=T[R[y++]],b+=T[R[y++]],b+="-",b+=T[R[y++]],b+=T[R[y++]],b+="-",b+=T[R[y++]],b+=T[R[y++]],b+="-",b+=T[R[y++]],b+=T[R[y++]],b+=T[R[y++]],b+=T[R[y++]],b+=T[R[y++]],b+=T[R[y++]],b}e.generateUuid=P}),define(Z[68],ee([0,1,218]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(T="utf8"){this.stringDecoder=new D.StringDecoder(T),this.remaining=null}write(T){const k=[],P=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(P.length<1)return k;let y=0,b,i=y;for(;i<P.length;)if(b=P.charCodeAt(i),b===13||b===10){if(k.push(P.substring(y,i)),i++,i<P.length){const C=b;b=P.charCodeAt(i),(C===13&&b===10||C===10&&b===13)&&i++}y=i}else i++;return this.remaining=y<P.length?P.substr(y):null,k}end(){return this.remaining}}e.LineDecoder=L}),define(Z[97],ee([0,1,35]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(P){const y=P.replace(/\-/g,":").toLowerCase();return!L.has(y)}function T(){return new Promise(async(P,y)=>{const b=setTimeout(()=>y("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await k())}catch(i){y(i)}finally{clearTimeout(b)}})}e.getMac=T;function k(){return new Promise((P,y)=>{try{const b=(0,D.networkInterfaces)();for(let i in b){const C=b[i];if(C){for(const{mac:f}of C)if(R(f))return P(f)}}y("Unable to retrieve mac address (unexpected format)")}catch(b){y(b)}})}}),define(Z[98],ee([0,1,35,9,40,30,97]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,C=0;const f=(0,D.networkInterfaces)();for(let I in f){const u=f[I];if(u)for(const{mac:E,internal:g}of u)g||(C+=1,this._isVirtualMachineMacAddress(E.toUpperCase())&&(i+=1))}this._value=C>0?i/C:0}return this._value}};let P;async function y(){return P||(P=(async()=>await b()||T.generateUuid())()),P}e.getMachineId=y;async function b(){try{const i=await new Promise((f,I)=>{K(["crypto"],f,I)}),C=await(0,k.getMac)();return i.createHash("sha256").update(C,"utf8").digest("hex")}catch(i){L.onUnexpectedError(i);return}}}),define(Z[19],ee([0,1,51,35,219,6,39,66,8,4,15,5,30]),function(K,e,D,L,R,T,k,P,y,b,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var I;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(I=e.RimRafMode||(e.RimRafMode={}));async function u(M,W=I.UNLINK){if((0,k.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return W===I.UNLINK?g(M):E(M)}async function E(M){try{const W=(0,y.join)((0,L.tmpdir)(),(0,f.generateUuid)());try{await e.Promises.rename(M,W)}catch(x){return g(M)}g(W).catch(x=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function g(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function w(M){if((0,k.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");D.rmdirSync(M,{recursive:!0})}e.rimrafSync=w;async function m(M,W){return a(await(W?v(M):(0,R.promisify)(D.readdir)(M)))}async function v(M){try{return await(0,R.promisify)(D.readdir)(M,{withFileTypes:!0})}catch($){console.warn("[node.js fs] readdir with filetypes failed with error: ",$)}const W=[],x=await m(M);for(const $ of x){let q=!1,N=!1,V=!1;try{const _=await e.Promises.lstat((0,y.join)(M,$));q=_.isFile(),N=_.isDirectory(),V=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}W.push({name:$,isFile:()=>q,isDirectory:()=>N,isSymbolicLink:()=>V})}return W}function o(M){return a(D.readdirSync(M))}e.readdirSync=o;function a(M){return M.map(W=>typeof W=="string"?b.isMacintosh?(0,P.normalizeNFC)(W):W:(W.name=b.isMacintosh?(0,P.normalizeNFC)(W.name):W.name,W))}async function t(M){const W=await m(M),x=[];for(const $ of W)await n.existsDirectory((0,y.join)(M,$))&&x.push($);return x}function s(M,W=1e3){return new Promise(x=>{let $=!1;const q=setInterval(()=>{$||($=!0,D.access(M,N=>{$=!1,N&&(clearInterval(q),x(void 0))}))},W)})}e.whenDeleted=s;var n;(function(M){async function W(q){let N;try{if(N=await e.Promises.lstat(q),!N.isSymbolicLink())return{stat:N}}catch(V){}try{return{stat:await e.Promises.stat(q),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(b.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw _}throw V}}M.stat=W;async function x(q){try{const{stat:N,symbolicLink:V}=await M.stat(q);return N.isFile()&&V?.dangling!==!0}catch(N){}return!1}M.existsFile=x;async function $(q){try{const{stat:N,symbolicLink:V}=await M.stat(q);return N.isDirectory()&&V?.dangling!==!0}catch(N){}return!1}M.existsDirectory=$})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new T.ResourceQueue;function c(M,W,x){return r.queueFor(C.URI.file(M),i.extUriBiasedIgnorePathCase).queue(()=>{const $=p(x);return new Promise((q,N)=>h(M,W,$,V=>V?N(V):q()))})}let l=!0;function h(M,W,x,$){if(!l)return D.writeFile(M,W,{mode:x.mode,flag:x.flag},$);D.open(M,x.flag,x.mode,(q,N)=>{if(q)return $(q);D.writeFile(N,W,V=>{if(V)return D.close(N,()=>$(V));D.fdatasync(N,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),l=!1),D.close(N,Y=>$(Y))))})})}function d(M,W,x){const $=p(x);if(!l)return D.writeFileSync(M,W,{mode:$.mode,flag:$.flag});const q=D.openSync(M,$.flag,$.mode);try{D.writeFileSync(q,W);try{D.fdatasyncSync(q)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),l=!1}}finally{D.closeSync(q)}}e.writeFileSync=d;function p(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function A(M,W){if(M===W)return;async function x($){try{const q=await e.Promises.lstat($);if(q.isDirectory()||q.isSymbolicLink())return;await e.Promises.utimes($,q.atime,new Date)}catch(q){}}try{await e.Promises.rename(M,W),await x(W)}catch($){if(M.toLowerCase()!==W.toLowerCase()&&$.code==="EXDEV"||M.endsWith("."))await O(M,W,{preserveSymlinks:!1}),await u(M,I.MOVE),await x(W);else throw $}}async function O(M,W,x){return U(M,W,{root:{source:M,target:W},options:x,handledSourcePaths:new Set})}const S=511;async function U(M,W,x){if(x.handledSourcePaths.has(M))return;x.handledSourcePaths.add(M);const{stat:$,symbolicLink:q}=await n.stat(M);if(q){if(x.options.preserveSymlinks)try{return await j(M,W,x)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(q.dangling)return}return $.isDirectory()?F(M,W,$.mode&S,x):z(M,W,$.mode&S)}async function F(M,W,x,$){await e.Promises.mkdir(W,{recursive:!0,mode:x});const q=await m(M);for(const N of q)await U((0,y.join)(M,N),(0,y.join)(W,N),$)}async function z(M,W,x){await e.Promises.copyFile(M,W),await e.Promises.chmod(W,x)}async function j(M,W,x){let $=await e.Promises.readlink(M);(0,k.isEqualOrParent)($,x.root.source,!b.isLinux)&&($=(0,y.join)(x.root.target,$.substr(x.root.source.length+1))),await e.Promises.symlink($,W)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return(0,R.promisify)(D.read)}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return(0,R.promisify)(D.write)}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return t}get writeFile(){return c}get rm(){return u}get move(){return A}get copy(){return O}}}),define(Z[99],ee([0,1,51,8,24,19]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(i){const C=(0,L.dirname)(i);if(i===C)return i;const f=((0,L.basename)(i)||i).toLowerCase();try{const u=(0,T.readdirSync)(C).filter(E=>E.toLowerCase()===f);if(u.length===1){const E=k(C);if(E)return(0,L.join)(E,u[0])}else if(u.length>1){const E=u.indexOf(f);if(E>=0){const g=k(C);if(g)return(0,L.join)(g,u[E])}}}catch(I){}return null}e.realcaseSync=k;async function P(i){try{return await T.Promises.realpath(i)}catch(C){const f=b(i);return await T.Promises.access(f,D.constants.R_OK),f}}e.realpath=P;function y(i){try{return D.realpathSync(i)}catch(C){const f=b(i);return D.accessSync(f,D.constants.R_OK),f}}e.realpathSync=y;function b(i){return(0,R.rtrim)((0,L.normalize)(i),L.sep)}}),define(Z[69],ee([0,1,35,8,19]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,k=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var y;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(y||(y={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class C{constructor(a,t,s){this.exePath=a,this.displayName=t,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:o=!1}={}){return o?b===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function I({useAlternateBitness:o=!1,findPreview:a=!1}={}){const t=f({useAlternateBitness:o});if(!t)return null;const s=L.join(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(s))return null;let n=-1,r=null;for(const h of await R.Promises.readdir(s)){let d=-1;if(a){const A=h.indexOf("-");if(A<0)continue;const O=h.substring(0,A);if(!T.test(O)||h.substring(A+1)!=="preview")continue;d=parseInt(O,10)}else{if(!T.test(h))continue;d=parseInt(h,10)}if(d<=n)continue;const p=L.join(s,h,"pwsh.exe");!await R.SymlinkSupport.existsFile(p)||(r=p,n=d)}if(!r)return null;const c=t.includes("x86")?" (x86)":"",l=a?" Preview":"";return new C(r,`PowerShell${l}${c}`,!0)}async function u({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const a=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=o?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const n of await R.Promises.readdir(a))if(t.test(n)){const r=L.join(a,n,"pwsh.exe");return new C(r,s)}return null}function E(){const o=L.join(D.homedir(),".dotnet","tools","pwsh.exe");return new C(o,".NET Core PowerShell Global Tool")}function g(){const o=L.join(process.env.windir,b===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(o,"Windows PowerShell",!0)}async function*w(){let o=await I();o&&(yield o),o=await I({useAlternateBitness:!0}),o&&(yield o),o=await u(),o&&(yield o),o=E(),o&&(yield o),o=await I({findPreview:!0}),o&&(yield o),o=await u({findPreview:!0}),o&&(yield o),o=await I({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=g(),o&&(yield o)}async function*m(){for await(const o of w())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=m;async function v(){for await(const o of m())return o;return null}e.getFirstAvailablePowerShellInstallation=v}),define(Z[100],ee([0,1,41,17]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(k){return new Promise((P,y)=>{let b;const i=new Map;function C(I,u,E,g,w){const m=i.get(u);if(I===k||m){const v={name:f(E),cmd:E,pid:I,ppid:u,load:g,mem:w};i.set(I,v),I===k&&(b=v),m&&(m.children||(m.children=[]),m.children.push(v),m.children.length>1&&(m.children=m.children.sort((o,a)=>o.pid-a.pid)))}}function f(I){const u=/--disable-blink-features=Auxclick/,E=/\\watcher\\win32\\CodeHelper\.exe/,g=/--crashes-directory/,w=/\\pipe\\winpty-control/,m=/conhost\.exe/,v=/--type=([a-zA-Z-]+)/;if(E.exec(I))return"watcherService ";if(g.exec(I))return"electron-crash-reporter";if(w.exec(I))return"winpty-process";if(m.exec(I))return"console-window-host (Windows internal process)";let o=v.exec(I);if(o&&o.length===2)return o[1]==="renderer"?u.exec(I)?"shared-process":"window":o[1];const a=/[a-zA-Z-]+\.js/g;let t="";do o=a.exec(I),o&&(t+=o+" ");while(o);return t&&I.indexOf("node ")<0&&I.indexOf("node.exe")<0?`electron_node ${t}`:I}if(process.platform==="win32"){const I=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,E)=>{K(["windows-process-tree"],u,E)}).then(u=>{u.getProcessList(k,E=>{u.getProcessCpuUsage(E,g=>{const w=new Map;g.forEach(m=>{const v=I(m.commandLine||"");w.set(m.pid,{name:f(v),cmd:v,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),b=w.get(k),b?(w.forEach(m=>{const v=w.get(m.ppid);v&&(v.children||(v.children=[]),v.children.push(m))}),w.forEach(m=>{m.children&&(m.children=m.children.sort((v,o)=>v.pid-o.pid))}),P(b)):y(new Error(`Root process ${k} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let I=function(){let u=[b];const E=[];for(;u.length;){const w=u.shift();w&&(E.push(w.pid),w.children&&(u=u.concat(w.children)))}let g=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);g+=" "+E.join(" "),(0,D.exec)(g,{},(w,m,v)=>{if(w||v)y(w||new Error(v.toString()));else{const o=m.toString().split(`
`);for(let a=0;a<E.length;a++){const t=i.get(E[a]);t.load=parseFloat(o[a])}if(!b){y(new Error(`Root process ${k} not found`));return}P(b)}})};(0,D.exec)("which ps",{},(u,E,g)=>{if(u||g)if(process.platform!=="linux")y(u||new Error(g.toString()));else{const w=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,D.exec)(w,{},(m,v,o)=>{m||o?y(m||new Error(o.toString())):(T(v,C),I())})}else{const w=E.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${w} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,o,a)=>{v||a&&!a.includes("screen size is bogus")?y(v||new Error(a.toString())):(T(o,C),process.platform==="linux"?I():b?P(b):y(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=R;function T(k,P){const y=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=k.toString().split(`
`);for(const i of b){const C=y.exec(i.trim());C&&C.length===6&&P(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(Z[101],ee([0,1,51,27,39,2,66,8,4,19]),function(K,e,D,L,R,T,k,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function i(u,E,g){return f({path:u,isDirectory:!1},E,g)}e.watchFile=i;function C(u,E,g){return f({path:u,isDirectory:!0},E,g)}e.watchFolder=C,e.CHANGE_BUFFER_DELAY=100;function f(u,E,g){if(y.isMacintosh&&(0,R.isEqualOrParent)(u.path,"/Volumes/"))return g(`Refusing to watch ${u.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const w=(0,P.basename)(u.path),m=new Map;let v=!1,o=[(0,T.toDisposable)(()=>{m.forEach(a=>(0,T.dispose)(a)),m.clear()})];try{const a=(0,D.watch)(u.path);o.push((0,T.toDisposable)(()=>{a.removeAllListeners(),a.close()}));const t=new Set;u.isDirectory&&b.Promises.readdir(u.path).then(s=>s.forEach(n=>t.add(n))),a.on("error",(s,n)=>{v||g(`Failed to watch ${u.path} for changes using fs.watch() (${s}, ${n})`)}),a.on("change",(s,n)=>{if(v)return;let r="";if(n&&(r=n.toString(),y.isMacintosh&&(r=(0,k.normalizeNFC)(r))),!r||s!=="change"&&s!=="rename")return;const c=u.isDirectory?(0,P.join)(u.path,r):u.path;if(u.isDirectory)if(s==="rename"){const l=m.get(c);l&&(0,T.dispose)(l);const h=setTimeout(async()=>{m.delete(c);const d=await b.Promises.exists(c);if(v)return;let p;d?t.has(r)?p="changed":(p="added",t.add(r)):(t.delete(r),p="deleted"),E(p,c)},e.CHANGE_BUFFER_DELAY);m.set(c,(0,T.toDisposable)(()=>clearTimeout(h)))}else{let l;t.has(r)?l="changed":(l="added",t.add(r)),E(l,c)}else if(s==="rename"||r!==w){const l=setTimeout(async()=>{const h=await b.Promises.exists(c);v||(h?(E("changed",c),o=[f(u,E,g)]):E("deleted",c))},e.CHANGE_BUFFER_DELAY);(0,T.dispose)(o),o=[(0,T.toDisposable)(()=>clearTimeout(l))]}else E("changed",c)})}catch(a){b.Promises.exists(u.path).then(t=>{t&&!v&&g(`Failed to watch ${u.path} for changes using fs.watch() (${a.toString()})`)})}return(0,T.toDisposable)(()=>{v=!0,o=(0,T.dispose)(o)})}async function I(u,E,g,w=512){const m=await b.Promises.open(u,"r"),v=Buffer.allocUnsafe(w),o=new L.CancellationTokenSource(g);let a,t=!1;const s=i(u,async n=>{if(n==="changed"){if(t)return;t=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:r}=await b.Promises.read(m,v,0,w,null);if(!r||o.token.isCancellationRequested)break;E(v.slice(0,r))}}catch(r){a=new Error(r),o.dispose(!0)}finally{t=!1}}},n=>{a=new Error(n),o.dispose(!0)});return new Promise((n,r)=>{o.token.onCancellationRequested(async()=>{s.dispose(),await b.Promises.close(m),a?r(a):n()})})}e.watchFileContents=I});var de=this&&this.__decorate||function(K,e,D,L){var R=arguments.length,T=R<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,D):L,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(K,e,D,L);else for(var P=K.length-1;P>=0;P--)(k=K[P])&&(T=(R<3?k(T):R>3?k(e,D,T):k(e,D))||T);return R>3&&T&&Object.defineProperty(e,D,T),T};define(Z[36],ee([0,1,18,6,25,27,64,9,3,2,94,24,16]),function(K,e,D,L,R,T,k,P,y,b,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var I;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(I=e.RequestType||(e.RequestType={}));function u(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(E=e.ResponseType||(e.ResponseType={}));function g(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(w||(w={}));class m{constructor(N){this.buffer=N,this.pos=0}read(N){const V=this.buffer.slice(this.pos,this.pos+N);return this.pos+=V.byteLength,V}}class v{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var o;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(o||(o={}));function a(q){const N=R.VSBuffer.alloc(4);return N.writeUInt32BE(q,0),N}function t(q){return q.read(4).readUInt32BE(0)}function s(q){const N=R.VSBuffer.alloc(1);return N.writeUInt8(q,0),N}const n={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object)},r=typeof Buffer!="undefined";function c(q,N){if(typeof N=="undefined")q.write(n.Undefined);else if(typeof N=="string"){const V=R.VSBuffer.fromString(N);q.write(n.String),q.write(a(V.byteLength)),q.write(V)}else if(r&&Buffer.isBuffer(N)){const V=R.VSBuffer.wrap(N);q.write(n.Buffer),q.write(a(V.byteLength)),q.write(V)}else if(N instanceof R.VSBuffer)q.write(n.VSBuffer),q.write(a(N.byteLength)),q.write(N);else if(Array.isArray(N)){q.write(n.Array),q.write(a(N.length));for(const V of N)c(q,V)}else{const V=R.VSBuffer.fromString(JSON.stringify(N));q.write(n.Object),q.write(a(V.byteLength)),q.write(V)}}function l(q){switch(q.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return q.read(t(q)).toString();case o.Buffer:return q.read(t(q)).buffer;case o.VSBuffer:return q.read(t(q));case o.Array:{const V=t(q),_=[];for(let Y=0;Y<V;Y++)_.push(l(q));return _}case o.Object:return JSON.parse(q.read(t(q)).toString())}}class h{constructor(N,V,_=null,Y=1e3){this.protocol=N,this.ctx=V,this.logger=_,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(G=>this.onRawMessage(G)),this.sendResponse({type:200})}registerChannel(N,V){this.channels.set(N,V),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const V=this.send([N.type]);this.logger&&this.logger.logOutgoing(V,0,1,g(N.type));return}case 201:case 202:case 204:case 203:{const V=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(V,N.id,1,g(N.type),N.data);return}}}send(N,V=void 0){const _=new v;return c(_,N),c(_,V),this.sendBuffer(_.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(V){return 0}}onRawMessage(N){const V=new m(N),_=l(V),Y=l(V),G=_[0];switch(G){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${u(G)}: ${_[2]}.${_[3]}`,Y),this.onPromise({type:G,id:_[1],channelName:_[2],name:_[3],arg:Y});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${u(G)}: ${_[2]}.${_[3]}`,Y),this.onEventListen({type:G,id:_[1],channelName:_[2],name:_[3],arg:Y});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${u(G)}`),this.disposeActiveRequest({type:G,id:_[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${u(G)}`),this.disposeActiveRequest({type:G,id:_[1]})}}onPromise(N){const V=this.channels.get(N.channelName);if(!V){this.collectPendingRequest(N);return}const _=new T.CancellationTokenSource;let Y;try{Y=V.call(this.ctx,N.name,N.arg,_.token)}catch(ne){Y=Promise.reject(ne)}const G=N.id;Y.then(ne=>{this.sendResponse({id:G,data:ne,type:201}),this.activeRequests.delete(N.id)},ne=>{ne instanceof Error?this.sendResponse({id:G,data:{message:ne.message,name:ne.name,stack:ne.stack?ne.stack.split?ne.stack.split(`
`):ne.stack:void 0},type:202}):this.sendResponse({id:G,data:ne,type:203}),this.activeRequests.delete(N.id)});const te=(0,b.toDisposable)(()=>_.cancel());this.activeRequests.set(N.id,te)}onEventListen(N){const V=this.channels.get(N.channelName);if(!V){this.collectPendingRequest(N);return}const _=N.id,G=V.listen(this.ctx,N.name,N.arg)(te=>this.sendResponse({id:_,data:te,type:204}));this.activeRequests.set(N.id,G)}disposeActiveRequest(N){const V=this.activeRequests.get(N.id);V&&(V.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let V=this.pendingRequests.get(N.channelName);V||(V=[],this.pendingRequests.set(N.channelName,V));const _=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);V.push({request:N,timeoutTimer:_})}flushPendingRequests(N){const V=this.pendingRequests.get(N);if(V){for(const _ of V)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.onPromise(_.request);break;case 102:this.onEventListen(_.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var d;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class p{constructor(N,V=null){this.protocol=N,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(_=>this.onBuffer(_)),this.logger=V}getChannel(N){const V=this;return{call(_,Y,G){return V.isDisposed?Promise.reject(P.canceled()):V.requestPromise(N,_,Y,G)},listen(_,Y){return V.isDisposed?Promise.reject(P.canceled()):V.requestEvent(N,_,Y)}}}requestPromise(N,V,_,Y=T.CancellationToken.None){const G=this.lastRequestId++,ne={id:G,type:100,channelName:N,name:V,arg:_};if(Y.isCancellationRequested)return Promise.reject(P.canceled());let J;return new Promise((re,ie)=>{if(Y.isCancellationRequested)return ie(P.canceled());const ce=()=>{const Ie=Pe=>{switch(Pe.type){case 201:this.handlers.delete(G),re(Pe.data);break;case 202:this.handlers.delete(G);const Ee=new Error(Pe.data.message);Ee.stack=Pe.data.stack,Ee.name=Pe.data.name,ie(Ee);break;case 203:this.handlers.delete(G),ie(Pe.data);break}};this.handlers.set(G,Ie),this.sendRequest(ne)};let ue=null;this.state===w.Idle?ce():(ue=(0,L.createCancelablePromise)(Ie=>this.whenInitialized()),ue.then(()=>{ue=null,ce()}));const ye=()=>{ue?(ue.cancel(),ue=null):this.sendRequest({id:G,type:101}),ie(P.canceled())},ge=Y.onCancellationRequested(ye);J=(0,b.combinedDisposable)((0,b.toDisposable)(ye),ge),this.activeRequests.add(J)}).finally(()=>{this.activeRequests.delete(J)})}requestEvent(N,V,_){const Y=this.lastRequestId++,te={id:Y,type:102,channelName:N,name:V,arg:_};let ne=null;const J=new y.Emitter({onFirstListenerAdd:()=>{ne=(0,L.createCancelablePromise)(re=>this.whenInitialized()),ne.then(()=>{ne=null,this.activeRequests.add(J),this.sendRequest(te)})},onLastListenerRemove:()=>{ne?(ne.cancel(),ne=null):(this.activeRequests.delete(J),this.sendRequest({id:Y,type:103}))}}),H=re=>J.fire(re.data);return this.handlers.set(Y,H),J.event}sendRequest(N){switch(N.type){case 100:case 102:{const V=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(V,N.id,0,`${u(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const V=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(V,N.id,0,u(N.type));return}}}send(N,V=void 0){const _=new v;return c(_,N),c(_,V),this.sendBuffer(_.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(V){return 0}}onBuffer(N){const V=new m(N),_=l(V),Y=l(V),G=_[0];switch(G){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,g(G)),this.onResponse({type:_[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],0,g(G),Y),this.onResponse({type:_[0],id:_[1],data:Y})}}onResponse(N){if(N.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const V=this.handlers.get(N.id);V&&V(N)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}de([k.memoize],p.prototype,"onDidInitializePromise",null),e.ChannelClient=p;class A{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:V,onDidClientDisconnect:_})=>{y.Event.once(V.onMessage)(G=>{const te=new m(G),ne=l(te),J=new h(V,ne),H=new p(V);this.channels.forEach((ie,ce)=>J.registerChannel(ce,ie));const re={channelServer:J,channelClient:H,ctx:ne};this._connections.add(re),this._onDidAddConnection.fire(re),_(()=>{J.dispose(),H.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)})})})}get connections(){const N=[];return this._connections.forEach(V=>N.push(V)),N}getChannel(N,V){const _=this;return{call(Y,G,te){let ne;if((0,f.isFunction)(V)){let H=(0,D.getRandomElement)(_.connections.filter(V));ne=H?Promise.resolve(H):y.Event.toPromise(y.Event.filter(_.onDidAddConnection,V))}else ne=V.routeCall(_,Y,G);const J=ne.then(H=>H.channelClient.getChannel(N));return S(J).call(Y,G,te)},listen(Y,G){if((0,f.isFunction)(V))return _.getMulticastEvent(N,V,Y,G);const te=V.routeEvent(_,Y,G).then(ne=>ne.channelClient.getChannel(N));return S(te).listen(Y,G)}}}getMulticastEvent(N,V,_,Y){const G=this;let te=new b.DisposableStore;const ne=new y.Emitter({onFirstListenerAdd:()=>{te=new b.DisposableStore;const J=new y.EventMultiplexer,H=new Map,re=ce=>{const ye=ce.channelClient.getChannel(N).listen(_,Y),ge=J.add(ye);H.set(ce,ge)},ie=ce=>{const ue=H.get(ce);!ue||(ue.dispose(),H.delete(ce))};G.connections.filter(V).forEach(re),y.Event.filter(G.onDidAddConnection,V)(re,void 0,te),G.onDidRemoveConnection(ie,void 0,te),J.event(ne.fire,ne,te),te.add(J)},onLastListenerRemove:()=>{te.dispose()}});return ne.event}registerChannel(N,V){this.channels.set(N,V),this._connections.forEach(_=>{_.channelServer.registerChannel(N,V)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class O{constructor(N,V,_=null){const Y=new v;c(Y,V),N.send(Y.buffer),this.channelClient=new p(N,_),this.channelServer=new h(N,V,_)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,V){this.channelServer.registerChannel(N,V)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function S(q){return{call(N,V,_){return q.then(Y=>Y.call(N,V,_))},listen(N,V){const _=new y.Relay;return q.then(Y=>_.input=Y.listen(N,V)),_.event}}}e.getDelayedChannel=S;function U(q){let N=!1;return{call(V,_,Y){return N?q.call(V,_,Y):(0,L.timeout)(0).then(()=>N=!0).then(()=>q.call(V,_,Y))},listen(V,_){if(N)return q.listen(V,_);const Y=new y.Relay;return(0,L.timeout)(0).then(()=>N=!0).then(()=>Y.input=q.listen(V,_)),Y.event}}}e.getNextTickChannel=U;class F{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const V of N.connections)if(await Promise.resolve(this.fn(V.ctx)))return Promise.resolve(V);return await y.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=F;var z;(function(q){function N(Y,G){const te=Y,ne=G&&G.disableMarshalling,J=new Map;for(const H in te)_(H)&&J.set(H,y.Event.buffer(te[H],!0));return new class{listen(H,re){const ie=J.get(re);if(ie)return ie;throw new Error(`Event not found: ${re}`)}call(H,re,ie){const ce=te[re];if(typeof ce=="function"){if(!ne&&Array.isArray(ie))for(let ue=0;ue<ie.length;ue++)ie[ue]=(0,i.revive)(ie[ue]);return ce.apply(te,ie)}throw new Error(`Method not found: ${re}`)}}}q.fromService=N;function V(Y,G){const te=G&&G.disableMarshalling;return new Proxy({},{get(ne,J){if(typeof J=="string")return G?.properties?.has(J)?G.properties.get(J):_(J)?Y.listen(J):async function(...H){let re;G&&!(0,f.isUndefinedOrNull)(G.context)?re=[G.context,...H]:re=H;const ie=await Y.call(J,re);return te?ie:(0,i.revive)(ie)};throw new Error(`Property not found: ${String(J)}`)}})}q.toService=V;function _(Y){return Y[0]==="o"&&Y[1]==="n"&&C.isUpperAsciiLetter(Y.charCodeAt(2))}})(z=e.ProxyChannel||(e.ProxyChannel={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let N=q.toString();if(N!=="[object Object]")return N}return q}function W(q){return Array.isArray(q)?q.map(M):M(q)}function x(q,N,V,_,Y,G,te){te=W(te);const ne=j[Y],J=ne[_%ne.length];let H=[`%c[${q}]%c[${String(N).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${J}`];/\($/.test(G)?(H=H.concat(te),H.push(")")):H.push(te),console.log.apply(console,H)}e.logWithColors=x;class ${constructor(N,V){this._outgoingPrefix=N,this._incomingPrefix=V,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,V,_,Y,G){this._totalOutgoing+=N,x(this._outgoingPrefix,this._totalOutgoing,N,V,_,Y,G)}logIncoming(N,V,_,Y,G){this._totalIncoming+=N,x(this._incomingPrefix,this._totalIncoming,N,V,_,Y,G)}}e.IPCLogger=$}),define(Z[102],ee([0,1,25,3,36]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(y){this.port=y,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",b=>D.VSBuffer.wrap(b.data)),y.start()}send(y){this.port.postMessage(y.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class k extends R.IPCClient{constructor(y,b){const i=new T(y);super(i,b);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=k}),define(Z[103],ee([0,1,104,3,36,102]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class k extends R.IPCServer{static getOnDidClientConnect(){const y=L.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(b,i)=>i);return L.Event.map(y,b=>{const{port1:i,port2:C}=new MessageChannel,I={protocol:new T.Protocol(i),onDidClientDisconnect:L.Event.fromDOMEventEmitter(i,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[C]),I})}constructor(){super(k.getOnDidClientConnect())}}e.Server=k}),define(Z[105],ee([0,1,25,9]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function R(P,y){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((i,C)=>{b.open(P.type||"GET",P.url||"",!0,P.user,P.password),T(b,P),b.responseType="arraybuffer",b.onerror=f=>C(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=f=>{i({res:{statusCode:b.status,headers:k(b)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=f=>C(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(b.timeout=P.timeout),b.send(P.data),y.onCancellationRequested(()=>{b.abort(),C((0,L.canceled)())})})}e.request=R;function T(P,y){if(y.headers){e:for(let b in y.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(b,y.headers[b])}}}function k(P){const y=Object.create(null);for(const b of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const i=b.indexOf(":");y[b.substr(0,i).trim().toLowerCase()]=b.substr(i+1).trim()}return y}}),define(Z[70],ee([0,1,6,3,2,16]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function P(C){const f=C;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var y;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(y||(y={}));class b extends R.Disposable{constructor(f,I=Object.create(null)){super();this.database=f,this.options=I,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=y.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((I,u)=>this.accept(u,I)),f.deleted?.forEach(I=>this.accept(I,void 0))}accept(f,I){if(this.state===y.Closed)return;let u=!1;(0,T.isUndefinedOrNull)(I)?u=this.cache.delete(f):this.cache.get(f)!==I&&(this.cache.set(f,I),u=!0),u&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===y.None&&(this.state=y.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,I){const u=this.cache.get(f);return(0,T.isUndefinedOrNull)(u)?I:u}getBoolean(f,I){const u=this.get(f);return(0,T.isUndefinedOrNull)(u)?I:u==="true"}getNumber(f,I){const u=this.get(f);return(0,T.isUndefinedOrNull)(u)?I:parseInt(u,10)}async set(f,I){if(this.state===y.Closed)return;if((0,T.isUndefinedOrNull)(I))return this.delete(f);const u=String(I);if(this.cache.get(f)!==u)return this.cache.set(f,u),this.pendingInserts.set(f,u),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}async delete(f){if(!(this.state===y.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=y.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(f){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((I,u)=>this.items.set(u,I)),f.delete&&f.delete.forEach(I=>this.items.delete(I))}async close(){}}e.InMemoryStorageDatabase=i}),define(Z[106],ee([10,11]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[56],ee([0,1,106]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,R=L*60,T=R*24,k=T*7,P=T*30,y=T*365;function b(C,f){typeof C!="number"&&(C=C.getTime());const I=Math.round((new Date().getTime()-C)/1e3);if(I<-30)return(0,D.localize)(0,null,b(new Date().getTime()+I*1e3,!1));if(I<30)return(0,D.localize)(1,null);let u;return I<L?(u=I,f?u===1?(0,D.localize)(2,null,u):(0,D.localize)(3,null,u):u===1?(0,D.localize)(4,null,u):(0,D.localize)(5,null,u)):I<R?(u=Math.floor(I/L),f?u===1?(0,D.localize)(6,null,u):(0,D.localize)(7,null,u):u===1?(0,D.localize)(8,null,u):(0,D.localize)(9,null,u)):I<T?(u=Math.floor(I/R),f?u===1?(0,D.localize)(10,null,u):(0,D.localize)(11,null,u):u===1?(0,D.localize)(12,null,u):(0,D.localize)(13,null,u)):I<k?(u=Math.floor(I/T),f?u===1?(0,D.localize)(14,null,u):(0,D.localize)(15,null,u):u===1?(0,D.localize)(16,null,u):(0,D.localize)(17,null,u)):I<P?(u=Math.floor(I/k),f?u===1?(0,D.localize)(18,null,u):(0,D.localize)(19,null,u):u===1?(0,D.localize)(20,null,u):(0,D.localize)(21,null,u)):I<y?(u=Math.floor(I/P),f?u===1?(0,D.localize)(22,null,u):(0,D.localize)(23,null,u):u===1?(0,D.localize)(24,null,u):(0,D.localize)(25,null,u)):(u=Math.floor(I/y),f?u===1?(0,D.localize)(26,null,u):(0,D.localize)(27,null,u):u===1?(0,D.localize)(28,null,u):(0,D.localize)(29,null,u))}e.fromNow=b;function i(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(Z[107],ee([10,11]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[37],ee([0,1,18,16,107]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(b,i){return i&&(b.stack||b.stacktrace)?R.localize(0,null,P(b),k(b.stack)||k(b.stacktrace)):P(b)}function k(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?R.localize(1,null,b.message):b.message||R.localize(2,null)}function y(b=null,i=!1){if(!b)return R.localize(3,null);if(Array.isArray(b)){const C=D.coalesce(b),f=y(C[0],i);return C.length>1?R.localize(4,null,f,C.length):f}if(L.isString(b))return b;if(b.detail){const C=b.detail;if(C.error)return T(C.error,i);if(C.exception)return T(C.exception,i)}return b.stack?T(b,i):b.message?b.message:R.localize(5,null)}e.toErrorMessage=y}),define(Z[108],ee([10,11]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[71],ee([0,1,41,39,17,26,8,4,31,16,68,19,108]),function(K,e,D,L,R,T,k,P,y,b,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function I(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(o,a){if(P.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};a&&(t.cwd=a);const s=D.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(n=>{s.once("error",r=>{n({success:!1,error:r})}),s.once("exit",(r,c)=>{n(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?I(t.status):1})}else if(P.isLinux||P.isMacintosh)try{const t=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(s=>{D.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(n,r,c)=>{s(n?{success:!1,error:n}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function E(o=y.env){return o.comspec||"cmd.exe"}e.getWindowsShell=E;class g{constructor(a,t,s,n){if(t!==void 0&&s!==void 0&&n!==void 0)this.cmd=a,this.args=t,this.shell=s,this.options=n;else{const r=a;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(y.env).forEach(c=>{r[c]=y.env[c]}),Object.keys(this.options.env).forEach(c=>{r[c]=this.options.env[c]}),this.options.env=r}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const t=a.lastIndexOf(k.sep);return t!==-1&&(a=a.substring(t+1)),g.WellKnowCommands[a]?a:"other"}start(a){return P.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(y.cwd()))?Promise.reject(new Error(f.localize(0,null))):this.useExec().then(t=>{let s,n;const r=new Promise((c,l)=>{s=c,n=l});if(t){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=D.exec(c,this.options,(l,h,d)=>{this.childProcess=null;const p=l;p&&p.killed?n({killed:this.terminateRequested,stdout:h.toString(),stderr:d.toString()}):this.handleExec(s,a,l,h,d)})}else{let c=null;const l=h=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(h,s,a,n);const d={terminated:this.terminateRequested};b.isNumber(h)&&(d.cmdCode=h),s(d)};if(this.shell&&P.isWindows){const h=T.deepClone(this.options);h.windowsVerbatimArguments=!0,h.detached=!1;let d=!1,p=!1;const A=[];let O=this.ensureQuotes(this.cmd);A.push(O.value),d=O.quoted,this.args&&this.args.forEach(U=>{O=this.ensureQuotes(U),A.push(O.value),p=p&&O.quoted});const S=["/s","/c"];d?p?S.push('"'+A.join(" ")+'"'):A.length>1?S.push('"'+A[0]+'" '+A.slice(1).join(" ")):S.push('"'+A[0]+'"'):S.push(A.join(" ")),c=D.spawn(E(),S,h)}else this.cmd&&(c=D.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(b.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",h=>{this.childProcess=null,n({terminated:this.terminateRequested,error:h})}),c.pid&&(this.childProcess.on("close",l),this.handleSpawn(c,s,a,n,!0)))}return r})}handleClose(a,t,s,n){}ensureQuotes(a){return g.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,u(a,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!P.isWindows)return a(!1);const t=D.spawn(E(),["/s","/c"]);t.on("error",s=>a(!0)),t.on("exit",s=>a(!1))})}}e.AbstractProcess=g,g.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},g.regexp=/^[^"].* .*[^"]/;class w extends g{constructor(a,t,s,n){super(a,t,s,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,t,s,n,r){[n,r].forEach((c,l)=>{const h=new i.LineDecoder;h.write(c).forEach(A=>{t({line:A,source:l===0?0:1})});const p=h.end();p&&t({line:p,source:l===0?0:1})}),a({terminated:this.terminateRequested,error:s})}handleSpawn(a,t,s,n,r){const c=new i.LineDecoder,l=new i.LineDecoder;a.stdout.on("data",h=>{c.write(h).forEach(p=>s({line:p,source:0}))}),a.stderr.on("data",h=>{l.write(h).forEach(p=>s({line:p,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=l}handleClose(a,t,s,n){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&s({line:r,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&s({line:c,source:1})}}e.LineProcess=w;function m(o){let a=[],t=!1;const s=function(n){if(t){a.push(n);return}(!o.send(n,c=>{if(c&&console.error(c),t=!1,a.length>0){const l=a.slice(0);a=[],l.forEach(h=>s(h))}})||P.isWindows)&&(t=!0)};return{send:s}}e.createQueuedSender=m;var v;(function(o){async function a(t,s,n){if(k.isAbsolute(t))return t;if(s===void 0&&(s=y.cwd()),k.dirname(t)!=="."||(n===void 0&&b.isString(y.env.PATH)&&(n=y.env.PATH.split(k.delimiter)),n===void 0||n.length===0))return k.join(s,t);async function c(l){if(await C.Promises.exists(l)){let h;try{h=await C.Promises.stat(l)}catch(d){d.message.startsWith("EACCES")&&(h=await C.Promises.lstat(l))}return h?!h.isDirectory():!1}return!1}for(let l of n){let h;if(k.isAbsolute(l)?h=k.join(l,t):h=k.join(s,l,t),await c(h))return h;let d=h+".com";if(await c(d)||(d=h+".exe",await c(d)))return d}return k.join(s,t)}o.findExecutable=a})(v=e.win32||(e.win32={}))}),define(Z[109],ee([0,1,35,4,69,71]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(I,u){return I===1?L.isWindows?C():T.getWindowsShell(u):b(I,u)}e.getSystemShell=k;function P(I,u){return I===1?L.isWindows?f(u):T.getWindowsShell(u):b(I,u)}e.getSystemShellSync=P;let y=null;function b(I,u){if(L.isLinux&&I===2||L.isMacintosh&&I===3)return"/bin/bash";if(!y){let E;if(L.isWindows)E="/bin/bash";else{if(E=u.SHELL,!E)try{E=(0,D.userInfo)().shell}catch(g){}E||(E="sh"),E==="/bin/false"&&(E="/bin/bash")}y=E}return y}let i=null;async function C(){return i||(i=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),i}function f(I){if(i)return i;const u=L.isWindows&&parseFloat((0,D.release)())>=10,E=I.hasOwnProperty("PROCESSOR_ARCHITEW6432"),g=`${I.windir}\\${E?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?g:T.getWindowsShell(I)}}),define(Z[52],ee([0,1,41,6,25,27,93,9,3,2,26,4,71,36]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends I.ChannelServer{constructor(w){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(v){}},onMessage:y.Event.fromNodeEventEmitter(process,"message",m=>R.VSBuffer.wrap(Buffer.from(m,"base64")))},w);process.once("disconnect",()=>this.dispose())}}e.Server=u;class E{constructor(w,m){this.modulePath=w,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new y.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new L.Delayer(v),this.child=null,this._client=null}getChannel(w){const m=this;return{call(v,o,a){return m.requestPromise(w,v,o,a)},listen(v,o){return m.requestEvent(w,v,o)}}}requestPromise(w,m,v,o=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(w),t=(0,L.createCancelablePromise)(r=>a.call(m,v,r)),s=o.onCancellationRequested(()=>t.cancel()),n=(0,b.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{s.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(w,m,v){if(!this.disposeDelayer)return y.Event.None;this.disposeDelayer.cancel();let o;const a=new y.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(w).listen(m,v)(a.fire,a),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const w=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),C.isMacintosh&&m.env&&delete m.env.DYLD_LIBRARY_PATH,this.child=(0,D.fork)(this.modulePath,w,m);const v=new y.Emitter;y.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if((0,k.isRemoteConsoleLog)(c)){(0,k.log)(c,`IPC Library: ${this.options.serverName}`);return}v.fire(R.VSBuffer.wrap(Buffer.from(c,"base64")))});const a=this.options.useQueue?(0,f.createQueuedSender)(this.child):this.child,t=c=>this.child&&this.child.connected&&a.send(c.buffer.toString("base64")),s=v.event,n={send:t,onMessage:s};this._client=new I.ChannelClient(n);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,l)=>{process.removeListener("exit",r),this.activeRequests.forEach(h=>(0,b.dispose)(h)),this.activeRequests.clear(),c!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:l})})}return this._client}getCachedChannel(w){let m=this.channels.get(w);return m||(m=this.client.getChannel(w),this.channels.set(w,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=E}),define(Z[110],ee([10,11]),function(K,e){return K.create("vs/base/node/zip",e)}),define(Z[111],ee([10,11]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[112],ee([10,11]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(Z[113],ee([10,11]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(Z[114],ee([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Z[115],ee([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[116],ee([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[117],ee([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[118],ee([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[119],ee([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[120],ee([10,11]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[121],ee([10,11]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[122],ee([10,11]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[123],ee([10,11]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[124],ee([10,11]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[125],ee([10,11]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[126],ee([10,11]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[127],ee([10,11]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Z[128],ee([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[129],ee([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[130],ee([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[131],ee([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[132],ee([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[133],ee([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Z[134],ee([0,1,56,64,17,8,31,15,5]),function(K,e,D,L,R,T,k,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(u,E,g){this._args=u,this.paths=E,this.productService=g}get appRoot(){return(0,T.dirname)(R.FileAccess.asFileUri("",K).fsPath)}get userHome(){return y.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return y.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return y.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const u=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",u)}return this.args.logsPath}get userDataSyncLogResource(){return y.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(y.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return y.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return y.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=k.env.VSCODE_PORTABLE;return u?y.URI.file((0,T.join)(u,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return y.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,T.resolve)(u):(0,T.normalize)((0,T.join)(R.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const u=this.args["extensions-download-dir"];return u?(0,T.resolve)(u):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,T.resolve)(u);const E=k.env.VSCODE_EXTENSIONS;if(E)return E;const g=k.env.VSCODE_PORTABLE;return g?(0,T.join)(g,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(E=>/^[^:/?#]+?:\/\//.test(E)?y.URI.parse(E):y.URI.file((0,T.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?y.URI.parse(u):y.URI.file((0,T.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(y.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return y.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([L.memoize],b.prototype,"appRoot",null),de([L.memoize],b.prototype,"userHome",null),de([L.memoize],b.prototype,"userDataPath",null),de([L.memoize],b.prototype,"appSettingsHome",null),de([L.memoize],b.prototype,"tmpDir",null),de([L.memoize],b.prototype,"userRoamingDataHome",null),de([L.memoize],b.prototype,"settingsResource",null),de([L.memoize],b.prototype,"userDataSyncHome",null),de([L.memoize],b.prototype,"userDataSyncLogResource",null),de([L.memoize],b.prototype,"sync",null),de([L.memoize],b.prototype,"machineSettingsResource",null),de([L.memoize],b.prototype,"globalStorageHome",null),de([L.memoize],b.prototype,"workspaceStorageHome",null),de([L.memoize],b.prototype,"keybindingsResource",null),de([L.memoize],b.prototype,"keyboardLayoutResource",null),de([L.memoize],b.prototype,"argvResource",null),de([L.memoize],b.prototype,"snippetsHome",null),de([L.memoize],b.prototype,"isExtensionDevelopment",null),de([L.memoize],b.prototype,"untitledWorkspacesHome",null),de([L.memoize],b.prototype,"installSourcePath",null),de([L.memoize],b.prototype,"builtinExtensionsPath",null),de([L.memoize],b.prototype,"extensionsPath",null),de([L.memoize],b.prototype,"extensionDevelopmentLocationURI",null),de([L.memoize],b.prototype,"extensionDevelopmentKind",null),de([L.memoize],b.prototype,"extensionTestsLocationURI",null),de([L.memoize],b.prototype,"debugExtensionHost",null),de([L.memoize],b.prototype,"serviceMachineIdResource",null),de([L.memoize],b.prototype,"telemetryLogResource",null),de([L.memoize],b.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=b;function i(I,u){return f(I["inspect-extensions"],I["inspect-brk-extensions"],5870,u,I.debugId)}e.parseExtensionHostPort=i;function C(I,u){return f(I["inspect-search"],I["inspect-brk-search"],5876,u)}e.parseSearchPort=C;function f(I,u,E,g,w){const v=Number(u||I)||(g?null:E),o=v?Boolean(!!u):!1;return{port:v,break:o,debugId:w}}}),define(Z[135],ee([0,1,220,4,112]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(u,E,g=k){const w={},m=[],v=[];for(let s in E){const n=E[s];n.alias&&(w[s]=n.alias),n.type==="string"||n.type==="string[]"?(m.push(s),n.deprecates&&m.push(n.deprecates)):n.type==="boolean"&&(v.push(s),n.deprecates&&v.push(n.deprecates))}const o=D(u,{string:m,boolean:v,alias:w}),a={},t=o;a._=o._.map(s=>String(s)).filter(s=>s.length>0),delete t._;for(let s in E){const n=E[s];n.alias&&delete t[n.alias];let r=t[s];n.deprecates&&t.hasOwnProperty(n.deprecates)&&(r||(r=t[n.deprecates]),delete t[n.deprecates]),typeof r!="undefined"&&(n.type==="string[]"?r&&!Array.isArray(r)&&(r=[r]):n.type==="string"&&Array.isArray(r)&&(r=r.pop(),g.onMultipleValues(s,r)),a[s]=r),delete t[s]}for(let s in t)g.onUnknownOption(s);return a}e.parseArgs=P;function y(u,E){let g="";return E.args&&(Array.isArray(E.args)?g=` <${E.args.join("> <")}>`:g=` <${E.args}>`),E.alias?`-${E.alias} --${u}${g}`:`--${u}${g}`}function b(u,E){let g=0,w=[];for(const a in u){const t=u[a],s=y(a,t);g=Math.max(g,s.length),w.push([s,t.description])}let m=g+2+1;if(E-m<25)return w.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let v=E-m-1,o=[];for(const a of w){let t=a[0],s=C(a[1],v),n=i(m-t.length-2);o.push("  "+t+n+s[0]);for(let r=1;r<s.length;r++)o.push(i(m)+s[r])}return o}e.formatOptions=b;function i(u){return" ".repeat(u)}function C(u,E){let g=[];for(;u.length;){let w=u.length<E?u.length:u.lastIndexOf(" ",E),m=u.slice(0,w).trim();u=u.slice(w),g.push(m)}return g}function f(u,E,g,w,m=!0){const v=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${u} ${g}`];o.push(""),o.push(`${(0,R.localize)(32,null)}: ${E} [${(0,R.localize)(33,null)}][${(0,R.localize)(34,null)}...]`),o.push(""),m&&(L.isWindows?o.push((0,R.localize)(35,null,E)):o.push((0,R.localize)(36,null,E)),o.push(""));const a={};for(const t in w){const s=w[t];if(s.description&&s.cat){let n=a[s.cat];n||(a[s.cat]=n={}),n[t]=s}}for(let t in a){const s=t;let n=a[s];n&&(o.push(T[s]),o.push(...b(n,v)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=f;function I(u,E){return`${u||(0,R.localize)(37,null)}
${E||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=I}),function(){"use strict";function K(e,D,L,R){function T(P){const y=k(P),b=[y];return e.isAbsolute(y)||b.unshift(R),e.resolve(...b)}function k(P){const y=process.env.VSCODE_PORTABLE;if(y)return e.join(y,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,L);const i=P["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(C,"AppData","Roaming")}break;case"darwin":b=e.join(D.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,L)}return{getUserDataPath:T}}if(typeof define=="function")define(Z[136],ee([0,137,35,17,15,31]),function(e,D,L,R,T,k){const P=T.dirname(R.FileAccess.asFileUri("",e)),y=e.__$__nodeRequire(T.joinPath(P,"package.json").fsPath);return K(D,L,y.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),L=require("os");module.exports=K(D,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[138],ee([0,1,35,134,136]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends L.AbstractNativeEnvironmentService{constructor(P,y){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P)},y)}}e.NativeEnvironmentService=T}),define(Z[139],ee([0,1,5]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,k=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,y=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(g){const w=g.match(k);return w?w[1]:null}function i(g){if(g.indexOf("://")===-1){const w=g.match(L);return w?b(w[2]):null}try{const w=D.URI.parse(g);if(w.authority)return b(w.authority)}catch(w){}return null}function C(g,w){const m=new Set;let v;for(;v=P.exec(g);){const a=i(v[1]);a&&m.add(a)}const o=new Set(w);return Array.from(m).map(a=>o.has(a)?a:a.replace(y,"a"))}e.getDomainsOfRemotes=C;function f(g){const w=g.match(T);return w?w[2]:null}function I(g,w,m){return g&&w?(m&&w.endsWith(".git")&&(w=w.substr(0,w.length-4)),w.indexOf("/")===0?`${g}${w}`:`${g}/${w}`):null}function u(g,w){if(g.indexOf("://")===-1){const m=g.match(R);if(m)return I(m[2],m[3],w)}try{const m=D.URI.parse(g);if(m.authority)return I(f(m.authority),m.path,w)}catch(m){}return null}function E(g,w=!1){const m=[];let v;for(;v=P.exec(g);){const o=u(v[1],w);o&&m.push(o)}return m}e.getRemotes=E}),define(Z[140],ee([0,1,26]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function R(T,k){const P=y=>{if(typeof y!="string")return;const b=L.exec(y);if(!b)return;const i=k[b[1]]??y;return typeof i=="string"?i:typeof i.message=="string"?i.message:y};return(0,D.cloneAndChange)(T,P)}e.localizeManifest=R}),define(Z[141],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,k,P,y){return this.channel.call("promptImportantExtensionsInstallNotification",[T,k,P,y])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class L{constructor(T){this.service=T}listen(T,k){throw new Error(`Event not found: ${k}`)}call(T,k,P){switch(k){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(Z[72],ee([0,1,120]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function T(f){return f=f.trim(),f==="*"||L.test(f)}e.isValidVersionStr=T;function k(f){if(!T(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let I=f.match(L);return I?{hasCaret:I[1]==="^",hasGreaterEquals:I[1]===">=",majorBase:I[2]==="x"?0:parseInt(I[2],10),majorMustEqual:I[2]!=="x",minorBase:I[4]==="x"?0:parseInt(I[4],10),minorMustEqual:I[4]!=="x",patchBase:I[6]==="x"?0:parseInt(I[6],10),patchMustEqual:I[6]!=="x",preRelease:I[8]||null}:null}e.parseVersion=k;function P(f){if(!f)return null;let I=f.majorBase,u=f.majorMustEqual,E=f.minorBase,g=f.minorMustEqual,w=f.patchBase,m=f.patchMustEqual;f.hasCaret&&(I===0||(g=!1),m=!1);let v=0;if(f.preRelease){const o=R.exec(f.preRelease);if(o){const[,a,t,s]=o;v=Date.UTC(Number(a),Number(t)-1,Number(s))}}return{majorBase:I,majorMustEqual:u,minorBase:E,minorMustEqual:g,patchBase:w,patchMustEqual:m,isMinimum:f.hasGreaterEquals,notBefore:v}}e.normalizeVersion=P;function y(f,I,u){let E;typeof f=="string"?E=P(k(f)):E=f;let g;I instanceof Date?g=I.getTime():typeof I=="string"&&(g=new Date(I).getTime());let w;if(typeof u=="string"?w=P(k(u)):w=u,!E||!w)return!1;let m=E.majorBase,v=E.minorBase,o=E.patchBase,a=w.majorBase,t=w.minorBase,s=w.patchBase,n=w.notBefore,r=w.majorMustEqual,c=w.minorMustEqual,l=w.patchMustEqual;return w.isMinimum?m>a?!0:m<a?!1:v>t?!0:v<t||g&&g<n?!1:o>=s:(m===1&&a===0&&(!r||!c||!l)&&(a=1,t=0,s=0,r=!0,c=!1,l=!1),m<a?!1:m>a?!r:v<t?!1:v>t?!c:o<s?!1:o>s?!l:!(g&&g<n))}e.isValidVersion=y;function b(f,I,u,E){return u.isBuiltin||typeof u.main=="undefined"?!0:C(f,I,u.engines.vscode,E)}e.isValidExtensionVersion=b;function i(f,I,u){return f==="*"||C(I,u,f)}e.isEngineValid=i;function C(f,I,u,E=[]){let g=P(k(u));if(!g)return E.push(D.localize(0,null,u)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return E.push(D.localize(1,null,u)),!1}else if(!g.majorMustEqual)return E.push(D.localize(2,null,u)),!1;return y(f,I,g)?!0:(E.push(D.localize(3,null,f,u)),!1)}}),define(Z[142],ee([0,1,2,17,36,52]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends D.Disposable{constructor(y,b,i,C){super();this.folders=y,this.onDidFilesChange=b,this.onLogMessage=i,this.verboseLogging=C,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const y=this._register(new T.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(y.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(y.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b))),this.setFolders(this.folders)}setVerboseLogging(y){this.verboseLogging=y,!this.isDisposed&&this.service&&this.service.setVerboseLogging(y)}error(y){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${y}`})}setFolders(y){this.folders=y,this.service&&this.service.setRoots(y)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(Z[143],ee([0,1,2,17,36,52]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends D.Disposable{constructor(y,b,i,C,f={}){super();this.folders=y,this.onDidFilesChange=b,this.onLogMessage=i,this.verboseLogging=C,this.watcherOptions=f,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const y=this._register(new T.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(y.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(y.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b))),this.service.setRoots(this.folders)}error(y){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${y}`})}setVerboseLogging(y){this.verboseLogging=y,this.service&&this.service.setVerboseLogging(y)}setFolders(y){this.folders=y,this.service&&this.service.setRoots(y)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(Z[144],ee([0,1,41,67,17,68]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class k{constructor(y,b,i,C,f){this.watchedFolder=y,this.eventCallback=i,this.logCallback=C,this.verboseLogging=f,this.restartCounter=0,Array.isArray(b)?this.ignored=b.map(I=>(0,L.parse)(I)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${y}, excludes: ${b.join(",")}`),this.startWatcher()}startWatcher(){const y=[this.watchedFolder];this.verboseLogging&&y.push("-verbose"),this.handle=(0,D.spawn)(R.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,y);const b=new T.LineDecoder;this.handle.stdout.on("data",i=>{const C=[];for(const f of b.write(i)){const I=f.split("|");if(I.length===2){const u=Number(I[0]),E=I[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(g=>g(E))){this.verboseLogging&&this.log(E);continue}C.push({type:k.changeTypeMap[u],path:E})}else this.log(I[1])}}C.length>0&&this.eventCallback(C)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,C)=>this.onExit(i,C))}onError(y){this.error("process error: "+y.toString())}onExit(y,b){this.handle&&(this.error(`terminated unexpectedly (code: ${y}, signal: ${b})`),this.restartCounter<=k.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(y){this.logCallback({type:"error",message:`[File Watcher (C#)] ${y}`})}log(y){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${y}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=k,k.MAX_RESTARTS=5,k.changeTypeMap=[0,1,2]}),define(Z[145],ee([0,1,8,24,144]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class T{constructor(P,y,b,i){this.onDidFilesChange=y,this.onLogMessage=b,this.verboseLogging=i,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(D.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,D.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new R.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=T}),define(Z[53],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,T=[],k=!1){this.ctor=R,this.staticArguments=T,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=D}),define(Z[146],ee([0,1,53]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function R(k,P,y){P instanceof D.SyncDescriptor||(P=new D.SyncDescriptor(P,[],y)),L.push([k,P])}e.registerSingleton=R;function T(){return L}e.getSingletonServiceDescriptors=T}),define(Z[147],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=D;class L{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let k of this._nodes.values())k.outgoing.size===0&&T.push(k);return T}insertEdge(T,k){const P=this.lookupOrInsertNode(T),y=this.lookupOrInsertNode(k);P.outgoing.set(this._hashFn(k),y),y.incoming.set(this._hashFn(T),P)}removeNode(T){const k=this._hashFn(T);this._nodes.delete(k);for(let P of this._nodes.values())P.outgoing.delete(k),P.incoming.delete(k)}lookupOrInsertNode(T){const k=this._hashFn(T);let P=this._nodes.get(k);return P||(P=new D(T),this._nodes.set(k,P)),P}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[k,P]of this._nodes)T.push(`${k}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,k]of this._nodes){const P=new Set([T]),y=this._findCycle(k,P);if(y)return y}}_findCycle(T,k){for(let[P,y]of T.outgoing){if(k.has(P))return[...k,P].join(" -> ");k.add(P);const b=this._findCycle(y,k);if(b)return b;k.delete(P)}}}e.Graph=L}),define(Z[7],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function y(b){return b[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=y})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function L(P,y,b,i){y[D.DI_TARGET]===y?y[D.DI_DEPENDENCIES].push({id:P,index:b,optional:i}):(y[D.DI_DEPENDENCIES]=[{id:P,index:b,optional:i}],y[D.DI_TARGET]=y)}function R(P){if(D.serviceIds.has(P))return D.serviceIds.get(P);const y=function(b,i,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(y,b,C,!1)};return y.toString=()=>P,D.serviceIds.set(P,y),y}e.createDecorator=R;function T(P){return P}e.refineServiceDecorator=T;function k(P){return function(y,b,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(P,y,i,!0)}}e.optional=k}),define(Z[148],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(Z[149],ee([0,1,4,24,7]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=D.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",D.isMacintosh),k.set("isLinux",D.isLinux),k.set("isWindows",D.isWindows),k.set("isWeb",D.isWeb),k.set("isMacNative",D.isMacintosh&&!D.isWeb),k.set("isEdge",T.indexOf("Edg/")>=0),k.set("isFirefox",T.indexOf("Firefox")>=0),k.set("isChrome",T.indexOf("Chrome")>=0),k.set("isSafari",T.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var y;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return C.INSTANCE}static true(){return f.INSTANCE}static has(S){return I.create(S)}static equals(S,U){return u.create(S,U)}static notEquals(S,U){return w.create(S,U)}static regex(S,U){return s.create(S,U)}static in(S,U){return E.create(S,U)}static not(S){return m.create(S)}static and(...S){return r.create(S,null)}static or(...S){return c.create(S,null,!0)}static greater(S,U){return v.create(S,U)}static less(S,U){return a.create(S,U)}static deserialize(S,U=!1){if(!!S)return this._deserializeOrExpression(S,U)}static _deserializeOrExpression(S,U){let F=S.split("||");return c.create(F.map(z=>this._deserializeAndExpression(z,U)),null,!0)}static _deserializeAndExpression(S,U){let F=S.split("&&");return r.create(F.map(z=>this._deserializeOne(z,U)),null)}static _deserializeOne(S,U){if(S=S.trim(),S.indexOf("!=")>=0){let F=S.split("!=");return w.create(F[0].trim(),this._deserializeValue(F[1],U))}if(S.indexOf("==")>=0){let F=S.split("==");return u.create(F[0].trim(),this._deserializeValue(F[1],U))}if(S.indexOf("=~")>=0){let F=S.split("=~");return s.create(F[0].trim(),this._deserializeRegexValue(F[1],U))}if(S.indexOf(" in ")>=0){let F=S.split(" in ");return E.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(S)){const F=S.split(">=");return o.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(S)){const F=S.split(">");return v.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(S)){const F=S.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(S)){const F=S.split("<");return a.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(S)?m.create(S.substr(1).trim()):I.create(S)}static _deserializeValue(S,U){if(S=S.trim(),S==="true")return!0;if(S==="false")return!1;let F=/^'([^']*)'$/.exec(S);return F?F[1].trim():S}static _deserializeRegexValue(S,U){if((0,L.isFalsyOrWhitespace)(S)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=S.indexOf("/"),z=S.lastIndexOf("/");if(F===z||F<0){if(U)throw new Error(`bad regexp-value '${S}', missing /-enclosure`);return console.warn(`bad regexp-value '${S}', missing /-enclosure`),null}let j=S.slice(F+1,z),M=S[z+1]==="i"?"i":"";try{return new RegExp(j,M)}catch(W){if(U)throw new Error(`bad regexp-value '${S}', parse error: ${W}`);return console.warn(`bad regexp-value '${S}', parse error: ${W}`),null}}}e.ContextKeyExpr=b;function i(O,S){return O.cmp(S)}class C{constructor(){this.type=0}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}evaluate(S){return!1}serialize(){return"false"}keys(){return[]}map(S){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class f{constructor(){this.type=1}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}evaluate(S){return!0}serialize(){return"true"}keys(){return[]}map(S){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class I{constructor(S,U){this.key=S,this.negated=U,this.type=2}static create(S,U=null){const F=k.get(S);return typeof F=="boolean"?F?f.INSTANCE:C.INSTANCE:new I(S,U)}cmp(S){return S.type!==this.type?this.type-S.type:h(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}evaluate(S){return!!S.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(S){return S.mapDefined(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=I;class u{constructor(S,U,F){this.key=S,this.value=U,this.negated=F,this.type=4}static create(S,U,F=null){if(typeof U=="boolean")return U?I.create(S,F):m.create(S,F);const z=k.get(S);return typeof z=="boolean"?U===(z?"true":"false")?f.INSTANCE:C.INSTANCE:new u(S,U,F)}cmp(S){return S.type!==this.type?this.type-S.type:d(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}evaluate(S){return S.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(S){return S.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class E{constructor(S,U){this.key=S,this.valueKey=U,this.type=10,this.negated=null}static create(S,U){return new E(S,U)}cmp(S){return S.type!==this.type?this.type-S.type:d(this.key,this.valueKey,S.key,S.valueKey)}equals(S){return S.type===this.type?this.key===S.key&&this.valueKey===S.valueKey:!1}evaluate(S){const U=S.getValue(this.valueKey),F=S.getValue(this.key);return Array.isArray(U)?U.indexOf(F)>=0:typeof F=="string"&&typeof U=="object"&&U!==null?P.call(U,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(S){return S.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=g.create(this)),this.negated}}e.ContextKeyInExpr=E;class g{constructor(S){this._actual=S,this.type=11}static create(S){return new g(S)}cmp(S){return S.type!==this.type?this.type-S.type:this._actual.cmp(S._actual)}equals(S){return S.type===this.type?this._actual.equals(S._actual):!1}evaluate(S){return!this._actual.evaluate(S)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(S){return new g(this._actual.map(S))}negate(){return this._actual}}e.ContextKeyNotInExpr=g;class w{constructor(S,U,F){this.key=S,this.value=U,this.negated=F,this.type=5}static create(S,U,F=null){if(typeof U=="boolean")return U?m.create(S,F):I.create(S,F);const z=k.get(S);return typeof z=="boolean"?U===(z?"true":"false")?C.INSTANCE:f.INSTANCE:new w(S,U,F)}cmp(S){return S.type!==this.type?this.type-S.type:d(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}evaluate(S){return S.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(S){return S.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class m{constructor(S,U){this.key=S,this.negated=U,this.type=3}static create(S,U=null){const F=k.get(S);return typeof F=="boolean"?F?C.INSTANCE:f.INSTANCE:new m(S,U)}cmp(S){return S.type!==this.type?this.type-S.type:h(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}evaluate(S){return!S.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(S){return S.mapNot(this.key)}negate(){return this.negated||(this.negated=I.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=m;class v{constructor(S,U,F){this.key=S,this.value=U,this.negated=F,this.type=12}static create(S,U,F=null){return new v(S,U,F)}cmp(S){return S.type!==this.type?this.type-S.type:d(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}evaluate(S){return parseFloat(S.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(S){return S.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=v;class o{constructor(S,U,F){this.key=S,this.value=U,this.negated=F,this.type=13}static create(S,U,F=null){return new o(S,U,F)}cmp(S){return S.type!==this.type?this.type-S.type:d(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}evaluate(S){return parseFloat(S.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(S){return S.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=o;class a{constructor(S,U,F){this.key=S,this.value=U,this.negated=F,this.type=14}static create(S,U,F=null){return new a(S,U,F)}cmp(S){return S.type!==this.type?this.type-S.type:d(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}evaluate(S){return parseFloat(S.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(S){return S.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class t{constructor(S,U,F){this.key=S,this.value=U,this.negated=F,this.type=15}static create(S,U,F=null){return new t(S,U,F)}cmp(S){return S.type!==this.type?this.type-S.type:d(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}evaluate(S){return parseFloat(S.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(S){return S.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=t;class s{constructor(S,U){this.key=S,this.regexp=U,this.type=7,this.negated=null}static create(S,U){return new s(S,U)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.key<S.key)return-1;if(this.key>S.key)return 1;const U=this.regexp?this.regexp.source:"",F=S.regexp?S.regexp.source:"";return U<F?-1:U>F?1:0}equals(S){if(S.type===this.type){const U=this.regexp?this.regexp.source:"",F=S.regexp?S.regexp.source:"";return this.key===S.key&&U===F}return!1}evaluate(S){let U=S.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const S=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${S}`}keys(){return[this.key]}map(S){return S.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class n{constructor(S){this._actual=S,this.type=8}static create(S){return new n(S)}cmp(S){return S.type!==this.type?this.type-S.type:this._actual.cmp(S._actual)}equals(S){return S.type===this.type?this._actual.equals(S._actual):!1}evaluate(S){return!this._actual.evaluate(S)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(S){return new n(this._actual.map(S))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;class r{constructor(S,U){this.expr=S,this.negated=U,this.type=6}static create(S,U){return r._normalizeArr(S,U)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const z=i(this.expr[U],S.expr[U]);if(z!==0)return z}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(S.expr[U]))return!1;return!0}return!1}evaluate(S){for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].evaluate(S))return!1;return!0}static _normalizeArr(S,U){const F=[];let z=!1;for(const j of S)if(!!j){if(j.type===1){z=!0;continue}if(j.type===0)return C.INSTANCE;if(j.type===6){F.push(...j.expr);continue}F.push(j)}if(F.length===0&&z)return f.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(i);for(let j=1;j<F.length;j++)F[j-1].equals(F[j])&&(F.splice(j,1),j--);if(F.length===1)return F[0];for(;F.length>1;){const j=F[F.length-1];if(j.type!==9)break;F.pop();const M=F.pop(),W=F.length===0,x=c.create(j.expr.map($=>r.create([$,M],null)),null,W);x&&(F.push(x),F.sort(i))}return F.length===1?F[0]:new r(F,U)}}serialize(){return this.expr.map(S=>S.serialize()).join(" && ")}keys(){const S=[];for(let U of this.expr)S.push(...U.keys());return S}map(S){return new r(this.expr.map(U=>U.map(S)),null)}negate(){if(!this.negated){const S=[];for(let U of this.expr)S.push(U.negate());this.negated=c.create(S,this,!0)}return this.negated}}class c{constructor(S,U){this.expr=S,this.negated=U,this.type=9}static create(S,U,F){return c._normalizeArr(S,U,F)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const z=i(this.expr[U],S.expr[U]);if(z!==0)return z}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(S.expr[U]))return!1;return!0}return!1}evaluate(S){for(let U=0,F=this.expr.length;U<F;U++)if(this.expr[U].evaluate(S))return!0;return!1}static _normalizeArr(S,U,F){let z=[],j=!1;if(S){for(let M=0,W=S.length;M<W;M++){const x=S[M];if(!!x){if(x.type===0){j=!0;continue}if(x.type===1)return f.INSTANCE;if(x.type===9){z=z.concat(x.expr);continue}z.push(x)}}if(z.length===0&&j)return C.INSTANCE;z.sort(i)}if(z.length!==0){if(z.length===1)return z[0];for(let M=1;M<z.length;M++)z[M-1].equals(z[M])&&(z.splice(M,1),M--);if(z.length===1)return z[0];if(F){for(let M=0;M<z.length;M++)for(let W=M+1;W<z.length;W++)p(z[M],z[W])&&(z.splice(W,1),W--);if(z.length===1)return z[0]}return new c(z,U)}}serialize(){return this.expr.map(S=>S.serialize()).join(" || ")}keys(){const S=[];for(let U of this.expr)S.push(...U.keys());return S}map(S){return new c(this.expr.map(U=>U.map(S)),null)}negate(){if(!this.negated){let S=[];for(let U of this.expr)S.push(U.negate());for(;S.length>1;){const U=S.shift(),F=S.shift(),z=[];for(const M of A(U))for(const W of A(F))z.push(r.create([M,W],null));const j=S.length===0;S.unshift(c.create(z,null,j))}this.negated=S[0]}return this.negated}}class l extends I{constructor(S,U,F){super(S,null);this._defaultValue=U,typeof F=="object"?l._info.push({...F,key:S}):F!==!0&&l._info.push({key:S,description:F,type:U!=null?typeof U:void 0})}static all(){return l._info.values()}bindTo(S){return S.createKey(this.key,this._defaultValue)}getValue(S){return S.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(S){return u.create(this.key,S)}notEqualsTo(S){return w.create(this.key,S)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(O,S){return O<S?-1:O>S?1:0}function d(O,S,U,F){return O<U?-1:O>U?1:S<F?-1:S>F?1:0}function p(O,S){if(S.type===6&&O.type!==9&&O.type!==6){for(const z of S.expr)if(O.equals(z))return!0}const U=O.negate(),F=A(U).concat(A(S));F.sort(i);for(let z=0;z<F.length;z++){const M=F[z].negate();for(let W=z+1;W<F.length;W++){const x=F[W];if(M.equals(x))return!0}}return!1}e.implies=p;function A(O){return O.type===9?O.expr:[O]}}),define(Z[73],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function L(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[74],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(Z[12],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[28],ee([0,1,17,115,7]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var T;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(T=e.TargetPlatform||(e.TargetPlatform={}));function k(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function P(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function y(m,v){switch(m){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function b(m,v){return v==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function i(m,v,o){return b(v,o)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===o?!0:C(o).includes(m)}e.isTargetPlatformCompatible=i;function C(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function f(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=f;var I;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=5]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var u;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(u=e.SortOrder||(e.SortOrder={}));var E;(function(m){m.Install="install",m.Uninstall="uninstall"})(E=e.StatisticType||(e.StatisticType={}));var g;(function(m){m[m.None=0]="None",m[m.Install=1]="Install",m[m.Update=2]="Update"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class w extends Error{constructor(v,o){super(v);this.code=o,this.name=o}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")});var X=this&&this.__param||function(K,e){return function(D,L){e(D,L,K)}};define(Z[150],ee([0,1,2,28]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let R=class extends D.Disposable{constructor(k){super();this.extensionManagementService=k,this._register(k),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};R=de([X(0,L.IExtensionManagementService)],R),e.DeprecatedExtensionsCleaner=R}),define(Z[151],ee([0,1,3,2,26,5,96,28]),function(K,e,D,L,R,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function y(E,g){return T.URI.revive(g?g.transformIncoming(E):E)}function b(E,g){return g?g.transformOutgoingURI(E):E}function i(E,g){g=g||k.DefaultURITransformer;const w=E.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...E,manifest:void 0},g),manifest:w}}function C(E,g){return g?(0,R.cloneAndChange)(E,w=>w instanceof T.URI?g.transformOutgoingURI(w):void 0):E}class f{constructor(g,w){this.service=g,this.getUriTransformer=w,this.onInstallExtension=D.Event.buffer(g.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(g.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(g.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(g.onDidUninstallExtension,!0)}listen(g,w){const m=this.getUriTransformer(g);switch(w){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,v=>v.map(o=>({...o,local:o.local?C(o.local,m):o.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(g,w,m){const v=this.getUriTransformer(g);switch(w){case"zip":return this.service.zip(i(m[0],v)).then(o=>b(o,v));case"unzip":return this.service.unzip(y(m[0],v));case"install":return this.service.install(y(m[0],v),m[1]);case"getManifest":return this.service.getManifest(y(m[0],v));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(m[0]);case"installFromGallery":return this.service.installFromGallery(m[0],m[1]);case"uninstall":return this.service.uninstall(i(m[0],v),m[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(i(m[0],v));case"getInstalled":return this.service.getInstalled(m[0]).then(o=>o.map(a=>C(a,v)));case"updateMetadata":return this.service.updateMetadata(i(m[0],v),m[1]).then(o=>C(o,v));case"updateExtensionScope":return this.service.updateExtensionScope(i(m[0],v),m[1]).then(o=>C(o,v));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class I extends L.Disposable{constructor(g){super();this.channel=g,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(w=>this._onInstallExtension.fire({identifier:w.identifier,source:this.isUriComponents(w.source)?T.URI.revive(w.source):w.source}))),this._register(this.channel.listen("onDidInstallExtensions")(w=>this._onDidInstallExtensions.fire(w.map(m=>({...m,local:m.local?i(m.local,null):m.local,source:this.isUriComponents(m.source)?T.URI.revive(m.source):m.source}))))),this._register(this.channel.listen("onUninstallExtension")(w=>this._onUninstallExtension.fire(w))),this._register(this.channel.listen("onDidUninstallExtension")(w=>this._onDidUninstallExtension.fire(w)))}isUriComponents(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(g){const w=await this.getTargetPlatform();return g.allTargetPlatforms.some(m=>(0,P.isTargetPlatformCompatible)(m,g.allTargetPlatforms,w))}zip(g){return Promise.resolve(this.channel.call("zip",[g]).then(w=>T.URI.revive(w)))}unzip(g){return Promise.resolve(this.channel.call("unzip",[g]))}install(g,w){return Promise.resolve(this.channel.call("install",[g,w])).then(m=>i(m,null))}getManifest(g){return Promise.resolve(this.channel.call("getManifest",[g]))}installFromGallery(g,w){return Promise.resolve(this.channel.call("installFromGallery",[g,w])).then(m=>i(m,null))}uninstall(g,w){return Promise.resolve(this.channel.call("uninstall",[g,w]))}reinstallFromGallery(g){return Promise.resolve(this.channel.call("reinstallFromGallery",[g]))}getInstalled(g=null){return Promise.resolve(this.channel.call("getInstalled",[g])).then(w=>w.map(m=>i(m,null)))}updateMetadata(g,w){return Promise.resolve(this.channel.call("updateMetadata",[g,w])).then(m=>i(m,null))}updateExtensionScope(g,w){return Promise.resolve(this.channel.call("updateExtensionScope",[g,w])).then(m=>i(m,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=I;class u{constructor(g){this.service=g}listen(g,w){throw new Error("Invalid listen")}call(g,w,m){switch(w){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(m[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=u}),define(Z[75],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function R(k){switch(k){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var T;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[76],ee([0,1,24,7]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=R;function T(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class P{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,f){if(typeof C=="undefined"||C===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof C=="string"||typeof f=="string"){let I=typeof C=="string"?C:C.value,u=typeof f=="string"?f:f.value;return D.equalsIgnoreCase(I,u)}return C._lower===f._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=P;function y(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function b(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=b,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[32],ee([0,1,24,76]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(u,E){return u.uuid&&E.uuid?u.uuid===E.uuid:u.id===E.id?!0:(0,D.compareIgnoreCase)(u.id,E.id)===0}e.areSameExtensions=R;class T{constructor(E,g){this.version=g,this.id=E.id,this.uuid=E.uuid}key(){return`${this.id}-${this.version}`}equals(E){return E instanceof T?R(this,E)&&this.version===E.version:!1}}e.ExtensionIdentifierWithVersion=T;function k(u,E){return`${u}.${E}`}e.getExtensionId=k;function P(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function y(u,E){return P(k(u,E))}e.getGalleryExtensionId=y;function b(u,E){const g=[],w=m=>{for(const v of g)if(v.some(o=>R(E(o),E(m))))return v;return null};for(const m of u){const v=w(m);v?v.push(m):g.push([m])}return g}e.groupByExtension=b;function i(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function C(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function f(u){const E=new Set;for(const g of u)g.malicious&&E.add(g.id.id);return E}e.getMaliciousExtensionsSet=f;function I(u,E){const g=[],w=E.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const m=w.shift();if(m&&g.every(v=>!R(v.identifier,{id:m}))){const v=u.filter(o=>R(o.identifier,{id:m}));v.length===1&&(g.push(v[0]),w.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}e.getExtensionDependencies=I}),define(Z[152],ee([0,1,2,8,19,76]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends D.Disposable{constructor(y,b){super();this.environmentService=y,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this._register(b.onDidUninstallExtension(i=>this.onDidUnInstallExtension(i)))}onDidInstallExtensions(y){y.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(y){y.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(Z[13],ee([0,1,40,8,24,16,5,122,7]),function(K,e,D,L,R,T,k,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function b(M){return M.create===!0}e.isFileOpenForWriteOptions=b;var i;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var C;(function(M){M[M.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var f;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function I(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=I;function u(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=u;function E(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=E;function g(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=g;var w;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor(W,x){super(W);this.code=x}}e.FileSystemProviderError=m;function v(M,W){const x=new m(M.toString(),W);return a(x,W),x}e.createFileSystemProviderError=v;function o(M){return M||v((0,P.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=o;function a(M,W){return M.name=W?`${W} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=a;function t(M){if(!M)return w.Unknown;if(M instanceof m)return M.code;const W=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!W)return w.Unknown;switch(W[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function s(M){if(M instanceof d)return M.fileOperationResult;switch(t(M)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var n;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class r{constructor(W,x,$){this.resource=W,this.operation=x,this.target=$}isOperation(W){return this.operation===W}}e.FileOperationEvent=r;var c;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class l{constructor(W,x){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const $ of W)switch($.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>x)),this.added.set($.resource,$);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>x)),this.updated.set($.resource,$);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>x)),this.deleted.set($.resource,$);break}}contains(W,...x){return this.doContains(W,{includeChildren:!1},...x)}affects(W,...x){return this.doContains(W,{includeChildren:!0},...x)}doContains(W,x,...$){if(!W)return!1;const q=$.length>0;return!!((!q||$.includes(1))&&(this.added?.get(W)||x.includeChildren&&this.added?.findSuperstr(W))||(!q||$.includes(0))&&(this.updated?.get(W)||x.includeChildren&&this.updated?.findSuperstr(W))||(!q||$.includes(2))&&(this.deleted?.findSubstr(W)||x.includeChildren&&this.deleted?.findSuperstr(W)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function h(M,W,x){return!M||!W||M===W||W.length>M.length?!1:(W.charAt(W.length-1)!==L.sep&&(W+=L.sep),x?(0,R.startsWithIgnoreCase)(M,W):M.indexOf(W)===0)}e.isParent=h;class d extends Error{constructor(W,x,$){super(W);this.fileOperationResult=x,this.options=$}}e.FileOperationError=d;class p extends d{constructor(W,x,$){super(W,2,$);this.stat=x}}e.NotModifiedSinceFileOperationError=p;var A;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function S(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=S;async function U(M,W){if(!W.canHandleResource(k.URI.from({scheme:M.scheme})))return new Promise(x=>{const $=W.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===M.scheme&&q.added&&($.dispose(),x())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(W){return(0,T.isNumber)(W)||(W=0),W<F.KB?(0,P.localize)(1,null,W.toFixed(0)):W<F.MB?(0,P.localize)(2,null,(W/F.KB).toFixed(2)):W<F.GB?(0,P.localize)(3,null,(W/F.MB).toFixed(2)):W<F.TB?(0,P.localize)(4,null,(W/F.GB).toFixed(2)):(0,P.localize)(5,null,(W/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var z;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function j(M){return{maxFileSize:M===0?300*F.MB:16*F.GB,maxHeapSize:M===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=j}),define(Z[153],ee([0,1,154,50,13]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(P){this.fileService=P}checksum(P){return new Promise(async(y,b)=>{const i=(0,D.createHash)("md5"),C=(await this.fileService.readFileStream(P)).value;(0,L.listenStream)(C,{onData:f=>i.update(f.buffer),onError:f=>b(f),onEnd:()=>y(i.digest("base64").replace(/=+$/,""))})})}};T=de([X(0,R.IFileService)],T),e.ChecksumService=T}),define(Z[155],ee([0,1,221,113,135,13]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(f,I){const u={onUnknownOption:g=>{console.warn((0,L.localize)(0,null,g))},onMultipleValues:(g,w)=>{console.warn((0,L.localize)(1,null,g,w))}},E=(0,R.parseArgs)(f,R.OPTIONS,I?u:void 0);return E.goto&&E._.forEach(g=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(g),(0,L.localize)(2,null))),E["max-memory"]&&D(parseInt(E["max-memory"])>=T.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${T.MIN_MAX_MEMORY_SIZE_MB} MB.`),E}function P(f){const I=f.findIndex(u=>!/^-/.test(u));if(I>-1)return[...f.slice(0,I),...f.slice(I+1)]}function y(f){let[,...I]=f;process.env.VSCODE_DEV&&(I=P(I)||[]);const u=!C(process.env);return k(I,u)}e.parseMainProcessArgv=y;function b(f){const[,,...I]=f;return k(I,!0)}e.parseCLIProcessArgv=b;function i(f,...I){const u=f.indexOf("--");return u===-1?f.push(...I):f.splice(u,0,...I),f}e.addArg=i;function C(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),define(Z[156],ee([0,1,41,137,27,37,9,4,30,109,155]),function(K,e,D,L,R,T,k,P,y,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function C(u,E,g){return E["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,i.isLaunchedFromCli)(g)&&!E["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,i.isLaunchedFromCli)(g)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=new Promise(async w=>{const m=new R.CancellationTokenSource,v=setTimeout(()=>{u.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),m.dispose(!0),w({})},1e4);try{const o=await I(u,m.token);w(o)}catch(o){(0,k.isPromiseCanceledError)(o)||u.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),w({})}finally{clearTimeout(v),m.dispose()}})),f)}e.resolveShellEnv=C;let f;async function I(u,E){const g=new Promise(async(w,m)=>{const v=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",v);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",o);const a=(0,y.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"(.*)"+a),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",s);const n=await(0,b.getSystemShell)(P.OS,s);if(u.trace("getUnixShellEnvironment#shell",n),E.isCancellationRequested)return m(k.canceled);const r=L.basename(n);let c,l;/^pwsh(-preview)?$/.test(r)?(c=`& '${process.execPath}' -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,l=["-Login","-Command"]):(c=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,l=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),c);const h=(0,D.spawn)(n,[...l,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});E.onCancellationRequested(()=>(h.kill(),m(k.canceled))),h.on("error",A=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(A)),w({})});const d=[];h.stdout.on("data",A=>d.push(A));const p=[];h.stderr.on("data",A=>p.push(A)),h.on("close",(A,O)=>{const S=Buffer.concat(d).toString("utf8");u.trace("getUnixShellEnvironment#raw",S);const U=Buffer.concat(p).toString("utf8");if(U.trim()&&u.trace("getUnixShellEnvironment#stderr",U),A||O)return m(new Error(`Failed to get environment (code ${A}, signal ${O})`));const F=t.exec(S),z=F?F[1]:"{}";try{const j=JSON.parse(z);v?j.ELECTRON_RUN_AS_NODE=v:delete j.ELECTRON_RUN_AS_NODE,o?j.ELECTRON_NO_ATTACH_CONSOLE=o:delete j.ELECTRON_NO_ATTACH_CONSOLE,delete j.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",j),w(j)}catch(j){u.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(j)),m(j)}})});try{return await g}catch(w){return u.error("getUnixShellEnvironment#error",(0,T.toErrorMessage)(w)),{}}}}),define(Z[77],ee([0,1,4,5,13]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function T(y){return y.map(b=>({type:b.type,resource:L.URI.file(b.path)}))}e.toFileChanges=T;function k(y){const b=new P;for(const i of y)b.processEvent(i);return b.normalize()}e.normalizeFileChanges=k;class P{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(b){const i=this.mapPathToChange.get(b.path);if(i){const C=i.type,f=b.type;C===1&&f===2?(this.mapPathToChange.delete(b.path),this.normalized.splice(this.normalized.indexOf(i),1)):C===2&&f===1?i.type=0:C===1&&f===0||(i.type=f)}else this.normalized.push(b),this.mapPathToChange.set(b.path,b)}normalize(){const b=[],i=[];return this.normalized.filter(C=>C.type!==2?(b.push(C),!1):!0).sort((C,f)=>C.path.length-f.path.length).filter(C=>i.some(f=>(0,R.isParent)(C.path,f,!D.isLinux))?!1:(i.push(C.path),!0)).concat(b)}}}),define(Z[157],ee([0,1,6,2,8,99,19,101,77]),function(K,e,D,L,R,T,k,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b extends L.Disposable{constructor(C,f,I,u){super();this.path=C,this.onDidFilesChange=f,this.onLogMessage=I,this.verboseLogging=u,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(C){this.verboseLogging=C}async startWatching(){try{const{stat:C,symbolicLink:f}=await k.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let I=this.path;if(f)try{I=await(0,T.realpath)(I)}catch(u){if(this.onError(u),f.dangling)return}C.isDirectory()?this._register((0,P.watchFolder)(I,(u,E)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,R.join)(this.path,(0,R.basename)(E))})},u=>this.onError(u))):this._register((0,P.watchFile)(I,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(C){C.code!=="ENOENT"&&this.onError(C)}}onFileChange(C){this.fileChangesBuffer.push(C),this.verboseLogging&&this.onVerbose(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),this.fileChangesDelayer.trigger(async()=>{const f=this.fileChangesBuffer;this.fileChangesBuffer=[];const I=(0,y.normalizeFileChanges)(f);if(this.verboseLogging)for(const u of I)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);I.length>0&&this.onDidFilesChange(I)})}onError(C){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${C}`})}onVerbose(C){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=b}),define(Z[78],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(let[T,k]of R)this.set(T,k)}set(R,T){const k=this._entries.get(R);return this._entries.set(R,T),k}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(Z[158],ee([0,1,6,9,53,147,7,78]),function(K,e,D,L,R,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class b extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class i{constructor(u=new P.ServiceCollection,E=!1,g){this._activeInstantiations=new Set,this._services=u,this._strict=E,this._parent=g,this._services.set(k.IInstantiationService,this)}createChild(u){return new i(u,this._strict,this)}invokeFunction(u,...E){let g=f.traceInvocation(u),w=!1;try{return u({get:(v,o)=>{if(w)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(v,g);if(!a&&o!==k.optional)throw new Error(`[invokeFunction] unknown service '${v}'`);return a}},...E)}finally{w=!0,g.stop()}}createInstance(u,...E){let g,w;return u instanceof R.SyncDescriptor?(g=f.traceCreation(u.ctor),w=this._createInstance(u.ctor,u.staticArguments.concat(E),g)):(g=f.traceCreation(u),w=this._createInstance(u,E,g)),g.stop(),w}_createInstance(u,E=[],g){let w=k._util.getServiceDependencies(u).sort((o,a)=>o.index-a.index),m=[];for(const o of w){let a=this._getOrCreateServiceInstance(o.id,g);if(!a&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);m.push(a)}let v=w.length>0?w[0].index:E.length;if(E.length!==v){console.warn(`[createInstance] First service dependency of ${u.name} at position ${v+1} conflicts with ${E.length} static arguments`);let o=v-E.length;o>0?E=E.concat(new Array(o)):E=E.slice(0,v)}return new u(...[...E,...m])}_setServiceInstance(u,E){if(this._services.get(u)instanceof R.SyncDescriptor)this._services.set(u,E);else if(this._parent)this._parent._setServiceInstance(u,E);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let E=this._services.get(u);return!E&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):E}_getOrCreateServiceInstance(u,E){let g=this._getServiceInstanceOrDescriptor(u);return g instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,g,E.branch(u,!0)):(E.branch(u,!1),g)}_safeCreateAndCacheServiceInstance(u,E,g){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,E,g)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,E,g){const w=new T.Graph(o=>o.id.toString());let m=0;const v=[{id:u,desc:E,_trace:g}];for(;v.length;){const o=v.pop();if(w.lookupOrInsertNode(o),m++>1e3)throw new b(w);for(let a of k._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${u} depends on ${a.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const s={id:a.id,desc:t,_trace:o._trace.branch(a.id,!0)};w.insertEdge(o,s),v.push(s)}}}for(;;){const o=w.roots();if(o.length===0){if(!w.isEmpty())throw new b(w);break}for(const{data:a}of o){if(this._getServiceInstanceOrDescriptor(a.id)instanceof R.SyncDescriptor){const s=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,s)}w.removeNode(a)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,E,g=[],w,m){if(this._services.get(u)instanceof R.SyncDescriptor)return this._createServiceInstance(E,g,w,m);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,E,g,w,m);throw new Error(`illegalState - creating UNKNOWN service instance ${E.name}`)}_createServiceInstance(u,E=[],g,w){if(g){const m=new D.IdleValue(()=>this._createInstance(u,E,w));return new Proxy(Object.create(null),{get(v,o){if(o in v)return v[o];let a=m.value,t=a[o];return typeof t!="function"||(t=t.bind(a),v[o]=t),t},set(v,o,a){return m.value[o]=a,!0}})}else return this._createInstance(u,E,w)}}e.InstantiationService=i;var C;(function(I){I[I.Creation=0]="Creation",I[I.Invocation=1]="Invocation",I[I.Branch=2]="Branch"})(C||(C={}));class f{constructor(u,E){this.type=u,this.name=E,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return y?new f(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(u){return y?new f(0,u.name):f._None}branch(u,E){let g=new f(2,u.toString());return this._dep.push([u,E,g]),g}stop(){let u=Date.now()-this._start;f._totals+=u;let E=!1;function g(m,v){let o=[],a=new Array(m+1).join("	");for(const[t,s,n]of v._dep)if(s&&n){E=!0,o.push(`${a}CREATES -> ${t}`);let r=g(m+1,n);r&&o.push(r)}else o.push(`${a}uses -> ${t}`);return o.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(u>2||E)&&console.log(w.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(Z[159],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,T){this.server=R,this.router=T}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,T){this.server.registerChannel(R,T)}}e.MessagePortMainProcessService=D}),define(Z[160],ee([0,1,36,53,146,7]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class k{constructor(I,u,E){const g=E.getChannel(I);return P(u)?new u.channelClientCtor(g):D.ProxyChannel.toService(g,u?.proxyOptions)}}function P(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let y=class extends k{constructor(I,u,E){super(I,u,E)}};y=de([X(2,e.IMainProcessService)],y);function b(f,I,u){(0,R.registerSingleton)(f,new L.SyncDescriptor(y,[I,u],u?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let i=class extends k{constructor(I,u,E){super(I,u,E)}};i=de([X(2,e.ISharedProcessService)],i);function C(f,I,u){(0,R.registerSingleton)(f,new L.SyncDescriptor(i,[I,u],u?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=C}),define(Z[57],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function L(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const T of R.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}e.isValidLocalization=L}),define(Z[161],ee([0,1,2,57]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(k){super();this.localizationsService=k,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=de([X(0,L.ILocalizationsService)],R),e.LocalizationsUpdater=R}),define(Z[14],ee([0,1,37,3,2,4,7]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function P(){return new Date().toISOString()}var y;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class b extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class i extends b{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(y.Error))if(t instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=t.stack,this.log(y.Error,this.format(n))}else this.log(y.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let n=0;n<t.length;n++){let r=t[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(c){}s+=(n>0?" ":"")+r}return s}}e.AbstractMessageLogger=i;class C extends b{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...s){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}debug(t,...s){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}info(t,...s){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}warn(t,...s){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...s):console.warn(`[main ${P()}]`,t,...s))}error(t,...s){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...s):console.error(`[main ${P()}]`,t,...s))}critical(t,...s){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...s):console.error(`[main ${P()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class f extends b{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=f;class I extends b{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=I;class u extends b{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const n of this.logServices)n.trace(t,...s)}debug(t,...s){for(const n of this.logServices)n.debug(t,...s)}info(t,...s){for(const n of this.logServices)n.info(t,...s)}warn(t,...s){for(const n of this.logServices)n.warn(t,...s)}error(t,...s){for(const n of this.logServices)n.error(t,...s)}critical(t,...s){for(const n of this.logServices)n.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class E extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=E;class g extends R.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(n))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,s){let n=this.loggers.get(t.toString());return n||(n=this.doCreateLogger(t,s?.always?y.Trace:this.logLevel,s),this.loggers.set(t.toString(),n),s?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class w{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=w;function m(a){if(a.verbose)return y.Trace;if(typeof a.logLevel=="string"){const t=v(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=m;function v(a){switch(a){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=v;function o(a){switch(a){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=o}),define(Z[162],ee([0,1,6,9,2,8,19,12,14]),function(K,e,D,L,R,T,k,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends R.Disposable{constructor(C,f){super();this.environmentService=C,this.logService=f,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,T.basename)(this.environmentService.logsPath),f=(0,T.dirname)(this.environmentService.logsPath),E=(await k.Promises.readdir(f)).filter(w=>/^\d{8}T\d{6}$/.test(w)).sort().filter(w=>w!==C),g=E.slice(0,Math.max(0,E.length-9));g.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${g.join(", ")}'`),await Promise.all(g.map(w=>k.Promises.rm((0,T.join)(f,w)))))}catch(C){(0,L.onUnexpectedError)(C)}}};b=de([X(0,P.IEnvironmentService),X(1,y.ILogService)],b),e.LogsDataCleaner=b}),define(Z[163],ee([0,1,6,9,2,8,19,12,14]),function(K,e,D,L,R,T,k,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let b=class ut extends R.Disposable{constructor(C,f,I){super();this.backupWorkspacesPath=C,this.environmentService=f,this.logService=I,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const C=await k.Promises.readFile(this.backupWorkspacesPath,"utf8"),I=JSON.parse(C).emptyWorkspaceInfos.map(E=>E.backupFolder),u=await k.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(u.map(async E=>{E.length!==ut.NON_EMPTY_WORKSPACE_ID_LENGTH&&I.indexOf(E)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${E}.`),await k.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,E)))}))}catch(C){(0,L.onUnexpectedError)(C)}}};b.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,b=de([X(1,P.INativeEnvironmentService),X(2,y.ILogService)],b),e.StorageDataCleaner=b}),define(Z[164],ee([0,1,6,9,2,4,15,58,5,30,19,12,28,32,13,14]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const g=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let w=class extends R.Disposable{constructor(v,o,a,t){super();this.fileService=o,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=y.URI.file(v.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(v,o){await this.cleanUpPromise;const a=this.getName(v),t=(0,k.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const s=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(v,s,o);try{await this.rename(s,t,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(s)}catch(r){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",v.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,s.path),n}}return t}async delete(v){}async rename(v,o,a){try{await i.Promises.rename(v.fsPath,o.fsPath)}catch(t){if(T.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${v} to ${o} with 'EPERM' error. Trying again...`),this.rename(v,o,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const v=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(v.children){const o=[],a=[];for(const n of v.children){const r=this.parse(n.name);r&&a.push([r,n])}const t=(0,I.groupByExtension)(a,([n])=>n),s=[];for(const n of t)n.sort((r,c)=>P.rcompare(r[0].version,c[0].version)),o.push(...n.slice(1).map(r=>r[1].resource)),s.push(n[0][1]);s.sort((n,r)=>n.mtime-r.mtime),o.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(n=>n.resource)),await D.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(v){this.logService.error(v)}}getName(v){return this.cache?`${new I.ExtensionIdentifierWithVersion(v.identifier,v.version).key().toLowerCase()}${v.properties.targetPlatform!=="undefined"?`-${v.properties.targetPlatform}`:""}`:(0,b.generateUuid)()}parse(v){const o=g.exec(v);return o&&o[1]&&o[2]?new I.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};w=de([X(0,C.INativeEnvironmentService),X(1,u.IFileService),X(2,f.IExtensionGalleryService),X(3,E.ILogService)],w),e.ExtensionsDownloader=w}),define(Z[165],ee([0,1,41,6,37,3,2,17,8,19,12,14]),function(K,e,D,L,R,T,k,P,y,b,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends k.Disposable{constructor(u,E){super();this.environmentService=u,this.logService=E,this.processesLimiter=new L.Limiter(5)}async postUninstall(u){const E=this.parseScript(u,"uninstall");return E&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(E.script,"uninstall",E.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),g=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${g}`)))),b.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,g=>this.logService.error("Error while removing extension storage path",g))}parseScript(u,E){const g=`vscode:${E}`;if(u.location.scheme===P.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[g]=="string"){const w=u.manifest.scripts[g].split(" ");return w.length<2||w[0]!=="node"||!w[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${g} should be a node script`),null):{script:(0,y.join)(u.location.fsPath,w[1]),args:w.slice(2)||[]}}return null}runLifecycleHook(u,E,g,w,m){return new Promise((v,o)=>{const a=this.start(u,E,g,m);let t;const s=n=>{t&&(clearTimeout(t),t=null),n?o(n):v(void 0)};a.on("error",n=>{s((0,R.toErrorMessage)(n)||"Unknown")}),a.on("exit",(n,r)=>{s(n?`post-${E} process exited with code ${n}`:void 0)}),w&&(t=setTimeout(()=>{t=null,a.kill(),o("timed out")},5e3))})}start(u,E,g,w){const m={silent:!0,execArgv:void 0},v=(0,D.fork)(u,[`--type=extension-post-${E}`,...g],m);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const o=T.Event.fromNodeEventEmitter(v.stdout,"data"),a=T.Event.fromNodeEventEmitter(v.stderr,"data");o(n=>this.logService.info(w.identifier.id,w.manifest.version,`post-${E}`,n)),a(n=>this.logService.error(w.identifier.id,w.manifest.version,`post-${E}`,n));const t=T.Event.any(T.Event.map(o,n=>({data:`%c${n}`,format:[""]})),T.Event.map(a,n=>({data:`%c${n}`,format:["color: red"]})));return T.Event.debounce(t,(n,r)=>n?{data:n.data+r.data,format:[...n.format,...r.format]}:{data:r.data,format:r.format},100)(n=>{console.group(w.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),v}getExtensionStoragePath(u){return(0,y.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};f=de([X(0,i.IEnvironmentService),X(1,C.ILogService)],f),e.ExtensionsLifecycle=f}),define(Z[166],ee([0,1,3,2,15,5,12,32,13,14]),function(K,e,D,L,R,T,k,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let i=class extends L.Disposable{constructor(f,I,u,E){super();this.extensionsManagementService=f,this.logService=E,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(m=>{this.installedExtensions=m.map(v=>v.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(m=>this.onInstallExtension(m))),this._register(f.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(f.onDidUninstallExtension(m=>this.onDidUninstallExtension(m)));const g=T.URI.file(u.extensionsPath),w=new R.ExtUri(m=>!I.hasCapability(m,1024));this._register(I.watch(g)),this._register(D.Event.filter(I.onDidChangeFilesRaw,m=>m.changes.some(v=>this.doesChangeAffects(v,g,w)))(()=>this.onDidChange()))}doesChangeAffects(f,I,u){return u.isEqual(u.dirname(f.resource),I)?u.isEqual(f.resource,u.joinPath(I,".obsolete"))?!0:!(f.type!==1&&f.type!==2||u.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const I of f)this.removeInstallingExtension(I.identifier),I.local&&this.addInstalledExtension(I.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(I=>!(0,P.areSameExtensions)(I,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(I=>!(0,P.areSameExtensions)(I,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),I=f.filter(E=>[...this.installingExtensions,...this.installedExtensions].some(g=>(0,P.areSameExtensions)(g,E.identifier))?!1:E.installedTimestamp&&E.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",E.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",E.identifier.id),!1)),u=this.installedExtensions.filter(E=>this.installingExtensions.some(g=>(0,P.areSameExtensions)(g,E))?!1:f.every(g=>!(0,P.areSameExtensions)(g.identifier,E))?(this.logService.info("Detected extension removed from another source",E.id),!0):!1);this.installedExtensions=f.map(E=>E.identifier),(I.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:I,removed:u})}}};i=de([X(1,y.IFileService),X(2,k.INativeEnvironmentService),X(3,b.ILogService)],i),e.ExtensionsWatcher=i}),define(Z[167],ee([0,1,154,18,6,2,17,8,19,12,28,32,57,14]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let u=class extends T.Disposable{constructor(w,m,v){super();this.extensionManagementService=w,this.logService=v,this.cache=this._register(new E(m,v)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const w=await this.cache.getLanguagePacks(),m=["en",...Object.keys(w)];return(0,L.distinct)(m)}async postInstallExtension(w){w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",w.identifier.id),await this.update())}async postUninstallExtension(w){const m=await this.cache.getLanguagePacks();Object.keys(m).some(v=>m[v]&&m[v].extensions.some(o=>(0,C.areSameExtensions)(o.extensionIdentifier,w.identifier)))&&(this.logService.info("Removing language packs from the extension",w.identifier.id),await this.update())}async update(){const[w,m]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),v=await this.cache.update(m);return!(0,L.equals)(Object.keys(w),Object.keys(v))}};u=de([X(0,i.IExtensionManagementService),X(1,b.INativeEnvironmentService),X(2,I.ILogService)],u),e.LocalizationsService=u;let E=class extends T.Disposable{constructor(w,m){super();this.logService=m,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(w.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(w){return this.withLanguagePacks(m=>{Object.keys(m).forEach(v=>delete m[v]),this.createLanguagePacksFromExtensions(m,...w)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(w,...m){for(const v of m)v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(w,v);Object.keys(w).forEach(v=>this.updateHash(w[v]))}createLanguagePacksFromExtension(w,m){const v=m.identifier,o=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const a of o)if(m.location.scheme===k.Schemas.file&&(0,f.isValidLocalization)(a)){let t=w[a.languageId];t||(t={hash:"",extensions:[],translations:{}},w[a.languageId]=t);let s=t.extensions.filter(n=>(0,C.areSameExtensions)(n.extensionIdentifier,v))[0];s?s.version=m.manifest.version:t.extensions.push({extensionIdentifier:v,version:m.manifest.version});for(const n of a.translations)t.translations[n.id]=(0,P.join)(m.location.fsPath,n.path)}}updateHash(w){if(w){const m=(0,D.createHash)("md5");for(const v of w.extensions)m.update(v.extensionIdentifier.uuid||v.extensionIdentifier.id).update(v.version);w.hash=m.digest("hex")}}withLanguagePacks(w=()=>null){return this.languagePacksFileLimiter.queue(()=>{let m=null;return y.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,v=>v.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(v)).then(v=>{try{return JSON.parse(v)}catch(o){return{}}}).then(v=>(m=w(v),v)).then(v=>{for(const a of Object.keys(v))v[a]||delete v[a];this.languagePacks=v,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),y.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>m,v=>this.logService.error(v))})}};E=de([X(0,b.INativeEnvironmentService),X(1,I.ILogService)],E)}),define(Z[79],ee([0,1,3,5,14]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(f){this.service=f,this.onDidChangeLogLevel=D.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,I){switch(I){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${I}`)}async call(f,I,u){switch(I){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${I}`)}}e.LogLevelChannel=T;class k{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){k.setLevel(this.channel,f)}static setLevel(f,I){return f.call("setLevel",I)}}e.LogLevelChannelClient=k;class P{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,I){throw new Error(`Event not found: ${I}`)}async call(f,I,u){switch(I){case"createLogger":this.createLogger(L.URI.revive(u[0]),u[1]);return;case"log":return this.log(L.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${I}`)}createLogger(f,I){this.loggers.set(f.toString(),this.loggerService.createLogger(f,I))}consoleLog(f,I){let u=console.log;switch(f){case R.LogLevel.Error:u=console.error;break;case R.LogLevel.Warning:u=console.warn;break;case R.LogLevel.Info:u=console.info;break}u.call(console,...I)}log(f,I){const u=this.loggers.get(f.toString());if(!u)throw new Error("Create the logger before logging");for(const[E,g]of I)switch(E){case R.LogLevel.Trace:u.trace(g);break;case R.LogLevel.Debug:u.debug(g);break;case R.LogLevel.Info:u.info(g);break;case R.LogLevel.Warning:u.warn(g);break;case R.LogLevel.Error:u.error(g);break;case R.LogLevel.Critical:u.critical(g);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class y extends R.AbstractLoggerService{constructor(f,I,u){super(f,I);this.channel=u}createConsoleMainLogger(){return new R.AdapterLogger({log:(f,I)=>{this.channel.call("consoleLog",[f,I])}})}doCreateLogger(f,I,u){return new b(this.channel,f,I,u)}}e.LoggerChannelClient=y;class b extends R.AbstractMessageLogger{constructor(f,I,u,E){super(E?.always);this.channel=f,this.file=I,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[I,E]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,I){const u=[[f,I]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(f){this.channel.call("log",[this.file,f])}}class i extends R.LogService{constructor(f,I){super(I);this.parent=f,this._register(f.onDidChangeLogLevel(u=>I.setLevel(u)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=i}),define(Z[59],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(Z[42],ee([0,1,17,4,31,15]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const P=L.globals.vscode.context.configuration();if(P)k=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const P=(0,T.dirname)(D.FileAccess.asFileUri("",K));k=K.__$__nodeRequire((0,T.joinPath)(P,"product.json").fsPath);const y=K.__$__nodeRequire((0,T.joinPath)(P,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:y.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(Z[80],ee([0,1,25,9,123,13,42]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(C,f,I,u,E,g){let w;try{await y(C,f,I,u,E,g)}catch(m){w=m}finally{w&&E.errorTransformer&&(w=E.errorTransformer(w)),typeof w!="undefined"&&I.error(w),I.end()}}e.readFileIntoStream=P;async function y(C,f,I,u,E,g){b(g);const w=await C.open(f,{create:!1});try{b(g);let m=0,v=0,o=E&&typeof E.length=="number"?E.length:void 0,a=D.VSBuffer.alloc(Math.min(E.bufferSize,typeof o=="number"?o:E.bufferSize)),t=E&&typeof E.position=="number"?E.position:0,s=0;do v=await C.read(w,t,a.buffer,s,a.byteLength-s),t+=v,s+=v,m+=v,typeof o=="number"&&(o-=v),s===a.byteLength&&(await I.write(u(a)),a=D.VSBuffer.alloc(Math.min(E.bufferSize,typeof o=="number"?o:E.bufferSize)),s=0);while(v>0&&(typeof o!="number"||o>0)&&b(g)&&i(m,E));if(s>0){let n=s;typeof o=="number"&&(n=Math.min(s,o)),I.write(u(a.slice(0,n)))}}catch(m){throw(0,T.ensureFileSystemProviderError)(m)}finally{await C.close(w)}}function b(C){if(C.isCancellationRequested)throw(0,L.canceled)();return!0}function i(C,f){if(f?.limits){if(typeof f.limits.memory=="number"&&C>f.limits.memory)throw(0,T.createFileSystemProviderError)((0,R.localize)(0,null,k.default.nameShort),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof f.limits.size=="number"&&C>f.limits.size)throw(0,T.createFileSystemProviderError)((0,R.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[168],ee([0,1,18,6,25,27,3,55,2,40,17,169,15,50,121,13,80,14]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I,u,E,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let m=class Be extends y.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new k.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Be.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Be.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Be.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new E.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Be.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Be.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Be.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new E.FileChangesEvent(a,!0)))),this.watchedResources=b.TernarySearchTree.forUris(a=>{const t=this.getProvider(a.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,a){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:a});const t=new y.DisposableStore;return t.add(a.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(a)))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:o}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,y.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:a}),this.provider.delete(o),(0,y.dispose)(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){a.push(t)}}),!this.provider.has(o)&&await L.Promises.settled(a)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,a){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return P.Iterable.map(this.provider,([o,a])=>({scheme:o,capabilities:a.capabilities}))}async withProvider(o){if(!(0,f.isAbsolutePath)(o))throw new E.FileOperationError((0,u.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const a=this.provider.get(o.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=(0,u.localize)(1,null,o.toString()),t}return a}async withReadProvider(o){const a=await this.withProvider(o);if((0,E.hasOpenReadWriteCloseCapability)(a)||(0,E.hasReadWriteCapability)(a)||(0,E.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const a=await this.withProvider(o);if((0,E.hasOpenReadWriteCloseCapability)(a)||(0,E.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,a){try{return await this.doResolveFile(o,a)}catch(t){throw(0,E.toFileSystemProviderErrorCode)(t)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,u.localize)(2,null,this.resourceForError(o)),1):(0,E.ensureFileSystemProviderError)(t)}}async doResolveFile(o,a){const t=await this.withProvider(o),s=this.isPathCaseSensitive(t),n=a?.resolveTo,r=a?.resolveSingleChildDescendants,c=a?.resolveMetadata,l=await t.stat(o);let h;return this.toFileStat(t,o,l,void 0,!!c,(d,p)=>{if(!h&&(h=b.TernarySearchTree.forUris(()=>!s),h.set(o,!0),n))for(const A of n)h.set(A,!0);return h.get(d.resource)||h.findSuperstr(d.resource.with({query:null,fragment:null}))?!0:d.isDirectory&&r?p===1:!1})}async toFileStat(o,a,t,s,n,r){const{providerExtUri:c}=this.getExtUri(o),l={resource:a,name:c.basename(a),isFile:(t.type&E.FileType.File)!=0,isDirectory:(t.type&E.FileType.Directory)!=0,isSymbolicLink:(t.type&E.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&E.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,E.etag)({mtime:t.mtime,size:t.size})};if(l.isDirectory&&r(l,s)){try{const h=await o.readdir(a),d=await L.Promises.settled(h.map(async([p,A])=>{try{const O=c.joinPath(a,p),S=n?await o.stat(O):{type:A};return await this.toFileStat(o,O,S,h.length,n,r)}catch(O){return this.logService.trace(O),null}}));l.children=(0,D.coalesce)(d)}catch(h){this.logService.trace(h),l.children=[]}return l}return l}async resolveAll(o){return L.Promises.settled(o.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const a=await this.withProvider(o);try{return!!await a.stat(o)}catch(t){return!1}}async canCreateFile(o,a){try{await this.doValidateCreateFile(o,a)}catch(t){return t}return!0}async doValidateCreateFile(o,a){if(!a?.overwrite&&await this.exists(o))throw new E.FileOperationError((0,u.localize)(3,null,this.resourceForError(o)),3,a)}async createFile(o,a=R.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const s=await this.writeFile(o,a);return this._onDidRunOperation.fire(new E.FileOperationEvent(o,0,s)),s}async writeFile(o,a,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(s);try{await this.validateWriteFile(s,o,t)||await this.mkdirp(s,n.dirname(o));let c;if((0,E.hasReadWriteCapability)(s)&&!(a instanceof R.VSBuffer))if((0,I.isReadableStream)(a)){const l=await(0,I.peekStream)(a,3);l.ended?c=R.VSBuffer.concat(l.buffer):c=l}else c=(0,I.peekReadable)(a,l=>R.VSBuffer.concat(l),3);else c=a;!(0,E.hasOpenReadWriteCloseCapability)(s)||(0,E.hasReadWriteCapability)(s)&&c instanceof R.VSBuffer?await this.doWriteUnbuffered(s,o,t,c):await this.doWriteBuffered(s,o,t,c instanceof R.VSBuffer?(0,R.bufferToReadable)(c):c)}catch(r){throw new E.FileOperationError((0,u.localize)(4,null,this.resourceForError(o),(0,E.ensureFileSystemProviderError)(r).toString()),(0,E.toFileOperationResult)(r),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,a,t){if(!!t?.unlock&&!(o.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(a)));let n;try{n=await o.stat(a)}catch(r){return}if((n.type&E.FileType.Directory)!=0)throw new E.FileOperationError((0,u.localize)(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,n),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==E.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&t.mtime<n.mtime&&t.etag!==(0,E.etag)({mtime:t.mtime,size:n.size}))throw new E.FileOperationError((0,u.localize)(7,null),3,t);return n}async readFile(o,a){const t=await this.withReadProvider(o);return a?.atomic?this.doReadFileAtomic(t,o,a):this.doReadFile(t,o,a)}async doReadFileAtomic(o,a,t){return new Promise((s,n)=>{this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,a,t);s(r)}catch(r){n(r)}})})}async doReadFile(o,a,t){const s=await this.doReadFileStream(o,a,{...t,preferUnbuffered:!0});return{...s,value:await(0,R.streamToBuffer)(s.value)}}async readFileStream(o,a){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,a)}async doReadFileStream(o,a,t){const s=new T.CancellationTokenSource,n=this.validateReadFile(a,t).then(c=>c,c=>{throw s.cancel(),c});let r;try{return typeof t?.etag=="string"&&t.etag!==E.ETAG_DISABLED&&await n,!((0,E.hasOpenReadWriteCloseCapability)(o)||(0,E.hasFileReadStreamCapability)(o))||(0,E.hasReadWriteCapability)(o)&&t?.preferUnbuffered?r=this.readFileUnbuffered(o,a,t):(0,E.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,a,s.token,t):r=this.readFileBuffered(o,a,s.token,t),{...await n,value:r}}catch(c){r&&await(0,I.consumeStream)(r);const l=(0,u.localize)(8,null,this.resourceForError(a),(0,E.ensureFileSystemProviderError)(c).toString());throw c instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(l,c.stat,t):new E.FileOperationError(l,(0,E.toFileOperationResult)(c),t)}}readFileStreamed(o,a,t,s=Object.create(null)){const n=o.readFileStream(a,s,t);return(0,I.transform)(n,{data:r=>r instanceof R.VSBuffer?r:R.VSBuffer.wrap(r),error:r=>new E.FileOperationError((0,u.localize)(9,null,this.resourceForError(a),(0,E.ensureFileSystemProviderError)(r).toString()),(0,E.toFileOperationResult)(r),s)},r=>R.VSBuffer.concat(r))}readFileBuffered(o,a,t,s=Object.create(null)){const n=(0,R.newWriteableBufferStream)();return(0,g.readFileIntoStream)(o,a,n,r=>r,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new E.FileOperationError((0,u.localize)(10,null,this.resourceForError(a),(0,E.ensureFileSystemProviderError)(r).toString()),(0,E.toFileOperationResult)(r),s)},t),n}readFileUnbuffered(o,a,t){const s=(0,I.newWriteableStream)(n=>R.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(a);typeof t?.position=="number"&&(n=n.slice(t.position)),typeof t?.length=="number"&&(n=n.slice(0,t.length)),this.validateReadFileLimits(a,n.byteLength,t),s.end(R.VSBuffer.wrap(n))}catch(n){s.error(n),s.end()}})(),s}async validateReadFile(o,a){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new E.FileOperationError((0,u.localize)(11,null,this.resourceForError(o)),0,a);if(typeof a?.etag=="string"&&a.etag!==E.ETAG_DISABLED&&a.etag===t.etag)throw new E.NotModifiedSinceFileOperationError((0,u.localize)(12,null),t,a);return this.validateReadFileLimits(o,t.size,a),t}validateReadFileLimits(o,a,t){if(t?.limits){let s;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(s=9),typeof t.limits.size=="number"&&a>t.limits.size&&(s=7),typeof s=="number")throw new E.FileOperationError((0,u.localize)(13,null,this.resourceForError(o)),s)}}async canMove(o,a,t){return this.doCanMoveCopy(o,a,"move",t)}async canCopy(o,a,t){return this.doCanMoveCopy(o,a,"copy",t)}async doCanMoveCopy(o,a,t,s){if(o.toString()!==a.toString())try{const n=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(n,o,r,a,t,s)}catch(n){return n}return!0}async move(o,a,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=await this.doMoveCopy(s,o,n,a,"move",!!t),c=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(o,r==="move"?2:3,c)),c}async copy(o,a,t){const s=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=await this.doMoveCopy(s,o,n,a,"copy",!!t),c=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(o,r==="copy"?3:2,c)),c}async doMoveCopy(o,a,t,s,n,r){if(a.toString()===s.toString())return n;const{exists:c,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(o,a,t,s,n,r);if(c&&!l&&r&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),n==="copy"){if(o===t&&(0,E.hasFileFolderCopyCapability)(o))await o.copy(a,s,{overwrite:r});else{const h=await this.resolve(a);h.isDirectory?await this.doCopyFolder(o,h,t,s):await this.doCopyFile(o,a,t,s)}return n}else return o===t?(await o.rename(a,s,{overwrite:r}),n):(await this.doMoveCopy(o,a,t,s,"copy",r),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(o,a,t,s){if((0,E.hasOpenReadWriteCloseCapability)(o)&&(0,E.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,a,t,s);if((0,E.hasOpenReadWriteCloseCapability)(o)&&(0,E.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,a,t,s);if((0,E.hasReadWriteCapability)(o)&&(0,E.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,a,t,s);if((0,E.hasReadWriteCapability)(o)&&(0,E.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,a,t,s)}async doCopyFolder(o,a,t,s){await t.mkdir(s),Array.isArray(a.children)&&await L.Promises.settled(a.children.map(async n=>{const r=this.getExtUri(t).providerExtUri.joinPath(s,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),t,r):this.doCopyFile(o,n.resource,t,r)}))}async doValidateMoveCopy(o,a,t,s,n,r){let c=!1;if(o===t){const{providerExtUri:h,isPathCaseSensitive:d}=this.getExtUri(o);if(d||(c=h.isEqual(a,s)),c&&n==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(a),this.resourceForError(s)));if(!c&&h.isEqualOrParent(s,a))throw new Error((0,u.localize)(15,null,this.resourceForError(a),this.resourceForError(s)))}const l=await this.exists(s);if(l&&!c){if(!r)throw new E.FileOperationError((0,u.localize)(16,null,this.resourceForError(a),this.resourceForError(s)),4);if(o===t){const{providerExtUri:h}=this.getExtUri(o);if(h.isEqualOrParent(a,s))throw new Error((0,u.localize)(17,null,this.resourceForError(a),this.resourceForError(s)))}}return{exists:l,isSameResourceWithDifferentPathCase:c}}getExtUri(o){const a=this.isPathCaseSensitive(o);return{providerExtUri:a?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(a,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(o,0,t)),t}async mkdirp(o,a){const t=[],{providerExtUri:s}=this.getExtUri(o);for(;!s.isEqual(a,s.dirname(a));)try{if(((await o.stat(a)).type&E.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(a)));break}catch(n){if((0,E.toFileSystemProviderErrorCode)(n)!==E.FileSystemProviderErrorCode.FileNotFound)throw n;t.push(s.basename(a)),a=s.dirname(a)}for(let n=t.length-1;n>=0;n--){a=s.joinPath(a,t[n]);try{await o.mkdir(a)}catch(r){if((0,E.toFileSystemProviderErrorCode)(r)!==E.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,a){try{await this.doValidateDelete(o,a)}catch(t){return t}return!0}async doValidateDelete(o,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!a?.useTrash&&!(t.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(o)));let n;try{n=await t.stat(o)}catch(c){}if(n)this.throwIfFileIsReadonly(o,n);else throw new E.FileOperationError((0,u.localize)(20,null,this.resourceForError(o)),1);if(!!!a?.recursive){const c=await this.resolve(o);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(o)))}return t}async del(o,a){const t=await this.doValidateDelete(o,a),s=!!a?.useTrash,n=!!a?.recursive;await t.delete(o,{recursive:n,useTrash:s}),this._onDidRunOperation.fire(new E.FileOperationEvent(o,1))}onDidChangeFile(o,a){this._onDidChangeFilesRaw.fire({changes:o});let t,s;{for(const n of o)this.watchedResources.has(n.resource)?(t||(t=[]),t.push(n)):(s||(s=[]),s.push(n));t&&this._onDidFilesChange.fire(new E.FileChangesEvent(t,!a))}if(s){const n=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(s)&&Be.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,a={recursive:!1,excludes:[]}){const t=new y.DisposableStore;{let s=!1,n=()=>{s=!0};t.add((0,y.toDisposable)(()=>n())),this.doWatch(o,a).then(r=>{s?(0,y.dispose)(r):n=()=>(0,y.dispose)(r)},r=>this.logService.error(r))}return a.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),t.add((0,y.toDisposable)(()=>{const s=this.watchedResources.get(o);typeof s=="number"&&(s<=1?this.watchedResources.delete(o):this.watchedResources.set(o,s-1))}))),t}async doWatch(o,a){const t=await this.withProvider(o),s=this.toWatchKey(t,o,a),n=this.activeWatchers.get(s)||{count:0,disposable:t.watch(o,a)};return this.activeWatchers.has(s)||this.activeWatchers.set(s,n),n.count+=1,(0,y.toDisposable)(()=>{n.count--,n.count===0&&((0,y.dispose)(n.disposable),this.activeWatchers.delete(s))})}toWatchKey(o,a,t){const{providerExtUri:s}=this.getExtUri(o);return[s.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,y.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,a,t,s){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(a,{create:!0,unlock:t?.unlock??!1});try{(0,I.isReadableStream)(s)||(0,I.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(o,n,s):await this.doWriteReadableBufferedQueued(o,n,s)}catch(r){throw(0,E.ensureFileSystemProviderError)(r)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,a,t){let s=0,n;if((0,I.isReadableBufferedStream)(t)){if(t.buffer.length>0){const r=R.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,a,r,r.byteLength,s,0),s+=r.byteLength}if(t.ended)return;n=t.stream}else n=t;return new Promise(async(r,c)=>{(0,I.listenStream)(n,{onData:async l=>{n.pause();try{await this.doWriteBuffer(o,a,l,l.byteLength,s,0)}catch(h){return c(h)}s+=l.byteLength,setTimeout(()=>n.resume())},onError:l=>c(l),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,a,t){let s=0,n;for(;(n=t.read())!==null;)await this.doWriteBuffer(o,a,n,n.byteLength,s,0),s+=n.byteLength}async doWriteBuffer(o,a,t,s,n,r){let c=0;for(;c<s;)c+=await o.write(a,n+c,t.buffer,r+c,s-c)}async doWriteUnbuffered(o,a,t,s){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,a,t,s))}async doWriteUnbufferedQueued(o,a,t,s){let n;s instanceof R.VSBuffer?n=s:(0,I.isReadableStream)(s)?n=await(0,R.streamToBuffer)(s):(0,I.isReadableBufferedStream)(s)?n=await(0,R.bufferedStreamToBuffer)(s):n=(0,R.readableToBuffer)(s),await o.writeFile(a,n.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(o,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,a,t,s))}async doPipeBufferedQueued(o,a,t,s){let n,r;try{n=await o.open(a,{create:!1}),r=await t.open(s,{create:!0,unlock:!1});const c=R.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,h=0,d=0;do d=await o.read(n,l,c.buffer,h,c.byteLength-h),await this.doWriteBuffer(t,r,c,d,l,h),l+=d,h+=d,h===c.byteLength&&(h=0);while(d>0)}catch(c){throw(0,E.ensureFileSystemProviderError)(c)}finally{await L.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof r=="number"?t.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,a,t,s))}async doPipeUnbufferedQueued(o,a,t,s){return t.writeFile(s,await o.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,a,t,s))}async doPipeUnbufferedToBufferedQueued(o,a,t,s){const n=await t.open(s,{create:!0,unlock:!1});try{const r=await o.readFile(a);await this.doWriteBuffer(t,n,R.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,E.ensureFileSystemProviderError)(r)}finally{await t.close(n)}}async doPipeBufferedToUnbuffered(o,a,t,s){const n=await(0,R.streamToBuffer)(this.readFileBuffered(o,a,T.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,n)}throwIfFileSystemIsReadonly(o,a){if(o.capabilities&2048)throw new E.FileOperationError((0,u.localize)(22,null,this.resourceForError(a)),6);return o}throwIfFileIsReadonly(o,a){if((a.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,u.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===i.Schemas.file?o.fsPath:o.toString(!0)}};m.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},m=de([X(0,w.ILogService)],m),e.FileService=m}),define(Z[170],ee([0,1,18,6,25,3,39,2,8,4,15,50,19,124,13,80,157,142,143,77,145,14,42]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I,u,E,g,w,m,v,o,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class s extends P.Disposable{constructor(r,c){super();this.logService=r,this.options=c,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new T.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:c,symbolicLink:l}=await f.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(c,l),ctime:c.birthtime.getTime(),mtime:c.mtime.getTime(),size:c.size}}catch(c){throw this.toFileSystemProviderError(c)}}async readdir(r){try{const c=await f.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),l=[];return await Promise.all(c.map(async h=>{try{let d;h.isSymbolicLink()?d=(await this.stat((0,i.joinPath)(r,h.name))).type:d=this.toType(h),l.push([h.name,d])}catch(d){this.logService.trace(d)}})),l}catch(c){throw this.toFileSystemProviderError(c)}}toType(r,c){let l;return c?.dangling?l=u.FileType.Unknown:r.isFile()?l=u.FileType.File:r.isDirectory()?l=u.FileType.Directory:l=u.FileType.Unknown,c&&(l|=u.FileType.SymbolicLink),l}async readFile(r){try{const c=this.toFilePath(r);return await f.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}}readFileStream(r,c,l){const h=(0,C.newWriteableStream)(d=>R.VSBuffer.concat(d.map(p=>R.VSBuffer.wrap(p))).buffer);return(0,E.readFileIntoStream)(this,r,h,d=>d.buffer,{...c,bufferSize:this.BUFFER_SIZE},l),h}async writeFile(r,c,l){let h;try{const d=this.toFilePath(r);if(!l.create||!l.overwrite){if(await f.Promises.exists(d)){if(!l.overwrite)throw(0,u.createFileSystemProviderError)((0,I.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,u.createFileSystemProviderError)((0,I.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(r,{create:!0,unlock:l.unlock}),await this.write(h,0,c,0,c.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(r,d)}finally{typeof h=="number"&&await this.close(h)}}async open(r,c){try{const l=this.toFilePath(r);if((0,u.isFileOpenForWriteOptions)(c)&&c.unlock)try{const{stat:p}=await f.SymlinkSupport.stat(l);p.mode&128||await f.Promises.chmod(l,p.mode|128)}catch(p){this.logService.trace(p)}let h;if((0,u.isFileOpenForWriteOptions)(c)){if(b.isWindows)try{await f.Promises.truncate(l,0),h="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}h||(h="w")}else h="r";const d=await f.Promises.open(l,h);return this.mapHandleToPos.set(d,0),(0,u.isFileOpenForWriteOptions)(c)&&this.writeHandles.set(d,r),d}catch(l){throw(0,u.isFileOpenForWriteOptions)(c)?await this.toFileSystemProviderWriteError(r,l):this.toFileSystemProviderError(l)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await f.Promises.fdatasync(r)}catch(c){this.canFlush=!1,this.logService.error(c)}return await f.Promises.close(r)}catch(c){throw this.toFileSystemProviderError(c)}}async read(r,c,l,h,d){const p=this.normalizePos(r,c);let A=null;try{const O=await f.Promises.read(r,l,h,d,p);return typeof O=="number"?A=O:A=O.bytesRead,A}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(r,p,A)}}normalizePos(r,c){return c===this.mapHandleToPos.get(r)?null:c}updatePos(r,c,l){const h=this.mapHandleToPos.get(r);typeof h=="number"&&(typeof c=="number"||(typeof l=="number"?this.mapHandleToPos.set(r,h+l):this.mapHandleToPos.delete(r)))}async write(r,c,l,h,d){return(0,L.retry)(()=>this.doWrite(r,c,l,h,d),100,3)}async doWrite(r,c,l,h,d){const p=this.normalizePos(r,c);let A=null;try{const O=await f.Promises.write(r,l,h,d,p);return typeof O=="number"?A=O:A=O.bytesWritten,A}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),O)}finally{this.updatePos(r,p,A)}}async mkdir(r){try{await f.Promises.mkdir(this.toFilePath(r))}catch(c){throw this.toFileSystemProviderError(c)}}async delete(r,c){try{const l=this.toFilePath(r);await this.doDelete(l,c)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(r,c){c.recursive?await f.Promises.rm(r,f.RimRafMode.MOVE):await f.Promises.unlink(r)}async rename(r,c,l){const h=this.toFilePath(r),d=this.toFilePath(c);if(h!==d)try{await this.validateTargetDeleted(r,c,"move",l.overwrite),await f.Promises.move(h,d)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,I.localize)(2,null,(0,y.basename)(h),(0,y.basename)((0,y.dirname)(d)),p.toString()))),this.toFileSystemProviderError(p)}}async copy(r,c,l){const h=this.toFilePath(r),d=this.toFilePath(c);if(h!==d)try{await this.validateTargetDeleted(r,c,"copy",l.overwrite),await f.Promises.copy(h,d,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,I.localize)(3,null,(0,y.basename)(h),(0,y.basename)((0,y.dirname)(d)),p.toString()))),this.toFileSystemProviderError(p)}}async validateTargetDeleted(r,c,l,h){const d=this.toFilePath(r),p=this.toFilePath(c);let A=!1;if(!!(this.capabilities&1024)||(A=(0,k.isEqual)(d,p,!0)),A&&l==="copy")throw(0,u.createFileSystemProviderError)((0,I.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!A&&await f.Promises.exists(p)){if(!h)throw(0,u.createFileSystemProviderError)((0,I.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(c,{recursive:!0,useTrash:!1})}}watch(r,c){return c.recursive?this.watchRecursive(r,c.excludes):this.watchNonRecursive(r)}watchRecursive(r,c){const l={path:this.toFilePath(r),excludes:c},h=(0,D.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,P.toDisposable)(()=>{h(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof w.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,c;this.options?.watcher?.usePolling?(r=m.FileWatcher,c=this.options?.watcher):t.default.quality==="stable"&&this.recursiveFoldersToWatch.length===1?b.isWindows?r=o.FileWatcher:r=m.FileWatcher:r=w.FileWatcher,this.recursiveWatcher=new r(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,v.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===a.LogLevel.Trace,c),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)}))}}watchNonRecursive(r){const c=new g.FileWatcher(this.toFilePath(r),h=>this._onDidChangeFile.fire((0,v.toFileChanges)(h)),h=>{h.type==="error"&&this._onDidWatchErrorOccur.fire(h.message),this.logService[h.type](h.message)},this.logService.getLevel()===a.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{c.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)});return(0,P.combinedDisposable)(c,l)}toFilePath(r){return(0,y.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof u.FileSystemProviderError)return r;let c;switch(r.code){case"ENOENT":c=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=u.FileSystemProviderErrorCode.NoPermissions;break;default:c=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(r,c)}async toFileSystemProviderWriteError(r,c){let l=this.toFileSystemProviderError(c);if(r&&l.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await f.SymlinkSupport.stat(this.toFilePath(r));h.mode&128||(l=(0,u.createFileSystemProviderError)(c,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.logService.trace(h)}return l}dispose(){super.dispose(),(0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,P.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=s}),define(Z[29],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService")}),define(Z[171],ee([0,1,6,9,2,8,19,14,29]),function(K,e,D,L,R,T,k,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends R.Disposable{constructor(C,f,I){super();this.productService=f,this.logService=I,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},30*1e3)).schedule()}async cleanUpCodeCaches(C){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),I=(0,T.dirname)(C),u=(0,T.basename)(C),E=await k.Promises.readdir(I);await Promise.all(E.map(async g=>{if(g===u)return;const w=(0,T.join)(I,g),m=await k.Promises.stat(w);if(m.isDirectory()&&f-m.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${g}.`),k.Promises.rm(w)}))}catch(f){(0,L.onUnexpectedError)(f)}}};b=de([X(1,y.IProductService),X(2,P.ILogService)],b),e.CodeCacheCleaner=b}),define(Z[172],ee([0,1,6,9,2,8,19,12,14,29]),function(K,e,D,L,R,T,k,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let i=class extends R.Disposable{constructor(f,I,u){super();this.environmentService=f,this.logService=I,this.productService=u,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),I=JSON.parse(await k.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let m of Object.keys(I)){const v=I[m];f[`${v.hash}.${m}`]=!0}const u=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await k.Promises.exists(u))return;const g=await k.Promises.readdir(u);for(const m of g){if(f[m]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${m}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${m}`),await k.Promises.rm((0,T.join)(u,m))}const w=Date.now();for(const m of Object.keys(f)){const v=(0,T.join)(u,m),o=await k.Promises.readdir(v);for(const a of o){if(a==="tcf.json")continue;const t=(0,T.join)(v,a),s=await k.Promises.stat(t);s.isDirectory()&&w-s.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(m,a)}`),await k.Promises.rm(t))}}}catch(f){(0,L.onUnexpectedError)(f)}}};i=de([X(0,P.INativeEnvironmentService),X(1,y.ILogService),X(2,b.IProductService)],i),e.LanguagePackCachedDataCleaner=i}),define(Z[33],ee([0,1,90,16]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(k,P){D.ok(L.isString(k)),D.ok(L.isObject(P)),D.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,P)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new R}),define(Z[81],ee([0,1,3,33]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,b){this.schemasById[R(y)]=b,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new T;L.Registry.add(e.Extensions.JSONContribution,k)}),define(Z[38],ee([0,1,3,16,111,81,33]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const b=k.Registry.as(T.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(m,v=!0){this.registerConfigurations([m],v)}registerConfigurations(m,v=!0){const o=[];m.forEach(a=>{o.push(...this.validateAndRegisterProperties(a,v,a.extensionInfo)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(m){const v=[],o=a=>{if(a.properties)for(const t in a.properties)v.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,a.properties[t]);a.allOf&&a.allOf.forEach(t=>o(t))};for(const a of m){o(a);const t=this.configurationContributors.indexOf(a);t!==-1&&this.configurationContributors.splice(t,1)}b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}registerDefaultConfigurations(m){const v=[],o=[];for(const a of m)for(const t in a)if(v.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...a[t]};const s={type:"object",default:this.defaultValues[t],description:R.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};o.push(f(t)),this.configurationProperties[t]=s,this.defaultLanguageConfigurationOverridesNode.properties[t]=s}else{this.defaultValues[t]=a[t];const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterDefaultConfigurations(m){const v=[];for(const o of m)for(const a in o)if(v.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const t=this.configurationProperties[a];t&&(this.updatePropertyDefaultValue(a,t),this.updateSchema(a,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const v of m)this.overrideIdentifiers.add(v);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(m,v=!0,o,a=3){a=L.isUndefinedOrNull(m.scope)?a:m.scope;let t=[],s=m.properties;if(s)for(let r in s){if(v&&E(r)){delete s[r];continue}const c=s[r];if(this.updatePropertyDefaultValue(r,c),e.OVERRIDE_PROPERTY_PATTERN.test(r)?c.scope=void 0:(c.scope=L.isUndefinedOrNull(c.scope)?a:c.scope,c.restricted=L.isUndefinedOrNull(c.restricted)?!!o?.restrictedConfigurations?.includes(r):c.restricted),s[r].hasOwnProperty("included")&&!s[r].included){this.excludedConfigurationProperties[r]=s[r],delete s[r];continue}else this.configurationProperties[r]=s[r];!s[r].deprecationMessage&&s[r].markdownDeprecationMessage&&(s[r].deprecationMessage=s[r].markdownDeprecationMessage),t.push(r)}let n=m.allOf;if(n)for(let r of n)t.push(...this.validateAndRegisterProperties(r,v,o,a));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(m){const v=o=>{let a=o.properties;if(a)for(const s in a)this.updateSchema(s,a[s]);let t=o.allOf;t&&t.forEach(v)};v(m)}updateSchema(m,v){switch(e.allSettings.properties[m]=v,v.scope){case 1:e.applicationSettings.properties[m]=v;break;case 2:e.machineSettings.properties[m]=v;break;case 6:e.machineOverridableSettings.properties[m]=v;break;case 3:e.windowSettings.properties[m]=v;break;case 4:e.resourceSettings.properties[m]=v;break;case 5:e.resourceSettings.properties[m]=v,this.resourceLanguageSettingsSchema.properties[m]=v;break}}removeFromSchema(m,v){switch(delete e.allSettings.properties[m],v.scope){case 1:delete e.applicationSettings.properties[m];break;case 2:delete e.machineSettings.properties[m];break;case 6:delete e.machineOverridableSettings.properties[m];break;case 3:delete e.windowSettings.properties[m];break;case 4:case 5:delete e.resourceSettings.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const v=`[${m}]`,o={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(v,o),e.allSettings.properties[v]=o,e.applicationSettings.properties[v]=o,e.machineSettings.properties[v]=o,e.machineOverridableSettings.properties[v]=o,e.windowSettings.properties[v]=o,e.resourceSettings.properties[v]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,v){let o=this.defaultValues[m];L.isUndefined(o)&&(o=v.default),L.isUndefined(o)&&(o=I(v.type)),v.default=o}}const C="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(C);function f(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=f;function I(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=I;const u=new i;k.Registry.add(e.Extensions.Configuration,u);function E(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?R.localize(5,null,w):u.getConfigurationProperties()[w]!==void 0?R.localize(6,null,w):null:R.localize(4,null)}e.validateProperty=E;function g(){const w=[],m=u.getConfigurationProperties();for(const v of Object.keys(m))w.push([v,m[v].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=g}),define(Z[21],ee([0,1,26,16,5,38,7,33]),function(K,e,D,L,R,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function y(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof R.URI)}e.isConfigurationOverrides=y;var b;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function C(s,n){const r=n?s?n.keys.filter(O=>s.keys.indexOf(O)===-1):[...n.keys]:[],c=s?n?s.keys.filter(O=>n.keys.indexOf(O)===-1):[...s.keys]:[],l=[];if(n&&s){for(const O of s.keys)if(n.keys.indexOf(O)!==-1){const S=w(s.contents,O),U=w(n.contents,O);D.equals(S,U)||l.push(O)}}const h=[],d=O=>{const S={};for(const U of O)for(const F of U.identifiers)S[a(F)]=U;return S},p=n?d(n.overrides):{},A=s?d(s.overrides):{};if(Object.keys(p).length)for(const O of r){const S=p[O];S&&h.push([(0,T.overrideIdentifierFromKey)(O),S.keys])}if(Object.keys(A).length)for(const O of c){const S=A[O];S&&h.push([(0,T.overrideIdentifierFromKey)(O),S.keys])}if(Object.keys(p).length&&Object.keys(A).length)for(const O of l){const S=A[O],U=p[O];if(S&&U){const F=C({contents:S.contents,keys:S.keys,overrides:[]},{contents:U.contents,keys:U.keys,overrides:[]});h.push([(0,T.overrideIdentifierFromKey)(O),[...F.added,...F.removed,...F.updated]])}}return{added:r,removed:c,updated:l,overrides:h}}e.compare=C;function f(s,n){const r=[];for(const c of Object.keys(s))if(T.OVERRIDE_PROPERTY_PATTERN.test(c)){const l={};for(const h in s[c])l[h]=s[c][h];r.push({identifiers:[(0,T.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(l),contents:I(l,n)})}return r}e.toOverrides=f;function I(s,n){const r=Object.create(null);for(let c in s)u(r,c,s[c],n);return r}e.toValuesTree=I;function u(s,n,r,c){const l=n.split("."),h=l.pop();let d=s;for(let p=0;p<l.length;p++){let A=l[p],O=d[A];switch(typeof O){case"undefined":O=d[A]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${l.slice(0,p+1).join(".")} is ${JSON.stringify(O)}`);return}d=O}if(typeof d=="object"&&d!==null)try{d[h]=r}catch(p){c(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}else c(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=u;function E(s,n){const r=n.split(".");g(s,r)}e.removeFromValueTree=E;function g(s,n){const r=n.shift();if(n.length===0){delete s[r];return}if(Object.keys(s).indexOf(r)!==-1){const c=s[r];typeof c=="object"&&!Array.isArray(c)&&(g(c,n),Object.keys(c).length===0&&delete s[r])}}function w(s,n,r){function c(d,p){let A=d;for(const O of p){if(typeof A!="object"||A===null)return;A=A[O]}return A}const l=n.split("."),h=c(s,l);return typeof h=="undefined"?r:h}e.getConfigurationValue=w;function m(s,n,r){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in s?L.isObject(s[c])&&L.isObject(n[c])?m(s[c],n[c],r):r&&(s[c]=n[c]):s[c]=n[c])})}e.merge=m;function v(){const s=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=v;function o(){const s=Object.create(null),n=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let r in n){let c=n[r].default;u(s,r,c,l=>console.error(`Conflict in default settings: ${l}`))}return s}e.getDefaultValues=o;function a(s){return`[${s}]`}e.keyFromOverrideIdentifier=a;function t(s,n,r){const c=s.inspect(n),l=s.inspect(r);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:c.defaultValue}e.getMigratedSettingValue=t}),define(Z[173],ee([0,1,18,3,34,2,40,26,16,5,21,38,33]),function(K,e,D,L,R,T,k,P,y,b,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class I{constructor(t={},s=[],n=[]){this._contents=t,this._keys=s,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const n=this.getContentsForOverrideIdentifer(s);return n?t?(0,i.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let n={};for(const r of D.distinct([...Object.keys(this.contents),...Object.keys(s)])){let c=this.contents[r],l=s[r];l&&(typeof c=="object"&&typeof l=="object"?(c=P.deepClone(c),this.mergeContents(c,l)):c=l),n[r]=c}return new I(n,this.keys,this.overrides)}merge(...t){const s=P.deepClone(this.contents),n=P.deepClone(this.overrides),r=[...this.keys];for(const c of t){this.mergeContents(s,c.contents);for(const l of c.overrides){const[h]=n.filter(d=>D.equals(d.identifiers,l.identifiers));h?this.mergeContents(h.contents,l.contents):n.push(P.deepClone(l))}for(const l of c.keys)r.indexOf(l)===-1&&r.push(l)}return new I(s,r,n)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const n of Object.keys(s)){if(n in t&&y.isObject(t[n])&&y.isObject(s[n])){this.mergeContents(t[n],s[n]);continue}t[n]=P.deepClone(s[n])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,i.addToValueTree)(this.contents,t,s,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let n=0;n<s;n++)t.indexOf(this.keys[n])===0&&(s=n);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=I;class u extends I{constructor(){const t=(0,i.getDefaultValues)(),s=(0,i.getConfigurationKeys)(),n=[];for(const r of Object.keys(t))C.OVERRIDE_PROPERTY_PATTERN.test(r)&&n.push({identifiers:[(0,C.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,i.toValuesTree)(t[r],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,s,n)}}e.DefaultConfigurationModel=u;class E{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!y.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:n,keys:r,overrides:c,restricted:l}=this.doParseRaw(t,s);this._configurationModel=new I(n,r,c),this._restrictedConfigurations=l||[]}doParseContent(t){let s={},n=null,r=[],c=[],l=[];function h(p){Array.isArray(r)?r.push(p):n!==null&&(r[n]=p)}let d={onObjectBegin:()=>{let p={};h(p),c.push(r),r=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{let p=[];h(p),c.push(r),r=p,n=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:h,onError:(p,A,O)=>{l.push({error:p,offset:A,length:O})}};if(t)try{R.visit(t,d),s=r[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return s}doParseRaw(t,s){const n=f.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,n,!0,s);t=r.raw;const c=(0,i.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),l=Object.keys(t),h=(0,i.toOverrides)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:c,keys:l,overrides:h,restricted:r.restricted}}filter(t,s,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:t,restricted:[]};const c={},l=[];for(let h in t)if(C.OVERRIDE_PROPERTY_PATTERN.test(h)&&n){const d=this.filter(t[h],s,!1,r);c[h]=d.raw,l.push(...d.restricted)}else{const d=s[h],p=d?typeof d.scope!="undefined"?d.scope:3:void 0;d?.restricted&&l.push(h),(p===void 0||r.scopes===void 0||r.scopes.includes(p))&&(r.skipRestricted&&d?.restricted||(c[h]=t[h]))}return{raw:c,restricted:l}}}e.ConfigurationModelParser=E;class g extends T.Disposable{constructor(t,s,n,r){super();this.userSettingsResource=t,this.scopes=s,this.fileService=r,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new I}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class w{constructor(t,s,n=new I,r=new I,c=new k.ResourceMap,l=new I,h=new k.ResourceMap,d=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=n,this._workspaceConfiguration=r,this._folderConfigurations=c,this._memoryConfiguration=l,this._memoryConfigurationByResource=h,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,s,n){return this.getConsolidateConfigurationModel(s,n).getValue(t)}updateValue(t,s,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new I,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,s===void 0?r.removeValue(t):r.setValue(t,s),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,n){const r=this.getConsolidateConfigurationModel(s,n),c=this.getFolderConfigurationModelForResource(s.resource,n),l=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,h=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),d=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),p=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),A=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),O=n?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,S=c?s.overrideIdentifier?c.freeze().override(s.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,U=s.overrideIdentifier?l.override(s.overrideIdentifier).getValue(t):l.getValue(t),F=r.getValue(t),z=D.distinct(D.flatten(r.overrides.map(j=>j.identifiers))).filter(j=>r.getOverrideValue(t,j)!==void 0);return{defaultValue:h,userValue:d,userLocalValue:p,userRemoteValue:A,workspaceValue:O,workspaceFolderValue:S,memoryValue:U,value:F,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:p!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:S!==void 0?{value:c?.freeze().getValue(t),override:s.overrideIdentifier?c?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:l.getValue(t),override:s.overrideIdentifier?l.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const n=s.filter(r=>C.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const c=(0,C.overrideIdentifierFromKey)(r),l=this._defaultConfiguration.getKeysForOverrideIdentifier(c),h=t.getKeysForOverrideIdentifier(c),d=[...h.filter(p=>l.indexOf(p)===-1),...l.filter(p=>h.indexOf(p)===-1),...l.filter(p=>!P.equals(this._defaultConfiguration.override(c).getValue(p),t.override(c).getValue(p)))];return[c,d]});return this.updateDefaultConfiguration(t),{keys:s,overrides:n}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:n,removed:r,overrides:c}=(0,i.compare)(this.localUserConfiguration,t),l=[...s,...n,...r];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:n,removed:r,overrides:c}=(0,i.compare)(this.remoteUserConfiguration,t);let l=[...s,...n,...r];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:n,removed:r,overrides:c}=(0,i.compare)(this.workspaceConfiguration,t);let l=[...s,...n,...r];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:c}}compareAndUpdateFolderConfiguration(t,s){const n=this.folderConfigurations.get(t),{added:r,updated:c,removed:l,overrides:h}=(0,i.compare)(n,s);let d=[...r,...c,...l];return(d.length||!n)&&this.updateFolderConfiguration(t,s),{keys:d,overrides:h}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:c,overrides:l}=(0,i.compare)(s,void 0);return{keys:[...n,...r,...c],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let n=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?n.override(t.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:t},s){let n=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const r=s.getFolder(t);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const c=this._memoryConfigurationByResource.get(t);c&&(n=n.merge(c))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(s=n.merge(r),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=n}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const n=s.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:n,overrides:r,keys:c}=this._folderConfigurations.get(s);return t.push([s,{contents:n,overrides:r,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((l,h)=>(l.set(b.URI.revive(h[0]),this.parseConfigurationModel(h[1])),l),new k.ResourceMap);return new w(s,n,new I,r,c,new I,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new I(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function m(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,s=new Map;for(const r of a)r.keys.forEach(c=>t.add(c)),r.overrides.forEach(([c,l])=>{const h=(0,k.getOrSet)(s,c,new Set);l.forEach(d=>h.add(d))});const n=[];return s.forEach((r,c)=>n.push([c,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=m;class v{constructor(t,s,n,r){this.change=t,this.previous=s,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(h=>c.add(h)),t.overrides.forEach(([,h])=>h.forEach(d=>c.add(d))),this.affectedKeys=[...c.values()];const l=new I;this.affectedKeys.forEach(h=>l.setValue(h,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const n=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!P.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let n=(0,i.toValuesTree)({[s]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(t=t[r],!t)return!1;n=n[r]}return!0}}e.ConfigurationChangeEvent=v;class o extends v{constructor(t,s,n,r){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=n,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=o}),define(Z[174],ee([0,1,6,3,2,15,21,173,38,33]),function(K,e,D,L,R,T,k,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends R.Disposable{constructor(f,I){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,I)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(b.Registry.as(y.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,I){const u=typeof f=="string"?f:void 0,E=(0,k.isConfigurationOverrides)(f)?f:(0,k.isConfigurationOverrides)(I)?I:{};return this.configuration.getValue(u,E,void 0)}updateValue(f,I,u,E){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const I=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(u,I,1)}onDidDefaultConfigurationChange(f){const I=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,f);this.trigger(u,I,6)}trigger(f,I,u){const E=new P.ConfigurationChangeEvent(f,{data:I},this.configuration);E.source=u,E.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(Z[175],ee([0,1,105,21,14]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(P,y){this.configurationService=P,this.logService=y}request(P,y){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(P,y)}async resolveProxy(P){}};T=de([X(0,L.IConfigurationService),X(1,R.ILogService)],T),e.RequestService=T}),define(Z[43],ee([0,1,25,125,38,7,33]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function P(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=P;function y(u){return u.res.statusCode===204}async function b(u){if(!P(u))throw new Error("Server returned "+u.res.statusCode);return y(u)?null:(await(0,D.streamToBuffer)(u.stream)).toString()}e.asText=b;async function i(u){if(!P(u))throw new Error("Server returned "+u.res.statusCode);if(y(u))return null;const g=(await(0,D.streamToBuffer)(u.stream)).toString();try{return JSON.parse(g)}catch(w){throw w.message+=`:
`+g,w}}e.asJson=i;function C(u){I(u)}e.updateProxyConfigurationsScope=C;let f;function I(u){const E=k.Registry.as(R.Extensions.Configuration);f&&E.deregisterConfigurations([f]),f={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},E.registerConfiguration(f)}I(2)}),define(Z[176],ee([0,1,27,17,13,43]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(y,b){this.requestService=y,this.fileService=b}async download(y,b,i=D.CancellationToken.None){if(y.scheme===L.Schemas.file||y.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(y,b);return}const C={type:"GET",url:y.toString()},f=await this.requestService.request(C,i);if(f.res.statusCode===200)await this.fileService.writeFile(b,f.stream);else{const I=await(0,T.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${I}`)}}};k=de([X(0,T.IRequestService),X(1,R.IFileService)],k),e.DownloadService=k}),define(Z[177],ee([0,1,18,27,63,2,15,139,13,14,29,43]),function(K,e,D,L,R,T,k,P,y,b,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends T.Disposable{constructor(u,E,g,w){super();this.fileService=u,this.productService=E,this.requestService=g,this.logService=w,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,R.forEach)(this.productService.configBasedExtensionTips,({value:m})=>this.allConfigBasedTips.set(m.configPath,m))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const E=[];for(const[g,w]of this.allConfigBasedTips)try{const m=await this.fileService.readFile((0,k.joinPath)(u,g)),v=new Map;(0,R.forEach)(w.recommendations,({key:a,value:t})=>{if((0,D.isNonEmptyArray)(t.remotes))for(const s of t.remotes)v.set(s,{extensionId:a,extensionName:t.name,configName:w.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else E.push({extensionId:a,extensionName:t.name,configName:w.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const o=(0,P.getDomainsOfRemotes)(m.value.toString(),[...v.keys()]);for(const a of o){const t=v.get(a);t&&E.push(t)}}catch(m){}return E}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const u=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},L.CancellationToken.None);if(u.res.statusCode!==200)return[];const E=await(0,C.asJson)(u);return E?E.workspaceRecommendations||[]:[]}catch(u){return this.logService.error(u),[]}}};f=de([X(0,y.IFileService),X(1,i.IProductService),X(2,C.IRequestService),X(3,b.ILogService)],f),e.ExtensionTipsService=f}),define(Z[46],ee([0,1,25,30]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(T,k,P){let y=P&&P.get("storage.serviceMachineId",0)||null;if(y)return y;try{const i=(await k.readFile(T.serviceMachineIdResource)).value.toString();y=(0,L.isUUID)(i)?i:null}catch(b){y=null}if(!y){y=(0,L.generateUuid)();try{await k.writeFile(T.serviceMachineIdResource,D.VSBuffer.fromString(y))}catch(b){}}return P&&P.store("storage.serviceMachineId",y,0,1),y}e.getServiceMachineId=R}),define(Z[22],ee([0,1,6,3,2,16,70,7]),function(K,e,D,L,R,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const y="__$__targetStorageMarker";e.IStorageService=(0,P.createDecorator)("storageService");var b;(function(E){E[E.NONE=0]="NONE",E[E.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(E){E[E.GLOBAL=0]="GLOBAL",E[E.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var C;(function(E){E[E.USER=0]="USER",E[E.MACHINE=1]="MACHINE"})(C=e.StorageTarget||(e.StorageTarget={}));class f extends R.Disposable{constructor(g={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,w){w===y?(g===0?this._globalKeyTargets=void 0:g===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:g})):this._onDidChangeValue.fire({scope:g,key:w,target:this.getKeyTargets(g)[w]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,w,m){return this.getStorage(w)?.get(g,m)}getBoolean(g,w,m){return this.getStorage(w)?.getBoolean(g,m)}getNumber(g,w,m){return this.getStorage(w)?.getNumber(g,m)}store(g,w,m,v){if((0,T.isUndefinedOrNull)(w)){this.remove(g,m);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,m,v),this.getStorage(m)?.set(g,w)})}remove(g,w){this.withPausedEmitters(()=>{this.updateKeyTarget(g,w,void 0),this.getStorage(w)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,w){const m=[],v=this.getKeyTargets(g);for(const o of Object.keys(v))v[o]===w&&m.push(o);return m}updateKeyTarget(g,w,m){const v=this.getKeyTargets(w);typeof m=="number"?v[g]!==m&&(v[g]=m,this.getStorage(w)?.set(y,JSON.stringify(v))):typeof v[g]=="number"&&(delete v[g],this.getStorage(w)?.set(y,JSON.stringify(v)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(g){return g===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(g){const w=this.get(y,g);if(w)try{return JSON.parse(w)}catch(m){}return Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=b.NONE){this._onWillSaveState.fire({reason:g}),await D.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const g=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return u(g,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;class I extends f{constructor(){super();this.globalStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.globalStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g)))}getStorage(g){return g===0?this.globalStorage:this.workspaceStorage}getLogDetails(g){return g===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(g){}}e.InMemoryStorageService=I;async function u(E,g,w,m){const v=c=>{try{return JSON.parse(c)}catch(l){return c}},o=new Map,a=new Map;E.forEach((c,l)=>{o.set(l,c),a.set(l,v(c))});const t=new Map,s=new Map;g.forEach((c,l)=>{t.set(l,c),s.set(l,v(c))}),console.group(`Storage: Global (path: ${w})`);let n=[];o.forEach((c,l)=>{n.push({key:l,value:c})}),console.table(n),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${m})`);let r=[];t.forEach((c,l)=>{r.push({key:l,value:c})}),console.table(r),console.groupEnd(),console.log(s)}e.logStorage=u}),define(Z[178],ee([0,1,3,2,16,28,32,22]),function(K,e,D,L,R,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let y=class extends L.Disposable{constructor(C){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(C)),this._register(this.storageManger.onDidChange(f=>this._onDidChangeEnablement.fire({extensions:f,source:"storage"})))}async enableExtension(C,f){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:f}),!0):!1}async disableExtension(C,f){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){let f=this.getDisabledExtensions();return f.every(I=>!(0,k.areSameExtensions)(I,C))?(f.push(C),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(C){let f=this.getDisabledExtensions();for(let I=0;I<f.length;I++){const u=f[I];if((0,k.areSameExtensions)(u,C))return f.splice(I,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(C){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,f){this.storageManger.set(C,f,0)}};y=de([X(0,P.IStorageService)],y),e.GlobalExtensionEnablementService=y;class b extends L.Disposable{constructor(C){super();this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(C,f){let I;return f===0?((0,R.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,f)),I=this.storage[C]):I=this._get(C,f),JSON.parse(I)}set(C,f,I){let u=JSON.stringify(f.map(({id:g,uuid:w})=>({id:g,uuid:w})));this._get(C,I)!==u&&(I===0&&(f.length?this.storage[C]=u:delete this.storage[C]),this._set(C,f.length?u:void 0,I))}onDidStorageChange(C){if(C.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const I=this.get(C.key,C.scope);delete this.storage[C.key];const u=this.get(C.key,C.scope),E=I.filter(w=>!u.some(m=>(0,k.areSameExtensions)(w,m))),g=u.filter(w=>!I.some(m=>(0,k.areSameExtensions)(m,w)));(E.length||g.length)&&this._onDidChange.fire([...E,...g])}}_get(C,f){return this.storageService.get(C,f,"[]")}_set(C,f,I){f?this.storageService.store(C,f,I,1):this.storageService.remove(C,I)}}e.StorageManager=b}),define(Z[179],ee([0,1,3,2]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class R extends L.Disposable{constructor(b,i){super();this.channel=b,this.workspace=i}async getItems(){const b={workspace:this.workspace},i=await this.channel.call("getItems",b);return new Map(i)}updateItems(b){const i={workspace:this.workspace};return b.insert&&(i.insert=Array.from(b.insert.entries())),b.delete&&(i.delete=Array.from(b.delete.values())),this.channel.call("updateItems",i)}}class T extends R{constructor(b){super(b,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(b=>this.onDidChangeGlobalStorage(b)))}onDidChangeGlobalStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}async close(){this.dispose()}}class k extends R{constructor(b,i){super(b,i);this.onDidChangeItemsExternal=D.Event.None}async close(){const b={workspace:this.workspace};return this.channel.call("close",b)}}class P extends L.Disposable{constructor(b,i){super();this.channel=b,this.workspace=i,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new k(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(Z[180],ee([0,1,6,2,169,15,70,22,179]),function(K,e,D,L,R,T,k,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends P.AbstractStorageService{constructor(C,f,I){super();this.mainProcessService=f,this.environmentService=I,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new L.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(C)}createGlobalStorage(){const C=new y.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),f=new k.Storage(C.globalStorage);return this._register(f.onDidChangeStorage(I=>this.emitDidChangeValue(0,I))),f}createWorkspaceStorage(C){const f=new y.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),C);if(f.workspaceStorage){const I=new k.Storage(f.workspaceStorage);return this.workspaceStorageDisposable.value=I.onDidChangeStorage(u=>this.emitDidChangeValue(1,u)),this.workspaceStorageId=C?.id,I}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,R.mark)("code/willInitStorage");try{await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,R.mark)("code/didInitStorage")}}getStorage(C){return C===0?this.globalStorage:this.workspaceStorage}getLogDetails(C){return C===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(P.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(C){const f=this.workspaceStorage,I=f?.items??new Map;f&&(await f.close(),f.dispose()),this.workspaceStorage=this.createWorkspaceStorage(C),await this.workspaceStorage.init();for(const[u,E]of I)this.workspaceStorage.set(u,E)}}e.NativeStorageService=b}),define(Z[181],ee([0,1,4,31,5,30]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(b){if(D.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function P(b,i,C,f,I,u,E,g,w,m){const v=Object.create(null);v["common.machineId"]=E,v.sessionID=(0,T.generateUuid)()+Date.now(),v.commitHash=I,v.version=u,v["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,D.PlatformToString)(D.platform),v["common.nodePlatform"]=L.platform,v["common.nodeArch"]=f,v["common.product"]=m||"desktop";const o=y(g||[]);o&&(v["common.msftInternal"]=o);let a=0;const t=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),D.isLinuxSnap&&(v["common.snap"]="true");const s=k(C);s&&(v["common.platformDetail"]=s);try{const n=await b.readFile(R.URI.file(w));v["common.source"]=n.value.toString().slice(0,30)}catch(n){}return v}e.resolveCommonProperties=P;function y(b){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const C=i.toLowerCase();return b.some(f=>C===f)}e.verifyMicrosoftInternalDomain=y}),define(Z[20],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(T){T[T.NONE=0]="NONE",T[T.LOG=1]="LOG",T[T.USER=2]="USER"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(T){T.OFF="off",T.ERROR="error",T.ON="on"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[182],ee([0,1,35,55,34,17,8,4,5,98,19,100,73,13,29,20]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function g(a,t){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],n=new Map,r=new Map,c=2e4;function l(p,A,O,S){const U=A.substring(p.length+1);return new Promise(async F=>{let z;try{z=await i.Promises.readdir(A,{withFileTypes:!0})}catch(W){F();return}if(S.count>=c){S.count+=z.length,S.maxReached=!0,F();return}let j=z.length;if(j===0){F();return}let M=z;S.count+z.length>c&&(S.maxReached=!0,j=c-S.count,M=z.slice(0,j)),S.count+=z.length;for(const W of M)if(W.isDirectory()){if(O.includes(W.name)||await l(p,(0,k.join)(A,W.name),O,S),--j==0){F();return}}else{const x=W.name.lastIndexOf(".");if(x>=0){const $=W.name.substring(x+1);$&&n.set($,(n.get($)??0)+1)}for(const $ of s)$.relativePathPattern?.test(U)!==!1&&$.filePattern.test(W.name)&&r.set($.tag,(r.get($.tag)??0)+1);if(--j==0){F();return}}})}const h={count:0,maxReached:!1};await l(a,a,t,h);const d=await v(a);return{configFiles:w(r),fileTypes:w(n),fileCount:h.count,maxFilesReached:h.maxReached,launchConfigFiles:d}}e.collectWorkspaceStats=g;function w(a){return[...L.Iterable.map(a.entries(),([t,s])=>({name:t,count:s}))].sort((t,s)=>s.count-t.count)}function m(){const a={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/I.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/I.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.virtualMachineHint.value()*100)}%`},t=D.cpus();return t&&t.length>0&&(a.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),a}e.getMachineInfo=m;async function v(a){try{const t=new Map,s=(0,k.join)(a,".vscode","launch.json"),n=await i.Promises.readFile(s),r=[],c=(0,R.parse)(n.toString(),r);if(r.length)return console.log(`Unable to parse ${s}`),[];if((0,R.getNodeType)(c)==="object"&&c.configurations)for(const l of c.configurations){const h=l.type;h&&(t.has(h)?t.set(h,t.get(h)+1):t.set(h,1))}return w(t)}catch(t){return[]}}e.collectLaunchConfigs=v;let o=class{constructor(t,s){this.telemetryService=t,this.productService=s}formatMachineInfo(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}formatEnvironment(t){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const n=D.cpus();return n&&n.length>0&&s.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),s.push(`Memory (System):  ${(D.totalmem()/I.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/I.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||s.push(`Load (avg):       ${D.loadavg().map(r=>Math.round(r)).join(", ")}`),s.push(`VM:               ${Math.round(b.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,C.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async n=>{let[r,c]=n,l=this.formatProcessList(t,r);return s.forEach(h=>{if((0,f.isRemoteDiagnosticError)(h))l+=`
${h.errorMessage}`,c+=`
${h.errorMessage}`;else if(l+=`

Remote: ${h.hostName}`,h.processes&&(l+=`
${this.formatProcessList(t,h.processes)}`),h.workspaceMetadata){c+=`
|  Remote: ${h.hostName}`;for(const d of Object.keys(h.workspaceMetadata)){const p=h.workspaceMetadata[d];let A=`${p.fileCount} files`;p.maxFilesReached&&(A=`more than ${A}`),c+=`|    Folder (${d}): ${A}`,c+=this.formatWorkspaceStats(p)}}}),{processInfo:l,workspaceInfo:c}})}async getSystemInfo(t,s){const{memory:n,vmHint:r,os:c,cpus:l}=m(),h={os:c,memory:n,cpus:l,vmHint:r,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return P.isWindows||(h.load=`${D.loadavg().map(d=>Math.round(d)).join(", ")}`),P.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(t,s){const n=[];return(0,C.listProcesses)(t.mainPID).then(async r=>(n.push(""),n.push(this.formatEnvironment(t)),n.push(""),n.push(this.formatProcessList(t,r)),t.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(t))),s.forEach(c=>{if((0,f.isRemoteDiagnosticError)(c))n.push(`
${c.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${c.hostName}`),n.push(this.formatMachineInfo(c.machineInfo)),c.processes&&n.push(this.formatProcessList(t,c.processes)),c.workspaceMetadata)for(const l of Object.keys(c.workspaceMetadata)){const h=c.workspaceMetadata[l];let d=`${h.fileCount} files`;h.maxFilesReached&&(d=`more than ${d}`),n.push(`Folder (${l}): ${d}`),n.push(this.formatWorkspaceStats(h))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(t){const s=[],n=60;let r=0;const c=(p,A)=>{const O=` ${p}(${A})`;r+O.length>n?(s.push(l),l="|                 ",r=l.length):r+=O.length,l+=O};let l="|      File types:";const h=10;let d=t.fileTypes.length>h?h:t.fileTypes.length;for(let p=0;p<d;p++){const A=t.fileTypes[p];c(A.name,A.count)}if(s.push(l),t.configFiles.length>=0&&(l="|      Conf files:",r=0,t.configFiles.forEach(p=>{c(p.name,p.count)}),s.push(l)),t.launchConfigFiles.length>0){let p="|      Launch Configs:";t.launchConfigFiles.forEach(A=>{p+=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`}),s.push(p)}return s.join(`
`)}expandGPUFeatures(t){const s=Math.max(...Object.keys(t).map(n=>n.length));return Object.keys(t).map(n=>`${n}:  ${" ".repeat(s-n.length)}  ${t[n]}`).join(`
                  `)}formatWorkspaceMetadata(t){const s=[],n=[];return t.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(s.push(`|  Window (${r.title})`),r.folderURIs.forEach(c=>{const l=y.URI.revive(c);if(l.scheme===T.Schemas.file){const h=l.fsPath;n.push(g(h,["node_modules",".git"]).then(d=>{let p=`${d.fileCount} files`;d.maxFilesReached&&(p=`more than ${p}`),s.push(`|    Folder (${(0,k.basename)(h)}): ${p}`),s.push(this.formatWorkspaceStats(d))}).catch(d=>{s.push(`|      Error: Unable to collect workspace stats for folder ${h} (${d.toString()})`)}))}else s.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(r=>s.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(t,s){const n=new Map;t.windows.forEach(c=>n.set(c.pid,c.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(t.mainPID,n,r,s,0),r.join(`
`)}formatProcessItem(t,s,n,r,c){const l=c===0;let h;l?h=r.pid===t?`${this.productService.applicationName} main`:"remote agent":(h=`${"  ".repeat(c)} ${r.name}`,r.name==="window"&&(h=`${h} (${s.get(r.pid)})`));const d=process.platform==="win32"?r.mem:D.totalmem()*(r.mem/100);n.push(`${r.load.toFixed(0).padStart(5," ")}	${(d/I.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(r.children)&&r.children.forEach(p=>this.formatProcessItem(t,s,n,p,c+1))}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const n=y.URI.revive(s);if(n.scheme!==T.Schemas.file)continue;const r=n.fsPath;try{const c=await g(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),c.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),c.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),c.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};o=de([X(0,E.ITelemetryService),X(1,u.IProductService)],o),e.DiagnosticsService=o}),define(Z[183],ee([0,1,18,6,27,9,3,2,4,5,114,28,32,14,42,20]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let g=class extends P.Disposable{constructor(a,t,s){super();this.galleryService=a,this.telemetryService=t,this.logService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const t=await this.getTargetPlatform();return a.allTargetPlatforms.some(s=>(0,C.isTargetPlatformCompatible)(s,a.allTargetPlatforms,t))}async installFromGallery(a,t={}){if(!this.galleryService.isEnabled())throw new Error(i.localize(0,null));if(!await this.canInstall(a)){const n=await this.getTargetPlatform(),r=new C.ExtensionManagementError(i.localize(1,null,a.identifier.id,u.default.nameLong,(0,C.TargetPlatformToString)(n)),e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",a.identifier.id,r.message),m(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(a),void 0,r),r}try{a=await this.checkAndGetCompatibleVersion(a,!t.installGivenVersion)}catch(n){throw this.logService.error((0,T.getErrorMessage)(n)),m(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(a),void 0,n),n}const s=await this.galleryService.getManifest(a,R.CancellationToken.None);if(s===null){const n=new C.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",a.identifier.id,n.message),m(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(a),void 0,n),n}if(s.version!==a.version){const n=new C.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error(n.message),m(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(a),void 0,n),n}return this.installExtension(s,a,t)}async uninstall(a,t={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,t)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(i.localize(2,null));const t=await this.findGalleryExtension(a);if(!t)throw new Error(i.localize(3,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsReport(){const a=new Date().getTime();return(!this.reportedExtensions||a-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=a),this.reportedExtensions}registerParticipant(a){this.participants.push(a)}async installExtension(a,t,s){if(!b.URI.isUri(t)){let h=this.installingExtensions.get(new f.ExtensionIdentifierWithVersion(t.identifier,t.version).key());if(h)return this.logService.info("Extensions is already requested to install",t.identifier.id),h.waitUntilTaskIsFinished();s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],r=[],c=this.createInstallExtensionTask(a,t,s);b.URI.isUri(t)||this.installingExtensions.set(new f.ExtensionIdentifierWithVersion(c.identifier,a.version).key(),c),this._onInstallExtension.fire({identifier:c.identifier,source:t}),this.logService.info("Installing extension:",c.identifier.id),n.push({task:c,manifest:a});let l=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",c.identifier.id);else try{const d=await this.getAllDepsAndPackExtensionsToInstall(c.identifier,a,!!s.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:p,manifest:A}of d)if(l=l||!!A.extensionDependencies?.some(O=>(0,f.areSameExtensions)({id:O},c.identifier)),this.installingExtensions.has(new f.ExtensionIdentifierWithVersion(p.identifier,p.version).key()))this.logService.info("Extension is already requested to install",p.identifier.id);else{const O=this.createInstallExtensionTask(A,p,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new f.ExtensionIdentifierWithVersion(O.identifier,A.version).key(),O),this._onInstallExtension.fire({identifier:O.identifier,source:p}),this.logService.info("Installing extension:",O.identifier.id),n.push({task:O,manifest:A})}}catch(d){if(b.URI.isUri(c.source))(0,D.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",c.identifier.id,d.message),(0,D.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",c.identifier.id,d.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",c.identifier.id),this.logService.error(d),d}const h=n.reduce((d,{task:p,manifest:A})=>(d.set(p.identifier.id.toLowerCase(),{task:p,manifest:A}),d),new Map);for(;h.size;){let d;const p=[...h.values()].filter(({manifest:A})=>!A.extensionDependencies?.some(O=>h.has(O.toLowerCase())));p.length?d=h.size===1?p:p.filter(({task:A})=>!(A===c&&!l)):(this.logService.info("Found extensions with circular dependencies",p.map(({task:A})=>A.identifier.id)),d=[...h.values()]),await this.joinAllSettled(d.map(async({task:A})=>{const O=new Date().getTime();try{const S=await A.run();if(await this.joinAllSettled(this.participants.map(U=>U.postInstall(S,A.source,s,R.CancellationToken.None))),!b.URI.isUri(A.source)&&(m(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-O,void 0),y.isWeb&&A.operation===1))try{await this.galleryService.reportStatistic(S.manifest.publisher,S.manifest.name,S.manifest.version,"install")}catch(U){}r.push({local:S,identifier:A.identifier,operation:A.operation,source:A.source})}catch(S){throw b.URI.isUri(A.source)||m(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-O,S),this.logService.error("Error while installing the extension:",A.identifier.id),this.logService.error(S),S}finally{h.delete(A.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:d})=>this.logService.info("Extension installed successfully:",d.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:d})=>(0,f.areSameExtensions)(d,c.identifier))[0].local}catch(h){if(n.forEach(({task:d})=>d.cancel()),r.length)try{const d=await Promise.allSettled(r.map(({local:p})=>this.createUninstallExtensionTask(p,{versionOnly:!0}).run()));for(let p=0;p<d.length;p++){const A=d[p],{identifier:O}=r[p];A.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",O.id):this.logService.warn("Rollback: Error while uninstalling extension",O.id,(0,T.getErrorMessage)(A.reason))}}catch(d){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(d),r.map(({identifier:p})=>p.id))}throw this.logService.error("Failed to install extension:",c.identifier.id,(0,T.getErrorMessage)(h)),this._onDidInstallExtensions.fire(n.map(({task:d})=>({identifier:d.identifier,operation:1,source:d.source}))),h instanceof Error&&(h.name=h&&h.code?h.code:e.ERROR_UNKNOWN),h}finally{for(const{task:h,manifest:d}of n)if(!b.URI.isUri(h.source)){const p=new f.ExtensionIdentifierWithVersion(h.identifier,d.version).key();this.installingExtensions.delete(p)||this.logService.warn("Installation task is not found in the cache",p)}}}async joinAllSettled(a){const t=[],s=[],n=await Promise.allSettled(a);for(const r of n)r.status==="fulfilled"?t.push(r.value):s.push(r.reason);if(s.length)throw w(s);return t}async getAllDepsAndPackExtensionsToInstall(a,t,s){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const r=[a,...n.map(h=>h.identifier)],c=[],l=async(h,d)=>{const p=d.extensionDependencies||[],A=[...p];if(d.extensionPack){const O=s?n.find(S=>(0,f.areSameExtensions)(S.identifier,h)):void 0;for(const S of d.extensionPack)O&&O.manifest.extensionPack&&O.manifest.extensionPack.some(U=>(0,f.areSameExtensions)({id:U},{id:S}))||A.every(U=>!(0,f.areSameExtensions)({id:U},{id:S}))&&A.push(S)}if(A.length){const O=[...r,...c.map(U=>U.gallery.identifier)],S=A.filter(U=>O.every(F=>!(0,f.areSameExtensions)(F,{id:U})));if(S.length){const U=await this.galleryService.query({names:S,pageSize:A.length},R.CancellationToken.None);for(const F of U.firstPage){if(O.find(W=>(0,f.areSameExtensions)(W,F.identifier)))continue;if(!p.some(W=>(0,f.areSameExtensions)({id:W},F.identifier))&&!await this.canInstall(F)){this.logService.info("Skipping the packed extension as it cannot be installed",F.identifier.id);continue}const j=await this.checkAndGetCompatibleVersion(F,!0),M=await this.galleryService.getManifest(j,R.CancellationToken.None);if(M===null)throw new C.ExtensionManagementError(`Missing manifest for extension ${j.identifier.id}`,e.INSTALL_ERROR_VALIDATING);c.push({gallery:j,manifest:M}),await l(j.identifier,M)}}}};return await l(a,t),n=await this.getInstalled(),c.filter(h=>!n.some(d=>(0,f.areSameExtensions)(d.identifier,h.gallery.identifier)))}async checkAndGetCompatibleVersion(a,t){if(await this.isMalicious(a))throw new C.ExtensionManagementError(i.localize(4,null,a.identifier.id),C.INSTALL_ERROR_MALICIOUS);const s=await this.getTargetPlatform();let n=null;if(await this.galleryService.isExtensionCompatible(a,s)&&(n=a),!n&&t&&(n=await this.galleryService.getCompatibleExtension(a,s)),!n)throw new C.ExtensionManagementError(i.localize(5,null,a.identifier.id,u.default.version),C.INSTALL_ERROR_INCOMPATIBLE);return n}async isMalicious(a){const t=await this.getExtensionsReport();return(0,f.getMaliciousExtensionsSet)(t).has(a.identifier.id)}async unininstallExtension(a,t){const s=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(s)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),s.waitUntilTaskIsFinished();const n=(h,d)=>{const p=this.createUninstallExtensionTask(h,d);return this.uninstallingExtensions.set(p.extension.identifier.id.toLowerCase(),p),this.logService.info("Uninstalling extension:",h.identifier.id),this._onUninstallExtension.fire(h.identifier),p},r=(h,d)=>{d?this.logService.error("Failed to uninstall extension:",h.identifier.id,d.message):this.logService.info("Successfully uninstalled extension:",h.identifier.id),m(this.telemetryService,"extensionGallery:uninstall",(0,f.getLocalExtensionTelemetryData)(h),void 0,d),this._onDidUninstallExtension.fire({identifier:h.identifier,error:d?.code})},c=[],l=[];try{c.push(n(a,{}));const h=await this.getInstalled(1);if(t.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const d=this.getAllPackExtensionsToUninstall(a,h);for(const p of d)this.uninstallingExtensions.has(p.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",p.identifier.id):c.push(n(p,{}))}t.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(c.map(d=>d.extension),h,a),await this.joinAllSettled(c.map(async d=>{try{if(await d.run(),await this.joinAllSettled(this.participants.map(p=>p.postUninstall(d.extension,t,R.CancellationToken.None))),d.extension.identifier.uuid)try{await this.galleryService.reportStatistic(d.extension.manifest.publisher,d.extension.manifest.name,d.extension.manifest.version,"uninstall")}catch(p){}r(d.extension)}catch(p){const A=p instanceof C.ExtensionManagementError?p:new C.ExtensionManagementError((0,T.getErrorMessage)(p),e.ERROR_UNKNOWN);throw r(d.extension,A),A}finally{l.push(d)}}))}catch(h){const d=h instanceof C.ExtensionManagementError?h:new C.ExtensionManagementError((0,T.getErrorMessage)(h),e.ERROR_UNKNOWN);for(const p of c){try{p.cancel()}catch(A){}l.includes(p)||r(p.extension,d)}throw d}finally{for(const h of c)this.uninstallingExtensions.delete(h.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",h.extension.identifier.id)}}checkForDependents(a,t,s){for(const n of a){const r=this.getDependents(n,t);if(r.length){const c=r.filter(l=>!a.some(h=>(0,f.areSameExtensions)(h.identifier,l.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(n,c,s))}}}getDependentsErrorMessage(a,t,s){return s===a?t.length===1?i.localize(6,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(7,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(8,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):t.length===1?i.localize(9,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(10,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(11,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}getAllPackExtensionsToUninstall(a,t,s=[]){if(s.indexOf(a)!==-1)return[];s.push(a);const n=a.manifest.extensionPack?a.manifest.extensionPack:[];if(n.length){const r=t.filter(l=>!l.isBuiltin&&n.some(h=>(0,f.areSameExtensions)({id:h},l.identifier))),c=[];for(const l of r)c.push(...this.getAllPackExtensionsToUninstall(l,t,s));return[...r,...c]}return[]}getDependents(a,t){return t.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(n=>(0,f.areSameExtensions)({id:n},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const t=await this.findGalleryExtensionById(a.identifier.uuid);return t||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},R.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},R.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${a.length} reported extensions from service`),a}catch(a){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};g=de([X(0,C.IExtensionGalleryService),X(1,E.ITelemetryService),X(2,I.ILogService)],g),e.AbstractExtensionManagementService=g;function w(o){const a=Array.isArray(o)?o:[o];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((t,s)=>new Error(`${t.message}${t.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=w;function m(o,a,t,s,n){const r=n?n instanceof C.ExtensionManagementError?n.code:e.ERROR_UNKNOWN:void 0;o.publicLogError(a,{...t,success:!n,duration:s,errorcode:r})}e.reportTelemetry=m;class v{constructor(){this.barrier=new L.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(a=>new Promise((t,s)=>{const n=a.onCancellationRequested(()=>{n.dispose(),s((0,T.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=v}),define(Z[184],ee([0,1,18,6,63,3,8,4,31,5,116,12,28,177,75,13,14,59,29,43,22,20]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I,u,E,g,w,m,v,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let n=class extends I.ExtensionTipsService{constructor(c,l,h,d,p,A,O,S,U,F){super(O,S,U,F);this.environmentService=c,this.telemetryService=l,this.extensionManagementService=h,this.storageService=d,this.nativeHostService=p,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,S.exeBasedExtensionTips&&(0,R.forEach)(S.exeBasedExtensionTips,({key:z,value:j})=>{const M=[],W=[],x=[];(0,R.forEach)(j.recommendations,({key:$,value:q})=>{q.important?j.important?M.push({extensionId:$,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):W.push({extensionId:$,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):x.push({extensionId:$,extensionName:q.name,isExtensionPack:!!q.isExtensionPack})}),M.length&&this.highImportanceExecutableTips.set(z,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:M}),W.length&&this.mediumImportanceExecutableTips.set(z,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:W}),x.length&&this.allOtherExecutableTips.set(z,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:x})}),(0,L.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const c=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...c,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const c=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),h=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(c,h),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,h)}groupImportantTipsByExe(c,l){const h=new Map;c.forEach(S=>h.set(S.extensionId.toLowerCase(),S));const{installed:d,uninstalled:p}=this.groupByInstalled([...h.keys()],l);for(const S of d){const U=h.get(S);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:S,exeName:U.exeName})}for(const S of p){const U=h.get(S);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:S,exeName:U.exeName})}const A=this.getPromptedExecutableTips(),O=new Map;for(const S of p){const U=h.get(S);if(U&&(!A[U.exeName]||!A[U.exeName].includes(U.extensionId))){let F=O.get(U.exeName);F||(F=[],O.set(U.exeName,F)),F.push(U)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[c,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(h=>{switch(h){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(c);break;case"incompatibleWindow":const d=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const p=this._register((0,L.disposableTimeout)(()=>{p.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const c=this.getLastPromptedMediumExeTime(),l=Date.now()-c,h=7*24*60*60*1e3;if(l<h){const A=this._register((0,L.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},h-l));return}const[d,p]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(p).then(A=>{switch(A){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(p[0].exeName,p);const O=this._register((0,L.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},h));break;case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const S=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(S(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const U=this._register((0,L.disposableTimeout)(()=>{U.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(c){const l=c.map(({extensionId:d})=>d.toLowerCase()),h=(0,i.localize)(0,null,c[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,h,`@exe:"${c[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let c=this.storageService.getNumber(s,0);return c||(c=Date.now(),this.updateLastPromptedMediumExeTime(c)),c}updateLastPromptedMediumExeTime(c){this.storageService.store(s,c,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(c,l){const h=this.getPromptedExecutableTips();h[c]=l.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(t,JSON.stringify(h),0,0)}groupByInstalled(c,l){const h=[],d=[],p=l.reduce((A,O)=>(A.add(O.identifier.id.toLowerCase()),A),new Set);return c.forEach(A=>{p.has(A.toLowerCase())?h.push(A):d.push(A)}),{installed:h,uninstalled:d}}async getValidExecutableBasedExtensionTips(c){const l=[],h=new Map;for(const d of c.keys()){const p=c.get(d);if(!p||!(0,D.isNonEmptyArray)(p.recommendations))continue;const A=[];P.isWindows?p.windowsPath&&A.push(p.windowsPath.replace("%USERPROFILE%",y.env.USERPROFILE).replace("%ProgramFiles(x86)%",y.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",y.env.ProgramFiles).replace("%APPDATA%",y.env.APPDATA).replace("%WINDIR%",y.env.WINDIR)):(A.push((0,k.join)("/usr/local/bin",d)),A.push((0,k.join)("/usr/bin",d)),A.push((0,k.join)(this.environmentService.userHome.fsPath,d)));for(const O of A){let S=h.get(O);if(S===void 0&&(S=await this.fileService.exists(b.URI.file(O)),h.set(O,S)),S)for(const{extensionId:U,extensionName:F,isExtensionPack:z}of p.recommendations)l.push({extensionId:U,extensionName:F,isExtensionPack:z,exeName:d,exeFriendlyName:p.exeFriendlyName,windowsPath:p.windowsPath})}}return l}};n=de([X(0,C.INativeEnvironmentService),X(1,a.ITelemetryService),X(2,f.IExtensionManagementService),X(3,o.IStorageService),X(4,w.INativeHostService),X(5,u.IExtensionRecommendationNotificationService),X(6,E.IFileService),X(7,m.IProductService),X(8,v.IRequestService),X(9,g.ILogService)],n),e.ExtensionTipsService=n}),define(Z[82],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(T){this.appender=T}listen(T,k){throw new Error(`Event not found: ${k}`)}call(T,k,{eventName:P,data:y}){return this.appender.log(P,y),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class L{constructor(T){this.channel=T}log(T,k){return this.channel.call("log",{eventName:T,data:k}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[44],ee([0,1,6,26,16,21,20]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryConfiguration=e.getTelemetryLevel=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(w,m){return Promise.resolve(void 0)}publicLog2(w,m){return this.publicLog(w,m)}publicLogError(w,m){return Promise.resolve(void 0)}publicLogError2(w,m){return this.publicLogError(w,m)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class P{async publicLog(m,v,o){}async publicLogError(m,v,o){}}e.NullEndpointTelemetryService=P;function y(...w){return{log:(m,v)=>w.forEach(o=>o.log(m,v)),flush:()=>D.Promises.settled(w.map(m=>m.flush()))}}e.combinedAppender=y,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(w,m){return m.onDidChangeConfiguration(v=>{v.source!==6&&w.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(v.source),configurationKeys:E(v.sourceConfig)})})}e.configurationTelemetry=b;function i(w,m){return m.disableTelemetry||!w.enableTelemetry?0:m.isBuilt?2:1}e.getTelemetryLevel=i;function C(w){const m=w.getValue(k.TELEMETRY_SETTING_ID),v=w.getValue(k.TELEMETRY_OLD_SETTING_ID);return v!==void 0&&v===!1?"off":m??"on"}e.getTelemetryConfiguration=C;function f(w){const m=Object.create(null),v=Object.create(null),o=Object.create(null);u(w,o);for(let a in o){a=a.length>150?a.substr(a.length-149):a;const t=o[a];typeof t=="number"?v[a]=t:typeof t=="boolean"?v[a]=t?1:0:typeof t=="string"?m[a]=t.substring(0,1023):typeof t!="undefined"&&t!==null&&(m[a]=t)}return{properties:m,measurements:v}}e.validateTelemetryData=f;function I(w){if(!w)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(o=>{w.indexOf(`${o}+`)===0&&(m=o)}),m}e.cleanRemoteAuthority=I;function u(w,m,v=0,o){if(!!w)for(let a of Object.getOwnPropertyNames(w)){const t=w[a],s=o?o+a:a;Array.isArray(t)?m[s]=(0,L.safeStringify)(t):t instanceof Date?m[s]=t.toISOString():(0,R.isObject)(t)?v<2?u(t,m,v+1,s+"."):m[s]=(0,L.safeStringify)(t):m[s]=t}}function E(w){if(!w)return[];const m=[];return g(m,"",w),m}function g(w,m,v){v&&typeof v=="object"&&!Array.isArray(v)?Object.keys(v).forEach(o=>g(w,m?`${m}.${o}`:o,v[o])):w.push(m)}}),define(Z[185],ee([0,1,18,27,9,26,4,31,5,21,12,28,32,72,13,14,29,43,46,22,20,44]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I,u,E,g,w,m,v,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=k.isWeb?"web":(0,C.getTargetPlatform)(k.platform,P.arch);var s;(function(J){J[J.None=0]="None",J[J.IncludeVersions=1]="IncludeVersions",J[J.IncludeFiles=2]="IncludeFiles",J[J.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",J[J.IncludeSharedAccounts=8]="IncludeSharedAccounts",J[J.IncludeVersionProperties=16]="IncludeVersionProperties",J[J.ExcludeNonValidated=32]="ExcludeNonValidated",J[J.IncludeInstallationTargets=64]="IncludeInstallationTargets",J[J.IncludeAssetUri=128]="IncludeAssetUri",J[J.IncludeStatistics=256]="IncludeStatistics",J[J.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",J[J.Unpublished=4096]="Unpublished"})(s||(s={}));function n(...J){return String(J.reduce((H,re)=>H|re,0))}var r;(function(J){J[J.Tag=1]="Tag",J[J.ExtensionId=4]="ExtensionId",J[J.Category=5]="Category",J[J.ExtensionName=7]="ExtensionName",J[J.Target=8]="Target",J[J.Featured=9]="Featured",J[J.SearchText=10]="SearchText",J[J.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const c={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},d={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class p{constructor(H=d){this.state=H}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(H,re=this.state.pageSize){return new p({...this.state,pageNumber:H,pageSize:re})}withFilter(H,...re){const ie=[...this.state.criteria,...re.length?re.map(ce=>({filterType:H,value:ce})):[{filterType:H}]];return new p({...this.state,criteria:ie})}withSortBy(H){return new p({...this.state,sortBy:H})}withSortOrder(H){return new p({...this.state,sortOrder:H})}withFlags(...H){return new p({...this.state,flags:H.reduce((re,ie)=>re|ie,0)})}withAssetTypes(...H){return new p({...this.state,assetTypes:H})}get raw(){const{criteria:H,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:ue,flags:ye,assetTypes:ge}=this.state;return{filters:[{criteria:H,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:ue}],assetTypes:ge,flags:ye}}get searchText(){const H=this.state.criteria.filter(re=>re.filterType===r.SearchText)[0];return H&&H.value?H.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(H=>String(H.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(J,H){const re=(J||[]).filter(ie=>ie.statisticName===H)[0];return re?re.value:0}function O(J){const H="Microsoft.VisualStudio.Code.Translation.";return J.files.filter(ie=>ie.assetType.indexOf(H)===0).reduce((ie,ce)=>{const ue=z(J,ce.assetType);return ue&&ie.push([ce.assetType.substring(H.length),ue]),ie},[])}function S(J){if(J.properties){const H=J.properties.filter(ce=>ce.key===c.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=H.filter(ce=>re.test(ce.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return z(J,c.Repository)}function U(J){return{uri:`${J.fallbackAssetUri}/${c.VSIX}?redirect=true${J.targetPlatform?`&targetPlatform=${J.targetPlatform}`:""}`,fallbackUri:`${J.fallbackAssetUri}/${c.VSIX}${J.targetPlatform?`?targetPlatform=${J.targetPlatform}`:""}`}}function F(J){const H=z(J,c.Icon);if(H)return H;const re=C.DefaultIconPath;return{uri:re,fallbackUri:re}}function z(J,H){return J.files.filter(ie=>ie.assetType===H)[0]?{uri:`${J.assetUri}/${H}`,fallbackUri:`${J.fallbackAssetUri}/${H}`}:null}function j(J,H){const re=J.properties?J.properties.filter(ce=>ce.key===H):[],ie=re.length>0&&re[0].value;return ie?ie.split(",").map(ce=>(0,f.adoptToGalleryExtensionId)(ce)):[]}function M(J){const H=J.properties?J.properties.filter(re=>re.key===l.Engine):[];return H.length>0&&H[0].value||""}function W(J){const H=J.properties?J.properties.filter(ie=>ie.key===l.LocalizedLanguages):[],re=H.length>0&&H[0].value||"";return re?re.split(","):[]}function x(J){return J.indexOf("preview")!==-1}function $(J){return J.targetPlatform?(0,C.toTargetPlatform)(J.targetPlatform):"undefined"}function q(J){const H=(0,D.distinct)(J.versions.map($)),re=!!J.tags?.includes(C.WEB_EXTENSION_TAG),ie=H.indexOf("web");return re?ie===-1&&H.push("web"):ie!==-1&&H.splice(ie,1),H}function N(J,H){const re=(0,C.getFallbackTargetPlarforms)(H);for(let ie=0;ie<J.length;ie++){const ce=J[ie];if(ce.version===J[ie-1]?.version){let ue=ie;const ye=$(ce);if(ye===H)for(;ue>0&&J[ue-1].version===ce.version;)ue--;else if(re.includes(ye))for(;ue>0&&J[ue-1].version===ce.version&&$(J[ue-1])!==H;)ue--;ue!==ie&&(J.splice(ie,1),J.splice(ue,0,ce))}}return J}e.sortExtensionVersions=N;function V(J,H,re,ie,ce){const ue=q(J);let ye=J.versions[0];return ye=J.versions.find(ge=>ge.version===ye.version&&(0,C.isTargetPlatformCompatible)($(ge),ue,ce))||ye,_(J,ye,ue,H,re,ie)}function _(J,H,re,ie,ce,ue){const ye={manifest:z(H,c.Manifest),readme:z(H,c.Details),changelog:z(H,c.Changelog),license:z(H,c.License),repository:S(H),download:U(H),icon:F(H),coreTranslations:O(H)};return{identifier:{id:(0,f.getGalleryExtensionId)(J.publisher.publisherName,J.extensionName),uuid:J.extensionId},name:J.extensionName,version:H.version,displayName:J.displayName,publisherId:J.publisher.publisherId,publisher:J.publisher.publisherName,publisherDisplayName:J.publisher.displayName,description:J.shortDescription||"",installCount:A(J.statistics,"install"),rating:A(J.statistics,"averagerating"),ratingCount:A(J.statistics,"ratingcount"),categories:J.categories||[],tags:J.tags||[],releaseDate:Date.parse(J.releaseDate),lastUpdated:Date.parse(J.lastUpdated),allTargetPlatforms:re,assets:ye,properties:{dependencies:j(H,l.Dependency),extensionPack:j(H,l.ExtensionPack),engine:M(H),localizedLanguages:W(H),targetPlatform:$(H)},preview:x(J.flags),telemetryData:{index:(ce.pageNumber-1)*ce.pageSize+ie,querySource:ue}}}let Y=class{constructor(H,re,ie,ce,ue,ye,ge,Ie){this.requestService=re,this.logService=ie,this.environmentService=ce,this.telemetryService=ue,this.fileService=ye,this.productService=ge,this.configurationService=Ie;const Pe=ge.extensionsGallery;this.extensionsGalleryUrl=Pe&&Pe.serviceUrl,this.extensionsControlUrl=Pe&&Pe.controlUrl,this.commonHeadersPromise=ne(ge.version,ge,this.environmentService,this.configurationService,this.fileService,H)}api(H=""){return`${this.extensionsGalleryUrl}${H}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(H,re){const ie=[];let ce=new p().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,H.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...H.map(({id:ye})=>ye.toLowerCase()));H.every(ye=>!ye.version)&&(ce=ce.withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties,s.IncludeLatestVersionOnly));const{galleryExtensions:ue}=await this.queryGallery(ce,t,L.CancellationToken.None);for(let ye=0;ye<ue.length;ye++){const ge=ue[ye];if(!ge.versions.length)continue;const Ie=(0,f.getGalleryExtensionId)(ge.publisher.publisherName,ge.extensionName),Pe=H.find(Ee=>(0,f.areSameExtensions)(Ee,{id:Ie}))?.version;if(Pe){const Ee=ge.versions.find(Ae=>Ae.version===Pe);Ee&&ie.push(_(ge,Ee,q(ge),ye,ce))}else ie.push(V(ge,ye,ce,void 0,t))}return ie}async getCompatibleExtension(H,re){const ie=(0,C.isIExtensionIdentifier)(H)?null:H;if(ie){if((0,C.isNotWebExtensionInWebTargetPlatform)(ie.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(ie,re))return ie}const{id:ce,uuid:ue}=ie?ie.identifier:H;let ye=new p().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");ue?ye=ye.withFilter(r.ExtensionId,ue):ye=ye.withFilter(r.ExtensionName,ce);const{galleryExtensions:ge}=await this.queryGallery(ye,re,L.CancellationToken.None),[Ie]=ge;if(!Ie||!Ie.versions.length)return null;const Pe=q(Ie);if((0,C.isNotWebExtensionInWebTargetPlatform)(Pe,re))return null;for(let Ee of Ie.versions){if(!M(Ee)){const Ae=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:l.Engine,value:Ae}]}}if(await this.isRawExtensionVersionCompatible(Ee,Pe,re))return _(Ie,Ee,Pe,0,ye)}return null}async isExtensionCompatible(H,re){if(!(0,C.isTargetPlatformCompatible)(H.properties.targetPlatform,H.allTargetPlatforms,re))return!1;let ie=H.properties.engine;if(!ie){const ce=await this.getManifest(H,L.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");ie=ce.engines.vscode}return(0,I.isEngineValid)(ie,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(H,re,ie){if(!(0,C.isTargetPlatformCompatible)($(H),re,ie))return!1;const ce=await this.getEngine(H);return(0,I.isEngineValid)(ce,this.productService.version,this.productService.date)}async query(H,re){const ie=L.CancellationToken.isCancellationToken(H)?{}:H,ce=L.CancellationToken.isCancellationToken(H)?H:re;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ue=ie.text||"";const ye=(0,T.getOrDefault)(ie,De=>De.pageSize,50);let ge=new p().withFlags(s.IncludeLatestVersionOnly,s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,ye).withFilter(r.Target,"Microsoft.VisualStudio.Code");ue?(ue=ue.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(De,Te,Ne)=>(ge=ge.withFilter(r.Category,Ne||Te),"")),ue=ue.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(De,Te,Ne)=>(ge=ge.withFilter(r.Tag,Ne||Te),"")),ue=ue.replace(/\bfeatured(\s+|\b|$)/g,()=>(ge=ge.withFilter(r.Featured),"")),ue=ue.trim(),ue&&(ue=ue.length<200?ue:ue.substring(0,200),ge=ge.withFilter(r.SearchText,ue)),ge=ge.withSortBy(0)):ie.ids?ge=ge.withFilter(r.ExtensionId,...ie.ids):ie.names?ge=ge.withFilter(r.ExtensionName,...ie.names):ge=ge.withSortBy(4),typeof ie.sortBy=="number"&&(ge=ge.withSortBy(ie.sortBy)),typeof ie.sortOrder=="number"&&(ge=ge.withSortOrder(ie.sortOrder));const{galleryExtensions:Ie,total:Pe}=await this.queryGallery(ge,t,ce),Ee=Ie.map((De,Te)=>V(De,Te,ge,ie.source,t)),Ae=async(De,Te)=>{if(Te.isCancellationRequested)throw(0,R.canceled)();const Ne=ge.withPage(De+1),{galleryExtensions:_e}=await this.queryGallery(Ne,t,Te);return _e.map(($e,xe)=>V($e,xe,Ne,ie.source,t))};return{firstPage:Ee,total:Pe,pageSize:ge.pageSize,getPage:Ae}}async queryGallery(H,re,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");H=H.withFlags(H.flags,s.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,n(s.Unpublished));const ce=await this.commonHeadersPromise,ue=JSON.stringify(H.raw),ye={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ue.length)},ge=new Date().getTime();let Ie,Pe,Ee=0;try{if(Ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ue,headers:ye},ie),Ie.res.statusCode&&Ie.res.statusCode>=400&&Ie.res.statusCode<500)return{galleryExtensions:[],total:Ee};const Ae=await(0,w.asJson)(Ie);if(Ae){const De=Ae.results[0],Te=De.extensions;Te.forEach(_e=>N(_e.versions,re));const Ne=De.resultMetadata&&De.resultMetadata.filter(_e=>_e.metadataType==="ResultCount")[0];return Ee=Ne&&Ne.metadataItems.filter(_e=>_e.name==="TotalCount")[0].count||0,{galleryExtensions:Te,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(Ae){throw Pe=Ae,Ae}finally{this.telemetryService.publicLog2("galleryService:query",{...H.telemetryData,requestBodySize:String(ue.length),duration:new Date().getTime()-ge,success:!!Ie&&(0,w.isSuccess)(Ie),responseBodySize:Ie?.res.headers["Content-Length"],statusCode:Ie?String(Ie.res.statusCode):void 0,errorCode:Pe?(0,R.isPromiseCanceledError)(Pe)?"canceled":(0,R.getErrorMessage)(Pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(H,re,ie,ce){if(!this.isEnabled())return;const ue=k.isWeb?this.api(`/itemName/${H}.${re}/version/${ie}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${H}/extensions/${re}/${ie}/stats?statType=${ce}`),ye=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ie={...await this.commonHeadersPromise,Accept:ye};try{await this.requestService.request({type:"POST",url:ue,headers:Ie},L.CancellationToken.None)}catch(Pe){}}async download(H,re,ie){this.logService.trace("ExtensionGalleryService#download",H.identifier.id);const ce=(0,f.getGalleryExtensionTelemetryData)(H),ue=new Date().getTime(),ye=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Ee}),ge=ie===1?"install":ie===2?"update":"",Ie=ge?{uri:`${H.assets.download.uri}${y.URI.parse(H.assets.download.uri).query?"&":"?"}${ge}=true`,fallbackUri:`${H.assets.download.fallbackUri}${y.URI.parse(H.assets.download.fallbackUri).query?"&":"?"}${ge}=true`}:H.assets.download,Pe=await this.getAsset(Ie);await this.fileService.writeFile(re,Pe.stream),ye(new Date().getTime()-ue)}async getReadme(H,re){if(H.assets.readme){const ie=await this.getAsset(H.assets.readme,{},re);return await(0,w.asText)(ie)||""}return""}async getManifest(H,re){if(H.assets.manifest){const ie=await this.getAsset(H.assets.manifest,{},re),ce=await(0,w.asText)(ie);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(H,re){const ie=z(H,c.Manifest);if(!ie)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},ue=await this.getAsset(ie,{headers:ce});return await(0,w.asJson)(ue)}async getCoreTranslation(H,re){const ie=H.assets.coreTranslations.filter(ce=>ce[0]===re.toUpperCase())[0];if(ie){const ce=await this.getAsset(ie[1]),ue=await(0,w.asText)(ce);return ue?JSON.parse(ue):null}return null}async getChangelog(H,re){if(H.assets.changelog){const ie=await this.getAsset(H.assets.changelog,{},re);return await(0,w.asText)(ie)||""}return""}async getAllCompatibleVersions(H,re){let ie=new p().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");H.identifier.uuid?ie=ie.withFilter(r.ExtensionId,H.identifier.uuid):ie=ie.withFilter(r.ExtensionName,H.identifier.id);const{galleryExtensions:ce}=await this.queryGallery(ie,re,L.CancellationToken.None);if(!ce.length)return[];const ue=q(ce[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(ue,re))return[];const ye=[];for(const ge of ce[0].versions)try{ye[ye.length-1]?.version!==ge.version&&await this.isRawExtensionVersionCompatible(ge,ue,re)&&ye.push({version:ge.version,date:ge.lastUpdated})}catch(Ie){}return ye}async getAsset(H,re={},ie=L.CancellationToken.None){const ce=await this.commonHeadersPromise,ue={type:"GET"},ye={...ce,...re.headers||{}};re={...re,...ue,headers:ye};const ge=H.uri,Ie=H.fallbackUri,Pe={...re,url:ge};try{const Ee=await this.requestService.request(Pe,ie);if(Ee.res.statusCode===200)return Ee;const Ae=await(0,w.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${Ae}`)}catch(Ee){if((0,R.isPromiseCanceledError)(Ee))throw Ee;const Ae=(0,R.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ge,message:Ae});const De={...re,url:Ie};return this.requestService.request(De,ie)}}async getEngine(H){let re=M(H);if(!re){const ie=await this.getManifestFromRawExtensionVersion(H,L.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");re=ie.engines.vscode}return re}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const H=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(H.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,w.asJson)(H),ie=new Map;if(re)for(const ce of re.malicious){const ue=ie.get(ce)||{id:{id:ce},malicious:!0,slow:!1};ue.malicious=!0,ie.set(ce,ue)}return[...ie.values()]}};Y=de([X(1,w.IRequestService),X(2,E.ILogService),X(3,i.IEnvironmentService),X(4,o.ITelemetryService),X(5,u.IFileService),X(6,g.IProductService),X(7,b.IConfigurationService)],Y);let G=class extends Y{constructor(H,re,ie,ce,ue,ye,ge,Ie){super(H,re,ie,ce,ue,ye,ge,Ie)}};G=de([X(0,v.IStorageService),X(1,w.IRequestService),X(2,E.ILogService),X(3,i.IEnvironmentService),X(4,o.ITelemetryService),X(5,u.IFileService),X(6,g.IProductService),X(7,b.IConfigurationService)],G),e.ExtensionGalleryService=G;let te=class extends Y{constructor(H,re,ie,ce,ue,ye,ge){super(void 0,H,re,ie,ce,ue,ye,ge)}};te=de([X(0,w.IRequestService),X(1,E.ILogService),X(2,i.IEnvironmentService),X(3,o.ITelemetryService),X(4,u.IFileService),X(5,g.IProductService),X(6,b.IConfigurationService)],te),e.ExtensionGalleryServiceWithNoStorageService=te;async function ne(J,H,re,ie,ce,ue){const ye={"X-Market-Client-Id":`VSCode ${J}`,"User-Agent":`VSCode ${J}`},ge=await(0,m.getServiceMachineId)(re,ce,ue);return(0,a.getTelemetryLevel)(H,re)>=2&&(0,a.getTelemetryConfiguration)(ie)==="on"&&(ye["X-Market-User-Id"]=ge),ye}e.resolveMarketplaceHeaders=ne}),define(Z[83],ee([0,1,2,12,14,44]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let k=class extends D.Disposable{constructor(y,b,i=""){super();this.prefix=i;const C=y.getLogger(b.telemetryLogResource);C?this.logger=this._register(C):(this.logger=this._register(y.createLogger(b.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(y,b){this.logger.trace(`${this.prefix}telemetry/${y}`,(0,T.validateTelemetryData)(b))}};k=de([X(0,R.ILoggerService),X(1,L.IEnvironmentService)],k),e.TelemetryLogAppender=k}),define(Z[84],ee([0,1,2,26,24,126,21,38,42,33,20,44]),function(K,e,D,L,R,T,k,P,y,b,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{constructor(u,E){this._configurationService=E,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appender=u.appender,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._userOptIn=!0,this._errorOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let g of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(g),"gi"));this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(g=>{const w=/^[a-f0-9]+$/i.test(g["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!w})})}setExperimentProperty(u,E){this._experimentProperties[u]=E}setEnabled(u){this._enabled=u}_updateUserOptIn(){const u=(0,C.getTelemetryConfiguration)(this._configurationService);this._errorOptIn=u!=="off",this._userOptIn=u==="on"}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const u=await this._commonProperties;let E=u.sessionID,g=u["common.instanceId"],w=u["common.machineId"],m=u["common.firstSessionDate"],v=u["common.msftInternal"];return{sessionId:E,instanceId:g,machineId:w,firstSessionDate:m,msftInternal:v}}dispose(){this._disposables.dispose()}publicLog(u,E,g){return this.isOptedIn?this._commonProperties.then(w=>{E=(0,L.mixin)(E,w),E=(0,L.mixin)(E,this._experimentProperties),E=(0,L.cloneAndChange)(E,m=>{if(typeof m=="string")return this._cleanupInfo(m,g)}),this._appender.log(u,E)},w=>{console.error(w)}):Promise.resolve(void 0)}publicLog2(u,E,g){return this.publicLog(u,E,g)}publicLogError(u,E){return!this.sendErrorTelemetry||!this._errorOptIn?Promise.resolve(void 0):this.publicLog(u,E,!0)}publicLogError2(u,E){return this.publicLogError(u,E)}_anonymizeFilePaths(u){let E=u;const g=[];for(let o of this._cleanupPatterns)for(;;){const a=o.exec(u);if(!a)break;g.push([a.index,o.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(E="";;){const o=m.exec(u);if(!o)break;!w.test(o[0])&&g.every(([a,t])=>o.index<a||o.index>=t)&&(E+=u.substring(v,o.index)+"<REDACTED: user-file-path>",v=m.lastIndex)}return v<u.length&&(E+=u.substr(v)),E}_removePropertiesWithPossibleUserInfo(u){if(!u)return u;const E=u.toLowerCase(),g=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(E)?"<REDACTED: secret>":g.test(E)?"<REDACTED: email>":u}_cleanupInfo(u,E){let g=u;E&&(g=this._anonymizeFilePaths(g));for(let w of this._cleanupPatterns)g=g.replace(w,"");return g=this._removePropertiesWithPossibleUserInfo(g),g}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=de([X(1,k.IConfigurationService)],f),e.TelemetryService=f,b.Registry.as(P.Extensions.Configuration).registerConfiguration({id:i.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(0,null),properties:{[i.TELEMETRY_SETTING_ID]:{type:"string",enum:["on","error","off"],enumDescriptions:[(0,T.localize)(1,null),(0,T.localize)(2,null),(0,T.localize)(3,null)],markdownDescription:y.default.privacyStatementUrl?(0,T.localize)(5,null,y.default.nameLong,y.default.privacyStatementUrl):(0,T.localize)(4,null,y.default.nameLong),default:"on",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(P.Extensions.Configuration).registerConfiguration({id:i.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(6,null),properties:{[i.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:y.default.privacyStatementUrl?(0,T.localize)(8,null,y.default.nameLong,y.default.privacyStatementUrl):(0,T.localize)(7,null,y.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(9,null,`\`#${i.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[186],ee([0,1,9,26,44]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(P){const y=await new Promise((i,C)=>{K(["applicationinsights"],i,C)});let b;return y.defaultClient?(b=new y.TelemetryClient(P),b.channel.setUseDiskRetryCaching(!0)):(y.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),b=y.defaultClient),P.indexOf("AIF-")===0&&(b.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),b}class k{constructor(y,b,i){this._eventPrefix=y,this._defaultData=b,this._defaultData||(this._defaultData=Object.create(null)),typeof i=="function"?this._aiClient=i():this._aiClient=i,this._asyncAIClient=null}_withAIClient(y){if(!!this._aiClient){if(typeof this._aiClient!="string"){y(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient)),this._asyncAIClient.then(b=>{y(b)},b=>{(0,D.onUnexpectedError)(b),console.error(b)})}}log(y,b){!this._aiClient||(b=(0,L.mixin)(b,this._defaultData),b=(0,R.validateTelemetryData)(b),this._withAIClient(i=>i.trackEvent({name:this._eventPrefix+"/"+y,properties:b.properties,measurements:b.measurements})))}flush(){return this._aiClient?new Promise(y=>{this._withAIClient(b=>{b.flush({callback:()=>{this._aiClient=void 0,y(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(Z[187],ee([0,1,17,52,21,12,14,20,82,83,84,44]),function(K,e,D,L,R,T,k,P,y,b,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let f=class{constructor(u,E,g,w){this.configurationService=u,this.telemetryService=E,this.loggerService=g,this.environmentService=w,this.customTelemetryServices=new Map}async getCustomTelemetryService(u){if(!this.customTelemetryServices.has(u.id)){const{machineId:E,sessionId:g}=await this.telemetryService.getTelemetryInfo(),w=Object.create(null);w["common.vscodemachineid"]=E,w["common.vscodesessionid"]=g;const m=[u.id,JSON.stringify(w),u.aiKey],o=new L.Client(D.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),a=(0,C.combinedAppender)(new y.TelemetryAppenderClient(o),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${u.id}] `));this.customTelemetryServices.set(u.id,new i.TelemetryService({appender:a,sendErrorTelemetry:u.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(u.id)}async publicLog(u,E,g){await(await this.getCustomTelemetryService(u)).publicLog(E,g)}async publicLogError(u,E,g){await(await this.getCustomTelemetryService(u)).publicLogError(E,g)}};f=de([X(0,R.IConfigurationService),X(1,P.ITelemetryService),X(2,k.ILoggerService),X(3,T.IEnvironmentService)],f),e.CustomEndpointTelemetryService=f}),define(Z[188],ee([0,1,6,27,3,2,14]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends T.Disposable{constructor(b,i){super();this._logService=i,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((i,C)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,i),this._onCreateRequest.fire({requestId:f,...b});const I=new L.CancellationTokenSource;(0,D.timeout)(this._timeout,I.token).then(()=>C(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,T.toDisposable)(()=>I.cancel())])})}acceptReply(b,i){const C=this._pendingRequests.get(b);C?(this._pendingRequests.delete(b),(0,T.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),C(i)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};P=de([X(1,k.ILogService)],P),e.RequestStore=P}),define(Z[85],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(g){g.Shell="terminal.integrated.shell.",g.ShellArgs="terminal.integrated.shellArgs.",g.DefaultProfile="terminal.integrated.defaultProfile.",g.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(g){g.ShellLinux="terminal.integrated.shell.linux",g.ShellMacOs="terminal.integrated.shell.osx",g.ShellWindows="terminal.integrated.shell.windows",g.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",g.AutomationShellLinux="terminal.integrated.automationShell.linux",g.AutomationShellMacOs="terminal.integrated.automationShell.osx",g.AutomationShellWindows="terminal.integrated.automationShell.windows",g.ShellArgsLinux="terminal.integrated.shellArgs.linux",g.ShellArgsMacOs="terminal.integrated.shellArgs.osx",g.ShellArgsWindows="terminal.integrated.shellArgs.windows",g.ProfilesWindows="terminal.integrated.profiles.windows",g.ProfilesMacOs="terminal.integrated.profiles.osx",g.ProfilesLinux="terminal.integrated.profiles.linux",g.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",g.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",g.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",g.UseWslProfiles="terminal.integrated.useWslProfiles",g.TabsEnabled="terminal.integrated.tabs.enabled",g.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",g.TabsHideCondition="terminal.integrated.tabs.hideCondition",g.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",g.TabsShowActions="terminal.integrated.tabs.showActions",g.TabsLocation="terminal.integrated.tabs.location",g.TabsFocusMode="terminal.integrated.tabs.focusMode",g.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",g.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",g.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",g.CopyOnSelection="terminal.integrated.copyOnSelection",g.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",g.FontFamily="terminal.integrated.fontFamily",g.FontSize="terminal.integrated.fontSize",g.LetterSpacing="terminal.integrated.letterSpacing",g.LineHeight="terminal.integrated.lineHeight",g.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",g.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",g.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",g.BellDuration="terminal.integrated.bellDuration",g.FontWeight="terminal.integrated.fontWeight",g.FontWeightBold="terminal.integrated.fontWeightBold",g.CursorBlinking="terminal.integrated.cursorBlinking",g.CursorStyle="terminal.integrated.cursorStyle",g.CursorWidth="terminal.integrated.cursorWidth",g.Scrollback="terminal.integrated.scrollback",g.DetectLocale="terminal.integrated.detectLocale",g.DefaultLocation="terminal.integrated.defaultLocation",g.GpuAcceleration="terminal.integrated.gpuAcceleration",g.TerminalTitleSeparator="terminal.integrated.tabs.separator",g.TerminalTitle="terminal.integrated.tabs.title",g.TerminalDescription="terminal.integrated.tabs.description",g.RightClickBehavior="terminal.integrated.rightClickBehavior",g.Cwd="terminal.integrated.cwd",g.ConfirmOnExit="terminal.integrated.confirmOnExit",g.ConfirmOnKill="terminal.integrated.confirmOnKill",g.EnableBell="terminal.integrated.enableBell",g.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",g.AllowChords="terminal.integrated.allowChords",g.AllowMnemonics="terminal.integrated.allowMnemonics",g.EnvMacOs="terminal.integrated.env.osx",g.EnvLinux="terminal.integrated.env.linux",g.EnvWindows="terminal.integrated.env.windows",g.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",g.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",g.ShowExitAlert="terminal.integrated.showExitAlert",g.SplitCwd="terminal.integrated.splitCwd",g.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",g.WordSeparators="terminal.integrated.wordSeparators",g.TitleMode="terminal.integrated.titleMode",g.EnableFileLinks="terminal.integrated.enableFileLinks",g.UnicodeVersion="terminal.integrated.unicodeVersion",g.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",g.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",g.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",g.LocalEchoStyle="terminal.integrated.localEchoStyle",g.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",g.CustomGlyphs="terminal.integrated.customGlyphs",g.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",g.PersistentSessionExperimentalSerializer="terminal.integrated.persistentSessionExperimentalSerializer",g.InheritEnv="terminal.integrated.inheritEnv",g.ShowLinkHover="terminal.integrated.showLinkHover"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var k;(function(g){g[g.Api=0]="Api",g[g.Process=1]="Process",g[g.Sequence=2]="Sequence",g[g.Config=3]="Config"})(k=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Log="log",g.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var y;(function(g){g.Cwd="cwd",g.InitialCwd="initialCwd"})(y=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var i;(function(g){g[g.Panel=1]="Panel",g[g.Editor=2]="Editor"})(i=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(g){g.TerminalView="view",g.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(g){g.CwdDetection="cwdDetection"})(f=e.ProcessCapability||(e.ProcessCapability={}));var I;(function(g){g[g.GraceTime=6e4]="GraceTime",g[g.ShortGraceTime=6e3]="ShortGraceTime"})(I=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var u;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(u=e.FlowControlConstants||(e.FlowControlConstants={}));var E;(function(g){g.GitBash="Git Bash",g.Pwsh="PowerShell"})(E=e.ProfileSource||(e.ProfileSource={}))}),define(Z[189],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(Z[190],ee([0,1,35,26,8,4,31,16,19]),function(K,e,D,L,R,T,k,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let f=0;return C&&C.length===4&&(f=parseInt(C[3])),f}e.getWindowsBuildNumber=b;async function i(C,f,I,u=k.env,E=y.Promises.exists){if(R.isAbsolute(C))return await E(C)?C:void 0;if(f===void 0&&(f=k.cwd()),R.dirname(C)!=="."){const v=R.join(f,C);return await E(v)?v:void 0}const w=(0,L.getCaseInsensitive)(u,"PATH");if(I===void 0&&(0,P.isString)(w)&&(I=w.split(R.delimiter)),I===void 0||I.length===0){const v=R.join(f,C);return await E(v)?v:void 0}for(let v of I){let o;if(R.isAbsolute(v)?o=R.join(v,C):o=R.join(f,v,C),await E(o))return o;if(T.isWindows){let a=o+".com";if(await E(a)||(a=o+".exe",await E(a)))return a}}const m=R.join(f,C);return await E(m)?m:void 0}e.findExecutable=i}),define(Z[191],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(Z[86],ee([0,1,49,3,2,7,33,191]),function(K,e,D,L,R,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var y;(function(g){function w(m){return m&&typeof m=="object"&&typeof m.id=="string"}g.isThemeColor=w})(y=e.ThemeColor||(e.ThemeColor={}));function b(g){return{id:g}}e.themeColorFromId=b;var i;(function(g){function w(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||y.isThemeColor(s.color))}g.isThemeIcon=w;const m=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function v(s){const n=m.exec(s);if(!n)return;let[,r]=n;return{id:r}}g.fromString=v;function o(s,n){let r=s.id;const c=r.lastIndexOf("~");return c!==-1&&(r=r.substring(0,c)),n&&(r=`${r}~${n}`),{id:r}}g.modify=o;function a(s,n){return s.id===n.id&&s.color?.id===n.color?.id}g.isEqual=a;function t(s,n){return{id:s.id,color:n?b(n):void 0}}g.asThemeIcon=t,g.asClassNameArray=D.CSSIcon.asClassNameArray,g.asClassName=D.CSSIcon.asClassName,g.asCSSSelector=D.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function C(g){switch(g){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,R.toDisposable)(()=>{const m=this.themingParticipants.indexOf(w);this.themingParticipants.splice(m,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let I=new f;k.Registry.add(e.Extensions.ThemingContribution,I);function u(g){return I.onColorThemeChange(g)}e.registerThemingParticipant=u;class E extends R.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(m=>this.onThemeChange(m)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,m){let v=this.theme.getColor(w);return v&&m&&(v=m(v,this.theme)),v?v.toString():null}}e.Themable=E}),define(Z[192],ee([0,1,49,86]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function R(P,y){const b=P.map(i=>({name:i.profileName,description:T(i)}));return y&&b.push(...y.map(i=>({name:i.title,description:k(i)}))),{values:b.map(i=>i.name),markdownDescriptions:b.map(i=>i.description)}}e.createProfileSchemaEnums=R;function T(P){let y=`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.profileName}
- path: ${P.path}`;return P.args&&(typeof P.args=="string"?y+=`
- args: "${P.args}"`:y+=`
- args: [${P.args.length===0?"":`'${P.args.join("','")}'`}]`),P.overrideName!==void 0&&(y+=`
- overrideName: ${P.overrideName}`),P.color&&(y+=`
- color: ${P.color}`),P.env&&(y+=`
- env: ${JSON.stringify(P.env)}`),y}function k(P){return`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.title}
- extensionIdenfifier: ${P.extensionIdentifier}`}}),define(Z[193],ee([0,1,49,127,38,33,192]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(D.iconRegistry.all,g=>g.id),markdownEnumDescriptions:Array.from(D.iconRegistry.all,g=>`$(${g.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},y={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},b=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),i=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),C=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),f={id:"terminal",order:100,title:(0,L.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:i},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:i},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(19,null)}},{type:"string",markdownDescription:(0,L.localize)(20,null)}],default:[],markdownDeprecationMessage:C},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(22,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(23,null),type:"string"},id:{description:(0,L.localize)(24,null),type:"string"},title:{description:(0,L.localize)(25,null),type:"string"},...P}},{type:"null"},y]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(27,null),type:"string"},id:{description:(0,L.localize)(28,null),type:"string"},title:{description:(0,L.localize)(29,null),type:"string"},...P}},{type:"null"},y]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(31,null),type:"string"},id:{description:(0,L.localize)(32,null),type:"string"},title:{description:(0,L.localize)(33,null),type:"string"},...P}},{type:"null"},y]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,L.localize)(36,null),type:"number",default:100},["terminal.integrated.persistentSessionExperimentalSerializer"]:{scope:1,description:(0,L.localize)(37,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(38,null),type:"boolean",default:!0}}};function I(){T.Registry.as(R.Extensions.Configuration).registerConfiguration(f),E()}e.registerTerminalPlatformConfiguration=I;let u;function E(g,w){const m=T.Registry.as(R.Extensions.Configuration);u&&m.deregisterConfigurations([u]);let v;g&&(v=(0,k.createProfileSchemaEnums)(g?.profiles,w)),u={id:"terminal",order:100,title:(0,L.localize)(39,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(40,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:g?.os===3?v?.values:void 0,markdownEnumDescriptions:g?.os===3?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(41,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:g?.os===2?v?.values:void 0,markdownEnumDescriptions:g?.os===2?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(42,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:g?.os===1?v?.values:void 0,markdownEnumDescriptions:g?.os===1?v?.markdownDescriptions:void 0}}},m.registerConfiguration(u)}e.registerTerminalDefaultProfileConfiguration=E}),define(Z[194],ee([0,1,41,49,8,4,19,69,190,86]),function(K,e,D,L,R,T,k,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let i;function C(t,s,n,r,c=process.env,l,h,d,p){return l=l||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},T.isWindows?f(n,l,c,h,r.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:r.getValue("terminal.integrated.profiles.windows"),typeof s=="string"?s:r.getValue("terminal.integrated.defaultProfile.windows"),p,d):v(l,h,n,t&&typeof t=="object"?{...t}:r.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof s=="string"?s:r.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),p,d,c)}e.detectAvailableProfiles=C;async function f(t,s,n,r,c,l,h,d,p){const A=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${A?"Sysnative":"System32"}`;let S=!1;(0,y.getWindowsBuildNumber)()>=16299&&(S=!0),await E(d);const U=new Map;t&&(U.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),U.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),U.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),U.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),U.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0})),o(l,U);const F=await I(U.entries(),h,s,n,r,p);if(t||!t&&c)try{const z=await w(`${O}\\${S?"wsl":"bash"}.exe`,h);for(const j of z)(!l||!(j.profileName in l))&&F.push(j)}catch(z){r?.info("WSL is not installed, so could not detect WSL profiles")}return F}async function I(t,s,n,r=process.env,c,l){const h=[];for(const[d,p]of t){if(p===null)continue;let A,O,S;if("source"in p){const z=i?.get(p.source);if(!z)continue;A=z.paths,O=p.args||z.args,p.icon?S=u(p.icon):z.icon&&(S=z.icon)}else A=Array.isArray(p.path)?p.path:[p.path],O=T.isWindows||Array.isArray(p.args)?p.args:void 0,S=u(p.icon)||void 0;const U=await l?.(A)||A.slice(),F=await a(d,s,U,n,r,O,p.env,p.overrideName,p.isAutoDetected,c);F?(F.isAutoDetected=p.isAutoDetected,F.icon=S,F.color=p.color,h.push(F)):c?.trace("profile not validated",d,A)}return h}function u(t){return typeof t=="string"?{id:t}:t}async function E(t){i&&!t||(i=new Map,i.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),i.set("PowerShell",{profileName:"PowerShell",paths:t||await g(),icon:b.ThemeIcon.asThemeIcon(L.Codicon.terminalPowershell)}))}async function g(){const t=[];for await(const s of(0,P.enumeratePowerShellInstallations)())t.push(s.exePath);return t}async function w(t,s){const n=[],r=await new Promise((h,d)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le"},(p,A)=>{if(p)return d("Problem occurred when getting wsl distros");h(A)})});if(!r)return[];const c=new RegExp(/[\r?\n]/),l=r.split(c).filter(h=>h.trim().length>0&&h!=="");for(const h of l){if(h===""||h.startsWith("docker-desktop"))continue;const d=`${h} (WSL)`,p={profileName:d,path:t,args:["-d",`${h}`],isDefault:d===s,icon:m(h)};n.push(p)}return n}function m(t){return t.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(L.Codicon.terminalUbuntu):t.includes("Debian")?b.ThemeIcon.asThemeIcon(L.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(L.Codicon.terminalLinux)}async function v(t,s,n,r,c,l,h,d){const p=new Map;if(n){const A=(await t.readFile("/etc/shells")).toString(),O=l||A.split(`
`).filter(U=>U.trim().indexOf("#")!==0&&U.trim().length>0),S=new Map;for(const U of O){let F=(0,R.basename)(U),z=S.get(F)||0;z++,z>1&&(F=`${F} (${z})`),S.set(F,z),p.set(F,{path:U,isAutoDetected:!0})}}return o(r,p),await I(p.entries(),c,t,d,s,h)}function o(t,s){if(!!t)for(const[n,r]of Object.entries(t))r===null||!("path"in r)&&!("source"in r)?s.delete(n):s.set(n,r)}async function a(t,s,n,r,c,l,h,d,p,A){if(n.length===0)return Promise.resolve(void 0);const O=n.shift();if(O==="")return a(t,s,n,r,c,l,h,d,p);const S={profileName:t,path:O,args:l,env:h,overrideName:d,isAutoDetected:p,isDefault:t===s};if((0,R.basename)(O)===O){const F=c.PATH?c.PATH.split(R.delimiter):void 0;return await(0,y.findExecutable)(O,void 0,F,void 0,r.existsFile)?S:a(t,s,n,r,c,l)}return await r.existsFile((0,R.normalize)(O))?S:a(t,s,n,r,c,l,h,d,p)}}),define(Z[195],ee([0,1,3,2,17,4,36,52,21,156,14,79,20,188,85,193,194]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I,u,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var w;(function(o){o[o.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let m=0,v=class extends L.Disposable{constructor(a,t,s,n){super();this._reconnectConstants=a,this._configurationService=t,this._logService=s,this._telemetryService=n,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new D.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new D.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new D.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new D.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new D.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,(0,E.registerTerminalPlatformConfiguration)(),this._shellEnv=T.isWindows?Promise.resolve(process.env):(0,b.resolveShellEnv)(this._logService,{_:[]},process.env),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new I.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const a=new P.Client(R.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:m,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback,VSCODE_RECONNECT_EXPERIMENTAL_SERIALIZATION:this._reconnectConstants.useExperimentalSerialization?1:0}});this._onPtyHostStart.fire(),k.ProxyChannel.toService(a.getChannel(u.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(a.onDidProcessExit(r=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(r.code),this._isDisposed||(this._restartCount<=w.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const s=a.getChannel(u.TerminalIpcChannels.Log);C.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{C.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const n=k.ProxyChannel.toService(a.getChannel(u.TerminalIpcChannels.PtyHost));return this._register(n.onProcessData(r=>this._onProcessData.fire(r))),this._register(n.onProcessExit(r=>this._onProcessExit.fire(r))),this._register(n.onProcessReady(r=>this._onProcessReady.fire(r))),this._register(n.onProcessTitleChanged(r=>this._onProcessTitleChanged.fire(r))),this._register(n.onProcessShellTypeChanged(r=>this._onProcessShellTypeChanged.fire(r))),this._register(n.onProcessOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r))),this._register(n.onProcessResolvedShellLaunchConfig(r=>this._onProcessResolvedShellLaunchConfig.fire(r))),this._register(n.onProcessDidChangeHasChildProcesses(r=>this._onProcessDidChangeHasChildProcesses.fire(r))),this._register(n.onDidChangeProperty(r=>this._onDidChangeProperty.fire(r))),this._register(n.onProcessReplay(r=>this._onProcessReplay.fire(r))),this._register(n.onProcessOrphanQuestion(r=>this._onProcessOrphanQuestion.fire(r))),this._register(n.onDidRequestDetach(r=>this._onDidRequestDetach.fire(r))),[a,n]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,t,s,n,r,c,l,h,d,p,A){const O=setTimeout(()=>this._handleUnresponsiveCreateProcess(),u.HeartbeatConstants.CreateProcessTimeout),S=await this._proxy.createProcess(a,t,s,n,r,c,l,h,d,p,A);return clearTimeout(O),m=Math.max(m,S),S}updateTitle(a,t,s){return this._proxy.updateTitle(a,t,s)}updateIcon(a,t,s){return this._proxy.updateIcon(a,t,s)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,t){return this._proxy.shutdown(a,t)}input(a,t){return this._proxy.input(a,t)}processBinary(a,t){return this._proxy.processBinary(a,t)}resize(a,t,s){return this._proxy.resize(a,t,s)}acknowledgeDataEvent(a,t){return this._proxy.acknowledgeDataEvent(a,t)}setUnicodeVersion(a,t){return this._proxy.setUnicodeVersion(a,t)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,t,s,n=!1){const r=await this._shellEnv;return(0,g.detectAvailableProfiles)(t,s,n,this._configurationService,r,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,t){return this._proxy.requestDetachInstance(a,t)}async acceptDetachInstanceReply(a,t){return this._proxy.acceptDetachInstanceReply(a,t)}async refreshProperty(a,t){return this._proxy.refreshProperty(a,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier+u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${u.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,t){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:t})}async acceptPtyHostResolvedVariables(a,t){this._resolveVariablesRequestStore.acceptReply(a,t)}};v=de([X(1,y.IConfigurationService),X(2,i.ILogService),X(3,f.ITelemetryService)],v),e.PtyHostService=v}),define(Z[54],ee([0,1,45]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(k,P,y,b){const i=(0,D.setProperty)(k,P,y,b)[0];return i&&(k=k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)),k}e.edit=L;function R(k,P,y){let b=y;for(;b>=0;){if(k.charAt(b)===P.charAt(P.length-1)&&P.length===1)return b+1;if(b--,P.length===2&&b>=0&&k.charAt(b)===P.charAt(0))return b+2}return 0}e.getLineStartOffset=R;function T(k,P,y){let b=y;for(;b>=0;)if(k.charAt(b)===P.charAt(P.length-1)&&P.length===1||(b++,P.length===2&&b>=0&&k.charAt(b)===P.charAt(1)))return b;return k.length-1}e.getLineEndOffset=T}),define(Z[196],ee([0,1,26,58]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(C,f,I,u,E){const g=[],w=[],m=[];if(!f){const O=C.filter(({identifier:S})=>E.every(U=>U.toLowerCase()!==S.id.toLowerCase()));return{local:{added:g,removed:w,updated:m},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}C=C.map(b),f=f.map(b),I=I?I.map(b):null;const v=new Map,o=O=>{O.uuid&&v.set(O.id.toLowerCase(),O.uuid)};C.forEach(({identifier:O})=>o(O)),f.forEach(({identifier:O})=>o(O)),I&&I.forEach(({identifier:O})=>o(O));const a=O=>{const S=O.identifier.uuid||v.get(O.identifier.id.toLowerCase());return S?`uuid:${S}`:`id:${O.identifier.id.toLowerCase()}`},t=(O,S)=>(O.set(a(S),S),O),s=C.reduce(t,new Map),n=f.reduce(t,new Map),r=f.reduce((O,S)=>{const U=a(S);S=(0,D.deepClone)(S);const F=s.get(U);return F&&(F.installed&&(S.installed=!0),S.version||(S.version=F.version)),t(O,S)},new Map),c=I?I.reduce(t,new Map):null,l=u.reduce(t,new Map),h=E.reduce((O,S)=>{const U=v.get(S.toLowerCase());return O.add(U?`uuid:${U}`:`id:${S.toLowerCase()}`)},new Set),d=T(s,n,h);if(d.added.size>0||d.removed.size>0||d.updated.size>0){const O=T(c,s,h),S=T(c,n,h),U=(F,z)=>{const j=s.get(F);if(j){const M=n.get(F);return{...z?M:j,version:(M.version&&L.gt(M.version,j.version),j.version),state:k(j,M,c?.get(F))}}};for(const F of S.removed.values()){const z=s.get(F);z&&w.push(z.identifier)}for(const F of S.added.values())if(O.added.has(F)){if(d.updated.has(F)){const z=U(F,!0);z&&(m.push(i(z,F)),r.set(F,z))}}else{const z=n.get(F);z.installed&&g.push(i(z,F))}for(const F of S.updated.values()){const z=U(F,!0);z&&(m.push(i(z,F)),r.set(F,z))}for(const F of O.added.values())S.added.has(F)||r.set(F,s.get(F));for(const F of O.updated.values())if(!S.removed.has(F)&&!S.updated.has(F)){const z=U(F,!1);z&&(r.get(F)?.installed&&(z.installed=!0),r.set(F,z))}for(const F of O.removed.values())!l.has(F)&&!S.updated.has(F)&&c?.get(F)?.installed&&r.delete(F)}const p=[],A=T(n,r,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(A.added.size>0||A.updated.size>0||A.removed.size>0)&&r.forEach((O,S)=>p.push(i(O,S))),{local:{added:g,removed:w,updated:m},remote:p.length?{added:[...A.added].map(O=>r.get(O)),updated:[...A.updated].map(O=>r.get(O)),removed:[...A.removed].map(O=>n.get(O)),all:p}:null}}e.merge=R;function T(C,f,I,{checkInstalledProperty:u,checkVersionProperty:E}={checkInstalledProperty:!1,checkVersionProperty:!1}){const g=C?[...C.keys()].filter(a=>!I.has(a)):[],w=[...f.keys()].filter(a=>!I.has(a)),m=w.filter(a=>g.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),v=g.filter(a=>w.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),o=new Set;for(const a of g){if(v.has(a))continue;const t=C.get(a),s=f.get(a);(!s||t.disabled!==s.disabled||!y(t.state,s.state)||E&&t.version!==s.version||u&&t.installed!==s.installed)&&o.add(a)}return{added:m,removed:v,updated:o}}function k(C,f,I){const u=C.state,E=f.state,g=I?.state;if(!f.version||u&&L.gt(C.version,f.version))return u;if(E&&L.gt(f.version,C.version)||!u)return E;if(!E)return u;const w=(0,D.deepClone)(u),m=g?P(g,E):{added:Object.keys(E).reduce((o,a)=>(o.add(a),o),new Set),removed:new Set,updated:new Set},v=g?P(g,u):{added:Object.keys(u).reduce((o,a)=>(o.add(a),o),new Set),removed:new Set,updated:new Set};for(const o of[...m.added.values(),...m.updated.values()])w[o]=E[o];for(const o of m.removed.values())v.updated.has(o)||delete w[o];return w}function P(C,f){const I=Object.keys(C),u=Object.keys(f),E=u.filter(m=>I.indexOf(m)===-1).reduce((m,v)=>(m.add(v),m),new Set),g=I.filter(m=>u.indexOf(m)===-1).reduce((m,v)=>(m.add(v),m),new Set),w=new Set;for(const m of I){if(g.has(m))continue;const v=C[m],o=f[m];(0,D.equals)(v,o)||w.add(m)}return{added:E,removed:g,updated:w}}function y(C={},f={}){const{added:I,removed:u,updated:E}=P(C,f);return I.size===0&&u.size===0&&E.size===0}function b(C){return{...C,disabled:!!C.disabled,installed:!!C.installed}}function i(C,f){const I={identifier:{id:C.identifier.id,uuid:f.startsWith("uuid:")?f.substring("uuid:".length):void 0}};return C.version&&(I.version=C.version),C.disabled&&(I.disabled=!0),C.installed&&(I.installed=!0),C.state&&(I.state=C.state),I}}),define(Z[87],ee([0,1,18,3,2,32,7,29,22]),function(K,e,D,L,R,T,k,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,k.createDecorator)("IExtensionsStorageSyncService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let i=class Ze extends R.Disposable{constructor(f,I){super();this.storageService=f,this.productService=I,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(u=>this.onDidChangeStorageValue(u)))}static toKey(f){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static fromKey(f){const I=b.exec(f);if(I&&I[1])return{id:I[1],version:I[2]}}initialize(){const f=this.storageService.keys(0,1);for(const I of f){const u=Ze.fromKey(I);u&&this.extensionsWithKeysForSync.add(u.id.toLowerCase())}}onDidChangeStorageValue(f){if(f.scope!==0)return;if(this.extensionsWithKeysForSync.has(f.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const I=Ze.fromKey(f.key);if(I){this.extensionsWithKeysForSync.add(I.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(f,I){this.storageService.store(Ze.toKey(f),JSON.stringify(I),0,1)}getKeysForSync(f){const I=this.productService.extensionSyncedKeys?.[f.id.toLowerCase()],u=this.storageService.get(Ze.toKey(f),0),E=u?JSON.parse(u):void 0;return E&&I?(0,D.distinct)([...E,...I]):E||I}};i=de([X(0,y.IStorageService),X(1,P.IProductService)],i),e.ExtensionsStorageSyncService=i}),define(Z[88],ee([0,1,18,21,7]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,y){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return b=b.filter(i=>i!==P&&i!==`-${P}`),y&&b.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}updateSynchronizedExtensions(P,y){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return b=b.filter(i=>i!==P&&i!==`-${P}`),y&&b.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}getIgnoredExtensions(P){const y=P.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),i=[],C=[];if(Array.isArray(b))for(const f of b)f.startsWith("-")?C.push(f.substring(1)):i.push(f);return(0,D.distinct)([...y,...i].filter(f=>C.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(y=>y.toLowerCase())}};T=de([X(0,L.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(Z[197],ee([0,1,18,34,26,149,54]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(o){return(0,L.parse)(o)||[]}e.parseKeybindings=P;async function y(o,a,t,s,n){const r=P(o),c=P(a),l=t?P(t):null,h=[...r,...c,...l||[]].map(W=>W.key),d=await n.resolveUserBindings(h);let p=i(r,c,l,d);if(!p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:o,hasChanges:!1,hasConflicts:!1};if(!p.hasLocalForwarded&&p.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};if(p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};const A=f(r),O=f(c),S=l?f(l):null,U=u(A,O,d),F=S?u(S,A,d):{added:[...A.keys()].reduce((W,x)=>(W.add(x),W),new Set),removed:new Set,updated:new Set},z=S?u(S,O,d):{added:[...O.keys()].reduce((W,x)=>(W.add(x),W),new Set),removed:new Set,updated:new Set},j=b(U,F,z);let M=o;for(const W of j.removed.values())j.conflicts.has(W)||(M=m(M,W,s));for(const W of j.added.values()){if(j.conflicts.has(W))continue;const x=O.get(W);if(x.some($=>$.command!==`-${W}`&&p.conflicts.has(d[$.key]))){j.conflicts.add(W);continue}M=w(M,x,s)}for(const W of j.updated.values()){if(j.conflicts.has(W))continue;const x=O.get(W);if(x.some($=>$.command!==`-${W}`&&p.conflicts.has(d[$.key]))){j.conflicts.add(W);continue}M=v(M,W,x,s)}return{mergeContent:M,hasChanges:!0,hasConflicts:j.conflicts.size>0}}e.merge=y;function b(o,a,t){const s=new Set,n=new Set,r=new Set,c=new Set;for(const l of a.removed.values())t.updated.has(l)&&c.add(l);for(const l of t.removed.values())c.has(l)||(a.updated.has(l)?c.add(l):n.add(l));for(const l of a.added.values())c.has(l)||t.added.has(l)&&o.updated.has(l)&&c.add(l);for(const l of t.added.values())c.has(l)||(a.added.has(l)?o.updated.has(l)&&c.add(l):s.add(l));for(const l of a.updated.values())c.has(l)||t.updated.has(l)&&o.updated.has(l)&&c.add(l);for(const l of t.updated.values())c.has(l)||(a.updated.has(l)?o.updated.has(l)&&c.add(l):r.add(l));return{added:s,removed:n,updated:r,conflicts:c}}function i(o,a,t,s){const n=new Set,r=C(o,s),c=C(a,s),l=t?C(t,s):null,h=I(r,c);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const d=l?I(l,r):{added:[...r.keys()].reduce((F,z)=>(F.add(z),F),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const p=l?I(l,c):{added:[...c.keys()].reduce((F,z)=>(F.add(z),F),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:A,removed:O,updated:S,conflicts:U}=b(h,d,p);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:O,updated:S,conflicts:U}}function C(o,a){const t=new Map;for(const s of o){const n=a[s.key];let r=t.get(n);r||(r=[],t.set(n,r)),r.push(s)}return t}function f(o){const a=new Map;for(const t of o){const s=t.command[0]==="-"?t.command.substring(1):t.command;let n=a.get(s);n||(n=[],a.set(s,n)),n.push(t)}return a}function I(o,a){const t=[...o.keys()],s=[...a.keys()],n=s.filter(l=>t.indexOf(l)===-1).reduce((l,h)=>(l.add(h),l),new Set),r=t.filter(l=>s.indexOf(l)===-1).reduce((l,h)=>(l.add(h),l),new Set),c=new Set;for(const l of t){if(r.has(l))continue;const h=o.get(l).map(p=>({...p,key:l})),d=a.get(l).map(p=>({...p,key:l}));(0,D.equals)(h,d,(p,A)=>g(p,A))||c.add(l)}return{added:n,removed:r,updated:c}}function u(o,a,t){const s=[...o.keys()],n=[...a.keys()],r=n.filter(h=>s.indexOf(h)===-1).reduce((h,d)=>(h.add(d),h),new Set),c=s.filter(h=>n.indexOf(h)===-1).reduce((h,d)=>(h.add(d),h),new Set),l=new Set;for(const h of s){if(c.has(h))continue;const d=o.get(h).map(A=>({...A,key:t[A.key]})),p=a.get(h).map(A=>({...A,key:t[A.key]}));E(d,p)||l.add(h)}return{added:r,removed:c,updated:l}}function E(o,a){return!(!(0,D.equals)(o.filter(({command:t})=>t[0]!=="-"),a.filter(({command:t})=>t[0]!=="-"),(t,s)=>g(t,s))||!(0,D.equals)(o.filter(({command:t})=>t[0]==="-"),a.filter(({command:t})=>t[0]==="-"),(t,s)=>g(t,s)))}function g(o,a){if(o.command!==a.command||o.key!==a.key)return!1;const t=T.ContextKeyExpr.deserialize(o.when),s=T.ContextKeyExpr.deserialize(a.when);return!(t&&!s||!t&&s||t&&s&&!t.equals(s)||!R.equals(o.args,a.args))}function w(o,a,t){for(const s of a)o=k.edit(o,[-1],s,t);return o}function m(o,a,t){const s=P(o);for(let n=s.length-1;n>=0;n--)(s[n].command===a||s[n].command===`-${a}`)&&(o=k.edit(o,[n],void 0,t));return o}function v(o,a,t,s){const n=P(o),r=n.findIndex(c=>c.command===a||c.command===`-${a}`);for(let c=n.length-1;c>=0;c--)(n[c].command===a||n[c].command===`-${a}`)&&(o=k.edit(o,[c],void 0,s));for(let c=t.length-1;c>=0;c--)o=k.edit(o,[r],t[c],s);return o}}),define(Z[198],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(T,k,P){const y={},b={},i=new Set;if(!k)return{local:{added:y,updated:b,removed:[...i.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const C=L(T,k);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:y,updated:b,removed:[...i.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=L(P,T),I=L(P,k),u={},E={},g=new Set,w=new Set;for(const m of f.removed.values())I.updated.has(m)?y[m]=k[m]:g.add(m);for(const m of I.removed.values())w.has(m)||(f.updated.has(m)?w.add(m):i.add(m));for(const m of f.updated.values())w.has(m)||(I.updated.has(m)?C.updated.has(m)&&w.add(m):E[m]=T[m]);for(const m of I.updated.values())w.has(m)||(f.updated.has(m)?C.updated.has(m)&&w.add(m):T[m]!==void 0&&(b[m]=k[m]));for(const m of f.added.values())w.has(m)||(I.added.has(m)?C.updated.has(m)&&w.add(m):u[m]=T[m]);for(const m of I.added.values())w.has(m)||(f.added.has(m)?C.updated.has(m)&&w.add(m):y[m]=k[m]);return{local:{added:y,removed:[...i.values()],updated:b},remote:{added:u,removed:[...g.values()],updated:E},conflicts:[...w.values()]}}e.merge=D;function L(T,k){const P=T?Object.keys(T):[],y=k?Object.keys(k):[],b=y.filter(f=>P.indexOf(f)===-1).reduce((f,I)=>(f.add(I),f),new Set),i=P.filter(f=>y.indexOf(f)===-1).reduce((f,I)=>(f.add(I),f),new Set),C=new Set;for(const f of P){if(i.has(f))continue;const I=T[f],u=k[f];I!==u&&C.add(f)}return{added:b,removed:i,updated:C}}function R(T,k){const{added:P,removed:y,updated:b}=L(T,k);return P.size===0&&y.size===0&&b.size===0}e.areSame=R}),define(Z[23],ee([0,1,18,15,16,132,38,28,7,81,33]),function(K,e,D,L,R,T,k,P,y,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const l=i.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(l).filter(h=>!!l[h].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function f(){const l=i.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(l).filter(A=>!!l[A].ignoreSync),d=Object.keys(l).filter(A=>l[A].scope===2||l[A].scope===6),p=C();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...h,...d,...p])}e.getDefaultIgnoredSettings=f;function I(){const l="vscode://schemas/ignoredSettings",h=i.Registry.as(k.Extensions.Configuration);h.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:l,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const d=i.Registry.as(b.Extensions.JSONContribution),p=()=>{const A=C(),O=f().filter(z=>z!==e.CONFIGURATION_SYNC_STORE_KEY),S=Object.keys(k.allSettings.properties).filter(z=>O.indexOf(z)===-1),U=O.filter(z=>A.indexOf(z)===-1),F={items:{type:"string",enum:[...S,...U.map(z=>`-${z}`)]}};d.registerSchema(l,F)};return h.onDidUpdateConfiguration(()=>p())}e.registerConfiguration=I;function u(l){return l&&(0,R.isObject)(l)&&(0,R.isString)(l.id)&&(0,R.isArray)(l.scopes)}e.isAuthenticationProvider=u;var E;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Extensions="extensions",l.GlobalState="globalState"})(E=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function g(l,h,d){return d.joinPath(h.userDataSyncHome,l,`lastSync${l}.json`)}e.getLastSyncResourceUri=g,e.IUserDataSyncStoreManagementService=(0,y.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,y.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,y.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function w(l){const h={};return h[e.HEADER_EXECUTION_ID]=l,h}e.createSyncHeaders=w;var m;(function(l){l.Unauthorized="Unauthorized",l.Conflict="Conflict",l.Gone="Gone",l.PreconditionFailed="PreconditionFailed",l.TooLarge="TooLarge",l.UpgradeRequired="UpgradeRequired",l.PreconditionRequired="PreconditionRequired",l.TooManyRequests="RemoteTooManyRequests",l.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",l.RequestFailed="RequestFailed",l.RequestCanceled="RequestCanceled",l.RequestTimeout="RequestTimeout",l.RequestProtocolNotSupported="RequestProtocolNotSupported",l.RequestPathNotEscaped="RequestPathNotEscaped",l.RequestHeadersNotObject="RequestHeadersNotObject",l.NoRef="NoRef",l.EmptyResponse="EmptyResponse",l.TurnedOff="TurnedOff",l.SessionExpired="SessionExpired",l.ServiceChanged="ServiceChanged",l.DefaultServiceChanged="DefaultServiceChanged",l.LocalTooManyRequests="LocalTooManyRequests",l.LocalPreconditionFailed="LocalPreconditionFailed",l.LocalInvalidContent="LocalInvalidContent",l.LocalError="LocalError",l.IncompatibleLocalContent="IncompatibleLocalContent",l.IncompatibleRemoteContent="IncompatibleRemoteContent",l.UnresolvedConflicts="UnresolvedConflicts",l.Unknown="Unknown"})(m=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class v extends Error{constructor(h,d,p,A){super(h);this.code=d,this.resource=p,this.operationId=A,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=v;class o extends v{constructor(h,d,p,A,O){super(h,p,void 0,O);this.url=d,this.serverCode=A}}e.UserDataSyncStoreError=o;class a extends v{constructor(h,d){super(h,d)}}e.UserDataAutoSyncError=a,function(l){function h(d){if(d instanceof l)return d;const p=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(d.name);if(p&&p[1]){const A=p[2]==="unknown"?void 0:p[2],O=p[3]==="unknown"?void 0:p[3];return new l(d.message,p[1],A,O)}return new l(d.message,"Unknown")}l.toUserDataSyncError=h}(v=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(l){l.Uninitialized="uninitialized",l.Idle="idle",l.Syncing="syncing",l.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var s;(function(l){l[l.None=0]="None",l[l.Added=1]="Added",l[l.Modified=2]="Modified",l[l.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var n;(function(l){l.Preview="preview",l.Conflict="conflict",l.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function r(l){return`sync.enable.${l}`}e.getEnablementKey=r,e.IUserDataSyncResourceEnablementService=(0,y.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,y.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,y.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,y.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,y.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,y.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function c(l,h){if(l.scheme!==e.USER_DATA_SYNC_SCHEME)return l=l.with({scheme:h.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(d=>(0,L.isEqualOrParent)(l,(0,L.joinPath)(h.userDataSyncHome,d,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=c}),define(Z[47],ee([0,1,18,6,25,27,3,34,2,15,24,16,5,128,21,12,13,46,22,20,23]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I,u,E,g,w,m,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function a(c){return!!(c&&c.version!==void 0&&typeof c.version=="number"&&c.content!==void 0&&typeof c.content=="string"&&(Object.keys(c).length===2||Object.keys(c).length===3&&c.machineId!==void 0&&typeof c.machineId=="string"))}e.isSyncData=a;let t=class extends y.Disposable{constructor(l,h,d,p,A,O,S,U,F,z){super();this.resource=l,this.fileService=h,this.environmentService=d,this.userDataSyncStoreService=A,this.userDataSyncBackupStoreService=O,this.userDataSyncResourceEnablementService=S,this.telemetryService=U,this.logService=F,this.configurationService=z,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new L.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,i.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?b.extUri:b.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(d.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,o.PREVIEW_DIR_NAME),this.lastSyncResource=(0,o.getLastSyncResourceUri)(l,d,this.extUri),this.currentMachineIdPromise=(0,w.getServiceMachineId)(d,h,p)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const h=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0);this.setStatus(h)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?(await this.doGenerateSyncResourcePreview(l,l,!0,T.CancellationToken.None)).resourcePreviews.some(({remoteChange:d})=>d!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){if(this._status!==l){const h=this._status;l==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),h==="hasConflicts"&&l==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=l,this._onDidChangStatus.fire(l)}}async sync(l,h={}){await this._sync(l,!0,h)}async preview(l,h={}){return this._sync(l,!1,h)}async apply(l,h={}){try{this.syncHeaders={...h};const d=await this.doApply(l);return this.setStatus(d),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,h,d){try{if(this.syncHeaders={...d},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let p="idle";try{const A=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(l,A);return p=await this.performSync(O,A,h),p==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):p==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(p)}}finally{this.syncHeaders={}}}async replace(l){const h=await this.resolveContent(l);if(!h)return!1;const d=this.parseSyncData(h);if(!d)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const p=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,p),O=await this.isRemoteDataFromCurrentMachine(A),S=await this.generateSyncPreview({ref:A.ref,syncData:d},p,O,T.CancellationToken.None),U=[];for(const F of S){const z=await this.getAcceptResult(F,F.remoteResource,void 0,T.CancellationToken.None),{remoteChange:j}=await this.getAcceptResult(F,F.previewResource,F.remoteContent,T.CancellationToken.None);U.push([F,{...z,remoteChange:j!==0?j:2}])}await this.applyResult(A,p,U,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(l){const h=await this.currentMachineIdPromise;return!!l.syncData?.machineId&&l.syncData.machineId===h}async getLatestRemoteUserData(l,h){if(h){const d=l&&l.latest?l.latest[this.resource]:void 0;if(h.ref===d||d===void 0&&h.syncData===null)return h}return this.getRemoteUserData(h)}async performSync(l,h,d){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new o.UserDataSyncError((0,I.localize)(0,null,this.resource,this.version,l.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(l,h,d)}catch(p){if(p instanceof o.UserDataSyncError)switch(p.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,h,d);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),h=await this.getLastSyncUserData(),this.performSync(l,h,d)}throw p}}async doSync(l,h,d){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,L.createCancelablePromise)(A=>this.doGenerateSyncResourcePreview(l,h,d,A)));const p=await this.syncPreviewPromise;return this.updateConflicts(p.resourcePreviews),p.resourcePreviews.some(({mergeState:A})=>A==="conflict")?"hasConflicts":d?await this.doApply(!1):"syncing"}catch(p){throw this.syncPreviewPromise=null,p}}async merge(l){return await this.updateSyncResourcePreview(l,async h=>{const d=await this.getMergeResult(h,T.CancellationToken.None);await this.fileService.writeFile(h.previewResource,R.VSBuffer.fromString(d?.content||""));const p=d&&!d.hasConflicts?await this.getAcceptResult(h,h.previewResource,void 0,T.CancellationToken.None):void 0;return h.acceptResult=p,h.mergeState=d.hasConflicts?"conflict":p?"accepted":"preview",h.localChange=p?p.localChange:d.localChange,h.remoteChange=p?p.remoteChange:d.remoteChange,h}),this.syncPreviewPromise}async accept(l,h){return await this.updateSyncResourcePreview(l,async d=>{const p=await this.getAcceptResult(d,l,h,T.CancellationToken.None);return d.acceptResult=p,d.mergeState="accepted",d.localChange=p.localChange,d.remoteChange=p.remoteChange,d}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async h=>{const d=await this.getMergeResult(h,T.CancellationToken.None);return await this.fileService.writeFile(h.previewResource,R.VSBuffer.fromString(d.content||"")),h.acceptResult=void 0,h.mergeState="preview",h.localChange=d.localChange,h.remoteChange=d.remoteChange,h}),this.syncPreviewPromise}async updateSyncResourcePreview(l,h){if(!this.syncPreviewPromise)return;let d=await this.syncPreviewPromise;const p=d.resourcePreviews.findIndex(({localResource:A,remoteResource:O,previewResource:S})=>this.extUri.isEqual(A,l)||this.extUri.isEqual(O,l)||this.extUri.isEqual(S,l));p!==-1&&(this.syncPreviewPromise=(0,L.createCancelablePromise)(async A=>{const O=[...d.resourcePreviews];return O[p]=await h(O[p]),{...d,resourcePreviews:O}}),d=await this.syncPreviewPromise,this.updateConflicts(d.resourcePreviews),d.resourcePreviews.some(({mergeState:A})=>A==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(l){if(!this.syncPreviewPromise)return"idle";const h=await this.syncPreviewPromise;return h.resourcePreviews.some(({mergeState:d})=>d==="conflict")?"hasConflicts":h.resourcePreviews.some(({mergeState:d})=>d!=="accepted")?"syncing":(await this.applyResult(h.remoteUserData,h.lastSyncUserData,h.resourcePreviews.map(d=>[d,d.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(l){}}updateConflicts(l){const h=l.filter(({mergeState:d})=>d==="conflict");(0,D.equals)(this._conflicts,h,(d,p)=>this.extUri.isEqual(d.previewResource,p.previewResource))||(this._conflicts=h,this._onDidChangeConflicts.fire(h))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:h,ref:d})=>({created:h,uri:this.toRemoteBackupResource(d)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:h,ref:d})=>({created:h,uri:this.toLocalBackupResource(d)}))}toRemoteBackupResource(l){return f.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return f.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const h=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(h))){const{content:d}=await this.getUserData(h);if(d)return this.parseSyncData(d)?.machineId}}async resolveContent(l){const h=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(h))){const{content:d}=await this.getUserData(h);return d}return this.extUri.isEqual(l,this.toLocalBackupResource(h))?this.userDataSyncBackupStoreService.resolveContent(this.resource,h):null}async resolvePreviewContent(l){const h=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(h)for(const d of h.resourcePreviews){if(this.extUri.isEqual(d.acceptedResource,l))return d.acceptResult?d.acceptResult.content:null;if(this.extUri.isEqual(d.remoteResource,l))return d.remoteContent;if(this.extUri.isEqual(d.localResource,l))return d.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(l){}}async doGenerateSyncResourcePreview(l,h,d,p){const A=await this.isRemoteDataFromCurrentMachine(l),O=await this.generateSyncPreview(l,h,A,p),S=[];for(const U of O){const F=U.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(U.localChange===0&&U.remoteChange===0)S.push({...U,acceptedResource:F,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const z=d?await this.getMergeResult(U,p):void 0;if(p.isCancellationRequested)break;await this.fileService.writeFile(U.previewResource,R.VSBuffer.fromString(z?.content||""));const j=z&&!z.hasConflicts?await this.getAcceptResult(U,U.previewResource,void 0,p):void 0;S.push({...U,acceptResult:j,mergeState:z?.hasConflicts?"conflict":j?"accepted":"preview",localChange:j?j.localChange:z?z.localChange:U.localChange,remoteChange:j?j.remoteChange:z?z.remoteChange:U.remoteChange})}}return{remoteUserData:l,lastSyncUserData:h,resourcePreviews:S,isLastSyncFromCurrentMachine:A}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),h=JSON.parse(l.value.toString()),d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=h.version&&d&&h.version!==d,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${h.version} is not compatible with current sync state version ${d}.`),await this.resetLocal(),null;const p=h;if(p.content===null)return{ref:h.ref,syncData:null};const A=JSON.parse(p.content);if(a(A))return{...h,syncData:A,content:void 0}}catch(l){l instanceof g.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,h={}){if(h.ref||h.content||h.version)throw new Error("Cannot have core properties as additional");const d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),p={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:d,...h};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(p)))}async getRemoteUserData(l){const{ref:h,content:d}=await this.getUserData(l);let p=null;return d!==null&&(p=this.parseSyncData(d)),{ref:h,syncData:p}}parseSyncData(l){try{const h=JSON.parse(l);if(a(h))return h}catch(h){this.logService.error(h)}throw new o.UserDataSyncError((0,I.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(l){if((0,C.isString)(l)){const h=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:h}}else{const h=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,h,this.syncHeaders)}}async updateRemoteUserData(l,h){const d=await this.currentMachineIdPromise,p={version:this.version,machineId:d,content:l};return h=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(p),h,this.syncHeaders),{ref:h,syncData:p}}async backupLocal(l){const h={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(h))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=de([X(1,g.IFileService),X(2,E.IEnvironmentService),X(3,m.IStorageService),X(4,o.IUserDataSyncStoreService),X(5,o.IUserDataSyncBackupStoreService),X(6,o.IUserDataSyncResourceEnablementService),X(7,v.ITelemetryService),X(8,o.IUserDataSyncLogService),X(9,u.IConfigurationService)],t),e.AbstractSynchroniser=t;let s=class extends t{constructor(l,h,d,p,A,O,S,U,F,z,j){super(h,d,p,A,O,S,U,F,z,j);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(M=>this.onFileChanges(M)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(l){return null}}async updateLocalFileContent(l,h,d){try{h?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(l),d?void 0:h):await this.fileService.createFile(this.file,R.VSBuffer.fromString(l),{overwrite:d})}catch(p){throw p instanceof g.FileOperationError&&p.fileOperationResult===1||p instanceof g.FileOperationError&&p.fileOperationResult===3?new o.UserDataSyncError(p.message,"LocalPreconditionFailed"):p}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};s=de([X(2,g.IFileService),X(3,E.IEnvironmentService),X(4,m.IStorageService),X(5,o.IUserDataSyncStoreService),X(6,o.IUserDataSyncBackupStoreService),X(7,o.IUserDataSyncResourceEnablementService),X(8,v.ITelemetryService),X(9,o.IUserDataSyncLogService),X(10,u.IConfigurationService)],s),e.AbstractFileSynchroniser=s;let n=class extends s{constructor(l,h,d,p,A,O,S,U,F,z,j,M){super(l,h,d,p,A,O,S,U,F,z,M);this.userDataSyncUtilService=j,this._formattingOptions=void 0}hasErrors(l){const h=[];return(0,P.parse)(l,h,{allowEmptyContent:!0,allowTrailingComma:!0}),h.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};n=de([X(2,g.IFileService),X(3,E.IEnvironmentService),X(4,m.IStorageService),X(5,o.IUserDataSyncStoreService),X(6,o.IUserDataSyncBackupStoreService),X(7,o.IUserDataSyncResourceEnablementService),X(8,v.ITelemetryService),X(9,o.IUserDataSyncLogService),X(10,o.IUserDataSyncUtilService),X(11,u.IConfigurationService)],n),e.AbstractJsonFileSynchroniser=n;let r=class{constructor(l,h,d,p){this.resource=l,this.environmentService=h,this.logService=d,this.fileService=p,this.extUri=this.fileService.hasCapability(h.userDataSyncHome,1024)?b.extUri:b.extUriIgnorePathCase,this.lastSyncResource=(0,o.getLastSyncResourceUri)(this.resource,h,b.extUri)}async initialize({ref:l,content:h}){if(!h){this.logService.info("Remote content does not exist.",this.resource);return}const d=this.parseSyncData(h);if(!d)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:l,syncData:d})}catch(A){this.logService.error(A)}}parseSyncData(l){try{const h=JSON.parse(l);if(a(h))return h}catch(h){this.logService.error(h)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,h={}){const d={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,...h};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(d)))}};r=de([X(1,E.IEnvironmentService),X(2,o.IUserDataSyncLogService),X(3,g.IFileService)],r),e.AbstractInitializer=r}),define(Z[199],ee([0,1,6,27,9,3,45,48,24,5,21,12,28,32,13,22,20,47,196,87,88,23]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I,u,E,g,w,m,v,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function t(l,h){const d=JSON.parse(l.content);if(l.version===1||l.version===2){const p=(await h.getInstalled(0)).filter(A=>A.isBuiltin);for(const A of d)l.version===1&&(A.enabled===!1&&(A.disabled=!0),delete A.enabled),l.version===2&&p.every(O=>!(0,I.areSameExtensions)(O.identifier,A.identifier))&&(A.installed=!0)}return d}function s(l,h,d){const p=d.get((0,I.getExtensionId)(l,h),0)||"{}";return JSON.parse(p)}e.getExtensionStorageState=s;function n(l,h,d,p){p.store((0,I.getExtensionId)(l,h),JSON.stringify(d),0,1)}e.storeExtensionStorageState=n;let r=class at extends w.AbstractSynchroniser{constructor(h,d,p,A,O,S,U,F,z,j,M,W,x,$){super("extensions",d,h,p,A,O,W,x,z,M);this.storageService=p,this.extensionManagementService=S,this.extensionEnablementService=U,this.ignoredExtensionsManagementService=F,this.extensionGalleryService=j,this.extensionsStorageSyncService=$,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.debounce(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,q=>q.some(({local:N})=>!!N)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,q=>!q.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(h,d){const p=h.syncData?await t(h.syncData,this.extensionManagementService):null,A=d?.skippedExtensions||[],O=d?.syncData?await t(d.syncData,this.extensionManagementService):null,S=await this.extensionManagementService.getInstalled(),U=this.getLocalExtensions(S),F=this.ignoredExtensionsManagementService.getIgnoredExtensions(S);p?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:j}=(0,m.merge)(U,p,O,A,F),M={local:z,remote:j,content:this.getPreviewContent(U,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:j!==null?2:0};return[{skippedExtensions:A,localResource:this.localResource,localContent:this.format(U),localExtensions:U,remoteResource:this.remoteResource,remoteContent:p?this.format(p):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(h,d,p,A){const O=[...d,...p],S=new Set,U=F=>{S.add(F.id.toLowerCase()),F.uuid&&S.add(F.uuid)};O.forEach(({identifier:F})=>U(F)),A.forEach(U);for(const F of h)S.has(F.identifier.id.toLowerCase())||F.identifier.uuid&&S.has(F.identifier.uuid)||O.push(F);return this.format(O)}async getMergeResult(h,d){return{...h.previewResult,hasConflicts:!1}}async getAcceptResult(h,d,p,A){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(d,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(h){const d=await this.extensionManagementService.getInstalled(),p=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),A=(0,m.merge)(h.localExtensions,null,null,h.skippedExtensions,p),{local:O,remote:S}=A;return{content:h.localContent,local:O,remote:S,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:S!==null?2:0}}async acceptRemote(h){const d=await this.extensionManagementService.getInstalled(),p=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),A=h.remoteContent?JSON.parse(h.remoteContent):null;if(A!==null){const O=(0,m.merge)(h.localExtensions,A,h.localExtensions,[],p),{local:S,remote:U}=O;return{content:h.remoteContent,local:S,remote:U,localChange:S.added.length>0||S.removed.length>0||S.updated.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(h,d,p,A){let{skippedExtensions:O,localExtensions:S}=p[0][0],{local:U,remote:F,localChange:z,remoteChange:j}=p[0][1];if(z===0&&j===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),z!==0&&(await this.backupLocal(JSON.stringify(S)),O=await this.updateLocalExtensions(U.added,U.removed,U.updated,O)),F){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const M=JSON.stringify(F.all);h=await this.updateRemoteUserData(M,A?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${F.added.length?` Added: ${JSON.stringify(F.added.map(W=>W.identifier.id))}.`:""}${F.updated.length?` Updated: ${JSON.stringify(F.updated.map(W=>W.identifier.id))}.`:""}${F.removed.length?` Removed: ${JSON.stringify(F.removed.map(W=>W.identifier.id))}.`:""}`)}d?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(h,{skippedExtensions:O}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${O.length?` Skipped: ${JSON.stringify(O.map(M=>M.identifier.id))}.`:""}`))}async getAssociatedResources({uri:h}){return[{resource:this.extUri.joinPath(h,"extensions.json"),comparableResource:at.EXTENSIONS_DATA_URI}]}async resolveContent(h){if(this.extUri.isEqual(h,at.EXTENSIONS_DATA_URI)){const p=await this.extensionManagementService.getInstalled(),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(p),O=this.getLocalExtensions(p).filter(S=>!A.some(U=>(0,I.areSameExtensions)({id:U},S.identifier)));return this.format(O)}if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h))return this.resolvePreviewContent(h);let d=await super.resolveContent(h);if(d)return d;if(d=await super.resolveContent(this.extUri.dirname(h)),d){const p=this.parseSyncData(d);if(p)switch(this.extUri.basename(h)){case"extensions.json":return this.format(this.parseExtensions(p))}}return null}format(h){h.sort((A,O)=>!A.identifier.uuid&&O.identifier.uuid?-1:A.identifier.uuid&&!O.identifier.uuid?1:(0,y.compare)(A.identifier.id,O.identifier.id));const d=JSON.stringify(h),p=(0,P.format)(d,void 0,{});return(0,k.applyEdits)(d,p)}async hasLocalData(){try{const h=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(h).some(p=>p.installed||p.disabled))return!0}catch(h){}return!1}async updateLocalExtensions(h,d,p,A){const O=[],S=[],U=await this.extensionManagementService.getInstalled();if(d.length){const z=U.filter(({identifier:j,isBuiltin:M})=>!M&&d.some(W=>(0,I.areSameExtensions)(j,W)));await D.Promises.settled(z.map(async j=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,j.identifier.id),await this.extensionManagementService.uninstall(j,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,j.identifier.id),O.push(j.identifier)}))}(h.length||p.length)&&await D.Promises.settled([...h,...p].map(async z=>{const j=U.find(W=>(0,I.areSameExtensions)(W.identifier,z.identifier));if(j&&j.isBuiltin){z.state&&j.manifest.version===z.version&&this.updateExtensionState(z.state,j.manifest.publisher,j.manifest.name,j.manifest.version),z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id),await this.extensionEnablementService.disableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id),await this.extensionEnablementService.enableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id)),O.push(z.identifier);return}const M=(await this.extensionGalleryService.getExtensions([z.identifier],L.CancellationToken.None))[0];if(z.state&&(j?j.manifest.version===z.version:!!M)){const W=j?j.manifest.publisher:M.publisher,x=j?j.manifest.name:M.name;this.updateExtensionState(z.state,W,x,j?.manifest.version)}if(M)try{z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id,M.version),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id,M.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id,M.version),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id,M.version)),j||(await this.extensionManagementService.canInstall(M)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,z.identifier.id,M.version),await this.extensionManagementService.installFromGallery(M,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,z.identifier.id,M.version),O.push(M.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),S.push(z)))}catch(W){S.push(z),W instanceof f.ExtensionManagementError&&W.code===f.INSTALL_ERROR_INCOMPATIBLE?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,M.displayName||M.identifier.id):(this.logService.error(W),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,M.displayName||M.identifier.id))}else S.push(z),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,z.identifier.id)}));const F=[];for(const z of A)O.some(j=>(0,I.areSameExtensions)(j,z.identifier))||F.push(z);for(const z of S)F.some(j=>(0,I.areSameExtensions)(j.identifier,z.identifier))||F.push(z);return F}updateExtensionState(h,d,p,A){const O=s(d,p,this.storageService),S=A?this.extensionsStorageSyncService.getKeysForSync({id:(0,I.getGalleryExtensionId)(d,p),version:A}):void 0;S?S.forEach(U=>{O[U]=h[U]}):Object.keys(h).forEach(U=>O[U]=h[U]),n(d,p,O,this.storageService)}parseExtensions(h){return JSON.parse(h.content)}getLocalExtensions(h){const d=this.extensionEnablementService.getDisabledExtensions();return h.map(({identifier:p,isBuiltin:A,manifest:O})=>{const S={identifier:p,version:O.version};d.some(U=>(0,I.areSameExtensions)(U,p))&&(S.disabled=!0),A||(S.installed=!0);try{const U=this.extensionsStorageSyncService.getKeysForSync({id:p.id,version:O.version});if(U){const F=s(O.publisher,O.name,this.storageService);S.state=Object.keys(F).reduce((z,j)=>(U.includes(j)&&(z[j]=F[j]),z),{})}}catch(U){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,R.getErrorMessage)(U))}return S})}};r.EXTENSIONS_DATA_URI=b.URI.from({scheme:a.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),r=de([X(0,C.IEnvironmentService),X(1,u.IFileService),X(2,E.IStorageService),X(3,a.IUserDataSyncStoreService),X(4,a.IUserDataSyncBackupStoreService),X(5,f.IExtensionManagementService),X(6,f.IGlobalExtensionEnablementService),X(7,o.IIgnoredExtensionsManagementService),X(8,a.IUserDataSyncLogService),X(9,f.IExtensionGalleryService),X(10,i.IConfigurationService),X(11,a.IUserDataSyncResourceEnablementService),X(12,g.ITelemetryService),X(13,v.IExtensionsStorageSyncService)],r),e.ExtensionsSynchroniser=r;let c=class extends w.AbstractInitializer{constructor(h,d,p,A,O){super("extensions",A,O,p);this.extensionManagementService=h,this.ignoredExtensionsManagementService=d}async parseExtensions(h){return h.syncData?await t(h.syncData,this.extensionManagementService):null}generatePreview(h,d){const p=[],A=[],O=[];for(const S of h){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(S.identifier.id))continue;const U=d.find(F=>(0,I.areSameExtensions)(F.identifier,S.identifier));U?(p.push(U),S.disabled&&O.push(S.identifier)):S.installed&&(A.push(S.identifier),S.disabled&&O.push(S.identifier))}return{installedExtensions:p,newExtensions:A,disabledExtensions:O,remoteExtensions:h}}};c=de([X(0,f.IExtensionManagementService),X(1,o.IIgnoredExtensionsManagementService),X(2,u.IFileService),X(3,C.IEnvironmentService),X(4,a.IUserDataSyncLogService)],c),e.AbstractExtensionsInitializer=c}),define(Z[200],ee([0,1,26,23]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(P,y,b,i,C){if(!y)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const f=T(P,y);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const I=b?T(b,y):{added:Object.keys(y).reduce((m,v)=>(m.add(v),m),new Set),removed:new Set,updated:new Set},u=b?T(b,P):{added:Object.keys(P).reduce((m,v)=>(m.add(v),m),new Set),removed:new Set,updated:new Set},E={added:{},removed:[],updated:{}},g=D.deepClone(y),w=!b;for(const m of u.added.values())m!==L.SYNC_SERVICE_URL_TYPE&&w&&I.added.has(m)||(g[m]=P[m]);for(const m of u.updated.values())g[m]=P[m];for(const m of u.removed.values())i.unregistered.includes(m)||delete g[m];for(const m of I.added.values()){const v=y[m];if(i.machine.includes(m)){C.info(`GlobalState: Skipped adding ${m} in local storage because it is declared as machine scoped.`);continue}if(b&&u.added.has(m))continue;const o=P[m];o&&o.value===v.value||m===L.SYNC_SERVICE_URL_TYPE&&w&&u.added.has(m)||(o?E.updated[m]=v:E.added[m]=v)}for(const m of I.updated.values()){const v=y[m];if(i.machine.includes(m)){C.info(`GlobalState: Skipped updating ${m} in local storage because it is declared as machine scoped.`);continue}if(u.updated.has(m)||u.removed.has(m))continue;const o=P[m];o&&o.value===v.value||(E.updated[m]=v)}for(const m of I.removed.values()){if(i.machine.includes(m)){C.trace(`GlobalState: Skipped removing ${m} in local storage because it is declared as machine scoped.`);continue}u.updated.has(m)||u.removed.has(m)||E.removed.push(m)}return{local:E,remote:k(g,y)?null:g}}e.merge=R;function T(P,y){const b=Object.keys(P),i=Object.keys(y),C=i.filter(u=>b.indexOf(u)===-1).reduce((u,E)=>(u.add(E),u),new Set),f=b.filter(u=>i.indexOf(u)===-1).reduce((u,E)=>(u.add(E),u),new Set),I=new Set;for(const u of b){if(f.has(u))continue;const E=P[u],g=y[u];D.equals(E,g)||I.add(u)}return{added:C,removed:f,updated:I}}function k(P,y){const{added:b,removed:i,updated:C}=T(P,y);return b.size===0&&i.size===0&&C.size===0}}),define(Z[201],ee([0,1,25,3,34,45,48,4,5,30,21,12,13,14,46,22,20,47,54,200,23]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I,u,E,g,w,m,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const a="globalState.argv.",t=["locale"];function s(h){const d=h.storage?Object.keys(h.storage).sort():[],p={};d.forEach(S=>p[S]=h.storage[S]),h.storage=p;const A=JSON.stringify(h),O=(0,k.format)(A,void 0,{});return(0,T.applyEdits)(A,O)}const n=1;let r=class ot extends w.AbstractSynchroniser{constructor(d,p,A,O,S,U,F,z,j){super("globalState",d,S,j,p,A,U,F,O,z);this.storageService=j,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(d.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(d.onDidFilesChange,M=>M.contains(this.environmentService.argvResource)),L.Event.filter(j.onDidChangeValue,M=>M.scope===0&&M.target!==void 0?M.target===0:j.keys(0,0).includes(M.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(d,p,A,O){const S=d.syncData?JSON.parse(d.syncData.content):null;p=p===null&&A?d:p;const U=p&&p.syncData?JSON.parse(p.syncData.content):null,F=await this.getLocalGlobalState();S?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const z=this.getStorageKeys(U),{local:j,remote:M}=(0,v.merge)(F.storage,S?S.storage:null,U?U.storage:null,z,this.logService),W={content:null,local:j,remote:M,localChange:Object.keys(j.added).length>0||Object.keys(j.updated).length>0||j.removed.length>0?2:0,remoteChange:M!==null?2:0};return[{localResource:this.localResource,localContent:s(F),localUserData:F,remoteResource:this.remoteResource,remoteContent:S?s(S):null,previewResource:this.previewResource,previewResult:W,localChange:W.localChange,remoteChange:W.remoteChange,acceptedResource:this.acceptedResource,storageKeys:z}]}async getMergeResult(d,p){return{...d.previewResult,hasConflicts:!1}}async getAcceptResult(d,p,A,O){if(this.extUri.isEqual(p,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(p,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(p,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${p.toString()}`)}async acceptLocal(d){return{content:d.localContent,local:{added:{},removed:[],updated:{}},remote:d.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(d){if(d.remoteContent!==null){const p=JSON.parse(d.remoteContent),{local:A,remote:O}=(0,v.merge)(d.localUserData.storage,p.storage,null,d.storageKeys,this.logService);return{content:d.remoteContent,local:A,remote:O,localChange:Object.keys(A.added).length>0||Object.keys(A.updated).length>0||A.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:d.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(d,p,A,O){let{localUserData:S}=A[0][0],{local:U,remote:F,localChange:z,remoteChange:j}=A[0][1];if(z===0&&j===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),z!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(S)),await this.writeLocalGlobalState(U),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),j!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const M=JSON.stringify({storage:F});d=await this.updateRemoteUserData(M,O?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}p?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,ot.GLOBAL_STATE_DATA_URI)){const A=await this.getLocalGlobalState();return s(A)}if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let p=await super.resolveContent(d);if(p)return p;if(p=await super.resolveContent(this.extUri.dirname(d)),p){const A=this.parseSyncData(p);if(A)switch(this.extUri.basename(d)){case"globalState.json":return s(JSON.parse(A.content))}}return null}async hasLocalData(){try{const{storage:d}=await this.getLocalGlobalState();if(Object.keys(d).length>1||d[`${a}.locale`]?.value!=="en")return!0}catch(d){}return!1}async getLocalGlobalState(){const d={},p=await this.getLocalArgvContent(),A=(0,R.parse)(p);for(const O of t)A[O]!==void 0&&(d[`${a}${O}`]={version:1,value:A[O]});for(const O of this.storageService.keys(0,0)){const S=this.storageService.get(O,0);S&&(d[O]={version:1,value:S})}return{storage:d}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(d){}return"{}"}async writeLocalGlobalState({added:d,removed:p,updated:A}){const O={},S={},U=(z,j)=>{for(const M of z){if(M.startsWith(a)){O[M.substring(a.length)]=j?j[M].value:void 0;continue}if(j){const W=j[M];W.value!==String(this.storageService.get(M,0))&&(S[M]=W.value)}else this.storageService.get(M,0)!==void 0&&(S[M]=void 0)}};if(U(Object.keys(d),d),U(Object.keys(A),A),U(p),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(S).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const z of Object.keys(S))this.storageService.store(z,S[z],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(S))}}async updateArgv(d){const p=await this.getLocalArgvContent();let A=p;for(const O of Object.keys(d))A=(0,m.edit)(A,[O],d[O],{});p!==A&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(A)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(d){const p=this.storageService.keys(0,0),A=this.storageService.keys(0,1),O=[...p,...A],S=d?.storage?Object.keys(d.storage).filter(U=>!U.startsWith(a)&&!O.includes(U)&&this.storageService.get(U,0)!==void 0):[];if(!P.isWeb){const U=[...o.ALL_SYNC_RESOURCES.map(F=>(0,o.getEnablementKey)(F)),o.SYNC_SERVICE_URL_TYPE];S.push(...U),A.push(...U)}return{user:p,machine:A,unregistered:S}}};r.GLOBAL_STATE_DATA_URI=y.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),r=de([X(0,f.IFileService),X(1,o.IUserDataSyncStoreService),X(2,o.IUserDataSyncBackupStoreService),X(3,o.IUserDataSyncLogService),X(4,C.IEnvironmentService),X(5,o.IUserDataSyncResourceEnablementService),X(6,g.ITelemetryService),X(7,i.IConfigurationService),X(8,E.IStorageService)],r),e.GlobalStateSynchroniser=r;let c=class extends w.AbstractInitializer{constructor(d,p,A,O){super("globalState",A,O,p);this.storageService=d}async doInitialize(d){const p=d.syncData?JSON.parse(d.syncData.content):null;if(!p){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const A={},O={};for(const S of Object.keys(p.storage))S.startsWith(a)?A[S.substring(a.length)]=p.storage[S].value:this.storageService.get(S,0)===void 0&&(O[S]=p.storage[S].value);if(Object.keys(A).length){let S="{}";try{S=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(U){}for(const U of Object.keys(A))S=(0,m.edit)(S,[U],A[U],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(S))}if(Object.keys(O).length)for(const S of Object.keys(O))this.storageService.store(S,O[S],0,0)}};c=de([X(0,E.IStorageService),X(1,f.IFileService),X(2,C.IEnvironmentService),X(3,o.IUserDataSyncLogService)],c),e.GlobalStateInitializer=c;let l=class{constructor(d,p,A,O,S){this.userDataSyncStoreClient=d,this.storageService=p,this.environmentService=A,this.fileService=O,this.logService=S}getSyncStoreType(d){return this.parseGlobalState(d)?.storage[o.SYNC_SERVICE_URL_TYPE]?.value}async sync(d){const p=(0,o.createSyncHeaders)((0,b.generateUuid)());try{return await this.doSync(d,p)}catch(A){if(A instanceof o.UserDataSyncError)switch(A.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(d,p)}throw A}}async doSync(d,p){const A=await this.userDataSyncStoreClient.read("globalState",null,p),O=this.parseGlobalState(A)||{storage:{}};O.storage[o.SYNC_SERVICE_URL_TYPE]={value:d,version:n};const S=await(0,u.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),U={version:n,machineId:S,content:s(O)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(U),A.ref,p)}parseGlobalState({content:d}){if(!d)return null;const p=JSON.parse(d);if((0,w.isSyncData)(p))return p?JSON.parse(p.content):null;throw new Error("Invalid remote data")}};l=de([X(1,E.IStorageService),X(2,C.IEnvironmentService),X(3,f.IFileService),X(4,I.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(Z[202],ee([0,1,18,25,3,34,4,16,129,21,12,13,22,20,47,197,23]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I,u,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(o,a){const t=JSON.parse(o);if(!a)return(0,P.isUndefined)(t.all)?null:t.all;switch(k.OS){case 2:return(0,P.isUndefined)(t.mac)?null:t.mac;case 3:return(0,P.isUndefined)(t.linux)?null:t.linux;case 1:return(0,P.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=w;let m=class extends u.AbstractJsonFileSynchroniser{constructor(a,t,s,n,r,c,l,h,d,p){super(l.keybindingsResource,"keybindings",c,l,h,a,t,r,p,s,d,n);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(n.onDidChangeConfiguration,A=>A.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(a,t,s,n){const r=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;t=t===null&&s?a:t;const c=t?this.getKeybindingsContentFromLastSyncUserData(t):null,l=await this.getLocalFileContent(),h=await this.getFormattingOptions();let d=null,p=!1,A=!1,O=!1;if(r){let U=l?l.value.toString():"[]";if(U=U||"[]",this.hasErrors(U))throw new g.UserDataSyncError((0,y.localize)(0,null),"LocalInvalidContent",this.resource);if(!c||c!==U||c!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const F=await(0,E.merge)(U,r,c,h,this.userDataSyncUtilService);F.hasChanges&&(d=F.mergeContent,O=F.hasConflicts,p=O||F.mergeContent!==U,A=O||F.mergeContent!==r)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),d=l.value.toString(),A=!0);const S={content:d,localChange:p?l?2:1:0,remoteChange:A?2:0,hasConflicts:O};return[{fileContent:l,localResource:this.localResource,localContent:l?l.value.toString():null,localChange:S.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:S.remoteChange,previewResource:this.previewResource,previewResult:S,acceptedResource:this.acceptedResource}]}async getMergeResult(a,t){return a.previewResult}async getAcceptResult(a,t,s,n){if(this.extUri.isEqual(t,this.localResource))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return s===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(a,t,s,n){const{fileContent:r}=s[0][0];let{content:c,localChange:l,remoteChange:h}=s[0][1];if(l===0&&h===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),c!==null&&(c=c.trim(),c=c||"[]",this.hasErrors(c)))throw new g.UserDataSyncError((0,y.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),r&&await this.backupLocal(this.toSyncContent(r.value.toString())),await this.updateLocalFileContent(c||"[]",r,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),h!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const d=this.toSyncContent(c||"[]",a.syncData?.content);a=await this.updateRemoteUserData(d,n?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(d){}t?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(a,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.getLocalFileContent();if(a){const t=(0,T.parse)(a.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:a}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(a,"keybindings.json"),comparableResource:t}]}async resolveContent(a){if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a))return this.resolvePreviewContent(a);let t=await super.resolveContent(a);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(a)),t){const s=this.parseSyncData(t);if(s)switch(this.extUri.basename(a)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(s.content)}}return null}getKeybindingsContentFromLastSyncUserData(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(a.syncData.content)}getKeybindingsContentFromSyncContent(a){try{return w(a,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(a,t){let s={};try{s=JSON.parse(t||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=a,k.OS){case 2:s.mac=a;break;case 3:s.linux=a;break;case 1:s.windows=a;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};m=de([X(0,g.IUserDataSyncStoreService),X(1,g.IUserDataSyncBackupStoreService),X(2,g.IUserDataSyncLogService),X(3,b.IConfigurationService),X(4,g.IUserDataSyncResourceEnablementService),X(5,C.IFileService),X(6,i.IEnvironmentService),X(7,f.IStorageService),X(8,g.IUserDataSyncUtilService),X(9,I.ITelemetryService)],m),e.KeybindingsSynchroniser=m;let v=class extends u.AbstractInitializer{constructor(a,t,s){super("keybindings",t,s,a)}async doInitialize(a){const t=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,L.VSBuffer.fromString(t)),await this.updateLastSyncUserData(a)}async isEmpty(){try{const a=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,T.parse)(a.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(a){return a.fileOperationResult===1}}getKeybindingsContentFromSyncContent(a){try{return w(a,!0)}catch(t){return this.logService.error(t),null}}};v=de([X(0,C.IFileService),X(1,i.IEnvironmentService),X(2,g.IUserDataSyncLogService)],v),e.KeybindingsInitializer=v}),define(Z[203],ee([0,1,18,34,45,48,26,54,23]),function(K,e,D,L,R,T,k,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function b(l,h,d){let p=[];d?p=C(d):p=i(h);const A=[],O=[...(0,y.getDisallowedIgnoredSettings)()];if(Array.isArray(p))for(const S of p)S.startsWith("-")?O.push(S.substring(1)):A.push(S);return(0,D.distinct)([...l,...A].filter(S=>O.indexOf(S)===-1))}e.getIgnoredSettings=b;function i(l){let h=l.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=l.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:l.getValue("settingsSync.ignoredSettings")||[]}function C(l){const h=(0,L.parse)(l);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function f(l,h,d,p){if(d.length){const A=c(h),O=(0,L.parse)(h),S=(0,L.parse)(l),U=[];for(const F of d){const z=O[F],j=S[F];z===void 0?l=P.edit(l,[F],void 0,p):j!==void 0?l=P.edit(l,[F],z,p):U.push(a(F,A))}U.sort((F,z)=>F.startOffset-z.startOffset),U.forEach(F=>l=w(F.setting.key,h,l,p))}return l}e.updateIgnoredSettings=f;function I(l,h,d,p,A,O){const S=f(l,h,p,O),U=d!==S,F=d!==h;if(!U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:S,hasConflicts:!1};if(F&&!U)return{conflictsSettings:[],localContent:f(h,l,p,O),remoteContent:null,hasConflicts:!1};if(d===null&&E(l)){const H=u(l,h,p)?null:f(h,l,p,O);return{conflictsSettings:[],localContent:H,remoteContent:null,hasConflicts:!1}}let z=l,j=h;const M=(0,L.parse)(l),W=(0,L.parse)(h),x=d?(0,L.parse)(d):null,$=p.reduce((H,re)=>(H.add(re),H),new Set),q=g(M,W,$),N=g(x,M,$),V=g(x,W,$),_=new Map,Y=new Set,G=H=>{Y.add(H);const re=A.filter(({key:ie})=>ie===H)[0];re?(z=P.edit(z,[H],re.value,O),j=P.edit(j,[H],re.value,O)):_.set(H,{key:H,localValue:M[H],remoteValue:W[H]})};for(const H of N.removed.values())V.updated.has(H)?G(H):j=P.edit(j,[H],void 0,O);for(const H of V.removed.values())Y.has(H)||(N.updated.has(H)?G(H):z=P.edit(z,[H],void 0,O));for(const H of N.updated.values())Y.has(H)||(V.updated.has(H)?q.updated.has(H)&&G(H):j=P.edit(j,[H],M[H],O));for(const H of V.updated.values())Y.has(H)||(N.updated.has(H)?q.updated.has(H)&&G(H):z=P.edit(z,[H],W[H],O));for(const H of N.added.values())Y.has(H)||(V.added.has(H)?q.updated.has(H)&&G(H):j=w(H,z,j,O));for(const H of V.added.values())Y.has(H)||(N.added.has(H)?q.updated.has(H)&&G(H):z=w(H,j,z,O));const te=_.size>0||!u(z,j,p),ne=te||!u(z,l,[]),J=te||!u(j,h,[]);return{localContent:ne?z:null,remoteContent:J?j:null,conflictsSettings:[..._.values()],hasConflicts:te}}e.merge=I;function u(l,h,d){if(l===h)return!0;const p=(0,L.parse)(l),A=(0,L.parse)(h),O=d.reduce((F,z)=>(F.add(z),F),new Set),S=c(l).filter(F=>!(F.setting&&O.has(F.setting.key))),U=c(h).filter(F=>!(F.setting&&O.has(F.setting.key)));if(S.length!==U.length)return!1;for(let F=0;F<S.length;F++){const z=S[F],j=U[F];if(z.setting&&j.setting){if(z.setting.key!==j.setting.key||!k.equals(p[z.setting.key],A[z.setting.key]))return!1}else if(!z.setting&&!j.setting){if(z.value!==j.value)return!1}else return!1}return!0}e.areSame=u;function E(l){return l?c(l).length===0:!0}e.isEmpty=E;function g(l,h,d){const p=l?Object.keys(l).filter(F=>!d.has(F)):[],A=Object.keys(h).filter(F=>!d.has(F)),O=A.filter(F=>p.indexOf(F)===-1).reduce((F,z)=>(F.add(z),F),new Set),S=p.filter(F=>A.indexOf(F)===-1).reduce((F,z)=>(F.add(z),F),new Set),U=new Set;if(l)for(const F of p){if(S.has(F))continue;const z=l[F],j=h[F];k.equals(z,j)||U.add(F)}return{added:O,removed:S,updated:U}}function w(l,h,d,p){const A=(0,L.parse)(h),O=c(h),S=c(d),U=m(l,O,S);return v(d,l,A[l],U,S,p)}e.addSetting=w;function m(l,h,d){const p=h.findIndex(O=>O.setting?.key===l),A=h[p-1];if(A){if(A.setting){const S=a(A.setting.key,d);if(S)return{index:d.indexOf(S),insertAfter:!0}}else{const S=t(p,h);if(S){const U=a(S.setting.key,d);if(U){const F=s(d.indexOf(U),d),z=n(h,S,h[p]);if(F){const j=n(d,U,F),M=r(z,j);return M?{index:d.indexOf(M),insertAfter:!0}:{index:d.indexOf(F),insertAfter:!1}}else{const j=n(d,U,d[d.length-1]),M=r(z,j);return M?{index:d.indexOf(M),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const O=h[p+1];if(O)if(O.setting){const S=a(O.setting.key,d);if(S)return{index:d.indexOf(S),insertAfter:!1}}else{const S=s(p,h);if(S){const U=a(S.setting.key,d);if(U){const F=t(d.indexOf(U),d),z=n(h,h[p],S);if(F){const j=n(d,F,U),M=r(z.reverse(),j.reverse());return M?{index:d.indexOf(M),insertAfter:!1}:{index:d.indexOf(F),insertAfter:!0}}else{const j=n(d,d[0],U),M=r(z.reverse(),j.reverse());return M?{index:d.indexOf(M),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function v(l,h,d,p,A,O){let S;return p.index===-1?S=(0,R.setProperty)(l,[h],d,O):S=o(l,h,d,p,A,O).map(U=>(0,R.withFormatting)(l,U,O)[0]),(0,R.applyEdits)(l,S)}function o(l,h,d,p,A,O){const S=`${JSON.stringify(h)}: ${JSON.stringify(d)}`,U=(0,T.getEOL)(O,l),F=A[p.index];if(p.insertAfter){const z=[];if(F.setting)z.push({offset:F.endOffset,length:0,content:","+S});else{const j=s(p.index,A),M=t(p.index,A),W=M?.setting?.commaOffset;M&&W===void 0&&z.push({offset:M.endOffset,length:0,content:","});const x=W!==void 0&&W>F.endOffset;z.push({offset:x?W+1:F.endOffset,length:0,content:j?U+S+",":U+S})}return z}else{if(F.setting)return[{offset:F.startOffset,length:0,content:S+","}];const z=(A[p.index-1]&&!A[p.index-1].setting?U:"")+S+(s(p.index,A)?",":"")+U;return[{offset:F.startOffset,length:0,content:z}]}}function a(l,h){return h.filter(d=>d.setting?.key===l)[0]}function t(l,h){for(let d=l-1;d>=0;d--)if(h[d].setting)return h[d]}function s(l,h){for(let d=l+1;d<h.length;d++)if(h[d].setting)return h[d]}function n(l,h,d){const p=l.indexOf(h),A=l.indexOf(d);return l.filter((O,S)=>p<S&&S<A)}function r(l,h){if(l.length&&h.length){let d=0;for(;d<h.length&&d<l.length;d++)if(l[d].value!==h[d].value)return h[d-1];return h[d-1]}}function c(l){const h=[];let d=-1,p,A;const O={onObjectBegin:S=>{d++},onObjectProperty:(S,U,F)=>{d===0&&(p=U,A=S)},onObjectEnd:(S,U)=>{d--,d===0&&h.push({startOffset:p,endOffset:S+U,value:l.substring(p,S+U),setting:{key:A,commaOffset:void 0}})},onArrayBegin:(S,U)=>{d++},onArrayEnd:(S,U)=>{d--,d===0&&h.push({startOffset:p,endOffset:S+U,value:l.substring(p,S+U),setting:{key:A,commaOffset:void 0}})},onLiteralValue:(S,U,F)=>{d===0&&h.push({startOffset:p,endOffset:U+F,value:l.substring(p,U+F),setting:{key:A,commaOffset:void 0}})},onSeparator:(S,U,F)=>{if(d===0&&S===","){let z=h.length-1;for(;z>=0&&!h[z].setting;z--);const j=h[z];j&&h.splice(z,1,{startOffset:j.startOffset,endOffset:j.endOffset,value:j.value,setting:{key:j.setting.key,commaOffset:U}})}},onComment:(S,U)=>{d===0&&h.push({startOffset:S,endOffset:S+U,value:l.substring(S,S+U)})}};return(0,L.visit)(l,O),h}}),define(Z[204],ee([0,1,25,3,45,130,21,12,28,13,22,20,47,54,203,23]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(a){return a&&a.settings&&typeof a.settings=="string"&&Object.keys(a).length===1}function w(a){const t=JSON.parse(a);return g(t)?t:{settings:a}}e.parseSettingsSyncContent=w;let m=class extends f.AbstractJsonFileSynchroniser{constructor(t,s,n,r,c,l,h,d,p,A,O){super(s.settingsResource,"settings",t,s,n,r,c,p,A,l,h,d);this.extensionManagementService=O,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,s,n,r){const c=await this.getLocalFileContent(),l=await this.getFormattingOptions(),h=this.getSettingsSyncContent(t);s=s===null&&n?t:s;const d=s?this.getSettingsSyncContent(s):null,p=await this.getIgnoredSettings();let A=null,O=!1,S=!1,U=!1;if(h){let z=c?c.value.toString().trim():"{}";z=z||"{}",this.validateContent(z),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const j=(0,u.merge)(z,h.settings,d?d.settings:null,p,[],l);A=j.localContent||j.remoteContent,O=j.localContent!==null,S=j.remoteContent!==null,U=j.hasConflicts}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),A=c.value.toString(),S=!0);const F={content:A,localChange:O?2:0,remoteChange:S?2:0,hasConflicts:U};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:h?h.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async getMergeResult(t,s){const n=await this.getFormattingOptions(),r=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,u.updateIgnoredSettings)(t.previewResult.content,"{}",r,n):null}}async getAcceptResult(t,s,n,r){const c=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(s,this.localResource))return{content:t.fileContent?(0,u.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",l,c):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(s,this.remoteResource))return{content:t.remoteContent!==null?(0,u.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",l,c):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(s,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,u.updateIgnoredSettings)(n,t.fileContent?t.fileContent.value.toString():"{}",l,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async applyResult(t,s,n,r){const{fileContent:c}=n[0][0];let{content:l,localChange:h,remoteChange:d}=n[0][1];if(h===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),c&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(c.value.toString()))),await this.updateLocalFileContent(l,c,r),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),d!==0){const p=await this.getFormattingOptions(),A=this.getSettingsSyncContent(t),O=await this.getIgnoredSettings(l);l=(0,u.updateIgnoredSettings)(l,A?A.settings:"{}",O,p),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),r?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(p){}s?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const s=await this.getFormattingOptions(),n=(0,I.edit)(t.value.toString(),[E.CONFIGURATION_SYNC_STORE_KEY],void 0,s);return!(0,u.isEmpty)(n)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const s=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:s}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let s=await super.resolveContent(t);if(s)return s;if(s=await super.resolveContent(this.extUri.dirname(t)),s){const n=this.parseSyncData(s);if(n){const r=this.parseSettingsSyncContent(n.content);if(r)switch(this.extUri.basename(t)){case"settings.json":return r.settings}}}return null}async resolvePreviewContent(t){let s=await super.resolvePreviewContent(t);if(s){const n=await this.getFormattingOptions(),r=await this.getIgnoredSettings();s=(0,u.updateIgnoredSettings)(s,"{}",r,n)}return s}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return w(t)}catch(s){this.logService.error(s)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,r=>r.some(({local:c})=>!!c)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,r=>!r.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const s=await this._defaultIgnoredSettings;return(0,u.getIgnoredSettings)(s,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new E.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const s=JSON.parse(t.value.toString());if(!o(s))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const n=this.parseSettingsSyncContent(s.content);if(!n||!n.settings)return;let r=n.settings;const c=await this.getFormattingOptions();for(const l in s)if(["version","content","machineId"].indexOf(l)===-1&&s[l]!==void 0){const h=(0,R.setProperty)(r,[l],s[l],c);h.length&&(r=(0,R.applyEdits)(r,h))}await this.fileService.writeFile(this.file,D.VSBuffer.fromString(r))}catch(t){}}};m=de([X(0,b.IFileService),X(1,P.IEnvironmentService),X(2,i.IStorageService),X(3,E.IUserDataSyncStoreService),X(4,E.IUserDataSyncBackupStoreService),X(5,E.IUserDataSyncLogService),X(6,E.IUserDataSyncUtilService),X(7,k.IConfigurationService),X(8,E.IUserDataSyncResourceEnablementService),X(9,C.ITelemetryService),X(10,y.IExtensionManagementService)],m),e.SettingsSynchroniser=m;let v=class extends f.AbstractInitializer{constructor(t,s,n){super("settings",s,n,t)}async doInitialize(t){const s=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!s){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(s.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,u.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return w(t)}catch(s){this.logService.error(s)}return null}};v=de([X(0,b.IFileService),X(1,P.IEnvironmentService),X(2,E.IUserDataSyncLogService)],v),e.SettingsInitializer=v;function o(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&a.machineId!==void 0&&typeof a.machineId=="string")}}),define(Z[205],ee([0,1,25,3,26,21,12,13,22,20,47,198,23]),function(K,e,D,L,R,T,k,P,y,b,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let I=class extends i.AbstractSynchroniser{constructor(g,w,m,v,o,a,t,s,n){super("snippets",w,g,m,v,o,s,n,a,t);this.version=1,this.snippetsFolder=g.snippetsHome,this._register(this.fileService.watch(g.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(L.Event.filter(this.fileService.onDidFilesChange,r=>r.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,w,m,v){const o=await this.getSnippetsFileContents(),a=this.toSnippetsContents(o),t=g.syncData?this.parseSnippets(g.syncData):null;w=w===null&&m?g:w;const s=w&&w.syncData?this.parseSnippets(w.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,C.merge)(a,t,s);return this.getResourcePreviews(n,o,t||{})}async getMergeResult(g,w){return g.previewResult}async getAcceptResult(g,w,m,v){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return m===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:m,localChange:m===null?g.fileContent!==null?3:0:2,remoteChange:m===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(g,w,m,v){const o=m.map(([a,t])=>({...a,acceptResult:t}));o.every(({localChange:a,remoteChange:t})=>a===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:a})=>a!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,v)),o.some(({remoteChange:a})=>a!==0)&&(g=await this.updateRemoteSnippets(o,g,v)),w?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:a}of o)try{await this.fileService.del(a)}catch(t){}}getResourcePreviews(g,w,m){const v=new Map;for(const o of Object.keys(g.local.added)){const a={content:g.local.added[o],hasConflicts:!1,localChange:1,remoteChange:0};v.set(o,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(g.local.updated)){const a={content:g.local.updated[o],hasConflicts:!1,localChange:2,remoteChange:0};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o],localContent:w[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of g.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o],localContent:w[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(g.remote.added)){const a={content:g.remote.added[o],hasConflicts:!1,localChange:0,remoteChange:1};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o],localContent:w[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(g.remote.updated)){const a={content:g.remote.updated[o],hasConflicts:!1,localChange:0,remoteChange:2};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o],localContent:w[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of g.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of g.conflicts){const a={content:w[o]?w[o].value.toString():null,hasConflicts:!0,localChange:w[o]?2:1,remoteChange:m[o]?2:1};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o]||null,localContent:w[o]?w[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(w))if(!v.has(o)){const a={content:w[o]?w[o].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o]||null,localContent:w[o]?w[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...v.values()]}async getAssociatedResources({uri:g}){let w=await super.resolveContent(g);if(w){const m=this.parseSyncData(w);if(m){const v=this.parseSnippets(m),o=[];for(const a of Object.keys(v)){const t=this.extUri.joinPath(g,a),s=this.extUri.joinPath(this.snippetsFolder,a),n=await this.fileService.exists(s);o.push({resource:t,comparableResource:n?s:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})})}return o}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let w=await super.resolveContent(g);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(g)),w){const m=this.parseSyncData(w);if(m)return this.parseSnippets(m)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch(g){}return!1}async updateLocalBackup(g){const w={};for(const m of g)m.fileContent&&(w[this.extUri.basename(m.localResource)]=m.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(g,w){for(const{fileContent:m,acceptResult:v,localResource:o,remoteResource:a,localChange:t}of g)if(t!==0){const s=a?this.extUri.basename(a):this.extUri.basename(o),n=this.extUri.joinPath(this.snippetsFolder,s);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(n)),await this.fileService.del(n),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(n))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(n)),await this.fileService.createFile(n,D.VSBuffer.fromString(v.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(n))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(n)),await this.fileService.writeFile(n,D.VSBuffer.fromString(v.content),w?void 0:m),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(n)))}}async updateRemoteSnippets(g,w,m){const v=w.syncData?this.parseSnippets(w.syncData):{},o=(0,R.deepClone)(v);for(const{acceptResult:a,localResource:t,remoteResource:s,remoteChange:n}of g)if(n!==0){const r=t?this.extUri.basename(t):this.extUri.basename(s);n===3?delete o[r]:o[r]=a.content}return(0,C.areSame)(v,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(o),m?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const w={};for(const m of Object.keys(g))w[m]=g[m].value.toString();return w}async getSnippetsFileContents(){const g={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(m){if(m instanceof P.FileOperationError&&m.fileOperationResult===1)return g;throw m}for(const m of w.children||[]){const v=m.resource,o=this.extUri.extname(v);if(o===".json"||o===".code-snippets"){const a=this.extUri.relativePath(this.snippetsFolder,v),t=await this.fileService.readFile(v);g[a]=t}}return g}};I=de([X(0,k.IEnvironmentService),X(1,P.IFileService),X(2,y.IStorageService),X(3,f.IUserDataSyncStoreService),X(4,f.IUserDataSyncBackupStoreService),X(5,f.IUserDataSyncLogService),X(6,T.IConfigurationService),X(7,f.IUserDataSyncResourceEnablementService),X(8,b.ITelemetryService)],I),e.SnippetsSynchroniser=I;let u=class extends i.AbstractInitializer{constructor(g,w,m){super("snippets",w,m,g)}async doInitialize(g){const w=g.syncData?JSON.parse(g.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const v of Object.keys(w)){const o=w[v];if(o){const a=this.extUri.joinPath(this.environmentService.snippetsHome,v);await this.fileService.createFile(a,D.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(a))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};u=de([X(0,P.IFileService),X(1,k.IEnvironmentService),X(2,f.IUserDataSyncLogService)],u),e.SnippetsInitializer=u}),define(Z[60],ee([0,1,3,2,7,23]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let k=class extends L.Disposable{constructor(y){super();this.userDataSyncStoreService=y,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(y.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(y.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(y){(y&&this._account?y.token!==this._account.token||y.authenticationProviderId!==this._account.authenticationProviderId:y!==this._account)&&(this._account=y,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(y))}};k=de([X(0,T.IUserDataSyncStoreService)],k),e.UserDataSyncAccountService=k}),define(Z[206],ee([0,1,6,25,56,2,15,21,12,13,23]),function(K,e,D,L,R,T,k,P,y,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let C=class extends T.Disposable{constructor(I,u,E,g){super();this.environmentService=I,this.fileService=u,this.configurationService=E,this.logService=g,i.ALL_SYNC_RESOURCES.forEach(w=>this.cleanUpBackup(w))}async getAllRefs(I){const u=(0,k.joinPath)(this.environmentService.userDataSyncHome,I),E=await this.fileService.resolve(u);return E.children?E.children.filter(w=>w.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(w.name)).sort().reverse().map(w=>({ref:w.name,created:this.getCreationTime(w)})):[]}async resolveContent(I,u){if(!u){const E=await this.getAllRefs(I);E.length&&(u=E[E.length-1].ref)}if(u){const E=(0,k.joinPath)(this.environmentService.userDataSyncHome,I,u);return(await this.fileService.readFile(E)).value.toString()}return null}async backup(I,u){const E=(0,k.joinPath)(this.environmentService.userDataSyncHome,I),g=(0,k.joinPath)(E,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(g,L.VSBuffer.fromString(u))}catch(w){this.logService.error(w)}try{this.cleanUpBackup(I)}catch(w){}}async cleanUpBackup(I){const u=(0,k.joinPath)(this.environmentService.userDataSyncHome,I);try{try{if(!await this.fileService.exists(u))return}catch(g){return}const E=await this.fileService.resolve(u);if(E.children){const g=E.children.filter(o=>o.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(o.name)).sort(),w=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let m=g.filter(o=>Date.now()-this.getCreationTime(o)>w);const v=g.length-m.length;v<10&&(m=m.slice(10-v)),await D.Promises.settled(m.map(async o=>{this.logService.info("Deleting from backup",o.resource.path),await this.fileService.del(o.resource)}))}}catch(E){this.logService.error(E)}}getCreationTime(I){return I.ctime||new Date(parseInt(I.name.substring(0,4)),parseInt(I.name.substring(4,6))-1,parseInt(I.name.substring(6,8)),parseInt(I.name.substring(9,11)),parseInt(I.name.substring(11,13)),parseInt(I.name.substring(13,15))).getTime()}};C=de([X(0,y.IEnvironmentService),X(1,b.IFileService),X(2,P.IConfigurationService),X(3,i.IUserDataSyncLogService)],C),e.UserDataSyncBackupStoreService=C}),define(Z[207],ee([0,1,2,5]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(f){this.service=f}listen(f,I){switch(I){case"onError":return this.service.onError}throw new Error(`Event not found: ${I}`)}call(f,I,u){switch(I){case"triggerSync":return this.service.triggerSync(u[0],u[1],u[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(u[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class T{constructor(f){this.service=f}listen(f,I){throw new Error(`Event not found: ${I}`)}call(f,I,u){switch(I){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(u[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(L.URI.revive(u[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class k{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=k;class P{constructor(f){this.service=f}listen(f,I){switch(I){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${I}`)}async call(f,I,u){switch(I){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(u[0],u[1]);case"setEnablement":return this.service.setEnablement(u[0],u[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class y{constructor(f){this.service=f}listen(f,I){switch(I){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${I}`)}call(f,I,u){switch(I){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(u)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=y;class b{constructor(f){this.service=f}listen(f,I){switch(I){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${I}`)}call(f,I,u){switch(I){case"switch":return this.service.switch(u[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class i extends D.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:L.URI.revive(f.url),type:f.type,defaultUrl:L.URI.revive(f.defaultUrl),insidersUrl:L.URI.revive(f.insidersUrl),stableUrl:L.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=i}),define(Z[208],ee([0,1,12,14]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends L.AbstractLogger{constructor(k,P){super();this.logger=this._register(k.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(k,...P){this.logger.trace(k,...P)}debug(k,...P){this.logger.debug(k,...P)}info(k,...P){this.logger.info(k,...P)}warn(k,...P){this.logger.warn(k,...P)}error(k,...P){this.logger.error(k,...P)}critical(k,...P){this.logger.critical(k,...P)}flush(){this.logger.flush()}};R=de([X(0,L.ILoggerService),X(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(Z[61],ee([0,1,3,2,4,24,133,12,13,7,29,46,22,23]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const u="sync.currentMachineName";let E=class Je extends L.Disposable{constructor(w,m,v,o,a,t){super();this.storageService=v,this.userDataSyncStoreService=o,this.logService=a,this.productService=t,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(w,m,v)}async getMachines(w){const m=await this.currentMachineIdPromise;return(await this.readMachinesData(w)).machines.map(o=>({...o,isCurrent:o.id===m}))}async addCurrentMachine(w){const m=await this.currentMachineIdPromise,v=await this.readMachinesData(w);v.machines.some(({id:o})=>o===m)||(v.machines.push({id:m,name:this.computeCurrentMachineName(v.machines)}),await this.writeMachinesData(v))}async removeCurrentMachine(w){const m=await this.currentMachineIdPromise,v=await this.readMachinesData(w),o=v.machines.filter(({id:a})=>a!==m);o.length!==v.machines.length&&(v.machines=o,await this.writeMachinesData(v))}async renameMachine(w,m,v){const o=await this.currentMachineIdPromise,a=await this.readMachinesData(v),t=a.machines.find(({id:s})=>s===w);t&&(t.name=m,await this.writeMachinesData(a),a.machines.some(({id:s})=>s===o)&&this.storageService.store(u,m,0,1))}async setEnablement(w,m){const v=await this.readMachinesData(),o=v.machines.find(({id:a})=>a===w);o&&(o.disabled=m?void 0:!0,await this.writeMachinesData(v))}computeCurrentMachineName(w){const m=this.storageService.get(u,0);if(m)return m;const v=`${this.productService.nameLong} (${(0,R.PlatformToString)(R.isWeb?0:R.platform)})`,o=new RegExp(`${(0,T.escapeRegExpCharacters)(v)}\\s#(\\d+)`);let a=0;for(const t of w){const s=o.exec(t.name),n=s?parseInt(s[1]):0;a=n>a?n:a}return`${v} #${a+1}`}async readMachinesData(w){this.userData=await this.readUserData(w);const m=this.parse(this.userData);if(m.version!==Je.VERSION)throw new Error((0,k.localize)(0,null,this.productService.nameLong));return m}async writeMachinesData(w){const m=JSON.stringify(w),v=await this.userDataSyncStoreService.write(Je.RESOURCE,m,this.userData?.ref||null);this.userData={ref:v,content:m},this._onDidChange.fire()}async readUserData(w){if(this.userData){const m=w&&w.latest?w.latest[Je.RESOURCE]:void 0;if(this.userData.ref===m)return this.userData;if(m===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Je.RESOURCE,this.userData)}parse(w){if(w.content!==null)try{return JSON.parse(w.content)}catch(m){this.logService.error(m)}return{version:Je.VERSION,machines:[]}}};E.VERSION=1,E.RESOURCE="machines",E=de([X(0,P.IEnvironmentService),X(1,y.IFileService),X(2,f.IStorageService),X(3,I.IUserDataSyncStoreService),X(4,I.IUserDataSyncLogService),X(5,i.IProductService)],E),e.UserDataSyncMachinesService=E}),define(Z[89],ee([0,1,6,56,37,9,3,2,4,15,5,131,12,29,22,20,23,60,61]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I,u,E,g,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const v="sync.enable",o="sync.disableMachineEventually",a="sync.sessionId",t="sync.storeUrl",s="sync.productQuality";let n=class extends P.Disposable{constructor(h,d,p){super();this.storageService=h,this.environmentService=d,this.userDataSyncStoreManagementService=p,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(h.onDidChangeValue(A=>this.onDidStorageChange(A)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(v,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(h){h&&!this.canToggleEnablement()||this.storageService.store(v,h,0,1)}onDidStorageChange(h){if(h.scope===0&&v===h.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};n=de([X(0,u.IStorageService),X(1,f.IEnvironmentService),X(2,g.IUserDataSyncStoreManagementService)],n),e.UserDataAutoSyncEnablementService=n;let r=class extends P.Disposable{constructor(h,d,p,A,O,S,U,F,z,j,M){super();this.userDataSyncStoreManagementService=d,this.userDataSyncStoreService=p,this.userDataSyncResourceEnablementService=A,this.userDataSyncService=O,this.logService=S,this.userDataSyncAccountService=U,this.telemetryService=F,this.userDataSyncMachinesService=z,this.storageService=j,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=M,this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=h.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(d.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,d.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(U.onDidChangeAccount(()=>this.updateAutoSync())),this._register(p.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(O.onDidChangeLocal,(W,x)=>W?[...W,x]:[x],1e3)(W=>this.triggerSync(W,!1,!1))),this._register(k.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,W])=>W)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const h=this.storageService.get(t,0);return h?i.URI.parse(h):void 0}set syncUrl(h){h?this.storageService.store(t,h.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(s,0)}set productQuality(h){h?this.storageService.store(s,h,0,1):this.storageService.remove(s,0)}updateAutoSync(){const{enabled:h,message:d}=this.isAutoSyncEnabled();h?this.autoSync.value===void 0&&(this.autoSync.value=new c(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(p=>this.onDidFinishSync(p))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(d&&this.logService.info(d),this.autoSync.clear()):d&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(d))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(h,d,p){try{this.userDataSyncAccountService.account&&!p&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,0),h?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(A){if(d)this.logService.error(A),this.updateEnablement(!1);else throw A}}updateEnablement(h){this.userDataAutoSyncEnablementService.isEnabled()!==h&&(this.telemetryService.publicLog2(v,{enabled:h}),this.userDataAutoSyncEnablementService.setEnablement(h),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(h){if(!h){this.successiveFailures=0;return}const d=g.UserDataSyncError.toUserDataSyncError(h);d instanceof g.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:d.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),d.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):d.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):d.code==="LocalTooManyRequests"||d.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):d.code==="UpgradeRequired"||d.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):d.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with newer version than of client. Requires client upgrade.`)):d.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with older version than of client. Requires server reset.`)):d.code==="ServiceChanged"||d.code==="DefaultServiceChanged"?y.isWeb&&d.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(d),this.successiveFailures++),this._onError.fire(d)}async disableMachineEventually(){this.storageService.store(o,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(o,0,!1)}stopDisableMachineEventually(){this.storageService.remove(o,0)}async triggerSync(h,d,p){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(d&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...h),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",p)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=de([X(0,I.IProductService),X(1,g.IUserDataSyncStoreManagementService),X(2,g.IUserDataSyncStoreService),X(3,g.IUserDataSyncResourceEnablementService),X(4,g.IUserDataSyncService),X(5,g.IUserDataSyncLogService),X(6,w.IUserDataSyncAccountService),X(7,E.ITelemetryService),X(8,m.IUserDataSyncMachinesService),X(9,u.IStorageService),X(10,g.IUserDataAutoSyncEnablementService)],r),e.UserDataAutoSyncService=r;class c extends P.Disposable{constructor(h,d,p,A,O,S,U,F){super();this.lastSyncUrl=h,this.interval=d,this.userDataSyncStoreManagementService=p,this.userDataSyncStoreService=A,this.userDataSyncService=O,this.userDataSyncMachinesService=S,this.logService=U,this.storageService=F,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(c.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(c.INTERVAL_SYNCING,!1),this.interval)}sync(h,d){const p=(0,D.createCancelablePromise)(async A=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(O){if((0,T.isPromiseCanceledError)(O))return}return this.doSync(h,d,A)});return this.syncPromise=p,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const h=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),d=this.userDataSyncStoreManagementService.userDataSyncStore;return!!d&&!!h&&(!(0,b.isEqual)(d.defaultUrl,h.defaultUrl)||!(0,b.isEqual)(d.insidersUrl,h.insidersUrl)||!(0,b.isEqual)(d.stableUrl,h.stableUrl))}async doSync(h,d,p){this.logService.info(`Auto Sync: Triggered by ${h}`),this._onDidStartSync.fire();let A;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,d),p.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new g.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new g.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new g.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const O=this.storageService.get(a,0);if(O&&this.manifest&&O!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new g.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new g.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new g.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const S=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(p.isCancellationRequested)return;const U=S.find(F=>F.isCurrent);if(U?.disabled)throw new g.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(F){throw new g.UserDataAutoSyncError((0,R.toErrorMessage)(F),F instanceof g.UserDataSyncError?F.code:"Unknown")}if(this.manifest&&this.manifest.session!==O&&this.storageService.store(a,this.manifest.session,0,1),p.isCancellationRequested)return;U||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(O){this.logService.error(O),A=O}this._onDidFinishSync.fire(A)}register(h){return super._register(h)}}c.INTERVAL_SYNCING="Interval"}),define(Z[209],ee([0,1,3,2,4,22,20,23]),function(K,e,D,L,R,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let y=class extends L.Disposable{constructor(i,C){super();this.storageService=i,this.telemetryService=C,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(i.onDidChangeValue(f=>this.onDidStorageChange(f)))}isResourceEnabled(i){return this.storageService.getBoolean((0,P.getEnablementKey)(i),0,!0)}setResourceEnablement(i,C){if(this.isResourceEnabled(i)!==C){const f=(0,P.getEnablementKey)(i);this.telemetryService.publicLog2(f,{enabled:C}),this.storeResourceEnablement(f,C)}}getResourceSyncStateVersion(i){}storeResourceEnablement(i,C){this.storageService.store(i,C,0,R.isWeb?0:1)}onDidStorageChange(i){if(i.scope===0){const C=P.ALL_SYNC_RESOURCES.filter(f=>(0,P.getEnablementKey)(f)===i.key)[0];if(C){this._onDidChangeResourceEnablement.fire([C,this.isResourceEnabled(C)]);return}}}};y=de([X(0,T.IStorageService),X(1,k.ITelemetryService)],y),e.UserDataSyncResourceEnablementService=y}),define(Z[210],ee([0,1,18,6,37,9,3,2,15,30,7,22,20,199,201,202,204,205,23]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I,u,E,g,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const v="sync.lastSyncTime";let o=class extends P.Disposable{constructor(n,r,c,l,h,d){super();this.userDataSyncStoreService=n,this.userDataSyncStoreManagementService=r,this.instantiationService=c,this.logService=l,this.telemetryService=h,this.storageService=d,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(g.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(E.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(w.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(u.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(I.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(k.Event.any(...this.synchronisers.map(p=>k.Event.map(p.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(k.Event.any(...this.synchronisers.map(p=>k.Event.map(p.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(v,0,void 0),this.onDidChangeLocal=k.Event.any(...this.synchronisers.map(p=>k.Event.map(p.onDidChangeLocal,()=>p.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(n,r){await this.checkEnablement();const c=(0,b.generateUuid)();try{const p=(0,m.createSyncHeaders)(c);r&&(p["Cache-Control"]="no-cache"),n=await this.userDataSyncStoreService.manifest(n,p)}catch(p){const A=m.UserDataSyncError.toUserDataSyncError(p);throw this.reportUserDataSyncError(A,c),A}let l=!1;const h=this;let d;return{manifest:n,run(){if(l)throw new Error("Can run a task only once");return d=(0,L.createCancelablePromise)(p=>h.sync(n,c,p)),d.finally(()=>d=void 0)},async stop(){if(d&&d.cancel(),h.status!=="idle")return h.stop()}}}async createManualSyncTask(){await this.checkEnablement();const n=(0,b.generateUuid)(),r=(0,m.createSyncHeaders)(n);let c;try{c=await this.userDataSyncStoreService.manifest(null,r)}catch(l){const h=m.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(h,n),h}return new a(n,c,r,this.synchronisers,this.logService)}async sync(n,r,c){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),c.isCancellationRequested)return;const l=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const h=(0,m.createSyncHeaders)(r);for(const d of this.synchronisers){if(c.isCancellationRequested)return;try{await d.sync(n,h)}catch(p){let A=!1;if(p instanceof m.UserDataSyncError)switch(p.code){case"TooLarge":p=new m.UserDataSyncError(p.message,p.code,d.resource),A=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":A=!0;break}const O=m.UserDataSyncError.toUserDataSyncError(p);if(this.reportUserDataSyncError(O,r),A)throw O;this.logService.error(p),this.logService.error(`${d.resource}: ${(0,R.toErrorMessage)(p)}`),this._syncErrors.push([d.resource,O])}}this.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),this.updateLastSyncTime()}catch(h){const d=m.UserDataSyncError.toUserDataSyncError(h);throw this.reportUserDataSyncError(d,r),d}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const n of this.synchronisers)try{n.status!=="idle"&&await n.stop()}catch(r){this.logService.error(r)}}async replace(n){await this.checkEnablement();for(const r of this.synchronisers)if(await r.replace(n))return}async accept(n,r,c,l){await this.checkEnablement();const h=this.getSynchroniser(n);await h.accept(r,c),l&&await h.apply(!1,(0,m.createSyncHeaders)((0,b.generateUuid)()))}async resolveContent(n){for(const r of this.synchronisers){const c=await r.resolveContent(n);if(c)return c}return null}getRemoteSyncResourceHandles(n){return this.getSynchroniser(n).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(n){return this.getSynchroniser(n).getLocalSyncResourceHandles()}getAssociatedResources(n,r){return this.getSynchroniser(n).getAssociatedResources(r)}getMachineId(n,r){return this.getSynchroniser(n).getMachineId(r)}async hasLocalData(){const n=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const r of n)if(await r.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(n){this.logService.error(n)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(v,0);for(const n of this.synchronisers)try{await n.resetLocal()}catch(r){this.logService.error(`${n.resource}: ${(0,R.toErrorMessage)(r)}`),this.logService.error(r)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const n of this.synchronisers)if(await n.hasPreviouslySynced())return!0;return!1}setStatus(n){const r=this._status;this._status!==n&&(this._status=n,this._onDidChangeStatus.fire(n),r==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const n=this.computeStatus();this.setStatus(n)}updateConflicts(){const n=this.computeConflicts();(0,D.equals)(this._conflicts,n,([r,c],[l,h])=>r===r&&(0,D.equals)(c,h,(d,p)=>(0,y.isEqual)(d.previewResource,p.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(n))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(v,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(n,r){this.telemetryService.publicLog2("sync/error",{code:n.code,serverCode:n instanceof m.UserDataSyncStoreError?String(n.serverCode):void 0,url:n instanceof m.UserDataSyncStoreError?n.url:void 0,resource:n.resource,executionId:r,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(n=>n.status==="hasConflicts").map(n=>[n.resource,n.conflicts.map(t)])}getSynchroniser(n){return this.synchronisers.find(r=>r.resource===n)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};o=de([X(0,m.IUserDataSyncStoreService),X(1,m.IUserDataSyncStoreManagementService),X(2,i.IInstantiationService),X(3,m.IUserDataSyncLogService),X(4,f.ITelemetryService),X(5,C.IStorageService)],o),e.UserDataSyncService=o;class a extends P.Disposable{constructor(n,r,c,l,h){super();this.id=n,this.manifest=r,this.syncHeaders=c,this.synchronisers=l,this.logService=h,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new k.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,L.createCancelablePromise)(n=>this.getPreviews(n))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(n){throw this.logService.error(n),n}}async accept(n,r){try{return await this.performAction(n,c=>c.accept(n,r))}catch(c){throw this.logService.error(c),c}}async merge(n){try{return n?await this.performAction(n,r=>r.merge(n)):await this.mergeAll()}catch(r){throw this.logService.error(r),r}}async discard(n){try{return await this.performAction(n,r=>r.discard(n))}catch(r){throw this.logService.error(r),r}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const n=[];for(const[,r]of this.previews)for(const c of r.resourcePreviews)c.mergeState==="conflict"&&n.push(c.previewResource);for(const r of n)await this.discard(r);return this.previews}catch(n){throw this.logService.error(n),n}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const n=[];for(const[r,c]of this.previews){this.synchronizingResources.push([r,c.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===r);for(const d of c.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&await l.merge(d.previewResource);const h=await l.apply(!1,this.syncHeaders);h&&n.push(this.toSyncResourcePreview(l.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}catch(n){throw this.logService.error(n),n}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,r]of this.previews){this.synchronizingResources.push([n,r.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(l=>l.resource===n);for(const l of r.resourcePreviews)await c.accept(l.remoteResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,r]of this.previews){this.synchronizingResources.push([n,r.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(l=>l.resource===n);for(const l of r.resourcePreviews)await c.accept(l.localResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async stop(){for(const n of this.synchronisers)try{await n.stop()}catch(r){(0,T.isPromiseCanceledError)(r)||this.logService.error(r)}this.reset()}async performAction(n,r){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const c=this.previews.findIndex(([,U])=>U.resourcePreviews.some(({localResource:F,previewResource:z,remoteResource:j})=>(0,y.isEqual)(n,F)||(0,y.isEqual)(n,z)||(0,y.isEqual)(n,j)));if(c===-1)return this.previews;const[l,h]=this.previews[c],d=h.resourcePreviews.find(({localResource:U,remoteResource:F,previewResource:z})=>(0,y.isEqual)(U,n)||(0,y.isEqual)(F,n)||(0,y.isEqual)(z,n));if(!d)return this.previews;let p=this.synchronizingResources.find(U=>U[0]===l);p||(p=[l,[]],this.synchronizingResources.push(p)),p[1].some(U=>(0,y.isEqual)(U,d.localResource))||(p[1].push(d.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const A=this.synchronisers.find(U=>U.resource===this.previews[c][0]),O=await r(A);O?this.previews.splice(c,1,this.toSyncResourcePreview(A.resource,O)):this.previews.splice(c,1);const S=this.synchronizingResources.findIndex(U=>U[0]===l);return this.synchronizingResources[S][1].splice(p[1].findIndex(U=>(0,y.isEqual)(U,d.localResource)),1),p[1].length||(this.synchronizingResources.splice(S,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const n=[];for(const[r,c]of this.previews){this.synchronizingResources.push([r,c.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===r);let h=c;for(const d of c.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&(h=await l.merge(d.previewResource));h&&n.push(this.toSyncResourcePreview(l.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}async getPreviews(n){const r=[];for(const c of this.synchronisers){if(n.isCancellationRequested)return[];const l=await c.preview(this.manifest,this.syncHeaders);l&&r.push(this.toSyncResourcePreview(c.resource,l))}return r}toSyncResourcePreview(n,r){return[n,{isLastSyncFromCurrentMachine:r.isLastSyncFromCurrentMachine,resourcePreviews:r.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(s){return{localResource:s.localResource,previewResource:s.previewResource,remoteResource:s.remoteResource,acceptedResource:s.acceptedResource,localChange:s.localChange,remoteChange:s.remoteChange,mergeState:s.mergeState}}}),define(Z[211],ee([0,1,3,2,16,5,23]),function(K,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(C,f){this.service=C,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(C,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(C,f,I){try{return await this._call(C,f,I)}catch(u){throw this.logService.error(u),u}}async _call(C,f,I){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(I[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(I[0],T.URI.revive(I[1]),I[2],I[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(I[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(I[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(I[0]);case"getAssociatedResources":return this.service.getAssociatedResources(I[0],{created:I[1].created,uri:T.URI.revive(I[1].uri)});case"getMachineId":return this.service.getMachineId(I[0],{created:I[1].created,uri:T.URI.revive(I[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const u=f.substring("manualSync/".length),E=I[0],g=this.getManualSyncTask(E);switch(I=I.slice(1),u){case"preview":return g.preview();case"accept":return g.accept(T.URI.revive(I[0]),I[1]);case"merge":return g.merge(T.URI.revive(I[0]));case"discard":return g.discard(T.URI.revive(I[0]));case"discardConflicts":return g.discardConflicts();case"apply":return g.apply();case"pull":return g.pull();case"push":return g.push();case"stop":return g.stop();case"_getStatus":return g.status;case"dispose":return this.disposeManualSyncTask(g)}}throw new Error("Invalid call")}getManualSyncTask(C){const f=this.manualSyncTasks.get(this.createKey(C));if(!f)throw new Error(`Manual sync taks not found: ${C}`);return f.manualSyncTask}async createManualSyncTask(){const C=new L.DisposableStore,f=C.add(await this.service.createManualSyncTask());return C.add(f.onSynchronizeResources(I=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:I}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:C}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(C){C.dispose();const f=this.createKey(C.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(C){return`manualSyncTask-${C}`}}e.UserDataSyncChannel=P;class y extends L.Disposable{constructor(C){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,I,u){return C.call(f,I,u).then(null,E=>{throw k.UserDataSyncError.toUserDataSyncError(E)})},listen(f,I){return C.listen(f,I)}},this.channel.call("_getInitialData").then(([f,I,u])=>{this.updateStatus(f),this.updateConflicts(I),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(E=>this.updateStatus(E))),this._register(this.channel.listen("onDidChangeLastSyncTime")(E=>this.updateLastSyncTime(E)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([I,u])=>[I,k.UserDataSyncError.toUserDataSyncError(u)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:C,manifest:f,status:I}=await this.channel.call("createManualSyncTask"),u=this,E=new b(C,f,I,{async call(g,w,m){return u.channel.call(`manualSync/${g}`,[C,...(0,R.isArray)(w)?w:[w]],m)},listen(g,w){return D.Event.map(D.Event.filter(u.channel.listen(`manualSync/${g}`,w),m=>!E.isDiposed()&&m.manualSyncTaskId===C),m=>m.data)}});return E}replace(C){return this.channel.call("replace",[C])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(C,f,I,u){return this.channel.call("accept",[C,f,I,u])}resolveContent(C){return this.channel.call("resolveContent",[C])}async getLocalSyncResourceHandles(C){return(await this.channel.call("getLocalSyncResourceHandles",[C])).map(({created:I,uri:u})=>({created:I,uri:T.URI.revive(u)}))}async getRemoteSyncResourceHandles(C){return(await this.channel.call("getRemoteSyncResourceHandles",[C])).map(({created:I,uri:u})=>({created:I,uri:T.URI.revive(u)}))}async getAssociatedResources(C,f){return(await this.channel.call("getAssociatedResources",[C,f])).map(({resource:u,comparableResource:E})=>({resource:T.URI.revive(u),comparableResource:T.URI.revive(E)}))}async getMachineId(C,f){return this.channel.call("getMachineId",[C,f])}async updateStatus(C){this._status=C,this._onDidChangeStatus.fire(C)}async updateConflicts(C){this._conflicts=C.map(([f,I])=>[f,I.map(u=>({...u,localResource:T.URI.revive(u.localResource),remoteResource:T.URI.revive(u.remoteResource),previewResource:T.URI.revive(u.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(C){this._lastSyncTime!==C&&(this._lastSyncTime=C,this._onDidChangeLastSyncTime.fire(C))}}e.UserDataSyncChannelClient=y;class b extends L.Disposable{constructor(C,f,I,u){super();this.id=C,this.manifest=f,this._disposed=!1,this._status=I;const E=this;this.channel={async call(g,w,m){try{const v=await u.call(g,w,m);return E.isDiposed()||(E._status=await u.call("_getStatus")),v}catch(v){throw k.UserDataSyncError.toUserDataSyncError(v)}},listen(g,w){return u.listen(g,w)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const C=await this.channel.call("preview");return this.deserializePreviews(C)}async accept(C,f){const I=await this.channel.call("accept",[C,f]);return this.deserializePreviews(I)}async merge(C){const f=await this.channel.call("merge",[C]);return this.deserializePreviews(f)}async discard(C){const f=await this.channel.call("discard",[C]);return this.deserializePreviews(f)}async discardConflicts(){const C=await this.channel.call("discardConflicts");return this.deserializePreviews(C)}async apply(){const C=await this.channel.call("apply");return this.deserializePreviews(C)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(C){return C.map(([f,I])=>[f,{isLastSyncFromCurrentMachine:I.isLastSyncFromCurrentMachine,resourcePreviews:I.resourcePreviews.map(u=>({...u,localResource:T.URI.revive(u.localResource),remoteResource:T.URI.revive(u.remoteResource),previewResource:T.URI.revive(u.previewResource),acceptedResource:T.URI.revive(u.acceptedResource)}))}])}}}),define(Z[212],ee([0,1,6,27,9,3,2,95,4,15,16,5,30,21,12,13,29,43,46,22,23]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I,u,E,g,w,m,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const a="sync.previous.store",t="sync.donot-make-requests-until",s="sync.user-session-id",n="sync.machine-session-id",r=100,c=1e3*60*5;let l=class extends k.Disposable{constructor(S,U,F){super();this.productService=S,this.configurationService=U,this.storageService=F,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(F.onDidChangeValue,z=>z.key===o.SYNC_SERVICE_URL_TYPE&&z.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(o.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(S){this.storageService.store(o.SYNC_SERVICE_URL_TYPE,S,0,y.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[o.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(o.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(S,U){S=y.isWeb&&S?.web?{...S,...S.web}:S;const F={...S||{},...U||{}};if(F&&(0,i.isString)(F.url)&&(0,i.isObject)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(z=>(0,i.isArray)(F.authenticationProviders[z].scopes))){const z=F,j=!!z.canSwitch&&!U?.url,M=z.url===z.insidersUrl?"insiders":"stable",W=(j?this.userDataSyncStoreType:void 0)||M,x=U?.url||(W==="insiders"?z.insidersUrl:W==="stable"?z.stableUrl:z.url);return{url:C.URI.parse(x),type:W,defaultType:M,defaultUrl:C.URI.parse(z.url),stableUrl:C.URI.parse(z.stableUrl),insidersUrl:C.URI.parse(z.insidersUrl),canSwitch:j,authenticationProviders:Object.keys(z.authenticationProviders).reduce(($,q)=>($.push({id:q,scopes:z.authenticationProviders[q].scopes}),$),[])}}}};l=de([X(0,g.IProductService),X(1,I.IConfigurationService),X(2,v.IStorageService)],l),e.AbstractUserDataSyncStoreManagementService=l;let h=class extends l{constructor(S,U,F){super(S,U,F);const z=this.storageService.get(a,0);z&&(this.previousConfigurationSyncStore=JSON.parse(z));const j=this.productService[o.CONFIGURATION_SYNC_STORE_KEY];j?this.storageService.store(a,JSON.stringify(j),0,1):this.storageService.remove(a,0)}async switch(S){S!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=S,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};h=de([X(0,g.IProductService),X(1,I.IConfigurationService),X(2,v.IStorageService)],h),e.UserDataSyncStoreManagementService=h;let d=class extends k.Disposable{constructor(S,U,F,z,j,M,W){super();this.requestService=F,this.logService=z,this.storageService=W,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(S),this.commonHeadersPromise=(0,m.getServiceMachineId)(j,M,W).then(x=>{const $={"X-Client-Name":`${U.applicationName}${y.isWeb?"-web":""}`,"X-Client-Version":U.version};return U.commit&&($["X-Client-Commit"]=U.commit),$}),this.session=new A(r,c,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,k.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(S,U){this.authToken={token:S,type:U}}updateUserDataSyncStoreUrl(S){this.userDataSyncStoreUrl=S?(0,b.joinPath)(S,"v1"):void 0}initDonotMakeRequestsUntil(){const S=this.storageService.getNumber(t,0);S&&Date.now()<S&&this.setDonotMakeRequestsUntil(new Date(S))}setDonotMakeRequestsUntil(S){this._donotMakeRequestsUntil?.getTime()!==S?.getTime()&&(this._donotMakeRequestsUntil=S,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(U=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),U).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,U=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(S){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",S),F={},z=await this.request(U.toString(),{type:"GET",headers:F},[],L.CancellationToken.None);return(await(0,w.asJson)(z)||[]).map(({url:M,created:W})=>({ref:(0,b.relativePath)(U,U.with({path:M})),created:W*1e3}))}async resolveContent(S,U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",S,U).toString(),z={};z["Cache-Control"]="no-cache";const j=await this.request(F,{type:"GET",headers:z},[],L.CancellationToken.None);return await(0,w.asText)(j)}async delete(S){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",S).toString(),F={};await this.request(U,{type:"DELETE",headers:F},[],L.CancellationToken.None)}async read(S,U,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",S,"latest").toString();F={...F},F["Cache-Control"]="no-cache",U&&(F["If-None-Match"]=U.ref);const j=await this.request(z,{type:"GET",headers:F},[304],L.CancellationToken.None);let M=null;if(j.res.statusCode===304&&(M=U),M===null){const W=j.res.headers.etag;if(!W)throw new o.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",j.res.statusCode,j.res.headers[o.HEADER_OPERATION_ID]);const x=await(0,w.asText)(j);if(!x&&j.res.statusCode===304)throw new o.UserDataSyncStoreError("Empty response",z,"EmptyResponse",j.res.statusCode,j.res.headers[o.HEADER_OPERATION_ID]);M={ref:W,content:x}}return M}async write(S,U,F,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",S).toString();z={...z},z["Content-Type"]=P.Mimes.text,F&&(z["If-Match"]=F);const M=await this.request(j,{type:"POST",data:U,headers:z},[],L.CancellationToken.None),W=M.res.headers.etag;if(!W)throw new o.UserDataSyncStoreError("Server did not return the ref",j,"NoRef",M.res.statusCode,M.res.headers[o.HEADER_OPERATION_ID]);return W}async manifest(S,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();U={...U},U["Content-Type"]="application/json",S&&(U["If-None-Match"]=S.ref);const z=await this.request(F,{type:"GET",headers:U},[304],L.CancellationToken.None);let j=null;if(z.res.statusCode===304&&(j=S),!j){const W=z.res.headers.etag;if(!W)throw new o.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",z.res.statusCode,z.res.headers[o.HEADER_OPERATION_ID]);const x=await(0,w.asText)(z);if(!x&&z.res.statusCode===304)throw new o.UserDataSyncStoreError("Empty response",F,"EmptyResponse",z.res.statusCode,z.res.headers[o.HEADER_OPERATION_ID]);x&&(j={...JSON.parse(x),ref:W})}const M=this.storageService.get(s,0);return M&&j&&M!==j.session&&this.clearSession(),j===null&&M&&this.clearSession(),j&&this.storageService.store(s,j.session,0,1),j}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const S=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),U={"Content-Type":P.Mimes.text};await this.request(S,{type:"DELETE",headers:U},[],L.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(s,0),this.storageService.remove(n,0)}async request(S,U,F,z){if(!this.authToken)throw new o.UserDataSyncStoreError("No Auth Token Available",S,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new o.UserDataSyncStoreError(`${U.type} request '${S}' failed because of too many requests (429).`,S,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const j=await this.commonHeadersPromise;U.headers={...U.headers||{},...j,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(U.headers),this.logService.trace("Sending request to server",{url:S,type:U.type,headers:{...U.headers,authorization:void 0}});let M;try{M=await this.session.request(S,U,z)}catch(q){if(!(q instanceof o.UserDataSyncStoreError)){let N="RequestFailed";const V=(0,R.getErrorMessage)(q).toLowerCase();V.includes("xhr timeout")?N="RequestTimeout":V.includes("protocol")&&V.includes("not supported")?N="RequestProtocolNotSupported":V.includes("request path contains unescaped characters")?N="RequestPathNotEscaped":V.includes("headers must be an object")?N="RequestHeadersNotObject":(0,R.isPromiseCanceledError)(q)&&(N="RequestCanceled"),q=new o.UserDataSyncStoreError(`Connection refused for the request '${S}'.`,S,N,void 0,void 0)}throw this.logService.info("Request failed",S),q}const W=M.res.headers[o.HEADER_OPERATION_ID],x={url:S,status:M.res.statusCode,"execution-id":U.headers[o.HEADER_EXECUTION_ID],"operation-id":W},$=(0,w.isSuccess)(M)||M.res.statusCode&&F.indexOf(M.res.statusCode)!==-1;if($?this.logService.trace("Request succeeded",x):this.logService.info("Request failed",x),M.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new o.UserDataSyncStoreError(`Request '${S}' failed because of Unauthorized (401).`,S,"Unauthorized",M.res.statusCode,W);if(this._onTokenSucceed.fire(),M.res.statusCode===409)throw new o.UserDataSyncStoreError(`${U.type} request '${S}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,S,"Conflict",M.res.statusCode,W);if(M.res.statusCode===410)throw new o.UserDataSyncStoreError(`${U.type} request '${S}' failed because the requested resource is not longer available (410).`,S,"Gone",M.res.statusCode,W);if(M.res.statusCode===412)throw new o.UserDataSyncStoreError(`${U.type} request '${S}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,S,"PreconditionFailed",M.res.statusCode,W);if(M.res.statusCode===413)throw new o.UserDataSyncStoreError(`${U.type} request '${S}' failed because of too large payload (413).`,S,"TooLarge",M.res.statusCode,W);if(M.res.statusCode===426)throw new o.UserDataSyncStoreError(`${U.type} request '${S}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,S,"UpgradeRequired",M.res.statusCode,W);if(M.res.statusCode===429){const q=M.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new o.UserDataSyncStoreError(`${U.type} request '${S}' failed because of too many requests (429).`,S,"TooManyRequestsAndRetryAfter",M.res.statusCode,W)):new o.UserDataSyncStoreError(`${U.type} request '${S}' failed because of too many requests (429).`,S,"RemoteTooManyRequests",M.res.statusCode,W)}if(!$)throw new o.UserDataSyncStoreError("Server returned "+M.res.statusCode,S,"Unknown",M.res.statusCode,W);return M}addSessionHeaders(S){let U=this.storageService.get(n,0);U===void 0&&(U=(0,f.generateUuid)(),this.storageService.store(n,U,0,1)),S["X-Machine-Session-Id"]=U;const F=this.storageService.get(s,0);F!==void 0&&(S["X-User-Session-Id"]=F)}};d=de([X(1,g.IProductService),X(2,w.IRequestService),X(3,o.IUserDataSyncLogService),X(4,u.IEnvironmentService),X(5,E.IFileService),X(6,v.IStorageService)],d),e.UserDataSyncStoreClient=d;let p=class extends d{constructor(S,U,F,z,j,M,W){super(S.userDataSyncStore?.url,U,F,z,j,M,W);this._register(S.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(S.userDataSyncStore?.url)))}};p=de([X(0,o.IUserDataSyncStoreManagementService),X(1,g.IProductService),X(2,w.IRequestService),X(3,o.IUserDataSyncLogService),X(4,u.IEnvironmentService),X(5,E.IFileService),X(6,v.IStorageService)],p),e.UserDataSyncStoreService=p;class A{constructor(S,U,F,z){this.limit=S,this.interval=U,this.requestService=F,this.logService=z,this.requests=[],this.startTime=void 0}request(S,U,F){if(this.isExpired()&&this.reset(),U.url=S,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new o.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,S,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(S),this.requestService.request(U,F)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(Z[213],ee([0,1,3,59,29,22,20,89,23,60,61]),function(K,e,D,L,R,T,k,P,y,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends P.UserDataAutoSyncService{constructor(I,u,E,g,w,m,v,o,a,t,s,n){super(I,u,E,g,w,v,o,a,t,s,n);this._register(D.Event.debounce(D.Event.any(D.Event.map(m.onDidFocusWindow,()=>"windowFocus"),D.Event.map(m.onDidOpenWindow,()=>"windowOpen")),(r,c)=>r?[...r,c]:[c],1e3)(r=>this.triggerSync(r,!0,!1)))}};C=de([X(0,R.IProductService),X(1,y.IUserDataSyncStoreManagementService),X(2,y.IUserDataSyncStoreService),X(3,y.IUserDataSyncResourceEnablementService),X(4,y.IUserDataSyncService),X(5,L.INativeHostService),X(6,y.IUserDataSyncLogService),X(7,b.IUserDataSyncAccountService),X(8,k.ITelemetryService),X(9,i.IUserDataSyncMachinesService),X(10,T.IStorageService),X(11,y.IUserDataAutoSyncEnablementService)],C),e.UserDataAutoSyncService=C}),define(Z[214],ee([0,1,6,3,2]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:y,getActiveWindowId:b}){super();this.disposables=this._register(new R.DisposableStore),L.Event.latch(L.Event.any(P,y))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>b()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch(C){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(Z[62],ee([0,1,51,6,8,16,19,110,222,223]),function(K,e,D,L,R,T,k,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class i extends Error{constructor(t,s){let n=s.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=t,this.cause=s}}e.ExtractError=i;function C(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,n)=>s+n,t&61440)}function f(a){if(a instanceof i)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new i(t,a)}function I(a,t,s,n,r,c){const l=R.dirname(t),h=R.join(n,l);if(!h.startsWith(n))return Promise.reject(new Error(P.localize(0,null,t)));const d=R.join(n,t);let p;return c.onCancellationRequested(()=>{p&&p.destroy()}),Promise.resolve(k.Promises.mkdir(h,{recursive:!0})).then(()=>new Promise((A,O)=>{if(!c.isCancellationRequested)try{p=(0,D.createWriteStream)(d,{mode:s}),p.once("close",()=>A()),p.once("error",O),a.once("error",O),a.pipe(p)}catch(S){O(S)}}))}function u(a,t,s,n){let r=(0,L.createCancelablePromise)(()=>Promise.resolve()),c=0;return n.onCancellationRequested(()=>{r.cancel(),a.close()}),new Promise((l,h)=>{const d=new L.Sequencer,p=A=>{A.isCancellationRequested||(c++,a.readEntry())};a.once("error",h),a.once("close",()=>r.then(()=>{n.isCancellationRequested||a.entryCount===c?l():h(new i("Incomplete",new Error(P.localize(1,null,c,a.entryCount))))},h)),a.readEntry(),a.on("entry",A=>{if(n.isCancellationRequested)return;if(!s.sourcePathRegex.test(A.fileName)){p(n);return}const O=A.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(O)){const F=R.join(t,O);r=(0,L.createCancelablePromise)(z=>k.Promises.mkdir(F,{recursive:!0}).then(()=>p(z)).then(void 0,h));return}const S=g(a,A),U=C(A);r=(0,L.createCancelablePromise)(F=>d.queue(()=>S.then(z=>I(z,O,U,t,s,F).then(()=>p(F)))).then(null,h))})})}function E(a,t=!1){return new Promise((s,n)=>{(0,y.open)(a,t?{lazyEntries:!0}:void 0,(r,c)=>{r?n(f(r)):s((0,T.assertIsDefined)(c))})})}function g(a,t){return new Promise((s,n)=>{a.openReadStream(t,(r,c)=>{r?n(f(r)):s((0,T.assertIsDefined)(c))})})}function w(a,t){return new Promise((s,n)=>{const r=new b.ZipFile;t.forEach(l=>{l.contents?r.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&r.addFile(l.localPath,l.path)}),r.end();const c=(0,D.createWriteStream)(a);r.outputStream.pipe(c),r.outputStream.once("error",n),c.once("error",n),c.once("finish",()=>s(a))})}e.zip=w;function m(a,t,s={},n){const r=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let c=E(a,!0);return s.overwrite&&(c=c.then(l=>k.Promises.rm(t).then(()=>l))),c.then(l=>u(l,t,{sourcePathRegex:r},n))}e.extract=m;function v(a,t){return E(a).then(s=>new Promise((n,r)=>{s.on("entry",c=>{c.fileName===t&&g(s,c).then(l=>n(l),l=>r(l))}),s.once("close",()=>r(new Error(P.localize(2,null,t))))}))}function o(a,t){return v(a,t).then(s=>new Promise((n,r)=>{const c=[];s.once("error",r),s.on("data",l=>c.push(l)),s.on("end",()=>n(Buffer.concat(c)))}))}e.buffer=o}),define(Z[215],ee([0,1,62,118]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(T){return(0,D.buffer)(T,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch(P){throw new Error((0,L.localize)(0,null))}})}e.getManifest=R}),define(Z[216],ee([0,1,18,6,9,2,17,8,4,15,58,5,30,19,62,119,12,28,32,140,13,14,29]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I,u,E,g,w,m,v,o,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const s="scanningSystem",n="scanningUser",r="extracting",c="deleting",l="renaming";let h=class extends T.Disposable{constructor(p,A,O,S,U){super();this.beforeRemovingExtension=p,this.fileService=A,this.logService=O,this.environmentService=S,this.productService=U,this._devSystemExtensionsPath=null,this.systemExtensionsPath=S.builtinExtensionsPath,this.extensionsPath=S.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(p){const A=[];(p===null||p===0)&&A.push(this.scanSystemExtensions().then(null,O=>Promise.reject(new w.ExtensionManagementError(this.joinErrors(O).message,s)))),(p===null||p===1)&&A.push(this.scanUserExtensions(!0).then(null,O=>Promise.reject(new w.ExtensionManagementError(this.joinErrors(O).message,n))));try{const O=await Promise.all(A);return(0,D.flatten)(O)}catch(O){throw this.joinErrors(O)}}async scanUserExtensions(p){this.logService.trace("Started scanning user extensions");let[A,O]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return O=O.filter(S=>!A[new m.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).key()]),p&&(O=(0,m.groupByExtension)(O,U=>U.identifier).map(U=>U.sort((F,z)=>i.rcompare(F.manifest.version,z.manifest.version))[0])),this.logService.trace("Scanned user extensions:",O.length),O}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(p,A,O,S){const U=p.key(),F=P.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),z=P.join(this.extensionsPath,U);try{await I.Promises.rm(z)}catch(M){try{await I.Promises.rm(z)}catch(W){}throw new w.ExtensionManagementError((0,E.localize)(0,null,z,p.id),c)}await this.extractAtLocation(p,A,F,S);let j=await this.scanExtension(C.URI.file(F),1);if(!j)throw new Error((0,E.localize)(1,null,F));await this.storeMetadata(j,{...O,installedTimestamp:Date.now()});try{await this.rename(p,F,z,Date.now()+2*60*1e3),this.logService.info("Renamed to",z)}catch(M){try{await I.Promises.rm(F)}catch(W){}if(M.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",p.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(M)}. Deleted from extracted location`,F),M}try{j=await this.scanExtension(C.URI.file(z),1)}catch(M){}if(j)return j;throw new Error((0,E.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(p,A){return this.setMetadata(p,A),await this.storeMetadata(p,{...A,installedTimestamp:p.installedTimestamp}),p}async storeMetadata(p,A){A.isMachineScoped=A.isMachineScoped||void 0,A.isBuiltin=A.isBuiltin||void 0,A.installedTimestamp=A.installedTimestamp||void 0;const O=P.join(p.location.fsPath,"package.json"),S=await I.Promises.readFile(O,"utf8"),{manifest:U}=await this.parseManifest(S);return U.__metadata=A,await I.Promises.writeFile(O,JSON.stringify(U,null,"	")),p}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...p){const A=p.map(O=>new m.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version));await this.withUninstalledExtensions(O=>{A.forEach(S=>O[S.key()]=!0)})}async setInstalled(p){await this.withUninstalledExtensions(S=>delete S[p.key()]);const O=(await this.scanExtensions(1)).find(S=>new m.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).equals(p))||null;return O?(await this.storeMetadata(O,{installedTimestamp:Date.now()}),this.scanExtension(O.location,1)):null}async withUninstalledExtensions(p){return this.uninstalledFileLimiter.queue(async()=>{let A;try{A=await I.Promises.readFile(this.uninstalledPath,"utf8")}catch(S){if(S.code!=="ENOENT")throw S}let O={};if(A)try{O=JSON.parse(A)}catch(S){}return p&&(p(O),Object.keys(O).length?await I.Promises.writeFile(this.uninstalledPath,JSON.stringify(O)):await I.Promises.rm(this.uninstalledPath)),O})}async removeExtension(p,A){this.logService.trace(`Deleting ${A} extension from disk`,p.identifier.id,p.location.fsPath),await I.Promises.rm(p.location.fsPath),this.logService.info("Deleted from disk",p.identifier.id,p.location.fsPath)}async removeUninstalledExtension(p){await this.removeExtension(p,"uninstalled"),await this.withUninstalledExtensions(A=>delete A[new m.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()])}async extractAtLocation(p,A,O,S){this.logService.trace(`Started extracting the extension from ${A} to ${O}`);try{await I.Promises.rm(O)}catch(U){throw new w.ExtensionManagementError(this.joinErrors(U).message,c)}try{await(0,u.extract)(A,O,{sourcePath:"extension",overwrite:!0},S),this.logService.info(`Extracted extension to ${O}:`,p.id)}catch(U){try{await I.Promises.rm(O)}catch(F){}throw new w.ExtensionManagementError(U.message,U instanceof u.ExtractError&&U.type?U.type:r)}}async rename(p,A,O,S){try{await I.Promises.rename(A,O)}catch(U){if(y.isWindows&&U&&U.code==="EPERM"&&Date.now()<S)return this.logService.info(`Failed renaming ${A} to ${O} with 'EPERM' error. Trying again...`,p.id),this.rename(p,A,O,S);throw new w.ExtensionManagementError(U.message||(0,E.localize)(3,null,A,O),U.code||l)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const p=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return p;const A=this.scanDevSystemExtensions(),[O,S]=await Promise.all([p,A]);return[...O,...S]}async scanExtensionsInDir(p,A){const O=new L.Limiter(10),S=await this.fileService.resolve(C.URI.file(p));return S.children?(await Promise.all(S.children.filter(F=>F.isDirectory).map(F=>O.queue(async()=>A===1&&(0,b.basename)(F.resource).indexOf(".")===0?null:this.scanExtension(F.resource,A))))).filter(F=>F&&F.identifier):[]}async scanExtension(p,A){try{const O=await this.fileService.resolve(p);if(O.children){const{manifest:S,metadata:U}=await this.readManifest(p.fsPath),F=O.children.find(({name:W})=>/^readme(\.txt|\.md|)$/i.test(W))?.resource,z=O.children.find(({name:W})=>/^changelog(\.txt|\.md|)$/i.test(W))?.resource,j={id:(0,m.getGalleryExtensionId)(S.publisher,S.name)},M={type:A,identifier:j,manifest:S,location:p,readmeUrl:F,changelogUrl:z,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:A===0};return U&&(this.setMetadata(M,U),M.installedTimestamp=U.installedTimestamp),M}}catch(O){A!==0&&this.logService.trace(O)}return null}async scanDefaultSystemExtensions(){const p=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",p.length),p}async scanDevSystemExtensions(){const p=this.getDevSystemExtensionsList();if(p.length){const A=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",A.length),A.filter(O=>p.some(S=>(0,m.areSameExtensions)(O.identifier,{id:S})))}else return[]}setMetadata(p,A){p.publisherDisplayName=A.publisherDisplayName||null,p.publisherId=A.publisherId||null,p.identifier.uuid=A.id,p.isMachineScoped=!!A.isMachineScoped,p.isBuiltin=p.type===0||!!A.isBuiltin}async removeUninstalledExtensions(){const p=await this.getUninstalledExtensions(),A=await this.scanAllUserExtensions(),O=new Set;for(const F of A)p[new m.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()]||O.add(F.identifier.id.toLowerCase());const S=(0,m.groupByExtension)(A,F=>F.identifier);await L.Promises.settled(S.map(async F=>{const z=F.sort((j,M)=>i.rcompare(j.manifest.version,M.manifest.version))[0];O.has(z.identifier.id.toLowerCase())||await this.beforeRemovingExtension(z)}));const U=A.filter(F=>p[new m.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()]);await L.Promises.settled(U.map(F=>this.removeUninstalledExtension(F)))}async removeOutdatedExtensions(){const p=await this.scanAllUserExtensions(),A=[],O=(0,m.groupByExtension)(p,S=>S.identifier);A.push(...(0,D.flatten)(O.map(S=>S.sort((U,F)=>i.rcompare(U.manifest.version,F.manifest.version)).slice(1)))),await L.Promises.settled(A.map(S=>this.removeExtension(S,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(p=>p.name)}joinErrors(p){const A=Array.isArray(p)?p:[p];return A.length===1?A[0]instanceof Error?A[0]:new Error(A[0]):A.reduce((O,S)=>new Error(`${O.message}${O.message?",":""}${S instanceof Error?S.message:S}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(k.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(p){const A=[I.Promises.readFile(P.join(p,"package.json"),"utf8").then(F=>this.parseManifest(F)),I.Promises.readFile(P.join(p,"package.nls.json"),"utf8").then(void 0,F=>F.code!=="ENOENT"?Promise.reject(F):"{}").then(F=>JSON.parse(F))],[{manifest:O,metadata:S},U]=await Promise.all(A);return{manifest:(0,v.localizeManifest)(O,U),metadata:S}}parseManifest(p){return new Promise((A,O)=>{try{const S=JSON.parse(p),U=S.__metadata||null;A({manifest:S,metadata:U})}catch(S){O(new Error((0,E.localize)(4,null)))}})}};h=de([X(1,o.IFileService),X(2,a.ILogService),X(3,g.INativeEnvironmentService),X(4,t.IProductService)],h),e.ExtensionsScanner=h}),define(Z[217],ee([0,1,37,9,17,8,4,31,15,58,5,30,19,62,117,74,12,183,28,32,164,165,215,152,216,166,72,13,7,14,42,20]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I,u,E,g,w,m,v,o,a,t,s,n,r,c,l,h,d,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const O="unsetUninstalled",S="downloading";let U=class extends w.AbstractExtensionManagementService{constructor(x,$,q,N,V,_,Y){super(x,$,q);this.environmentService=N,this.downloadService=V,this.fileService=Y;const G=this._register(_.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(_.createInstance(n.ExtensionsScanner,ne=>G.postUninstall(ne))),this.manifestCache=this._register(new s.ExtensionsManifestCache(N,this)),this.extensionsDownloader=this._register(_.createInstance(o.ExtensionsDownloader));const te=this._register(new r.ExtensionsWatcher(this,Y,N,q));this._register(te.onDidChangeExtensionsByAnotherSource(({added:ne,removed:J})=>{ne.length&&this._onDidInstallExtensions.fire(ne.map(H=>({identifier:H.identifier,operation:0,local:H}))),J.forEach(H=>this._onDidUninstallExtension.fire({identifier:H}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const x=await this.isAlpineLinux(),$=(0,m.getTargetPlatform)(x?"alpine":k.platform,P.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",$),$})()),this._targetPlatformPromise}async isAlpineLinux(){if(!k.isLinux)return!1;let x;try{x=(await this.fileService.readFile(i.URI.file("/etc/os-release"))).value.toString()}catch($){try{x=(await this.fileService.readFile(i.URI.file("/usr/lib/os-release"))).value.toString()}catch(q){this.logService.debug("Error while getting the os-release file.",(0,L.getErrorMessage)(q))}}return!!x&&(x.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(x){this.logService.trace("ExtensionManagementService#zip",x.identifier.id);const $=await this.collectFiles(x),q=await(0,I.zip)((0,y.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,$);return i.URI.file(q)}async unzip(x){return this.logService.trace("ExtensionManagementService#unzip",x.toString()),(await this.install(x)).identifier}async getManifest(x){const $=await this.downloadVsix(x),q=T.resolve($.fsPath);return(0,t.getManifest)(q)}getInstalled(x=null){return this.extensionsScanner.scanExtensions(x)}async install(x,$={}){this.logService.trace("ExtensionManagementService#install",x.toString());const q=await this.downloadVsix(x),N=await(0,t.getManifest)(T.resolve(q.fsPath));if(N.engines&&N.engines.vscode&&!(0,c.isEngineValid)(N.engines.vscode,p.default.version,p.default.date))throw new Error(u.localize(0,null,(0,v.getGalleryExtensionId)(N.publisher,N.name),p.default.version));return this.installExtension(N,q,$)}async updateMetadata(x,$){return this.logService.trace("ExtensionManagementService#updateMetadata",x.identifier.id),x=await this.extensionsScanner.saveMetadataForLocalExtension(x,{...x.manifest.__metadata||{},...$}),this.manifestCache.invalidate(),x}async updateExtensionScope(x,$){return this.logService.trace("ExtensionManagementService#updateExtensionScope",x.identifier.id),x=await this.extensionsScanner.saveMetadataForLocalExtension(x,{...x.manifest.__metadata||{},isMachineScoped:$}),this.manifestCache.invalidate(),x}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(x){if(x.scheme===R.Schemas.file)return x;const $=(0,y.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(x,$),$}createInstallExtensionTask(x,$,q){return i.URI.isUri($)?new j(x,$,q,this.galleryService,this.extensionsScanner,this.logService):new z($,q,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(x,$){return new M(x,$,this.extensionsScanner)}async collectFiles(x){const $=async N=>{let V=await f.Promises.readdir(N);V=V.map(G=>T.join(N,G));const _=await Promise.all(V.map(G=>f.Promises.stat(G)));let Y=Promise.resolve([]);return _.forEach((G,te)=>{const ne=V[te];G.isFile()&&(Y=Y.then(J=>[...J,ne])),G.isDirectory()&&(Y=Y.then(J=>$(ne).then(H=>[...J,...H])))}),Y};return(await $(x.location.fsPath)).map(N=>({path:`extension/${T.relative(x.location.fsPath,N)}`,localPath:N}))}};U=de([X(0,m.IExtensionGalleryService),X(1,A.ITelemetryService),X(2,d.ILogService),X(3,g.INativeEnvironmentService),X(4,E.IDownloadService),X(5,h.IInstantiationService),X(6,l.IFileService)],U),e.ExtensionManagementService=U;class F extends w.AbstractExtensionTask{constructor(x,$,q,N){super();this.identifier=x,this.source=$,this.extensionsScanner=q,this.logService=N,this._operation=1}get operation(){return this._operation}async installExtension(x,$){try{const q=await this.unsetUninstalledAndGetLocal(x.identifierWithVersion);if(q)return x.metadata?this.extensionsScanner.saveMetadataForLocalExtension(q,x.metadata):q}catch(q){throw k.isMacintosh?new m.ExtensionManagementError(u.localize(1,null),O):new m.ExtensionManagementError(u.localize(2,null),O)}return this.extract(x,$)}async unsetUninstalledAndGetLocal(x){if(!await this.isUninstalled(x))return null;this.logService.trace("Removing the extension from uninstalled list:",x.id);const q=await this.extensionsScanner.setInstalled(x);return this.logService.info("Removed the extension from uninstalled list:",x.id),q}async isUninstalled(x){return!!(await this.extensionsScanner.getUninstalledExtensions())[x.key()]}async extract({zipPath:x,identifierWithVersion:$,metadata:q},N){let V=await this.extensionsScanner.extractUserExtension($,x,q,N);return this.logService.info("Extracting completed.",$.id),V}}class z extends F{constructor(x,$,q,N,V){super(x.identifier,x,N,V);this.gallery=x,this.options=$,this.extensionsDownloader=q}async doRun(x){const q=(await this.extensionsScanner.scanExtensions(null)).find(_=>(0,v.areSameExtensions)(_.identifier,this.gallery.identifier));q&&(this._operation=2);const N=await this.downloadInstallableExtension(this.gallery,this._operation);N.metadata.isMachineScoped=this.options.isMachineScoped||q?.isMachineScoped,N.metadata.isBuiltin=this.options.isBuiltin||q?.isBuiltin;const V=await this.installExtension(N,x);q&&b.neq(q.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(q);try{await this.extensionsDownloader.delete(i.URI.file(N.zipPath))}catch(_){}return V}async downloadInstallableExtension(x,$){const q={id:x.identifier.uuid,publisherId:x.publisherId,publisherDisplayName:x.publisherDisplayName};let N;try{this.logService.trace("Started downloading extension:",x.identifier.id),N=(await this.extensionsDownloader.downloadExtension(x,$)).fsPath,this.logService.info("Downloaded extension:",x.identifier.id,N)}catch(V){throw new m.ExtensionManagementError((0,w.joinErrors)(V).message,S)}try{const V=await(0,t.getManifest)(N);return{zipPath:N,identifierWithVersion:new v.ExtensionIdentifierWithVersion(x.identifier,V.version),metadata:q}}catch(V){throw new m.ExtensionManagementError((0,w.joinErrors)(V).message,w.INSTALL_ERROR_VALIDATING)}}}class j extends F{constructor(x,$,q,N,V,_){super({id:(0,v.getGalleryExtensionId)(x.publisher,x.name)},$,V,_);this.manifest=x,this.location=$,this.options=q,this.galleryService=N}async doRun(x){const $=new v.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),N=(await this.extensionsScanner.scanExtensions(1)).find(_=>(0,v.areSameExtensions)(this.identifier,_.identifier)),V=await this.getMetadata(this.identifier.id,x);if(V.isMachineScoped=this.options.isMachineScoped||N?.isMachineScoped,V.isBuiltin=this.options.isBuiltin||N?.isBuiltin,N)if(this._operation=2,$.equals(new v.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version)))try{await this.extensionsScanner.removeExtension(N,"existing")}catch(_){throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else b.gt(N.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(N);else{const _=await this.unsetUninstalledAndGetLocal($);if(_)try{await this.extensionsScanner.removeExtension(_,"existing")}catch(Y){throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:T.resolve(this.location.fsPath),identifierWithVersion:$,metadata:V},x)}async getMetadata(x,$){try{const q=(await this.galleryService.query({names:[x],pageSize:1},$)).firstPage[0];if(q)return{id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId}}catch(q){}return{}}}class M extends w.AbstractExtensionTask{constructor(x,$,q){super();this.extension=x,this.options=$,this.extensionsScanner=q}async doRun(x){const $=[],q=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const N=new v.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);$.push(...q.filter(V=>N.equals(new v.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version))))}else $.push(...q.filter(N=>(0,v.areSameExtensions)(N.identifier,this.extension.identifier)));if(!$.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...$),this.options.remove)for(const N of $)try{x.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(N)}catch(V){throw new Error(u.localize(6,null,(0,D.toErrorMessage)(V)))}}}}),define(Z[224],ee([0,1,104,51,225,35,37,9,2,17,15,5,36,103,171,150,172,161,162,163,148,153,21,174,73,182,74,176,12,138,178,185,28,151,184,217,75,141,13,168,170,53,7,158,78,159,160,57,167,14,79,59,42,29,175,43,22,180,181,20,82,83,84,44,186,187,85,189,195,87,88,89,23,60,206,207,208,61,209,210,211,212,213,214]),function(K,e,D,L,R,T,k,P,y,b,i,C,f,I,u,E,g,w,m,v,o,a,t,s,n,r,c,l,h,d,p,A,O,S,U,F,z,j,M,W,x,$,q,N,V,_,Y,G,te,ne,J,H,re,ie,ce,ue,ye,ge,Ie,Pe,Ee,Ae,De,Te,Ne,_e,$e,xe,Q,ae,oe,pe,Se,Oe,Le,Ue,ke,B,se,le,he,me,be,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class we extends y.Disposable{constructor(fe){super();this.configuration=fe,this.server=this._register(new I.Server),(0,R.gracefulify)(L),this.registerListeners()}registerListeners(){const fe=()=>this.dispose();process.once("exit",fe),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",fe)}async open(){const fe=await this.initServices();(0,Se.registerConfiguration)(),fe.invokeFunction(Fe=>{const Me=Fe.get(ne.ILogService);Me.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Fe),this.registerErrorHandler(Me)}),this._register((0,y.combinedDisposable)(fe.createInstance(u.CodeCacheCleaner,this.configuration.codeCachePath),fe.createInstance(g.LanguagePackCachedDataCleaner),fe.createInstance(v.StorageDataCleaner,this.configuration.backupWorkspacesPath),fe.createInstance(m.LogsDataCleaner),fe.createInstance(w.LocalizationsUpdater),fe.createInstance(E.DeprecatedExtensionsCleaner)))}async initServices(){const fe=new V.ServiceCollection,Fe={_serviceBrand:void 0,...re.default};fe.set(ie.IProductService,Fe);const Me=new f.StaticRouter(Ve=>Ve==="main"),ze=new _.MessagePortMainProcessService(this.server,Me);fe.set(Y.IMainProcessService,ze);const qe=new d.NativeEnvironmentService(this.configuration.args,Fe);fe.set(h.INativeEnvironmentService,qe);const et=new J.LogLevelChannelClient(this.server.getChannel("logLevel",Me)),He=new J.LoggerChannelClient(this.configuration.logLevel,et.onDidChangeLogLevel,ze.getChannel("logger"));fe.set(ne.ILoggerService,He);const nt=this._register(new ne.MultiplexLogService([this._register(new ne.ConsoleLogger(this.configuration.logLevel)),this._register(He.createLogger((0,i.joinPath)(C.URI.file(qe.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new J.FollowerLogService(et,nt));fe.set(ne.ILogService,Ge);const Ke=this._register(new W.FileService(Ge));fe.set(M.IFileService,Ke);const it=this._register(new x.DiskFileSystemProvider(Ge));Ke.registerProvider(b.Schemas.file,it);const je=this._register(new s.ConfigurationService(qe.settingsResource,Ke));fe.set(t.IConfigurationService,je),await je.initialize();const Xe=new ge.NativeStorageService(void 0,ze,qe);fe.set(ye.IStorageService,Xe),await Xe.initialize(),this._register((0,y.toDisposable)(()=>Xe.flush())),fe.set(ue.IRequestService,new $.SyncDescriptor(ce.RequestService)),fe.set(o.IChecksumService,new $.SyncDescriptor(a.ChecksumService));const tt=f.ProxyChannel.toService(ze.getChannel("nativeHost"),{context:this.configuration.windowId});fe.set(H.INativeHostService,tt),fe.set(c.IDownloadService,new $.SyncDescriptor(l.DownloadService));const rt=this._register(new ve.ActiveWindowManager(tt)),ft=new f.StaticRouter(Ve=>rt.getActiveClientId().then(st=>Ve===st));fe.set(z.IExtensionRecommendationNotificationService,new j.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ft)));let Qe,Ye,ct=(0,Te.getTelemetryLevel)(Fe,qe);if(ct>=1){Ye=new Ae.TelemetryLogAppender(He,qe);const{appRoot:Ve,extensionsPath:st,installSourcePath:gt}=qe;if(Fe.aiConfig&&Fe.aiConfig.asimovKey&&ct>=2){const lt=new Ne.AppInsightsAppender("monacoworkbench",null,Fe.aiConfig.asimovKey);this._register((0,y.toDisposable)(()=>lt.flush())),Ye=(0,Te.combinedAppender)(lt,Ye)}Qe=new De.TelemetryService({appender:Ye,commonProperties:(0,Ie.resolveCommonProperties)(Ke,(0,T.release)(),(0,T.hostname)(),process.arch,Fe.commit,Fe.version,this.configuration.machineId,Fe.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:[Ve,st]},je)}else Qe=Te.NullTelemetryService,Ye=Te.NullAppender;this.server.registerChannel("telemetryAppender",new Ee.TelemetryAppenderChannel(Ye)),fe.set(Pe.ITelemetryService,Qe);const dt=new _e.CustomEndpointTelemetryService(je,Qe,He,qe);return fe.set(Pe.ICustomEndpointTelemetryService,dt),fe.set(O.IExtensionManagementService,new $.SyncDescriptor(F.ExtensionManagementService)),fe.set(O.IExtensionGalleryService,new $.SyncDescriptor(A.ExtensionGalleryService)),fe.set(O.IExtensionTipsService,new $.SyncDescriptor(U.ExtensionTipsService)),fe.set(G.ILocalizationsService,new $.SyncDescriptor(te.LocalizationsService)),fe.set(n.IDiagnosticsService,new $.SyncDescriptor(r.DiagnosticsService)),fe.set(Oe.IUserDataSyncAccountService,new $.SyncDescriptor(Oe.UserDataSyncAccountService)),fe.set(Se.IUserDataSyncLogService,new $.SyncDescriptor(ke.UserDataSyncLogService)),fe.set(Se.IUserDataSyncUtilService,new Ue.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ve=>Ve.ctx!=="main"))),fe.set(O.IGlobalExtensionEnablementService,new $.SyncDescriptor(p.GlobalExtensionEnablementService)),fe.set(oe.IIgnoredExtensionsManagementService,new $.SyncDescriptor(oe.IgnoredExtensionsManagementService)),fe.set(ae.IExtensionsStorageSyncService,new $.SyncDescriptor(ae.ExtensionsStorageSyncService)),fe.set(Se.IUserDataSyncStoreManagementService,new $.SyncDescriptor(me.UserDataSyncStoreManagementService)),fe.set(Se.IUserDataSyncStoreService,new $.SyncDescriptor(me.UserDataSyncStoreService)),fe.set(B.IUserDataSyncMachinesService,new $.SyncDescriptor(B.UserDataSyncMachinesService)),fe.set(Se.IUserDataSyncBackupStoreService,new $.SyncDescriptor(Le.UserDataSyncBackupStoreService)),fe.set(Se.IUserDataAutoSyncEnablementService,new $.SyncDescriptor(pe.UserDataAutoSyncEnablementService)),fe.set(Se.IUserDataSyncResourceEnablementService,new $.SyncDescriptor(se.UserDataSyncResourceEnablementService)),fe.set(Se.IUserDataSyncService,new $.SyncDescriptor(le.UserDataSyncService)),fe.set(xe.ILocalPtyService,this._register(new Q.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:je.getValue("terminal.integrated.persistentSessionScrollback")??100,useExperimentalSerialization:je.getValue("terminal.integrated.persistentSessionExperimentalSerializer")??!0},je,Ge,Qe))),new N.InstantiationService(fe)}initChannels(fe){const Fe=new S.ExtensionManagementChannel(fe.get(O.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Fe);const Me=f.ProxyChannel.fromService(fe.get(G.ILocalizationsService));this.server.registerChannel("localizations",Me);const ze=f.ProxyChannel.fromService(fe.get(n.IDiagnosticsService));this.server.registerChannel("diagnostics",ze);const qe=new S.ExtensionTipsChannel(fe.get(O.IExtensionTipsService));this.server.registerChannel("extensionTipsService",qe);const et=f.ProxyChannel.fromService(fe.get(o.IChecksumService));this.server.registerChannel("checksum",et);const He=new Ue.UserDataSyncMachinesServiceChannel(fe.get(B.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",He);const nt=f.ProxyChannel.fromService(fe.get(Pe.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",nt);const Ge=new Ue.UserDataSyncAccountServiceChannel(fe.get(Oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ge);const Ke=new Ue.UserDataSyncStoreManagementServiceChannel(fe.get(Se.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ke);const it=new he.UserDataSyncChannel(fe.get(Se.IUserDataSyncService),fe.get(ne.ILogService));this.server.registerChannel("userDataSync",it);const je=this._register(fe.get(q.IInstantiationService).createInstance(be.UserDataAutoSyncService)),Xe=new Ue.UserDataAutoSyncChannel(je);this.server.registerChannel("userDataAutoSync",Xe);const tt=fe.get(xe.ILocalPtyService),rt=f.ProxyChannel.fromService(tt);this.server.registerChannel($e.TerminalIpcChannels.LocalPty,rt)}registerErrorHandler(fe){window.addEventListener("unhandledrejection",Fe=>{(0,P.onUnexpectedError)(Fe.reason),Fe.preventDefault()}),(0,P.setUnexpectedErrorHandler)(Fe=>{const Me=(0,k.toErrorMessage)(Fe,!0);!Me||fe.error(`[uncaught exception in sharedProcess]: ${Me}`)})}}async function Ce(Re){const fe=new we(Re);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await fe.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Ce})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/da10782b86bd9d895ccb20be4514b19728036951/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
