/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/severity","fs","vs/editor/common/core/position","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/skipList","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(J){for(var e=[],m=0,L=J.length;m<L;m++)e[m]=me[J[m]];return e};define(me[57],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(L,k){if(!L)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=m}),define(me[58],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function L(n){const I=[];for(let c in n)m.call(n,c)&&I.push(n[c]);return I}e.values=L;function k(n,I){for(let c in n)if(m.call(n,c)&&I({key:c,value:n[c]},function(){delete n[c]})===!1)return}e.forEach=k;function C(n,I){const c=Object.create(null);for(const f of n){const h=I(f);let p=c[h];p||(p=c[h]=[]),p.push(f)}return c}e.groupBy=C;function R(n){const I=Object.create(null);return n&&n.forEach((c,f)=>{I[f]=c}),I}e.fromMap=R;function S(n,I){const c=[],f=[];for(let h of n)I.has(h)||c.push(h);for(let h of I)n.has(h)||f.push(h);return{removed:c,added:f}}e.diffSets=S;function y(n,I){const c=[],f=[];for(let[h,p]of n)I.has(h)||c.push(p);for(let[h,p]of I)n.has(h)||f.push(p);return{removed:c,added:f}}e.diffMaps=y;class T{constructor(){this.map=new Map}add(I,c){let f=this.map.get(I);f||(f=new Set,this.map.set(I,f)),f.add(c)}delete(I,c){const f=this.map.get(I);!f||(f.delete(c),f.size===0&&this.map.delete(I))}forEach(I,c){const f=this.map.get(I);!f||f.forEach(c)}}e.SetMap=T}),define(me[59],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(R){return(S,y,T)=>{let n=null,I=null;if(typeof T.value=="function"?(n="value",I=T.value):typeof T.get=="function"&&(n="get",I=T.get),!I)throw new Error("not supported");T[n]=R(I,y)}}e.createDecorator=m;function L(R,S,y){let T=null,n=null;if(typeof y.value=="function"?(T="value",n=y.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(T="get",n=y.get),!n)throw new Error("not supported");const I=`$memoize$${S}`;y[T]=function(...c){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,c)}),this[I]}}e.memoize=L;function k(R,S,y){return m((T,n)=>{const I=`$debounce$${n}`,c=`$debounce$result$${n}`;return function(...f){this[c]||(this[c]=y?y():void 0),clearTimeout(this[I]),S&&(this[c]=S(this[c],...f),f=[this[c]]),this[I]=setTimeout(()=>{T.apply(this,f),this[c]=y?y():void 0},R)}})}e.debounce=k;function C(R,S,y){return m((T,n)=>{const I=`$throttle$timer$${n}`,c=`$throttle$result$${n}`,f=`$throttle$lastRun$${n}`,h=`$throttle$pending$${n}`;return function(...p){if(this[c]||(this[c]=y?y():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),S&&(this[c]=S(this[c],...p)),this[h])return;const D=this[f]+R;D<=Date.now()?(this[f]=Date.now(),T.apply(this,[this[c]]),this[c]=y?y():void 0):(this[h]=!0,this[I]=setTimeout(()=>{this[h]=!1,this[f]=Date.now(),T.apply(this,[this[c]]),this[c]=y?y():void 0},D-Date.now()))}})}e.throttle=C}),define(me[16],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(u=>{u(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function L(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=L;function k(g){y(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=k;function C(g){y(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=C;function R(g){if(g instanceof Error){let{name:t,message:u}=g;const r=g.stacktrace||g.stack;return{$isError:!0,name:t,message:u,stack:r}}return g}e.transformErrorForSerialization=R;const S="Canceled";function y(g){return g instanceof Error&&g.name===S&&g.message===S}e.isPromiseCanceledError=y;class T extends Error{constructor(){super(S);this.name=this.message}}e.CancellationError=T;function n(){const g=new Error(S);return g.name=g.message,g}e.canceled=n;function I(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=I;function c(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=c;function f(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function h(g){const t=new Error(`${g} has been disposed`);return t.name="DISPOSED",t}e.disposed=h;function p(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=p;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class A extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=A;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function a(g){const t=g;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=a;function s(g,t=Object.create(null)){const u=new Error(g);return t.actions&&(u.actions=t.actions),u}e.createErrorWithActions=s}),define(me[17],ge([0,1,16]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(W,Q=0){return W[W.length-(1+Q)]}e.tail=L;function k(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=k;function C(W,Q,Y=(he,_e)=>he===_e){if(W===Q)return!0;if(!W||!Q||W.length!==Q.length)return!1;for(let he=0,_e=W.length;he<_e;he++)if(!Y(W[he],Q[he]))return!1;return!0}e.equals=C;function R(W,Q,Y){let he=0,_e=W.length-1;for(;he<=_e;){const Se=(he+_e)/2|0,Re=Y(W[Se],Q);if(Re<0)he=Se+1;else if(Re>0)_e=Se-1;else return Se}return-(he+1)}e.binarySearch=R;function S(W,Q){let Y=0,he=W.length;if(he===0)return 0;for(;Y<he;){const _e=Math.floor((Y+he)/2);Q(W[_e])?he=_e:Y=_e+1}return Y}e.findFirstInSorted=S;function y(W,Q,Y){if(W=W|0,W>=Q.length)throw new TypeError("invalid index");let he=Q[Math.floor(Q.length*Math.random())],_e=[],Se=[],Re=[];for(let xe of Q){const Ue=Y(xe,he);Ue<0?_e.push(xe):Ue>0?Se.push(xe):Re.push(xe)}return W<_e.length?y(W,_e,Y):W<_e.length+Re.length?Re[0]:y(W-(_e.length+Re.length),Se,Y)}e.quickSelect=y;function T(W,Q){const Y=[];let he;for(const _e of W.slice(0).sort(Q))!he||Q(he[0],_e)!==0?(he=[_e],Y.push(he)):he.push(_e);return Y}e.groupBy=T;function n(W,Q,Y){const he=[];function _e(xe,Ue,je){if(Ue===0&&je.length===0)return;const V=he[he.length-1];V&&V.start+V.deleteCount===xe?(V.deleteCount+=Ue,V.toInsert.push(...je)):he.push({start:xe,deleteCount:Ue,toInsert:je})}let Se=0,Re=0;for(;;){if(Se===W.length){_e(Se,0,Q.slice(Re));break}if(Re===Q.length){_e(Se,W.length-Se,[]);break}const xe=W[Se],Ue=Q[Re],je=Y(xe,Ue);je===0?(Se+=1,Re+=1):je<0?(_e(Se,1,[]),Se+=1):je>0&&(_e(Se,0,[Ue]),Re+=1)}return he}e.sortedDiff=n;function I(W,Q,Y){const he=n(W,Q,Y),_e=[],Se=[];for(const Re of he)_e.push(...W.slice(Re.start,Re.start+Re.deleteCount)),Se.push(...Re.toInsert);return{removed:_e,added:Se}}e.delta=I;function c(W,Q,Y){if(Y===0)return[];const he=W.slice(0,Y).sort(Q);return h(W,Q,he,Y,W.length),he}e.top=c;function f(W,Q,Y,he,_e){return Y===0?Promise.resolve([]):new Promise((Se,Re)=>{(async()=>{const xe=W.length,Ue=W.slice(0,Y).sort(Q);for(let je=Y,V=Math.min(Y+he,xe);je<xe;je=V,V=Math.min(V+he,xe)){if(je>Y&&await new Promise(ee=>setTimeout(ee)),_e&&_e.isCancellationRequested)throw(0,m.canceled)();h(W,Q,Ue,je,V)}return Ue})().then(Se,Re)})}e.topAsync=f;function h(W,Q,Y,he,_e){for(const Se=Y.length;he<_e;he++){const Re=W[he];if(Q(Re,Y[Se-1])<0){Y.pop();const xe=S(Y,Ue=>Q(Re,Ue)<0);Y.splice(xe,0,Re)}}}function p(W){return W.filter(Q=>!!Q)}e.coalesce=p;function D(W){let Q=0;for(let Y=0;Y<W.length;Y++)W[Y]&&(W[Q]=W[Y],Q+=1);W.length=Q}e.coalesceInPlace=D;function A(W,Q,Y){W.splice(Y,0,W.splice(Q,1)[0])}e.move=A;function E(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=E;function a(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=a;function s(W,Q){if(!Q)return W.filter((he,_e)=>W.indexOf(he)===_e);const Y=Object.create(null);return W.filter(he=>{const _e=Q(he);return Y[_e]?!1:(Y[_e]=!0,!0)})}e.distinct=s;function g(W){const Q=new Set;return W.filter(Y=>Q.has(Y)?!1:(Q.add(Y),!0))}e.distinctES6=g;function t(W){const Q=Object.create(null);return Y=>{const he=W(Y);return Q[he]?!1:(Q[he]=!0,!0)}}e.uniqueFilter=t;function u(W,Q){for(let Y=W.length-1;Y>=0;Y--){const he=W[Y];if(Q(he))return Y}return-1}e.lastIndex=u;function r(W,Q){return W.length>0?W[0]:Q}e.firstOrDefault=r;function i(W,Q,Y=(he,_e)=>he===_e){let he=0;for(let _e=0,Se=Math.min(W.length,Q.length);_e<Se&&Y(W[_e],Q[_e]);_e++)he++;return he}e.commonPrefixLength=i;function o(W){return[].concat(...W)}e.flatten=o;function l(W,Q){let Y=typeof Q=="number"?W:0;typeof Q=="number"?Y=W:(Y=0,Q=W);const he=[];if(Y<=Q)for(let _e=Y;_e<Q;_e++)he.push(_e);else for(let _e=Y;_e>Q;_e--)he.push(_e);return he}e.range=l;function d(W,Q,Y){return W.reduce((he,_e)=>(he[Q(_e)]=Y?Y(_e):_e,he),Object.create(null))}e.index=d;function b(W,Q){return W.push(Q),()=>_(W,Q)}e.insert=b;function _(W,Q){const Y=W.indexOf(Q);if(Y>-1)return W.splice(Y,1),Q}e.remove=_;function v(W,Q,Y){const he=W.slice(0,Q),_e=W.slice(Q);return he.concat(Y,_e)}e.arrayInsert=v;function P(W,Q){let Y;if(typeof Q=="number"){let he=Q;Y=()=>{const _e=Math.sin(he++)*179426549;return _e-Math.floor(_e)}}else Y=Math.random;for(let he=W.length-1;he>0;he-=1){const _e=Math.floor(Y()*(he+1)),Se=W[he];W[he]=W[_e],W[_e]=Se}}e.shuffle=P;function w(W,Q){const Y=W.indexOf(Q);Y>-1&&(W.splice(Y,1),W.unshift(Q))}e.pushToStart=w;function F(W,Q){const Y=W.indexOf(Q);Y>-1&&(W.splice(Y,1),W.push(Q))}e.pushToEnd=F;function M(W,Q){return Array.isArray(W)?W.map(Q):Q(W)}e.mapArrayOrNot=M;function K(W){return Array.isArray(W)?W:[W]}e.asArray=K;function G(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=G;function N(W,Q){for(const Y of W){const he=Q(Y);if(he!==void 0)return he}}e.mapFind=N;function z(W,Q,Y){const he=x(W,Q),_e=W.length,Se=Y.length;W.length=_e+Se;for(let Re=_e-1;Re>=he;Re--)W[Re+Se]=W[Re];for(let Re=0;Re<Se;Re++)W[Re+he]=Y[Re]}e.insertInto=z;function O(W,Q,Y,he){const _e=x(W,Q),Se=W.splice(_e,Y);return z(W,_e,he),Se}e.splice=O;function x(W,Q){return Q<0?Math.max(Q+W.length,0):Math.min(Q,W.length)}function B(W,Q){let Y=Number.MAX_SAFE_INTEGER,he=0;return W.forEach((_e,Se)=>{const Re=Q(_e);Re<Y&&(Y=Re,he=Se)}),he}e.minIndex=B;function U(W,Q){let Y=Number.MIN_SAFE_INTEGER,he=0;return W.forEach((_e,Se)=>{const Re=Q(_e);Re>Y&&(Y=Re,he=Se)}),he}e.maxIndex=U;class H{constructor(Q){this.items=Q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Q){let Y=this.firstIdx;for(;Y<this.items.length&&Q(this.items[Y]);)Y++;const he=Y===this.firstIdx?null:this.items.slice(this.firstIdx,Y);return this.firstIdx=Y,he}takeFromEndWhile(Q){let Y=this.lastIdx;for(;Y>=0&&Q(this.items[Y]);)Y--;const he=Y===this.lastIdx?null:this.items.slice(Y+1,this.lastIdx+1);return this.lastIdx=Y,he}}e.ArrayQueue=H}),define(me[75],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(L){const k=this;let C=!1,R;return function(){return C||(C=!0,R=L.apply(k,arguments)),R}}e.once=m}),define(me[76],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(me[94],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(L){function k(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}L.is=k;const C=Object.freeze([]);function R(){return C}L.empty=R;function*S(g){yield g}L.single=S;function y(g){return g||C}L.from=y;function T(g){return!g||g[Symbol.iterator]().next().done===!0}L.isEmpty=T;function n(g){return g[Symbol.iterator]().next().value}L.first=n;function I(g,t){for(const u of g)if(t(u))return!0;return!1}L.some=I;function c(g,t){for(const u of g)if(t(u))return u}L.find=c;function*f(g,t){for(const u of g)t(u)&&(yield u)}L.filter=f;function*h(g,t){let u=0;for(const r of g)yield t(r,u++)}L.map=h;function*p(...g){for(const t of g)for(const u of t)yield u}L.concat=p;function*D(g){for(const t of g)for(const u of t)yield u}L.concatNested=D;function A(g,t,u){let r=u;for(const i of g)r=t(r,i);return r}L.reduce=A;function*E(g,t,u=g.length){for(t<0&&(t+=g.length),u<0?u+=g.length:u>g.length&&(u=g.length);t<u;t++)yield g[t]}L.slice=E;function a(g,t=Number.POSITIVE_INFINITY){const u=[];if(t===0)return[u,g];const r=g[Symbol.iterator]();for(let i=0;i<t;i++){const o=r.next();if(o.done)return[u,L.empty()];u.push(o.value)}return[u,{[Symbol.iterator](){return r}}]}L.consume=a;function s(g,t,u=(r,i)=>r===i){const r=g[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const o=r.next(),l=i.next();if(o.done!==l.done)return!1;if(o.done)return!0;if(!u(o.value,l.value))return!1}}L.equals=s})(m=e.Iterable||(e.Iterable={}))}),define(me[60],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function R(t,u=!1){let r=0,i=t.length,o="",l=0,d=16,b=0;function _(G){let N=0,z=0;for(;N<G;){const O=t.charCodeAt(r);if(O>=48&&O<=57)z=z*16+O-48;else if(O>=65&&O<=70)z=z*16+O-65+10;else if(O>=97&&O<=102)z=z*16+O-97+10;else break;r++,N++}return N<G&&(z=-1),z}function v(G){r=G,o="",l=0,d=16,b=0}function P(){const G=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&T(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&T(t.charCodeAt(r)))for(r++;r<t.length&&T(t.charCodeAt(r));)r++;else return b=3,t.substring(G,r);let N=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&T(t.charCodeAt(r))){for(r++;r<t.length&&T(t.charCodeAt(r));)r++;N=r}else b=3;return t.substring(G,N)}function w(){let G="",N=r;for(;;){if(r>=i){G+=t.substring(N,r),b=2;break}const z=t.charCodeAt(r);if(z===34){G+=t.substring(N,r),r++;break}if(z===92){if(G+=t.substring(N,r),r++,r>=i){b=2;break}switch(t.charCodeAt(r++)){case 34:G+='"';break;case 92:G+="\\";break;case 47:G+="/";break;case 98:G+="\b";break;case 102:G+="\f";break;case 110:G+=`
`;break;case 114:G+="\r";break;case 116:G+="	";break;case 117:const x=_(4);x>=0?G+=String.fromCharCode(x):b=4;break;default:b=5}N=r;continue}if(z>=0&&z<=31)if(y(z)){G+=t.substring(N,r),b=2;break}else b=6;r++}return G}function F(){if(o="",b=0,l=r,r>=i)return l=i,d=17;let G=t.charCodeAt(r);if(S(G)){do r++,o+=String.fromCharCode(G),G=t.charCodeAt(r);while(S(G));return d=15}if(y(G))return r++,o+=String.fromCharCode(G),G===13&&t.charCodeAt(r)===10&&(r++,o+=`
`),d=14;switch(G){case 123:return r++,d=1;case 125:return r++,d=2;case 91:return r++,d=3;case 93:return r++,d=4;case 58:return r++,d=6;case 44:return r++,d=5;case 34:return r++,o=w(),d=10;case 47:const N=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!y(t.charCodeAt(r));)r++;return o=t.substring(N,r),d=12}if(t.charCodeAt(r+1)===42){r+=2;const z=i-1;let O=!1;for(;r<z;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,O=!0;break}r++}return O||(r++,b=1),o=t.substring(N,r),d=13}return o+=String.fromCharCode(G),r++,d=16;case 45:if(o+=String.fromCharCode(G),r++,r===i||!T(t.charCodeAt(r)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=P(),d=11;default:for(;r<i&&M(G);)r++,G=t.charCodeAt(r);if(l!==r){switch(o=t.substring(l,r),o){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return o+=String.fromCharCode(G),r++,d=16}}function M(G){if(S(G)||y(G))return!1;switch(G){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let G;do G=F();while(G>=12&&G<=15);return G}return{setPosition:v,getPosition:()=>r,scan:u?K:F,getToken:()=>d,getTokenValue:()=>o,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>b}}e.createScanner=R;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function T(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function I(t,u){const r=[],i=new Object;let o;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function b(_,v,P,w){l.value=_,l.offset=v,l.length=P,l.type=w,l.colonOffset=void 0,o=l}try{a(t,{onObjectBegin:(_,v)=>{if(u<=_)throw i;o=void 0,d=u>_,r.push("")},onObjectProperty:(_,v,P)=>{if(u<v||(b(_,v,P,"property"),r[r.length-1]=_,u<=v+P))throw i},onObjectEnd:(_,v)=>{if(u<=_)throw i;o=void 0,r.pop()},onArrayBegin:(_,v)=>{if(u<=_)throw i;o=void 0,r.push(0)},onArrayEnd:(_,v)=>{if(u<=_)throw i;o=void 0,r.pop()},onLiteralValue:(_,v,P)=>{if(u<v||(b(_,v,P,g(_)),u<=v+P))throw i},onSeparator:(_,v,P)=>{if(u<=v)throw i;if(_===":"&&o&&o.type==="property")o.colonOffset=v,d=!1,o=void 0;else if(_===","){const w=r[r.length-1];typeof w=="number"?r[r.length-1]=w+1:(d=!0,r[r.length-1]=""),o=void 0}}})}catch(_){if(_!==i)throw _}return{path:r,previousNode:o,isAtPropertyKey:d,matches:_=>{let v=0;for(let P=0;v<_.length&&P<r.length;P++)if(_[v]===r[P]||_[v]==="*")v++;else if(_[v]!=="**")return!1;return v===_.length}}}e.getLocation=I;function c(t,u=[],r=C.DEFAULT){let i=null,o=[];const l=[];function d(_){Array.isArray(o)?o.push(_):i!==null&&(o[i]=_)}return a(t,{onObjectBegin:()=>{const _={};d(_),l.push(o),o=_,i=null},onObjectProperty:_=>{i=_},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const _=[];d(_),l.push(o),o=_,i=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:d,onError:(_,v,P)=>{u.push({error:_,offset:v,length:P})}},r),o[0]}e.parse=c;function f(t,u=[],r=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(_){i.type==="property"&&(i.length=_-i.offset,i=i.parent)}function l(_){return i.children.push(_),_}a(t,{onObjectBegin:_=>{i=l({type:"object",offset:_,length:-1,parent:i,children:[]})},onObjectProperty:(_,v,P)=>{i=l({type:"property",offset:v,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:_,offset:v,length:P,parent:i})},onObjectEnd:(_,v)=>{i.length=_+v-i.offset,i=i.parent,o(_+v)},onArrayBegin:(_,v)=>{i=l({type:"array",offset:_,length:-1,parent:i,children:[]})},onArrayEnd:(_,v)=>{i.length=_+v-i.offset,i=i.parent,o(_+v)},onLiteralValue:(_,v,P)=>{l({type:g(_),offset:v,length:P,parent:i,value:_}),o(v+P)},onSeparator:(_,v,P)=>{i.type==="property"&&(_===":"?i.colonOffset=v:_===","&&o(v))},onError:(_,v,P)=>{u.push({error:_,offset:v,length:P})}},r);const b=i.children[0];return b&&delete b.parent,b}e.parseTree=f;function h(t,u){if(!t)return;let r=t;for(let i of u)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===i){r=l.children[1],o=!0;break}if(!o)return}else{const o=i;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}e.findNodeAtLocation=h;function p(t){if(!t.parent||!t.parent.children)return[];const u=p(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;u.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&u.push(r)}return u}e.getNodePath=p;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const u=Object.create(null);for(let r of t.children){const i=r.children[1];i&&(u[r.children[0].value]=D(i))}return u;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function A(t,u,r=!1){return u>=t.offset&&u<t.offset+t.length||r&&u===t.offset+t.length}e.contains=A;function E(t,u,r=!1){if(A(t,u,r)){const i=t.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=u;o++){const l=E(i[o],u,r);if(l)return l}return t}}e.findNodeAtOffset=E;function a(t,u,r=C.DEFAULT){const i=R(t,!1);function o(Y){return Y?()=>Y(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(Y){return Y?he=>Y(he,i.getTokenOffset(),i.getTokenLength()):()=>!0}const d=o(u.onObjectBegin),b=l(u.onObjectProperty),_=o(u.onObjectEnd),v=o(u.onArrayBegin),P=o(u.onArrayEnd),w=l(u.onLiteralValue),F=l(u.onSeparator),M=o(u.onComment),K=l(u.onError),G=r&&r.disallowComments,N=r&&r.allowTrailingComma;function z(){for(;;){const Y=i.scan();switch(i.getTokenError()){case 4:O(14);break;case 5:O(15);break;case 3:O(13);break;case 1:G||O(11);break;case 2:O(12);break;case 6:O(16);break}switch(Y){case 12:case 13:G?O(10):M();break;case 16:O(1);break;case 15:case 14:break;default:return Y}}}function O(Y,he=[],_e=[]){if(K(Y),he.length+_e.length>0){let Se=i.getToken();for(;Se!==17;){if(he.indexOf(Se)!==-1){z();break}else if(_e.indexOf(Se)!==-1)break;Se=z()}}}function x(Y){const he=i.getTokenValue();return Y?w(he):b(he),z(),!0}function B(){switch(i.getToken()){case 11:let Y=0;try{Y=JSON.parse(i.getTokenValue()),typeof Y!="number"&&(O(2),Y=0)}catch(he){O(2)}w(Y);break;case 7:w(null);break;case 8:w(!0);break;case 9:w(!1);break;default:return!1}return z(),!0}function U(){return i.getToken()!==10?(O(3,[],[2,5]),!1):(x(!1),i.getToken()===6?(F(":"),z(),Q()||O(4,[],[2,5])):O(5,[],[2,5]),!0)}function H(){d(),z();let Y=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Y||O(4,[],[]),F(","),z(),i.getToken()===2&&N)break}else Y&&O(6,[],[]);U()||O(4,[],[2,5]),Y=!0}return _(),i.getToken()!==2?O(7,[2],[]):z(),!0}function W(){v(),z();let Y=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Y||O(4,[],[]),F(","),z(),i.getToken()===4&&N)break}else Y&&O(6,[],[]);Q()||O(4,[],[4,5]),Y=!0}return P(),i.getToken()!==4?O(8,[4],[]):z(),!0}function Q(){switch(i.getToken()){case 3:return W();case 1:return H();case 10:return x(!0);default:return B()}}return z(),i.getToken()===17?r.allowEmptyContent?!0:(O(4,[],[]),!1):Q()?(i.getToken()!==17&&O(9,[],[]),!0):(O(4,[],[]),!1)}e.visit=a;function s(t,u){let r=R(t),i=[],o,l=0,d;do switch(d=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:l!==d&&i.push(t.substring(l,d)),u!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,u)),l=r.getPosition();break}while(o!==17);return i.join("")}e.stripComments=s;function g(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(me[137],ge([0,1,60]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(y,T,n){let I,c,f,h,p;if(T){for(h=T.offset,p=h+T.length,f=h;f>0&&!S(y,f-1);)f--;let l=p;for(;l<y.length&&!S(y,l);)l++;c=y.substring(f,l),I=C(c,n)}else c=y,I=0,f=0,h=0,p=y.length;const D=R(n,y);let A=!1,E=0,a;n.insertSpaces?a=k(" ",n.tabSize||4):a="	";const s=(0,m.createScanner)(c,!1);let g=!1;function t(){return D+k(a,I+E)}function u(){let l=s.scan();for(A=!1;l===15||l===14;)A=A||l===14,l=s.scan();return g=l===16||s.getTokenError()!==0,l}const r=[];function i(l,d,b){!g&&d<p&&b>h&&y.substring(d,b)!==l&&r.push({offset:d,length:b-d,content:l})}let o=u();if(o!==17){const l=s.getTokenOffset()+f,d=k(a,I);i(d,f,l)}for(;o!==17;){let l=s.getTokenOffset()+s.getTokenLength()+f,d=u(),b="";for(;!A&&(d===12||d===13);){const v=s.getTokenOffset()+f;i(" ",l,v),l=s.getTokenOffset()+s.getTokenLength()+f,b=d===12?t():"",d=u()}if(d===2)o!==1&&(E--,b=t());else if(d===4)o!==3&&(E--,b=t());else{switch(o){case 3:case 1:E++,b=t();break;case 5:case 12:b=t();break;case 13:A?b=t():b=" ";break;case 6:b=" ";break;case 10:if(d===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?b=" ":d!==5&&d!==17&&(g=!0);break;case 16:g=!0;break}A&&(d===12||d===13)&&(b=t())}const _=s.getTokenOffset()+f;i(b,l,_),o=d}return r}e.format=L;function k(y,T){let n="";for(let I=0;I<T;I++)n+=y;return n}function C(y,T){let n=0,I=0;const c=T.tabSize||4;for(;n<y.length;){const f=y.charAt(n);if(f===" ")I++;else if(f==="	")I+=c;else break;n++}return Math.floor(I/c)}function R(y,T){for(let n=0;n<T.length;n++){const I=T.charAt(n);if(I==="\r")return n+1<T.length&&T.charAt(n+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=R;function S(y,T){return`\r
`.indexOf(y.charAt(T))!==-1}e.isEOL=S}),define(me[138],ge([0,1,60,137]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(T,n,I){return C(T,n,void 0,I)}e.removeProperty=k;function C(T,n,I,c,f){const h=n.slice(),p=[],D=(0,m.parseTree)(T,p);let A,E;for(;h.length>0&&(E=h.pop(),A=(0,m.findNodeAtLocation)(D,h),A===void 0&&I!==void 0);)typeof E=="string"?I={[E]:I}:I=[I];if(A)if(A.type==="object"&&typeof E=="string"&&Array.isArray(A.children)){const a=(0,m.findNodeAtLocation)(A,[E]);if(a!==void 0)if(I===void 0){if(!a.parent)throw new Error("Malformed AST");const s=A.children.indexOf(a.parent);let g,t=a.parent.offset+a.parent.length;if(s>0){const u=A.children[s-1];g=u.offset+u.length}else g=A.offset+1,A.children.length>1&&(t=A.children[1].offset);return R(T,{offset:g,length:t-g,content:""},c)}else return R(T,{offset:a.offset,length:a.length,content:JSON.stringify(I)},c);else{if(I===void 0)return[];const s=`${JSON.stringify(E)}: ${JSON.stringify(I)}`,g=f?f(A.children.map(u=>u.children[0].value)):A.children.length;let t;if(g>0){const u=A.children[g-1];t={offset:u.offset+u.length,length:0,content:","+s}}else A.children.length===0?t={offset:A.offset+1,length:0,content:s}:t={offset:A.offset+1,length:0,content:s+","};return R(T,t,c)}}else if(A.type==="array"&&typeof E=="number"&&Array.isArray(A.children))if(I!==void 0){const a=`${JSON.stringify(I)}`;let s;if(A.children.length===0||E===0)s={offset:A.offset+1,length:0,content:A.children.length===0?a:a+","};else{const g=E===-1||E>A.children.length?A.children.length:E,t=A.children[g-1];s={offset:t.offset+t.length,length:0,content:","+a}}return R(T,s,c)}else{const a=E,s=A.children[a];let g;if(A.children.length===1)g={offset:A.offset+1,length:A.length-2,content:""};else if(A.children.length-1===a){const t=A.children[a-1],u=t.offset+t.length,r=A.offset+A.length;g={offset:u,length:r-2-u,content:""}}else g={offset:s.offset,length:A.children[a+1].offset-s.offset,content:""};return R(T,g,c)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${A.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return R(T,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(I)},c)}}e.setProperty=C;function R(T,n,I){let c=S(T,n),f=n.offset,h=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;f>0&&!(0,L.isEOL)(c,f-1);)f--;for(;h<c.length&&!(0,L.isEOL)(c,h);)h++}const p=(0,L.format)(c,{offset:f,length:h-f},I);for(let A=p.length-1;A>=0;A--){const E=p[A];c=S(c,E),f=Math.min(f,E.offset),h=Math.max(h,E.offset+E.length),h+=E.content.length-E.length}const D=T.length-(c.length-h)-f;return[{offset:f,length:D,content:c.substring(f,h)}]}e.withFormatting=R;function S(T,n){return T.substring(0,n.offset)+n.content+T.substring(n.offset+n.length)}e.applyEdit=S;function y(T,n){let I=n.slice(0).sort((f,h)=>{const p=f.offset-h.offset;return p===0?f.length-h.length:p}),c=T.length;for(let f=I.length-1;f>=0;f--){let h=I[f];if(h.offset+h.length<=c)T=S(T,h);else throw new Error("Overlapping edit");c=h.offset}return T}e.applyEdits=y}),define(me[139],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new m(()=>k(this.getValue()))}}e.Lazy=m}),define(me[6],ge([0,1,75,94]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let C=null;function R(r){C=r}if(e.setDisposableTracker=R,k){const r="__is_disposable_tracked__";R(new class{trackDisposable(i){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[r]||console.log(o)},3e3)}setParent(i,o){if(i&&i!==E.None)try{i[r]=!0}catch{}}markAsDisposed(i){if(i&&i!==E.None)try{i[r]=!0}catch{}}markAsSingleton(i){}})}function S(r){return C?.trackDisposable(r),r}function y(r){C?.markAsDisposed(r)}function T(r,i){C?.setParent(r,i)}function n(r,i){if(!!C)for(const o of r)C.setParent(o,i)}function I(r){return C?.markAsSingleton(r),r}e.markAsSingleton=I;class c extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=c;function f(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=f;function h(r){if(L.Iterable.is(r)){let i=[];for(const o of r)if(o)try{o.dispose()}catch(l){i.push(l)}if(i.length===1)throw i[0];if(i.length>1)throw new c(i);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=h;function p(...r){const i=D(()=>h(r));return n(r,i),i}e.combinedDisposable=p;function D(r){const i=S({dispose:(0,m.once)(()=>{y(i),r()})});return i}e.toDisposable=D;class A{constructor(){this._toDispose=new Set,this._isDisposed=!1,S(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return T(i,this),this._isDisposed?A.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=A,A.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new A,S(this),T(this._store,this)}dispose(){y(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=E,E.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&T(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&T(i,null),i}}e.MutableDisposable=a;class s{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class g{constructor(){this.references=new Map}acquire(i,...o){let l=this.references.get(i);l||(l={counter:0,object:this.createReferencedObject(i,...o)},this.references.set(i,l));const{object:d}=l,b=(0,m.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(i,l.object),this.references.delete(i))});return l.counter++,{object:d,dispose:b}}}e.ReferenceCollection=g;class t{constructor(i){this.referenceCollection=i}async acquire(i,...o){const l=this.referenceCollection.acquire(i,...o);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(d){throw l.dispose(),d}}}e.AsyncReferenceCollection=t;class u{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=u}),define(me[95],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(C){this.element=C,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class L{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let C=this._first;for(;C!==m.Undefined;){const R=C.next;C.prev=m.Undefined,C.next=m.Undefined,C=R}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,R){const S=new m(C);if(this._first===m.Undefined)this._first=S,this._last=S;else if(R){const T=this._last;this._last=S,S.prev=T,T.next=S}else{const T=this._first;this._first=S,S.next=T,T.prev=S}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(S))}}shift(){if(this._first!==m.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==m.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==m.Undefined&&C.next!==m.Undefined){const R=C.prev;R.next=C.next,C.next.prev=R}else C.prev===m.Undefined&&C.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):C.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):C.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==m.Undefined;)yield C.element,C=C.next}}e.LinkedList=L}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(Le,ye){for(var ke=0;ke<ye.length;ke++){var ne=ye[ke];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(Le,ne.key,ne)}}function e(Le,ye,ke){return ye&&J(Le.prototype,ye),ke&&J(Le,ke),Le}function m(Le,ye){if(!!Le){if(typeof Le=="string")return L(Le,ye);var ke=Object.prototype.toString.call(Le).slice(8,-1);if(ke==="Object"&&Le.constructor&&(ke=Le.constructor.name),ke==="Map"||ke==="Set")return Array.from(Le);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return L(Le,ye)}}function L(Le,ye){(ye==null||ye>Le.length)&&(ye=Le.length);for(var ke=0,ne=new Array(ye);ke<ye;ke++)ne[ke]=Le[ke];return ne}function k(Le,ye){var ke=typeof Symbol!="undefined"&&Le[Symbol.iterator]||Le["@@iterator"];if(ke)return(ke=ke.call(Le)).next.bind(ke);if(Array.isArray(Le)||(ke=m(Le))||ye&&Le&&typeof Le.length=="number"){ke&&(Le=ke);var ne=0;return function(){return ne>=Le.length?{done:!0}:{done:!1,value:Le[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function R(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function S(Le){C.exports.defaults=Le}C.exports={defaults:R(),getDefaults:R,changeDefaults:S};var y=/[&<>"']/,T=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(ye){return c[ye]};function h(Le,ye){if(ye){if(y.test(Le))return Le.replace(T,f)}else if(n.test(Le))return Le.replace(I,f);return Le}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function D(Le){return Le.replace(p,function(ye,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var A=/(^|[^\[])\^/g;function E(Le,ye){Le=Le.source||Le,ye=ye||"";var ke={replace:function(de,be){return be=be.source||be,be=be.replace(A,"$1"),Le=Le.replace(de,be),ke},getRegex:function(){return new RegExp(Le,ye)}};return ke}var a=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(Le,ye,ke){if(Le){var ne;try{ne=decodeURIComponent(D(ke)).replace(a,"").toLowerCase()}catch(de){return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}ye&&!s.test(ke)&&(ke=o(ye,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch(de){return null}return ke}var t={},u=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(Le,ye){t[" "+Le]||(u.test(Le)?t[" "+Le]=Le+"/":t[" "+Le]=_(Le,"/",!0)),Le=t[" "+Le];var ke=Le.indexOf(":")===-1;return ye.substring(0,2)==="//"?ke?ye:Le.replace(r,"$1")+ye:ye.charAt(0)==="/"?ke?ye:Le.replace(i,"$1")+ye:Le+ye}var l={exec:function(){}};function d(Le){for(var ye=1,ke,ne;ye<arguments.length;ye++){ke=arguments[ye];for(ne in ke)Object.prototype.hasOwnProperty.call(ke,ne)&&(Le[ne]=ke[ne])}return Le}function b(Le,ye){var ke=Le.replace(/\|/g,function(be,we,Fe){for(var Ge=!1,He=we;--He>=0&&Fe[He]==="\\";)Ge=!Ge;return Ge?"|":" |"}),ne=ke.split(/ \|/),de=0;if(ne[0].trim()||ne.shift(),ne[ne.length-1].trim()||ne.pop(),ne.length>ye)ne.splice(ye);else for(;ne.length<ye;)ne.push("");for(;de<ne.length;de++)ne[de]=ne[de].trim().replace(/\\\|/g,"|");return ne}function _(Le,ye,ke){var ne=Le.length;if(ne===0)return"";for(var de=0;de<ne;){var be=Le.charAt(ne-de-1);if(be===ye&&!ke)de++;else if(be!==ye&&ke)de++;else break}return Le.substr(0,ne-de)}function v(Le,ye){if(Le.indexOf(ye[1])===-1)return-1;for(var ke=Le.length,ne=0,de=0;de<ke;de++)if(Le[de]==="\\")de++;else if(Le[de]===ye[0])ne++;else if(Le[de]===ye[1]&&(ne--,ne<0))return de;return-1}function P(Le){Le&&Le.sanitize&&!Le.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function w(Le,ye){if(ye<1)return"";for(var ke="";ye>1;)ye&1&&(ke+=Le),ye>>=1,Le+=Le;return ke+Le}var F={escape:h,unescape:D,edit:E,cleanUrl:g,resolveUrl:o,noopTest:l,merge:d,splitCells:b,rtrim:_,findClosingBracket:v,checkSanitizeDeprecation:P,repeatString:w},M=C.exports.defaults,K=F.rtrim,G=F.splitCells,N=F.escape,z=F.findClosingBracket;function O(Le,ye,ke,ne){var de=ye.href,be=ye.title?N(ye.title):null,we=Le[1].replace(/\\([\[\]])/g,"$1");if(Le[0].charAt(0)!=="!"){ne.state.inLink=!0;var Fe={type:"link",raw:ke,href:de,title:be,text:we,tokens:ne.inlineTokens(we,[])};return ne.state.inLink=!1,Fe}else return{type:"image",raw:ke,href:de,title:be,text:N(we)}}function x(Le,ye){var ke=Le.match(/^(\s+)(?:```)/);if(ke===null)return ye;var ne=ke[1];return ye.split(`
`).map(function(de){var be=de.match(/^\s+/);if(be===null)return de;var we=be[0];return we.length>=ne.length?de.slice(ne.length):de}).join(`
`)}var B=function(){function Le(ke){this.options=ke||M}var ye=Le.prototype;return ye.space=function(ne){var de=this.rules.block.newline.exec(ne);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},ye.code=function(ne){var de=this.rules.block.code.exec(ne);if(de){var be=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?be:K(be,`
`)}}},ye.fences=function(ne){var de=this.rules.block.fences.exec(ne);if(de){var be=de[0],we=x(be,de[3]||"");return{type:"code",raw:be,lang:de[2]?de[2].trim():de[2],text:we}}},ye.heading=function(ne){var de=this.rules.block.heading.exec(ne);if(de){var be=de[2].trim();if(/#$/.test(be)){var we=K(be,"#");(this.options.pedantic||!we||/ $/.test(we))&&(be=we.trim())}var Fe={type:"heading",raw:de[0],depth:de[1].length,text:be,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},ye.hr=function(ne){var de=this.rules.block.hr.exec(ne);if(de)return{type:"hr",raw:de[0]}},ye.blockquote=function(ne){var de=this.rules.block.blockquote.exec(ne);if(de){var be=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},ye.list=function(ne){var de=this.rules.block.list.exec(ne);if(de){var be,we,Fe,Ge,He,Ye,it,ae,Ee,ce,q=de[1].trim(),Te=q.length>1,Pe={type:"list",raw:"",ordered:Te,start:Te?+q.slice(0,-1):"",loose:!1,items:[]};q=Te?"\\d{1,9}\\"+q.slice(-1):"\\"+q,this.options.pedantic&&(q=Te?q:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+q+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ne&&!(this.rules.block.hr.test(ne)||!(de=Ze.exec(ne)));){Ee=de[2].split(`
`),this.options.pedantic?(Ge=2,ce=Ee[0].trimLeft()):(Ge=de[2].search(/[^ ]/),Ge=de[1].length+(Ge>4?1:Ge),ce=Ee[0].slice(Ge-de[1].length)),Ye=!1,be=de[0],!Ee[0]&&/^ *$/.test(Ee[1])&&(be=de[1]+Ee.slice(0,2).join(`
`)+`
`,Pe.loose=!0,Ee=[]);var Xe=new RegExp("^ {0,"+Math.min(3,Ge-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(He=1;He<Ee.length;He++){if(ae=Ee[He],this.options.pedantic&&(ae=ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Xe.test(ae)){be=de[1]+Ee.slice(0,He).join(`
`)+`
`;break}if(!Ye){ae.trim()||(Ye=!0),ae.search(/[^ ]/)>=Ge?ce+=`
`+ae.slice(Ge):ce+=`
`+ae;continue}if(ae.search(/[^ ]/)>=Ge||!ae.trim()){ce+=`
`+ae.slice(Ge);continue}else{be=de[1]+Ee.slice(0,He).join(`
`)+`
`;break}}Pe.loose||(it?Pe.loose=!0:/\n *\n *$/.test(be)&&(it=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(ce),we&&(Fe=we[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),Pe.items.push({type:"list_item",raw:be,task:!!we,checked:Fe,loose:!1,text:ce}),Pe.raw+=be,ne=ne.slice(be.length)}Pe.items[Pe.items.length-1].raw=be.trimRight(),Pe.items[Pe.items.length-1].text=ce.trimRight(),Pe.raw=Pe.raw.trimRight();var st=Pe.items.length;for(He=0;He<st;He++)this.lexer.state.top=!1,Pe.items[He].tokens=this.lexer.blockTokens(Pe.items[He].text,[]),Pe.items[He].tokens.some(function(wt){return wt.type==="space"})&&(Pe.loose=!0,Pe.items[He].loose=!0);return Pe}},ye.html=function(ne){var de=this.rules.block.html.exec(ne);if(de){var be={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(be.type="paragraph",be.text=this.options.sanitizer?this.options.sanitizer(de[0]):N(de[0]),be.tokens=[],this.lexer.inline(be.text,be.tokens)),be}},ye.def=function(ne){var de=this.rules.block.def.exec(ne);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var be=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:de[0],href:de[2],title:de[3]}}},ye.table=function(ne){var de=this.rules.block.table.exec(ne);if(de){var be={type:"table",header:G(de[1]).map(function(it){return{text:it}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=de[0];var we=be.align.length,Fe,Ge,He,Ye;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(be.align[Fe])?be.align[Fe]="right":/^ *:-+: *$/.test(be.align[Fe])?be.align[Fe]="center":/^ *:-+ *$/.test(be.align[Fe])?be.align[Fe]="left":be.align[Fe]=null;for(we=be.rows.length,Fe=0;Fe<we;Fe++)be.rows[Fe]=G(be.rows[Fe],be.header.length).map(function(it){return{text:it}});for(we=be.header.length,Ge=0;Ge<we;Ge++)be.header[Ge].tokens=[],this.lexer.inlineTokens(be.header[Ge].text,be.header[Ge].tokens);for(we=be.rows.length,Ge=0;Ge<we;Ge++)for(Ye=be.rows[Ge],He=0;He<Ye.length;He++)Ye[He].tokens=[],this.lexer.inlineTokens(Ye[He].text,Ye[He].tokens);return be}}},ye.lheading=function(ne){var de=this.rules.block.lheading.exec(ne);if(de){var be={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},ye.paragraph=function(ne){var de=this.rules.block.paragraph.exec(ne);if(de){var be={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},ye.text=function(ne){var de=this.rules.block.text.exec(ne);if(de){var be={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},ye.escape=function(ne){var de=this.rules.inline.escape.exec(ne);if(de)return{type:"escape",raw:de[0],text:N(de[1])}},ye.tag=function(ne){var de=this.rules.inline.tag.exec(ne);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):N(de[0]):de[0]}},ye.link=function(ne){var de=this.rules.inline.link.exec(ne);if(de){var be=de[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var we=K(be.slice(0,-1),"\\");if((be.length-we.length)%2==0)return}else{var Fe=z(de[2],"()");if(Fe>-1){var Ge=de[0].indexOf("!")===0?5:4,He=Ge+de[1].length+Fe;de[2]=de[2].substring(0,Fe),de[0]=de[0].substring(0,He).trim(),de[3]=""}}var Ye=de[2],it="";if(this.options.pedantic){var ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ye);ae&&(Ye=ae[1],it=ae[3])}else it=de[3]?de[3].slice(1,-1):"";return Ye=Ye.trim(),/^</.test(Ye)&&(this.options.pedantic&&!/>$/.test(be)?Ye=Ye.slice(1):Ye=Ye.slice(1,-1)),O(de,{href:Ye&&Ye.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},ye.reflink=function(ne,de){var be;if((be=this.rules.inline.reflink.exec(ne))||(be=this.rules.inline.nolink.exec(ne))){var we=(be[2]||be[1]).replace(/\s+/g," ");if(we=de[we.toLowerCase()],!we||!we.href){var Fe=be[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return O(be,we,be[0],this.lexer)}},ye.emStrong=function(ne,de,be){be===void 0&&(be="");var we=this.rules.inline.emStrong.lDelim.exec(ne);if(!!we&&!(we[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(be===""||this.rules.inline.punctuation.exec(be))){var Ge=we[0].length-1,He,Ye,it=Ge,ae=0,Ee=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ee.lastIndex=0,de=de.slice(-1*ne.length+Ge);(we=Ee.exec(de))!=null;)if(He=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!He){if(Ye=He.length,we[3]||we[4]){it+=Ye;continue}else if((we[5]||we[6])&&Ge%3&&!((Ge+Ye)%3)){ae+=Ye;continue}if(it-=Ye,!(it>0)){if(Ye=Math.min(Ye,Ye+it+ae),Math.min(Ge,Ye)%2){var ce=ne.slice(1,Ge+we.index+Ye);return{type:"em",raw:ne.slice(0,Ge+we.index+Ye+1),text:ce,tokens:this.lexer.inlineTokens(ce,[])}}var q=ne.slice(2,Ge+we.index+Ye-1);return{type:"strong",raw:ne.slice(0,Ge+we.index+Ye+1),text:q,tokens:this.lexer.inlineTokens(q,[])}}}}}},ye.codespan=function(ne){var de=this.rules.inline.code.exec(ne);if(de){var be=de[2].replace(/\n/g," "),we=/[^ ]/.test(be),Fe=/^ /.test(be)&&/ $/.test(be);return we&&Fe&&(be=be.substring(1,be.length-1)),be=N(be,!0),{type:"codespan",raw:de[0],text:be}}},ye.br=function(ne){var de=this.rules.inline.br.exec(ne);if(de)return{type:"br",raw:de[0]}},ye.del=function(ne){var de=this.rules.inline.del.exec(ne);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},ye.autolink=function(ne,de){var be=this.rules.inline.autolink.exec(ne);if(be){var we,Fe;return be[2]==="@"?(we=N(this.options.mangle?de(be[1]):be[1]),Fe="mailto:"+we):(we=N(be[1]),Fe=we),{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ye.url=function(ne,de){var be;if(be=this.rules.inline.url.exec(ne)){var we,Fe;if(be[2]==="@")we=N(this.options.mangle?de(be[0]):be[0]),Fe="mailto:"+we;else{var Ge;do Ge=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(Ge!==be[0]);we=N(be[0]),be[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ye.inlineText=function(ne,de){var be=this.rules.inline.text.exec(ne);if(be){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):N(be[0]):be[0]:we=N(this.options.smartypants?de(be[0]):be[0]),{type:"text",raw:be[0],text:we}}},Le}(),U=F.noopTest,H=F.edit,W=F.merge,Q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:U,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Q.def=H(Q.def).replace("label",Q._label).replace("title",Q._title).getRegex(),Q.bullet=/(?:[*+-]|\d{1,9}[.)])/,Q.listItemStart=H(/^( *)(bull) */).replace("bull",Q.bullet).getRegex(),Q.list=H(Q.list).replace(/bull/g,Q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Q.def.source+")").getRegex(),Q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Q.html=H(Q.html,"i").replace("comment",Q._comment).replace("tag",Q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Q.paragraph=H(Q._paragraph).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.blockquote=H(Q.blockquote).replace("paragraph",Q.paragraph).getRegex(),Q.normal=W({},Q),Q.gfm=W({},Q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Q.gfm.table=H(Q.gfm.table).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.pedantic=W({},Q.normal,{html:H(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:U,paragraph:H(Q.normal._paragraph).replace("hr",Q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Y={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:U,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:U,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Y._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Y.punctuation=H(Y.punctuation).replace(/punctuation/g,Y._punctuation).getRegex(),Y.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Y.escapedEmSt=/\\\*|\\_/g,Y._comment=H(Q._comment).replace("(?:-->|$)","-->").getRegex(),Y.emStrong.lDelim=H(Y.emStrong.lDelim).replace(/punct/g,Y._punctuation).getRegex(),Y.emStrong.rDelimAst=H(Y.emStrong.rDelimAst,"g").replace(/punct/g,Y._punctuation).getRegex(),Y.emStrong.rDelimUnd=H(Y.emStrong.rDelimUnd,"g").replace(/punct/g,Y._punctuation).getRegex(),Y._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Y._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Y._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Y.autolink=H(Y.autolink).replace("scheme",Y._scheme).replace("email",Y._email).getRegex(),Y._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Y.tag=H(Y.tag).replace("comment",Y._comment).replace("attribute",Y._attribute).getRegex(),Y._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Y._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Y._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Y.link=H(Y.link).replace("label",Y._label).replace("href",Y._href).replace("title",Y._title).getRegex(),Y.reflink=H(Y.reflink).replace("label",Y._label).getRegex(),Y.reflinkSearch=H(Y.reflinkSearch,"g").replace("reflink",Y.reflink).replace("nolink",Y.nolink).getRegex(),Y.normal=W({},Y),Y.pedantic=W({},Y.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:H(/^!?\[(label)\]\((.*?)\)/).replace("label",Y._label).getRegex(),reflink:H(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Y._label).getRegex()}),Y.gfm=W({},Y.normal,{escape:H(Y.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Y.gfm.url=H(Y.gfm.url,"i").replace("email",Y.gfm._extended_email).getRegex(),Y.breaks=W({},Y.gfm,{br:H(Y.br).replace("{2,}","*").getRegex(),text:H(Y.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var he={block:Q,inline:Y},_e=B,Se=C.exports.defaults,Re=he.block,xe=he.inline,Ue=F.repeatString;function je(Le){return Le.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(Le){var ye="",ke,ne,de=Le.length;for(ke=0;ke<de;ke++)ne=Le.charCodeAt(ke),Math.random()>.5&&(ne="x"+ne.toString(16)),ye+="&#"+ne+";";return ye}var ee=function(){function Le(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||Se,this.options.tokenizer=this.options.tokenizer||new _e,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:Re.normal,inline:xe.normal};this.options.pedantic?(ne.block=Re.pedantic,ne.inline=xe.pedantic):this.options.gfm&&(ne.block=Re.gfm,this.options.breaks?ne.inline=xe.breaks:ne.inline=xe.gfm),this.tokenizer.rules=ne}Le.lex=function(ne,de){var be=new Le(de);return be.lex(ne)},Le.lexInline=function(ne,de){var be=new Le(de);return be.inlineTokens(ne)};var ye=Le.prototype;return ye.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ne,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},ye.blockTokens=function(ne,de){var be=this;de===void 0&&(de=[]),this.options.pedantic&&(ne=ne.replace(/^ +$/gm,""));for(var we,Fe,Ge,He;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(we=it.call({lexer:be},ne,de))?(ne=ne.substring(we.raw.length),de.push(we),!0):!1}))){if(we=this.tokenizer.space(ne)){ne=ne.substring(we.raw.length),we.type&&de.push(we);continue}if(we=this.tokenizer.code(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we);continue}if(we=this.tokenizer.fences(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.heading(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.hr(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.blockquote(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.list(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.html(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.def(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.lheading(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(Ge=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=Infinity,ae=ne.slice(1),Ee=void 0;be.options.extensions.startBlock.forEach(function(ce){Ee=ce.call({lexer:this},ae),typeof Ee=="number"&&Ee>=0&&(it=Math.min(it,Ee))}),it<Infinity&&it>=0&&(Ge=ne.substring(0,it+1))}(),this.state.top&&(we=this.tokenizer.paragraph(Ge))){Fe=de[de.length-1],He&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we),He=Ge.length!==ne.length,ne=ne.substring(we.raw.length);continue}if(we=this.tokenizer.text(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we);continue}if(ne){var Ye="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(Ye);break}else throw new Error(Ye)}}return this.state.top=!0,de},ye.inline=function(ne,de){this.inlineQueue.push({src:ne,tokens:de})},ye.inlineTokens=function(ne,de){var be=this;de===void 0&&(de=[]);var we,Fe,Ge,He=ne,Ye,it,ae;if(this.tokens.links){var Ee=Object.keys(this.tokens.links);if(Ee.length>0)for(;(Ye=this.tokenizer.rules.inline.reflinkSearch.exec(He))!=null;)Ee.includes(Ye[0].slice(Ye[0].lastIndexOf("[")+1,-1))&&(He=He.slice(0,Ye.index)+"["+Ue("a",Ye[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ye=this.tokenizer.rules.inline.blockSkip.exec(He))!=null;)He=He.slice(0,Ye.index)+"["+Ue("a",Ye[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ye=this.tokenizer.rules.inline.escapedEmSt.exec(He))!=null;)He=He.slice(0,Ye.index)+"++"+He.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(it||(ae=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(q){return(we=q.call({lexer:be},ne,de))?(ne=ne.substring(we.raw.length),de.push(we),!0):!1}))){if(we=this.tokenizer.escape(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.tag(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(we=this.tokenizer.link(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(we=this.tokenizer.emStrong(ne,He,ae)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.codespan(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.br(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.del(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.autolink(ne,V)){ne=ne.substring(we.raw.length),de.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(ne,V))){ne=ne.substring(we.raw.length),de.push(we);continue}if(Ge=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var q=Infinity,Te=ne.slice(1),Pe=void 0;be.options.extensions.startInline.forEach(function(Ze){Pe=Ze.call({lexer:this},Te),typeof Pe=="number"&&Pe>=0&&(q=Math.min(q,Pe))}),q<Infinity&&q>=0&&(Ge=ne.substring(0,q+1))}(),we=this.tokenizer.inlineText(Ge,je)){ne=ne.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(ae=we.raw.slice(-1)),it=!0,Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(ne){var ce="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return de},e(Le,null,[{key:"rules",get:function(){return{block:Re,inline:xe}}}]),Le}(),re=C.exports.defaults,le=F.cleanUrl,Z=F.escape,oe=function(){function Le(ke){this.options=ke||re}var ye=Le.prototype;return ye.code=function(ne,de,be){var we=(de||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(ne,we);Fe!=null&&Fe!==ne&&(be=!0,ne=Fe)}return ne=ne.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+Z(we,!0)+'">'+(be?ne:Z(ne,!0))+`</code></pre>
`:"<pre><code>"+(be?ne:Z(ne,!0))+`</code></pre>
`},ye.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},ye.html=function(ne){return ne},ye.heading=function(ne,de,be,we){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+we.slug(be)+'">'+ne+"</h"+de+`>
`:"<h"+de+">"+ne+"</h"+de+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ne,de,be){var we=de?"ol":"ul",Fe=de&&be!==1?' start="'+be+'"':"";return"<"+we+Fe+`>
`+ne+"</"+we+`>
`},ye.listitem=function(ne){return"<li>"+ne+`</li>
`},ye.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ne){return"<p>"+ne+`</p>
`},ye.table=function(ne,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+de+`</table>
`},ye.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},ye.tablecell=function(ne,de){var be=de.header?"th":"td",we=de.align?"<"+be+' align="'+de.align+'">':"<"+be+">";return we+ne+"</"+be+`>
`},ye.strong=function(ne){return"<strong>"+ne+"</strong>"},ye.em=function(ne){return"<em>"+ne+"</em>"},ye.codespan=function(ne){return"<code>"+ne+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ne){return"<del>"+ne+"</del>"},ye.link=function(ne,de,be){if(ne=le(this.options.sanitize,this.options.baseUrl,ne),ne===null)return be;var we='<a href="'+Z(ne)+'"';return de&&(we+=' title="'+de+'"'),we+=">"+be+"</a>",we},ye.image=function(ne,de,be){if(ne=le(this.options.sanitize,this.options.baseUrl,ne),ne===null)return be;var we='<img src="'+ne+'" alt="'+be+'"';return de&&(we+=' title="'+de+'"'),we+=this.options.xhtml?"/>":">",we},ye.text=function(ne){return ne},Le}(),ve=function(){function Le(){}var ye=Le.prototype;return ye.strong=function(ne){return ne},ye.em=function(ne){return ne},ye.codespan=function(ne){return ne},ye.del=function(ne){return ne},ye.html=function(ne){return ne},ye.text=function(ne){return ne},ye.link=function(ne,de,be){return""+be},ye.image=function(ne,de,be){return""+be},ye.br=function(){return""},Le}(),Me=function(){function Le(){this.seen={}}var ye=Le.prototype;return ye.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ne,de){var be=ne,we=0;if(this.seen.hasOwnProperty(be)){we=this.seen[ne];do we++,be=ne+"-"+we;while(this.seen.hasOwnProperty(be))}return de||(this.seen[ne]=we,this.seen[be]=0),be},ye.slug=function(ne,de){de===void 0&&(de={});var be=this.serialize(ne);return this.getNextSafeSlug(be,de.dryrun)},Le}(),qe=oe,Qe=ve,Je=Me,Ce=C.exports.defaults,at=F.unescape,X=function(){function Le(ke){this.options=ke||Ce,this.options.renderer=this.options.renderer||new qe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Qe,this.slugger=new Je}Le.parse=function(ne,de){var be=new Le(de);return be.parse(ne)},Le.parseInline=function(ne,de){var be=new Le(de);return be.parseInline(ne)};var ye=Le.prototype;return ye.parse=function(ne,de){de===void 0&&(de=!0);var be="",we,Fe,Ge,He,Ye,it,ae,Ee,ce,q,Te,Pe,Ze,Xe,st,wt,_t,dt,gt,ft=ne.length;for(we=0;we<ft;we++){if(q=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[q.type]&&(gt=this.options.extensions.renderers[q.type].call({parser:this},q),gt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(q.type))){be+=gt||"";continue}switch(q.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(q.tokens),q.depth,at(this.parseInline(q.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(q.text,q.lang,q.escaped);continue}case"table":{for(Ee="",ae="",He=q.header.length,Fe=0;Fe<He;Fe++)ae+=this.renderer.tablecell(this.parseInline(q.header[Fe].tokens),{header:!0,align:q.align[Fe]});for(Ee+=this.renderer.tablerow(ae),ce="",He=q.rows.length,Fe=0;Fe<He;Fe++){for(it=q.rows[Fe],ae="",Ye=it.length,Ge=0;Ge<Ye;Ge++)ae+=this.renderer.tablecell(this.parseInline(it[Ge].tokens),{header:!1,align:q.align[Ge]});ce+=this.renderer.tablerow(ae)}be+=this.renderer.table(Ee,ce);continue}case"blockquote":{ce=this.parse(q.tokens),be+=this.renderer.blockquote(ce);continue}case"list":{for(Te=q.ordered,Pe=q.start,Ze=q.loose,He=q.items.length,ce="",Fe=0;Fe<He;Fe++)st=q.items[Fe],wt=st.checked,_t=st.task,Xe="",st.task&&(dt=this.renderer.checkbox(wt),Ze?st.tokens.length>0&&st.tokens[0].type==="paragraph"?(st.tokens[0].text=dt+" "+st.tokens[0].text,st.tokens[0].tokens&&st.tokens[0].tokens.length>0&&st.tokens[0].tokens[0].type==="text"&&(st.tokens[0].tokens[0].text=dt+" "+st.tokens[0].tokens[0].text)):st.tokens.unshift({type:"text",text:dt}):Xe+=dt),Xe+=this.parse(st.tokens,Ze),ce+=this.renderer.listitem(Xe,_t,wt);be+=this.renderer.list(ce,Te,Pe);continue}case"html":{be+=this.renderer.html(q.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(q.tokens));continue}case"text":{for(ce=q.tokens?this.parseInline(q.tokens):q.text;we+1<ft&&ne[we+1].type==="text";)q=ne[++we],ce+=`
`+(q.tokens?this.parseInline(q.tokens):q.text);be+=de?this.renderer.paragraph(ce):ce;continue}default:{var Tt='Token with "'+q.type+'" type was not found.';if(this.options.silent){console.error(Tt);return}else throw new Error(Tt)}}}return be},ye.parseInline=function(ne,de){de=de||this.renderer;var be="",we,Fe,Ge,He=ne.length;for(we=0;we<He;we++){if(Fe=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Ge=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){be+=Ge||"";continue}switch(Fe.type){case"escape":{be+=de.text(Fe.text);break}case"html":{be+=de.html(Fe.text);break}case"link":{be+=de.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,de));break}case"image":{be+=de.image(Fe.href,Fe.title,Fe.text);break}case"strong":{be+=de.strong(this.parseInline(Fe.tokens,de));break}case"em":{be+=de.em(this.parseInline(Fe.tokens,de));break}case"codespan":{be+=de.codespan(Fe.text);break}case"br":{be+=de.br();break}case"del":{be+=de.del(this.parseInline(Fe.tokens,de));break}case"text":{be+=de.text(Fe.text);break}default:{var Ye='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}}return be},Le}(),te=ee,pe=X,ze=B,tt=oe,ut=ve,lt=Me,vt=F.merge,Dt=F.checkSanitizeDeprecation,ue=F.escape,Ie=C.exports.getDefaults,Be=C.exports.changeDefaults,Ke=C.exports.defaults;function We(Le,ye,ke){if(typeof Le=="undefined"||Le===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Le!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Le)+", string expected");if(typeof ye=="function"&&(ke=ye,ye=null),ye=vt({},We.defaults,ye||{}),Dt(ye),ke){var ne=ye.highlight,de;try{de=te.lex(Le,ye)}catch(Ge){return ke(Ge)}var be=function(He){var Ye;if(!He)try{ye.walkTokens&&We.walkTokens(de,ye.walkTokens),Ye=pe.parse(de,ye)}catch(it){He=it}return ye.highlight=ne,He?ke(He):ke(null,Ye)};if(!ne||ne.length<3||(delete ye.highlight,!de.length))return be();var we=0;We.walkTokens(de,function(Ge){Ge.type==="code"&&(we++,setTimeout(function(){ne(Ge.text,Ge.lang,function(He,Ye){if(He)return be(He);Ye!=null&&Ye!==Ge.text&&(Ge.text=Ye,Ge.escaped=!0),we--,we===0&&be()})},0))}),we===0&&be();return}try{var Fe=te.lex(Le,ye);return ye.walkTokens&&We.walkTokens(Fe,ye.walkTokens),pe.parse(Fe,ye)}catch(Ge){if(Ge.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ue(Ge.message+"",!0)+"</pre>";throw Ge}}We.options=We.setOptions=function(Le){return vt(We.defaults,Le),Be(We.defaults),We},We.getDefaults=Ie,We.defaults=Ke,We.use=function(){for(var Le=this,ye=arguments.length,ke=new Array(ye),ne=0;ne<ye;ne++)ke[ne]=arguments[ne];var de=vt.apply(void 0,[{}].concat(ke)),be=We.defaults.extensions||{renderers:{},childTokens:{}},we;ke.forEach(function(Fe){if(Fe.extensions&&(we=!0,Fe.extensions.forEach(function(He){if(!He.name)throw new Error("extension name required");if(He.renderer){var Ye=be.renderers?be.renderers[He.name]:null;Ye?be.renderers[He.name]=function(){for(var it=arguments.length,ae=new Array(it),Ee=0;Ee<it;Ee++)ae[Ee]=arguments[Ee];var ce=He.renderer.apply(this,ae);return ce===!1&&(ce=Ye.apply(this,ae)),ce}:be.renderers[He.name]=He.renderer}if(He.tokenizer){if(!He.level||He.level!=="block"&&He.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");be[He.level]?be[He.level].unshift(He.tokenizer):be[He.level]=[He.tokenizer],He.start&&(He.level==="block"?be.startBlock?be.startBlock.push(He.start):be.startBlock=[He.start]:He.level==="inline"&&(be.startInline?be.startInline.push(He.start):be.startInline=[He.start]))}He.childTokens&&(be.childTokens[He.name]=He.childTokens)})),Fe.renderer&&function(){var He=We.defaults.renderer||new tt,Ye=function(Ee){var ce=He[Ee];He[Ee]=function(){for(var q=arguments.length,Te=new Array(q),Pe=0;Pe<q;Pe++)Te[Pe]=arguments[Pe];var Ze=Fe.renderer[Ee].apply(He,Te);return Ze===!1&&(Ze=ce.apply(He,Te)),Ze}};for(var it in Fe.renderer)Ye(it);de.renderer=He}(),Fe.tokenizer&&function(){var He=We.defaults.tokenizer||new ze,Ye=function(Ee){var ce=He[Ee];He[Ee]=function(){for(var q=arguments.length,Te=new Array(q),Pe=0;Pe<q;Pe++)Te[Pe]=arguments[Pe];var Ze=Fe.tokenizer[Ee].apply(He,Te);return Ze===!1&&(Ze=ce.apply(He,Te)),Ze}};for(var it in Fe.tokenizer)Ye(it);de.tokenizer=He}(),Fe.walkTokens){var Ge=We.defaults.walkTokens;de.walkTokens=function(He){Fe.walkTokens.call(Le,He),Ge&&Ge(He)}}we&&(de.extensions=be),We.setOptions(de)})},We.walkTokens=function(Le,ye){for(var ke=function(){var we=de.value;switch(ye(we),we.type){case"table":{for(var Fe=k(we.header),Ge;!(Ge=Fe()).done;){var He=Ge.value;We.walkTokens(He.tokens,ye)}for(var Ye=k(we.rows),it;!(it=Ye()).done;)for(var ae=it.value,Ee=k(ae),ce;!(ce=Ee()).done;){var q=ce.value;We.walkTokens(q.tokens,ye)}break}case"list":{We.walkTokens(we.items,ye);break}default:We.defaults.extensions&&We.defaults.extensions.childTokens&&We.defaults.extensions.childTokens[we.type]?We.defaults.extensions.childTokens[we.type].forEach(function(Te){We.walkTokens(we[Te],ye)}):we.tokens&&We.walkTokens(we.tokens,ye)}},ne=k(Le),de;!(de=ne()).done;)ke()},We.parseInline=function(Le,ye){if(typeof Le=="undefined"||Le===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Le!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Le)+", string expected");ye=vt({},We.defaults,ye||{}),Dt(ye);try{var ke=te.lexInline(Le,ye);return ye.walkTokens&&We.walkTokens(ke,ye.walkTokens),pe.parseInline(ke,ye)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ue(ne.message+"",!0)+"</pre>";throw ne}},We.Parser=pe,We.parser=pe.parse,We.Renderer=tt,We.TextRenderer=ut,We.Lexer=te,We.lexer=te.lex,We.Tokenizer=ze,We.Slugger=lt,We.parse=We;var ot=We;return ot}),define(me[77],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(R,S,y){return Math.min(Math.max(R,S),y)}e.clamp=m;function L(R,S){return(S+R%S)%S}e.rot=L;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class C{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function J(k){const C=[];typeof k=="number"&&C.push("code/timeOrigin",k);function R(y){C.push(y,Date.now())}function S(){const y=[];for(let T=0;T<C.length;T+=2)y.push({name:C[T],startTime:C[T+1]});return y}return{mark:R,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const R of performance.getEntriesByType("mark"))C.push({name:R.name,startTime:Math.round(k+R.startTime)});return C}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function m(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=m(L))}(),define(me[11],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let L=!1,k=!1,C=!1,R=!1,S=!1,y=!1,T=!1,n,I=m,c,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const p=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=p&&h?.sandboxed,typeof navigator=="object"&&!p)f=navigator.userAgent,L=f.indexOf("Windows")>=0,k=f.indexOf("Macintosh")>=0,T=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=f.indexOf("Linux")>=0,y=!0,n=navigator.language,I=n;else if(typeof h=="object"){L=h.platform==="win32",k=h.platform==="darwin",C=h.platform==="linux",R=C&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,n=m,I=m;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const i=JSON.parse(r),o=i.availableLanguages["*"];n=i.locale,I=o||m,c=i._translationsConfigFile}catch(i){}S=!0}else console.error("Unable to resolve platform.");var D;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function A(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=A;let E=0;k?E=1:L?E=3:C&&(E=2),e.isWindows=L,e.isMacintosh=k,e.isLinux=C,e.isLinuxSnap=R,e.isNative=S,e.isWeb=y,e.isIOS=T,e.platform=E,e.userAgent=f,e.language=I;var a;(function(r){function i(){return e.language}r.value=i;function o(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=o;function l(){return e.language==="en"}r.isDefault=l})(a=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=c,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeSetImmediateId)for(let b=0,_=o.length;b<_;b++){const v=o[b];if(v.id===d.data.vscodeSetImmediateId){o.splice(b,1),v.callback();return}}});let l=0;return d=>{const b=++l;o.push({id:b,callback:d}),e.globals.postMessage({vscodeSetImmediateId:b},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const i=Promise.resolve();return o=>i.then(o)}();var s;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||T?2:L?1:3;let g=!0,t=!1;function u(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,g=new Uint16Array(r.buffer)[0]===(2<<8)+1}return g}e.isLittleEndian=u}),define(me[38],ge([0,1,11]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const k=m.globals.vscode.process;L={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()},nextTick(C){return(0,m.setImmediate)(C)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:L={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},nextTick(k){return(0,m.setImmediate)(k)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(me[8],ge([0,1,38]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,C=90,R=122,S=46,y=47,T=92,n=58,I=63;class c extends Error{constructor(s,g,t){let u;typeof g=="string"&&g.indexOf("not ")===0?(u="must not be",g=g.replace(/^not /,"")):u="must be";const r=s.indexOf(".")!==-1?"property":"argument";let i=`The "${s}" ${r} ${u} of type ${g}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function f(a,s){if(typeof a!="string")throw new c(s,"string",a)}function h(a){return a===y||a===T}function p(a){return a===y}function D(a){return a>=L&&a<=C||a>=k&&a<=R}function A(a,s,g,t){let u="",r=0,i=-1,o=0,l=0;for(let d=0;d<=a.length;++d){if(d<a.length)l=a.charCodeAt(d);else{if(t(l))break;l=y}if(t(l)){if(!(i===d-1||o===1))if(o===2){if(u.length<2||r!==2||u.charCodeAt(u.length-1)!==S||u.charCodeAt(u.length-2)!==S){if(u.length>2){const b=u.lastIndexOf(g);b===-1?(u="",r=0):(u=u.slice(0,b),r=u.length-1-u.lastIndexOf(g)),i=d,o=0;continue}else if(u.length!==0){u="",r=0,i=d,o=0;continue}}s&&(u+=u.length>0?`${g}..`:"..",r=2)}else u.length>0?u+=`${g}${a.slice(i+1,d)}`:u=a.slice(i+1,d),r=d-i-1;i=d,o=0}else l===S&&o!==-1?++o:o=-1}return u}function E(a,s){if(s===null||typeof s!="object")throw new c("pathObject","Object",s);const g=s.dir||s.root,t=s.base||`${s.name||""}${s.ext||""}`;return g?g===s.root?`${g}${t}`:`${g}${a}${t}`:t}e.win32={resolve(...a){let s="",g="",t=!1;for(let u=a.length-1;u>=-1;u--){let r;if(u>=0){if(r=a[u],f(r,"path"),r.length===0)continue}else s.length===0?r=m.cwd():(r=m.env[`=${s}`]||m.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==s.toLowerCase()&&r.charCodeAt(2)===T)&&(r=`${s}\\`));const i=r.length;let o=0,l="",d=!1;const b=r.charCodeAt(0);if(i===1)h(b)&&(o=1,d=!0);else if(h(b))if(d=!0,h(r.charCodeAt(1))){let _=2,v=_;for(;_<i&&!h(r.charCodeAt(_));)_++;if(_<i&&_!==v){const P=r.slice(v,_);for(v=_;_<i&&h(r.charCodeAt(_));)_++;if(_<i&&_!==v){for(v=_;_<i&&!h(r.charCodeAt(_));)_++;(_===i||_!==v)&&(l=`\\\\${P}\\${r.slice(v,_)}`,o=_)}}}else o=1;else D(b)&&r.charCodeAt(1)===n&&(l=r.slice(0,2),o=2,i>2&&h(r.charCodeAt(2))&&(d=!0,o=3));if(l.length>0)if(s.length>0){if(l.toLowerCase()!==s.toLowerCase())continue}else s=l;if(t){if(s.length>0)break}else if(g=`${r.slice(o)}\\${g}`,t=d,d&&s.length>0)break}return g=A(g,!t,"\\",h),t?`${s}\\${g}`:`${s}${g}`||"."},normalize(a){f(a,"path");const s=a.length;if(s===0)return".";let g=0,t,u=!1;const r=a.charCodeAt(0);if(s===1)return p(r)?"\\":a;if(h(r))if(u=!0,h(a.charCodeAt(1))){let o=2,l=o;for(;o<s&&!h(a.charCodeAt(o));)o++;if(o<s&&o!==l){const d=a.slice(l,o);for(l=o;o<s&&h(a.charCodeAt(o));)o++;if(o<s&&o!==l){for(l=o;o<s&&!h(a.charCodeAt(o));)o++;if(o===s)return`\\\\${d}\\${a.slice(l)}\\`;o!==l&&(t=`\\\\${d}\\${a.slice(l,o)}`,g=o)}}}else g=1;else D(r)&&a.charCodeAt(1)===n&&(t=a.slice(0,2),g=2,s>2&&h(a.charCodeAt(2))&&(u=!0,g=3));let i=g<s?A(a.slice(g),!u,"\\",h):"";return i.length===0&&!u&&(i="."),i.length>0&&h(a.charCodeAt(s-1))&&(i+="\\"),t===void 0?u?`\\${i}`:i:u?`${t}\\${i}`:`${t}${i}`},isAbsolute(a){f(a,"path");const s=a.length;if(s===0)return!1;const g=a.charCodeAt(0);return h(g)||s>2&&D(g)&&a.charCodeAt(1)===n&&h(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let s,g;for(let r=0;r<a.length;++r){const i=a[r];f(i,"path"),i.length>0&&(s===void 0?s=g=i:s+=`\\${i}`)}if(s===void 0)return".";let t=!0,u=0;if(typeof g=="string"&&h(g.charCodeAt(0))){++u;const r=g.length;r>1&&h(g.charCodeAt(1))&&(++u,r>2&&(h(g.charCodeAt(2))?++u:t=!1))}if(t){for(;u<s.length&&h(s.charCodeAt(u));)u++;u>=2&&(s=`\\${s.slice(u)}`)}return e.win32.normalize(s)},relative(a,s){if(f(a,"from"),f(s,"to"),a===s)return"";const g=e.win32.resolve(a),t=e.win32.resolve(s);if(g===t||(a=g.toLowerCase(),s=t.toLowerCase(),a===s))return"";let u=0;for(;u<a.length&&a.charCodeAt(u)===T;)u++;let r=a.length;for(;r-1>u&&a.charCodeAt(r-1)===T;)r--;const i=r-u;let o=0;for(;o<s.length&&s.charCodeAt(o)===T;)o++;let l=s.length;for(;l-1>o&&s.charCodeAt(l-1)===T;)l--;const d=l-o,b=i<d?i:d;let _=-1,v=0;for(;v<b;v++){const w=a.charCodeAt(u+v);if(w!==s.charCodeAt(o+v))break;w===T&&(_=v)}if(v!==b){if(_===-1)return t}else{if(d>b){if(s.charCodeAt(o+v)===T)return t.slice(o+v+1);if(v===2)return t.slice(o+v)}i>b&&(a.charCodeAt(u+v)===T?_=v:v===2&&(_=3)),_===-1&&(_=0)}let P="";for(v=u+_+1;v<=r;++v)(v===r||a.charCodeAt(v)===T)&&(P+=P.length===0?"..":"\\..");return o+=_,P.length>0?`${P}${t.slice(o,l)}`:(t.charCodeAt(o)===T&&++o,t.slice(o,l))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const s=e.win32.resolve(a);if(s.length<=2)return a;if(s.charCodeAt(0)===T){if(s.charCodeAt(1)===T){const g=s.charCodeAt(2);if(g!==I&&g!==S)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(D(s.charCodeAt(0))&&s.charCodeAt(1)===n&&s.charCodeAt(2)===T)return`\\\\?\\${s}`;return a},dirname(a){f(a,"path");const s=a.length;if(s===0)return".";let g=-1,t=0;const u=a.charCodeAt(0);if(s===1)return h(u)?a:".";if(h(u)){if(g=t=1,h(a.charCodeAt(1))){let o=2,l=o;for(;o<s&&!h(a.charCodeAt(o));)o++;if(o<s&&o!==l){for(l=o;o<s&&h(a.charCodeAt(o));)o++;if(o<s&&o!==l){for(l=o;o<s&&!h(a.charCodeAt(o));)o++;if(o===s)return a;o!==l&&(g=t=o+1)}}}}else D(u)&&a.charCodeAt(1)===n&&(g=s>2&&h(a.charCodeAt(2))?3:2,t=g);let r=-1,i=!0;for(let o=s-1;o>=t;--o)if(h(a.charCodeAt(o))){if(!i){r=o;break}}else i=!1;if(r===-1){if(g===-1)return".";r=g}return a.slice(0,r)},basename(a,s){s!==void 0&&f(s,"ext"),f(a,"path");let g=0,t=-1,u=!0,r;if(a.length>=2&&D(a.charCodeAt(0))&&a.charCodeAt(1)===n&&(g=2),s!==void 0&&s.length>0&&s.length<=a.length){if(s===a)return"";let i=s.length-1,o=-1;for(r=a.length-1;r>=g;--r){const l=a.charCodeAt(r);if(h(l)){if(!u){g=r+1;break}}else o===-1&&(u=!1,o=r+1),i>=0&&(l===s.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=o))}return g===t?t=o:t===-1&&(t=a.length),a.slice(g,t)}for(r=a.length-1;r>=g;--r)if(h(a.charCodeAt(r))){if(!u){g=r+1;break}}else t===-1&&(u=!1,t=r+1);return t===-1?"":a.slice(g,t)},extname(a){f(a,"path");let s=0,g=-1,t=0,u=-1,r=!0,i=0;a.length>=2&&a.charCodeAt(1)===n&&D(a.charCodeAt(0))&&(s=t=2);for(let o=a.length-1;o>=s;--o){const l=a.charCodeAt(o);if(h(l)){if(!r){t=o+1;break}continue}u===-1&&(r=!1,u=o+1),l===S?g===-1?g=o:i!==1&&(i=1):g!==-1&&(i=-1)}return g===-1||u===-1||i===0||i===1&&g===u-1&&g===t+1?"":a.slice(g,u)},format:E.bind(null,"\\"),parse(a){f(a,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return s;const g=a.length;let t=0,u=a.charCodeAt(0);if(g===1)return h(u)?(s.root=s.dir=a,s):(s.base=s.name=a,s);if(h(u)){if(t=1,h(a.charCodeAt(1))){let _=2,v=_;for(;_<g&&!h(a.charCodeAt(_));)_++;if(_<g&&_!==v){for(v=_;_<g&&h(a.charCodeAt(_));)_++;if(_<g&&_!==v){for(v=_;_<g&&!h(a.charCodeAt(_));)_++;_===g?t=_:_!==v&&(t=_+1)}}}}else if(D(u)&&a.charCodeAt(1)===n){if(g<=2)return s.root=s.dir=a,s;if(t=2,h(a.charCodeAt(2))){if(g===3)return s.root=s.dir=a,s;t=3}}t>0&&(s.root=a.slice(0,t));let r=-1,i=t,o=-1,l=!0,d=a.length-1,b=0;for(;d>=t;--d){if(u=a.charCodeAt(d),h(u)){if(!l){i=d+1;break}continue}o===-1&&(l=!1,o=d+1),u===S?r===-1?r=d:b!==1&&(b=1):r!==-1&&(b=-1)}return o!==-1&&(r===-1||b===0||b===1&&r===o-1&&r===i+1?s.base=s.name=a.slice(i,o):(s.name=a.slice(i,r),s.base=a.slice(i,o),s.ext=a.slice(r,o))),i>0&&i!==t?s.dir=a.slice(0,i-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let s="",g=!1;for(let t=a.length-1;t>=-1&&!g;t--){const u=t>=0?a[t]:m.cwd();f(u,"path"),u.length!==0&&(s=`${u}/${s}`,g=u.charCodeAt(0)===y)}return s=A(s,!g,"/",p),g?`/${s}`:s.length>0?s:"."},normalize(a){if(f(a,"path"),a.length===0)return".";const s=a.charCodeAt(0)===y,g=a.charCodeAt(a.length-1)===y;return a=A(a,!s,"/",p),a.length===0?s?"/":g?"./":".":(g&&(a+="/"),s?`/${a}`:a)},isAbsolute(a){return f(a,"path"),a.length>0&&a.charCodeAt(0)===y},join(...a){if(a.length===0)return".";let s;for(let g=0;g<a.length;++g){const t=a[g];f(t,"path"),t.length>0&&(s===void 0?s=t:s+=`/${t}`)}return s===void 0?".":e.posix.normalize(s)},relative(a,s){if(f(a,"from"),f(s,"to"),a===s||(a=e.posix.resolve(a),s=e.posix.resolve(s),a===s))return"";const g=1,t=a.length,u=t-g,r=1,i=s.length-r,o=u<i?u:i;let l=-1,d=0;for(;d<o;d++){const _=a.charCodeAt(g+d);if(_!==s.charCodeAt(r+d))break;_===y&&(l=d)}if(d===o)if(i>o){if(s.charCodeAt(r+d)===y)return s.slice(r+d+1);if(d===0)return s.slice(r+d)}else u>o&&(a.charCodeAt(g+d)===y?l=d:d===0&&(l=0));let b="";for(d=g+l+1;d<=t;++d)(d===t||a.charCodeAt(d)===y)&&(b+=b.length===0?"..":"/..");return`${b}${s.slice(r+l)}`},toNamespacedPath(a){return a},dirname(a){if(f(a,"path"),a.length===0)return".";const s=a.charCodeAt(0)===y;let g=-1,t=!0;for(let u=a.length-1;u>=1;--u)if(a.charCodeAt(u)===y){if(!t){g=u;break}}else t=!1;return g===-1?s?"/":".":s&&g===1?"//":a.slice(0,g)},basename(a,s){s!==void 0&&f(s,"ext"),f(a,"path");let g=0,t=-1,u=!0,r;if(s!==void 0&&s.length>0&&s.length<=a.length){if(s===a)return"";let i=s.length-1,o=-1;for(r=a.length-1;r>=0;--r){const l=a.charCodeAt(r);if(l===y){if(!u){g=r+1;break}}else o===-1&&(u=!1,o=r+1),i>=0&&(l===s.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=o))}return g===t?t=o:t===-1&&(t=a.length),a.slice(g,t)}for(r=a.length-1;r>=0;--r)if(a.charCodeAt(r)===y){if(!u){g=r+1;break}}else t===-1&&(u=!1,t=r+1);return t===-1?"":a.slice(g,t)},extname(a){f(a,"path");let s=-1,g=0,t=-1,u=!0,r=0;for(let i=a.length-1;i>=0;--i){const o=a.charCodeAt(i);if(o===y){if(!u){g=i+1;break}continue}t===-1&&(u=!1,t=i+1),o===S?s===-1?s=i:r!==1&&(r=1):s!==-1&&(r=-1)}return s===-1||t===-1||r===0||r===1&&s===t-1&&s===g+1?"":a.slice(s,t)},format:E.bind(null,"/"),parse(a){f(a,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return s;const g=a.charCodeAt(0)===y;let t;g?(s.root="/",t=1):t=0;let u=-1,r=0,i=-1,o=!0,l=a.length-1,d=0;for(;l>=t;--l){const b=a.charCodeAt(l);if(b===y){if(!o){r=l+1;break}continue}i===-1&&(o=!1,i=l+1),b===S?u===-1?u=l:d!==1&&(d=1):u!==-1&&(d=-1)}if(i!==-1){const b=r===0&&g?1:r;u===-1||d===0||d===1&&u===i-1&&u===r+1?s.base=s.name=a.slice(b,i):(s.name=a.slice(b,u),s.base=a.slice(b,i),s.ext=a.slice(u,i))}return r>0?s.dir=a.slice(0,r-1):g&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[140],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var L;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(C,...R){const S=R.reduce((n,I)=>(n[I]=!0,n),{}),y=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(n=>!S[n]).forEach(n=>{for(let I=0;I<y.length;I++)if(n.search(y[I])!==-1){delete C[n];break}})}e.sanitizeProcessEnvironment=k}),define(me[141],ge([0,1]),function(J,e){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(S,y,T){this.level=S,this.key=y,this.value=T,this.forward=[]}}const k=void 0;class C{constructor(S,y=2**16){this.comparator=S,this[m]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(y)|0),this._header=new L(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new L(this._maxLevel,k,k)}has(S){return Boolean(C._search(this,S,this.comparator))}get(S){return C._search(this,S,this.comparator)?.value}set(S,y){return C._insert(this,S,y,this.comparator)&&(this._size+=1),this}delete(S){const y=C._delete(this,S,this.comparator);return y&&(this._size-=1),y}forEach(S,y){let T=this._header.forward[0];for(;T;)S.call(y,T.value,T.key,this),T=T.forward[0]}[(m=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this._header.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this._header.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this._header.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",y=this._header.forward[0];for(;y;)S+=`node(${y.key}, ${y.value}, lvl:${y.level})`,y=y.forward[0];return S}static _search(S,y,T){let n=S._header;for(let I=S._level-1;I>=0;I--)for(;n.forward[I]&&T(n.forward[I].key,y)<0;)n=n.forward[I];if(n=n.forward[0],n&&T(n.key,y)===0)return n}static _insert(S,y,T,n){let I=[],c=S._header;for(let f=S._level-1;f>=0;f--){for(;c.forward[f]&&n(c.forward[f].key,y)<0;)c=c.forward[f];I[f]=c}if(c=c.forward[0],c&&n(c.key,y)===0)return c.value=T,!1;{let f=C._randomLevel(S);if(f>S._level){for(let h=S._level;h<f;h++)I[h]=S._header;S._level=f}c=new L(f,y,T);for(let h=0;h<f;h++)c.forward[h]=I[h].forward[h],I[h].forward[h]=c;return!0}}static _randomLevel(S,y=.5){let T=1;for(;Math.random()<y&&T<S._maxLevel;)T+=1;return T}static _delete(S,y,T){let n=[],I=S._header;for(let c=S._level-1;c>=0;c--){for(;I.forward[c]&&T(I.forward[c].key,y)<0;)I=I.forward[c];n[c]=I}if(I=I.forward[0],!I||T(I.key,y)!==0)return!1;for(let c=0;c<S._level&&n[c].forward[c]===I;c++)n[c].forward[c]=I.forward[c];for(;S._level>0&&S._header.forward[S._level-1]===k;)S._level-=1;return!0}}e.SkipList=C}),define(me[46],ge([0,1,11]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=m.globals.performance&&typeof m.globals.performance.now=="function";class k{constructor(R){this._highResolution=L&&R,this._startTime=this._now(),this._stopTime=-1}static create(R=!0){return new k(R)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=k}),define(me[3],ge([0,1,16,75,6,95,46]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var S;(function(a){a.None=()=>k.Disposable.None;function s(G){return(N,z=null,O)=>{let x=!1,B;return B=G(U=>{if(!x)return B?B.dispose():x=!0,N.call(z,U)},null,O),x&&B.dispose(),B}}a.once=s;function g(G,N){return l((z,O=null,x)=>G(B=>z.call(O,N(B)),null,x))}a.map=g;function t(G,N){return l((z,O=null,x)=>G(B=>{N(B),z.call(O,B)},null,x))}a.forEach=t;function u(G,N){return l((z,O=null,x)=>G(B=>N(B)&&z.call(O,B),null,x))}a.filter=u;function r(G){return G}a.signal=r;function i(...G){return(N,z=null,O)=>(0,k.combinedDisposable)(...G.map(x=>x(B=>N.call(z,B),null,O)))}a.any=i;function o(G,N,z){let O=z;return g(G,x=>(O=N(O,x),O))}a.reduce=o;function l(G){let N;const z=new c({onFirstListenerAdd(){N=G(z.fire,z)},onLastListenerRemove(){N.dispose()}});return z.event}function d(G,N,z=100,O=!1,x){let B,U,H,W=0;const Q=new c({leakWarningThreshold:x,onFirstListenerAdd(){B=G(Y=>{W++,U=N(U,Y),O&&!H&&(Q.fire(U),U=void 0),clearTimeout(H),H=setTimeout(()=>{const he=U;U=void 0,H=void 0,(!O||W>1)&&Q.fire(he),W=0},z)})},onLastListenerRemove(){B.dispose()}});return Q.event}a.debounce=d;function b(G,N=(z,O)=>z===O){let z=!0,O;return u(G,x=>{const B=z||!N(x,O);return z=!1,O=x,B})}a.latch=b;function _(G,N){return[a.filter(G,N),a.filter(G,z=>!N(z))]}a.split=_;function v(G,N=!1,z=[]){let O=z.slice(),x=G(H=>{O?O.push(H):U.fire(H)});const B=()=>{O&&O.forEach(H=>U.fire(H)),O=null},U=new c({onFirstListenerAdd(){x||(x=G(H=>U.fire(H)))},onFirstListenerDidAdd(){O&&(N?setTimeout(B):B())},onLastListenerRemove(){x&&x.dispose(),x=null}});return U.event}a.buffer=v;class P{constructor(N){this.event=N}map(N){return new P(g(this.event,N))}forEach(N){return new P(t(this.event,N))}filter(N){return new P(u(this.event,N))}reduce(N,z){return new P(o(this.event,N,z))}latch(){return new P(b(this.event))}debounce(N,z=100,O=!1,x){return new P(d(this.event,N,z,O,x))}on(N,z,O){return this.event(N,z,O)}once(N,z,O){return s(this.event)(N,z,O)}}function w(G){return new P(G)}a.chain=w;function F(G,N,z=O=>O){const O=(...H)=>U.fire(z(...H)),x=()=>G.on(N,O),B=()=>G.removeListener(N,O),U=new c({onFirstListenerAdd:x,onLastListenerRemove:B});return U.event}a.fromNodeEventEmitter=F;function M(G,N,z=O=>O){const O=(...H)=>U.fire(z(...H)),x=()=>G.addEventListener(N,O),B=()=>G.removeEventListener(N,O),U=new c({onFirstListenerAdd:x,onLastListenerRemove:B});return U.event}a.fromDOMEventEmitter=M;function K(G){return new Promise(N=>s(G)(N))}a.toPromise=K})(S=e.Event||(e.Event={}));class y{constructor(s){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${s}_${y._idPool++}`}start(s){this._stopWatch=new R.StopWatch(!0),this._listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this._elapsedOverall+=s,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${s.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let T=-1;function n(a){const s=T;return T=a,{dispose(){T=s}}}e.setGlobalLeakWarningThreshold=n;class I{constructor(s,g=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=g,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s){let g=T;if(typeof this.customThreshold=="number"&&(g=this.customThreshold),g<=0||s<g)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),u=this._stacks.get(t)||0;if(this._stacks.set(t,u+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=g*.5;let r,i=0;for(const[o,l]of this._stacks)(!r||i<l)&&(r=o,i=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${i}):`),console.warn(r)}return()=>{const r=this._stacks.get(t)||0;this._stacks.set(t,r-1)}}}class c{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=T>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(s,g,t)=>{this._listeners||(this._listeners=new C.LinkedList);const u=this._listeners.isEmpty();u&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(g?[s,g]:s);u&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,g);const i=this._leakageMon?.check(this._listeners.size),o=(0,k.toDisposable)(()=>{i&&i(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof k.DisposableStore?t.add(o):Array.isArray(t)&&t.push(o),o}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let g of this._listeners)this._deliveryQueue.push([g,s]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[g,t]=this._deliveryQueue.shift();try{typeof g=="function"?g.call(void 0,t):g[0].call(g[1],t)}catch(u){(0,m.onUnexpectedError)(u)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=c;class f extends c{async fireAsync(s,g,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const u of this._listeners)this._asyncDeliveryQueue.push([u,s]);for(;this._asyncDeliveryQueue.size>0&&!g.isCancellationRequested;){const[u,r]=this._asyncDeliveryQueue.shift(),i=[],o={...r,waitUntil:l=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");t&&(l=t(l,typeof u=="function"?u:u[0])),i.push(l)}};try{typeof u=="function"?u.call(void 0,o):u[0].call(u[1],o)}catch(l){(0,m.onUnexpectedError)(l);continue}Object.freeze(i),await Promise.allSettled(i).then(l=>{for(const d of l)d.status==="rejected"&&(0,m.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=f;class h extends c{constructor(s){super(s);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}e.PauseableEmitter=h;class p extends h{constructor(s){super(s);this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}e.DebounceEmitter=p;class D{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const g={event:s,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const t=()=>{this.hasListeners&&this.unhook(g);const u=this.events.indexOf(g);this.events.splice(u,1)};return(0,k.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(g=>this.emitter.fire(g))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=D;class A{constructor(){this.buffers=[]}wrapEvent(s){return(g,t,u)=>s(r=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>g.call(t,r)):g.call(t,r)},void 0,u)}bufferEvents(s){const g=[];this.buffers.push(g);const t=s();return this.buffers.pop(),g.forEach(u=>u()),t}}e.EventBufferer=A;class E{constructor(){this.listening=!1,this.inputEvent=S.None,this.inputEventListener=k.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(me[21],ge([0,1,3]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(S,y){const T=setTimeout(S.bind(y),0);return{dispose(){clearTimeout(T)}}});var k;(function(S){function y(T){return T===S.None||T===S.Cancelled||T instanceof C?!0:!T||typeof T!="object"?!1:typeof T.isCancellationRequested=="boolean"&&typeof T.onCancellationRequested=="function"}S.isCancellationToken=y,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=k.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=R}),define(me[47],ge([0,1,3]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(I){const c=this._icons.get(I.id);c?I.description?c.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new L;e.iconRegistry=k;function C(n,I){return new S(n,I)}e.registerCodicon=C;function R(n){return n?n.replace(/\$\((.*?)\)/g,(I,c)=>` ${c} `).trim():""}e.getCodiconAriaLabel=R;class S{constructor(I,c,f){this.id=I,this.definition=c,this.description=f,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=S;function y(n,I){const c=["codicon","codicon-"+n];return I&&c.push("codicon-modifier-"+I),c}e.getClassNamesArray=y;var T;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function c(p){if(p instanceof S)return["codicon","codicon-"+p.id];const D=I.exec(p.id);if(!D)return c(S.error);let[,A,E]=D;const a=["codicon","codicon-"+A];return E&&a.push("codicon-modifier-"+E.substr(1)),a}n.asClassNameArray=c;function f(p){return c(p).join(" ")}n.asClassName=f;function h(p){return"."+c(p).join(".")}n.asCSSSelector=h})(T=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(S=e.Codicon||(e.Codicon={}))}),define(me[96],ge([0,1,16,6]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(a){const s=a;return s?[s.on,s.pause,s.resume,s.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=k;function C(a){const s=a;return s?k(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=C;function R(a,s){return new S(a,s)}e.newWriteableStream=R;class S{constructor(s,g){this.reducer=s,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(g=>this.pendingWritePromises.push(g))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(g=>g(s))}emitError(s){this.listeners.error.length===0?(0,m.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(g=>g(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,g){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(s,g){if(this.state.destroyed)return;let t;switch(s){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const u=t.indexOf(g);u>=0&&t.splice(u,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(a,s){const g=[];let t;for(;(t=a.read())!==null;)g.push(t);return s(g)}e.consumeReadable=y;function T(a,s,g){const t=[];let u;for(;(u=a.read())!==null&&t.length<g;)t.push(u);return u===null&&t.length>0?s(t):{read:()=>{if(t.length>0)return t.shift();if(typeof u!="undefined"){const r=u;return u=void 0,r}return a.read()}}}e.peekReadable=T;function n(a,s){return new Promise((g,t)=>{const u=[];I(a,{onData:r=>{s&&u.push(r)},onError:r=>{s?t(r):g(void 0)},onEnd:()=>{g(s?s(u):void 0)}})})}e.consumeStream=n;function I(a,s){a.on("error",g=>s.onError(g)),a.on("end",()=>s.onEnd()),a.on("data",g=>s.onData(g))}e.listenStream=I;function c(a,s){return new Promise((g,t)=>{const u=new L.DisposableStore,r=[],i=d=>{if(r.push(d),r.length>s)return u.dispose(),a.pause(),g({stream:a,buffer:r,ended:!1})},o=d=>t(d),l=()=>g({stream:a,buffer:r,ended:!0});u.add((0,L.toDisposable)(()=>a.removeListener("error",o))),a.on("error",o),u.add((0,L.toDisposable)(()=>a.removeListener("end",l))),a.on("end",l),u.add((0,L.toDisposable)(()=>a.removeListener("data",i))),a.on("data",i)})}e.peekStream=c;function f(a,s){const g=R(s);return g.end(a),g}e.toStream=f;function h(){const a=R(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=h;function p(a){let s=!1;return{read:()=>s?null:(s=!0,a)}}e.toReadable=p;function D(a,s,g){const t=R(g);return I(a,{onData:u=>t.write(s.data(u)),onError:u=>t.error(s.error?s.error(u):u),onEnd:()=>t.end()}),t}e.transform=D;function A(a,s,g){let t=!1;return{read:()=>{const u=s.read();return t?u:(t=!0,u!==null?g([a,u]):a)}}}e.prefixedReadable=A;function E(a,s,g){let t=!1;const u=R(g);return I(s,{onData:r=>t?u.write(r):(t=!0,u.write(g([a,r]))),onError:r=>u.error(r),onEnd:()=>{t||(t=!0,u.write(a)),u.end()}}),u}e.prefixedStream=E}),define(me[22],ge([0,1,96]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let k,C;class R{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return L?new R(Buffer.allocUnsafe(i)):new R(new Uint8Array(i))}static wrap(i){return L&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new R(i)}static fromString(i,o){return!(o?.dontUseNodeBuffer||!1)&&L?new R(Buffer.from(i)):(k||(k=new TextEncoder),new R(k.encode(i)))}static concat(i,o){if(typeof o=="undefined"){o=0;for(let b=0,_=i.length;b<_;b++)o+=i[b].byteLength}const l=R.alloc(o);let d=0;for(let b=0,_=i.length;b<_;b++){const v=i[b];l.set(v,d),d+=v.byteLength}return l}toString(){return L?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(i,o){return new R(this.buffer.subarray(i,o))}set(i,o){i instanceof R?this.buffer.set(i.buffer,o):this.buffer.set(i,o)}readUInt32BE(i){return T(this.buffer,i)}writeUInt32BE(i,o){n(this.buffer,i,o)}readUInt32LE(i){return I(this.buffer,i)}writeUInt32LE(i,o){c(this.buffer,i,o)}readUInt8(i){return f(this.buffer,i)}writeUInt8(i,o){h(this.buffer,i,o)}}e.VSBuffer=R;function S(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=S;function y(r,i,o){r[o+0]=i&255,i=i>>>8,r[o+1]=i&255}e.writeUInt16LE=y;function T(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=T;function n(r,i,o){r[o+3]=i,i=i>>>8,r[o+2]=i,i=i>>>8,r[o+1]=i,i=i>>>8,r[o]=i}e.writeUInt32BE=n;function I(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=I;function c(r,i,o){r[o+0]=i&255,i=i>>>8,r[o+1]=i&255,i=i>>>8,r[o+2]=i&255,i=i>>>8,r[o+3]=i&255}e.writeUInt32LE=c;function f(r,i){return r[i]}e.readUInt8=f;function h(r,i,o){r[o]=i}e.writeUInt8=h;function p(r){return m.consumeReadable(r,i=>R.concat(i))}e.readableToBuffer=p;function D(r){return m.toReadable(r)}e.bufferToReadable=D;function A(r){return m.consumeStream(r,i=>R.concat(i))}e.streamToBuffer=A;async function E(r){return r.ended?R.concat(r.buffer):R.concat([...r.buffer,await A(r.stream)])}e.bufferedStreamToBuffer=E;function a(r){return m.toStream(r,i=>R.concat(i))}e.bufferToStream=a;function s(r){return m.transform(r,{data:i=>typeof i=="string"?R.fromString(i):R.wrap(i)},i=>R.concat(i))}e.streamToBufferReadableStream=s;function g(r){return m.newWriteableStream(i=>R.concat(i),r)}e.newWriteableBufferStream=g;function t(r,i){return m.prefixedReadable(r,i,o=>R.concat(o))}e.prefixedBufferReadable=t;function u(r,i){return m.prefixedStream(r,i,o=>R.concat(o))}e.prefixedBufferStream=u}),define(me[9],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function m(ue){return!ue||typeof ue!="string"?!0:ue.trim().length===0}e.isFalsyOrWhitespace=m;const L=/{(\d+)}/g;function k(ue,...Ie){return Ie.length===0?ue:ue.replace(L,function(Be,Ke){const We=parseInt(Ke,10);return isNaN(We)||We<0||We>=Ie.length?Be:Ie[We]})}e.format=k;const C=/{([^}]+)}/g;function R(ue,Ie){return ue.replace(C,(Be,Ke)=>Ie[Ke]??Be)}e.format2=R;function S(ue){return ue.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=S;function y(ue){return ue.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function T(ue,Ie){let Be=0;const Ke=Ie.charCodeAt(0);for(let We=ue.length-1;We>=0;We--)ue.charCodeAt(We)===Ke&&Be++;return Be}e.count=T;function n(ue,Ie,Be="\u2026"){return ue.length<=Ie?ue:`${ue.substr(0,Ie)}${Be}`}e.truncate=n;function I(ue,Ie=" "){const Be=c(ue,Ie);return f(Be,Ie)}e.trim=I;function c(ue,Ie){if(!ue||!Ie)return ue;const Be=Ie.length;if(Be===0||ue.length===0)return ue;let Ke=0;for(;ue.indexOf(Ie,Ke)===Ke;)Ke=Ke+Be;return ue.substring(Ke)}e.ltrim=c;function f(ue,Ie){if(!ue||!Ie)return ue;const Be=Ie.length,Ke=ue.length;if(Be===0||Ke===0)return ue;let We=Ke,ot=-1;for(;ot=ue.lastIndexOf(Ie,We-1),!(ot===-1||ot+Be!==We);){if(ot===0)return"";We=ot}return ue.substring(0,We)}e.rtrim=f;function h(ue){return ue.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function p(ue){return ue.replace(/\*/g,"")}e.stripWildcards=p;function D(ue,Ie,Be={}){if(!ue)throw new Error("Cannot create regex from empty string");Ie||(ue=y(ue)),Be.wholeWord&&(/\B/.test(ue.charAt(0))||(ue="\\b"+ue),/\B/.test(ue.charAt(ue.length-1))||(ue=ue+"\\b"));let Ke="";return Be.global&&(Ke+="g"),Be.matchCase||(Ke+="i"),Be.multiline&&(Ke+="m"),Be.unicode&&(Ke+="u"),new RegExp(ue,Ke)}e.createRegExp=D;function A(ue){return ue.source==="^"||ue.source==="^$"||ue.source==="$"||ue.source==="^\\s*$"?!1:!!(ue.exec("")&&ue.lastIndex===0)}e.regExpLeadsToEndlessLoop=A;function E(ue){return!!ue.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function a(ue){return(ue.global?"g":"")+(ue.ignoreCase?"i":"")+(ue.multiline?"m":"")+(ue.unicode?"u":"")}e.regExpFlags=a;function s(ue){return ue.split(/\r\n|\r|\n/)}e.splitLines=s;function g(ue){for(let Ie=0,Be=ue.length;Ie<Be;Ie++){const Ke=ue.charCodeAt(Ie);if(Ke!==32&&Ke!==9)return Ie}return-1}e.firstNonWhitespaceIndex=g;function t(ue,Ie=0,Be=ue.length){for(let Ke=Ie;Ke<Be;Ke++){const We=ue.charCodeAt(Ke);if(We!==32&&We!==9)return ue.substring(Ie,Ke)}return ue.substring(Ie,Be)}e.getLeadingWhitespace=t;function u(ue,Ie=ue.length-1){for(let Be=Ie;Be>=0;Be--){const Ke=ue.charCodeAt(Be);if(Ke!==32&&Ke!==9)return Be}return-1}e.lastNonWhitespaceIndex=u;function r(ue,Ie){return ue<Ie?-1:ue>Ie?1:0}e.compare=r;function i(ue,Ie,Be=0,Ke=ue.length,We=0,ot=Ie.length){for(;Be<Ke&&We<ot;Be++,We++){let ke=ue.charCodeAt(Be),ne=Ie.charCodeAt(We);if(ke<ne)return-1;if(ke>ne)return 1}const Le=Ke-Be,ye=ot-We;return Le<ye?-1:Le>ye?1:0}e.compareSubstring=i;function o(ue,Ie){return l(ue,Ie,0,ue.length,0,Ie.length)}e.compareIgnoreCase=o;function l(ue,Ie,Be=0,Ke=ue.length,We=0,ot=Ie.length){for(;Be<Ke&&We<ot;Be++,We++){let ke=ue.charCodeAt(Be),ne=Ie.charCodeAt(We);if(ke===ne)continue;const de=ke-ne;if(!(de===32&&b(ne))&&!(de===-32&&b(ke)))return d(ke)&&d(ne)?de:i(ue.toLowerCase(),Ie.toLowerCase(),Be,Ke,We,ot)}const Le=Ke-Be,ye=ot-We;return Le<ye?-1:Le>ye?1:0}e.compareSubstringIgnoreCase=l;function d(ue){return ue>=97&&ue<=122}e.isLowerAsciiLetter=d;function b(ue){return ue>=65&&ue<=90}e.isUpperAsciiLetter=b;function _(ue){return d(ue)||b(ue)}function v(ue,Ie){return ue.length===Ie.length&&P(ue,Ie)}e.equalsIgnoreCase=v;function P(ue,Ie,Be=ue.length){for(let Ke=0;Ke<Be;Ke++){const We=ue.charCodeAt(Ke),ot=Ie.charCodeAt(Ke);if(We!==ot){if(_(We)&&_(ot)){const Le=Math.abs(We-ot);if(Le!==0&&Le!==32)return!1}else if(String.fromCharCode(We).toLowerCase()!==String.fromCharCode(ot).toLowerCase())return!1}}return!0}function w(ue,Ie){const Be=Ie.length;return Ie.length>ue.length?!1:P(ue,Ie,Be)}e.startsWithIgnoreCase=w;function F(ue,Ie){let Be,Ke=Math.min(ue.length,Ie.length);for(Be=0;Be<Ke;Be++)if(ue.charCodeAt(Be)!==Ie.charCodeAt(Be))return Be;return Ke}e.commonPrefixLength=F;function M(ue,Ie){let Be,Ke=Math.min(ue.length,Ie.length);const We=ue.length-1,ot=Ie.length-1;for(Be=0;Be<Ke;Be++)if(ue.charCodeAt(We-Be)!==Ie.charCodeAt(ot-Be))return Be;return Ke}e.commonSuffixLength=M;function K(ue){return 55296<=ue&&ue<=56319}e.isHighSurrogate=K;function G(ue){return 56320<=ue&&ue<=57343}e.isLowSurrogate=G;function N(ue,Ie){return(ue-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=N;function z(ue,Ie,Be){const Ke=ue.charCodeAt(Be);if(K(Ke)&&Be+1<Ie){const We=ue.charCodeAt(Be+1);if(G(We))return N(Ke,We)}return Ke}e.getNextCodePoint=z;function O(ue,Ie){const Be=ue.charCodeAt(Ie-1);if(G(Be)&&Ie>1){const Ke=ue.charCodeAt(Ie-2);if(K(Ke))return N(Ke,Be)}return Be}function x(ue,Ie){const Be=pe.getInstance(),Ke=Ie,We=ue.length,ot=z(ue,We,Ie);Ie+=ot>=65536?2:1;let Le=Be.getGraphemeBreakType(ot);for(;Ie<We;){const ye=z(ue,We,Ie),ke=Be.getGraphemeBreakType(ye);if(X(Le,ke))break;Ie+=ye>=65536?2:1,Le=ke}return Ie-Ke}e.nextCharLength=x;function B(ue,Ie){const Be=pe.getInstance(),Ke=Ie,We=O(ue,Ie);Ie-=We>=65536?2:1;let ot=Be.getGraphemeBreakType(We);for(;Ie>0;){const Le=O(ue,Ie),ye=Be.getGraphemeBreakType(Le);if(X(ye,ot))break;Ie-=Le>=65536?2:1,ot=ye}return Ke-Ie}e.prevCharLength=B;function U(ue,Ie){const Be=pe.getInstance(),Ke=ue.length,We=Ie,ot=z(ue,Ke,Ie),Le=Be.getGraphemeBreakType(ot);Ie+=ot>=65536?2:1;let ye=Le;for(;Ie<Ke;){const ne=z(ue,Ke,Ie),de=Be.getGraphemeBreakType(ne);if(X(ye,de))break;Ie+=ne>=65536?2:1,ye=de}const ke=Ie;for(Ie=We,ye=Le;Ie>0;){const ne=O(ue,Ie),de=Be.getGraphemeBreakType(ne);if(X(de,ye))break;Ie-=ne>=65536?2:1,ye=de}return[Ie,ke]}function H(ue,Ie){return Ie>0&&G(ue.charCodeAt(Ie))?U(ue,Ie-1):U(ue,Ie)}e.getCharContainingOffset=H;const W=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(ue){return W.test(ue)}e.containsRTL=Q;const Y=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function he(ue){return Y.test(ue)}e.containsEmoji=he;const _e=/^[\t\n\r\x20-\x7E]*$/;function Se(ue){return _e.test(ue)}e.isBasicASCII=Se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Re(ue){return e.UNUSUAL_LINE_TERMINATORS.test(ue)}e.containsUnusualLineTerminators=Re;function xe(ue){for(let Ie=0,Be=ue.length;Ie<Be;Ie++)if(Ue(ue.charCodeAt(Ie)))return!0;return!1}e.containsFullWidthCharacter=xe;function Ue(ue){return ue=+ue,ue>=11904&&ue<=55215||ue>=63744&&ue<=64255||ue>=65281&&ue<=65374}e.isFullWidthCharacter=Ue;function je(ue){return ue>=127462&&ue<=127487||ue===8986||ue===8987||ue===9200||ue===9203||ue>=9728&&ue<=10175||ue===11088||ue===11093||ue>=127744&&ue<=128591||ue>=128640&&ue<=128764||ue>=128992&&ue<=129003||ue>=129280&&ue<=129535||ue>=129648&&ue<=129750}e.isEmojiImprecise=je;function V(ue,Ie){if(ue.length<Ie)return ue;const Be=/\b/g;let Ke=0;for(;Be.test(ue)&&!(ue.length-Be.lastIndex<Ie);)Ke=Be.lastIndex,Be.lastIndex+=1;return ue.substring(Ke).replace(/^\s/,"")}e.lcut=V;const ee=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,le=/\x1b\[0?m/g;function Z(ue){return ue&&(ue=ue.replace(ee,""),ue=ue.replace(re,""),ue=ue.replace(le,"")),ue}e.removeAnsiEscapeCodes=Z,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function oe(ue){return!!(ue&&ue.length>0&&ue.charCodeAt(0)===65279)}e.startsWithUTF8BOM=oe;function ve(ue){return oe(ue)?ue.substr(1):ue}e.stripUTF8BOM=ve;function Me(ue,Ie){if(!ue||!Ie||ue.length<Ie.length)return!1;const Be=Ie.length,Ke=ue.toLowerCase();let We=0,ot=-1;for(;We<Be;){const Le=Ke.indexOf(Ie[We],ot+1);if(Le<0)return!1;ot=Le,We++}return!0}e.fuzzyContains=Me;function qe(ue,Ie=!1){return ue?(Ie&&(ue=ue.replace(/\\./g,"")),ue.toLowerCase()!==ue):!1}e.containsUppercaseCharacter=qe;function Qe(ue){return ue.charAt(0).toUpperCase()+ue.slice(1)}e.uppercaseFirstLetter=Qe;function Je(ue,Ie=1){if(Ie===0)return"";let Be=-1;do Be=ue.indexOf(`
`,Be+1),Ie--;while(Ie>0&&Be>=0);return Be===-1?ue:(ue[Be-1]==="\r"&&Be--,ue.substr(0,Be))}e.getNLines=Je;function Ce(ue){const Ie=90-65+1;return ue=ue%(2*Ie),ue<Ie?String.fromCharCode(97+ue):String.fromCharCode(65+ue-Ie)}e.singleLetterHash=Ce;function at(ue){return pe.getInstance().getGraphemeBreakType(ue)}e.getGraphemeBreakType=at;function X(ue,Ie){return ue===0?Ie!==5&&Ie!==7:ue===2&&Ie===3?!1:ue===4||ue===2||ue===3||Ie===4||Ie===2||Ie===3?!0:!(ue===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(ue===11||ue===9)&&(Ie===9||Ie===10)||(ue===12||ue===10)&&Ie===10||Ie===5||Ie===13||Ie===7||ue===1||ue===13&&Ie===14||ue===6&&Ie===6)}e.breakBetweenGraphemeBreakType=X;var te;(function(ue){ue[ue.Other=0]="Other",ue[ue.Prepend=1]="Prepend",ue[ue.CR=2]="CR",ue[ue.LF=3]="LF",ue[ue.Control=4]="Control",ue[ue.Extend=5]="Extend",ue[ue.Regional_Indicator=6]="Regional_Indicator",ue[ue.SpacingMark=7]="SpacingMark",ue[ue.L=8]="L",ue[ue.V=9]="V",ue[ue.T=10]="T",ue[ue.LV=11]="LV",ue[ue.LVT=12]="LVT",ue[ue.ZWJ=13]="ZWJ",ue[ue.Extended_Pictographic=14]="Extended_Pictographic"})(te=e.GraphemeBreakType||(e.GraphemeBreakType={}));class pe{constructor(){this._data=ze()}static getInstance(){return pe._INSTANCE||(pe._INSTANCE=new pe),pe._INSTANCE}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Be=this._data,Ke=Be.length/3;let We=1;for(;We<=Ke;)if(Ie<Be[3*We])We=2*We;else if(Ie>Be[3*We+1])We=2*We+1;else return Be[3*We+2];return 0}}pe._INSTANCE=null;function ze(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function tt(ue,Ie){if(ue===0)return 0;const Be=ut(ue,Ie);if(Be!==void 0)return Be;const Ke=O(Ie,ue);return ue-=lt(Ke),ue}e.getLeftDeleteOffset=tt;function ut(ue,Ie){let Be=O(Ie,ue);for(ue-=lt(Be);vt(Be)||Be===65039||Be===8419;){if(ue===0)return;Be=O(Ie,ue),ue-=lt(Be)}if(!!je(Be)){if(ue>=0){const Ke=O(Ie,ue);Ke===8205&&(ue-=lt(Ke))}return ue}}function lt(ue){return ue>=65536?2:1}function vt(ue){return 127995<=ue&&ue<=127999}var Dt;(function(ue){ue[ue.zwj=8205]="zwj",ue[ue.emojiVariantSelector=65039]="emojiVariantSelector",ue[ue.enclosingKeyCap=8419]="enclosingKeyCap"})(Dt||(Dt={}))}),define(me[48],ge([0,1,9]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(A){return k(A,0)}e.hash=L;function k(A,E){switch(typeof A){case"object":return A===null?C(349,E):Array.isArray(A)?y(A,E):T(A,E);case"string":return S(A,E);case"boolean":return R(A,E);case"number":return C(A,E);case"undefined":return C(937,E);default:return C(617,E)}}e.doHash=k;function C(A,E){return(E<<5)-E+A|0}function R(A,E){return C(A?433:863,E)}function S(A,E){E=C(149417,E);for(let a=0,s=A.length;a<s;a++)E=C(A.charCodeAt(a),E);return E}e.stringHash=S;function y(A,E){return E=C(104579,E),A.reduce((a,s)=>k(s,a),E)}function T(A,E){return E=C(181387,E),Object.keys(A).sort().reduce((a,s)=>(a=S(s,a),k(A[s],a)),E)}class n{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=k(E,this._value),this._value}}e.Hasher=n;var I;(function(A){A[A.BLOCK_SIZE=64]="BLOCK_SIZE",A[A.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function c(A,E,a=32){const s=a-E,g=~((1<<s)-1);return(A<<E|(g&A)>>>s)>>>0}function f(A,E=0,a=A.byteLength,s=0){for(let g=0;g<a;g++)A[E+g]=s}function h(A,E,a="0"){for(;A.length<E;)A=a+A;return A}function p(A,E=32){return A instanceof ArrayBuffer?Array.from(new Uint8Array(A)).map(a=>a.toString(16).padStart(2,"0")).join(""):h((A>>>0).toString(16),E/4)}e.toHexString=p;class D{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const a=E.length;if(a===0)return;const s=this._buff;let g=this._buffLen,t=this._leftoverHighSurrogate,u,r;for(t!==0?(u=t,r=-1,t=0):(u=E.charCodeAt(0),r=0);;){let i=u;if(m.isHighSurrogate(u))if(r+1<a){const o=E.charCodeAt(r+1);m.isLowSurrogate(o)?(r++,i=m.computeCodePoint(u,o)):i=65533}else{t=u;break}else m.isLowSurrogate(u)&&(i=65533);if(g=this._push(s,g,i),r++,r<a)u=E.charCodeAt(r);else break}this._buffLen=g,this._leftoverHighSurrogate=t}_push(E,a,s){return s<128?E[a++]=s:s<2048?(E[a++]=192|(s&1984)>>>6,E[a++]=128|(s&63)>>>0):s<65536?(E[a++]=224|(s&61440)>>>12,E[a++]=128|(s&4032)>>>6,E[a++]=128|(s&63)>>>0):(E[a++]=240|(s&1835008)>>>18,E[a++]=128|(s&258048)>>>12,E[a++]=128|(s&4032)>>>6,E[a++]=128|(s&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=D._bigBlock32,a=this._buffDV;for(let d=0;d<64;d+=4)E.setUint32(d,a.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)E.setUint32(d,c(E.getUint32(d-12,!1)^E.getUint32(d-32,!1)^E.getUint32(d-56,!1)^E.getUint32(d-64,!1),1),!1);let s=this._h0,g=this._h1,t=this._h2,u=this._h3,r=this._h4,i,o,l;for(let d=0;d<80;d++)d<20?(i=g&t|~g&u,o=1518500249):d<40?(i=g^t^u,o=1859775393):d<60?(i=g&t|g&u|t&u,o=2400959708):(i=g^t^u,o=3395469782),l=c(s,5)+i+r+o+E.getUint32(d*4,!1)&4294967295,r=u,u=t,t=c(g,30),g=s,s=l;this._h0=this._h0+s&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=D,D._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[49],ge([0,1,9]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(L||(L={})),function(k){const C="error",R="warning",S="warn",y="info",T="ignore";function n(c){return c?m.equalsIgnoreCase(C,c)?k.Error:m.equalsIgnoreCase(R,c)||m.equalsIgnoreCase(S,c)?k.Warning:m.equalsIgnoreCase(y,c)?k.Info:k.Ignore:k.Ignore}k.fromValue=n;function I(c){switch(c){case k.Error:return C;case k.Warning:return R;case k.Info:return y;default:return T}}k.toString=I}(L||(L={})),e.default=L}),define(me[13],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(b){return Array.isArray(b)}e.isArray=m;function L(b){return typeof b=="string"}e.isString=L;function k(b){return Array.isArray(b)&&b.every(_=>L(_))}e.isStringArray=k;function C(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}e.isObject=C;function R(b){return typeof b=="number"&&!isNaN(b)}e.isNumber=R;function S(b){return!!b&&typeof b[Symbol.iterator]=="function"}e.isIterable=S;function y(b){return b===!0||b===!1}e.isBoolean=y;function T(b){return typeof b=="undefined"}e.isUndefined=T;function n(b){return!I(b)}e.isDefined=n;function I(b){return T(b)||b===null}e.isUndefinedOrNull=I;function c(b,_){if(!b)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}e.assertType=c;function f(b){if(I(b))throw new Error("Assertion Failed: argument is undefined or null");return b}e.assertIsDefined=f;function h(...b){const _=[];for(let v=0;v<b.length;v++){const P=b[v];if(I(P))throw new Error(`Assertion Failed: argument at index ${v} is undefined or null`);_.push(P)}return _}e.assertAllDefined=h;const p=Object.prototype.hasOwnProperty;function D(b){if(!C(b))return!1;for(let _ in b)if(p.call(b,_))return!1;return!0}e.isEmptyObject=D;function A(b){return typeof b=="function"}e.isFunction=A;function E(...b){return b.length>0&&b.every(A)}e.areFunctions=E;function a(b,_){const v=Math.min(b.length,_.length);for(let P=0;P<v;P++)s(b[P],_[P])}e.validateConstraints=a;function s(b,_){if(L(_)){if(typeof b!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(A(_)){try{if(b instanceof _)return}catch{}if(!I(b)&&b.constructor===_||_.length===1&&_.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function g(b){let _=[],v=Object.getPrototypeOf(b);for(;Object.prototype!==v;)_=_.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return _}e.getAllPropertyNames=g;function t(b){const _=[];for(const v of g(b))typeof b[v]=="function"&&_.push(v);return _}e.getAllMethodNames=t;function u(b,_){const v=w=>function(){const F=Array.prototype.slice.call(arguments,0);return _(w,F)};let P={};for(const w of b)P[w]=v(w);return P}e.createProxyObject=u;function r(b){return b===null?void 0:b}e.withNullAsUndefined=r;function i(b){return typeof b=="undefined"?null:b}e.withUndefinedAsNull=i;function o(b){return class{constructor(){return new Proxy({},{get(_,v){if(_[v])return _[v];throw new Error(`Not Implemented: ${b}->${String(v)}`)}})}}}e.NotImplementedProxy=o;function l(b,_="Unreachable"){throw new Error(_)}e.assertNever=l;function d(b){return!!b&&typeof b.then=="function"&&typeof b.catch=="function"}e.isPromise=d}),define(me[29],ge([0,1,8,11,9,13]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(r){return r===47||r===92}e.isPathSeparator=R;function S(r){return r.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=S;function y(r){return r.indexOf("/")===-1&&(r=S(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=y;function T(r,i=m.posix.sep){if(!r)return"";const o=r.length,l=r.charCodeAt(0);if(R(l)){if(R(r.charCodeAt(1))&&!R(r.charCodeAt(2))){let b=3;const _=b;for(;b<o&&!R(r.charCodeAt(b));b++);if(_!==b&&!R(r.charCodeAt(b+1))){for(b+=1;b<o;b++)if(R(r.charCodeAt(b)))return r.slice(0,b+1).replace(/[\\/]/g,i)}}return i}else if(A(l)&&r.charCodeAt(1)===58)return R(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let d=r.indexOf("://");if(d!==-1){for(d+=3;d<o;d++)if(R(r.charCodeAt(d)))return r.slice(0,d+1)}return""}e.getRoot=T;function n(r){if(!L.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let o=2;const l=o;for(;o<r.length&&(i=r.charCodeAt(o),i!==92);o++);return!(l===o||(i=r.charCodeAt(o+1),isNaN(i)||i===92))}e.isUNC=n;const I=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(r,i=L.isWindows){const o=i?I:c;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||i&&f.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=h;function p(r,i,o){const l=r===i;return!o||l?l:!r||!i?!1:(0,k.equalsIgnoreCase)(r,i)}e.isEqual=p;function D(r,i,o,l=m.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(o){if(!(0,k.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let b=i.length;return i.charAt(i.length-1)===l&&b--,r.charAt(b)===l}return i.charAt(i.length-1)!==l&&(i+=l),r.indexOf(i)===0}e.isEqualOrParent=D;function A(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=A;function E(r,i){return L.isWindows&&r.endsWith(":")&&(r+=m.sep),(0,m.isAbsolute)(r)||(r=(0,m.join)(i,r)),r=(0,m.normalize)(r),L.isWindows?(r=(0,k.rtrim)(r,m.sep),r.endsWith(":")&&(r+=m.sep)):(r=(0,k.rtrim)(r,m.sep),r||(r=m.sep)),r}e.sanitizeFilePath=E;function a(r){const i=(0,m.normalize)(r);return L.isWindows?r.length>3?!1:s(i)&&(r.length===2||i.charCodeAt(2)===92):i===m.posix.sep}e.isRootOrDriveLetter=a;function s(r){return L.isWindows?A(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=s;function g(r){return s(r)?r[0]:void 0}e.getDriveLetter=g;function t(r,i,o){return i.length>r.length?-1:r===i?0:(o&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=t;function u(r){const i=r.split(":");let o,l,d;if(i.forEach(b=>{const _=Number(b);(0,C.isNumber)(_)?l===void 0?l=_:d===void 0&&(d=_):o=o?[o,b].join(":"):b}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:l!==void 0?l:void 0,column:d!==void 0?d:l!==void 0?1:void 0}}e.parseLineAndColumnAware=u}),define(me[25],ge([0,1,13]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const D=Array.isArray(p)?[]:{};return Object.keys(p).forEach(A=>{p[A]&&typeof p[A]=="object"?D[A]=L(p[A]):D[A]=p[A]}),D}e.deepClone=L;function k(p){if(!p||typeof p!="object")return p;const D=[p];for(;D.length>0;){const A=D.shift();Object.freeze(A);for(const E in A)if(C.call(A,E)){const a=A[E];typeof a=="object"&&!Object.isFrozen(a)&&D.push(a)}}return p}e.deepFreeze=k;const C=Object.prototype.hasOwnProperty;function R(p,D){return S(p,D,new Set)}e.cloneAndChange=R;function S(p,D,A){if((0,m.isUndefinedOrNull)(p))return p;const E=D(p);if(typeof E!="undefined")return E;if((0,m.isArray)(p)){const a=[];for(const s of p)a.push(S(s,D,A));return a}if((0,m.isObject)(p)){if(A.has(p))throw new Error("Cannot clone recursive data-structure");A.add(p);const a={};for(let s in p)C.call(p,s)&&(a[s]=S(p[s],D,A));return A.delete(p),a}return p}function y(p,D,A=!0){return(0,m.isObject)(p)?((0,m.isObject)(D)&&Object.keys(D).forEach(E=>{E in p?A&&((0,m.isObject)(p[E])&&(0,m.isObject)(D[E])?y(p[E],D[E],A):p[E]=D[E]):p[E]=D[E]}),p):D}e.mixin=y;function T(p,D){if(p===D)return!0;if(p==null||D===null||D===void 0||typeof p!=typeof D||typeof p!="object"||Array.isArray(p)!==Array.isArray(D))return!1;let A,E;if(Array.isArray(p)){if(p.length!==D.length)return!1;for(A=0;A<p.length;A++)if(!T(p[A],D[A]))return!1}else{const a=[];for(E in p)a.push(E);a.sort();const s=[];for(E in D)s.push(E);if(s.sort(),!T(a,s))return!1;for(A=0;A<a.length;A++)if(!T(p[a[A]],D[a[A]]))return!1}return!0}e.equals=T;function n(p){const D=new Set;return JSON.stringify(p,(A,E)=>{if((0,m.isObject)(E)||Array.isArray(E)){if(D.has(E))return"[Circular]";D.add(E)}return E})}e.safeStringify=n;function I(p,D,A){const E=D(p);return typeof E=="undefined"?A:E}e.getOrDefault=I;function c(p,D){const A=Object.create(null);return!p||!D||Object.keys(D).forEach(a=>{const s=p[a],g=D[a];T(s,g)||(A[a]=g)}),A}e.distinct=c;function f(p,D){const A=D.toLowerCase(),E=Object.keys(p).find(a=>a.toLowerCase()===A);return E?p[E]:p[D]}e.getCaseInsensitive=f;function h(p,D){const A=Object.create(null);for(const E of Object.keys(p))D(E,p[E])&&(A[E]=p[E]);return A}e.filter=h}),define(me[97],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function L(C){return C<0?0:C>255?255:C|0}e.toUint8=L;function k(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=k}),define(me[2],ge([0,1,8,11]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,C=/^\//,R=/^\/\//;function S(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!C.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(r,i){return!r&&!i?"file":r}function T(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==I&&(i=I+i):i=I;break}return i}const n="",I="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(i,o,l,d,b,_=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=y(i,_),this.authority=o||n,this.path=T(this.scheme,l||n),this.query=d||n,this.fragment=b||n,S(this,_))}static isUri(i){return i instanceof f?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return a(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:l,path:d,query:b,fragment:_}=i;return o===void 0?o=this.scheme:o===null&&(o=n),l===void 0?l=this.authority:l===null&&(l=n),d===void 0?d=this.path:d===null&&(d=n),b===void 0?b=this.query:b===null&&(b=n),_===void 0?_=this.fragment:_===null&&(_=n),o===this.scheme&&l===this.authority&&d===this.path&&b===this.query&&_===this.fragment?this:new p(o,l,d,b,_)}static parse(i,o=!1){const l=c.exec(i);return l?new p(l[2]||n,u(l[4]||n),u(l[5]||n),u(l[7]||n),u(l[9]||n),o):new p(n,n,n,n,n)}static file(i){let o=n;if(L.isWindows&&(i=i.replace(/\\/g,I)),i[0]===I&&i[1]===I){const l=i.indexOf(I,2);l===-1?(o=i.substring(2),i=I):(o=i.substring(2,l),i=i.substring(l)||I)}return new p("file",o,i,n,n)}static from(i){const o=new p(i.scheme,i.authority,i.path,i.query,i.fragment);return S(o,!0),o}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return L.isWindows&&i.scheme==="file"?l=f.file(m.win32.join(a(i,!0),...o)).path:l=m.posix.join(i.path,...o),i.with({path:l})}toString(i=!1){return s(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof f)return i;{const o=new p(i);return o._formatted=i.external,o._fsPath=i._sep===h?i.fsPath:null,o}}else return i}}e.URI=f;const h=L.isWindows?1:void 0;class p extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(i=!1){return i?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=h),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function A(r,i){let o,l=-1;for(let d=0;d<r.length;d++){const b=r.charCodeAt(d);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||i&&b===47)l!==-1&&(o+=encodeURIComponent(r.substring(l,d)),l=-1),o!==void 0&&(o+=r.charAt(d));else{o===void 0&&(o=r.substr(0,d));const _=D[b];_!==void 0?(l!==-1&&(o+=encodeURIComponent(r.substring(l,d)),l=-1),o+=_):l===-1&&(l=d)}}return l!==-1&&(o+=encodeURIComponent(r.substring(l))),o!==void 0?o:r}function E(r){let i;for(let o=0;o<r.length;o++){const l=r.charCodeAt(o);l===35||l===63?(i===void 0&&(i=r.substr(0,o)),i+=D[l]):i!==void 0&&(i+=r[o])}return i!==void 0?i:r}function a(r,i){let o;return r.authority&&r.path.length>1&&r.scheme==="file"?o=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?o=r.path.substr(1):o=r.path[1].toLowerCase()+r.path.substr(2):o=r.path,L.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=a;function s(r,i){const o=i?E:A;let l="",{scheme:d,authority:b,path:_,query:v,fragment:P}=r;if(d&&(l+=d,l+=":"),(b||d==="file")&&(l+=I,l+=I),b){let w=b.indexOf("@");if(w!==-1){const F=b.substr(0,w);b=b.substr(w+1),w=F.indexOf(":"),w===-1?l+=o(F,!1):(l+=o(F.substr(0,w),!1),l+=":",l+=o(F.substr(w+1),!1)),l+="@"}b=b.toLowerCase(),w=b.indexOf(":"),w===-1?l+=o(b,!1):(l+=o(b.substr(0,w),!1),l+=b.substr(w))}if(_){if(_.length>=3&&_.charCodeAt(0)===47&&_.charCodeAt(2)===58){const w=_.charCodeAt(1);w>=65&&w<=90&&(_=`/${String.fromCharCode(w+32)}:${_.substr(3)}`)}else if(_.length>=2&&_.charCodeAt(1)===58){const w=_.charCodeAt(0);w>=65&&w<=90&&(_=`${String.fromCharCode(w+32)}:${_.substr(2)}`)}l+=o(_,!0)}return v&&(l+="?",l+=o(v,!1)),P&&(l+="#",l+=i?P:A(P,!1)),l}function g(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+g(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(r){return r.match(t)?r.replace(t,i=>g(i)):r}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[24],ge([0,1,17,9,2]),function(J,e,m,L,k){"use strict";var C,R,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(u,r,i){let o=u.get(r);return o===void 0&&(o=i,u.set(r,o)),o}e.getOrSet=y;function T(u){const r=[];return u.forEach((i,o)=>{r.push(`${o} => ${i}`)}),`Map(${u.size}) {${r.join(", ")}}`}e.mapToString=T;function n(u){const r=[];return u.forEach(i=>{r.push(i)}),`Set(${u.size}) {${r.join(", ")}}`}e.setToString=n;class I{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),o=this._value.charCodeAt(this._pos);return i-o}value(){return this._value[this._pos]}}e.StringIterator=I;class c{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=c;class f{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var h;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(h||(h={}));class p{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class D{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class A{constructor(r){this._iter=r}static forUris(r=()=>!1){return new A(new p(r))}static forPaths(){return new A(new f)}static forStrings(){return new A(new I)}static forConfigKeys(){return new A(new c)}clear(){this._root=void 0}set(r,i){const o=this._iter.reset(r);let l;for(this._root||(this._root=new D,this._root.segment=o.value()),l=this._root;;){const b=o.cmp(l.segment);if(b>0)l.left||(l.left=new D,l.left.segment=o.value()),l=l.left;else if(b<0)l.right||(l.right=new D,l.right.segment=o.value()),l=l.right;else if(o.hasNext())o.next(),l.mid||(l.mid=new D,l.mid.segment=o.value()),l=l.mid;else break}const d=l.value;return l.value=i,l.key=r,d}fill(r,i){const o=i.slice(0);(0,m.shuffle)(o);for(let l of o)this.set(l,r)}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let o=this._root;for(;o;){const l=i.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(i.hasNext())i.next(),o=o.mid;else break}return o}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const o=this._iter.reset(r),l=[];let d=this._root;for(;d;){const b=o.cmp(d.segment);if(b>0)l.push([1,d]),d=d.left;else if(b<0)l.push([-1,d]),d=d.right;else if(o.hasNext())o.next(),l.push([0,d]),d=d.mid;else{for(i?(d.left=void 0,d.mid=void 0,d.right=void 0):d.value=void 0;l.length>0&&d.isEmpty();){let[_,v]=l.pop();switch(_){case 1:v.left=void 0;break;case 0:v.mid=void 0;break;case-1:v.right=void 0;break}d=v}break}}}findSubstr(r){const i=this._iter.reset(r);let o=this._root,l;for(;o;){const d=i.cmp(o.segment);if(d>0)o=o.left;else if(d<0)o=o.right;else if(i.hasNext())i.next(),l=o.value||l,o=o.mid;else break}return o&&o.value||l}findSuperstr(r){const i=this._iter.reset(r);let o=this._root;for(;o;){const l=i.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(i.hasNext())i.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(r){for(const[i,o]of this)r(o,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const o=i.pop();o&&(o.value&&(yield[o.key,o.value]),o.left&&i.push(o.left),o.mid&&i.push(o.mid),o.right&&i.push(o.right))}}}e.TernarySearchTree=A;class E{constructor(r,i){this[C]="ResourceMap",r instanceof E?(this.map=new Map(r.map),this.toKey=i??E.defaultToKey):(this.map=new Map,this.toKey=r??E.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[o,l]of this.map)r(l,k.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield k.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[k.URI.parse(r[0]),r[1]]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[k.URI.parse(r[0]),r[1]]}}e.ResourceMap=E,E.defaultToKey=u=>u.toString();var a;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class s{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const o=this._map.get(r);if(!!o)return i!==0&&this.touch(o,i),o.value}set(r,i,o=0){let l=this._map.get(r);if(l)l.value=i,o!==0&&this.touch(l,o);else{switch(l={key:r,value:i,next:void 0,previous:void 0},o){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(r,l),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const o=this._state;let l=this._head;for(;l;){if(i?r.bind(i)(l.value,l.key,this):r(l.value,l.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const r=this,i=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const d={value:o.key,done:!1};return o=o.next,d}else return{value:void 0,done:!0}}};return l}values(){const r=this,i=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const d={value:o.value,done:!1};return o=o.next,d}else return{value:void 0,done:!0}}};return l}entries(){const r=this,i=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const d={value:[o.key,o.value],done:!1};return o=o.next,d}else return{value:void 0,done:!0}}};return l}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,o=this.size;for(;i&&o>r;)this._map.delete(i.key),i=i.next,o--;this._head=i,this._size=o,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,o=r.previous;if(!i||!o)throw new Error("Invalid list");i.previous=o,o.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const o=r.next,l=r.previous;r===this._tail?(l.next=void 0,this._tail=l):(o.previous=l,l.next=o),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const o=r.next,l=r.previous;r===this._head?(o.previous=void 0,this._head=o):(o.previous=l,l.next=o),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,o)=>{r.push([o,i])}),r}fromJSON(r){this.clear();for(const[i,o]of r)this.set(i,o)}}e.LinkedMap=s;class g extends s{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=g;class t{constructor(r){S.set(this,void 0),nt(this,S,r,"f")}get size(){return Oe(this,S,"f").size}forEach(r,i){Oe(this,S,"f").forEach(r,i)}get(r){return Oe(this,S,"f").get(r)}has(r){return Oe(this,S,"f").has(r)}entries(){return Oe(this,S,"f").entries()}keys(){return Oe(this,S,"f").keys()}values(){return Oe(this,S,"f").values()}[(S=new WeakMap,Symbol.iterator)](){return Oe(this,S,"f").entries()}}e.ReadonlyMapView=t}),define(me[98],ge([0,1,24,9]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...Z){return function(oe,ve){for(let Me=0,qe=Z.length;Me<qe;Me++){const Qe=Z[Me](oe,ve);if(Qe)return Qe}return null}}e.or=k,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(Z,oe,ve){if(!ve||ve.length<oe.length)return null;let Me;return Z?Me=L.startsWithIgnoreCase(ve,oe):Me=ve.indexOf(oe)===0,Me?oe.length>0?[{start:0,end:oe.length}]:[]:null}function R(Z,oe){const ve=oe.toLowerCase().indexOf(Z.toLowerCase());return ve===-1?null:[{start:ve,end:ve+Z.length}]}e.matchesContiguousSubString=R;function S(Z,oe){return y(Z.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=S;function y(Z,oe,ve,Me){if(ve===Z.length)return[];if(Me===oe.length)return null;if(Z[ve]===oe[Me]){let qe=null;return(qe=y(Z,oe,ve+1,Me+1))?A({start:Me,end:Me+1},qe):null}return y(Z,oe,ve,Me+1)}function T(Z){return 97<=Z&&Z<=122}function n(Z){return 65<=Z&&Z<=90}e.isUpper=n;function I(Z){return 48<=Z&&Z<=57}function c(Z){return Z===32||Z===9||Z===10||Z===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Z=>f.add(Z.charCodeAt(0)));function h(Z){return c(Z)||f.has(Z)}function p(Z,oe){return Z===oe||h(Z)&&h(oe)}function D(Z){return T(Z)||n(Z)||I(Z)}function A(Z,oe){return oe.length===0?oe=[Z]:Z.end===oe[0].start?oe[0].start=Z.start:oe.unshift(Z),oe}function E(Z,oe){for(let ve=oe;ve<Z.length;ve++){const Me=Z.charCodeAt(ve);if(n(Me)||I(Me)||ve>0&&!D(Z.charCodeAt(ve-1)))return ve}return Z.length}function a(Z,oe,ve,Me){if(ve===Z.length)return[];if(Me===oe.length)return null;if(Z[ve]!==oe[Me].toLowerCase())return null;{let qe=null,Qe=Me+1;for(qe=a(Z,oe,ve+1,Me+1);!qe&&(Qe=E(oe,Qe))<oe.length;)qe=a(Z,oe,ve+1,Qe),Qe++;return qe===null?null:A({start:Me,end:Me+1},qe)}}function s(Z){let oe=0,ve=0,Me=0,qe=0,Qe=0;for(let te=0;te<Z.length;te++)Qe=Z.charCodeAt(te),n(Qe)&&oe++,T(Qe)&&ve++,D(Qe)&&Me++,I(Qe)&&qe++;const Je=oe/Z.length,Ce=ve/Z.length,at=Me/Z.length,X=qe/Z.length;return{upperPercent:Je,lowerPercent:Ce,alphaPercent:at,numericPercent:X}}function g(Z){const{upperPercent:oe,lowerPercent:ve}=Z;return ve===0&&oe>.6}function t(Z){const{upperPercent:oe,lowerPercent:ve,alphaPercent:Me,numericPercent:qe}=Z;return ve>.2&&oe<.8&&Me>.6&&qe<.2}function u(Z){let oe=0,ve=0,Me=0,qe=0;for(let Qe=0;Qe<Z.length;Qe++)Me=Z.charCodeAt(Qe),n(Me)&&oe++,T(Me)&&ve++,c(Me)&&qe++;return(oe===0||ve===0)&&qe===0?Z.length<=30:oe<=5}function r(Z,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!u(Z)||oe.length>60)return null;const ve=s(oe);if(!t(ve)){if(!g(ve))return null;oe=oe.toLowerCase()}let Me=null,qe=0;for(Z=Z.toLowerCase();qe<oe.length&&(Me=a(Z,oe,0,qe))===null;)qe=E(oe,qe+1);return Me}e.matchesCamelCase=r;function i(Z,oe,ve=!1){if(!oe||oe.length===0)return null;let Me=null,qe=0;for(Z=Z.toLowerCase(),oe=oe.toLowerCase();qe<oe.length&&(Me=o(Z,oe,0,qe,ve))===null;)qe=l(oe,qe+1);return Me}e.matchesWords=i;function o(Z,oe,ve,Me,qe){if(ve===Z.length)return[];if(Me===oe.length)return null;if(p(Z.charCodeAt(ve),oe.charCodeAt(Me))){let Qe=null,Je=Me+1;if(Qe=o(Z,oe,ve+1,Me+1,qe),!qe)for(;!Qe&&(Je=l(oe,Je))<oe.length;)Qe=o(Z,oe,ve+1,Je,qe),Je++;return Qe===null?null:A({start:Me,end:Me+1},Qe)}else return null}function l(Z,oe){for(let ve=oe;ve<Z.length;ve++)if(h(Z.charCodeAt(ve))||ve>0&&h(Z.charCodeAt(ve-1)))return ve;return Z.length}const d=k(e.matchesPrefix,r,R),b=k(e.matchesPrefix,r,S),_=new m.LRUCache(1e4);function v(Z,oe,ve=!1){if(typeof Z!="string"||typeof oe!="string")return null;let Me=_.get(Z);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(Z),"i"),_.set(Z,Me));const qe=Me.exec(oe);return qe?[{start:qe.index,end:qe.index+qe[0].length}]:ve?b(Z,oe):d(Z,oe)}e.matchesFuzzy=v;function P(Z,oe){const ve=xe(Z,Z.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return ve?F(ve):null}e.matchesFuzzy2=P;function w(Z,oe,ve,Me,qe,Qe){const Je=Math.min(13,Z.length);for(;ve<Je;ve++){const Ce=xe(Z,oe,ve,Me,qe,Qe,!1);if(Ce)return Ce}return[0,Qe]}e.anyScore=w;function F(Z){if(typeof Z=="undefined")return[];const oe=[],ve=Z[1];for(let Me=Z.length-1;Me>1;Me--){const qe=Z[Me]+ve,Qe=oe[oe.length-1];Qe&&Qe.end===qe?Qe.end=qe+1:oe.push({start:qe,end:qe+1})}return oe}e.createMatches=F;const M=128;function K(){const Z=[],oe=[];for(let ve=0;ve<=M;ve++)oe[ve]=0;for(let ve=0;ve<=M;ve++)Z.push(oe.slice(0));return Z}function G(Z){const oe=[];for(let ve=0;ve<=Z;ve++)oe[ve]=0;return oe}const N=G(2*M),z=G(2*M),O=K(),x=K(),B=K(),U=!1;function H(Z,oe,ve,Me,qe){function Qe(Ce,at,X=" "){for(;Ce.length<at;)Ce=X+Ce;return Ce}let Je=` |   |${Me.split("").map(Ce=>Qe(Ce,3)).join("|")}
`;for(let Ce=0;Ce<=ve;Ce++)Ce===0?Je+=" |":Je+=`${oe[Ce-1]}|`,Je+=Z[Ce].slice(0,qe+1).map(at=>Qe(at.toString(),3)).join("|")+`
`;return Je}function W(Z,oe,ve,Me){Z=Z.substr(oe),ve=ve.substr(Me),console.log(H(x,Z,Z.length,ve,ve.length)),console.log(H(B,Z,Z.length,ve,ve.length)),console.log(H(O,Z,Z.length,ve,ve.length))}function Q(Z,oe){if(oe<0||oe>=Z.length)return!1;const ve=Z.codePointAt(oe);switch(ve){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(ve)}}function Y(Z,oe){if(oe<0||oe>=Z.length)return!1;switch(Z.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function he(Z,oe,ve){return oe[Z]!==ve[Z]}function _e(Z,oe,ve,Me,qe,Qe,Je=!1){for(;oe<ve&&qe<Qe;)Z[oe]===Me[qe]&&(Je&&(N[oe]=qe),oe+=1),qe+=1;return oe===ve}e.isPatternInWord=_e;var Se;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var Re;(function(Z){Z.Default=[-100,0];function oe(ve){return!ve||ve.length===2&&ve[0]===-100&&ve[1]===0}Z.isDefault=oe})(Re=e.FuzzyScore||(e.FuzzyScore={}));function xe(Z,oe,ve,Me,qe,Qe,Je){const Ce=Z.length>M?M:Z.length,at=Me.length>M?M:Me.length;if(ve>=Ce||Qe>=at||Ce-ve>at-Qe||!_e(oe,ve,Ce,qe,Qe,at,!0))return;Ue(Ce,at,ve,Qe,oe,qe);let X=1,te=1,pe=ve,ze=Qe;const tt=[!1];for(X=1,pe=ve;pe<Ce;X++,pe++){const ue=N[pe],Ie=z[pe],Be=pe+1<Ce?z[pe+1]:at;for(te=ue-Qe+1,ze=ue;ze<Be;te++,ze++){let Ke=Number.MIN_SAFE_INTEGER,We=!1;ze<=Ie&&(Ke=je(Z,oe,pe,ve,Me,qe,ze,at,Qe,O[X-1][te-1]===0,tt));let ot=0;Ke!==Number.MAX_SAFE_INTEGER&&(We=!0,ot=Ke+x[X-1][te-1]);const Le=ze>ue,ye=Le?x[X][te-1]+(O[X][te-1]>0?-5:0):0,ke=ze>ue+1&&O[X][te-1]>0,ne=ke?x[X][te-2]+(O[X][te-2]>0?-5:0):0;if(ke&&(!Le||ne>=ye)&&(!We||ne>=ot))x[X][te]=ne,B[X][te]=3,O[X][te]=0;else if(Le&&(!We||ye>=ot))x[X][te]=ye,B[X][te]=2,O[X][te]=0;else if(We)x[X][te]=ot,B[X][te]=1,O[X][te]=O[X-1][te-1]+1;else throw new Error("not possible")}}if(U&&W(Z,ve,Me,Qe),!tt[0]&&!Je)return;X--,te--;const ut=[x[X][te],Qe];let lt=0,vt=0;for(;X>=1;){let ue=te;do{const Ie=B[X][ue];if(Ie===3)ue=ue-2;else if(Ie===2)ue=ue-1;else break}while(ue>=1);lt>1&&oe[ve+X-1]===qe[Qe+te-1]&&!he(ue+Qe-1,Me,qe)&&lt+1>O[X][ue]&&(ue=te),ue===te?lt++:lt=1,vt||(vt=ue),X--,te=ue-1,ut.push(te)}at===Ce&&(ut[0]+=2);const Dt=vt-Ce;return ut[0]-=Dt,ut}e.fuzzyScore=xe;function Ue(Z,oe,ve,Me,qe,Qe){let Je=Z-1,Ce=oe-1;for(;Je>=ve&&Ce>=Me;)qe[Je]===Qe[Ce]&&(z[Je]=Ce,Je--),Ce--}function je(Z,oe,ve,Me,qe,Qe,Je,Ce,at,X,te){if(oe[ve]!==Qe[Je])return Number.MIN_SAFE_INTEGER;let pe=1,ze=!1;return Je===ve-Me?pe=Z[ve]===qe[Je]?7:5:he(Je,qe,Qe)&&(Je===0||!he(Je-1,qe,Qe))?(pe=Z[ve]===qe[Je]?7:5,ze=!0):Q(Qe,Je)&&(Je===0||!Q(Qe,Je-1))?pe=5:(Q(Qe,Je-1)||Y(Qe,Je-1))&&(pe=5,ze=!0),pe>1&&ve===Me&&(te[0]=!0),ze||(ze=he(Je,qe,Qe)||Q(Qe,Je-1)||Y(Qe,Je-1)),ve===Me?Je>at&&(pe-=ze?3:5):X?pe+=ze?2:0:pe+=ze?0:1,Je+1===Ce&&(pe-=ze?3:5),pe}function V(Z,oe,ve,Me,qe,Qe,Je){return re(Z,oe,ve,Me,qe,Qe,!0,Je)}e.fuzzyScoreGracefulAggressive=V;function ee(Z,oe,ve,Me,qe,Qe,Je){return re(Z,oe,ve,Me,qe,Qe,!1,Je)}e.fuzzyScoreGraceful=ee;function re(Z,oe,ve,Me,qe,Qe,Je,Ce){let at=xe(Z,oe,ve,Me,qe,Qe,Ce);if(at&&!Je)return at;if(Z.length>=3){const X=Math.min(7,Z.length-1);for(let te=ve+1;te<X;te++){const pe=le(Z,te);if(pe){const ze=xe(pe,pe.toLowerCase(),ve,Me,qe,Qe,Ce);ze&&(ze[0]-=3,(!at||ze[0]>at[0])&&(at=ze))}}}return at}function le(Z,oe){if(oe+1>=Z.length)return;const ve=Z[oe],Me=Z[oe+1];if(ve!==Me)return Z.slice(0,oe)+Me+ve+Z.slice(oe+2)}}),define(me[142],ge([0,1,47,98,9]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${C.source}`,"g");function S(p){return p.replace(R,(D,A)=>A?D:`\\${D}`)}e.escapeIcons=S;const y=new RegExp(`\\\\${C.source}`,"g");function T(p){return p.replace(y,D=>`\\${D}`)}e.markdownEscapeEscapedIcons=T;const n=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function I(p){return p.indexOf(e.iconStartMarker)===-1?p:p.replace(n,(D,A,E,a)=>E?D:A||a||"")}e.stripIcons=I;function c(p){const D=p.indexOf(e.iconStartMarker);return D===-1?{text:p}:f(p,D)}e.parseLabelWithIcons=c;function f(p,D){const A=[];let E="";function a(l){if(l){E+=l;for(const d of l)A.push(t)}}let s=-1,g="",t=0,u,r,i=D;const o=p.length;for(a(p.substr(0,D));i<o;)u=p[i],r=p[i+1],u===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(s=i,a(g),g=e.iconStartMarker,i++):u===")"&&s!==-1?(t+=i-s+1,s=-1,g=""):s!==-1?/^[a-z0-9\-]$/i.test(u)?g+=u:(a(g),s=-1,g=""):a(u),i++;return a(g),{text:E,iconOffsets:A}}function h(p,D,A=!1){const{text:E,iconOffsets:a}=D;if(!a||a.length===0)return(0,L.matchesFuzzy)(p,E,A);const s=(0,k.ltrim)(E," "),g=E.length-s.length,t=(0,L.matchesFuzzy)(p,s,A);if(t)for(const u of t){const r=a[u.start+g]+g;u.start+=r,u.end+=r}return t}e.matchesFuzzyIconAware=h}),define(me[99],ge([0,1,16,142]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(f="",h=!1){if(this.value=f,typeof this.value!="string")throw(0,m.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(f,h=0){return this.value+=T(this.supportThemeIcons?(0,L.escapeIcons)(f):f).replace(/([ \t]+)/g,(p,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,h){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}}e.MarkdownString=C;function R(c){return S(c)?!c.value:Array.isArray(c)?c.every(R):!0}e.isEmptyMarkdownString=R;function S(c){return c instanceof C?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=S;function y(c,f){return c===f?!0:!c||!f?!1:c.value===f.value&&c.isTrusted===f.isTrusted&&c.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=y;function T(c){return c.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=T;function n(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function I(c){const f=[],h=c.split("|").map(D=>D.trim());c=h[0];const p=h[1];if(p){const D=/height=(\d+)/.exec(p),A=/width=(\d+)/.exec(p),E=D?D[1]:"",a=A?A[1]:"",s=isFinite(parseInt(a)),g=isFinite(parseInt(E));s&&f.push(`width="${a}"`),g&&f.push(`height="${E}"`)}return{href:c,dimensions:f}}e.parseHrefAndDimensions=I}),define(me[61],ge([0,1,22,9,2]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(n){return JSON.stringify(n,y)}e.stringify=C;function R(n){let I=JSON.parse(n);return I=T(I),I}e.parse=R;var S;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(S=e.MarshalledId||(e.MarshalledId={}));function y(n,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function T(n,I=0){if(!n||I>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return k.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof m.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let c=0;c<n.length;++c)n[c]=T(n[c],I+1);else for(const c in n)Object.hasOwnProperty.call(n,c)&&(n[c]=T(n[c],I+1))}return n}e.revive=T}),define(me[10],ge([0,1,11,2]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.userData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,T,n){this._hosts[y]=T,this._ports[y]=n}setConnectionToken(y,T){this._connectionTokens[y]=T}rewrite(y){if(this._delegate)return this._delegate(y);const T=y.authority;let n=this._hosts[T];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const I=this._ports[T],c=this._connectionTokens[T];let f=`path=${encodeURIComponent(y.path)}`;return typeof c=="string"&&(f+=`&tkn=${encodeURIComponent(c)}`),L.URI.from({scheme:m.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${n}:${I}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new C;class R{asBrowserUri(y,T){const n=this.toUri(y,T);return n.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===k.file&&(m.isNative||typeof m.globals.importScripts=="function"&&m.globals.origin===`${k.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?n.with({scheme:k.vscodeFileResource,authority:n.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(y,T){const n=this.toUri(y,T);return n.scheme===k.vscodeFileResource?n.with({scheme:k.file,authority:n.authority!==R.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(y,T){return L.URI.isUri(y)?y:L.URI.parse(T.toUrl(y))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R}),define(me[78],ge([0,1,24]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new m.LRUCache(1e4);function k(T){return y(T,"NFC",L)}e.normalizeNFC=k;const C=new m.LRUCache(1e4);function R(T){return y(T,"NFD",C)}e.normalizeNFD=R;const S=/[^\u0000-\u0080]/;function y(T,n,I){if(!T)return T;const c=I.get(T);if(c)return c;let f;return S.test(T)?f=T.normalize(n):f=T,I.set(T,f),f}e.removeAccents=function(){const T=/[\u0300-\u036f]/g;return function(n){return R(n).replace(T,"")}}()}),define(me[23],ge([0,1,29,10,8,11,9,2]),function(J,e,m,L,k,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(f){return(0,S.uriToFsPath)(f,!0)}e.originalFSPath=y;class T{constructor(h){this._ignorePathCasing=h}compare(h,p,D=!1){return h===p?0:(0,R.compare)(this.getComparisonKey(h,D),this.getComparisonKey(p,D))}isEqual(h,p,D=!1){return h===p?!0:!h||!p?!1:this.getComparisonKey(h,D)===this.getComparisonKey(p,D)}getComparisonKey(h,p=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,p,D=!1){if(h.scheme===p.scheme){if(h.scheme===L.Schemas.file)return m.isEqualOrParent(y(h),y(p),this._ignorePathCasing(h))&&h.query===p.query&&(D||h.fragment===p.fragment);if((0,e.isEqualAuthority)(h.authority,p.authority))return m.isEqualOrParent(h.path,p.path,this._ignorePathCasing(h),"/")&&h.query===p.query&&(D||h.fragment===p.fragment)}return!1}joinPath(h,...p){return S.URI.joinPath(h,...p)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return k.posix.basename(h.path)}extname(h){return k.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let p;return h.scheme===L.Schemas.file?p=S.URI.file(k.dirname(y(h))).path:(p=k.posix.dirname(h.path),h.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),p="/")),h.with({path:p})}normalizePath(h){if(!h.path.length)return h;let p;return h.scheme===L.Schemas.file?p=S.URI.file(k.normalize(y(h))).path:p=k.posix.normalize(h.path),h.with({path:p})}relativePath(h,p){if(h.scheme!==p.scheme||!(0,e.isEqualAuthority)(h.authority,p.authority))return;if(h.scheme===L.Schemas.file){const E=k.relative(y(h),y(p));return C.isWindows?m.toSlashes(E):E}let D=h.path||"/",A=p.path||"/";if(this._ignorePathCasing(h)){let E=0;for(const a=Math.min(D.length,A.length);E<a&&!(D.charCodeAt(E)!==A.charCodeAt(E)&&D.charAt(E).toLowerCase()!==A.charAt(E).toLowerCase());E++);D=A.substr(0,E)+D.substr(E)}return k.posix.relative(D,A)}resolvePath(h,p){if(h.scheme===L.Schemas.file){const D=S.URI.file(k.resolve(y(h),p));return h.with({authority:D.authority,path:D.path})}return p=m.toPosixPath(p),h.with({path:k.posix.resolve(h.path,p)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,p){return h===p||(0,R.equalsIgnoreCase)(h,p)}hasTrailingPathSeparator(h,p=k.sep){if(h.scheme===L.Schemas.file){const D=y(h);return D.length>m.getRoot(D).length&&D[D.length-1]===p}else{const D=h.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,p=k.sep){return(0,e.hasTrailingPathSeparator)(h,p)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,p=k.sep){let D=!1;if(h.scheme===L.Schemas.file){const A=y(h);D=A!==void 0&&A.length===m.getRoot(A).length&&A[A.length-1]===p}else{p="/";const A=h.path;D=A.length===1&&A.charCodeAt(A.length-1)===47}return!D&&!(0,e.hasTrailingPathSeparator)(h,p)?h.with({path:h.path+"/"}):h}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(f=>f.scheme===L.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new T(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(f,h){const p=[];for(let D=0;D<f.length;D++){const A=h(f[D]);f.some((E,a)=>a===D?!1:(0,e.isEqualOrParent)(A,h(E)))||p.push(f[D])}return p}e.distinctParents=n;var I;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function h(p){const D=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(a=>{const[s,g]=a.split(":");s&&g&&D.set(s,g)});const E=p.path.substring(0,p.path.indexOf(";"));return E&&D.set(f.META_DATA_MIME,E),D}f.parseMetaData=h})(I=e.DataUri||(e.DataUri={}));function c(f,h,p){if(h){let D=f.path;return D&&D[0]!==k.posix.sep&&(D=k.posix.sep+D),f.with({scheme:p,authority:h,path:D})}return f.with({scheme:p})}e.toLocalResource=c}),define(me[18],ge([0,1,21,16,3,6,23]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(O){return!!O&&typeof O.then=="function"}e.isThenable=S;function y(O){const x=new m.CancellationTokenSource,B=O(x.token),U=new Promise((H,W)=>{const Q=x.token.onCancellationRequested(()=>{Q.dispose(),x.dispose(),W((0,L.canceled)())});Promise.resolve(B).then(Y=>{Q.dispose(),x.dispose(),H(Y)},Y=>{Q.dispose(),x.dispose(),W(Y)})});return new class{cancel(){x.cancel()}then(H,W){return U.then(H,W)}catch(H){return this.then(void 0,H)}finally(H){return U.finally(H)}}}e.createCancelablePromise=y;function T(O,x,B){return Promise.race([O,new Promise(U=>x.onCancellationRequested(()=>U(B)))])}e.raceCancellation=T;async function n(O){let x=-1;const B=O.map((H,W)=>H.then(Q=>(x=W,Q))),U=await Promise.race(B);return O.forEach((H,W)=>{W!==x&&H.cancel()}),U}e.raceCancellablePromises=n;function I(O,x,B){let U;const H=setTimeout(()=>{U?.(void 0),B?.()},x);return Promise.race([O.finally(()=>clearTimeout(H)),new Promise(W=>U=W)])}e.raceTimeout=I;function c(O){return new Promise((x,B)=>{const U=O();S(U)?U.then(x,B):x(U)})}e.asPromise=c;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(x){if(this.activePromise){if(this.queuedPromiseFactory=x,!this.queuedPromise){const B=()=>{this.queuedPromise=null;const U=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,U};this.queuedPromise=new Promise(U=>{this.activePromise.then(B,B).then(U)})}return new Promise((B,U)=>{this.queuedPromise.then(B,U)})}return this.activePromise=x(),new Promise((B,U)=>{this.activePromise.then(H=>{this.activePromise=null,B(H)},H=>{this.activePromise=null,U(H)})})}}e.Throttler=f;class h{constructor(){this.current=Promise.resolve(null)}queue(x){return this.current=this.current.then(()=>x(),()=>x())}}e.Sequencer=h;class p{constructor(){this.promiseMap=new Map}queue(x,B){const H=(this.promiseMap.get(x)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.promiseMap.get(x)===H&&this.promiseMap.delete(x)});return this.promiseMap.set(x,H),H}}e.SequencerByKey=p;class D{constructor(x){this.defaultDelay=x,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(x,B=this.defaultDelay){return this.task=x,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,H)=>{this.doResolve=U,this.doReject=H}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},B),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=D;class A{constructor(x){this.delayer=new D(x),this.throttler=new f}trigger(x,B){return this.delayer.trigger(()=>this.throttler.queue(x),B)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=A;class E{constructor(){this._isOpen=!1,this._promise=new Promise((x,B)=>{this._completePromise=x})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=E;class a extends E{constructor(x){super();this._timeout=setTimeout(()=>this.open(),x)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function s(O,x){return x?new Promise((B,U)=>{const H=setTimeout(()=>{W.dispose(),B()},O),W=x.onCancellationRequested(()=>{clearTimeout(H),W.dispose(),U((0,L.canceled)())})}):y(B=>s(O,B))}e.timeout=s;function g(O,x=0){const B=setTimeout(O,x);return(0,C.toDisposable)(()=>clearTimeout(B))}e.disposableTimeout=g;function t(O){const x=[];let B=0;const U=O.length;function H(){return B<U?O[B++]():null}function W(Q){Q!=null&&x.push(Q);const Y=H();return Y?Y.then(W):Promise.resolve(x)}return Promise.resolve(null).then(W)}e.sequence=t;function u(O,x=U=>!!U,B=null){let U=0;const H=O.length,W=()=>{if(U>=H)return Promise.resolve(B);const Q=O[U++];return Promise.resolve(Q()).then(he=>x(he)?Promise.resolve(he):W())};return W()}e.first=u;function r(O,x=U=>!!U,B=null){if(O.length===0)return Promise.resolve(B);let U=O.length;const H=()=>{U=-1;for(const W of O)W.cancel?.()};return new Promise((W,Q)=>{for(const Y of O)Y.then(he=>{--U>=0&&x(he)?(H(),W(he)):U===0&&W(B)}).catch(he=>{--U>=0&&(H(),Q(he))})})}e.firstParallel=r;class i{constructor(x){this._size=0,this.maxDegreeOfParalellism=x,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(x){return this._size++,new Promise((B,U)=>{this.outstandingPromises.push({factory:x,c:B,e:U}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const x=this.outstandingPromises.shift();this.runningPromises++;const B=x.factory();B.then(x.c,x.e),B.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class o extends i{constructor(){super(1)}}e.Queue=o;class l{constructor(){this.queues=new Map}queueFor(x,B=R.extUri){const U=B.getComparisonKey(x);let H=this.queues.get(U);return H||(H=new o,k.Event.once(H.onFinished)(()=>{H?.dispose(),this.queues.delete(U)}),this.queues.set(U,H)),H}dispose(){this.queues.forEach(x=>x.dispose()),this.queues.clear()}}e.ResourceQueue=l;class d{constructor(x,B){this._token=-1,typeof x=="function"&&typeof B=="number"&&this.setIfNotSet(x,B)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(x,B){this.cancel(),this._token=setTimeout(()=>{this._token=-1,x()},B)}setIfNotSet(x,B){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,x()},B))}}e.TimeoutTimer=d;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(x,B){this.cancel(),this._token=setInterval(()=>{x()},B)}}e.IntervalTimer=b;class _{constructor(x,B){this.timeoutToken=-1,this.runner=x,this.timeout=B,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(x=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,x)}get delay(){return this.timeout}set delay(x){this.timeout=x}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=_;class v{constructor(x,B){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.runner=x,this.timeout=B,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(x=this.timeout){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(x/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=v;class P extends _{constructor(x,B){super(x,B);this.units=[]}work(x){this.units.push(x),this.isScheduled()||this.schedule()}doRun(){const x=this.units;this.units=[],this.runner&&this.runner(x)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=P;class w extends C.Disposable{constructor(x,B,U,H){super();this.maxWorkChunkSize=x,this.maxPendingWork=B,this.throttleDelay=U,this.handler=H,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(x){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+x.length>this.maxPendingWork)return!1}else if(this.pending+x.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...x),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new _(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=w,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const O=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=x=>{const B=setTimeout(()=>x(O));let U=!1;return{dispose(){U||(U=!0,clearTimeout(B))}}}}else e.runWhenIdle=(O,x)=>{const B=requestIdleCallback(O,typeof x=="number"?{timeout:x}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(B))}}}}();class F{constructor(x){this._didRun=!1,this._executor=()=>{try{this._value=x()}catch(B){this._error=B}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function M(O,x,B){let U;for(let H=0;H<B;H++)try{return await O()}catch(W){U=W,await s(x)}throw U}e.retry=M;class K{hasPending(x){return this._pending?typeof x=="number"?this._pending.taskId===x:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(x,B,U){return this._pending={taskId:x,cancel:()=>U?.(),promise:B},B.then(()=>this.donePending(x),()=>this.donePending(x)),B}donePending(x){this._pending&&x===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const x=this._next;this._next=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}setNext(x){if(this._next)this._next.run=x;else{let B,U;const H=new Promise((W,Q)=>{B=W,U=Q});this._next={run:x,promise:H,promiseResolve:B,promiseReject:U}}return this._next.promise}}e.TaskSequentializer=K;class G{constructor(x){this.interval=x,this.lastIncrementTime=0,this.value=0}increment(){const x=Date.now();return x-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=x,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((x,B)=>{this.completeCallback=x,this.errorCallback=B})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(x){return new Promise(B=>{this.completeCallback(x),this.resolved=!0,B()})}error(x){return new Promise(B=>{this.errorCallback(x),this.rejected=!0,B()})}cancel(){new Promise(x=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,x()})}}e.DeferredPromise=N;var z;(function(O){async function x(B){let U;const H=await Promise.all(B.map(W=>W.then(Q=>Q,Q=>{U||(U=Q)})));if(typeof U!="undefined")throw U;return H}O.settled=x})(z=e.Promises||(e.Promises={}))}),define(me[100],ge([0,1,18,8]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new m.IdleValue(()=>{const _=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:_,collatorIsNumeric:_.resolvedOptions().numeric}}),C=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function S(_,v,P=!1){const w=_||"",F=v||"",M=k.value.collator.compare(w,F);return k.value.collatorIsNumeric&&M===0&&w!==F?w<F?-1:1:M}e.compareFileNames=S;function y(_,v){const P=C.value.collator;return _=_||"",v=v||"",g(P,_,v)}e.compareFileNamesDefault=y;function T(_,v){const P=C.value.collator;return _=_||"",v=v||"",i(_,v)||g(P,_,v)}e.compareFileNamesUpper=T;function n(_,v){const P=C.value.collator;return _=_||"",v=v||"",r(_,v)||g(P,_,v)}e.compareFileNamesLower=n;function I(_,v){return _=_||"",v=v||"",_===v?0:_<v?-1:1}e.compareFileNamesUnicode=I;function c(_,v,P=!1){P||(_=_&&_.toLowerCase(),v=v&&v.toLowerCase());const[w,F]=a(_),[M,K]=a(v);return w!==M?w<M?-1:1:F===K?0:F<K?-1:1}e.noIntlCompareFileNames=c;function f(_,v){const[P,w]=a(_),[F,M]=a(v);let K=k.value.collator.compare(w,M);if(K===0){if(k.value.collatorIsNumeric&&w!==M)return w<M?-1:1;if(K=k.value.collator.compare(P,F),k.value.collatorIsNumeric&&K===0&&P!==F)return P<F?-1:1}return K}e.compareFileExtensions=f;function h(_,v){_=_||"",v=v||"";const P=s(_),w=s(v),F=C.value.collator,M=R.value.collator;return g(M,P,w)||g(F,_,v)}e.compareFileExtensionsDefault=h;function p(_,v){_=_||"",v=v||"";const P=s(_),w=s(v),F=C.value.collator,M=R.value.collator;return g(M,P,w)||i(_,v)||g(F,_,v)}e.compareFileExtensionsUpper=p;function D(_,v){_=_||"",v=v||"";const P=s(_),w=s(v),F=C.value.collator,M=R.value.collator;return g(M,P,w)||r(_,v)||g(F,_,v)}e.compareFileExtensionsLower=D;function A(_,v){_=_||"",v=v||"";const P=s(_).toLowerCase(),w=s(v).toLowerCase();return P!==w?P<w?-1:1:_!==v?_<v?-1:1:0}e.compareFileExtensionsUnicode=A;const E=/^(.*?)(\.([^.]*))?$/;function a(_,v=!1){const P=_?E.exec(_):[];let w=[P&&P[1]||"",P&&P[3]||""];return v&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function s(_){const v=_?E.exec(_):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function g(_,v,P){let w=_.compare(v,P);return w!==0?w:v.length!==P.length?v.length<P.length?-1:1:0}function t(_){const v=_.charAt(0);return v.toLocaleUpperCase()!==v}function u(_){const v=_.charAt(0);return v.toLocaleLowerCase()!==v}function r(_,v){return t(_)&&u(v)?-1:u(_)&&t(v)?1:0}function i(_,v){return u(_)&&t(v)?-1:t(_)&&u(v)?1:0}function o(_,v,P=!1){return P||(_=_&&_.toLowerCase(),v=v&&v.toLowerCase()),_===v?0:_<v?-1:1}function l(_,v,P=!1){const w=_.split(L.sep),F=v.split(L.sep),M=w.length-1,K=F.length-1;let G,N;for(let z=0;;z++){if(G=M===z,N=K===z,G&&N)return S(w[z],F[z],P);if(G)return-1;if(N)return 1;const O=o(w[z],F[z],P);if(O!==0)return O}}e.comparePaths=l;function d(_,v,P){const w=_.toLowerCase(),F=v.toLowerCase(),M=b(_,v,P);if(M)return M;const K=w.endsWith(P),G=F.endsWith(P);if(K!==G)return K?-1:1;const N=S(w,F);return N!==0?N:w.localeCompare(F)}e.compareAnything=d;function b(_,v,P){const w=_.toLowerCase(),F=v.toLowerCase(),M=w.startsWith(P),K=F.startsWith(P);if(M!==K)return M?-1:1;if(M&&K){if(w.length<F.length)return-1;if(w.length>F.length)return 1}return 0}e.compareByPrefix=b}),define(me[101],ge([0,1,100,98,48,8,11,9]),function(J,e,m,L,k,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,T=[y,[]];function n(O,x,B,U){if(!O||!x)return T;const H=O.length,W=x.length;if(H<W)return T;const Q=O.toLowerCase();return I(x,B,W,O,Q,H,U)}e.scoreFuzzy=n;function I(O,x,B,U,H,W,Q){const Y=[],he=[];for(let xe=0;xe<B;xe++){const Ue=xe*W,je=Ue-W,V=xe>0,ee=O[xe],re=x[xe];for(let le=0;le<W;le++){const Z=le>0,oe=Ue+le,ve=oe-1,Me=je+le-1,qe=Z?Y[ve]:0,Qe=V&&Z?Y[Me]:0,Je=V&&Z?he[Me]:0;let Ce;!Qe&&V?Ce=0:Ce=c(ee,re,U,H,le,Je),Ce&&Qe+Ce>=qe&&(Q||V||H.startsWith(x,le))?(he[oe]=Je+1,Y[oe]=Qe+Ce):(he[oe]=y,Y[oe]=qe)}}const _e=[];let Se=B-1,Re=W-1;for(;Se>=0&&Re>=0;){const xe=Se*W+Re;he[xe]===y||(_e.push(Re),Se--),Re--}return[Y[B*W-1],_e.reverse()]}function c(O,x,B,U,H,W){let Q=0;if(!f(x,U[H]))return Q;if(Q+=1,W>0&&(Q+=W*5),O===B[H]&&(Q+=1),H===0)Q+=8;else{const Y=h(B.charCodeAt(H-1));Y?Q+=Y:(0,L.isUpper)(B.charCodeAt(H))&&(Q+=2)}return Q}function f(O,x){return O===x?!0:O==="/"||O==="\\"?x==="/"||x==="\\":!1}function h(O){switch(O){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function D(O,x,B=0,U=0){const H=x;return H.values&&H.values.length>1?A(O,H.values,B,U):E(O,x,B,U)}e.scoreFuzzy2=D;function A(O,x,B,U){let H=0;const W=[];for(const Q of x){const[Y,he]=E(O,Q,B,U);if(typeof Y!="number")return p;H+=Y,W.push(...he)}return[H,b(W)]}function E(O,x,B,U){const H=(0,L.fuzzyScore)(x.original,x.originalLowercase,B,O,O.toLowerCase(),U,!0);return H?[H[0],(0,L.createMatches)(H)]:p}const a=Object.freeze({score:0}),s=1<<18,g=1<<17,t=1<<16;function u(O,x,B,U){const H=U.values?U.values:[U];return(0,k.hash)({[U.normalized]:{values:H.map(Q=>({value:Q.normalized,expectContiguousMatch:Q.expectContiguousMatch})),label:O,description:x,allowNonContiguousMatches:B}})}function r(O,x,B,U,H){if(!O||!x.normalized)return a;const W=U.getItemLabel(O);if(!W)return a;const Q=U.getItemDescription(O),Y=u(W,Q,B,x),he=H[Y];if(he)return he;const _e=i(W,Q,U.getItemPath(O),x,B);return H[Y]=_e,_e}e.scoreItemFuzzy=r;function i(O,x,B,U,H){const W=!B||!U.containsPathSeparator;return B&&(R.isLinux?U.pathNormalized===B:(0,S.equalsIgnoreCase)(U.pathNormalized,B))?{score:s,labelMatch:[{start:0,end:O.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:U.values&&U.values.length>1?o(O,x,B,U.values,W,H):l(O,x,B,U,W,H)}function o(O,x,B,U,H,W){let Q=0;const Y=[],he=[];for(const _e of U){const{score:Se,labelMatch:Re,descriptionMatch:xe}=l(O,x,B,_e,H,W);if(Se===y)return a;Q+=Se,Re&&Y.push(...Re),xe&&he.push(...xe)}return{score:Q,labelMatch:b(Y),descriptionMatch:b(he)}}function l(O,x,B,U,H,W){if(H||!x){const[Q,Y]=n(O,U.normalized,U.normalizedLowercase,W&&!U.expectContiguousMatch);if(Q){const he=(0,L.matchesPrefix)(U.normalized,O);let _e;return he?(_e=g,_e+=Math.round(U.normalized.length/O.length*100)):_e=t,{score:_e+Q,labelMatch:he||d(Y)}}}if(x){let Q=x;B&&(Q=`${x}${C.sep}`);const Y=Q.length,he=`${Q}${O}`,[_e,Se]=n(he,U.normalized,U.normalizedLowercase,W&&!U.expectContiguousMatch);if(_e){const Re=d(Se),xe=[],Ue=[];return Re.forEach(je=>{je.start<Y&&je.end>Y?(xe.push({start:0,end:je.end-Y}),Ue.push({start:je.start,end:Y})):je.start>=Y?xe.push({start:je.start-Y,end:je.end-Y}):Ue.push(je)}),{score:_e,labelMatch:xe,descriptionMatch:Ue}}}return a}function d(O){const x=[];if(!O)return x;let B;for(const U of O)B&&B.end===U?B.end+=1:(B={start:U,end:U+1},x.push(B));return x}function b(O){const x=O.sort((H,W)=>H.start-W.start),B=[];let U;for(const H of x)!U||!_(U,H)?(U=H,B.push(H)):(U.start=Math.min(U.start,H.start),U.end=Math.max(U.end,H.end));return B}function _(O,x){return!(O.end<x.start||x.end<O.start)}function v(O,x,B,U,H,W){const Q=r(O,B,U,H,W),Y=r(x,B,U,H,W),he=Q.score,_e=Y.score;if((he===s||_e===s)&&he!==_e)return he===s?-1:1;if(he>t||_e>t){if(he!==_e)return he>_e?-1:1;if(he<g&&_e<g){const ee=w(Q.labelMatch,Y.labelMatch);if(ee!==0)return ee}const je=H.getItemLabel(O)||"",V=H.getItemLabel(x)||"";if(je.length!==V.length)return je.length-V.length}if(he!==_e)return he>_e?-1:1;const Se=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0,Re=Array.isArray(Y.labelMatch)&&Y.labelMatch.length>0;if(Se&&!Re)return-1;if(Re&&!Se)return 1;const xe=P(O,Q,H),Ue=P(x,Y,H);return xe&&Ue&&xe!==Ue?Ue>xe?-1:1:F(O,x,B,H)}e.compareItemsByFuzzyScore=v;function P(O,x,B){let U=-1,H=-1;if(x.descriptionMatch&&x.descriptionMatch.length?U=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(U=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(H=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const W=B.getItemDescription(O);W&&(H+=W.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(H=x.descriptionMatch[x.descriptionMatch.length-1].end);return H-U}function w(O,x){if(!O&&!x||(!O||!O.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!O||!O.length)return 1;const B=O[0].start,H=O[O.length-1].end-B,W=x[0].start,Y=x[x.length-1].end-W;return H===Y?0:Y<H?1:-1}function F(O,x,B,U){const H=U.getItemLabel(O)||"",W=U.getItemLabel(x)||"",Q=U.getItemDescription(O),Y=U.getItemDescription(x),he=H.length+(Q?Q.length:0),_e=W.length+(Y?Y.length:0);if(he!==_e)return he-_e;const Se=U.getItemPath(O),Re=U.getItemPath(x);return Se&&Re&&Se.length!==Re.length?Se.length-Re.length:H!==W?(0,m.compareAnything)(H,W,B.normalized):Q&&Y&&Q!==Y?(0,m.compareAnything)(Q,Y,B.normalized):Se&&Re&&Se!==Re?(0,m.compareAnything)(Se,Re,B.normalized):0}function M(O){return O.startsWith('"')&&O.endsWith('"')}const K=" ";function G(O){typeof O!="string"&&(O="");const x=O.toLowerCase(),{pathNormalized:B,normalized:U,normalizedLowercase:H}=N(O),W=B.indexOf(C.sep)>=0,Q=M(O);let Y;const he=O.split(K);if(he.length>1)for(const _e of he){const Se=M(_e),{pathNormalized:Re,normalized:xe,normalizedLowercase:Ue}=N(_e);xe&&(Y||(Y=[]),Y.push({original:_e,originalLowercase:_e.toLowerCase(),pathNormalized:Re,normalized:xe,normalizedLowercase:Ue,expectContiguousMatch:Se}))}return{original:O,originalLowercase:x,pathNormalized:B,normalized:U,normalizedLowercase:H,values:Y,containsPathSeparator:W,expectContiguousMatch:Q}}e.prepareQuery=G;function N(O){let x;R.isWindows?x=O.replace(/\//g,C.sep):x=O.replace(/\\/g,C.sep);const B=(0,S.stripWildcards)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:B,normalizedLowercase:B.toLowerCase()}}function z(O){return Array.isArray(O)?G(O.map(x=>x.original).join(K)):G(O.original)}e.pieceToQuery=z}),define(me[30],ge([0,1,18,29,24,8,9]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S;const y="**",T="/",n="[/\\\\]",I="[^/\\\\]",c=/\//g;function f(U){switch(U){case 0:return"";case 1:return`${I}*?`;default:return`(?:${n}|${I}+${n}|${n}${I}+)*?`}}function h(U,H){if(!U)return[];const W=[];let Q=!1,Y=!1,he="";for(const _e of U){switch(_e){case H:if(!Q&&!Y){W.push(he),he="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}he+=_e}return he&&W.push(he),W}e.splitGlobAware=h;function p(U){if(!U)return"";let H="";const W=h(U,T);if(W.every(Q=>Q===y))H=".*";else{let Q=!1;W.forEach((Y,he)=>{if(Y===y){Q||(H+=f(2),Q=!0);return}let _e=!1,Se="",Re=!1,xe="";for(const Ue of Y){if(Ue!=="}"&&_e){Se+=Ue;continue}if(Re&&(Ue!=="]"||!xe)){let je;Ue==="-"?je=Ue:(Ue==="^"||Ue==="!")&&!xe?je="^":Ue===T?je="":je=R.escapeRegExpCharacters(Ue),xe+=je;continue}switch(Ue){case"{":_e=!0;continue;case"[":Re=!0;continue;case"}":H+=`(?:${h(Se,",").map(ee=>p(ee)).join("|")})`,_e=!1,Se="";break;case"]":H+="["+xe+"]",Re=!1,xe="";break;case"?":H+=I;continue;case"*":H+=f(1);continue;default:H+=R.escapeRegExpCharacters(Ue)}}he<W.length-1&&(W[he+1]!==y||he+2<W.length)&&(H+=n),Q=!1})}return H}const D=/^\*\*\/\*\.[\w\.-]+$/,A=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,a=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new k.LRUCache(1e4),u=function(){return!1},r=function(){return null};function i(U,H){if(!U)return r;let W;typeof U!="string"?W=U.pattern:W=U,W=W.trim();const Q=`${W}_${!!H.trimForExclusions}`;let Y=t.get(Q);if(Y)return o(Y,U);let he;if(D.test(W)){const _e=W.substr(4);Y=function(Se,Re){return typeof Se=="string"&&Se.endsWith(_e)?W:null}}else(he=A.exec(l(W,H)))?Y=d(he[1],W):(H.trimForExclusions?a:E).test(W)?Y=b(W,H):(he=s.exec(l(W,H)))?Y=_(he[1].substr(1),W,!0):(he=g.exec(l(W,H)))?Y=_(he[1],W,!1):Y=v(W);return t.set(Q,Y),o(Y,U)}function o(U,H){return typeof H=="string"?U:function(W,Q){return L.isEqualOrParent(W,H.base)?U(C.relative(H.base,W),Q):null}}function l(U,H){return H.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function d(U,H){const W=`/${U}`,Q=`\\${U}`,Y=function(_e,Se){return typeof _e!="string"?null:Se?Se===U?H:null:_e===U||_e.endsWith(W)||_e.endsWith(Q)?H:null},he=[U];return Y.basenames=he,Y.patterns=[H],Y.allBasenames=he,Y}function b(U,H){const W=B(U.slice(1,-1).split(",").map(Se=>i(Se,H)).filter(Se=>Se!==r),U),Q=W.length;if(!Q)return r;if(Q===1)return W[0];const Y=function(Se,Re){for(let xe=0,Ue=W.length;xe<Ue;xe++)if(W[xe](Se,Re))return U;return null},he=W.find(Se=>!!Se.allBasenames);he&&(Y.allBasenames=he.allBasenames);const _e=W.reduce((Se,Re)=>Re.allPaths?Se.concat(Re.allPaths):Se,[]);return _e.length&&(Y.allPaths=_e),Y}function _(U,H,W){const Q=C.sep===C.posix.sep,Y=Q?U:U.replace(c,C.sep),he=C.sep+Y,_e=C.posix.sep+U,Se=W?function(Re,xe){return typeof Re=="string"&&(Re===Y||Re.endsWith(he)||!Q&&(Re===U||Re.endsWith(_e)))?H:null}:function(Re,xe){return typeof Re=="string"&&(Re===Y||!Q&&Re===U)?H:null};return Se.allPaths=[(W?"*/":"./")+U],Se}function v(U){try{const H=new RegExp(`^${p(U)}$`);return function(W){return H.lastIndex=0,typeof W=="string"&&H.test(W)?U:null}}catch(H){return r}}function P(U,H,W){return!U||typeof H!="string"?!1:w(U)(H,void 0,W)}e.match=P;function w(U,H={}){if(!U)return u;if(typeof U=="string"||G(U)){const W=i(U,H);if(W===r)return u;const Q=function(Y,he){return!!W(Y,he)};return W.allBasenames&&(Q.allBasenames=W.allBasenames),W.allPaths&&(Q.allPaths=W.allPaths),Q}return O(U,H)}e.parse=w;function F(U){if(!U)return;let H;return W=>(H||(H=(U()||Promise.resolve([])).then(Q=>Q?K(Q):{})),H.then(Q=>!!Q[W]))}e.hasSiblingPromiseFn=F;function M(U){if(!U)return;let H;return W=>{if(!H){const Q=U();H=Q?K(Q):{}}return!!H[W]}}e.hasSiblingFn=M;function K(U){const H={};for(const W of U)H[W]=!0;return H}function G(U){const H=U;return H&&typeof H.base=="string"&&typeof H.pattern=="string"}e.isRelativePattern=G;function N(U){return U.allBasenames||[]}e.getBasenameTerms=N;function z(U){return U.allPaths||[]}e.getPathTerms=z;function O(U,H){const W=B(Object.getOwnPropertyNames(U).map(Se=>x(Se,U[Se],H)).filter(Se=>Se!==r)),Q=W.length;if(!Q)return r;if(!W.some(Se=>!!Se.requiresSiblings)){if(Q===1)return W[0];const Se=function(Ue,je){for(let V=0,ee=W.length;V<ee;V++){const re=W[V](Ue,je);if(re)return re}return null},Re=W.find(Ue=>!!Ue.allBasenames);Re&&(Se.allBasenames=Re.allBasenames);const xe=W.reduce((Ue,je)=>je.allPaths?Ue.concat(je.allPaths):Ue,[]);return xe.length&&(Se.allPaths=xe),Se}const Y=function(Se,Re,xe){let Ue;for(let je=0,V=W.length;je<V;je++){const ee=W[je];ee.requiresSiblings&&xe&&(Re||(Re=C.basename(Se)),Ue||(Ue=Re.substr(0,Re.length-C.extname(Se).length)));const re=ee(Se,Re,Ue,xe);if(re)return re}return null},he=W.find(Se=>!!Se.allBasenames);he&&(Y.allBasenames=he.allBasenames);const _e=W.reduce((Se,Re)=>Re.allPaths?Se.concat(Re.allPaths):Se,[]);return _e.length&&(Y.allPaths=_e),Y}function x(U,H,W){if(H===!1)return r;const Q=i(U,W);if(Q===r)return r;if(typeof H=="boolean")return Q;if(H){const Y=H.when;if(typeof Y=="string"){const he=(_e,Se,Re,xe)=>{if(!xe||!Q(_e,Se))return null;const Ue=Y.replace("$(basename)",Re),je=xe(Ue);return(0,m.isThenable)(je)?je.then(V=>V?U:null):je?U:null};return he.requiresSiblings=!0,he}}return Q}function B(U,H){const W=U.filter(Se=>!!Se.basenames);if(W.length<2)return U;const Q=W.reduce((Se,Re)=>{const xe=Re.basenames;return xe?Se.concat(xe):Se},[]);let Y;if(H){Y=[];for(let Se=0,Re=Q.length;Se<Re;Se++)Y.push(H)}else Y=W.reduce((Se,Re)=>{const xe=Re.patterns;return xe?Se.concat(xe):Se},[]);const he=function(Se,Re){if(typeof Se!="string")return null;if(!Re){let Ue;for(Ue=Se.length;Ue>0;Ue--){const je=Se.charCodeAt(Ue-1);if(je===47||je===92)break}Re=Se.substr(Ue)}const xe=Q.indexOf(Re);return xe!==-1?Y[xe]:null};he.basenames=Q,he.patterns=Y,he.allBasenames=Q;const _e=U.filter(Se=>!Se.basenames);return _e.push(he),_e}}),define(me[79],ge([0,1,29,10,8,11,23,9,2]),function(J,e,m,L,k,C,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(i,o,l){if(typeof i=="string"&&(i=y.URI.file(i)),l){const b=l.getWorkspaceFolder(i);if(b){const _=l.getWorkspace().folders.length>1;let v;if((0,R.isEqual)(b.uri,i)?v="":v=(0,R.relativePath)(b.uri,i),_){const P=b.name?b.name:(0,R.basename)(b.uri);v=v?P+" \u2022 "+v:P}return v}}if(i.scheme!==L.Schemas.file&&i.scheme!==L.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(i.fsPath))return(0,k.normalize)(I(i.fsPath));let d=(0,k.normalize)(i.fsPath);return!C.isWindows&&o?.userHome&&(d=f(d,o.userHome.fsPath)),d}e.getPathLabel=T;function n(i){if(!i)return;typeof i=="string"&&(i=y.URI.file(i));const o=(0,R.basename)(i)||(i.scheme===L.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,m.isRootOrDriveLetter)(o)?I(o):o}e.getBaseLabel=n;function I(i){return(0,m.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=I;let c=Object.create(null);function f(i,o){if(C.isWindows||!i||!o)return i;let l=c.original===o?c.normalized:void 0;return l||(l=`${(0,S.rtrim)(o,k.posix.sep)}${k.posix.sep}`,c={original:o,normalized:l}),(C.isLinux?i.startsWith(l):(0,S.startsWithIgnoreCase)(i,l))&&(i=`~/${i.substr(l.length)}`),i}e.tildify=f;function h(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=h;const p="\u2026",D="\\\\",A="~";function E(i,o=k.sep){const l=new Array(i.length);let d=!1;for(let b=0;b<i.length;b++){let _=i[b];if(_===""){l[b]=`.${o}`;continue}if(!_){l[b]=_;continue}d=!0;let v="";_.indexOf(D)===0?(v=_.substr(0,_.indexOf(D)+D.length),_=_.substr(_.indexOf(D)+D.length)):_.indexOf(o)===0?(v=_.substr(0,_.indexOf(o)+o.length),_=_.substr(_.indexOf(o)+o.length)):_.indexOf(A)===0&&(v=_.substr(0,_.indexOf(A)+A.length),_=_.substr(_.indexOf(A)+A.length));const P=_.split(o);for(let w=1;d&&w<=P.length;w++)for(let F=P.length-w;d&&F>=0;F--){d=!1;let M=P.slice(F,F+w).join(o);for(let K=0;!d&&K<i.length;K++)if(K!==b&&i[K]&&i[K].indexOf(M)>-1){const G=F+w===P.length,N=F>0&&i[K].indexOf(o)>-1?o+M:M,z=i[K].endsWith(N);d=!G||z}if(!d){let K="";(P[0].endsWith(":")||v!=="")&&(F===1&&(F=0,w++,M=P[0]+o+M),F>0&&(K=P[0]+o),K=v+K),F>0&&(K=K+p+o),K=K+M,F+w<P.length&&(K=K+o+p),l[b]=K}}d&&(l[b]=_)}return l}e.shorten=E;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function s(i,o=Object.create(null)){const l=[];let d=!1,b="";for(const _ of i)if(_==="$"||d&&_==="{")b&&l.push({value:b,type:a.TEXT}),b="",d=!0;else if(_==="}"&&d){const v=o[b];if(typeof v=="string")v.length&&l.push({value:v,type:a.VARIABLE});else if(v){const P=l[l.length-1];(!P||P.type!==a.SEPARATOR)&&l.push({value:v.label,type:a.SEPARATOR})}b="",d=!1}else b+=_;return b&&!d&&l.push({value:b,type:a.TEXT}),l.filter((_,v)=>{if(_.type===a.SEPARATOR){const P=l[v-1],w=l[v+1];return[P,w].every(F=>F&&(F.type===a.VARIABLE||F.type===a.TEXT)&&F.value.length>0)}return!0}).map(_=>_.value).join("")}e.template=s;function g(i,o){return C.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function t(i,o){return C.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function u(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=u;function r(i){const o=i.indexOf("/")!==-1?k.posix:k.win32,l=o.basename(i),d=o.dirname(i);return l.length?{name:l,parentPath:d}:{name:d,parentPath:""}}e.splitName=r}),define(me[102],ge([0,1,30,10,8,23,9]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var S;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(S=e.Mimes||(e.Mimes={}));let y=[],T=[],n=[];function I(i,o=!1){const l=c(i);y.push(l),l.userConfigured?n.push(l):T.push(l),o&&!l.userConfigured&&y.forEach(d=>{d.mime===l.mime||d.userConfigured||(l.extension&&d.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&d.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&d.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&d.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=I;function c(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,m.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(k.posix.sep)>=0:!1}}function f(i){i?(y=y.filter(o=>!o.userConfigured),n=[]):(y=[],T=[],n=[])}e.clearTextMimes=f;function h(i,o){let l;if(i)switch(i.scheme){case L.Schemas.file:l=i.fsPath;break;case L.Schemas.data:l=C.DataUri.parseMetaData(i).get(C.DataUri.META_DATA_LABEL);break;default:l=i.path}if(!l)return[S.unknown];l=l.toLowerCase();const d=(0,k.basename)(l),b=p(l,d,n);if(b)return[b,S.text];const _=p(l,d,T);if(_)return[_,S.text];if(o){const v=D(o);if(v)return[v,S.text]}return[S.unknown]}e.guessMimeTypes=h;function p(i,o,l){let d=null,b=null,_=null;for(let v=l.length-1;v>=0;v--){const P=l[v];if(o===P.filenameLowercase){d=P;break}if(P.filepattern&&(!b||P.filepattern.length>b.filepattern.length)){const w=P.filepatternOnPath?i:o;P.filepatternLowercase?.(w)&&(b=P)}P.extension&&(!_||P.extension.length>_.extension.length)&&o.endsWith(P.extensionLowercase)&&(_=P)}return d?d.mime:b?b.mime:_?_.mime:null}function D(i){if((0,R.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let o=y.length-1;o>=0;o--){const l=y[o];if(!l.firstline)continue;const d=i.match(l.firstline);if(d&&d.length>0)return l.mime}return null}function A(i){return i?typeof i=="string"?i===S.binary||i===S.text||i===S.unknown:i.length===1&&A(i[0]):!0}e.isUnspecific=A;const E={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},a={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function s(i){const o=(0,k.extname)(i),l=E[o.toLowerCase()];return l!==void 0?l:g(i)}e.getMediaOrTextMime=s;function g(i){const o=(0,k.extname)(i);return a[o.toLowerCase()]}e.getMediaMime=g;function t(i){for(const o in a)if(a[o]===i)return o}e.getExtensionForMimeType=t;const u=/^(.+)\/(.+?)(;.+)?$/;function r(i,o){const l=u.exec(i);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:o?void 0:i}e.normalizeMimeType=r}),define(me[103],ge([0,1,2]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class k{constructor(I){this._uriTransformer=I}transformIncoming(I){const c=this._uriTransformer.transformIncoming(I);return c===I?I:L(m.URI.from(c))}transformOutgoing(I){const c=this._uriTransformer.transformOutgoing(I);return c===I?I:L(m.URI.from(c))}transformOutgoingURI(I){const c=this._uriTransformer.transformOutgoing(I);return c===I?I:m.URI.from(c)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function C(n,I,c){if(!n||c>200)return null;if(typeof n=="object"){if(n instanceof m.URI)return I.transformOutgoing(n);for(let f in n)if(Object.hasOwnProperty.call(n,f)){const h=C(n[f],I,c+1);h!==null&&(n[f]=h)}}return null}function R(n,I){const c=C(n,I,0);return c===null?n:c}e.transformOutgoingURIs=R;function S(n,I,c,f){if(!n||f>200)return null;if(typeof n=="object"){if(n.$mid===1)return c?m.URI.revive(I.transformIncoming(n)):I.transformIncoming(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const p=S(n[h],I,c,f+1);p!==null&&(n[h]=p)}}return null}function y(n,I){const c=S(n,I,!1,0);return c===null?n:c}e.transformIncomingURIs=y;function T(n,I){const c=S(n,I,!0,0);return c===null?n:c}e.transformAndReviveIncomingURIs=T}),define(me[32],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(y){return m.test(y)}e.isUUID=L;const k=new Uint8Array(16),C=[];for(let y=0;y<256;y++)C.push(y.toString(16).padStart(2,"0"));let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(y){for(let T=0;T<y.length;T++)y[T]=Math.floor(Math.random()*256);return y};function S(){R(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let y=0,T="";return T+=C[k[y++]],T+=C[k[y++]],T+=C[k[y++]],T+=C[k[y++]],T+="-",T+=C[k[y++]],T+=C[k[y++]],T+="-",T+=C[k[y++]],T+=C[k[y++]],T+="-",T+=C[k[y++]],T+=C[k[y++]],T+="-",T+=C[k[y++]],T+=C[k[y++]],T+=C[k[y++]],T+=C[k[y++]],T+=C[k[y++]],T+=C[k[y++]],T}e.generateUuid=S}),define(me[143],ge([0,1,104]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(C="utf8"){this.stringDecoder=new m.StringDecoder(C),this.remaining=null}write(C){const R=[],S=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(S.length<1)return R;let y=0,T,n=y;for(;n<S.length;)if(T=S.charCodeAt(n),T===13||T===10){if(R.push(S.substring(y,n)),n++,n<S.length){const I=T;T=S.charCodeAt(n),(I===13&&T===10||I===10&&T===13)&&n++}y=n}else n++;return this.remaining=y<S.length?S.substr(y):null,R}end(){return this.remaining}}e.LineDecoder=L}),define(me[28],ge([0,1,50,80,291,18,29,78,8,11,23,2,32]),function(J,e,m,L,k,C,R,S,y,T,n,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function h(N,z=f.UNLINK){if((0,R.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return z===f.UNLINK?D(N):p(N)}async function p(N){try{const z=(0,y.join)((0,L.tmpdir)(),(0,c.generateUuid)());try{await e.Promises.rename(N,z)}catch(O){return D(N)}D(z).catch(O=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function D(N){return e.Promises.rmdir(N,{recursive:!0,maxRetries:3})}function A(N){if((0,R.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(N,{recursive:!0})}e.rimrafSync=A;async function E(N,z){return g(await(z?a(N):(0,k.promisify)(m.readdir)(N)))}async function a(N){try{return await(0,k.promisify)(m.readdir)(N,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const z=[],O=await E(N);for(const x of O){let B=!1,U=!1,H=!1;try{const W=await e.Promises.lstat((0,y.join)(N,x));B=W.isFile(),U=W.isDirectory(),H=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}z.push({name:x,isFile:()=>B,isDirectory:()=>U,isSymbolicLink:()=>H})}return z}function s(N){return g(m.readdirSync(N))}e.readdirSync=s;function g(N){return N.map(z=>typeof z=="string"?T.isMacintosh?(0,S.normalizeNFC)(z):z:(z.name=T.isMacintosh?(0,S.normalizeNFC)(z.name):z.name,z))}async function t(N){const z=await E(N),O=[];for(const x of z)await r.existsDirectory((0,y.join)(N,x))&&O.push(x);return O}function u(N,z=1e3){return new Promise(O=>{let x=!1;const B=setInterval(()=>{x||(x=!0,m.access(N,U=>{x=!1,U&&(clearInterval(B),O(void 0))}))},z)})}e.whenDeleted=u;var r;(function(N){async function z(B){let U;try{if(U=await e.Promises.lstat(B),!U.isSymbolicLink())return{stat:U}}catch(H){}try{return{stat:await e.Promises.stat(B),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(T.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw W}throw H}}N.stat=z;async function O(B){try{const{stat:U,symbolicLink:H}=await N.stat(B);return U.isFile()&&H?.dangling!==!0}catch(U){}return!1}N.existsFile=O;async function x(B){try{const{stat:U,symbolicLink:H}=await N.stat(B);return U.isDirectory()&&H?.dangling!==!0}catch(U){}return!1}N.existsDirectory=x})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new C.ResourceQueue;function o(N,z,O){return i.queueFor(I.URI.file(N),n.extUriBiasedIgnorePathCase).queue(()=>{const x=_(O);return new Promise((B,U)=>d(N,z,x,H=>H?U(H):B()))})}let l=!0;function d(N,z,O,x){if(!l)return m.writeFile(N,z,{mode:O.mode,flag:O.flag},x);m.open(N,O.flag,O.mode,(B,U)=>{if(B)return x(B);m.writeFile(U,z,H=>{if(H)return m.close(U,()=>x(H));m.fdatasync(U,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),l=!1),m.close(U,Q=>x(Q))))})})}function b(N,z,O){const x=_(O);if(!l)return m.writeFileSync(N,z,{mode:x.mode,flag:x.flag});const B=m.openSync(N,x.flag,x.mode);try{m.writeFileSync(B,z);try{m.fdatasyncSync(B)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),l=!1}}finally{m.closeSync(B)}}e.writeFileSync=b;function _(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function v(N,z){if(N===z)return;async function O(x){try{const B=await e.Promises.lstat(x);if(B.isDirectory()||B.isSymbolicLink())return;await e.Promises.utimes(x,B.atime,new Date)}catch(B){}}try{await e.Promises.rename(N,z),await O(z)}catch(x){if(N.toLowerCase()!==z.toLowerCase()&&x.code==="EXDEV"||N.endsWith("."))await P(N,z,{preserveSymlinks:!1}),await h(N,f.MOVE),await O(z);else throw x}}async function P(N,z,O){return F(N,z,{root:{source:N,target:z},options:O,handledSourcePaths:new Set})}const w=511;async function F(N,z,O){if(O.handledSourcePaths.has(N))return;O.handledSourcePaths.add(N);const{stat:x,symbolicLink:B}=await r.stat(N);if(B){if(O.options.preserveSymlinks)try{return await G(N,z,O)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(B.dangling)return}return x.isDirectory()?M(N,z,x.mode&w,O):K(N,z,x.mode&w)}async function M(N,z,O,x){await e.Promises.mkdir(z,{recursive:!0,mode:O});const B=await E(N);for(const U of B)await F((0,y.join)(N,U),(0,y.join)(z,U),x)}async function K(N,z,O){await e.Promises.copyFile(N,z),await e.Promises.chmod(z,O)}async function G(N,z,O){let x=await e.Promises.readlink(N);(0,R.isEqualOrParent)(x,O.root.source,!T.isLinux)&&(x=(0,y.join)(O.root.target,x.substr(O.root.source.length+1))),await e.Promises.symlink(x,z)}e.Promises=new class{get access(){return(0,k.promisify)(m.access)}get stat(){return(0,k.promisify)(m.stat)}get lstat(){return(0,k.promisify)(m.lstat)}get utimes(){return(0,k.promisify)(m.utimes)}get read(){return(0,k.promisify)(m.read)}get readFile(){return(0,k.promisify)(m.readFile)}get write(){return(0,k.promisify)(m.write)}get appendFile(){return(0,k.promisify)(m.appendFile)}get fdatasync(){return(0,k.promisify)(m.fdatasync)}get truncate(){return(0,k.promisify)(m.truncate)}get rename(){return(0,k.promisify)(m.rename)}get copyFile(){return(0,k.promisify)(m.copyFile)}get open(){return(0,k.promisify)(m.open)}get close(){return(0,k.promisify)(m.close)}get symlink(){return(0,k.promisify)(m.symlink)}get readlink(){return(0,k.promisify)(m.readlink)}get chmod(){return(0,k.promisify)(m.chmod)}get mkdir(){return(0,k.promisify)(m.mkdir)}get unlink(){return(0,k.promisify)(m.unlink)}get rmdir(){return(0,k.promisify)(m.rmdir)}get realpath(){return(0,k.promisify)(m.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return E}get readDirsInDir(){return t}get writeFile(){return o}get rm(){return h}get move(){return v}get copy(){return P}}}),define(me[105],ge([0,1,50,8,9,28]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function R(n){const I=(0,L.dirname)(n);if(n===I)return n;const c=((0,L.basename)(n)||n).toLowerCase();try{const h=(0,C.readdirSync)(I).filter(p=>p.toLowerCase()===c);if(h.length===1){const p=R(I);if(p)return(0,L.join)(p,h[0])}else if(h.length>1){const p=h.indexOf(c);if(p>=0){const D=R(I);if(D)return(0,L.join)(D,h[p])}}}catch(f){}return null}e.realcaseSync=R;async function S(n){try{return await C.Promises.realpath(n)}catch(I){const c=T(n);return await C.Promises.access(c,m.constants.R_OK),c}}e.realpath=S;function y(n){try{return m.realpathSync(n)}catch(I){const c=T(n);return m.accessSync(c,m.constants.R_OK),c}}e.realpathSync=y;function T(n){return(0,k.rtrim)((0,L.normalize)(n),L.sep)}});var Ve=this&&this.__decorate||function(J,e,m,L){var k=arguments.length,C=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,m):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(J,e,m,L);else for(var S=J.length-1;S>=0;S--)(R=J[S])&&(C=(k<3?R(C):k>3?R(e,m,C):R(e,m))||C);return k>3&&C&&Object.defineProperty(e,m,C),C};define(me[106],ge([0,1,17,18,22,21,59,16,3,6,61,9,13]),function(J,e,m,L,k,C,R,S,y,T,n,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var f;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(f=e.RequestType||(e.RequestType={}));function h(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function D(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var A;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(A||(A={}));class E{constructor(U){this.buffer=U,this.pos=0}read(U){const H=this.buffer.slice(this.pos,this.pos+U);return this.pos+=H.byteLength,H}}class a{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var s;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(s||(s={}));function g(B){const U=k.VSBuffer.alloc(4);return U.writeUInt32BE(B,0),U}function t(B){return B.read(4).readUInt32BE(0)}function u(B){const U=k.VSBuffer.alloc(1);return U.writeUInt8(B,0),U}const r={Undefined:u(s.Undefined),String:u(s.String),Buffer:u(s.Buffer),VSBuffer:u(s.VSBuffer),Array:u(s.Array),Object:u(s.Object)},i=typeof Buffer!="undefined";function o(B,U){if(typeof U=="undefined")B.write(r.Undefined);else if(typeof U=="string"){const H=k.VSBuffer.fromString(U);B.write(r.String),B.write(g(H.byteLength)),B.write(H)}else if(i&&Buffer.isBuffer(U)){const H=k.VSBuffer.wrap(U);B.write(r.Buffer),B.write(g(H.byteLength)),B.write(H)}else if(U instanceof k.VSBuffer)B.write(r.VSBuffer),B.write(g(U.byteLength)),B.write(U);else if(Array.isArray(U)){B.write(r.Array),B.write(g(U.length));for(const H of U)o(B,H)}else{const H=k.VSBuffer.fromString(JSON.stringify(U));B.write(r.Object),B.write(g(H.byteLength)),B.write(H)}}function l(B){switch(B.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return B.read(t(B)).toString();case s.Buffer:return B.read(t(B)).buffer;case s.VSBuffer:return B.read(t(B));case s.Array:{const H=t(B),W=[];for(let Q=0;Q<H;Q++)W.push(l(B));return W}case s.Object:return JSON.parse(B.read(t(B)).toString())}}class d{constructor(U,H,W=null,Q=1e3){this.protocol=U,this.ctx=H,this.logger=W,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Y=>this.onRawMessage(Y)),this.sendResponse({type:200})}registerChannel(U,H){this.channels.set(U,H),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const H=this.send([U.type]);this.logger&&this.logger.logOutgoing(H,0,1,D(U.type));return}case 201:case 202:case 204:case 203:{const H=this.send([U.type,U.id],U.data);this.logger&&this.logger.logOutgoing(H,U.id,1,D(U.type),U.data);return}}}send(U,H=void 0){const W=new a;return o(W,U),o(W,H),this.sendBuffer(W.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(H){return 0}}onRawMessage(U){const H=new E(U),W=l(H),Q=l(H),Y=W[0];switch(Y){case 100:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${h(Y)}: ${W[2]}.${W[3]}`,Q),this.onPromise({type:Y,id:W[1],channelName:W[2],name:W[3],arg:Q});case 102:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${h(Y)}: ${W[2]}.${W[3]}`,Q),this.onEventListen({type:Y,id:W[1],channelName:W[2],name:W[3],arg:Q});case 101:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${h(Y)}`),this.disposeActiveRequest({type:Y,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${h(Y)}`),this.disposeActiveRequest({type:Y,id:W[1]})}}onPromise(U){const H=this.channels.get(U.channelName);if(!H){this.collectPendingRequest(U);return}const W=new C.CancellationTokenSource;let Q;try{Q=H.call(this.ctx,U.name,U.arg,W.token)}catch(_e){Q=Promise.reject(_e)}const Y=U.id;Q.then(_e=>{this.sendResponse({id:Y,data:_e,type:201}),this.activeRequests.delete(U.id)},_e=>{_e instanceof Error?this.sendResponse({id:Y,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:202}):this.sendResponse({id:Y,data:_e,type:203}),this.activeRequests.delete(U.id)});const he=(0,T.toDisposable)(()=>W.cancel());this.activeRequests.set(U.id,he)}onEventListen(U){const H=this.channels.get(U.channelName);if(!H){this.collectPendingRequest(U);return}const W=U.id,Y=H.listen(this.ctx,U.name,U.arg)(he=>this.sendResponse({id:W,data:he,type:204}));this.activeRequests.set(U.id,Y)}disposeActiveRequest(U){const H=this.activeRequests.get(U.id);H&&(H.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let H=this.pendingRequests.get(U.channelName);H||(H=[],this.pendingRequests.set(U.channelName,H));const W=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);H.push({request:U,timeoutTimer:W})}flushPendingRequests(U){const H=this.pendingRequests.get(U);if(H){for(const W of H)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var b;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class _{constructor(U,H=null){this.protocol=U,this.isDisposed=!1,this.state=A.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=H}getChannel(U){const H=this;return{call(W,Q,Y){return H.isDisposed?Promise.reject(S.canceled()):H.requestPromise(U,W,Q,Y)},listen(W,Q){return H.isDisposed?Promise.reject(S.canceled()):H.requestEvent(U,W,Q)}}}requestPromise(U,H,W,Q=C.CancellationToken.None){const Y=this.lastRequestId++,_e={id:Y,type:100,channelName:U,name:H,arg:W};if(Q.isCancellationRequested)return Promise.reject(S.canceled());let Se;return new Promise((xe,Ue)=>{if(Q.isCancellationRequested)return Ue(S.canceled());const je=()=>{const le=Z=>{switch(Z.type){case 201:this.handlers.delete(Y),xe(Z.data);break;case 202:this.handlers.delete(Y);const oe=new Error(Z.data.message);oe.stack=Z.data.stack,oe.name=Z.data.name,Ue(oe);break;case 203:this.handlers.delete(Y),Ue(Z.data);break}};this.handlers.set(Y,le),this.sendRequest(_e)};let V=null;this.state===A.Idle?je():(V=(0,L.createCancelablePromise)(le=>this.whenInitialized()),V.then(()=>{V=null,je()}));const ee=()=>{V?(V.cancel(),V=null):this.sendRequest({id:Y,type:101}),Ue(S.canceled())},re=Q.onCancellationRequested(ee);Se=(0,T.combinedDisposable)((0,T.toDisposable)(ee),re),this.activeRequests.add(Se)}).finally(()=>{this.activeRequests.delete(Se)})}requestEvent(U,H,W){const Q=this.lastRequestId++,he={id:Q,type:102,channelName:U,name:H,arg:W};let _e=null;const Se=new y.Emitter({onFirstListenerAdd:()=>{_e=(0,L.createCancelablePromise)(xe=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(Se),this.sendRequest(he)})},onLastListenerRemove:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(Se),this.sendRequest({id:Q,type:103}))}}),Re=xe=>Se.fire(xe.data);return this.handlers.set(Q,Re),Se.event}sendRequest(U){switch(U.type){case 100:case 102:{const H=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger&&this.logger.logOutgoing(H,U.id,0,`${h(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const H=this.send([U.type,U.id]);this.logger&&this.logger.logOutgoing(H,U.id,0,h(U.type));return}}}send(U,H=void 0){const W=new a;return o(W,U),o(W,H),this.sendBuffer(W.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(H){return 0}}onBuffer(U){const H=new E(U),W=l(H),Q=l(H),Y=W[0];switch(Y){case 200:return this.logger&&this.logger.logIncoming(U.byteLength,0,0,D(Y)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],0,D(Y),Q),this.onResponse({type:W[0],id:W[1],data:Q})}}onResponse(U){if(U.type===200){this.state=A.Idle,this._onDidInitialize.fire();return}const H=this.handlers.get(U.id);H&&H(U)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===A.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}Ve([R.memoize],_.prototype,"onDidInitializePromise",null),e.ChannelClient=_;class v{constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:H,onDidClientDisconnect:W})=>{y.Event.once(H.onMessage)(Y=>{const he=new E(Y),_e=l(he),Se=new d(H,_e),Re=new _(H);this.channels.forEach((Ue,je)=>Se.registerChannel(je,Ue));const xe={channelServer:Se,channelClient:Re,ctx:_e};this._connections.add(xe),this._onDidAddConnection.fire(xe),W(()=>{Se.dispose(),Re.dispose(),this._connections.delete(xe),this._onDidRemoveConnection.fire(xe)})})})}get connections(){const U=[];return this._connections.forEach(H=>U.push(H)),U}getChannel(U,H){const W=this;return{call(Q,Y,he){let _e;if((0,c.isFunction)(H)){let Re=(0,m.getRandomElement)(W.connections.filter(H));_e=Re?Promise.resolve(Re):y.Event.toPromise(y.Event.filter(W.onDidAddConnection,H))}else _e=H.routeCall(W,Q,Y);const Se=_e.then(Re=>Re.channelClient.getChannel(U));return w(Se).call(Q,Y,he)},listen(Q,Y){if((0,c.isFunction)(H))return W.getMulticastEvent(U,H,Q,Y);const he=H.routeEvent(W,Q,Y).then(_e=>_e.channelClient.getChannel(U));return w(he).listen(Q,Y)}}}getMulticastEvent(U,H,W,Q){const Y=this;let he=new T.DisposableStore;const _e=new y.Emitter({onFirstListenerAdd:()=>{he=new T.DisposableStore;const Se=new y.EventMultiplexer,Re=new Map,xe=je=>{const ee=je.channelClient.getChannel(U).listen(W,Q),re=Se.add(ee);Re.set(je,re)},Ue=je=>{const V=Re.get(je);!V||(V.dispose(),Re.delete(je))};Y.connections.filter(H).forEach(xe),y.Event.filter(Y.onDidAddConnection,H)(xe,void 0,he),Y.onDidRemoveConnection(Ue,void 0,he),Se.event(_e.fire,_e,he),he.add(Se)},onLastListenerRemove:()=>{he.dispose()}});return _e.event}registerChannel(U,H){this.channels.set(U,H),this._connections.forEach(W=>{W.channelServer.registerChannel(U,H)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=v;class P{constructor(U,H,W=null){const Q=new a;o(Q,H),U.send(Q.buffer),this.channelClient=new _(U,W),this.channelServer=new d(U,H,W)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,H){this.channelServer.registerChannel(U,H)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=P;function w(B){return{call(U,H,W){return B.then(Q=>Q.call(U,H,W))},listen(U,H){const W=new y.Relay;return B.then(Q=>W.input=Q.listen(U,H)),W.event}}}e.getDelayedChannel=w;function F(B){let U=!1;return{call(H,W,Q){return U?B.call(H,W,Q):(0,L.timeout)(0).then(()=>U=!0).then(()=>B.call(H,W,Q))},listen(H,W){if(U)return B.listen(H,W);const Q=new y.Relay;return(0,L.timeout)(0).then(()=>U=!0).then(()=>Q.input=B.listen(H,W)),Q.event}}}e.getNextTickChannel=F;class M{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const H of U.connections)if(await Promise.resolve(this.fn(H.ctx)))return Promise.resolve(H);return await y.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=M;var K;(function(B){function U(Q,Y){const he=Q,_e=Y&&Y.disableMarshalling,Se=new Map;for(const Re in he)W(Re)&&Se.set(Re,y.Event.buffer(he[Re],!0));return new class{listen(Re,xe){const Ue=Se.get(xe);if(Ue)return Ue;throw new Error(`Event not found: ${xe}`)}call(Re,xe,Ue){const je=he[xe];if(typeof je=="function"){if(!_e&&Array.isArray(Ue))for(let V=0;V<Ue.length;V++)Ue[V]=(0,n.revive)(Ue[V]);return je.apply(he,Ue)}throw new Error(`Method not found: ${xe}`)}}}B.fromService=U;function H(Q,Y){const he=Y&&Y.disableMarshalling;return new Proxy({},{get(_e,Se){if(typeof Se=="string")return Y?.properties?.has(Se)?Y.properties.get(Se):W(Se)?Q.listen(Se):async function(...Re){let xe;Y&&!(0,c.isUndefinedOrNull)(Y.context)?xe=[Y.context,...Re]:xe=Re;const Ue=await Q.call(Se,xe);return he?Ue:(0,n.revive)(Ue)};throw new Error(`Property not found: ${String(Se)}`)}})}B.toService=H;function W(Q){return Q[0]==="o"&&Q[1]==="n"&&I.isUpperAsciiLetter(Q.charCodeAt(2))}})(K=e.ProxyChannel||(e.ProxyChannel={}));const G=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let U=B.toString();if(U!=="[object Object]")return U}return B}function z(B){return Array.isArray(B)?B.map(N):N(B)}function O(B,U,H,W,Q,Y,he){he=z(he);const _e=G[Q],Se=_e[W%_e.length];let Re=[`%c[${B}]%c[${String(U).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${Se}`];/\($/.test(Y)?(Re=Re.concat(he),Re.push(")")):Re.push(he),console.log.apply(console,Re)}e.logWithColors=O;class x{constructor(U,H){this._outgoingPrefix=U,this._incomingPrefix=H,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,H,W,Q,Y){this._totalOutgoing+=U,O(this._outgoingPrefix,this._totalOutgoing,U,H,W,Q,Y)}logIncoming(U,H,W,Q,Y){this._totalIncoming+=U,O(this._incomingPrefix,this._totalIncoming,U,H,W,Q,Y)}}e.IPCLogger=x}),define(me[107],ge([0,1,22,3,6,11,38,106]),function(J,e,m,L,k,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var y;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let T=null;function n(){return T||(T=m.VSBuffer.alloc(0)),T}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,o){if(i===0)return n();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const _=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=i),_}if(this._chunks[0].byteLength>i){const _=this._chunks[0].slice(0,i);return o&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),_}let l=m.VSBuffer.alloc(i),d=0,b=0;for(;i>0;){const _=this._chunks[b];if(_.byteLength>i){const v=_.slice(0,i);l.set(v,d),d+=i,o&&(this._chunks[b]=_.slice(i),this._totalLength-=i),i-=i}else l.set(_,d),d+=_.byteLength,o?(this._chunks.shift(),this._totalLength-=_.byteLength):b++,i-=_.byteLength}return l}}e.ChunkStream=I;var c;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(c||(c={}));var f;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(i,o,l,d){this.type=i,this.id=o,this.ack=l,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends k.Disposable{constructor(i){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5);else{const l=this._state.messageType,d=this._state.id,b=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(l,d,b,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class D{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=m.VSBuffer.alloc(13);o.writeUInt8(i.type,0),o.writeUInt32BE(i.id,1),o.writeUInt32BE(i.ack,5),o.writeUInt32BE(i.data.byteLength,9),this._writeSoon(o,i.data)}_bufferAdd(i,o){const l=this._totalLength===0;return this._data.push(i,o),this._totalLength+=i.byteLength+o.byteLength,l}_bufferTake(){const i=m.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,o){this._bufferAdd(i,o)&&C.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class A extends k.Disposable{constructor(i){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new D(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new h(1,0,0,i))}}e.Protocol=A;class E extends S.IPCClient{constructor(i,o,l=null){super(i,o,l);this.protocol=i}static fromSocket(i,o){return new E(new A(i),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=E;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,R.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class s{constructor(i){this.data=i,this.next=null}}class g{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],o=0,l=this._first;for(;l;)i[o++]=l.data,l=l.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const o=new s(i);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class t{constructor(){this.lastRuns=[];const i=Date.now();for(let o=0;o<t._HISTORY_LENGTH;o++)this.lastRuns[o]=i-1e3*o;setInterval(()=>{for(let o=t._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const i=Date.now(),o=(1+t._HISTORY_LENGTH)*1e3;let l=0;for(let d=0;d<t._HISTORY_LENGTH;d++)i-this.lastRuns[d]<=o&&l++;return 1-l/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class u{constructor(i,o=null,l=t.getInstance()){this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new g,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),o&&this._socketReader.acceptChunk(o),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new h(5,0,0,n());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const o=new h(4,0,0,n());this._socketWriter.write(o),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,o){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let o=0,l=i.length;o<l;o++)this._socketWriter.write(i[o]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new h(6,0,0,n())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const o=this._outgoingUnackMsg.toArray();for(let l=0,d=o.length;l<d;l++)this._socketWriter.write(o[l]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new h(1,o,this._incomingAckId,i);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(i){const o=new h(2,0,0,i);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),o=Date.now()-i.writtenTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-o,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new h(3,0,this._incomingAckId,n());this._socketWriter.write(i)}}e.PersistentProtocol=u}),define(me[108],ge([0,1,97]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(S){let y=(0,m.toUint8)(S);this._defaultValue=y,this._asciiMap=L._createAsciiMap(y),this._map=new Map}static _createAsciiMap(S){let y=new Uint8Array(256);for(let T=0;T<256;T++)y[T]=S;return y}set(S,y){let T=(0,m.toUint8)(y);S>=0&&S<256?this._asciiMap[S]=T:this._map.set(S,T)}get(S){return S>=0&&S<256?this._asciiMap[S]:this._map.get(S)||this._defaultValue}}e.CharacterClassifier=L;var k;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(k||(k={}));class C{constructor(){this._actual=new L(0)}add(S){this._actual.set(S,1)}has(S){return this._actual.get(S)===1}}e.CharacterSet=C}),define(me[144],ge([0,1,108]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends m.CharacterClassifier{constructor(S){super(0);for(let y=0,T=S.length;y<T;y++)this.set(S.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function C(R){let S={};return y=>(S.hasOwnProperty(y)||(S[y]=R(y)),S[y])}e.getMapForWordSeparators=C(R=>new k(R))}),define(me[51],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(k,C){this.lineNumber=k,this.column=C}with(k=this.lineNumber,C=this.column){return k===this.lineNumber&&C===this.column?this:new m(k,C)}delta(k=0,C=0){return this.with(this.lineNumber+k,this.column+C)}equals(k){return m.equals(this,k)}static equals(k,C){return!k&&!C?!0:!!k&&!!C&&k.lineNumber===C.lineNumber&&k.column===C.column}isBefore(k){return m.isBefore(this,k)}static isBefore(k,C){return k.lineNumber<C.lineNumber?!0:C.lineNumber<k.lineNumber?!1:k.column<C.column}isBeforeOrEqual(k){return m.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,C){return k.lineNumber<C.lineNumber?!0:C.lineNumber<k.lineNumber?!1:k.column<=C.column}static compare(k,C){let R=k.lineNumber|0,S=C.lineNumber|0;if(R===S){let y=k.column|0,T=C.column|0;return y-T}return R-S}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new m(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=m}),define(me[42],ge([0,1,51]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(C,R,S,y){C>S||C===S&&R>y?(this.startLineNumber=S,this.startColumn=y,this.endLineNumber=C,this.endColumn=R):(this.startLineNumber=C,this.startColumn=R,this.endLineNumber=S,this.endColumn=y)}isEmpty(){return L.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return L.containsPosition(this,C)}static containsPosition(C,R){return!(R.lineNumber<C.startLineNumber||R.lineNumber>C.endLineNumber||R.lineNumber===C.startLineNumber&&R.column<C.startColumn||R.lineNumber===C.endLineNumber&&R.column>C.endColumn)}containsRange(C){return L.containsRange(this,C)}static containsRange(C,R){return!(R.startLineNumber<C.startLineNumber||R.endLineNumber<C.startLineNumber||R.startLineNumber>C.endLineNumber||R.endLineNumber>C.endLineNumber||R.startLineNumber===C.startLineNumber&&R.startColumn<C.startColumn||R.endLineNumber===C.endLineNumber&&R.endColumn>C.endColumn)}strictContainsRange(C){return L.strictContainsRange(this,C)}static strictContainsRange(C,R){return!(R.startLineNumber<C.startLineNumber||R.endLineNumber<C.startLineNumber||R.startLineNumber>C.endLineNumber||R.endLineNumber>C.endLineNumber||R.startLineNumber===C.startLineNumber&&R.startColumn<=C.startColumn||R.endLineNumber===C.endLineNumber&&R.endColumn>=C.endColumn)}plusRange(C){return L.plusRange(this,C)}static plusRange(C,R){let S,y,T,n;return R.startLineNumber<C.startLineNumber?(S=R.startLineNumber,y=R.startColumn):R.startLineNumber===C.startLineNumber?(S=R.startLineNumber,y=Math.min(R.startColumn,C.startColumn)):(S=C.startLineNumber,y=C.startColumn),R.endLineNumber>C.endLineNumber?(T=R.endLineNumber,n=R.endColumn):R.endLineNumber===C.endLineNumber?(T=R.endLineNumber,n=Math.max(R.endColumn,C.endColumn)):(T=C.endLineNumber,n=C.endColumn),new L(S,y,T,n)}intersectRanges(C){return L.intersectRanges(this,C)}static intersectRanges(C,R){let S=C.startLineNumber,y=C.startColumn,T=C.endLineNumber,n=C.endColumn,I=R.startLineNumber,c=R.startColumn,f=R.endLineNumber,h=R.endColumn;return S<I?(S=I,y=c):S===I&&(y=Math.max(y,c)),T>f?(T=f,n=h):T===f&&(n=Math.min(n,h)),S>T||S===T&&y>n?null:new L(S,y,T,n)}equalsRange(C){return L.equalsRange(this,C)}static equalsRange(C,R){return!!C&&!!R&&C.startLineNumber===R.startLineNumber&&C.startColumn===R.startColumn&&C.endLineNumber===R.endLineNumber&&C.endColumn===R.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(C){return new m.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(C){return new m.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,R){return new L(this.startLineNumber,this.startColumn,C,R)}setStartPosition(C,R){return new L(C,R,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(C){return new L(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,R=C){return new L(C.lineNumber,C.column,R.lineNumber,R.column)}static lift(C){return C?new L(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,R){return!(C.endLineNumber<R.startLineNumber||C.endLineNumber===R.startLineNumber&&C.endColumn<R.startColumn||R.endLineNumber<C.startLineNumber||R.endLineNumber===C.startLineNumber&&R.endColumn<C.startColumn)}static areIntersecting(C,R){return!(C.endLineNumber<R.startLineNumber||C.endLineNumber===R.startLineNumber&&C.endColumn<=R.startColumn||R.endLineNumber<C.startLineNumber||R.endLineNumber===C.startLineNumber&&R.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,R){if(C&&R){const T=C.startLineNumber|0,n=R.startLineNumber|0;if(T===n){const I=C.startColumn|0,c=R.startColumn|0;if(I===c){const f=C.endLineNumber|0,h=R.endLineNumber|0;if(f===h){const p=C.endColumn|0,D=R.endColumn|0;return p-D}return f-h}return I-c}return T-n}return(C?1:0)-(R?1:0)}static compareRangesUsingEnds(C,R){return C.endLineNumber===R.endLineNumber?C.endColumn===R.endColumn?C.startLineNumber===R.startLineNumber?C.startColumn-R.startColumn:C.startLineNumber-R.startLineNumber:C.endColumn-R.endColumn:C.endLineNumber-R.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=L}),define(me[145],ge([0,1,51,42]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class C extends L.Range{constructor(S,y,T,n){super(S,y,T,n);this.selectionStartLineNumber=S,this.selectionStartColumn=y,this.positionLineNumber=T,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(S){return C.selectionsEqual(this,S)}static selectionsEqual(S,y){return S.selectionStartLineNumber===y.selectionStartLineNumber&&S.selectionStartColumn===y.selectionStartColumn&&S.positionLineNumber===y.positionLineNumber&&S.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(S,y){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,S,y):new C(S,y,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(S,y){return this.getDirection()===0?new C(S,y,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,S,y)}static fromPositions(S,y=S){return new C(S.lineNumber,S.column,y.lineNumber,y.column)}static liftSelection(S){return new C(S.selectionStartLineNumber,S.selectionStartColumn,S.positionLineNumber,S.positionColumn)}static selectionsArrEqual(S,y){if(S&&!y||!S&&y)return!1;if(!S&&!y)return!0;if(S.length!==y.length)return!1;for(let T=0,n=S.length;T<n;T++)if(!this.selectionsEqual(S[T],y[T]))return!1;return!0}static isISelection(S){return S&&typeof S.selectionStartLineNumber=="number"&&typeof S.selectionStartColumn=="number"&&typeof S.positionLineNumber=="number"&&typeof S.positionColumn=="number"}static createWithDirection(S,y,T,n,I){return I===0?new C(S,y,T,n):new C(T,n,S,y)}}e.Selection=C}),define(me[109],ge([0,1,25]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var R;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(R=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(D){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,D.tabSize|0),this.indentSize=D.tabSize|0,this.insertSpaces=Boolean(D.insertSpaces),this.defaultEOL=D.defaultEOL|0,this.trimAutoWhitespace=Boolean(D.trimAutoWhitespace),this.bracketPairColorizationOptions=D.bracketPairColorizationOptions}equals(D){return this.tabSize===D.tabSize&&this.indentSize===D.indentSize&&this.insertSpaces===D.insertSpaces&&this.defaultEOL===D.defaultEOL&&this.trimAutoWhitespace===D.trimAutoWhitespace&&(0,m.equals)(this.bracketPairColorizationOptions,D.bracketPairColorizationOptions)}createChangeEvent(D){return{tabSize:this.tabSize!==D.tabSize,indentSize:this.indentSize!==D.indentSize,insertSpaces:this.insertSpaces!==D.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==D.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class T{constructor(D,A){this._findMatchBrand=void 0,this.range=D,this.matches=A}}e.FindMatch=T;var n;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var I;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None"})(I=e.PositionAffinity||(e.PositionAffinity={}));var c;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c=e.ModelConstants||(e.ModelConstants={}));class f{constructor(D,A,E,a,s,g){this.identifier=D,this.range=A,this.text=E,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=s,this._isTracked=g}}e.ValidAnnotatedEditOperation=f;class h{constructor(D,A,E){this.reverseEdits=D,this.changes=A,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=h}),define(me[146],ge([0,1,9,144,51,42,109]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const S=999;class y{constructor(a,s,g,t){this.searchString=a,this.isRegex=s,this.matchCase=g,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=T(this.searchString):a=this.searchString.indexOf(`
`)>=0;let s=null;try{s=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch(t){return null}if(!s)return null;let g=!this.isRegex&&!a;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new n(s,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=y;function T(E){if(!E||E.length===0)return!1;for(let a=0,s=E.length;a<s;a++)if(E.charCodeAt(a)===92){if(a++,a>=s)break;const t=E.charCodeAt(a);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=T;class n{constructor(a,s,g){this.regex=a,this.wordSeparators=s,this.simpleSearch=g}}e.SearchData=n;function I(E,a,s){if(!s)return new R.FindMatch(E,null);let g=[];for(let t=0,u=a.length;t<u;t++)g[t]=a[t];return new R.FindMatch(E,g)}e.createFindMatch=I;class c{constructor(a){let s=[],g=0;for(let t=0,u=a.length;t<u;t++)a.charCodeAt(t)===10&&(s[g++]=t);this._lineFeedsOffsets=s}findLineFeedCountBeforeOffset(a){const s=this._lineFeedsOffsets;let g=0,t=s.length-1;if(t===-1||a<=s[0])return 0;for(;g<t;){const u=g+((t-g)/2>>0);s[u]>=a?t=u-1:s[u+1]>=a?(g=u,t=u):g=u+1}return g+1}}class f{static findMatches(a,s,g,t,u){const r=s.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(a,g,new A(r.wordSeparators,r.regex),t,u):this._doFindMatchesLineByLine(a,g,r,t,u):[]}static _getMultilineMatchRange(a,s,g,t,u,r){let i,o=0;t?(o=t.findLineFeedCountBeforeOffset(u),i=s+u+o):i=s+u;let l;if(t){let v=t.findLineFeedCountBeforeOffset(u+r.length)-o;l=i+r.length+v}else l=i+r.length;const d=a.getPositionAt(i),b=a.getPositionAt(l);return new C.Range(d.lineNumber,d.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(a,s,g,t,u){const r=a.getOffsetAt(s.getStartPosition()),i=a.getValueInRange(s,1),o=a.getEOL()===`\r
`?new c(i):null,l=[];let d=0,b;for(g.reset(0);b=g.next(i);)if(l[d++]=I(this._getMultilineMatchRange(a,r,i,o,b.index,b[0]),b,t),d>=u)return l;return l}static _doFindMatchesLineByLine(a,s,g,t,u){const r=[];let i=0;if(s.startLineNumber===s.endLineNumber){const l=a.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return i=this._findMatchesInLine(g,l,s.startLineNumber,s.startColumn-1,i,r,t,u),r}const o=a.getLineContent(s.startLineNumber).substring(s.startColumn-1);i=this._findMatchesInLine(g,o,s.startLineNumber,s.startColumn-1,i,r,t,u);for(let l=s.startLineNumber+1;l<s.endLineNumber&&i<u;l++)i=this._findMatchesInLine(g,a.getLineContent(l),l,0,i,r,t,u);if(i<u){const l=a.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);i=this._findMatchesInLine(g,l,s.endLineNumber,0,i,r,t,u)}return r}static _findMatchesInLine(a,s,g,t,u,r,i,o){const l=a.wordSeparators;if(!i&&a.simpleSearch){const _=a.simpleSearch,v=_.length,P=s.length;let w=-v;for(;(w=s.indexOf(_,w+v))!==-1;)if((!l||D(l,s,P,w,v))&&(r[u++]=new R.FindMatch(new C.Range(g,w+1+t,g,w+1+v+t),null),u>=o))return u;return u}const d=new A(a.wordSeparators,a.regex);let b;d.reset(0);do if(b=d.next(s),b&&(r[u++]=I(new C.Range(g,b.index+1+t,g,b.index+1+b[0].length+t),b,i),u>=o))return u;while(b);return u}static findNextMatch(a,s,g,t){const u=s.parseSearchRequest();if(!u)return null;const r=new A(u.wordSeparators,u.regex);return u.regex.multiline?this._doFindNextMatchMultiline(a,g,r,t):this._doFindNextMatchLineByLine(a,g,r,t)}static _doFindNextMatchMultiline(a,s,g,t){const u=new k.Position(s.lineNumber,1),r=a.getOffsetAt(u),i=a.getLineCount(),o=a.getValueInRange(new C.Range(u.lineNumber,u.column,i,a.getLineMaxColumn(i)),1),l=a.getEOL()===`\r
`?new c(o):null;g.reset(s.column-1);let d=g.next(o);return d?I(this._getMultilineMatchRange(a,r,o,l,d.index,d[0]),d,t):s.lineNumber!==1||s.column!==1?this._doFindNextMatchMultiline(a,new k.Position(1,1),g,t):null}static _doFindNextMatchLineByLine(a,s,g,t){const u=a.getLineCount(),r=s.lineNumber,i=a.getLineContent(r),o=this._findFirstMatchInLine(g,i,r,s.column,t);if(o)return o;for(let l=1;l<=u;l++){const d=(r+l-1)%u,b=a.getLineContent(d+1),_=this._findFirstMatchInLine(g,b,d+1,1,t);if(_)return _}return null}static _findFirstMatchInLine(a,s,g,t,u){a.reset(t-1);const r=a.next(s);return r?I(new C.Range(g,r.index+1,g,r.index+1+r[0].length),r,u):null}static findPreviousMatch(a,s,g,t){const u=s.parseSearchRequest();if(!u)return null;const r=new A(u.wordSeparators,u.regex);return u.regex.multiline?this._doFindPreviousMatchMultiline(a,g,r,t):this._doFindPreviousMatchLineByLine(a,g,r,t)}static _doFindPreviousMatchMultiline(a,s,g,t){const u=this._doFindMatchesMultiline(a,new C.Range(1,1,s.lineNumber,s.column),g,t,10*S);if(u.length>0)return u[u.length-1];const r=a.getLineCount();return s.lineNumber!==r||s.column!==a.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(a,new k.Position(r,a.getLineMaxColumn(r)),g,t):null}static _doFindPreviousMatchLineByLine(a,s,g,t){const u=a.getLineCount(),r=s.lineNumber,i=a.getLineContent(r).substring(0,s.column-1),o=this._findLastMatchInLine(g,i,r,t);if(o)return o;for(let l=1;l<=u;l++){const d=(u+r-l-1)%u,b=a.getLineContent(d+1),_=this._findLastMatchInLine(g,b,d+1,t);if(_)return _}return null}static _findLastMatchInLine(a,s,g,t){let u=null,r;for(a.reset(0);r=a.next(s);)u=I(new C.Range(g,r.index+1,g,r.index+1+r[0].length),r,t);return u}}e.TextModelSearch=f;function h(E,a,s,g,t){if(g===0)return!0;const u=a.charCodeAt(g-1);if(E.get(u)!==0||u===13||u===10)return!0;if(t>0){const r=a.charCodeAt(g);if(E.get(r)!==0)return!0}return!1}function p(E,a,s,g,t){if(g+t===s)return!0;const u=a.charCodeAt(g+t);if(E.get(u)!==0||u===13||u===10)return!0;if(t>0){const r=a.charCodeAt(g+t-1);if(E.get(r)!==0)return!0}return!1}function D(E,a,s,g,t){return h(E,a,s,g,t)&&p(E,a,s,g,t)}e.isValidMatch=D;class A{constructor(a,s){this._wordSeparators=a,this._searchRegex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const s=a.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===s||(g=this._searchRegex.exec(a),!g))return null;const t=g.index,u=g[0].length;if(t===this._prevMatchStartIndex&&u===this._prevMatchLength){if(u===0){m.getNextCodePoint(a,s,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=u,!this._wordSeparators||D(this._wordSeparators,a,s,t,u))return g}while(g);return null}}e.Searcher=A}),define(me[110],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(S=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)S.indexOf(T)>=0||(y+="\\"+T);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=m();function L(S){let y=e.DEFAULT_WORD_REGEXP;if(S&&S instanceof RegExp)if(S.global)y=S;else{let T="g";S.ignoreCase&&(T+="i"),S.multiline&&(T+="m"),S.unicode&&(T+="u"),y=new RegExp(S.source,T)}return y.lastIndex=0,y}e.ensureValidWordDefinition=L;const k={maxLen:1e3,windowSize:15,timeBudget:150};function C(S,y,T,n,I=k){if(T.length>I.maxLen){let D=S-I.maxLen/2;return D<0?D=0:n+=D,T=T.substring(D,S+I.maxLen/2),C(S,y,T,n,I)}const c=Date.now(),f=S-1-n;let h=-1,p=null;for(let D=1;!(Date.now()-c>=I.timeBudget);D++){const A=f-I.windowSize*D;y.lastIndex=Math.max(0,A);const E=R(y,T,f,h);if(!E&&p||(p=E,A<=0))break;h=A}if(p){let D={word:p[0],startColumn:n+1+p.index,endColumn:n+1+p.index+p[0].length};return y.lastIndex=0,D}return null}e.getWordAtText=C;function R(S,y,T,n){let I;for(;I=S.exec(y);){const c=I.index||0;if(c<=T&&S.lastIndex>=T)return I;if(n>0&&c>n)return null}return null}}),define(me[147],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class L{constructor(S){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=S.open,this.close=S.close,this._standardTokenMask=0,Array.isArray(S.notIn))for(let y=0,T=S.notIn.length;y<T;y++)switch(S.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(S){return(this._standardTokenMask&S)==0}}e.StandardAutoClosingPairConditional=L;class k{constructor(S){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of S)C(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),C(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),C(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),C(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&C(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=k;function C(R,S,y){R.has(S)?R.get(S).push(y):R.set(S,[y])}}),define(me[81],ge([0,1,30,8]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(C,R,S,y){if(Array.isArray(C)){let T=0;for(const n of C){const I=k(n,R,S,y);if(I===10)return I;I>T&&(T=I)}return T}else{if(typeof C=="string")return y?C==="*"?5:C===S?10:0:0;if(C){const{language:T,pattern:n,scheme:I,hasAccessToAllModels:c}=C;if(!y&&!c)return 0;let f=0;if(I)if(I===R.scheme)f=10;else if(I==="*")f=5;else return 0;if(T)if(T===S)f=10;else if(T==="*")f=Math.max(f,5);else return 0;if(n){let h;if(typeof n=="string"?h=n:h={...n,base:(0,L.normalize)(n.base)},h===R.fsPath||(0,m.match)(h,R.fsPath))f=10;else return 0}return f}else return 0}}e.score=k}),define(me[148],ge([0,1,108]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class k{constructor(h,p,D){const A=new Uint8Array(h*p);for(let E=0,a=h*p;E<a;E++)A[E]=D;this._data=A,this.rows=h,this.cols=p}get(h,p){return this._data[h*this.cols+p]}set(h,p,D){this._data[h*this.cols+p]=D}}e.Uint8Matrix=k;class C{constructor(h){let p=0,D=0;for(let E=0,a=h.length;E<a;E++){let[s,g,t]=h[E];g>p&&(p=g),s>D&&(D=s),t>D&&(D=t)}p++,D++;let A=new k(D,p,0);for(let E=0,a=h.length;E<a;E++){let[s,g,t]=h[E];A.set(s,g,t)}this._states=A,this._maxCharCode=p}nextState(h,p){return p<0||p>=this._maxCharCode?0:this._states.get(h,p)}}e.StateMachine=C;let R=null;function S(){return R===null&&(R=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var y;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let T=null;function n(){if(T===null){T=new m.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<f.length;p++)T.set(f.charCodeAt(p),1);const h=".,;";for(let p=0;p<h.length;p++)T.set(h.charCodeAt(p),2)}return T}class I{static _createLink(h,p,D,A,E){let a=E-1;do{const s=p.charCodeAt(a);if(h.get(s)!==2)break;a--}while(a>A);if(A>0){const s=p.charCodeAt(A-1),g=p.charCodeAt(a);(s===40&&g===41||s===91&&g===93||s===123&&g===125)&&a--}return{range:{startLineNumber:D,startColumn:A+1,endLineNumber:D,endColumn:a+2},url:p.substring(A,a+1)}}static computeLinks(h,p=S()){const D=n();let A=[];for(let E=1,a=h.getLineCount();E<=a;E++){const s=h.getLineContent(E),g=s.length;let t=0,u=0,r=0,i=1,o=!1,l=!1,d=!1,b=!1;for(;t<g;){let _=!1;const v=s.charCodeAt(t);if(i===13){let P;switch(v){case 40:o=!0,P=0;break;case 41:P=o?0:1;break;case 91:d=!0,l=!0,P=0;break;case 93:d=!1,P=l?0:1;break;case 123:b=!0,P=0;break;case 125:P=b?0:1;break;case 39:P=r===34||r===96?0:1;break;case 34:P=r===39||r===96?0:1;break;case 96:P=r===39||r===34?0:1;break;case 42:P=r===42?1:0;break;case 124:P=r===124?1:0;break;case 32:P=d?0:1;break;default:P=D.get(v)}P===1&&(A.push(I._createLink(D,s,E,u,t)),_=!0)}else if(i===12){let P;v===91?(l=!0,P=0):P=D.get(v),P===1?_=!0:i=13}else i=p.nextState(i,v),i===0&&(_=!0);_&&(i=1,o=!1,l=!1,b=!1,u=t+1,r=v),t++}i===13&&A.push(I._createLink(D,s,E,u,g))}return A}}e.LinkComputer=I;function c(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:I.computeLinks(f)}e.computeLinks=c}),define(me[149],ge([0,1,3,6]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class k{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(R){this._onDidChange.fire({changedLanguages:R,changedColorMap:!1})}register(R,S){return this._map.set(R,S),this.fire([R]),(0,L.toDisposable)(()=>{this._map.get(R)===S&&(this._map.delete(R),this.fire([R]))})}registerPromise(R,S){let y=null,T=!1;return this._promises.set(R,S.then(n=>{this._promises.delete(R),!(T||!n)&&(y=this.register(R,n))})),(0,L.toDisposable)(()=>{T=!0,y&&y.dispose()})}getPromise(R){const S=this.get(R);if(S)return Promise.resolve(S);const y=this._promises.get(R);return y?y.then(T=>this.get(R)):null}get(R){return this._map.get(R)||null}setColorMap(R){this._colorMap=R,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=k}),define(me[111],ge([0,1,22,11]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(k||(k={}));function C(I){for(let c=0,f=I.length;c<f;c+=4){const h=I[c+0],p=I[c+1],D=I[c+2],A=I[c+3];I[c+0]=A,I[c+1]=D,I[c+2]=p,I[c+3]=h}}function R(I){const c=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return L.isLittleEndian()||C(c),m.VSBuffer.wrap(c)}function S(I){const c=I.buffer;if(L.isLittleEndian()||C(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const f=new Uint8Array(c.byteLength);return f.set(c),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function y(I){const c=new Uint32Array(T(I));let f=0;if(c[f++]=I.id,I.type==="full")c[f++]=1,c[f++]=I.data.length,c.set(I.data,f),f+=I.data.length;else{c[f++]=2,c[f++]=I.deltas.length;for(const h of I.deltas)c[f++]=h.start,c[f++]=h.deleteCount,h.data?(c[f++]=h.data.length,c.set(h.data,f),f+=h.data.length):c[f++]=0}return R(c)}e.encodeSemanticTokensDto=y;function T(I){let c=0;if(c+=1+1,I.type==="full")c+=1+I.data.length;else{c+=1,c+=(1+1+1)*I.deltas.length;for(const f of I.deltas)f.data&&(c+=f.data.length)}return c}function n(I){const c=S(I);let f=0;const h=c[f++];if(c[f++]===1){const E=c[f++],a=c.subarray(f,f+E);return f+=E,{id:h,type:"full",data:a}}const D=c[f++];let A=[];for(let E=0;E<D;E++){const a=c[f++],s=c[f++],g=c[f++];let t;g>0&&(t=c.subarray(f,f+g),f+=g),A[E]={start:a,deleteCount:s,data:t}}return{id:h,type:"delta",deltas:A}}e.decodeSemanticTokensDto=n}),define(me[112],ge([0,1,97]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class L{constructor(R,S){this._prefixSumIndexOfResultBrand=void 0,this.index=R,this.remainder=S}}e.PrefixSumIndexOfResult=L;class k{constructor(R){this.values=R,this.prefixSum=new Uint32Array(R.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(R,S){R=(0,m.toUint32)(R);const y=this.values,T=this.prefixSum,n=S.length;return n===0?!1:(this.values=new Uint32Array(y.length+n),this.values.set(y.subarray(0,R),0),this.values.set(y.subarray(R),R+n),this.values.set(S,R),R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(R,S){return R=(0,m.toUint32)(R),S=(0,m.toUint32)(S),this.values[R]===S?!1:(this.values[R]=S,R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),!0)}removeValues(R,S){R=(0,m.toUint32)(R),S=(0,m.toUint32)(S);const y=this.values,T=this.prefixSum;if(R>=y.length)return!1;let n=y.length-R;return S>=n&&(S=n),S===0?!1:(this.values=new Uint32Array(y.length-S),this.values.set(y.subarray(0,R),0),this.values.set(y.subarray(R+S),R),this.prefixSum=new Uint32Array(this.values.length),R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(T.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(R){return R<0?0:(R=(0,m.toUint32)(R),this._getPrefixSum(R))}_getPrefixSum(R){if(R<=this.prefixSumValidIndex[0])return this.prefixSum[R];let S=this.prefixSumValidIndex[0]+1;S===0&&(this.prefixSum[0]=this.values[0],S++),R>=this.values.length&&(R=this.values.length-1);for(let y=S;y<=R;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],R),this.prefixSum[R]}getIndexOf(R){R=Math.floor(R),this.getTotalSum();let S=0,y=this.values.length-1,T=0,n=0,I=0;for(;S<=y;)if(T=S+(y-S)/2|0,n=this.prefixSum[T],I=n-this.values[T],R<I)y=T-1;else if(R>=n)S=T+1;else break;return new L(T,R-I)}}e.PrefixSumComputer=k}),define(me[150],ge([0,1,9,51,112]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(S,y,T,n){this._uri=S,this._lines=y,this._eol=T,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(S){S.eol&&S.eol!==this._eol&&(this._eol=S.eol,this._lineStarts=null);const y=S.changes;for(const T of y)this._acceptDeleteRange(T.range),this._acceptInsertText(new L.Position(T.range.startLineNumber,T.range.startColumn),T.text);this._versionId=S.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const S=this._eol.length,y=this._lines.length,T=new Uint32Array(y);for(let n=0;n<y;n++)T[n]=this._lines[n].length+S;this._lineStarts=new k.PrefixSumComputer(T)}}_setLineText(S,y){this._lines[S]=y,this._lineStarts&&this._lineStarts.changeValue(S,this._lines[S].length+this._eol.length)}_acceptDeleteRange(S){if(S.startLineNumber===S.endLineNumber){if(S.startColumn===S.endColumn)return;this._setLineText(S.startLineNumber-1,this._lines[S.startLineNumber-1].substring(0,S.startColumn-1)+this._lines[S.startLineNumber-1].substring(S.endColumn-1));return}this._setLineText(S.startLineNumber-1,this._lines[S.startLineNumber-1].substring(0,S.startColumn-1)+this._lines[S.endLineNumber-1].substring(S.endColumn-1)),this._lines.splice(S.startLineNumber,S.endLineNumber-S.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(S.startLineNumber,S.endLineNumber-S.startLineNumber)}_acceptInsertText(S,y){if(y.length===0)return;let T=(0,m.splitLines)(y);if(T.length===1){this._setLineText(S.lineNumber-1,this._lines[S.lineNumber-1].substring(0,S.column-1)+T[0]+this._lines[S.lineNumber-1].substring(S.column-1));return}T[T.length-1]+=this._lines[S.lineNumber-1].substring(S.column-1),this._setLineText(S.lineNumber-1,this._lines[S.lineNumber-1].substring(0,S.column-1)+T[0]);let n=new Uint32Array(T.length-1);for(let I=1;I<T.length;I++)this._lines.splice(S.lineNumber+I-1,0,T[I]),n[I-1]=T[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(S.lineNumber,n)}}e.MirrorTextModel=C}),define(me[151],ge([19,20]),function(J,e){return J.create("vs/base/common/date",e)}),define(me[152],ge([0,1,151]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,C=k*24,R=C*7,S=C*30,y=C*365;function T(I,c){typeof I!="number"&&(I=I.getTime());const f=Math.round((new Date().getTime()-I)/1e3);if(f<-30)return(0,m.localize)(0,null,T(new Date().getTime()+f*1e3,!1));if(f<30)return(0,m.localize)(1,null);let h;return f<L?(h=f,c?h===1?(0,m.localize)(2,null,h):(0,m.localize)(3,null,h):h===1?(0,m.localize)(4,null,h):(0,m.localize)(5,null,h)):f<k?(h=Math.floor(f/L),c?h===1?(0,m.localize)(6,null,h):(0,m.localize)(7,null,h):h===1?(0,m.localize)(8,null,h):(0,m.localize)(9,null,h)):f<C?(h=Math.floor(f/k),c?h===1?(0,m.localize)(10,null,h):(0,m.localize)(11,null,h):h===1?(0,m.localize)(12,null,h):(0,m.localize)(13,null,h)):f<R?(h=Math.floor(f/C),c?h===1?(0,m.localize)(14,null,h):(0,m.localize)(15,null,h):h===1?(0,m.localize)(16,null,h):(0,m.localize)(17,null,h)):f<S?(h=Math.floor(f/R),c?h===1?(0,m.localize)(18,null,h):(0,m.localize)(19,null,h):h===1?(0,m.localize)(20,null,h):(0,m.localize)(21,null,h)):f<y?(h=Math.floor(f/S),c?h===1?(0,m.localize)(22,null,h):(0,m.localize)(23,null,h):h===1?(0,m.localize)(24,null,h):(0,m.localize)(25,null,h)):(h=Math.floor(f/y),c?h===1?(0,m.localize)(26,null,h):(0,m.localize)(27,null,h):h===1?(0,m.localize)(28,null,h):(0,m.localize)(29,null,h))}e.fromNow=T;function n(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(me[153],ge([19,20]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(me[62],ge([0,1,17,13,153]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(T,n){return n&&(T.stack||T.stacktrace)?k.localize(0,null,S(T),R(T.stack)||R(T.stacktrace)):S(T)}function R(T){return Array.isArray(T)?T.join(`
`):T}function S(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?k.localize(1,null,T.message):T.message||k.localize(2,null)}function y(T=null,n=!1){if(!T)return k.localize(3,null);if(Array.isArray(T)){const I=m.coalesce(T),c=y(I[0],n);return I.length>1?k.localize(4,null,c,I.length):c}if(L.isString(T))return T;if(T.detail){const I=T.detail;if(I.error)return C(I.error,n);if(I.exception)return C(I.exception,n)}return T.stack?C(T,n):T.message?T.message:k.localize(5,null)}e.toErrorMessage=y}),define(me[154],ge([19,20]),function(J,e){return J.create("vs/base/node/processes",e)}),define(me[113],ge([0,1,39,29,10,25,8,11,38,13,143,28,154]),function(J,e,m,L,k,C,R,S,y,T,n,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function f(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(s,g){if(S.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};g&&(t.cwd=g);const u=m.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],t);return new Promise(r=>{u.once("error",i=>{r({success:!1,error:i})}),u.once("exit",(i,o)=>{r(i===0?{success:!0}:{success:!1,code:i!==null?i:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?f(t.status):1})}else if(S.isLinux||S.isMacintosh)try{const t=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(u=>{m.execFile(t,[s.pid.toString()],{encoding:"utf8",shell:!0},(r,i,o)=>{u(r?{success:!1,error:r}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function p(s=y.env){return s.comspec||"cmd.exe"}e.getWindowsShell=p;class D{constructor(g,t,u,r){if(t!==void 0&&u!==void 0&&r!==void 0)this.cmd=g,this.args=t,this.shell=u,this.options=r;else{const i=g;this.cmd=i.command,this.shell=i.isShellCommand,this.args=i.args.slice(0),this.options=i.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const i=Object.create(null);Object.keys(y.env).forEach(o=>{i[o]=y.env[o]}),Object.keys(this.options.env).forEach(o=>{i[o]=this.options.env[o]}),this.options.env=i}}getSanitizedCommand(){let g=this.cmd.toLowerCase();const t=g.lastIndexOf(R.sep);return t!==-1&&(g=g.substring(t+1)),D.WellKnowCommands[g]?g:"other"}start(g){return S.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(y.cwd()))?Promise.reject(new Error(c.localize(0,null))):this.useExec().then(t=>{let u,r;const i=new Promise((o,l)=>{u=o,r=l});if(t){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=m.exec(o,this.options,(l,d,b)=>{this.childProcess=null;const _=l;_&&_.killed?r({killed:this.terminateRequested,stdout:d.toString(),stderr:b.toString()}):this.handleExec(u,g,l,d,b)})}else{let o=null;const l=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,u,g,r);const b={terminated:this.terminateRequested};T.isNumber(d)&&(b.cmdCode=d),u(b)};if(this.shell&&S.isWindows){const d=C.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let b=!1,_=!1;const v=[];let P=this.ensureQuotes(this.cmd);v.push(P.value),b=P.quoted,this.args&&this.args.forEach(F=>{P=this.ensureQuotes(F),v.push(P.value),_=_&&P.quoted});const w=["/s","/c"];b?_?w.push('"'+v.join(" ")+'"'):v.length>1?w.push('"'+v[0]+'" '+v.slice(1).join(" ")):w.push('"'+v[0]+'"'):w.push(v.join(" ")),o=m.spawn(p(),w,d)}else this.cmd&&(o=m.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(T.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",d=>{this.childProcess=null,r({terminated:this.terminateRequested,error:d})}),o.pid&&(this.childProcess.on("close",l),this.handleSpawn(o,u,g,r,!0)))}return i})}handleClose(g,t,u,r){}ensureQuotes(g){return D.regexp.test(g)?{value:'"'+g+'"',quoted:!0}:{value:g,quoted:g.length>0&&g[0]==='"'&&g[g.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(g=>g.pid,g=>-1):new Promise(g=>{this.pidResolve=g})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(g=>(this.terminateRequested=!0,h(g,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),g=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(g=>{if(!this.shell||!S.isWindows)return g(!1);const t=m.spawn(p(),["/s","/c"]);t.on("error",u=>g(!0)),t.on("exit",u=>g(!1))})}}e.AbstractProcess=D,D.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},D.regexp=/^[^"].* .*[^"]/;class A extends D{constructor(g,t,u,r){super(g,t,u,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(g,t,u,r,i){[r,i].forEach((o,l)=>{const d=new n.LineDecoder;d.write(o).forEach(v=>{t({line:v,source:l===0?0:1})});const _=d.end();_&&t({line:_,source:l===0?0:1})}),g({terminated:this.terminateRequested,error:u})}handleSpawn(g,t,u,r,i){const o=new n.LineDecoder,l=new n.LineDecoder;g.stdout.on("data",d=>{o.write(d).forEach(_=>u({line:_,source:0}))}),g.stderr.on("data",d=>{l.write(d).forEach(_=>u({line:_,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=l}handleClose(g,t,u,r){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&u({line:i,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&u({line:o,source:1})}}e.LineProcess=A;function E(s){let g=[],t=!1;const u=function(r){if(t){g.push(r);return}(!s.send(r,o=>{if(o&&console.error(o),t=!1,g.length>0){const l=g.slice(0);g=[],l.forEach(d=>u(d))}})||S.isWindows)&&(t=!0)};return{send:u}}e.createQueuedSender=E;var a;(function(s){async function g(t,u,r){if(R.isAbsolute(t))return t;if(u===void 0&&(u=y.cwd()),R.dirname(t)!=="."||(r===void 0&&T.isString(y.env.PATH)&&(r=y.env.PATH.split(R.delimiter)),r===void 0||r.length===0))return R.join(u,t);async function o(l){if(await I.Promises.exists(l)){let d;try{d=await I.Promises.stat(l)}catch(b){b.message.startsWith("EACCES")&&(d=await I.Promises.lstat(l))}return d?!d.isDirectory():!1}return!1}for(let l of r){let d;if(R.isAbsolute(l)?d=R.join(l,t):d=R.join(u,l,t),await o(d))return d;let b=d+".com";if(await o(b)||(b=d+".exe",await o(b)))return b}return R.join(u,t)}s.findExecutable=g})(a=e.win32||(e.win32={}))}),define(me[155],ge([19,20]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(me[114],ge([0,1,155,11,110]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var C;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(C=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class R{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=R;class S{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,pe){this._values[te]=pe}}e.ValidatedEditorOptions=S;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class T{constructor(te,pe,ze,tt){this.id=te,this.name=pe,this.defaultValue=ze,this.schema=tt}compute(te,pe,ze){return ze}}class n{constructor(te,pe=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(te){return this.defaultValue}}class I{constructor(te,pe,ze,tt){this.id=te,this.name=pe,this.defaultValue=ze,this.schema=tt}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,pe,ze){return ze}}function c(X,te){return typeof X=="undefined"?te:X==="false"?!1:Boolean(X)}e.boolean=c;class f extends I{constructor(te,pe,ze,tt=void 0){typeof tt!="undefined"&&(tt.type="boolean",tt.default=ze),super(te,pe,ze,tt)}validate(te){return c(te,this.defaultValue)}}function h(X,te,pe,ze){if(typeof X=="undefined")return te;let tt=parseInt(X,10);return isNaN(tt)?te:(tt=Math.max(pe,tt),tt=Math.min(ze,tt),tt|0)}e.clampedInt=h;class p extends I{constructor(te,pe,ze,tt,ut,lt=void 0){typeof lt!="undefined"&&(lt.type="integer",lt.default=ze,lt.minimum=tt,lt.maximum=ut),super(te,pe,ze,lt),this.minimum=tt,this.maximum=ut}static clampedInt(te,pe,ze,tt){return h(te,pe,ze,tt)}validate(te){return p.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class D extends I{constructor(te,pe,ze,tt,ut){typeof ut!="undefined"&&(ut.type="number",ut.default=ze),super(te,pe,ze,ut),this.validationFn=tt}static clamp(te,pe,ze){return te<pe?pe:te>ze?ze:te}static float(te,pe){if(typeof te=="number")return te;if(typeof te=="undefined")return pe;const ze=parseFloat(te);return isNaN(ze)?pe:ze}validate(te){return this.validationFn(D.float(te,this.defaultValue))}}class A extends I{static string(te,pe){return typeof te!="string"?pe:te}constructor(te,pe,ze,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.default=ze),super(te,pe,ze,tt)}validate(te){return A.string(te,this.defaultValue)}}function E(X,te,pe){return typeof X!="string"||pe.indexOf(X)===-1?te:X}e.stringSet=E;class a extends I{constructor(te,pe,ze,tt,ut=void 0){typeof ut!="undefined"&&(ut.type="string",ut.enum=tt,ut.default=ze),super(te,pe,ze,ut),this._allowedValues=tt}validate(te){return E(te,this.defaultValue,this._allowedValues)}}class s extends T{constructor(te,pe,ze,tt,ut,lt,vt=void 0){typeof vt!="undefined"&&(vt.type="string",vt.enum=ut,vt.default=tt),super(te,pe,ze,vt),this._allowedValues=ut,this._convert=lt}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function g(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class t extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,pe,ze){return ze===0?te.accessibilitySupport:ze}}class u extends T{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:m.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertSpace:c(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var o;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(o=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(X){switch(X){case o.Line:return"line";case o.Block:return"block";case o.Underline:return"underline";case o.LineThin:return"line-thin";case o.BlockOutline:return"block-outline";case o.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function d(X){switch(X){case"line":return o.Line;case"block":return o.Block;case"underline":return o.Underline;case"line-thin":return o.LineThin;case"block-outline":return o.BlockOutline;case"underline-thin":return o.UnderlineThin}}class b extends n{constructor(){super(127,[65,32])}compute(te,pe,ze){const tt=["monaco-editor"];return pe.get(32)&&tt.push(pe.get(32)),te.extraEditorClassName&&tt.push(te.extraEditorClassName),pe.get(65)==="default"?tt.push("mouse-default"):pe.get(65)==="copy"&&tt.push("mouse-copy"),pe.get(100)&&tt.push("showUnused"),pe.get(125)&&tt.push("showDeprecated"),tt.join(" ")}}class _ extends f{constructor(){super(31,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(te,pe,ze){return ze&&te.emptySelectionClipboard}}class v extends T{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:te.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:m.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:m.localize(18,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{cursorMoveOnType:c(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof te.seedSearchStringFromSelection=="boolean"?te.seedSearchStringFromSelection?"always":"never":E(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":E(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(pe.loop,this.defaultValue.loop)}}}class P extends T{constructor(){super(43,"fontLigatures",P.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?P.OFF:te==="true"?P.ON:te:Boolean(te)?P.ON:P.OFF}}e.EditorFontLigatures=P,P.OFF='"liga" off, "calt" off',P.ON='"liga" on, "calt" on';class w extends n{constructor(){super(42)}compute(te,pe,ze){return te.fontInfo}}class F extends I{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(22,null)})}validate(te){let pe=D.float(te,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:D.clamp(pe,6,100)}compute(te,pe,ze){return te.fontInfo.fontSize}}class M extends T{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:M.MINIMUM_VALUE,maximum:M.MAXIMUM_VALUE,errorMessage:m.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:M.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(24,null)})}validate(te){return te==="normal"||te==="bold"?te:String(p.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,M.MINIMUM_VALUE,M.MAXIMUM_VALUE))}}M.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],M.MINIMUM_VALUE=1,M.MAXIMUM_VALUE=1e3;class K extends T{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[m.localize(25,null),m.localize(26,null),m.localize(27,null)]},ze=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:m.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:m.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:m.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:ze,description:m.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:ze,description:m.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:ze,description:m.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:ze,description:m.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:ze,description:m.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{multiple:E(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??E(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??E(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??E(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??E(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??E(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:A.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:A.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:A.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:A.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:A.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class G extends T{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(52,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:m.localize(39,null)},"editor.hover.delay":{type:"number",default:te.delay,description:m.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:m.localize(41,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),delay:p.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:c(pe.sticky,this.defaultValue.sticky)}}}var N;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(N=e.RenderMinimap||(e.RenderMinimap={}));class z extends n{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(te,pe,ze){return z.computeLayout(pe,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const pe=te.height/te.lineHeight,ze=te.scrollBeyondLastLine?pe-1:0,tt=(te.viewLineCount+ze)/(te.pixelRatio*te.height),ut=Math.floor(te.viewLineCount/tt);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:ze,desiredRatio:tt,minimapLineCount:ut}}static _computeMinimapLayout(te,pe){const ze=te.outerWidth,tt=te.outerHeight,ut=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ut*tt),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:tt};const lt=pe.stableMinimapLayoutInput,vt=lt&&te.outerHeight===lt.outerHeight&&te.lineHeight===lt.lineHeight&&te.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&te.pixelRatio===lt.pixelRatio&&te.scrollBeyondLastLine===lt.scrollBeyondLastLine&&te.minimap.enabled===lt.minimap.enabled&&te.minimap.side===lt.minimap.side&&te.minimap.size===lt.minimap.size&&te.minimap.showSlider===lt.minimap.showSlider&&te.minimap.renderCharacters===lt.minimap.renderCharacters&&te.minimap.maxColumn===lt.minimap.maxColumn&&te.minimap.scale===lt.minimap.scale&&te.verticalScrollbarWidth===lt.verticalScrollbarWidth&&te.isViewportWrapping===lt.isViewportWrapping,Dt=te.lineHeight,ue=te.typicalHalfwidthCharacterWidth,Ie=te.scrollBeyondLastLine,Be=te.minimap.renderCharacters;let Ke=ut>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const We=te.minimap.maxColumn,ot=te.minimap.size,Le=te.minimap.side,ye=te.verticalScrollbarWidth,ke=te.viewLineCount,ne=te.remainingWidth,de=te.isViewportWrapping,be=Be?2:3;let we=Math.floor(ut*tt);const Fe=we/ut;let Ge=!1,He=!1,Ye=be*Ke,it=Ke/ut,ae=1;if(ot==="fill"||ot==="fit"){const{typicalViewportLineCount:Xe,extraLinesBeyondLastLine:st,desiredRatio:wt,minimapLineCount:_t}=z.computeContainedMinimapLineCount({viewLineCount:ke,scrollBeyondLastLine:Ie,height:tt,lineHeight:Dt,pixelRatio:ut});if(ke/_t>1)Ge=!0,He=!0,Ke=1,Ye=1,it=Ke/ut;else{let gt=!1,ft=Ke+1;if(ot==="fit"){const Tt=Math.ceil((ke+st)*Ye);de&&vt&&ne<=pe.stableFitRemainingWidth?(gt=!0,ft=pe.stableFitMaxMinimapScale):gt=Tt>we}if(ot==="fill"||gt){Ge=!0;const Tt=Ke;Ye=Math.min(Dt*ut,Math.max(1,Math.floor(1/wt))),de&&vt&&ne<=pe.stableFitRemainingWidth&&(ft=pe.stableFitMaxMinimapScale),Ke=Math.min(ft,Math.max(1,Math.floor(Ye/be))),Ke>Tt&&(ae=Math.min(2,Ke/Tt)),it=Ke/ut/ae,we=Math.ceil(Math.max(Xe,ke+st)*Ye),de?(pe.stableMinimapLayoutInput=te,pe.stableFitRemainingWidth=ne,pe.stableFitMaxMinimapScale=Ke):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const Ee=Math.floor(We*it),ce=Math.min(Ee,Math.max(0,Math.floor((ne-ye-2)*it/(ue+it)))+e.MINIMAP_GUTTER_WIDTH);let q=Math.floor(ut*ce);const Te=q/ut;q=Math.floor(q*ae);const Pe=Be?1:2,Ze=Le==="left"?0:ze-ce-ye;return{renderMinimap:Pe,minimapLeft:Ze,minimapWidth:ce,minimapHeightIsEditorHeight:Ge,minimapIsSampling:He,minimapScale:Ke,minimapLineHeight:Ye,minimapCanvasInnerWidth:q,minimapCanvasInnerHeight:we,minimapCanvasOuterWidth:Te,minimapCanvasOuterHeight:Fe}}static computeLayout(te,pe){const ze=pe.outerWidth|0,tt=pe.outerHeight|0,ut=pe.lineHeight|0,lt=pe.lineNumbersDigitCount|0,vt=pe.typicalHalfwidthCharacterWidth,Dt=pe.maxDigitWidth,ue=pe.pixelRatio,Ie=pe.viewLineCount,Be=te.get(122),Ke=Be==="inherit"?te.get(121):Be,We=Ke==="inherit"?te.get(117):Ke,ot=te.get(120),Le=te.get(2),ye=pe.isDominatedByLongLines,ke=te.get(48),ne=te.get(59).renderType!==0,de=te.get(60),be=te.get(94),we=te.get(64),Fe=te.get(92),Ge=Fe.verticalScrollbarSize,He=Fe.verticalHasArrows,Ye=Fe.arrowSize,it=Fe.horizontalScrollbarSize,ae=te.get(57),Ee=te.get(36);let ce;if(typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)){const $t=parseFloat(ae.substr(0,ae.length-2));ce=p.clampedInt($t*vt,0,0,1e3)}else ce=p.clampedInt(ae,0,0,1e3);Ee&&(ce+=16);let q=0;if(ne){const $t=Math.max(lt,de);q=Math.round($t*Dt)}let Te=0;ke&&(Te=ut);let Pe=0,Ze=Pe+Te,Xe=Ze+q,st=Xe+ce;const wt=ze-Te-q-ce;let _t=!1,dt=!1,gt=-1;Le!==2&&(Ke==="inherit"&&ye?(_t=!0,dt=!0):We==="on"||We==="bounded"?dt=!0:We==="wordWrapColumn"&&(gt=ot));const ft=z._computeMinimapLayout({outerWidth:ze,outerHeight:tt,lineHeight:ut,typicalHalfwidthCharacterWidth:vt,pixelRatio:ue,scrollBeyondLastLine:be,minimap:we,verticalScrollbarWidth:Ge,viewLineCount:Ie,remainingWidth:wt,isViewportWrapping:dt},pe.memory||new y);ft.renderMinimap!==0&&ft.minimapLeft===0&&(Pe+=ft.minimapWidth,Ze+=ft.minimapWidth,Xe+=ft.minimapWidth,st+=ft.minimapWidth);const Tt=wt-ft.minimapWidth,yt=Math.max(1,Math.floor((Tt-Ge-2)/vt)),Bt=He?Ye:0;return dt&&(gt=Math.max(1,yt),We==="bounded"&&(gt=Math.min(gt,ot))),{width:ze,height:tt,glyphMarginLeft:Pe,glyphMarginWidth:Te,lineNumbersLeft:Ze,lineNumbersWidth:q,decorationsLeft:Xe,decorationsWidth:ce,contentLeft:st,contentWidth:Tt,minimap:ft,viewportColumn:yt,isWordWrapMinified:_t,isViewportWrapping:dt,wrappingColumn:gt,verticalScrollbarWidth:Ge,horizontalScrollbarHeight:it,overviewRuler:{top:Bt,width:Ge,height:tt-2*Bt,right:0}}}}e.EditorLayoutInfoComputer=z;class O extends T{constructor(){const te={enabled:!0};super(56,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:m.localize(42,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:c(te.enabled,this.defaultValue.enabled)}}}class x extends T{constructor(){const te={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:m.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,markdownDescription:m.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,markdownDescription:m.localize(45,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),fontSize:p.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:A.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class B extends D{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,te=>D.clamp(te,0,150),{markdownDescription:m.localize(46,null)})}compute(te,pe,ze){return te.fontInfo.lineHeight}}class U extends T{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:m.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(48,null),m.localize(49,null),m.localize(50,null)],default:te.size,description:m.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:m.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:m.localize(53,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:m.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:m.localize(56,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),size:E(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:E(pe.side,this.defaultValue.side,["right","left"]),showSlider:E(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(pe.renderCharacters,this.defaultValue.renderCharacters),scale:p.clampedInt(pe.scale,1,1,3),maxColumn:p.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function H(X){return X==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class W extends T{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(58,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{top:p.clampedInt(pe.top,0,0,1e3),bottom:p.clampedInt(pe.bottom,0,0,1e3)}}}class Q extends T{constructor(){const te={enabled:!0,cycle:!1};super(75,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:m.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:m.localize(60,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),cycle:c(pe.cycle,this.defaultValue.cycle)}}}class Y extends n{constructor(){super(128)}compute(te,pe,ze){return te.pixelRatio}}class he extends T{constructor(){const te={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:m.localize(61,null)},comments:{type:"boolean",default:te.comments,description:m.localize(62,null)},other:{type:"boolean",default:te.other,description:m.localize(63,null)}}}],default:te,description:m.localize(64,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const pe=te,ze={other:c(pe.other,this.defaultValue.other),comments:c(pe.comments,this.defaultValue.comments),strings:c(pe.strings,this.defaultValue.strings)};return ze.other&&ze.comments&&ze.strings?!0:!ze.other&&!ze.comments&&!ze.strings?!1:ze}return this.defaultValue}}var _e;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(_e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Se extends T{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(65,null),m.localize(66,null),m.localize(67,null),m.localize(68,null)],default:"on",description:m.localize(69,null)})}validate(te){let pe=this.defaultValue.renderType,ze=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(pe=4,ze=te):te==="interval"?pe=3:te==="relative"?pe=2:te==="on"?pe=1:pe=0),{renderType:pe,renderFn:ze}}}function Re(X){const te=X.get(87);return te==="editable"?X.get(80):te!=="on"}e.filterValidationDecorations=Re;class xe extends T{constructor(){const te=[],pe={type:"number",description:m.localize(70,null)};super(91,"rulers",te,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:m.localize(71,null),format:"color-hex"}}}]},default:te,description:m.localize(72,null)})}validate(te){if(Array.isArray(te)){let pe=[];for(let ze of te)if(typeof ze=="number")pe.push({column:p.clampedInt(ze,0,0,1e4),color:null});else if(ze&&typeof ze=="object"){const tt=ze;pe.push({column:p.clampedInt(tt.column,0,0,1e4),color:tt.color})}return pe.sort((ze,tt)=>ze.column-tt.column),pe}return this.defaultValue}}function Ue(X,te){if(typeof X!="string")return te;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class je extends T{constructor(){const te={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",te,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(73,null),m.localize(74,null),m.localize(75,null)],default:"auto",description:m.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(77,null),m.localize(78,null),m.localize(79,null)],default:"auto",description:m.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:te.verticalScrollbarSize,description:m.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:te.horizontalScrollbarSize,description:m.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:te.scrollByPage,description:m.localize(83,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te,ze=p.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),tt=p.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:p.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ue(pe.vertical,this.defaultValue.vertical),horizontal:Ue(pe.horizontal,this.defaultValue.horizontal),useShadows:c(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ze,horizontalSliderSize:p.clampedInt(pe.horizontalSliderSize,ze,0,1e3),verticalScrollbarSize:tt,verticalSliderSize:p.clampedInt(pe.verticalSliderSize,tt,0,1e3),scrollByPage:c(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class V extends T{constructor(){const te={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",te,{"editor.inlineSuggest.enabled":{type:"boolean",default:te.enabled,description:m.localize(84,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),mode:E(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends T{constructor(){const te={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",te,{"editor.bracketPairColorization.enabled":{type:"boolean",default:te.enabled,description:m.localize(85,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:c(te.enabled,this.defaultValue.enabled)}}}class re extends T{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(86,null),m.localize(87,null)],default:te.insertMode,description:m.localize(88,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:m.localize(89,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:m.localize(90,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:m.localize(91,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:m.localize(92,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:m.localize(93,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:m.localize(94,null)},"editor.suggest.preview":{type:"boolean",default:te.preview,description:m.localize(95,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:m.localize(96,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(97,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(98,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(99,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(100,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(101,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(102,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(103,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(104,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(105,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(106,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(107,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(108,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(109,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(110,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(111,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(112,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(113,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(114,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(115,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(116,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertMode:E(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(pe.showIcons,this.defaultValue.showIcons),showStatusBar:c(pe.showStatusBar,this.defaultValue.showStatusBar),preview:c(pe.preview,this.defaultValue.preview),previewMode:E(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(pe.showMethods,this.defaultValue.showMethods),showFunctions:c(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:c(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:c(pe.showFields,this.defaultValue.showFields),showVariables:c(pe.showVariables,this.defaultValue.showVariables),showClasses:c(pe.showClasses,this.defaultValue.showClasses),showStructs:c(pe.showStructs,this.defaultValue.showStructs),showInterfaces:c(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:c(pe.showModules,this.defaultValue.showModules),showProperties:c(pe.showProperties,this.defaultValue.showProperties),showEvents:c(pe.showEvents,this.defaultValue.showEvents),showOperators:c(pe.showOperators,this.defaultValue.showOperators),showUnits:c(pe.showUnits,this.defaultValue.showUnits),showValues:c(pe.showValues,this.defaultValue.showValues),showConstants:c(pe.showConstants,this.defaultValue.showConstants),showEnums:c(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:c(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(pe.showKeywords,this.defaultValue.showKeywords),showWords:c(pe.showWords,this.defaultValue.showWords),showColors:c(pe.showColors,this.defaultValue.showColors),showFiles:c(pe.showFiles,this.defaultValue.showFiles),showReferences:c(pe.showReferences,this.defaultValue.showReferences),showFolders:c(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:c(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(pe.showSnippets,this.defaultValue.showSnippets),showUsers:c(pe.showUsers,this.defaultValue.showUsers),showIssues:c(pe.showIssues,this.defaultValue.showIssues)}}}class le extends T{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(128,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Z extends n{constructor(){super(129,[80])}compute(te,pe,ze){return pe.get(80)?!0:te.tabFocusMode}}var oe;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(oe=e.WrappingIndent||(e.WrappingIndent={}));function ve(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Me extends n{constructor(){super(131,[130])}compute(te,pe,ze){const tt=pe.get(130);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:tt.isWordWrapMinified,isViewportWrapping:tt.isViewportWrapping,wrappingColumn:tt.wrappingColumn}}}const qe="Consolas, 'Courier New', monospace",Qe="Menlo, Monaco, 'Courier New', monospace",Je="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?Qe:L.isLinux?Je:qe,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Ce(X){return e.editorOptionsRegistry[X.id]=X,X}var at;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.bracketPairColorization=12]="bracketPairColorization",X[X.codeLens=13]="codeLens",X[X.codeLensFontFamily=14]="codeLensFontFamily",X[X.codeLensFontSize=15]="codeLensFontSize",X[X.colorDecorators=16]="colorDecorators",X[X.columnSelection=17]="columnSelection",X[X.comments=18]="comments",X[X.contextmenu=19]="contextmenu",X[X.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",X[X.cursorBlinking=21]="cursorBlinking",X[X.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",X[X.cursorStyle=23]="cursorStyle",X[X.cursorSurroundingLines=24]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",X[X.cursorWidth=26]="cursorWidth",X[X.disableLayerHinting=27]="disableLayerHinting",X[X.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",X[X.domReadOnly=29]="domReadOnly",X[X.dragAndDrop=30]="dragAndDrop",X[X.emptySelectionClipboard=31]="emptySelectionClipboard",X[X.extraEditorClassName=32]="extraEditorClassName",X[X.fastScrollSensitivity=33]="fastScrollSensitivity",X[X.find=34]="find",X[X.fixedOverflowWidgets=35]="fixedOverflowWidgets",X[X.folding=36]="folding",X[X.foldingStrategy=37]="foldingStrategy",X[X.foldingHighlight=38]="foldingHighlight",X[X.foldingImportsByDefault=39]="foldingImportsByDefault",X[X.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=41]="fontFamily",X[X.fontInfo=42]="fontInfo",X[X.fontLigatures=43]="fontLigatures",X[X.fontSize=44]="fontSize",X[X.fontWeight=45]="fontWeight",X[X.formatOnPaste=46]="formatOnPaste",X[X.formatOnType=47]="formatOnType",X[X.glyphMargin=48]="glyphMargin",X[X.gotoLocation=49]="gotoLocation",X[X.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",X[X.hover=52]="hover",X[X.inDiffEditor=53]="inDiffEditor",X[X.inlineSuggest=54]="inlineSuggest",X[X.letterSpacing=55]="letterSpacing",X[X.lightbulb=56]="lightbulb",X[X.lineDecorationsWidth=57]="lineDecorationsWidth",X[X.lineHeight=58]="lineHeight",X[X.lineNumbers=59]="lineNumbers",X[X.lineNumbersMinChars=60]="lineNumbersMinChars",X[X.linkedEditing=61]="linkedEditing",X[X.links=62]="links",X[X.matchBrackets=63]="matchBrackets",X[X.minimap=64]="minimap",X[X.mouseStyle=65]="mouseStyle",X[X.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=67]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",X[X.multiCursorModifier=69]="multiCursorModifier",X[X.multiCursorPaste=70]="multiCursorPaste",X[X.occurrencesHighlight=71]="occurrencesHighlight",X[X.overviewRulerBorder=72]="overviewRulerBorder",X[X.overviewRulerLanes=73]="overviewRulerLanes",X[X.padding=74]="padding",X[X.parameterHints=75]="parameterHints",X[X.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",X[X.quickSuggestions=78]="quickSuggestions",X[X.quickSuggestionsDelay=79]="quickSuggestionsDelay",X[X.readOnly=80]="readOnly",X[X.renameOnType=81]="renameOnType",X[X.renderControlCharacters=82]="renderControlCharacters",X[X.renderIndentGuides=83]="renderIndentGuides",X[X.renderFinalNewline=84]="renderFinalNewline",X[X.renderLineHighlight=85]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=87]="renderValidationDecorations",X[X.renderWhitespace=88]="renderWhitespace",X[X.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",X[X.roundedSelection=90]="roundedSelection",X[X.rulers=91]="rulers",X[X.scrollbar=92]="scrollbar",X[X.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=94]="scrollBeyondLastLine",X[X.scrollPredominantAxis=95]="scrollPredominantAxis",X[X.selectionClipboard=96]="selectionClipboard",X[X.selectionHighlight=97]="selectionHighlight",X[X.selectOnLineNumbers=98]="selectOnLineNumbers",X[X.showFoldingControls=99]="showFoldingControls",X[X.showUnused=100]="showUnused",X[X.snippetSuggestions=101]="snippetSuggestions",X[X.smartSelect=102]="smartSelect",X[X.smoothScrolling=103]="smoothScrolling",X[X.stickyTabStops=104]="stickyTabStops",X[X.stopRenderingLineAfter=105]="stopRenderingLineAfter",X[X.suggest=106]="suggest",X[X.suggestFontSize=107]="suggestFontSize",X[X.suggestLineHeight=108]="suggestLineHeight",X[X.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",X[X.suggestSelection=110]="suggestSelection",X[X.tabCompletion=111]="tabCompletion",X[X.tabIndex=112]="tabIndex",X[X.unusualLineTerminators=113]="unusualLineTerminators",X[X.useShadowDOM=114]="useShadowDOM",X[X.useTabStops=115]="useTabStops",X[X.wordSeparators=116]="wordSeparators",X[X.wordWrap=117]="wordWrap",X[X.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=120]="wordWrapColumn",X[X.wordWrapOverride1=121]="wordWrapOverride1",X[X.wordWrapOverride2=122]="wordWrapOverride2",X[X.wrappingIndent=123]="wrappingIndent",X[X.wrappingStrategy=124]="wrappingStrategy",X[X.showDeprecated=125]="showDeprecated",X[X.inlayHints=126]="inlayHints",X[X.editorClassName=127]="editorClassName",X[X.pixelRatio=128]="pixelRatio",X[X.tabFocusMode=129]="tabFocusMode",X[X.layoutInfo=130]="layoutInfo",X[X.wrappingInfo=131]="wrappingInfo"})(at=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ce(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(129,null)})),acceptSuggestionOnEnter:Ce(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(130,null),""],markdownDescription:m.localize(131,null)})),accessibilitySupport:Ce(new t),accessibilityPageSize:Ce(new p(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(132,null)})),ariaLabel:Ce(new A(4,"ariaLabel",m.localize(133,null))),autoClosingBrackets:Ce(new a(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(134,null),m.localize(135,null),""],description:m.localize(136,null)})),autoClosingDelete:Ce(new a(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(137,null),""],description:m.localize(138,null)})),autoClosingOvertype:Ce(new a(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(139,null),""],description:m.localize(140,null)})),autoClosingQuotes:Ce(new a(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(141,null),m.localize(142,null),""],description:m.localize(143,null)})),autoIndent:Ce(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],g,{enumDescriptions:[m.localize(144,null),m.localize(145,null),m.localize(146,null),m.localize(147,null),m.localize(148,null)],description:m.localize(149,null)})),automaticLayout:Ce(new f(10,"automaticLayout",!1)),autoSurround:Ce(new a(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(150,null),m.localize(151,null),m.localize(152,null),""],description:m.localize(153,null)})),bracketPairColorization:Ce(new ee),stickyTabStops:Ce(new f(104,"stickyTabStops",!1,{description:m.localize(154,null)})),codeLens:Ce(new f(13,"codeLens",!0,{description:m.localize(155,null)})),codeLensFontFamily:Ce(new A(14,"codeLensFontFamily","",{description:m.localize(156,null)})),codeLensFontSize:Ce(new p(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(157,null)})),colorDecorators:Ce(new f(16,"colorDecorators",!0,{description:m.localize(158,null)})),columnSelection:Ce(new f(17,"columnSelection",!1,{description:m.localize(159,null)})),comments:Ce(new u),contextmenu:Ce(new f(19,"contextmenu",!0)),copyWithSyntaxHighlighting:Ce(new f(20,"copyWithSyntaxHighlighting",!0,{description:m.localize(160,null)})),cursorBlinking:Ce(new s(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:m.localize(161,null)})),cursorSmoothCaretAnimation:Ce(new f(22,"cursorSmoothCaretAnimation",!1,{description:m.localize(162,null)})),cursorStyle:Ce(new s(23,"cursorStyle",o.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],d,{description:m.localize(163,null)})),cursorSurroundingLines:Ce(new p(24,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(164,null)})),cursorSurroundingLinesStyle:Ce(new a(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(165,null),m.localize(166,null)],description:m.localize(167,null)})),cursorWidth:Ce(new p(26,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(168,null)})),disableLayerHinting:Ce(new f(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ce(new f(28,"disableMonospaceOptimizations",!1)),domReadOnly:Ce(new f(29,"domReadOnly",!1)),dragAndDrop:Ce(new f(30,"dragAndDrop",!0,{description:m.localize(169,null)})),emptySelectionClipboard:Ce(new _),extraEditorClassName:Ce(new A(32,"extraEditorClassName","")),fastScrollSensitivity:Ce(new D(33,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:m.localize(170,null)})),find:Ce(new v),fixedOverflowWidgets:Ce(new f(35,"fixedOverflowWidgets",!1)),folding:Ce(new f(36,"folding",!0,{description:m.localize(171,null)})),foldingStrategy:Ce(new a(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(172,null),m.localize(173,null)],description:m.localize(174,null)})),foldingHighlight:Ce(new f(38,"foldingHighlight",!0,{description:m.localize(175,null)})),foldingImportsByDefault:Ce(new f(39,"foldingImportsByDefault",!1,{description:m.localize(176,null)})),unfoldOnClickAfterEndOfLine:Ce(new f(40,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(177,null)})),fontFamily:Ce(new A(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(178,null)})),fontInfo:Ce(new w),fontLigatures2:Ce(new P),fontSize:Ce(new F),fontWeight:Ce(new M),formatOnPaste:Ce(new f(46,"formatOnPaste",!1,{description:m.localize(179,null)})),formatOnType:Ce(new f(47,"formatOnType",!1,{description:m.localize(180,null)})),glyphMargin:Ce(new f(48,"glyphMargin",!0,{description:m.localize(181,null)})),gotoLocation:Ce(new K),hideCursorInOverviewRuler:Ce(new f(50,"hideCursorInOverviewRuler",!1,{description:m.localize(182,null)})),highlightActiveIndentGuide:Ce(new f(51,"highlightActiveIndentGuide",!0,{description:m.localize(183,null)})),hover:Ce(new G),inDiffEditor:Ce(new f(53,"inDiffEditor",!1)),letterSpacing:Ce(new D(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>D.clamp(X,-5,20),{description:m.localize(184,null)})),lightbulb:Ce(new O),lineDecorationsWidth:Ce(new I(57,"lineDecorationsWidth",10)),lineHeight:Ce(new B),lineNumbers:Ce(new Se),lineNumbersMinChars:Ce(new p(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Ce(new f(61,"linkedEditing",!1,{description:m.localize(185,null)})),links:Ce(new f(62,"links",!0,{description:m.localize(186,null)})),matchBrackets:Ce(new a(63,"matchBrackets","always",["always","near","never"],{description:m.localize(187,null)})),minimap:Ce(new U),mouseStyle:Ce(new a(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ce(new D(66,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:m.localize(188,null)})),mouseWheelZoom:Ce(new f(67,"mouseWheelZoom",!1,{markdownDescription:m.localize(189,null)})),multiCursorMergeOverlapping:Ce(new f(68,"multiCursorMergeOverlapping",!0,{description:m.localize(190,null)})),multiCursorModifier:Ce(new s(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],H,{markdownEnumDescriptions:[m.localize(191,null),m.localize(192,null)],markdownDescription:m.localize(193,null)})),multiCursorPaste:Ce(new a(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(194,null),m.localize(195,null)],markdownDescription:m.localize(196,null)})),occurrencesHighlight:Ce(new f(71,"occurrencesHighlight",!0,{description:m.localize(197,null)})),overviewRulerBorder:Ce(new f(72,"overviewRulerBorder",!0,{description:m.localize(198,null)})),overviewRulerLanes:Ce(new p(73,"overviewRulerLanes",3,0,3)),padding:Ce(new W),parameterHints:Ce(new Q),peekWidgetDefaultFocus:Ce(new a(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(199,null),m.localize(200,null)],description:m.localize(201,null)})),definitionLinkOpensInPeek:Ce(new f(77,"definitionLinkOpensInPeek",!1,{description:m.localize(202,null)})),quickSuggestions:Ce(new he),quickSuggestionsDelay:Ce(new p(79,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(203,null)})),readOnly:Ce(new f(80,"readOnly",!1)),renameOnType:Ce(new f(81,"renameOnType",!1,{description:m.localize(204,null),markdownDeprecationMessage:m.localize(205,null)})),renderControlCharacters:Ce(new f(82,"renderControlCharacters",!1,{description:m.localize(206,null)})),renderIndentGuides:Ce(new f(83,"renderIndentGuides",!0,{description:m.localize(207,null)})),renderFinalNewline:Ce(new f(84,"renderFinalNewline",!0,{description:m.localize(208,null)})),renderLineHighlight:Ce(new a(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(209,null)],description:m.localize(210,null)})),renderLineHighlightOnlyWhenFocus:Ce(new f(86,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(211,null)})),renderValidationDecorations:Ce(new a(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ce(new a(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(212,null),m.localize(213,null),m.localize(214,null),""],description:m.localize(215,null)})),revealHorizontalRightPadding:Ce(new p(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ce(new f(90,"roundedSelection",!0,{description:m.localize(216,null)})),rulers:Ce(new xe),scrollbar:Ce(new je),scrollBeyondLastColumn:Ce(new p(93,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(217,null)})),scrollBeyondLastLine:Ce(new f(94,"scrollBeyondLastLine",!0,{description:m.localize(218,null)})),scrollPredominantAxis:Ce(new f(95,"scrollPredominantAxis",!0,{description:m.localize(219,null)})),selectionClipboard:Ce(new f(96,"selectionClipboard",!0,{description:m.localize(220,null),included:L.isLinux})),selectionHighlight:Ce(new f(97,"selectionHighlight",!0,{description:m.localize(221,null)})),selectOnLineNumbers:Ce(new f(98,"selectOnLineNumbers",!0)),showFoldingControls:Ce(new a(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(222,null),m.localize(223,null)],description:m.localize(224,null)})),showUnused:Ce(new f(100,"showUnused",!0,{description:m.localize(225,null)})),showDeprecated:Ce(new f(125,"showDeprecated",!0,{description:m.localize(226,null)})),inlayHints:Ce(new x),snippetSuggestions:Ce(new a(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(227,null),m.localize(228,null),m.localize(229,null),m.localize(230,null)],description:m.localize(231,null)})),smartSelect:Ce(new le),smoothScrolling:Ce(new f(103,"smoothScrolling",!1,{description:m.localize(232,null)})),stopRenderingLineAfter:Ce(new p(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ce(new re),inlineSuggest:Ce(new V),suggestFontSize:Ce(new p(107,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(233,null)})),suggestLineHeight:Ce(new p(108,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(234,null)})),suggestOnTriggerCharacters:Ce(new f(109,"suggestOnTriggerCharacters",!0,{description:m.localize(235,null)})),suggestSelection:Ce(new a(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(236,null),m.localize(237,null),m.localize(238,null)],description:m.localize(239,null)})),tabCompletion:Ce(new a(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(240,null),m.localize(241,null),m.localize(242,null)],description:m.localize(243,null)})),tabIndex:Ce(new p(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ce(new a(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(244,null),m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),useShadowDOM:Ce(new f(114,"useShadowDOM",!0)),useTabStops:Ce(new f(115,"useTabStops",!0,{description:m.localize(248,null)})),wordSeparators:Ce(new A(116,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:m.localize(249,null)})),wordWrap:Ce(new a(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(250,null),m.localize(251,null),m.localize(252,null),m.localize(253,null)],description:m.localize(254,null)})),wordWrapBreakAfterCharacters:Ce(new A(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ce(new A(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ce(new p(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(255,null)})),wordWrapOverride1:Ce(new a(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ce(new a(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ce(new s(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ve,{enumDescriptions:[m.localize(256,null),m.localize(257,null),m.localize(258,null),m.localize(259,null)],description:m.localize(260,null)})),wrappingStrategy:Ce(new a(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(261,null),m.localize(262,null)],description:m.localize(263,null)})),editorClassName:Ce(new b),pixelRatio:Ce(new Y),tabFocusMode:Ce(new Z),layoutInfo:Ce(new z),wrappingInfo:Ce(new Me)}}),define(me[156],ge([19,20]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[157],ge([19,20]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[158],ge([19,20]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[159],ge([19,20]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[160],ge([19,20]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(me[161],ge([19,20]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(me[162],ge([19,20]),function(J,e){return J.create("vs/platform/theme/common/iconRegistry",e)}),define(me[163],ge([19,20]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(me[164],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[165],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[166],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(me[167],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[168],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[169],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[170],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[171],ge([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[172],ge([19,20]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(me[173],ge([19,20]),function(J,e){return J.create("vs/workbench/common/views",e)}),define(me[174],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[175],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[176],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[177],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[178],ge([19,20]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[179],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(R){R[R.ACTIVATE=1]="ACTIVATE",R[R.RESTORE=2]="RESTORE",R[R.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var L;(function(R){R[R.PICK=0]="PICK",R[R.DISABLED=1]="DISABLED",R[R.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var k;(function(R){R[R.API=0]="API",R[R.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(R){R[R.Center=0]="Center",R[R.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",R[R.NearTop=2]="NearTop",R[R.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[180],ge([0,1,158]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function C(c){return c=c.trim(),c==="*"||L.test(c)}e.isValidVersionStr=C;function R(c){if(!C(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=c.match(L);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=R;function S(c){if(!c)return null;let f=c.majorBase,h=c.majorMustEqual,p=c.minorBase,D=c.minorMustEqual,A=c.patchBase,E=c.patchMustEqual;c.hasCaret&&(f===0||(D=!1),E=!1);let a=0;if(c.preRelease){const s=k.exec(c.preRelease);if(s){const[,g,t,u]=s;a=Date.UTC(Number(g),Number(t)-1,Number(u))}}return{majorBase:f,majorMustEqual:h,minorBase:p,minorMustEqual:D,patchBase:A,patchMustEqual:E,isMinimum:c.hasGreaterEquals,notBefore:a}}e.normalizeVersion=S;function y(c,f,h){let p;typeof c=="string"?p=S(R(c)):p=c;let D;f instanceof Date?D=f.getTime():typeof f=="string"&&(D=new Date(f).getTime());let A;if(typeof h=="string"?A=S(R(h)):A=h,!p||!A)return!1;let E=p.majorBase,a=p.minorBase,s=p.patchBase,g=A.majorBase,t=A.minorBase,u=A.patchBase,r=A.notBefore,i=A.majorMustEqual,o=A.minorMustEqual,l=A.patchMustEqual;return A.isMinimum?E>g?!0:E<g?!1:a>t?!0:a<t||D&&D<r?!1:s>=u:(E===1&&g===0&&(!i||!o||!l)&&(g=1,t=0,u=0,i=!0,o=!1,l=!1),E<g?!1:E>g?!i:a<t?!1:a>t?!o:s<u?!1:s>u?!l:!(D&&D<r))}e.isValidVersion=y;function T(c,f,h,p){return h.isBuiltin||typeof h.main=="undefined"?!0:I(c,f,h.engines.vscode,p)}e.isValidExtensionVersion=T;function n(c,f,h){return c==="*"||I(f,h,c)}e.isEngineValid=n;function I(c,f,h,p=[]){let D=S(R(h));if(!D)return p.push(m.localize(0,null,h)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return p.push(m.localize(1,null,h)),!1}else if(!D.majorMustEqual)return p.push(m.localize(2,null,h)),!1;return y(c,f,D)?!0:(p.push(m.localize(3,null,c,h)),!1)}}),define(me[115],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(k,C=[],R=!1){this.ctor=k,this.staticArguments=C,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=m}),define(me[82],ge([0,1,115]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function k(R,S,y){S instanceof m.SyncDescriptor||(S=new m.SyncDescriptor(S,[],y)),L.push([R,S])}e.registerSingleton=k;function C(){return L}e.getSingletonServiceDescriptors=C}),define(me[181],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=m;class L{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let R of this._nodes.values())R.outgoing.size===0&&C.push(R);return C}insertEdge(C,R){const S=this.lookupOrInsertNode(C),y=this.lookupOrInsertNode(R);S.outgoing.set(this._hashFn(R),y),y.incoming.set(this._hashFn(C),S)}removeNode(C){const R=this._hashFn(C);this._nodes.delete(R);for(let S of this._nodes.values())S.outgoing.delete(R),S.incoming.delete(R)}lookupOrInsertNode(C){const R=this._hashFn(C);let S=this._nodes.get(R);return S||(S=new m(C),this._nodes.set(R,S)),S}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[R,S]of this._nodes)C.push(`${R}, (incoming)[${[...S.incoming.keys()].join(", ")}], (outgoing)[${[...S.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,R]of this._nodes){const S=new Set([C]),y=this._findCycle(R,S);if(y)return y}}_findCycle(C,R){for(let[S,y]of C.outgoing){if(R.has(S))return[...R,S].join(" -> ");R.add(S);const T=this._findCycle(y,R);if(T)return T;R.delete(S)}}}e.Graph=L}),define(me[4],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function y(T){return T[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=y})(m=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(S,y,T,n){y[m.DI_TARGET]===y?y[m.DI_DEPENDENCIES].push({id:S,index:T,optional:n}):(y[m.DI_DEPENDENCIES]=[{id:S,index:T,optional:n}],y[m.DI_TARGET]=y)}function k(S){if(m.serviceIds.has(S))return m.serviceIds.get(S);const y=function(T,n,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(y,T,I,!1)};return y.toString=()=>S,m.serviceIds.set(S,y),y}e.createDecorator=k;function C(S){return S}e.refineServiceDecorator=C;function R(S){return function(y,T,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(S,y,n,!0)}}e.optional=R}),define(me[182],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function L(k){return!k.isTooLargeForSyncing()&&!k.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(me[183],ge([0,1,3,48,6,24,77,81,182]),function(J,e,m,L,k,C,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function T(p){return typeof p=="string"?!1:Array.isArray(p)?p.every(T):!!p.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(D,A){let E={selector:D,provider:A,_score:-1,_time:this._clock++};return this._entries.push(E),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,k.toDisposable)(()=>{if(E){let a=this._entries.indexOf(E);a>=0&&(this._entries.splice(a,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),E=void 0)}})}has(D){return this.all(D).length>0}all(D){if(!D)return[];this._updateScores(D);const A=[];for(let E of this._entries)E._score>0&&A.push(E.provider);return A}ordered(D){const A=[];return this._orderedForEach(D,E=>A.push(E.provider)),A}orderedGroups(D){const A=[];let E,a;return this._orderedForEach(D,s=>{E&&a===s._score?E.push(s.provider):(a=s._score,E=[s.provider],A.push(E))}),A}_orderedForEach(D,A){if(!!D){this._updateScores(D);for(const E of this._entries)E._score>0&&A(E)}}_updateScores(D){let A={uri:D.uri.toString(),language:D.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===A.language&&this._lastCandidate.uri===A.uri)){this._lastCandidate=A;for(let E of this._entries)if(E._score=(0,S.score)(E.selector,D.uri,D.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(D)),T(E.selector)&&E._score>0){for(let a of this._entries)a._score=0;E._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(D,A){return D._score<A._score?1:D._score>A._score?-1:D._time<A._time?1:D._time>A._time?-1:0}}e.LanguageFeatureRegistry=n;const I=new WeakMap;let c=0;function f(p){let D=I.get(p);return D===void 0&&(D=++c,I.set(p,D)),D}class h{constructor(D,A,E=Number.MAX_SAFE_INTEGER){this._registry=D,this.min=A,this.max=E,this._cache=new C.LRUCache(50,.7)}_key(D){return D.id+this._registry.all(D).reduce((A,E)=>(0,L.doHash)(f(E),A),0)}_clamp(D){return D===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(D*1.3)))}get(D){const A=this._key(D),E=this._cache.get(A);return this._clamp(E?.value)}update(D,A){const E=this._key(D);let a=this._cache.get(E);return a||(a=new R.MovingAverage,this._cache.set(E,a)),a.update(A),this.get(D)}}e.LanguageFeatureRequestDelays=h}),define(me[83],ge([0,1,2,42,183,149,47]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var S;(function(v){v[v.Null=0]="Null",v[v.PlainText=1]="PlainText"})(S=e.LanguageId||(e.LanguageId={}));class y{constructor(P,w){this.language=P,this.id=w}}e.LanguageIdentifier=y;var T;(function(v){v[v.NotSet=-1]="NotSet",v[v.None=0]="None",v[v.Italic=1]="Italic",v[v.Bold=2]="Bold",v[v.Underline=4]="Underline"})(T=e.FontStyle||(e.FontStyle={}));var n;(function(v){v[v.None=0]="None",v[v.DefaultForeground=1]="DefaultForeground",v[v.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var I;(function(v){v[v.Other=0]="Other",v[v.Comment=1]="Comment",v[v.String=2]="String",v[v.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var c;(function(v){v[v.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",v[v.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",v[v.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",v[v.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",v[v.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",v[v.ITALIC_MASK=2048]="ITALIC_MASK",v[v.BOLD_MASK=4096]="BOLD_MASK",v[v.UNDERLINE_MASK=8192]="UNDERLINE_MASK",v[v.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",v[v.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",v[v.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",v[v.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",v[v.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",v[v.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",v[v.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",v[v.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",v[v.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",v[v.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(c=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(P){return(P&255)>>>0}static getTokenType(P){return(P&1792)>>>8}static getFontStyle(P){return(P&14336)>>>11}static getForeground(P){return(P&8372224)>>>14}static getBackground(P){return(P&4286578688)>>>23}static getClassNameFromMetadata(P){let w=this.getForeground(P),F="mtk"+w,M=this.getFontStyle(P);return M&1&&(F+=" mtki"),M&2&&(F+=" mtkb"),M&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(P,w){const F=this.getForeground(P),M=this.getFontStyle(P);let K=`color: ${w[F]};`;return M&1&&(K+="font-style: italic;"),M&2&&(K+="font-weight: bold;"),M&4&&(K+="text-decoration: underline;"),K}}e.TokenMetadata=f;var h;(function(v){v[v.Method=0]="Method",v[v.Function=1]="Function",v[v.Constructor=2]="Constructor",v[v.Field=3]="Field",v[v.Variable=4]="Variable",v[v.Class=5]="Class",v[v.Struct=6]="Struct",v[v.Interface=7]="Interface",v[v.Module=8]="Module",v[v.Property=9]="Property",v[v.Event=10]="Event",v[v.Operator=11]="Operator",v[v.Unit=12]="Unit",v[v.Value=13]="Value",v[v.Constant=14]="Constant",v[v.Enum=15]="Enum",v[v.EnumMember=16]="EnumMember",v[v.Keyword=17]="Keyword",v[v.Text=18]="Text",v[v.Color=19]="Color",v[v.File=20]="File",v[v.Reference=21]="Reference",v[v.Customcolor=22]="Customcolor",v[v.Folder=23]="Folder",v[v.TypeParameter=24]="TypeParameter",v[v.User=25]="User",v[v.Issue=26]="Issue",v[v.Snippet=27]="Snippet"})(h=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let v=Object.create(null);return v[0]="symbol-method",v[1]="symbol-function",v[2]="symbol-constructor",v[3]="symbol-field",v[4]="symbol-variable",v[5]="symbol-class",v[6]="symbol-struct",v[7]="symbol-interface",v[8]="symbol-module",v[9]="symbol-property",v[10]="symbol-event",v[11]="symbol-operator",v[12]="symbol-unit",v[13]="symbol-value",v[14]="symbol-constant",v[15]="symbol-enum",v[16]="symbol-enum-member",v[17]="symbol-keyword",v[27]="symbol-snippet",v[18]="symbol-text",v[19]="symbol-color",v[20]="symbol-file",v[21]="symbol-reference",v[22]="symbol-customcolor",v[23]="symbol-folder",v[24]="symbol-type-parameter",v[25]="account",v[26]="issues",function(P){const w=v[P];let F=w&&R.iconRegistry.get(w);return F||(console.info("No codicon found for CompletionItemKind "+P),F=R.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let v=Object.create(null);return v.method=0,v.function=1,v.constructor=2,v.field=3,v.variable=4,v.class=5,v.struct=6,v.interface=7,v.module=8,v.property=9,v.event=10,v.operator=11,v.unit=12,v.value=13,v.constant=14,v.enum=15,v["enum-member"]=16,v.enumMember=16,v.keyword=17,v.snippet=27,v.text=18,v.color=19,v.file=20,v.reference=21,v.customcolor=22,v.folder=23,v["type-parameter"]=24,v.typeParameter=24,v.account=25,v.issue=26,function(P,w){let F=v[P];return typeof F=="undefined"&&!w&&(F=9),F}}();var p;(function(v){v[v.Deprecated=1]="Deprecated"})(p=e.CompletionItemTag||(e.CompletionItemTag={}));var D;(function(v){v[v.KeepWhitespace=1]="KeepWhitespace",v[v.InsertAsSnippet=4]="InsertAsSnippet"})(D=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var A;(function(v){v[v.Invoke=0]="Invoke",v[v.TriggerCharacter=1]="TriggerCharacter",v[v.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(A=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(v){v[v.Automatic=0]="Automatic",v[v.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var a;(function(v){v[v.Invoke=1]="Invoke",v[v.Auto=2]="Auto"})(a=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var s;(function(v){v[v.Invoke=1]="Invoke",v[v.TriggerCharacter=2]="TriggerCharacter",v[v.ContentChange=3]="ContentChange"})(s=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(v){v[v.Text=0]="Text",v[v.Read=1]="Read",v[v.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(v){return v&&m.URI.isUri(v.uri)&&L.Range.isIRange(v.range)&&(L.Range.isIRange(v.originSelectionRange)||L.Range.isIRange(v.targetSelectionRange))}e.isLocationLink=t;var u;(function(v){v[v.File=0]="File",v[v.Module=1]="Module",v[v.Namespace=2]="Namespace",v[v.Package=3]="Package",v[v.Class=4]="Class",v[v.Method=5]="Method",v[v.Property=6]="Property",v[v.Field=7]="Field",v[v.Constructor=8]="Constructor",v[v.Enum=9]="Enum",v[v.Interface=10]="Interface",v[v.Function=11]="Function",v[v.Variable=12]="Variable",v[v.Constant=13]="Constant",v[v.String=14]="String",v[v.Number=15]="Number",v[v.Boolean=16]="Boolean",v[v.Array=17]="Array",v[v.Object=18]="Object",v[v.Key=19]="Key",v[v.Null=20]="Null",v[v.EnumMember=21]="EnumMember",v[v.Struct=22]="Struct",v[v.Event=23]="Event",v[v.Operator=24]="Operator",v[v.TypeParameter=25]="TypeParameter"})(u=e.SymbolKind||(e.SymbolKind={}));var r;(function(v){v[v.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var i;(function(v){const P=new Map;P.set("file",0),P.set("module",1),P.set("namespace",2),P.set("package",3),P.set("class",4),P.set("method",5),P.set("property",6),P.set("field",7),P.set("constructor",8),P.set("enum",9),P.set("interface",10),P.set("function",11),P.set("variable",12),P.set("constant",13),P.set("string",14),P.set("number",15),P.set("boolean",16),P.set("array",17),P.set("object",18),P.set("key",19),P.set("null",20),P.set("enum-member",21),P.set("struct",22),P.set("event",23),P.set("operator",24),P.set("type-parameter",25);const w=new Map;w.set(0,"file"),w.set(1,"module"),w.set(2,"namespace"),w.set(3,"package"),w.set(4,"class"),w.set(5,"method"),w.set(6,"property"),w.set(7,"field"),w.set(8,"constructor"),w.set(9,"enum"),w.set(10,"interface"),w.set(11,"function"),w.set(12,"variable"),w.set(13,"constant"),w.set(14,"string"),w.set(15,"number"),w.set(16,"boolean"),w.set(17,"array"),w.set(18,"object"),w.set(19,"key"),w.set(20,"null"),w.set(21,"enum-member"),w.set(22,"struct"),w.set(23,"event"),w.set(24,"operator"),w.set(25,"type-parameter");function F(G){return P.get(G)}v.fromString=F;function M(G){return w.get(G)}v.toString=M;function K(G,N){const z=w.get(G);let O=z&&R.iconRegistry.get("symbol-"+z);return O||(console.info("No codicon found for SymbolKind "+G),O=R.Codicon.symbolProperty),`${N?"inline":"block"} ${O.classNames}`}v.toCssClassName=K})(i=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(P){this.value=P}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var l;(function(v){v[v.Collapsed=0]="Collapsed",v[v.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(v){v[v.Editing=0]="Editing",v[v.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var b;(function(v){v[v.Other=0]="Other",v[v.Type=1]="Type",v[v.Parameter=2]="Parameter"})(b=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new k.LanguageFeatureRegistry,e.RenameProviderRegistry=new k.LanguageFeatureRegistry,e.CompletionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new k.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new k.LanguageFeatureRegistry,e.HoverProviderRegistry=new k.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new k.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new k.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new k.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new k.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new k.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.LinkProviderRegistry=new k.LanguageFeatureRegistry,e.ColorProviderRegistry=new k.LanguageFeatureRegistry,e.SelectionRangeRegistry=new k.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var _;(function(v){v[v.None=0]="None",v[v.Option=1]="Option",v[v.Default=2]="Default",v[v.Preferred=3]="Preferred"})(_=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[63],ge([0,1,11,9,4]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=m.userAgent||"";const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",m.isMacintosh),R.set("isLinux",m.isLinux),R.set("isWindows",m.isWindows),R.set("isWeb",m.isWeb),R.set("isMacNative",m.isMacintosh&&!m.isWeb),R.set("isEdge",C.indexOf("Edg/")>=0),R.set("isFirefox",C.indexOf("Firefox")>=0),R.set("isChrome",C.indexOf("Chrome")>=0),R.set("isSafari",C.indexOf("Safari")>=0);const S=Object.prototype.hasOwnProperty;var y;(function(P){P[P.False=0]="False",P[P.True=1]="True",P[P.Defined=2]="Defined",P[P.Not=3]="Not",P[P.Equals=4]="Equals",P[P.NotEquals=5]="NotEquals",P[P.And=6]="And",P[P.Regex=7]="Regex",P[P.NotRegex=8]="NotRegex",P[P.Or=9]="Or",P[P.In=10]="In",P[P.NotIn=11]="NotIn",P[P.Greater=12]="Greater",P[P.GreaterEquals=13]="GreaterEquals",P[P.Smaller=14]="Smaller",P[P.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class T{static false(){return I.INSTANCE}static true(){return c.INSTANCE}static has(w){return f.create(w)}static equals(w,F){return h.create(w,F)}static notEquals(w,F){return A.create(w,F)}static regex(w,F){return u.create(w,F)}static in(w,F){return p.create(w,F)}static not(w){return E.create(w)}static and(...w){return i.create(w,null)}static or(...w){return o.create(w,null,!0)}static greater(w,F){return a.create(w,F)}static less(w,F){return g.create(w,F)}static deserialize(w,F=!1){if(!!w)return this._deserializeOrExpression(w,F)}static _deserializeOrExpression(w,F){let M=w.split("||");return o.create(M.map(K=>this._deserializeAndExpression(K,F)),null,!0)}static _deserializeAndExpression(w,F){let M=w.split("&&");return i.create(M.map(K=>this._deserializeOne(K,F)),null)}static _deserializeOne(w,F){if(w=w.trim(),w.indexOf("!=")>=0){let M=w.split("!=");return A.create(M[0].trim(),this._deserializeValue(M[1],F))}if(w.indexOf("==")>=0){let M=w.split("==");return h.create(M[0].trim(),this._deserializeValue(M[1],F))}if(w.indexOf("=~")>=0){let M=w.split("=~");return u.create(M[0].trim(),this._deserializeRegexValue(M[1],F))}if(w.indexOf(" in ")>=0){let M=w.split(" in ");return p.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(w)){const M=w.split(">=");return s.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(w)){const M=w.split(">");return a.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(w)){const M=w.split("<=");return t.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(w)){const M=w.split("<");return g.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(w)?E.create(w.substr(1).trim()):f.create(w)}static _deserializeValue(w,F){if(w=w.trim(),w==="true")return!0;if(w==="false")return!1;let M=/^'([^']*)'$/.exec(w);return M?M[1].trim():w}static _deserializeRegexValue(w,F){if((0,L.isFalsyOrWhitespace)(w)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=w.indexOf("/"),K=w.lastIndexOf("/");if(M===K||M<0){if(F)throw new Error(`bad regexp-value '${w}', missing /-enclosure`);return console.warn(`bad regexp-value '${w}', missing /-enclosure`),null}let G=w.slice(M+1,K),N=w[K+1]==="i"?"i":"";try{return new RegExp(G,N)}catch(z){if(F)throw new Error(`bad regexp-value '${w}', parse error: ${z}`);return console.warn(`bad regexp-value '${w}', parse error: ${z}`),null}}}e.ContextKeyExpr=T;function n(P,w){return P.cmp(w)}class I{constructor(){this.type=0}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!1}serialize(){return"false"}keys(){return[]}map(w){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class c{constructor(){this.type=1}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!0}serialize(){return"true"}keys(){return[]}map(w){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=c,c.INSTANCE=new c;class f{constructor(w,F){this.key=w,this.negated=F,this.type=2}static create(w,F=null){const M=R.get(w);return typeof M=="boolean"?M?c.INSTANCE:I.INSTANCE:new f(w,F)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!!w.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(w){return w.mapDefined(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=f;class h{constructor(w,F,M){this.key=w,this.value=F,this.negated=M,this.type=4}static create(w,F,M=null){if(typeof F=="boolean")return F?f.create(w,M):E.create(w,M);const K=R.get(w);return typeof K=="boolean"?F===(K?"true":"false")?c.INSTANCE:I.INSTANCE:new h(w,F,M)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(w){return w.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=A.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class p{constructor(w,F){this.key=w,this.valueKey=F,this.type=10,this.negated=null}static create(w,F){return new p(w,F)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.valueKey,w.key,w.valueKey)}equals(w){return w.type===this.type?this.key===w.key&&this.valueKey===w.valueKey:!1}evaluate(w){const F=w.getValue(this.valueKey),M=w.getValue(this.key);return Array.isArray(F)?F.indexOf(M)>=0:typeof M=="string"&&typeof F=="object"&&F!==null?S.call(F,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(w){return w.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=D.create(this)),this.negated}}e.ContextKeyInExpr=p;class D{constructor(w){this._actual=w,this.type=11}static create(w){return new D(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new D(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class A{constructor(w,F,M){this.key=w,this.value=F,this.negated=M,this.type=5}static create(w,F,M=null){if(typeof F=="boolean")return F?E.create(w,M):f.create(w,M);const K=R.get(w);return typeof K=="boolean"?F===(K?"true":"false")?I.INSTANCE:c.INSTANCE:new A(w,F,M)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(w){return w.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=A;class E{constructor(w,F){this.key=w,this.negated=F,this.type=3}static create(w,F=null){const M=R.get(w);return typeof M=="boolean"?M?I.INSTANCE:c.INSTANCE:new E(w,F)}cmp(w){return w.type!==this.type?this.type-w.type:d(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!w.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(w){return w.mapNot(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=E;class a{constructor(w,F,M){this.key=w,this.value=F,this.negated=M,this.type=12}static create(w,F,M=null){return new a(w,F,M)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=a;class s{constructor(w,F,M){this.key=w,this.value=F,this.negated=M,this.type=13}static create(w,F,M=null){return new s(w,F,M)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=s;class g{constructor(w,F,M){this.key=w,this.value=F,this.negated=M,this.type=14}static create(w,F,M=null){return new g(w,F,M)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=g;class t{constructor(w,F,M){this.key=w,this.value=F,this.negated=M,this.type=15}static create(w,F,M=null){return new t(w,F,M)}cmp(w){return w.type!==this.type?this.type-w.type:b(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=t;class u{constructor(w,F){this.key=w,this.regexp=F,this.type=7,this.negated=null}static create(w,F){return new u(w,F)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.key<w.key)return-1;if(this.key>w.key)return 1;const F=this.regexp?this.regexp.source:"",M=w.regexp?w.regexp.source:"";return F<M?-1:F>M?1:0}equals(w){if(w.type===this.type){const F=this.regexp?this.regexp.source:"",M=w.regexp?w.regexp.source:"";return this.key===w.key&&F===M}return!1}evaluate(w){let F=w.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const w=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${w}`}keys(){return[this.key]}map(w){return w.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=u;class r{constructor(w){this._actual=w,this.type=8}static create(w){return new r(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new r(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class i{constructor(w,F){this.expr=w,this.negated=F,this.type=6}static create(w,F){return i._normalizeArr(w,F)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let F=0,M=this.expr.length;F<M;F++){const K=n(this.expr[F],w.expr[F]);if(K!==0)return K}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].equals(w.expr[F]))return!1;return!0}return!1}evaluate(w){for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].evaluate(w))return!1;return!0}static _normalizeArr(w,F){const M=[];let K=!1;for(const G of w)if(!!G){if(G.type===1){K=!0;continue}if(G.type===0)return I.INSTANCE;if(G.type===6){M.push(...G.expr);continue}M.push(G)}if(M.length===0&&K)return c.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(n);for(let G=1;G<M.length;G++)M[G-1].equals(M[G])&&(M.splice(G,1),G--);if(M.length===1)return M[0];for(;M.length>1;){const G=M[M.length-1];if(G.type!==9)break;M.pop();const N=M.pop(),z=M.length===0,O=o.create(G.expr.map(x=>i.create([x,N],null)),null,z);O&&(M.push(O),M.sort(n))}return M.length===1?M[0]:new i(M,F)}}serialize(){return this.expr.map(w=>w.serialize()).join(" && ")}keys(){const w=[];for(let F of this.expr)w.push(...F.keys());return w}map(w){return new i(this.expr.map(F=>F.map(w)),null)}negate(){if(!this.negated){const w=[];for(let F of this.expr)w.push(F.negate());this.negated=o.create(w,this,!0)}return this.negated}}class o{constructor(w,F){this.expr=w,this.negated=F,this.type=9}static create(w,F,M){return o._normalizeArr(w,F,M)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let F=0,M=this.expr.length;F<M;F++){const K=n(this.expr[F],w.expr[F]);if(K!==0)return K}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].equals(w.expr[F]))return!1;return!0}return!1}evaluate(w){for(let F=0,M=this.expr.length;F<M;F++)if(this.expr[F].evaluate(w))return!0;return!1}static _normalizeArr(w,F,M){let K=[],G=!1;if(w){for(let N=0,z=w.length;N<z;N++){const O=w[N];if(!!O){if(O.type===0){G=!0;continue}if(O.type===1)return c.INSTANCE;if(O.type===9){K=K.concat(O.expr);continue}K.push(O)}}if(K.length===0&&G)return I.INSTANCE;K.sort(n)}if(K.length!==0){if(K.length===1)return K[0];for(let N=1;N<K.length;N++)K[N-1].equals(K[N])&&(K.splice(N,1),N--);if(K.length===1)return K[0];if(M){for(let N=0;N<K.length;N++)for(let z=N+1;z<K.length;z++)_(K[N],K[z])&&(K.splice(z,1),z--);if(K.length===1)return K[0]}return new o(K,F)}}serialize(){return this.expr.map(w=>w.serialize()).join(" || ")}keys(){const w=[];for(let F of this.expr)w.push(...F.keys());return w}map(w){return new o(this.expr.map(F=>F.map(w)),null)}negate(){if(!this.negated){let w=[];for(let F of this.expr)w.push(F.negate());for(;w.length>1;){const F=w.shift(),M=w.shift(),K=[];for(const N of v(F))for(const z of v(M))K.push(i.create([N,z],null));const G=w.length===0;w.unshift(o.create(K,null,G))}this.negated=w[0]}return this.negated}}class l extends f{constructor(w,F,M){super(w,null);this._defaultValue=F,typeof M=="object"?l._info.push({...M,key:w}):M!==!0&&l._info.push({key:w,description:M,type:F!=null?typeof F:void 0})}static all(){return l._info.values()}bindTo(w){return w.createKey(this.key,this._defaultValue)}getValue(w){return w.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(w){return h.create(this.key,w)}notEqualsTo(w){return A.create(this.key,w)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(P,w){return P<w?-1:P>w?1:0}function b(P,w,F,M){return P<F?-1:P>F?1:w<M?-1:w>M?1:0}function _(P,w){if(w.type===6&&P.type!==9&&P.type!==6){for(const K of w.expr)if(P.equals(K))return!0}const F=P.negate(),M=v(F).concat(v(w));M.sort(n);for(let K=0;K<M.length;K++){const N=M[K].negate();for(let z=K+1;z<M.length;z++){const O=M[z];if(N.equals(O))return!0}}return!1}e.implies=_;function v(P){return P.type===9?P.expr:[P]}}),define(me[184],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(me[185],ge([0,1,10,157,4]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function R(E){switch(E){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function S(E){switch(E){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=S;function y(E,a){switch(E){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function T(E,a){return a==="web"&&!E.includes("web")}e.isNotWebExtensionInWebTargetPlatform=T;function n(E,a,s){return T(a,s)?!1:E==="undefined"||E==="universal"?!0:E==="unknown"?!1:E===s?!0:I(s).includes(E)}e.isTargetPlatformCompatible=n;function I(E){switch(E){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function c(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=c;var f;(function(E){E[E.NoneOrRelevance=0]="NoneOrRelevance",E[E.LastUpdatedDate=1]="LastUpdatedDate",E[E.Title=2]="Title",E[E.PublisherName=3]="PublisherName",E[E.InstallCount=4]="InstallCount",E[E.PublishedDate=5]="PublishedDate",E[E.AverageRating=6]="AverageRating",E[E.WeightedRating=12]="WeightedRating"})(f=e.SortBy||(e.SortBy={}));var h;(function(E){E[E.Default=0]="Default",E[E.Ascending=1]="Ascending",E[E.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var p;(function(E){E.Install="install",E.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var D;(function(E){E[E.None=0]="None",E[E.Install=1]="Install",E[E.Update=2]="Update"})(D=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class A extends Error{constructor(a,s){super(a);this.code=s,this.name=s}}e.ExtensionManagementError=A,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=m.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(me[26],ge([0,1,9,4]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=k;function C(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class S{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,c){if(typeof I=="undefined"||I===null)return typeof c=="undefined"||c===null;if(typeof c=="undefined"||c===null)return!1;if(typeof I=="string"||typeof c=="string"){let f=typeof I=="string"?I:I.value,h=typeof c=="string"?c:c.value;return m.equalsIgnoreCase(f,h)}return I._lower===c._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=S;function y(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function T(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=T,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[186],ge([0,1,9,26]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(h,p){return h.uuid&&p.uuid?h.uuid===p.uuid:h.id===p.id?!0:(0,m.compareIgnoreCase)(h.id,p.id)===0}e.areSameExtensions=k;class C{constructor(p,D){this.version=D,this.id=p.id,this.uuid=p.uuid}key(){return`${this.id}-${this.version}`}equals(p){return p instanceof C?k(this,p)&&this.version===p.version:!1}}e.ExtensionIdentifierWithVersion=C;function R(h,p){return`${h}.${p}`}e.getExtensionId=R;function S(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function y(h,p){return S(R(h,p))}e.getGalleryExtensionId=y;function T(h,p){const D=[],A=E=>{for(const a of D)if(a.some(s=>k(p(s),p(E))))return a;return null};for(const E of h){const a=A(E);a?a.push(E):D.push([E])}return D}e.groupByExtension=T;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function I(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function c(h){const p=new Set;for(const D of h)D.malicious&&p.add(D.id.id);return p}e.getMaliciousExtensionsSet=c;function f(h,p){const D=[],A=p.manifest.extensionDependencies?.slice(0)??[];for(;A.length;){const E=A.shift();if(E&&D.every(a=>!k(a.identifier,{id:E}))){const a=h.filter(s=>k(s.identifier,{id:E}));a.length===1&&(D.push(a[0]),A.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return D}e.getExtensionDependencies=f}),define(me[187],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(me[188],ge([0,1,39,10,8,11,140,28,113,159,187]),function(J,e,m,L,k,C,R,S,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=T.localize(0,null);class c{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends c{openTerminal(s,g){return this.spawnTerminal(m,s,y.getWindowsShell(),g)}spawnTerminal(s,g,t,u){const r=g.windowsExec||f.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const i=k.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return s.spawn(r,u?[u]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return r.indexOf(" ")>=0&&o.push('""'),o.push(r),(i==="wt"||i==="wt.exe")&&o.push("-d ."),new Promise((l,d)=>{const b=D(process),_=s.spawn(t,o,{cwd:u,env:b});_.on("error",d),_.on("exit",()=>l())})}runInTerminal(s,g,t,u,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:f.getDefaultTerminalWindows();return new Promise((o,l)=>{const d=`"${g} - ${I}"`,b=`""${t.join('" "')}" & pause"`,_=["/c","start",d,"/wait",i,"/c",b],v=Object.assign({},D(process),u);Object.keys(v).filter(F=>v[F]===null).forEach(F=>delete v[F]);const P={cwd:g,env:v,windowsVerbatimArguments:!0};m.spawn(f.CMD,_,P).on("error",F=>{l(A(F))}),o(void 0)})}static getDefaultTerminalWindows(){if(!f._DEFAULT_TERMINAL_WINDOWS){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return f._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=f,f.CMD="cmd.exe";class h extends c{openTerminal(s,g){return this.spawnTerminal(m,s,g)}runInTerminal(s,g,t,u,r){const i=r.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((o,l)=>{if(i===n.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const d=i===n.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",_=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${d}.scpt`,J).fsPath,"-t",s||I,"-w",g];for(let w of t)_.push("-a"),_.push(w);if(u){const w=Object.assign({},D(process),u);for(let F in w){const M=w[F];M===null?(_.push("-u"),_.push(F)):(_.push("-e"),_.push(`${F}=${M}`))}}let v="";const P=m.spawn(h.OSASCRIPT,_);P.on("error",w=>{l(A(w))}),P.stderr.on("data",w=>{v+=w.toString()}),P.on("exit",w=>{if(w===0)o(void 0);else if(v){const F=v.split(`
`,1);l(new Error(F[0]))}else l(new Error(T.localize(1,null,d,w)))})}else l(new Error(T.localize(2,null,i)))})}spawnTerminal(s,g,t){const u=g.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const o=["-a",u];t&&o.push(t);const l=D(process),d=s.spawn("/usr/bin/open",o,{cwd:t,env:l});d.on("error",i),d.on("exit",()=>r())})}}e.MacExternalTerminalService=h,h.OSASCRIPT="/usr/bin/osascript";class p extends c{openTerminal(s,g){return this.spawnTerminal(m,s,g)}runInTerminal(s,g,t,u,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((o,l)=>{let d=[];i.then(b=>{b.indexOf("gnome-terminal")>=0?d.push("-x"):d.push("-e"),d.push("bash"),d.push("-c");const _=`${E(t)}; echo; read -p "${p.WAIT_MESSAGE}" -n1;`;d.push(`''${_}''`);const v=Object.assign({},D(process),u);Object.keys(v).filter(M=>v[M]===null).forEach(M=>delete v[M]);const P={cwd:g,env:v};let w="";const F=m.spawn(b,d,P);F.on("error",M=>{l(A(M))}),F.stderr.on("data",M=>{w+=M.toString()}),F.on("exit",M=>{if(M===0)o(void 0);else if(w){const K=w.split(`
`,1);l(new Error(K[0]))}else l(new Error(T.localize(4,null,b,M)))})})})}static async getDefaultTerminalLinuxReady(){return p._DEFAULT_TERMINAL_LINUX_READY||(p._DEFAULT_TERMINAL_LINUX_READY=new Promise(async s=>{C.isLinux?await S.Promises.exists("/etc/debian_version")?s("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?s("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?s("konsole"):process.env.COLORTERM?s(process.env.COLORTERM):process.env.TERM?s(process.env.TERM):s("xterm"):s("xterm")})),p._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(s,g,t){const u=g.linuxExec?Promise.resolve(g.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{u.then(o=>{const l=D(process),d=s.spawn(o,[],{cwd:t,env:l});d.on("error",i),d.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=p,p.WAIT_MESSAGE=T.localize(3,null);function D(a){const s={...a.env};return(0,R.sanitizeProcessEnvironment)(s),s}function A(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(T.localize(5,null,a.path)):a}function E(a){let s="";for(let g of a)g.indexOf(" ")>=0?s+='"'+g+'"':s+=g,s+=" ";return s}}),define(me[43],ge([0,1,24,8,9,13,2,160,4]),function(J,e,m,L,k,C,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function T(N){return N.create===!0}e.isFileOpenForWriteOptions=T;var n;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var I;(function(N){N[N.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var c;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=f;function h(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=h;function p(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function D(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=D;var A;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(A=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(z,O){super(z);this.code=O}}e.FileSystemProviderError=E;function a(N,z){const O=new E(N.toString(),z);return g(O,z),O}e.createFileSystemProviderError=a;function s(N){return N||a((0,S.localize)(0,null),A.Unknown)}e.ensureFileSystemProviderError=s;function g(N,z){return N.name=z?`${z} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=g;function t(N){if(!N)return A.Unknown;if(N instanceof E)return N.code;const z=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!z)return A.Unknown;switch(z[1]){case A.FileExists:return A.FileExists;case A.FileIsADirectory:return A.FileIsADirectory;case A.FileNotADirectory:return A.FileNotADirectory;case A.FileNotFound:return A.FileNotFound;case A.FileExceedsMemoryLimit:return A.FileExceedsMemoryLimit;case A.FileTooLarge:return A.FileTooLarge;case A.FileWriteLocked:return A.FileWriteLocked;case A.NoPermissions:return A.NoPermissions;case A.Unavailable:return A.Unavailable}return A.Unknown}e.toFileSystemProviderErrorCode=t;function u(N){if(N instanceof b)return N.fileOperationResult;switch(t(N)){case A.FileNotFound:return 1;case A.FileIsADirectory:return 0;case A.FileNotADirectory:return 10;case A.FileWriteLocked:return 5;case A.NoPermissions:return 6;case A.FileExists:return 4;case A.FileExceedsMemoryLimit:return 9;case A.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var r;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(z,O,x){this.resource=z,this.operation=O,this.target=x}isOperation(z){return this.operation===z}}e.FileOperationEvent=i;var o;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class l{constructor(z,O){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const x of z)switch(x.type){case 1:this.added||(this.added=m.TernarySearchTree.forUris(()=>O)),this.added.set(x.resource,x);break;case 0:this.updated||(this.updated=m.TernarySearchTree.forUris(()=>O)),this.updated.set(x.resource,x);break;case 2:this.deleted||(this.deleted=m.TernarySearchTree.forUris(()=>O)),this.deleted.set(x.resource,x);break}}contains(z,...O){return this.doContains(z,{includeChildren:!1},...O)}affects(z,...O){return this.doContains(z,{includeChildren:!0},...O)}doContains(z,O,...x){if(!z)return!1;const B=x.length>0;return!!((!B||x.includes(1))&&(this.added?.get(z)||O.includeChildren&&this.added?.findSuperstr(z))||(!B||x.includes(0))&&(this.updated?.get(z)||O.includeChildren&&this.updated?.findSuperstr(z))||(!B||x.includes(2))&&(this.deleted?.findSubstr(z)||O.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function d(N,z,O){return!N||!z||N===z||z.length>N.length?!1:(z.charAt(z.length-1)!==L.sep&&(z+=L.sep),O?(0,k.startsWithIgnoreCase)(N,z):N.indexOf(z)===0)}e.isParent=d;class b extends Error{constructor(z,O,x){super(z);this.fileOperationResult=O,this.options=x}}e.FileOperationError=b;class _ extends b{constructor(z,O,x){super(z,2,x);this.stat=O}}e.NotModifiedSinceFileOperationError=_;var v;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(v=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var P;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(P=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function w(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=w;async function F(N,z){if(!z.canHandleResource(R.URI.from({scheme:N.scheme})))return new Promise(O=>{const x=z.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===N.scheme&&B.added&&(x.dispose(),O())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(z){return(0,C.isNumber)(z)||(z=0),z<M.KB?(0,S.localize)(1,null,z.toFixed(0)):z<M.MB?(0,S.localize)(2,null,(z/M.KB).toFixed(2)):z<M.GB?(0,S.localize)(3,null,(z/M.MB).toFixed(2)):z<M.TB?(0,S.localize)(4,null,(z/M.GB).toFixed(2)):(0,S.localize)(5,null,(z/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var K;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(K=e.Arch||(e.Arch={}));function G(N){return{maxFileSize:N===0?300*M.MB:16*M.GB,maxHeapSize:N===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=G}),define(me[84],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...k){this._entries=new Map;for(let[C,R]of k)this.set(C,R)}set(k,C){const R=this._entries.get(k);return this._entries.set(k,C),R}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=m}),define(me[189],ge([0,1,18,16,115,181,4,84]),function(J,e,m,L,k,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class T extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class n{constructor(h=new S.ServiceCollection,p=!1,D){this._activeInstantiations=new Set,this._services=h,this._strict=p,this._parent=D,this._services.set(R.IInstantiationService,this)}createChild(h){return new n(h,this._strict,this)}invokeFunction(h,...p){let D=c.traceInvocation(h),A=!1;try{return h({get:(a,s)=>{if(A)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(a,D);if(!g&&s!==R.optional)throw new Error(`[invokeFunction] unknown service '${a}'`);return g}},...p)}finally{A=!0,D.stop()}}createInstance(h,...p){let D,A;return h instanceof k.SyncDescriptor?(D=c.traceCreation(h.ctor),A=this._createInstance(h.ctor,h.staticArguments.concat(p),D)):(D=c.traceCreation(h),A=this._createInstance(h,p,D)),D.stop(),A}_createInstance(h,p=[],D){let A=R._util.getServiceDependencies(h).sort((s,g)=>s.index-g.index),E=[];for(const s of A){let g=this._getOrCreateServiceInstance(s.id,D);if(!g&&this._strict&&!s.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${s.id}.`);E.push(g)}let a=A.length>0?A[0].index:p.length;if(p.length!==a){console.warn(`[createInstance] First service dependency of ${h.name} at position ${a+1} conflicts with ${p.length} static arguments`);let s=a-p.length;s>0?p=p.concat(new Array(s)):p=p.slice(0,a)}return new h(...[...p,...E])}_setServiceInstance(h,p){if(this._services.get(h)instanceof k.SyncDescriptor)this._services.set(h,p);else if(this._parent)this._parent._setServiceInstance(h,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let p=this._services.get(h);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):p}_getOrCreateServiceInstance(h,p){let D=this._getServiceInstanceOrDescriptor(h);return D instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,D,p.branch(h,!0)):(p.branch(h,!1),D)}_safeCreateAndCacheServiceInstance(h,p,D){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,p,D)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,p,D){const A=new C.Graph(s=>s.id.toString());let E=0;const a=[{id:h,desc:p,_trace:D}];for(;a.length;){const s=a.pop();if(A.lookupOrInsertNode(s),E++>1e3)throw new T(A);for(let g of R._util.getServiceDependencies(s.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(g.id);if(!t&&!g.optional&&console.warn(`[createInstance] ${h} depends on ${g.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const u={id:g.id,desc:t,_trace:s._trace.branch(g.id,!0)};A.insertEdge(s,u),a.push(u)}}}for(;;){const s=A.roots();if(s.length===0){if(!A.isEmpty())throw new T(A);break}for(const{data:g}of s){if(this._getServiceInstanceOrDescriptor(g.id)instanceof k.SyncDescriptor){const u=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,u)}A.removeNode(g)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,p,D=[],A,E){if(this._services.get(h)instanceof k.SyncDescriptor)return this._createServiceInstance(p,D,A,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,p,D,A,E);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(h,p=[],D,A){if(D){const E=new m.IdleValue(()=>this._createInstance(h,p,A));return new Proxy(Object.create(null),{get(a,s){if(s in a)return a[s];let g=E.value,t=g[s];return typeof t!="function"||(t=t.bind(g),a[s]=t),t},set(a,s,g){return E.value[s]=g,!0}})}else return this._createInstance(h,p,A)}}e.InstantiationService=n;var I;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(I||(I={}));class c{constructor(h,p){this.type=h,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return y?new c(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(h){return y?new c(0,h.name):c._None}branch(h,p){let D=new c(2,h.toString());return this._dep.push([h,p,D]),D}stop(){let h=Date.now()-this._start;c._totals+=h;let p=!1;function D(E,a){let s=[],g=new Array(E+1).join("	");for(const[t,u,r]of a._dep)if(u&&r){p=!0,s.push(`${g}CREATES -> ${t}`);let i=D(E+1,r);i&&s.push(i)}else s.push(`${g}uses -> ${t}`);return s.join(`
`)}let A=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(h>2||p)&&console.log(A.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(me[12],ge([0,1,62,3,6,11,4]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,R.createDecorator)("logService"),e.ILoggerService=(0,R.createDecorator)("loggerService");function S(){return new Date().toISOString()}var y;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class T extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class n extends T{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...u){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...u]))}debug(t,...u){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...u]))}info(t,...u){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...u]))}warn(t,...u){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...u]))}error(t,...u){if(this.checkLogLevel(y.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(y.Error,this.format(r))}else this.log(y.Error,this.format([t,...u]))}critical(t,...u){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...u]))}flush(){}format(t){let u="";for(let r=0;r<t.length;r++){let i=t[r];if(typeof i=="object")try{i=JSON.stringify(i)}catch(o){}u+=(r>0?" ":"")+i}return u}}e.AbstractMessageLogger=n;class I extends T{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...u){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...u):console.log(`[main ${S()}]`,t,...u))}debug(t,...u){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...u):console.log(`[main ${S()}]`,t,...u))}info(t,...u){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...u):console.log(`[main ${S()}]`,t,...u))}warn(t,...u){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${S()}][0m`,t,...u):console.warn(`[main ${S()}]`,t,...u))}error(t,...u){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${S()}][0m`,t,...u):console.error(`[main ${S()}]`,t,...u))}critical(t,...u){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${S()}][0m`,t,...u):console.error(`[main ${S()}]`,t,...u))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class c extends T{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...u){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...u)}debug(t,...u){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...u)}info(t,...u){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...u)}warn(t,...u){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...u)}error(t,...u){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...u)}critical(t,...u){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...u)}dispose(){}flush(){}}e.ConsoleLogger=c;class f extends T{constructor(t,u=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(u)}trace(t,...u){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...u])}debug(t,...u){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...u])}info(t,...u){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...u])}warn(t,...u){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...u])}error(t,...u){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...u])}critical(t,...u){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...u])}extractMessage(t){return typeof t=="string"?t:(0,m.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class h extends T{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const u of this.logServices)u.setLevel(t);super.setLevel(t)}trace(t,...u){for(const r of this.logServices)r.trace(t,...u)}debug(t,...u){for(const r of this.logServices)r.debug(t,...u)}info(t,...u){for(const r of this.logServices)r.info(t,...u)}warn(t,...u){for(const r of this.logServices)r.warn(t,...u)}error(t,...u){for(const r of this.logServices)r.error(t,...u)}critical(t,...u){for(const r of this.logServices)r.critical(t,...u)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=h;class p extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...u){this.logger.trace(t,...u)}debug(t,...u){this.logger.debug(t,...u)}info(t,...u){this.logger.info(t,...u)}warn(t,...u){this.logger.warn(t,...u)}error(t,...u){this.logger.error(t,...u)}critical(t,...u){this.logger.critical(t,...u)}flush(){this.logger.flush()}}e.LogService=p;class D extends k.Disposable{constructor(t,u){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(u(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(r))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,u){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,u?.always?y.Trace:this.logLevel,u),this.loggers.set(t.toString(),r),u?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class A{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...u){}debug(t,...u){}info(t,...u){}warn(t,...u){}error(t,...u){}critical(t,...u){}dispose(){}flush(){}}e.NullLogService=A;function E(g){if(g.verbose)return y.Trace;if(typeof g.logLevel=="string"){const t=a(g.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function a(g){switch(g){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=a;function s(g){switch(g){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=s}),define(me[116],ge([0,1,43,12]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(y,T,n,I){try{const c=await new Promise((f,h)=>{J(["spdlog"],f,h)});return c.setFlushOn(L.LogLevel.Trace),c.createAsyncRotatingLogger(y,T,n,I)}catch(c){console.error(c)}return null}function C(y,T,n,I){const c=J.__$__nodeRequire("spdlog");return c.setFlushOn(L.LogLevel.Trace),c.createRotatingLogger(y,T,n,I)}e.createRotatingLogger=C;function R(y,T,n){switch(T){case L.LogLevel.Trace:y.trace(n);break;case L.LogLevel.Debug:y.debug(n);break;case L.LogLevel.Info:y.info(n);break;case L.LogLevel.Warning:y.warn(n);break;case L.LogLevel.Error:y.error(n);break;case L.LogLevel.Critical:y.critical(n);break;default:throw new Error("Invalid log level")}}class S extends L.AbstractMessageLogger{constructor(T,n,I,c){super();this.name=T,this.filepath=n,this.rotating=I,this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(f=>{this._logger&&this._logger.setLevel(f)}))}_createSpdLogLogger(){const T=this.rotating?6:1,n=30/T*m.ByteSize.MB;return k(this.name,this.filepath,n,T).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:c,message:f}of this.buffer)R(this._logger,c,f);this.buffer=[]}})}log(T,n){this._logger?R(this._logger,T,n):this.getLevel()<=T&&this.buffer.push({level:T,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=S}),define(me[117],ge([0,1,49,161,4]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var R;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(R=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function T(h,p){return p-h}y.compare=T;const n=Object.create(null);n[y.Error]=(0,L.localize)(0,null),n[y.Warning]=(0,L.localize)(1,null),n[y.Info]=(0,L.localize)(2,null);function I(h){return n[h]||""}y.toString=I;function c(h){switch(h){case m.default.Error:return y.Error;case m.default.Warning:return y.Warning;case m.default.Info:return y.Info;case m.default.Ignore:return y.Hint}}y.fromSeverity=c;function f(h){switch(h){case y.Error:return m.default.Error;case y.Warning:return m.default.Warning;case y.Info:return m.default.Info;case y.Hint:return m.default.Ignore}}y.toSeverity=f}(R=e.MarkerSeverity||(e.MarkerSeverity={}));var S;(function(y){const T="";function n(c){return I(c,!0)}y.makeKey=n;function I(c,f){let h=[T];return c.source?h.push(c.source.replace("\xA6","\\\xA6")):h.push(T),c.code?typeof c.code=="string"?h.push(c.code.replace("\xA6","\\\xA6")):h.push(c.code.value.replace("\xA6","\\\xA6")):h.push(T),c.severity!==void 0&&c.severity!==null?h.push(R.toString(c.severity)):h.push(T),c.message&&f?h.push(c.message.replace("\xA6","\\\xA6")):h.push(T),c.startLineNumber!==void 0&&c.startLineNumber!==null?h.push(c.startLineNumber.toString()):h.push(T),c.startColumn!==void 0&&c.startColumn!==null?h.push(c.startColumn.toString()):h.push(T),c.endLineNumber!==void 0&&c.endLineNumber!==null?h.push(c.endLineNumber.toString()):h.push(T),c.endColumn!==void 0&&c.endColumn!==null?h.push(c.endColumn.toString()):h.push(T),h.push(T),h.join("\xA6")}y.makeKeyOptionalMessage=I})(S=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(me[190],ge([0,1,3,49,4]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,k.createDecorator)("notificationService");var C;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var R;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(R=e.NotificationsFilter||(e.NotificationsFilter={}));class S{constructor(){this.progress=new y,this.onDidClose=m.Event.None,this.onDidChangeVisibility=m.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=S;class y{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=y}),define(me[191],ge([0,1,6,9,2,4]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(S){return{resolved:S,dispose(){}}}});function R(S,y){return k.URI.isUri(S)?(0,L.equalsIgnoreCase)(S.scheme,y):(0,L.startsWithIgnoreCase)(S,y+":")}e.matchesScheme=R}),define(me[192],ge([0,1,10,11,38,23]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const S=L.globals.vscode.context.configuration();if(S)R=S.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const S=(0,C.dirname)(m.FileAccess.asFileUri("",J));R=J.__$__nodeRequire((0,C.joinPath)(S,"product.json").fsPath);const y=J.__$__nodeRequire((0,C.joinPath)(S,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`}),Object.assign(R,{version:y.version})}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=R});var $e=this&&this.__param||function(J,e){return function(m,L){e(m,L,J)}};define(me[118],ge([0,1,18,21,6,4]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var R;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(R=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class S{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=S,S.None=Object.freeze({report(){}});let y=class extends k.Disposable{constructor(I,c){super();this.deferred=new m.DeferredPromise,c.withProgress(I,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,k.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};y=Ve([$e(1,e.IProgressService)],y),e.UnmanagedProgress=y;class T extends k.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(I){this.stop();const c=++this.currentOperationId,f=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,k.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,k.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,k.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:f.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(me[34],ge([0,1,57,13]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(R,S){m.ok(L.isString(R)),m.ok(L.isObject(S)),m.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,S)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new k}),define(me[119],ge([0,1,3,34]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class C{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,T){this.schemasById[k(y)]=T,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new C;L.Registry.add(e.Extensions.JSONContribution,R)}),define(me[85],ge([0,1,3,13,156,119,34]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(A){A.Multiline="multilineText",A.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(A){A[A.APPLICATION=1]="APPLICATION",A[A.MACHINE=2]="MACHINE",A[A.WINDOW=3]="WINDOW",A[A.RESOURCE=4]="RESOURCE",A[A.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",A[A.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const T=R.Registry.as(C.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new m.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new m.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,a=!0){this.registerConfigurations([E],a)}registerConfigurations(E,a=!0){const s=[];E.forEach(g=>{s.push(...this.validateAndRegisterProperties(g,a,g.extensionInfo)),this.configurationContributors.push(g),this.registerJSONConfiguration(g)}),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterConfigurations(E){const a=[],s=g=>{if(g.properties)for(const t in g.properties)a.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,g.properties[t]);g.allOf&&g.allOf.forEach(t=>s(t))};for(const g of E){s(g);const t=this.configurationContributors.indexOf(g);t!==-1&&this.configurationContributors.splice(t,1)}T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}registerDefaultConfigurations(E){const a=[],s=[];for(const g of E)for(const t in g)if(a.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...g[t]};const u={type:"object",default:this.defaultValues[t],description:k.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};s.push(c(t)),this.configurationProperties[t]=u,this.defaultLanguageConfigurationOverridesNode.properties[t]=u}else{this.defaultValues[t]=g[t];const u=this.configurationProperties[t];u&&(this.updatePropertyDefaultValue(t,u),this.updateSchema(t,u))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(E){const a=[];for(const s of E)for(const g in s)if(a.push(g),delete this.defaultValues[g],e.OVERRIDE_PROPERTY_PATTERN.test(g))delete this.configurationProperties[g],delete this.defaultLanguageConfigurationOverridesNode.properties[g];else{const t=this.configurationProperties[g];t&&(this.updatePropertyDefaultValue(g,t),this.updateSchema(g,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const a of E)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,a=!0,s,g=3){g=L.isUndefinedOrNull(E.scope)?g:E.scope;let t=[],u=E.properties;if(u)for(let i in u){if(a&&p(i)){delete u[i];continue}const o=u[i];if(this.updatePropertyDefaultValue(i,o),e.OVERRIDE_PROPERTY_PATTERN.test(i)?o.scope=void 0:(o.scope=L.isUndefinedOrNull(o.scope)?g:o.scope,o.restricted=L.isUndefinedOrNull(o.restricted)?!!s?.restrictedConfigurations?.includes(i):o.restricted),u[i].hasOwnProperty("included")&&!u[i].included){this.excludedConfigurationProperties[i]=u[i],delete u[i];continue}else this.configurationProperties[i]=u[i];!u[i].deprecationMessage&&u[i].markdownDeprecationMessage&&(u[i].deprecationMessage=u[i].markdownDeprecationMessage),t.push(i)}let r=E.allOf;if(r)for(let i of r)t.push(...this.validateAndRegisterProperties(i,a,s,g));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const a=s=>{let g=s.properties;if(g)for(const u in g)this.updateSchema(u,g[u]);let t=s.allOf;t&&t.forEach(a)};a(E)}updateSchema(E,a){switch(e.allSettings.properties[E]=a,a.scope){case 1:e.applicationSettings.properties[E]=a;break;case 2:e.machineSettings.properties[E]=a;break;case 6:e.machineOverridableSettings.properties[E]=a;break;case 3:e.windowSettings.properties[E]=a;break;case 4:e.resourceSettings.properties[E]=a;break;case 5:e.resourceSettings.properties[E]=a,this.resourceLanguageSettingsSchema.properties[E]=a;break}}removeFromSchema(E,a){switch(delete e.allSettings.properties[E],a.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const a=`[${E}]`,s={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,s),e.allSettings.properties[a]=s,e.applicationSettings.properties[a]=s,e.machineSettings.properties[a]=s,e.machineOverridableSettings.properties[a]=s,e.windowSettings.properties[a]=s,e.resourceSettings.properties[a]=s}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,a){let s=this.defaultValues[E];L.isUndefined(s)&&(s=a.default),L.isUndefined(s)&&(s=f(a.type)),a.default=s}}const I="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function c(A){return A.substring(1,A.length-1)}e.overrideIdentifierFromKey=c;function f(A){switch(Array.isArray(A)?A[0]:A){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const h=new n;R.Registry.add(e.Extensions.Configuration,h);function p(A){return A.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(A)?k.localize(5,null,A):h.getConfigurationProperties()[A]!==void 0?k.localize(6,null,A):null:k.localize(4,null)}e.validateProperty=p;function D(){const A=[],E=h.getConfigurationProperties();for(const a of Object.keys(E))A.push([a,E[a].scope]);return A.push(["launch",4]),A.push(["task",4]),A}e.getScopes=D}),define(me[120],ge([0,1,25,13,2,85,4,34]),function(J,e,m,L,k,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function y(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof k.URI)}e.isConfigurationOverrides=y;var T;(function(u){u[u.USER=1]="USER",u[u.USER_LOCAL=2]="USER_LOCAL",u[u.USER_REMOTE=3]="USER_REMOTE",u[u.WORKSPACE=4]="WORKSPACE",u[u.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",u[u.DEFAULT=6]="DEFAULT",u[u.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(u){switch(u){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function I(u,r){const i=r?u?r.keys.filter(P=>u.keys.indexOf(P)===-1):[...r.keys]:[],o=u?r?u.keys.filter(P=>r.keys.indexOf(P)===-1):[...u.keys]:[],l=[];if(r&&u){for(const P of u.keys)if(r.keys.indexOf(P)!==-1){const w=A(u.contents,P),F=A(r.contents,P);m.equals(w,F)||l.push(P)}}const d=[],b=P=>{const w={};for(const F of P)for(const M of F.identifiers)w[g(M)]=F;return w},_=r?b(r.overrides):{},v=u?b(u.overrides):{};if(Object.keys(_).length)for(const P of i){const w=_[P];w&&d.push([(0,C.overrideIdentifierFromKey)(P),w.keys])}if(Object.keys(v).length)for(const P of o){const w=v[P];w&&d.push([(0,C.overrideIdentifierFromKey)(P),w.keys])}if(Object.keys(_).length&&Object.keys(v).length)for(const P of l){const w=v[P],F=_[P];if(w&&F){const M=I({contents:w.contents,keys:w.keys,overrides:[]},{contents:F.contents,keys:F.keys,overrides:[]});d.push([(0,C.overrideIdentifierFromKey)(P),[...M.added,...M.removed,...M.updated]])}}return{added:i,removed:o,updated:l,overrides:d}}e.compare=I;function c(u,r){const i=[];for(const o of Object.keys(u))if(C.OVERRIDE_PROPERTY_PATTERN.test(o)){const l={};for(const d in u[o])l[d]=u[o][d];i.push({identifiers:[(0,C.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(l),contents:f(l,r)})}return i}e.toOverrides=c;function f(u,r){const i=Object.create(null);for(let o in u)h(i,o,u[o],r);return i}e.toValuesTree=f;function h(u,r,i,o){const l=r.split("."),d=l.pop();let b=u;for(let _=0;_<l.length;_++){let v=l[_],P=b[v];switch(typeof P){case"undefined":P=b[v]=Object.create(null);break;case"object":break;default:o(`Ignoring ${r} as ${l.slice(0,_+1).join(".")} is ${JSON.stringify(P)}`);return}b=P}if(typeof b=="object"&&b!==null)try{b[d]=i}catch(_){o(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(b)}`)}else o(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(b)}`)}e.addToValueTree=h;function p(u,r){const i=r.split(".");D(u,i)}e.removeFromValueTree=p;function D(u,r){const i=r.shift();if(r.length===0){delete u[i];return}if(Object.keys(u).indexOf(i)!==-1){const o=u[i];typeof o=="object"&&!Array.isArray(o)&&(D(o,r),Object.keys(o).length===0&&delete u[i])}}function A(u,r,i){function o(b,_){let v=b;for(const P of _){if(typeof v!="object"||v===null)return;v=v[P]}return v}const l=r.split("."),d=o(u,l);return typeof d=="undefined"?i:d}e.getConfigurationValue=A;function E(u,r,i){Object.keys(r).forEach(o=>{o!=="__proto__"&&(o in u?L.isObject(u[o])&&L.isObject(r[o])?E(u[o],r[o],i):i&&(u[o]=r[o]):u[o]=r[o])})}e.merge=E;function a(){const u=S.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(u)}e.getConfigurationKeys=a;function s(){const u=Object.create(null),r=S.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let i in r){let o=r[i].default;h(u,i,o,l=>console.error(`Conflict in default settings: ${l}`))}return u}e.getDefaultValues=s;function g(u){return`[${u}]`}e.keyFromOverrideIdentifier=g;function t(u,r,i){const o=u.inspect(r),l=u.inspect(i);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:o.defaultValue}e.getMigratedSettingValue=t}),define(me[193],ge([0,1,17,3,60,6,24,25,13,2,120,85,34]),function(J,e,m,L,k,C,R,S,y,T,n,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},u=[],r=[]){this._contents=t,this._keys=u,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,u){const r=this.getContentsForOverrideIdentifer(u);return r?t?(0,n.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const u of this.overrides)if(u.identifiers.indexOf(t)!==-1)return u.keys;return[]}override(t){const u=this.getContentsForOverrideIdentifer(t);if(!u||typeof u!="object"||!Object.keys(u).length)return this;let r={};for(const i of m.distinct([...Object.keys(this.contents),...Object.keys(u)])){let o=this.contents[i],l=u[i];l&&(typeof o=="object"&&typeof l=="object"?(o=S.deepClone(o),this.mergeContents(o,l)):o=l),r[i]=o}return new f(r,this.keys,this.overrides)}merge(...t){const u=S.deepClone(this.contents),r=S.deepClone(this.overrides),i=[...this.keys];for(const o of t){this.mergeContents(u,o.contents);for(const l of o.overrides){const[d]=r.filter(b=>m.equals(b.identifiers,l.identifiers));d?this.mergeContents(d.contents,l.contents):r.push(S.deepClone(l))}for(const l of o.keys)i.indexOf(l)===-1&&i.push(l)}return new f(u,i,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,u){for(const r of Object.keys(u)){if(r in t&&y.isObject(t[r])&&y.isObject(u[r])){this.mergeContents(t[r],u[r]);continue}t[r]=S.deepClone(u[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?S.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const u of this.overrides)if(u.identifiers.indexOf(t)!==-1)return u.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,u){this.addKey(t),(0,n.addToValueTree)(this.contents,t,u,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let u=this.keys.length;for(let r=0;r<u;r++)t.indexOf(this.keys[r])===0&&(u=r);this.keys.splice(u,1,t)}removeKey(t){let u=this.keys.indexOf(t);return u!==-1?(this.keys.splice(u,1),!0):!1}}e.ConfigurationModel=f;class h extends f{constructor(){const t=(0,n.getDefaultValues)(),u=(0,n.getConfigurationKeys)(),r=[];for(const i of Object.keys(t))I.OVERRIDE_PROPERTY_PATTERN.test(i)&&r.push({identifiers:[(0,I.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,n.toValuesTree)(t[i],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,u,r)}}e.DefaultConfigurationModel=h;class p{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,u){if(!y.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,u)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,u){this._raw=t;const{contents:r,keys:i,overrides:o,restricted:l}=this.doParseRaw(t,u);this._configurationModel=new f(r,i,o),this._restrictedConfigurations=l||[]}doParseContent(t){let u={},r=null,i=[],o=[],l=[];function d(_){Array.isArray(i)?i.push(_):r!==null&&(i[r]=_)}let b={onObjectBegin:()=>{let _={};d(_),o.push(i),i=_,r=null},onObjectProperty:_=>{r=_},onObjectEnd:()=>{i=o.pop()},onArrayBegin:()=>{let _=[];d(_),o.push(i),i=_,r=null},onArrayEnd:()=>{i=o.pop()},onLiteralValue:d,onError:(_,v,P)=>{l.push({error:_,offset:v,length:P})}};if(t)try{k.visit(t,b),u=i[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return u}doParseRaw(t,u){const r=c.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,r,!0,u);t=i.raw;const o=(0,n.toValuesTree)(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),l=Object.keys(t),d=(0,n.toOverrides)(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:o,keys:l,overrides:d,restricted:i.restricted}}filter(t,u,r,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const o={},l=[];for(let d in t)if(I.OVERRIDE_PROPERTY_PATTERN.test(d)&&r){const b=this.filter(t[d],u,!1,i);o[d]=b.raw,l.push(...b.restricted)}else{const b=u[d],_=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&l.push(d),(_===void 0||i.scopes===void 0||i.scopes.includes(_))&&(i.skipRestricted&&b?.restricted||(o[d]=t[d]))}return{raw:o,restricted:l}}}e.ConfigurationModelParser=p;class D extends C.Disposable{constructor(t,u,r,i){super();this.userSettingsResource=t,this.scopes=u,this.fileService=i,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class A{constructor(t,u,r=new f,i=new f,o=new R.ResourceMap,l=new f,d=new R.ResourceMap,b=!0){this._defaultConfiguration=t,this._localUserConfiguration=u,this._remoteUserConfiguration=r,this._workspaceConfiguration=i,this._folderConfigurations=o,this._memoryConfiguration=l,this._memoryConfigurationByResource=d,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,u,r){return this.getConsolidateConfigurationModel(u,r).getValue(t)}updateValue(t,u,r={}){let i;r.resource?(i=this._memoryConfigurationByResource.get(r.resource),i||(i=new f,this._memoryConfigurationByResource.set(r.resource,i))):i=this._memoryConfiguration,u===void 0?i.removeValue(t):i.setValue(t,u),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,u,r){const i=this.getConsolidateConfigurationModel(u,r),o=this.getFolderConfigurationModelForResource(u.resource,r),l=u.resource?this._memoryConfigurationByResource.get(u.resource)||this._memoryConfiguration:this._memoryConfiguration,d=u.overrideIdentifier?this._defaultConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),b=u.overrideIdentifier?this.userConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),_=u.overrideIdentifier?this.localUserConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),v=u.overrideIdentifier?this.remoteUserConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),P=r?u.overrideIdentifier?this._workspaceConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,w=o?u.overrideIdentifier?o.freeze().override(u.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,F=u.overrideIdentifier?l.override(u.overrideIdentifier).getValue(t):l.getValue(t),M=i.getValue(t),K=m.distinct(m.flatten(i.overrides.map(G=>G.identifiers))).filter(G=>i.getOverrideValue(t,G)!==void 0);return{defaultValue:d,userValue:b,userLocalValue:_,userRemoteValue:v,workspaceValue:P,workspaceFolderValue:w,memoryValue:F,value:M,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,userRemote:v!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,workspace:P!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,workspaceFolder:w!==void 0?{value:o?.freeze().getValue(t),override:u.overrideIdentifier?o?.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:l.getValue(t),override:u.overrideIdentifier?l.getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,overrideIdentifiers:K.length?K:void 0}}keys(t){const u=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:u?u.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,u){this._folderConfigurations.set(t,u),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,u){const r=u.filter(i=>I.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const o=(0,I.overrideIdentifierFromKey)(i),l=this._defaultConfiguration.getKeysForOverrideIdentifier(o),d=t.getKeysForOverrideIdentifier(o),b=[...d.filter(_=>l.indexOf(_)===-1),...l.filter(_=>d.indexOf(_)===-1),...l.filter(_=>!S.equals(this._defaultConfiguration.override(o).getValue(_),t.override(o).getValue(_)))];return[o,b]});return this.updateDefaultConfiguration(t),{keys:u,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:u,updated:r,removed:i,overrides:o}=(0,n.compare)(this.localUserConfiguration,t),l=[...u,...r,...i];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:u,updated:r,removed:i,overrides:o}=(0,n.compare)(this.remoteUserConfiguration,t);let l=[...u,...r,...i];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:u,updated:r,removed:i,overrides:o}=(0,n.compare)(this.workspaceConfiguration,t);let l=[...u,...r,...i];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:o}}compareAndUpdateFolderConfiguration(t,u){const r=this.folderConfigurations.get(t),{added:i,updated:o,removed:l,overrides:d}=(0,n.compare)(r,u);let b=[...i,...o,...l];return(b.length||!r)&&this.updateFolderConfiguration(t,u),{keys:b,overrides:d}}compareAndDeleteFolderConfiguration(t){const u=this.folderConfigurations.get(t);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:i,removed:o,overrides:l}=(0,n.compare)(u,void 0);return{keys:[...r,...i,...o],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,u){let r=this.getConsolidatedConfigurationModelForResource(t,u);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},u){let r=this.getWorkspaceConsolidatedConfiguration();if(u&&t){const i=u.getFolder(t);i&&(r=this.getFolderConsolidatedConfiguration(i.uri)||r);const o=this._memoryConfigurationByResource.get(t);o&&(r=r.merge(o))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let u=this._foldersConsolidatedConfigurations.get(t);if(!u){const r=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(u=r.merge(i),this._freeze&&(u=u.freeze()),this._foldersConsolidatedConfigurations.set(t,u)):u=r}return u}getFolderConfigurationModelForResource(t,u){if(u&&t){const r=u.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,u)=>{const{contents:r,overrides:i,keys:o}=this._folderConfigurations.get(u);return t.push([u,{contents:r,overrides:i,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(u=>t.add(u)),this.userConfiguration.freeze().keys.forEach(u=>t.add(u)),this._workspaceConfiguration.freeze().keys.forEach(u=>t.add(u)),this._folderConfigurations.forEach(u=>u.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const u=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>u.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>u.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>u.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(i=>u.add(i))),[...u.values()]}static parse(t){const u=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((l,d)=>(l.set(T.URI.revive(d[0]),this.parseConfigurationModel(d[1])),l),new R.ResourceMap);return new A(u,r,new f,i,o,new f,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=A;function E(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const t=new Set,u=new Map;for(const i of g)i.keys.forEach(o=>t.add(o)),i.overrides.forEach(([o,l])=>{const d=(0,R.getOrSet)(u,o,new Set);l.forEach(b=>d.add(b))});const r=[];return u.forEach((i,o)=>r.push([o,[...i.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=E;class a{constructor(t,u,r,i){this.change=t,this.previous=u,this.currentConfiguraiton=r,this.currentWorkspace=i,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(d=>o.add(d)),t.overrides.forEach(([,d])=>d.forEach(b=>o.add(b))),this.affectedKeys=[...o.values()];const l=new f;this.affectedKeys.forEach(d=>l.setValue(d,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=A.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,u){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(u){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,u,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,u,this.currentWorkspace);return!S.equals(r,i)}return!0}return!1}doesAffectedKeysTreeContains(t,u){let r=(0,n.toValuesTree)({[u]:!0},()=>{}),i;for(;typeof r=="object"&&(i=Object.keys(r)[0]);){if(t=t[i],!t)return!1;r=r[i]}return!0}}e.ConfigurationChangeEvent=a;class s extends a{constructor(t,u,r,i){super({keys:t.allKeys(),overrides:[]},void 0,t,u);this.source=r,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=s}),define(me[121],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var L;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(R,S=L.Unknown,y){super(R);this._message=R,this._code=S,this._detail=y,this.isHandled=S===L.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(R){return R instanceof k&&R._code===L.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof k&&R._code===L.NoResolverFound}static isHandled(R){return R instanceof k&&R.isHandled}}e.RemoteAuthorityResolverError=k}),define(me[86],ge([0,1,10]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(T){return T.scheme===m.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=L;function k(T){if(!T)return;const n=T.indexOf("+");return n<0?T:T.substr(0,n)}e.getRemoteName=k;function C(T){return T.scheme!==m.Schemas.file&&T.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=C;function R(T){if(T.folders.length)return T.folders.every(n=>C(n.uri))?T.folders[0].uri:void 0;if(T.configuration&&C(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=R;function S(T){return R(T)?.scheme}e.getVirtualWorkspaceScheme=S;function y(T){return R(T)!==void 0}e.isVirtualWorkspace=y}),define(me[194],ge([0,1,3,11,4,12]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var R;(function(f){f.Http="http",f.Https="https"})(R=e.TunnelProtocol||(e.TunnelProtocol={}));var S;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function T(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=T,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function n(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=n;function I(f,h){return h?h!==1&&f<1024:!L.isWindows&&f<1024}e.isPortPrivileged=I;let c=class{constructor(h){this.logService=h,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h,p){return this._tunnelProvider=h,h?(this._canElevate=p.elevation,this._canMakePublic=p.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async h=>{const p=[],D=Array.from(this._tunnels.values());for(let A of D){const E=Array.from(A.values());for(let a of E){const s=await a.value;s&&p.push(s)}}h(p)})}async dispose(){for(const h of this._tunnels.values()){for(const{value:p}of h.values())await p.then(D=>D?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,p,D,A,E=!1,a=!1,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${D} on local port ${A}.`),!h)return;p||(p="localhost");const g=this.retainOrCreateTunnel(h,p,D,A,E,a,s);return g?g.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,D);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.makeTunnel(t);return(t.tunnelRemoteHost!==p||t.tunnelRemotePort!==D)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(u),u}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),g)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,public:h.public,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const p=this._tunnels.get(h.tunnelRemoteHost);if(p){const D=p.get(h.tunnelRemotePort);D&&(D.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,D))}}}}async tryDisposeTunnel(h,p,D){if(D.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${p}.`);const A=D.value.then(async E=>{E&&(await E.dispose(!0),this._onTunnelClosed.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(p),A}}async closeTunnel(h,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${p} `);const D=this._tunnels.get(h);if(D&&D.has(p)){const A=D.get(p);A.refcount=0,await this.tryDisposeTunnel(h,p,A)}}addTunnelToMap(h,p,D){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(p,{refcount:1,value:D})}async removeEmptyTunnelFromMap(h,p){const D=this._tunnels.get(h);D&&(await D.get(p)||D.delete(p),D.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,p){let D=[h];T(h)?(D.push(...e.LOCALHOST_ADDRESSES),D.push(...e.ALL_INTERFACES_ADDRESSES)):n(h)&&D.push(...e.ALL_INTERFACES_ADDRESSES);const A=D.map(E=>this._tunnels.get(E));for(const E of A){const a=E?.get(p);if(a)return a}}canTunnel(h){return!!y(h)}createWithProvider(h,p,D,A,E,a,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${D} on local port ${A}.`);const t={elevationRequired:E?I(A===void 0?D:A):!1},u={remoteAddress:{host:p,port:D},localAddressPort:A,public:a,protocol:s},r=h.forwardPort(u,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(p,D,r),r}};c=Ve([$e(0,C.ILogService)],c),e.AbstractTunnelService=c}),define(me[195],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{vsda(){return new Promise((k,C)=>J(["vsda"],k,C))}async sign(k){try{const C=await this.vsda(),R=new C.signer;if(R)return R.sign(k)}catch(C){}return k}}e.SignService=m}),define(me[196],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,C,R=5){let S;return S=C(y=>{const T=typeof y=="string"?y:y.data;let n=this._terminalBufferMap.get(k);if(n){n.data.push(T);return}const I=setTimeout(()=>this.flushBuffer(k),R);n={data:[T],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(k),S.dispose()}},this._terminalBufferMap.set(k,n)}),S}stopBuffering(k){const C=this._terminalBufferMap.get(k);C&&C.dispose()}flushBuffer(k){const C=this._terminalBufferMap.get(k);C&&(this._terminalBufferMap.delete(k),this._callback(k,C.data.join("")))}}e.TerminalDataBufferer=m}),define(me[197],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(me[64],ge([0,1,47,3,6,4,34,197]),function(J,e,m,L,k,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var y;(function(D){function A(E){return E&&typeof E=="object"&&typeof E.id=="string"}D.isThemeColor=A})(y=e.ThemeColor||(e.ThemeColor={}));function T(D){return{id:D}}e.themeColorFromId=T;var n;(function(D){function A(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color=="undefined"||y.isThemeColor(u.color))}D.isThemeIcon=A;const E=new RegExp(`^\\$\\((${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?)\\)$`);function a(u){const r=E.exec(u);if(!r)return;let[,i]=r;return{id:i}}D.fromString=a;function s(u,r){let i=u.id;const o=i.lastIndexOf("~");return o!==-1&&(i=i.substring(0,o)),r&&(i=`${i}~${r}`),{id:i}}D.modify=s;function g(u,r){return u.id===r.id&&u.color?.id===r.color?.id}D.isEqual=g;function t(u,r){return{id:u.id,color:r?T(r):void 0}}D.asThemeIcon=t,D.asClassNameArray=m.CSSIcon.asClassNameArray,D.asClassName=m.CSSIcon.asClassName,D.asCSSSelector=m.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=m.Codicon.file,e.FolderThemeIcon=m.Codicon.folder;function I(D){switch(D){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(A){return this.themingParticipants.push(A),this.onThemingParticipantAddedEmitter.fire(A),(0,k.toDisposable)(()=>{const E=this.themingParticipants.indexOf(A);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new c;R.Registry.add(e.Extensions.ThemingContribution,f);function h(D){return f.onColorThemeChange(D)}e.registerThemingParticipant=h;class p extends k.Disposable{constructor(A){super();this.themeService=A,this.theme=A.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(A){this.theme=A,this.updateStyles()}updateStyles(){}getColor(A,E){let a=this.theme.getColor(A);return a&&E&&(a=E(a,this.theme)),a?a.toString():null}}e.Themable=p}),define(me[198],ge([0,1,18,47,3,162,119,34,64]),function(J,e,m,L,k,C,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class T{constructor(){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,C.localize)(0,null)},fontCharacter:{type:"string",description:(0,C.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${L.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(A,E,a,s){const g=this.iconsById[A];if(g){if(a&&!g.description){g.description=a,this.iconSchema.properties[A].markdownDescription=`${a} $(${A})`;const r=this.iconReferenceSchema.enum.indexOf(A);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=a),this._onDidChange.fire()}return g}let t={id:A,description:a,defaults:E,deprecationMessage:s};this.iconsById[A]=t;let u={$ref:"#/definitions/icons"};return s&&(u.deprecationMessage=s),a&&(u.markdownDescription=`${a}: $(${A})`),this.iconSchema.properties[A]=u,this.iconReferenceSchema.enum.push(A),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:A}}deregisterIcon(A){delete this.iconsById[A],delete this.iconSchema.properties[A];const E=this.iconReferenceSchema.enum.indexOf(A);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(A=>this.iconsById[A])}getIcon(A){return this.iconsById[A]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(A,E){const a=this.iconFontsById[A];if(a)return a;let s={id:A,definition:E};return this.iconFontsById[A]=s,this._onDidChange.fire(),s}deregisterIconFont(A){delete this.iconFontsById[A]}getIconFonts(){return Object.keys(this.iconFontsById).map(A=>this.iconFontsById[A])}getIconFont(A){return this.iconFontsById[A]}toString(){const A=(g,t)=>g.id.localeCompare(t.id),E=g=>{for(;y.ThemeIcon.isThemeIcon(g.defaults);)g=this.iconsById[g.defaults.id];return`codicon codicon-${g?g.id:""}`};let a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.iconsById).map(g=>this.iconsById[g]);for(const g of s.filter(t=>!!t.description).sort(A))a.push(`|<i class="${E(g)}"></i>|${g.id}|${y.ThemeIcon.isThemeIcon(g.defaults)?g.defaults.id:g.id}|${g.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const g of s.filter(t=>!y.ThemeIcon.isThemeIcon(t.defaults)).sort(A))a.push(`|<i class="${E(g)}"></i>|${g.id}|`);return a.join(`
`)}}const n=new T;S.Registry.add(e.Extensions.IconContribution,n);function I(D,A,E,a){return n.registerIcon(D,A,E,a)}e.registerIcon=I;function c(){return n}e.getIconRegistry=c;function f(){for(const D of L.iconRegistry.all)n.registerIcon(D.id,D.definition,D.description);L.iconRegistry.onDidRegister(D=>n.registerIcon(D.id,D.definition,D.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let h=S.Registry.as(R.Extensions.JSONContribution);h.registerSchema(e.iconsSchemaId,n.getIconSchema());const p=new m.RunOnceScheduler(()=>h.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{p.isScheduled()||p.schedule()}),e.widgetClose=I("widget-close",L.Codicon.close,(0,C.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",L.Codicon.arrowUp,(0,C.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",L.Codicon.arrowDown,(0,C.localize)(4,null)),e.syncing=y.ThemeIcon.modify(L.Codicon.sync,"spin")}),define(me[44],ge([0,1,24,23,2,4]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var R;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(R=e.WorkbenchState||(e.WorkbenchState={}));function S(c){const f=c;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=S;function y(c){const f=c;return!!(f&&typeof f=="object"&&k.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=y;class T{constructor(f,h,p,D){this._id=f,this._configuration=p,this._ignorePathCasing=D,this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=h}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=T;class n{constructor(f,h){this.raw=h,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,L.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function I(c){return new n({uri:c,index:0,name:(0,L.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=I}),define(me[199],ge([0,1,29,60,138,79,10,8,11,23,2,163,4,86,44]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const p=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(N){return(typeof N=="string"?(0,S.extname)(N):(0,T.extname)(N))===p}e.hasWorkspaceFileExtension=D,e.IWorkspacesService=(0,c.createDecorator)("workspacesService");function A(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=A;function E(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=E;function a(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=a;function s(N){const z=N;return typeof z?.id=="string"&&n.URI.isUri(z.uri)}e.isSingleFolderWorkspaceIdentifier=s;function g(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=g;function t(N){const z=N;return typeof z?.id=="string"&&n.URI.isUri(z.configPath)}e.isWorkspaceIdentifier=t;function u(N){const z=N;if(z?.uri)return{id:z.id,uri:n.URI.revive(z.uri)};const O=N;if(O?.configPath)return{id:O.id,configPath:n.URI.revive(O.configPath)};if(N?.id)return{id:N.id}}e.reviveIdentifier=u;function r(N,z){return T.extUriBiasedIgnorePathCase.isEqualOrParent(N,z.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function i(N){return o(N)||l(N)}e.isStoredWorkspaceFolder=i;function o(N){const z=N;return typeof z?.path=="string"&&(!z.name||typeof z.name=="string")}e.isRawFileWorkspaceFolder=o;function l(N){const z=N;return typeof z?.uri=="string"&&(!z.name||typeof z.name=="string")}e.isRawUriWorkspaceFolder=l;function d(N,z,O,x,B=!y.isWindows,U){if(N.scheme!==x.scheme)return{name:O,uri:N.toString(!0)};let H=z?void 0:U.relativePath(x,N);if(H!==void 0)H.length===0?H=".":y.isWindows&&N.scheme===R.Schemas.file&&!B&&(H=H.replace(/\//g,"\\"));else if(N.scheme===R.Schemas.file)H=N.fsPath,y.isWindows&&(H=(0,C.normalizeDriveLetter)(H),B&&(H=(0,m.toSlashes)(H)));else{if(!U.isEqualAuthority(N.authority,x.authority))return{name:O,uri:N.toString(!0)};H=N.path}return{name:O,path:H}}e.getStoredWorkspaceFolder=d;function b(N,z,O){let x=[],B=new Set;const U=O.dirname(z);for(let H of N){let W;if(o(H))H.path&&(W=O.resolvePath(U,H.path));else if(l(H))try{W=n.URI.parse(H.uri),W.path[0]!=="/"&&(W=W.with({path:"/"+W.path}))}catch(Q){console.warn(Q)}if(W){let Q=O.getComparisonKey(W);if(!B.has(Q)){B.add(Q);const Y=H.name||O.basenameOrAuthority(W);x.push(new h.WorkspaceFolder({uri:W,name:Y,index:x.length},H))}}}return x}e.toWorkspaceFolders=b;function _(N,z,O,x,B){let U=v(z,N);const H=B.dirname(z),W=B.dirname(x),Q=[],Y=P(U.folders);for(const Re of U.folders){const xe=o(Re)?B.resolvePath(H,Re.path):n.URI.parse(Re.uri);let Ue;O?Ue=!1:Ue=!o(Re)||(0,S.isAbsolute)(Re.path),Q.push(d(xe,Ue,Re.name,W,Y,B))}const he={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},_e=k.setProperty(N,["folders"],Q,he);let Se=k.applyEdits(N,_e);return U.remoteAuthority===(0,f.getRemoteAuthority)(x)&&(Se=k.applyEdits(Se,k.removeProperty(Se,["remoteAuthority"],he))),Se}e.rewriteWorkspaceFileForNewLocation=_;function v(N,z){let O=L.parse(z);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(x=>i(x));else throw new Error(`${N} looks like an invalid workspace file.`);return O}function P(N){return y.isWindows?N.some(z=>o(z)&&z.path.indexOf("/")>=0):!0}e.useSlashForPath=P;function w(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function F(N){return typeof N.folderUri=="string"}function M(N){return typeof N.fileUri=="string"}function K(N,z){const O={workspaces:[],files:[]};if(N){const x=function(U,H){for(let W=0;W<U.length;W++)try{H(U[W],W)}catch(Q){z.warn(`Error restoring recent entry ${JSON.stringify(U[W])}: ${Q.toString()}. Skip entry.`)}},B=N;if(Array.isArray(B.entries))x(B.entries,U=>{const H=U.label,W=U.remoteAuthority;w(U)?O.workspaces.push({label:H,remoteAuthority:W,workspace:{id:U.workspace.id,configPath:n.URI.parse(U.workspace.configPath)}}):F(U)?O.workspaces.push({label:H,remoteAuthority:W,folderUri:n.URI.parse(U.folderUri)}):M(U)&&O.files.push({label:H,remoteAuthority:W,fileUri:n.URI.parse(U.fileUri)})});else{const U=N;Array.isArray(U.workspaces3)&&x(U.workspaces3,(H,W)=>{const Q=Array.isArray(U.workspaceLabels)&&U.workspaceLabels[W]||void 0;typeof H=="object"&&typeof H.id=="string"&&typeof H.configURIPath=="string"?O.workspaces.push({label:Q,workspace:{id:H.id,configPath:n.URI.parse(H.configURIPath)}}):typeof H=="string"&&O.workspaces.push({label:Q,folderUri:n.URI.parse(H)})}),Array.isArray(U.files2)&&x(U.files2,(H,W)=>{const Q=Array.isArray(U.fileLabels)&&U.fileLabels[W]||void 0;typeof H=="string"&&O.files.push({label:Q,fileUri:n.URI.parse(H)})})}}return O}e.restoreRecentlyOpened=K;function G(N){const z={entries:[]};for(const O of N.workspaces)E(O)?z.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):z.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of N.files)z.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return z}e.toStoreData=G}),define(me[87],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const C=this._idPool++;return this._data.set(C,k),this.logDebugInfo(),C}get(k,C){return this._data.has(k)?this._data.get(k)[C]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(me[52],ge([0,1,10,23,4]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(S=>{const y=this._providerInfo.get(S.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(S,y){y===null?this._providerInfo.delete(S):this._providerInfo.set(S,y)}isFreeScheme(S){return!this._providerInfo.has(S)&&!this._systemSchemes.has(S)}getCapabilities(S){return this._providerInfo.get(S)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(me[200],ge([0,1,18]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(R,S,y){this._deferredPromises=new Map,this._id=R,this._shared=S,this._storage=y,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of T.values())n.complete()}catch(n){for(const I of T.values())I.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,S){let y=this._value[R];return typeof y=="undefined"&&(y=S),y}update(R,S){this._value[R]=S;let y=this._deferredPromises.get(R);if(y!==void 0)return y.p;const T=new m.DeferredPromise;return this._deferredPromises.set(R,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class k extends L{constructor(R,S){super(R.identifier.value,!0,S);this._extension=R}setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}}e.ExtensionGlobalMemento=k}),define(me[201],ge([0,1,3,2,12]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(S,y){this._logService=S,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(S,y,T){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(S)).acceptModelChanged(y.value,T)}$acceptDirtyStateChanged(S,y){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(S)).acceptDirty(y)}$acceptModelSaved(S){const y=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(S));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(S,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",S.path,y);const T=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(S));T.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};C=Ve([$e(0,k.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(me[14],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class L{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=L});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[202],ge([0,1,26,3]),function(J,e,m,L){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(S,y){k.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(S.identifier),nt(this,k,y,"f"),Oe(this,k,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(S){return Oe(this,k,"f").get(this._id,S)}store(S,y){return Oe(this,k,"f").store(this._id,S,y)}delete(S){return Oe(this,k,"f").delete(this._id,S)}}e.ExtensionSecrets=C,k=new WeakMap}),define(me[122],ge([0,1,4,3]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(R){this._enabled=R}$onDidChangeTelemetryEnabled(R){this._enabled=R,this._onDidChangeTelemetryEnabled.fire(R)}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(me[65],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(E){E[E.Upsert=0]="Upsert",E[E.RemoveChild=1]="RemoveChild",E[E.Invalidated=2]="Invalidated",E[E.SetProp=3]="SetProp",E[E.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,k=(E,a)=>{const s={controllerId:a};return L.set(E,s),s};e.createPrivateApiFor=k;const C=E=>L.get(E);e.getPrivateApiFor=C;const R=(E,a,s,g)=>{let t=s;return{enumerable:!0,configurable:!1,get(){return t},set(u){if(!g(t,u)){const r=t;t=u,E.listener?.({op:3,key:a,value:u,previous:r})}}}},S=(E,a)=>E===a,y={range:(E,a)=>E===a?!0:!E||!a?!1:E.isEqual(a),label:S,description:S,busy:S,error:S,canResolveChildren:S,tags:(E,a)=>!(E.length!==a.length||E.some(s=>!a.find(g=>s.id===g.id)))},T=Object.keys(y),n=(E,a)=>({range:R(E,"range",void 0,y.range),label:R(E,"label",a,y.label),description:R(E,"description",void 0,y.description),canResolveChildren:R(E,"canResolveChildren",!1,y.canResolveChildren),busy:R(E,"busy",!1,y.busy),error:R(E,"error",void 0,y.error),tags:R(E,"tags",[],y.tags)}),I=(E,a)=>{const s=new Map;for(const g of T)y[g](E[g],a[g])||s.set(g,a[g]);return s};e.diffTestItems=I;class c extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=c;class f extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class h extends Error{constructor(a,s,g){super(`TestItem with ID "${a}" is from controller "${s}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=h;const p=E=>{const a=(0,e.getPrivateApiFor)(E);let s=new Map;return{get size(){return s.size},forEach(g,t){for(const u of s.values())g.call(t,u,this)},replace(g){const t=new Map,u=new Set(s.keys()),r={op:4,ops:[]};for(const i of g){if(!(i instanceof D))throw new f(i.id);const o=(0,e.getPrivateApiFor)(i).controllerId;if(o!==a.controllerId)throw new h(i.id,o,a.controllerId);if(t.has(i.id))throw new c(i.id);t.set(i.id,i),u.delete(i.id),r.ops.push({op:0,item:i})}for(const i of u.keys())r.ops.push({op:1,id:i});a.listener?.(r),s=t},add(g){if(!(g instanceof D))throw new f(g.id);s.set(g.id,g),a.listener?.({op:0,item:g})},delete(g){s.delete(g)&&a.listener?.({op:1,id:g})},get(g){return s.get(g)},toJSON(){return Array.from(s.values())},[Symbol.iterator](){return s.values()}}};class D{constructor(a,s,g,t){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const u=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof A?void 0:u.parent}},children:{value:p(this),enumerable:!0,writable:!1},...n(u,g)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=D;class A extends D{constructor(a,s){super(a,a,s,void 0)}}e.TestItemRootImpl=A}),define(me[53],ge([0,1,4,3,14]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var C;(function(S){function y(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}S.fromApiTunnel=y;function T(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}S.fromServiceTunnel=T})(C=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let R=class{constructor(y){this.onDidChangeTunnels=new L.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,T){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,T){return{dispose:()=>{}}}async $providePortAttributes(y,T,n,I,c){return[]}async $forwardPort(y,T){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=Ve([$e(0,k.IExtHostRpcService)],R),e.ExtHostTunnelService=R});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[7],ge([0,1,17,16,99,24,102,13,2,32,43,121]),function(J,e,m,L,k,C,R,S,y,T,n,I){"use strict";var c,f,h,p,D,A,E,a,s,g,t,u,r,i,o,l,d,b,_,v;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function P(j){function $(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf($,j),Object.setPrototypeOf($.prototype,j.prototype),$}let w=D=class{constructor($){c.set(this,void 0),nt(this,c,$,"f")}static from(...$){let se=$;return new D(function(){if(se){for(const De of se)De&&typeof De.dispose=="function"&&De.dispose();se=void 0}})}dispose(){typeof Oe(this,c,"f")=="function"&&(Oe(this,c,"f").call(this),nt(this,c,void 0,"f"))}};c=new WeakMap,w=D=Ve([P],w),e.Disposable=w;let F=A=class{constructor($,se){if($<0)throw(0,L.illegalArgument)("line must be non-negative");if(se<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=$,this._character=se}static Min(...$){if($.length===0)throw new TypeError;let se=$[0];for(let De=1;De<$.length;De++){const et=$[De];et.isBefore(se)&&(se=et)}return se}static Max(...$){if($.length===0)throw new TypeError;let se=$[0];for(let De=1;De<$.length;De++){const et=$[De];et.isAfter(se)&&(se=et)}return se}static isPosition($){if(!$)return!1;if($ instanceof A)return!0;let{line:se,character:De}=$;return typeof se=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,se=0){if($===null||se===null)throw(0,L.illegalArgument)();let De;return typeof $=="undefined"?De=0:typeof $=="number"?De=$:(De=typeof $.lineDelta=="number"?$.lineDelta:0,se=typeof $.characterDelta=="number"?$.characterDelta:0),De===0&&se===0?this:new A(this.line+De,this.character+se)}with($,se=this.character){if($===null||se===null)throw(0,L.illegalArgument)();let De;return typeof $=="undefined"?De=this.line:typeof $=="number"?De=$:(De=typeof $.line=="number"?$.line:this.line,se=typeof $.character=="number"?$.character:this.character),De===this.line&&se===this.character?this:new A(De,se)}toJSON(){return{line:this.line,character:this.character}}};F=A=Ve([P],F),e.Position=F;let M=E=class{constructor($,se,De,et){let rt,ht;if(typeof $=="number"&&typeof se=="number"&&typeof De=="number"&&typeof et=="number"?(rt=new F($,se),ht=new F(De,et)):$ instanceof F&&se instanceof F&&(rt=$,ht=se),!rt||!ht)throw new Error("Invalid arguments");rt.isBefore(ht)?(this._start=rt,this._end=ht):(this._start=ht,this._end=rt)}static isRange($){return $ instanceof E?!0:$?F.isPosition($.start)&&F.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof E?this.contains($._start)&&this.contains($._end):$ instanceof F?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const se=F.Max($.start,this._start),De=F.Min($.end,this._end);if(!se.isAfter(De))return new E(se,De)}union($){if(this.contains($))return this;if($.contains(this))return $;const se=F.Min($.start,this._start),De=F.Max($.end,this.end);return new E(se,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,se=this.end){if($===null||se===null)throw(0,L.illegalArgument)();let De;return $?F.isPosition($)?De=$:(De=$.start||this.start,se=$.end||this.end):De=this.start,De.isEqual(this._start)&&se.isEqual(this.end)?this:new E(De,se)}toJSON(){return[this.start,this.end]}};M=E=Ve([P],M),e.Range=M;let K=a=class extends M{constructor($,se,De,et){let rt,ht;if(typeof $=="number"&&typeof se=="number"&&typeof De=="number"&&typeof et=="number"?(rt=new F($,se),ht=new F(De,et)):$ instanceof F&&se instanceof F&&(rt=$,ht=se),!rt||!ht)throw new Error("Invalid arguments");super(rt,ht);this._anchor=rt,this._active=ht}static isSelection($){return $ instanceof a?!0:$?M.isRange($)&&F.isPosition($.anchor)&&F.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};K=a=Ve([P],K),e.Selection=K;class G{constructor($,se,De){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,L.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,L.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(se),this.connectionToken=De}}e.ResolvedAuthority=G;class N extends Error{constructor($,se=I.RemoteAuthorityResolverErrorCode.Unknown,De){super($);this._message=$,this._code=se,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,N.prototype)}static NotAvailable($,se){return new N($,I.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable($){return new N($,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=N;var z;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(z=e.EndOfLine||(e.EndOfLine={}));var O;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(O=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let x=s=class{constructor($,se){this._range=$,this._newText=se}static isTextEdit($){return $ instanceof s?!0:$?M.isRange($)&&typeof $.newText=="string":!1}static replace($,se){return new s($,se)}static insert($,se){return s.replace(new M($,$),se)}static delete($){return s.replace($,"")}static setEndOfLine($){const se=new s(new M(new F(0,0),new F(0,0)),"");return se.newEol=$,se}get range(){return this._range}set range($){if($&&!M.isRange($))throw(0,L.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,L.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,L.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};x=s=Ve([P],x),e.TextEdit=x;var B;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace"})(B=e.FileEditType||(e.FileEditType={}));let U=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,se,De,et){this._edits.push({_type:1,from:$,to:se,options:De,metadata:et})}createFile($,se,De){this._edits.push({_type:1,from:void 0,to:$,options:se,metadata:De})}deleteFile($,se,De){this._edits.push({_type:1,from:$,to:void 0,options:se,metadata:De})}replaceNotebookMetadata($,se,De){this._edits.push({_type:3,metadata:De,uri:$,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells($,se,De,et,rt){let ht,mt,Ct=[],At;if(Vt.isNotebookRange(se)&&Ft.isNotebookCellDataArray(De)&&!Ft.isNotebookCellDataArray(et)?(ht=se.start,mt=se.end,Ct=De,At=et):typeof se=="number"&&typeof De=="number"&&Ft.isNotebookCellDataArray(et)&&(ht=se,mt=De,Ct=et,At=rt),ht===void 0||mt===void 0)throw new Error("Invalid arguments");(ht!==mt||Ct.length>0)&&this._edits.push({_type:5,uri:$,index:ht,count:mt-ht,cells:Ct,metadata:At})}replaceNotebookCellMetadata($,se,De,et){this._edits.push({_type:3,metadata:et,uri:$,edit:{editType:8,index:se,metadata:De}})}replace($,se,De,et){this._edits.push({_type:2,uri:$,edit:new x(se,De),metadata:et})}insert($,se,De,et){this.replace($,new M(se,se),De,et)}delete($,se,De){this.replace($,se,"",De)}has($){return this._edits.some(se=>se._type===2&&se.uri.toString()===$.toString())}set($,se){if(se)for(const De of se)De&&this._edits.push({_type:2,uri:$,edit:De});else{for(let De=0;De<this._edits.length;De++){const et=this._edits[De];et._type===2&&et.uri.toString()===$.toString()&&(this._edits[De]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get($){const se=[];for(let De of this._edits)De._type===2&&De.uri.toString()===$.toString()&&se.push(De.edit);return se}entries(){const $=new C.ResourceMap;for(let se of this._edits)if(se._type===2){let De=$.get(se.uri);De||(De=[se.uri,[]],$.set(se.uri,De)),De[1].push(se.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};U=Ve([P],U),e.WorkspaceEdit=U;let H=g=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof g?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=g._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,se=this._tabstop++){if(typeof $=="function"){const De=new g;De._tabstop=this._tabstop,$(De),this._tabstop=De._tabstop,$=De.value}else $=g._escape($);return this.value+="${",this.value+=se,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,se=this._tabstop++){const De=$.map(et=>et.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable($,se){if(typeof se=="function"){const De=new g;De._tabstop=this._tabstop,se(De),this._tabstop=De._tabstop,se=De.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,se&&(this.value+=":",this.value+=se),this.value+="}",this}};H=g=Ve([P],H),e.SnippetString=H;var W;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(W=e.DiagnosticTag||(e.DiagnosticTag={}));var Q;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(Q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Y=t=class{constructor($,se){if(this.uri=$,se)if(se instanceof M)this.range=se;else if(se instanceof F)this.range=new M(se,se);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof t?!0:$?M.isRange($.range)&&y.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Y=t=Ve([P],Y),e.Location=Y;let he=class{constructor($,se){this.location=$,this.message=se}static is($){return $?typeof $.message=="string"&&$.location&&M.isRange($.location.range)&&y.URI.isUri($.location.uri):!1}static isEqual($,se){return $===se?!0:!$||!se?!1:$.message===se.message&&$.location.range.isEqual(se.location.range)&&$.location.uri.toString()===se.location.uri.toString()}};he=Ve([P],he),e.DiagnosticRelatedInformation=he;let _e=class{constructor($,se,De=Q.Error){if(!M.isRange($))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=$,this.message=se,this.severity=De}toJSON(){return{severity:Q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,se){return $===se?!0:!$||!se?!1:$.message===se.message&&$.severity===se.severity&&$.code===se.code&&$.severity===se.severity&&$.source===se.source&&$.range.isEqual(se.range)&&(0,m.equals)($.tags,se.tags)&&(0,m.equals)($.relatedInformation,se.relatedInformation,he.isEqual)}};_e=Ve([P],_e),e.Diagnostic=_e;let Se=class{constructor($,se){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=se}};Se=Ve([P],Se),e.Hover=Se;var Re;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Re=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let xe=class{constructor($,se=Re.Text){this.range=$,this.kind=se}toJSON(){return{range:this.range,kind:Re[this.kind]}}};xe=Ve([P],xe),e.DocumentHighlight=xe;var Ue;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Ue=e.SymbolKind||(e.SymbolKind={}));var je;(function(j){j[j.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let V=u=class{constructor($,se,De,et,rt){this.name=$,this.kind=se,this.containerName=rt,typeof De=="string"&&(this.containerName=De),et instanceof Y?this.location=et:De instanceof M&&(this.location=new Y(et,De)),u.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ue[this.kind],location:this.location,containerName:this.containerName}}};V=u=Ve([P],V),e.SymbolInformation=V;let ee=r=class{constructor($,se,De,et,rt){this.name=$,this.detail=se,this.kind=De,this.range=et,this.selectionRange=rt,this.children=[],r.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(r.validate)}};ee=r=Ve([P],ee),e.DocumentSymbol=ee;var re;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(re=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor($,se){this.title=$,this.kind=se}};le=Ve([P],le),e.CodeAction=le;let Z=i=class{constructor($){this.value=$}append($){return new i(this.value?this.value+i.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+i.sep)}};Z.sep=".",Z=i=Ve([P],Z),e.CodeActionKind=Z,Z.Empty=new Z(""),Z.QuickFix=Z.Empty.append("quickfix"),Z.Refactor=Z.Empty.append("refactor"),Z.RefactorExtract=Z.Refactor.append("extract"),Z.RefactorInline=Z.Refactor.append("inline"),Z.RefactorRewrite=Z.Refactor.append("rewrite"),Z.Source=Z.Empty.append("source"),Z.SourceOrganizeImports=Z.Source.append("organizeImports"),Z.SourceFixAll=Z.Source.append("fixAll");let oe=class{constructor($,se){if(this.range=$,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=Ve([P],oe),e.SelectionRange=oe;class ve{constructor($,se,De,et,rt,ht){this.kind=$,this.name=se,this.detail=De,this.uri=et,this.range=rt,this.selectionRange=ht}}e.CallHierarchyItem=ve;class Me{constructor($,se){this.fromRanges=se,this.from=$}}e.CallHierarchyIncomingCall=Me;class qe{constructor($,se){this.fromRanges=se,this.to=$}}e.CallHierarchyOutgoingCall=qe;var Qe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Je=class{constructor($,se){this.range=$,this.command=se}get isResolved(){return!!this.command}};Je=Ve([P],Je),e.CodeLens=Je;let Ce=o=class{constructor($,se=!1){f.set(this,void 0),nt(this,f,new k.MarkdownString($,{supportThemeIcons:se}),"f")}static isMarkdownString($){return $ instanceof o?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return Oe(this,f,"f").value}set value($){Oe(this,f,"f").value=$}get isTrusted(){return Oe(this,f,"f").isTrusted}set isTrusted($){Oe(this,f,"f").isTrusted=$}get supportThemeIcons(){return Oe(this,f,"f").supportThemeIcons}set supportThemeIcons($){Oe(this,f,"f").supportThemeIcons=$}get supportHtml(){return Oe(this,f,"f").supportHtml}set supportHtml($){Oe(this,f,"f").supportHtml=$}appendText($){return Oe(this,f,"f").appendText($),this}appendMarkdown($){return Oe(this,f,"f").appendMarkdown($),this}appendCodeblock($,se){return Oe(this,f,"f").appendCodeblock(se??"",$),this}};f=new WeakMap,Ce=o=Ve([P],Ce),e.MarkdownString=Ce;let at=class{constructor($,se){this.label=$,this.documentation=se}};at=Ve([P],at),e.ParameterInformation=at;let X=class{constructor($,se){this.label=$,this.documentation=se,this.parameters=[]}};X=Ve([P],X),e.SignatureInformation=X;let te=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};te=Ve([P],te),e.SignatureHelp=te;var pe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(pe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ze;(function(j){j[j.Other=0]="Other",j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(ze=e.InlayHintKind||(e.InlayHintKind={}));let tt=class{constructor($,se,De){this.text=$,this.position=se,this.kind=De}};tt=Ve([P],tt),e.InlayHint=tt;var ut;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ut=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var lt;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(lt=e.CompletionItemKind||(e.CompletionItemKind={}));var vt;(function(j){j[j.Deprecated=1]="Deprecated"})(vt=e.CompletionItemTag||(e.CompletionItemTag={}));let Dt=class{constructor($,se){this.label=$,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&lt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Dt=Ve([P],Dt),e.CompletionItem=Dt;let ue=class{constructor($=[],se=!1){this.items=$,this.isIncomplete=se}};ue=Ve([P],ue),e.CompletionList=ue;let Ie=class{constructor($,se,De){this.text=$,this.range=se,this.command=De}};Ie=Ve([P],Ie),e.InlineSuggestion=Ie;let Be=class{constructor($){this.items=$}};Be=Ve([P],Be),e.InlineSuggestions=Be;var Ke;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(Ke=e.ViewColumn||(e.ViewColumn={}));var We;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(We=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ot;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(ot=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Le;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Le=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ke;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ne;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(ne=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var de;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(de=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function $(se){switch(se){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=$}(ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let be=class{constructor($,se){if(se&&!y.URI.isUri(se))throw(0,L.illegalArgument)("target");if(!M.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.target=se}};be=Ve([P],be),e.DocumentLink=be;let we=class{constructor($,se,De,et){this.red=$,this.green=se,this.blue=De,this.alpha=et}};we=Ve([P],we),e.Color=we;let Fe=class{constructor($,se){if(se&&!(se instanceof we))throw(0,L.illegalArgument)("color");if(!M.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.color=se}};Fe=Ve([P],Fe),e.ColorInformation=Fe;let Ge=class{constructor($){if(!$||typeof $!="string")throw(0,L.illegalArgument)("label");this.label=$}};Ge=Ve([P],Ge),e.ColorPresentation=Ge;var He;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(He=e.ColorFormat||(e.ColorFormat={}));var Ye;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Ye=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class it{constructor($,se,De){if(this.startIndex=$,this.length=se,this.tooltip=De,typeof $!="number"||$<0)throw(0,L.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,L.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=it;var ae;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(ae=e.TerminalLocation||(e.TerminalLocation={}));class Ee{constructor($){this.options=$,typeof $!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=Ee;var ce;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ce=e.TaskRevealKind||(e.TaskRevealKind={}));var q;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(q=e.TaskPanelKind||(e.TaskPanelKind={}));let Te=l=class{constructor($,se){if(this.label=se,typeof $!="string"||typeof se!="string")throw(0,L.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};Te.Clean=new l("clean","Clean"),Te.Build=new l("build","Build"),Te.Rebuild=new l("rebuild","Rebuild"),Te.Test=new l("test","Test"),Te=l=Ve([P],Te),e.TaskGroup=Te;function Pe(j){let $="";for(let se=0;se<j.length;se++)$+=j[se].replace(/,/g,",,")+",";return $}let Ze=class{constructor($,se,De){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=$,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=De):this._options=se)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let se of this._args)$.push(se);return Pe($)}};Ze=Ve([P],Ze),e.ProcessExecution=Ze;let Xe=class{constructor($,se,De){if(this._args=[],Array.isArray(se)){if(!$)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$,this._args=se,this._options=De}else{if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$,this._options=se}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)$.push(typeof se=="string"?se:se.value);return Pe($)}};Xe=Ve([P],Xe),e.ShellExecution=Xe;var st;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(st=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class _t{constructor($){this._callback=$}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=_t;let dt=d=class{constructor($,se,De,et,rt,ht){this.__deprecated=!1,this._definition=this.definition=$;let mt;typeof se=="string"?(this._name=this.name=se,this._source=this.source=De,this.execution=et,mt=rt,this.__deprecated=!0):se===wt.Global||se===wt.Workspace?(this.target=se,this._name=this.name=De,this._source=this.source=et,this.execution=rt,mt=ht):(this.target=se,this._name=this.name=De,this._source=this.source=et,this.execution=rt,mt=ht),typeof mt=="string"?(this._problemMatchers=[mt],this._hasDefinedMatchers=!0):Array.isArray(mt)?(this._problemMatchers=mt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ze?this._definition={type:d.ProcessType,id:this._execution.computeId()}:this._execution instanceof Xe?this._definition={type:d.ShellType,id:this._execution.computeId()}:this._execution instanceof _t?this._definition={type:d.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:d.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const se=this._definition.type;(d.EmptyType===se||d.ProcessType===se||d.ShellType===se||d.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};dt.ExtensionCallbackType="customExecution",dt.ProcessType="process",dt.ShellType="shell",dt.EmptyType="$empty",dt=d=Ve([P],dt),e.Task=dt;var gt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let ft=class{constructor($,se=Tt.None){this.collapsibleState=se,y.URI.isUri($)?this.resourceUri=$:this.label=$}};ft=Ve([P],ft),e.TreeItem=ft;var Tt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Tt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let yt=class{constructor($,se){this.id=$,this.color=se}};yt=Ve([P],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let Bt=class{constructor($){this.id=$}};Bt=Ve([P],Bt),e.ThemeColor=Bt;var $t;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})($t=e.ConfigurationTarget||(e.ConfigurationTarget={}));let It=class{constructor($,se){if(typeof $!="string"&&(!$||!y.URI.isUri($)&&!y.URI.isUri($.uri)))throw(0,L.illegalArgument)("base");if(typeof se!="string")throw(0,L.illegalArgument)("pattern");typeof $=="string"?(this.baseFolder=y.URI.file($),this.base=$):y.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=se}};It=Ve([P],It),e.RelativePattern=It;let Wt=class{constructor($,se,De,et){this.enabled=typeof $=="boolean"?$:!0,typeof se=="string"&&(this.condition=se),typeof De=="string"&&(this.hitCondition=De),typeof et=="string"&&(this.logMessage=et)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};Wt=Ve([P],Wt),e.Breakpoint=Wt;let en=class extends Wt{constructor($,se,De,et,rt){super(se,De,et,rt);if($===null)throw(0,L.illegalArgument)("location");this.location=$}};en=Ve([P],en),e.SourceBreakpoint=en;let bt=class extends Wt{constructor($,se,De,et,rt){super(se,De,et,rt);this.functionName=$}};bt=Ve([P],bt),e.FunctionBreakpoint=bt;let Qt=class extends Wt{constructor($,se,De,et,rt,ht,mt){super(et,rt,ht,mt);if(!se)throw(0,L.illegalArgument)("dataId");this.label=$,this.dataId=se,this.canPersist=De}};Qt=Ve([P],Qt),e.DataBreakpoint=Qt;let jt=class{constructor($,se,De){this.command=$,this.args=se||[],this.options=De}};jt=Ve([P],jt),e.DebugAdapterExecutable=jt;let tn=class{constructor($,se){this.port=$,this.host=se}};tn=Ve([P],tn),e.DebugAdapterServer=tn;let nn=class{constructor($){this.path=$}};nn=Ve([P],nn),e.DebugAdapterNamedPipeServer=nn;let Pt=class{constructor($){this.implementation=$}};Pt=Ve([P],Pt),e.DebugAdapterInlineImplementation=Pt;let Xt=class{constructor($,se){this.range=$,this.expression=se}};Xt=Ve([P],Xt),e.EvaluatableExpression=Xt;var bn;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(bn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Ht=class{constructor($,se){this.range=$,this.text=se}};Ht=Ve([P],Ht),e.InlineValueText=Ht;let zt=class{constructor($,se,De=!0){this.range=$,this.variableName=se,this.caseSensitiveLookup=De}};zt=Ve([P],zt),e.InlineValueVariableLookup=zt;let pt=class{constructor($,se){this.range=$,this.expression=se}};pt=Ve([P],pt),e.InlineValueEvaluatableExpression=pt;let rn=class{constructor($,se){this.frameId=$,this.stoppedLocation=se}};rn=Ve([P],rn),e.InlineValueContext=rn;var Ot;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Nt=b=class extends Error{constructor($,se=n.FileSystemProviderErrorCode.Unknown,De){super(y.URI.isUri($)?$.toString(!0):$);this.code=De?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists($){return new b($,n.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound($){return new b($,n.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory($){return new b($,n.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory($){return new b($,n.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions($){return new b($,n.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable($){return new b($,n.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};Nt=b=Ve([P],Nt),e.FileSystemError=Nt;let Yt=class{constructor($,se,De){this.start=$,this.end=se,this.kind=De}};Yt=Ve([P],Yt),e.FoldingRange=Yt;var En;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(En=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class mn{constructor($,se=[]){this.tokenTypes=$,this.tokenModifiers=se}}e.SemanticTokensLegend=mn;function sn(j){return typeof j=="undefined"||(0,S.isStringArray)(j)}class on{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let se=0,De=$.tokenTypes.length;se<De;se++)this._tokenTypeStrToInt.set($.tokenTypes[se],se);for(let se=0,De=$.tokenModifiers.length;se<De;se++)this._tokenModifierStrToInt.set($.tokenModifiers[se],se)}}push($,se,De,et,rt){if(typeof $=="number"&&typeof se=="number"&&typeof De=="number"&&typeof et=="number"&&(typeof rt=="number"||typeof rt=="undefined"))return typeof rt=="undefined"&&(rt=0),this._pushEncoded($,se,De,et,rt);if(M.isRange($)&&typeof se=="string"&&sn(De))return this._push($,se,De);throw(0,L.illegalArgument)()}_push($,se,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const et=$.start.line,rt=$.start.character,ht=$.end.character-$.start.character,mt=this._tokenTypeStrToInt.get(se);let Ct=0;if(De)for(const At of De){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(At);Ct|=1<<Lt>>>0}this._pushEncoded(et,rt,ht,mt,Ct)}_pushEncoded($,se,De,et,rt){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ct=this._data.length/5|0;let At=0,Lt=0;for(let Mt=0;Mt<Ct;Mt++){let Ut=this._data[5*Mt],dn=this._data[5*Mt+1];Ut===0?(Ut=At,dn+=Lt):Ut+=At,this._data[5*Mt]=Ut,this._data[5*Mt+1]=dn,At=Ut,Lt=dn}}let ht=$,mt=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ht-=this._prevLine,ht===0&&(mt-=this._prevChar)),this._data[this._dataLen++]=ht,this._data[this._dataLen++]=mt,this._data[this._dataLen++]=De,this._data[this._dataLen++]=et,this._data[this._dataLen++]=rt,this._prevLine=$,this._prevChar=se}static _sortAndDeltaEncode($){let se=[];const De=$.length/5|0;for(let mt=0;mt<De;mt++)se[mt]=mt;se.sort((mt,Ct)=>{const At=$[5*mt],Lt=$[5*Ct];if(At===Lt){const Mt=$[5*mt+1],Ut=$[5*Ct+1];return Mt-Ut}return At-Lt});const et=new Uint32Array($.length);let rt=0,ht=0;for(let mt=0;mt<De;mt++){const Ct=5*se[mt],At=$[Ct+0],Lt=$[Ct+1],Mt=$[Ct+2],Ut=$[Ct+3],dn=$[Ct+4],xn=At-rt,Gn=xn===0?Lt-ht:Lt,hn=5*mt;et[hn+0]=xn,et[hn+1]=Gn,et[hn+2]=Mt,et[hn+3]=Ut,et[hn+4]=dn,rt=At,ht=Lt}return et}build($){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),$):new qt(on._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=on;class qt{constructor($,se){this.resultId=se,this.data=$}}e.SemanticTokens=qt;class an{constructor($,se,De){this.start=$,this.deleteCount=se,this.data=De}}e.SemanticTokensEdit=an;class Sn{constructor($,se){this.resultId=se,this.edits=$}}e.SemanticTokensEdits=Sn;var yn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(yn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Gt;(function(j){j[j.Initial=1]="Initial",j[j.Dynamic=2]="Dynamic"})(Gt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Jt=class{constructor(){}};Jt.Back={iconPath:new yt("arrow-left")},Jt=Ve([P],Jt),e.QuickInputButtons=Jt;var Dn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor($,se,De){this.badge=$,this.tooltip=se,this.color=De}static validate($){if($.badge&&$.badge.length!==1&&$.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let ln=class{constructor($){this.kind=$}};ln=Ve([P],ln),e.ColorTheme=ln;var cn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(cn=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor($,se){if($<0)throw(0,L.illegalArgument)("start must be positive");if(se<0)throw(0,L.illegalArgument)("end must be positive");$<=se?(this._start=$,this._end=se):(this._start=se,this._end=$)}static isNotebookRange($){return $ instanceof Vt?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let se=this._start,De=this._end;return $.start!==void 0&&(se=$.start),$.end!==void 0&&(De=$.end),se===this._start&&De===this._end?this:new Vt(se,De)}}e.NotebookRange=Vt;class Ft{constructor($,se,De,et,rt,ht,mt){this.kind=$,this.value=se,this.languageId=De,this.mime=et,this.outputs=rt??[],this.metadata=ht,this.executionSummary=mt,Ft.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(se=>Ft.isNotebookCellData(se))}static isNotebookCellData($){return!0}}e.NotebookCellData=Ft;class Ne{constructor($){this.cells=$}}e.NotebookData=Ne;class Rt{constructor($,se){this.data=$,this.mime=se;const De=(0,R.normalizeMimeType)(se,!0);if(!De)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}static isNotebookCellOutputItem($){return $ instanceof Rt?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const se={name:$.name,message:$.message,stack:$.stack};return Rt.json(se,"application/vnd.code.notebook.error")}static stdout($){return Rt.text($,"application/vnd.code.notebook.stdout")}static stderr($){return Rt.text($,"application/vnd.code.notebook.stderr")}static bytes($,se="application/octet-stream"){return new Rt($,se)}static text($,se=R.Mimes.text){const De=Oe(Rt,h,"f",p).encode(String($));return new Rt(De,se)}static json($,se="application/json"){const De=JSON.stringify($,void 0,"	");return Rt.text(De,se)}}e.NotebookCellOutputItem=Rt,h=Rt,p={value:new TextEncoder};class Kt{constructor($,se,De){this.items=Kt.ensureUniqueMimeTypes($,!0),typeof se=="string"?(this.id=se,this.metadata=De):(this.id=(0,T.generateUuid)(),this.metadata=se??De)}static isNotebookCellOutput($){return $ instanceof Kt?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&(0,S.isArray)($.items)}static ensureUniqueMimeTypes($,se=!1){const De=new Set,et=new Set;for(let rt=0;rt<$.length;rt++){const ht=$[rt],mt=(0,R.normalizeMimeType)(ht.mime);if(!De.has(mt)){De.add(mt);continue}et.add(rt),se&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return et.size===0?$:$.filter((rt,ht)=>!et.has(ht))}}e.NotebookCellOutput=Kt;var Et;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Et=e.NotebookCellKind||(e.NotebookCellKind={}));var kn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(kn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var In;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(In=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(gn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pn{constructor($,se){this.text=$,this.alignment=se}}e.NotebookCellStatusBarItem=pn;var Pn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Tn{constructor($,se=[]){this.uri=$,this.provides=(0,m.asArray)(se)}}e.NotebookRendererScript=Tn;let un=class{constructor($,se){this.label=$,this.timestamp=se}};un=Ve([P],un),e.TimelineItem=un;var An;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var vn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(vn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Rn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=4]="RegEx"})(Rn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor($,se){this.ranges=$,this.wordPattern=se}}e.LinkedEditingRanges=Ln;class Fn{constructor($,se){this._port=$,this._autoForwardAction=se}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var On;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(On=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ie=class{constructor($,se,De){this.include=$,this.exclude=se,this.profile=De}};ie=Ve([P],ie),e.TestRunRequest=ie;let fe=_=class{constructor($){this.message=$}static diff($,se,De){const et=new _($);return et.expectedOutput=se,et.actualOutput=De,et}};fe=_=Ve([P],fe),e.TestMessage=fe;let Ae=class{constructor($){this.id=$}};Ae=Ve([P],Ae),e.TestTag=Ae;let ct=class{constructor($,se){this.covered=$,this.total=se}};ct=Ve([P],ct),e.CoveredCount=ct;let St=v=class{constructor($,se,De,et){this.uri=$,this.statementCoverage=se,this.branchCoverage=De,this.functionCoverage=et}static fromDetails($,se){const De=new ct(0,0),et=new ct(0,0),rt=new ct(0,0);for(const mt of se)if("branches"in mt){De.total+=1,De.covered+=mt.executionCount>0?1:0;for(const Ct of mt.branches)et.total+=1,et.covered+=Ct.executionCount>0?1:0}else rt.total+=1,rt.covered+=mt.executionCount>0?1:0;const ht=new v($,De,et.total>0?et:void 0,rt.total>0?rt:void 0);return ht.detailedCoverage=se,ht}};St=v=Ve([P],St),e.FileCoverage=St;let kt=class{constructor($,se,De=[]){this.executionCount=$,this.location=se,this.branches=De}};kt=Ve([P],kt),e.StatementCoverage=kt;let Nn=class{constructor($,se){this.executionCount=$,this.location=se}};Nn=Ve([P],Nn),e.BranchCoverage=Nn;let Un=class{constructor($,se){this.executionCount=$,this.location=se}};Un=Ve([P],Un),e.FunctionCoverage=Un;var zn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(zn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var jn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(jn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qn{constructor($,se,De,et,rt,ht){this.kind=$,this.name=se,this.detail=De,this.uri=et,this.range=rt,this.selectionRange=ht}}e.TypeHierarchyItem=qn}),define(me[123],ge([0,1,57,10,9,150,110,7,17]),function(J,e,m,L,k,C,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function n(h,p){p?T.set(h,p):T.delete(h)}e.setWordDefinitionFor=n;function I(h){return T.get(h)}e.getWordDefinitionFor=I;class c extends C.MirrorTextModel{constructor(p,D,A,E,a,s,g,t){super(D,A,E,a);this._proxy=p,this._languageId=s,this._isDirty=g,this._notebook=t,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(p){return(0,y.equals)(this._lines,p)}get document(){if(!this._document){const p=this;this._document={get uri(){return p._uri},get fileName(){return p._uri.fsPath},get isUntitled(){return p._uri.scheme===L.Schemas.untitled},get languageId(){return p._languageId},get version(){return p._versionId},get isClosed(){return p._isDisposed},get isDirty(){return p._isDirty},get notebook(){return p._notebook},save(){return p._save()},getText(D){return D?p._getTextInRange(D):p.getText()},get eol(){return p._eol===`
`?S.EndOfLine.LF:S.EndOfLine.CRLF},get lineCount(){return p._lines.length},lineAt(D){return p._lineAt(D)},offsetAt(D){return p._offsetAt(D)},positionAt(D){return p._positionAt(D)},validateRange(D){return p._validateRange(D)},validatePosition(D){return p._validatePosition(D)},getWordRangeAtPosition(D,A){return p._getWordRangeAtPosition(D,A)}}}return Object.freeze(this._document)}_acceptLanguageId(p){(0,m.ok)(!this._isDisposed),this._languageId=p}_acceptIsDirty(p){(0,m.ok)(!this._isDisposed),this._isDirty=p}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(p){const D=this._validateRange(p);if(D.isEmpty)return"";if(D.isSingleLine)return this._lines[D.start.line].substring(D.start.character,D.end.character);const A=this._eol,E=D.start.line,a=D.end.line,s=[];s.push(this._lines[E].substring(D.start.character));for(let g=E+1;g<a;g++)s.push(this._lines[g]);return s.push(this._lines[a].substring(0,D.end.character)),s.join(A)}_lineAt(p){let D;if(p instanceof S.Position?D=p.line:typeof p=="number"&&(D=p),typeof D!="number"||D<0||D>=this._lines.length||Math.floor(D)!==D)throw new Error("Illegal value for `line`");return new f(D,this._lines[D],D===this._lines.length-1)}_offsetAt(p){return p=this._validatePosition(p),this._ensureLineStarts(),this._lineStarts.getPrefixSum(p.line-1)+p.character}_positionAt(p){p=Math.floor(p),p=Math.max(0,p),this._ensureLineStarts();const D=this._lineStarts.getIndexOf(p),A=this._lines[D.index].length;return new S.Position(D.index,Math.min(D.remainder,A))}_validateRange(p){if(!(p instanceof S.Range))throw new Error("Invalid argument");const D=this._validatePosition(p.start),A=this._validatePosition(p.end);return D===p.start&&A===p.end?p:new S.Range(D.line,D.character,A.line,A.character)}_validatePosition(p){if(!(p instanceof S.Position))throw new Error("Invalid argument");if(this._lines.length===0)return p.with(0,0);let{line:D,character:A}=p,E=!1;if(D<0)D=0,A=0,E=!0;else if(D>=this._lines.length)D=this._lines.length-1,A=this._lines[D].length,E=!0;else{const a=this._lines[D].length;A<0?(A=0,E=!0):A>a&&(A=a,E=!0)}return E?new S.Position(D,A):p}_getWordRangeAtPosition(p,D){const A=this._validatePosition(p);if(!D)D=I(this._languageId);else if((0,k.regExpLeadsToEndlessLoop)(D))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${D.source}' because it matches the empty string.`);const E=(0,R.getWordAtText)(A.character+1,(0,R.ensureValidWordDefinition)(D),this._lines[A.line],0);if(E)return new S.Range(A.line,E.startColumn-1,A.line,E.endColumn-1)}}e.ExtHostDocumentData=c;class f{constructor(p,D,A){this._line=p,this._text=D,this._isLastLine=A}get lineNumber(){return this._line}get text(){return this._text}get range(){return new S.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new S.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(me[203],ge([0,1,7,3,112,6,81,24,2,32]),function(J,e,m,L,k,C,R,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(c,f,h,p){this._notebook=h,this._selector=p,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(A=>{const E=this._cellUris.get(A.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const D=A=>{A===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(A=>D(A.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new S.ResourceMap;const c=[],f=[];for(const h of this._notebook.getCells())h.kind===m.NotebookCellKind.Code&&(!this._selector||(0,R.score)(this._selector,h.document.uri,h.document.languageId,!0))&&(this._cellUris.set(h.document.uri,this._cells.length),this._cells.push(h),c.push(h.document.getText().length+1),f.push(h.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(c){if(!c){let E="";for(const a of this._cells)E+=a.document.getText()+`
`;return E=E.slice(0,-1),E}if(c.isEmpty)return"";const f=this.locationAt(c.start),h=this.locationAt(c.end),p=this._cellUris.get(f.uri),D=this._cellUris.get(h.uri);if(p===void 0||D===void 0)return"";if(p===D)return this._cells[p].document.getText(new m.Range(f.range.start,h.range.end));const A=[this._cells[p].document.getText(new m.Range(f.range.start,new m.Position(this._cells[p].document.lineCount,0)))];for(let E=p+1;E<D;E++)A.push(this._cells[E].document.getText());return A.push(this._cells[D].document.getText(new m.Range(new m.Position(0,0),h.range.end))),A.join(`
`)}offsetAt(c){const f=this._cellLines.getIndexOf(c.line),h=this._cellLengths.getPrefixSum(f.index-1),p=this._cells[f.index].document.offsetAt(c.with(f.remainder));return h+p}positionAt(c){if(typeof c=="number"){const h=this._cellLengths.getIndexOf(c),p=this._cellLines.getPrefixSum(h.index-1);return this._cells[h.index].document.positionAt(h.remainder).translate(p)}const f=this._cellUris.get(c.uri);if(f!==void 0){const h=this._cellLines.getPrefixSum(f-1);return new m.Position(h+c.range.start.line,c.range.start.character)}return new m.Position(0,0)}locationAt(c){m.Range.isRange(c)||(c=new m.Range(c,c));const f=this._cellLines.getIndexOf(c.start.line);let h=f;c.isEmpty||(h=this._cellLines.getIndexOf(c.end.line));const p=new m.Position(f.remainder,c.start.character),D=new m.Position(h.remainder,c.end.character),A=new m.Range(p,D),E=this._cells[f.index];return new m.Location(E.document.uri,E.document.validateRange(A))}contains(c){return this._cellUris.has(c)}validateRange(c){const f=this.validatePosition(c.start),h=this.validatePosition(c.end);return c.with(f,h)}validatePosition(c){const f=this._cellLines.getIndexOf(c.line),h=new m.Position(f.remainder,c.character),p=this._cells[f.index].document.validatePosition(h),D=this._cellLines.getPrefixSum(f.index-1);return new m.Position(D+p.line,p.character)}}e.ExtHostNotebookConcatDocument=n}),define(me[204],ge([0,1,7,14,3]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(S){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(S){let y=S==="light"?m.ColorThemeKind.Light:S==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=Ve([$e(0,L.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(me[66],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class L{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=L}),define(me[205],ge([0,1,22]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(y){let T=this.buffers.indexOf(y);return T<0&&(T=this.buffers.length,this.buffers.push(y)),T}}function k(S,y){if(y.serializeBuffersForPostMessage){const T=new L,n=(f,h)=>{if(h instanceof ArrayBuffer){const p=T.add(h);return{$$vscode_array_buffer_reference$$:!0,index:p}}else if(ArrayBuffer.isView(h)){const p=C(h);if(p){const D=T.add(h.buffer);return{$$vscode_array_buffer_reference$$:!0,index:D,view:{type:p,byteLength:h.byteLength,byteOffset:h.byteOffset}}}}return h},I=JSON.stringify(S,n),c=T.buffers.map(f=>{const h=new Uint8Array(f);return m.VSBuffer.wrap(h)});return{message:I,buffers:c}}else return{message:JSON.stringify(S),buffers:[]}}e.serializeWebviewMessage=k;function C(S){switch(S.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(S,y){const T=y.map(c=>{const f=new ArrayBuffer(c.byteLength);return new Uint8Array(f).set(c.buffer),f}),n=y.length?(c,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const h=f,{index:p}=h,D=T[p];if(h.view)switch(h.view.type){case 1:return new Int8Array(D,h.view.byteOffset,h.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(D,h.view.byteOffset,h.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(D,h.view.byteOffset,h.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(D,h.view.byteOffset,h.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(D,h.view.byteOffset,h.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(D,h.view.byteOffset,h.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(D,h.view.byteOffset,h.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(D,h.view.byteOffset,h.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(D,h.view.byteOffset,h.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(D,h.view.byteOffset,h.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(D,h.view.byteOffset,h.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return D}return f}:void 0;return{message:JSON.parse(S,n),arrayBuffers:T}}e.deserializeWebviewMessage=R}),define(me[206],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var m;(function(L){function k(R){const S={items:new Map};return R.types.forEach((y,T)=>{S.items.set(y,{asString:async()=>R.items[T].asString})}),S}L.toITreeDataTransfer=k;async function C(R){const S={types:[],items:[]},y=Array.from(R.items.entries());for(const T of y)S.types.push(T[0]),S.items.push({asString:await T[1].asString()});return S}L.toTreeDataTransferDTO=C})(m=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(me[88],ge([0,1,10,2]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(S,y){return S.scheme===m.Schemas.http||S.scheme===m.Schemas.https?S:(y&&y.authority&&y.isRemote&&S.scheme===m.Schemas.file&&(S=L.URI.from({scheme:m.Schemas.vscodeRemote,authority:y.authority,path:S.path})),L.URI.from({scheme:m.Schemas.https,authority:`${S.scheme}+${C(S.authority)}.${e.webviewRootResourceAuthority}`,path:S.path,fragment:S.fragment,query:S.query}))}e.asWebviewUri=k;function C(S){return S.replace(/./g,y=>{const T=y.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?y:"-"+T.toString(16).padStart(4,"0")})}function R(S){return S.replace(/-([0-9a-f]{4})/g,(y,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=R}),define(me[207],ge([0,1,3,6,88]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(S,y,T){this._proxy=S,this._editors=y,this._initData=T,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const n=y.getVisibleTextEditors();for(const I of this._insets.values())n.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(S=>S.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(S,y,T,n,I){let c;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===S){c=a;break}if(!c)throw new Error("not a visible editor");const f=this,h=this._handlePool++,p=new m.Emitter,D=new m.Emitter,A=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,k.asWebviewUri)(a,f._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(a){this._options=a,f._proxy.$setOptions(h,a)}get options(){return this._options}set html(a){this._html=a,f._proxy.$setHtml(h,a)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(a){return f._proxy.$postMessage(h,a)}},E=new class{constructor(){this.editor=S,this.line=y,this.height=T,this.webview=A,this.onDidDispose=D.event}dispose(){f._insets.has(h)&&(f._insets.delete(h),f._proxy.$disposeEditorInset(h),D.fire(),D.dispose(),p.dispose())}};return this._proxy.$createEditorInset(h,c.id,c.value.document.uri,y+1,T,n||{},I.identifier,I.extensionLocation),this._insets.set(h,{editor:S,inset:E,onDidReceiveMessage:p}),E}$onDidDispose(S){const y=this._insets.get(S);y&&y.inset.dispose()}$onDidReceiveMessage(S,y){const T=this._insets.get(S);T&&T.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=C}),define(me[208],ge([0,1,172,13,2,6,4,63,34,17,10]),function(J,e,m,L,k,C,R,S,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new S.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new S.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new S.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new S.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new S.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new S.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new S.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new S.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new S.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new S.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.SideBySideEditorActiveContext=new S.RawContextKey("sideBySideEditorActive",!1,(0,m.localize)(11,null)),e.EditorGroupEditorsCountContext=new S.RawContextKey("groupEditorsCount",0,(0,m.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new S.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(13,null)),e.ActiveEditorGroupIndexContext=new S.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(14,null)),e.ActiveEditorGroupLastContext=new S.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(15,null)),e.ActiveEditorGroupLockedContext=new S.RawContextKey("activeEditorGroupLocked",!1,(0,m.localize)(16,null)),e.MultipleEditorGroupsContext=new S.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new S.RawContextKey("editorIsOpen",!1,(0,m.localize)(18,null)),e.InEditorZenModeContext=new S.RawContextKey("inZenMode",!1,(0,m.localize)(19,null)),e.IsCenteredLayoutContext=new S.RawContextKey("isCenteredLayout",!1,(0,m.localize)(20,null)),e.SplitEditorsVertically=new S.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(21,null)),e.EditorAreaVisibleContext=new S.RawContextKey("editorAreaVisible",!0,(0,m.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function I(w,F,M){for(const K of M.visibleEditorPanes)if(K.group.id===F&&w.matches(K.input))return K.getViewState()}e.findViewStateForEditor=I;function c(w){if(s(w))return!1;const F=w;return k.URI.isUri(F?.resource)}e.isResourceEditorInput=c;function f(w){if(s(w))return!1;const F=w;return F?.original!==void 0&&F.modified!==void 0}e.isResourceDiffEditorInput=f;function h(w){if(s(w)||f(w))return!1;const F=w;return F?.primary!==void 0&&F.secondary!==void 0}e.isResourceSideBySideEditorInput=h;function p(w){if(s(w))return!1;const F=w;return F?F.resource===void 0||F.resource.scheme===n.Schemas.untitled||F.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=p;var D;(function(w){w[w.SHORT=0]="SHORT",w[w.MEDIUM=1]="MEDIUM",w[w.LONG=2]="LONG"})(D=e.Verbosity||(e.Verbosity={}));var A;(function(w){w[w.EXPLICIT=1]="EXPLICIT",w[w.AUTO=2]="AUTO",w[w.FOCUS_CHANGE=3]="FOCUS_CHANGE",w[w.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(A=e.SaveReason||(e.SaveReason={}));var E;(function(w){w[w.None=0]="None",w[w.Readonly=2]="Readonly",w[w.Untitled=4]="Untitled",w[w.Singleton=8]="Singleton",w[w.RequiresTrust=16]="RequiresTrust",w[w.CanSplitInGroup=32]="CanSplitInGroup"})(E=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class a extends C.Disposable{}e.AbstractEditorInput=a;function s(w){return w instanceof a}e.isEditorInput=s;function g(w){const F=w;return k.URI.isUri(F?.preferredResource)}function t(w){const F=w;return s(F?.primary)&&s(F?.secondary)}e.isSideBySideEditorInput=t;function u(w){const F=w;return s(F?.modified)&&s(F?.original)}e.isDiffEditorInput=u;function r(w){return s(w?.editor)}e.isEditorInputWithOptions=r;function i(w){const F=w;return r(w)&&F?.group!==void 0}e.isEditorInputWithOptionsAndGroup=i;function o(w){const F=w;return typeof F?.groupId=="number"&&s(F.editor)}e.isEditorIdentifier=o;var l;(function(w){w[w.PRIMARY=1]="PRIMARY",w[w.SECONDARY=2]="SECONDARY",w[w.BOTH=3]="BOTH",w[w.ANY=4]="ANY"})(l=e.SideBySideEditor||(e.SideBySideEditor={}));class d{getOriginalUri(F,M){if(!F)return;if(M?.supportSideBySide){const{primary:G,secondary:N}=this.getSideEditors(F);if(G&&N){if(M?.supportSideBySide===l.BOTH)return{primary:this.getOriginalUri(G,{filterByScheme:M.filterByScheme}),secondary:this.getOriginalUri(N,{filterByScheme:M.filterByScheme})};if(M?.supportSideBySide===l.ANY)return this.getOriginalUri(G,{filterByScheme:M.filterByScheme})??this.getOriginalUri(N,{filterByScheme:M.filterByScheme});F=M.supportSideBySide===l.PRIMARY?G:N}}if(f(F)||h(F))return;const K=g(F)?F.preferredResource:F.resource;return!K||!M||!M.filterByScheme?K:this.filterUri(K,M.filterByScheme)}getSideEditors(F){return t(F)||h(F)?{primary:F.primary,secondary:F.secondary}:u(F)||f(F)?{primary:F.modified,secondary:F.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(F,M){if(!F)return;if(M?.supportSideBySide){const{primary:G,secondary:N}=this.getSideEditors(F);if(G&&N){if(M?.supportSideBySide===l.BOTH)return{primary:this.getCanonicalUri(G,{filterByScheme:M.filterByScheme}),secondary:this.getCanonicalUri(N,{filterByScheme:M.filterByScheme})};if(M?.supportSideBySide===l.ANY)return this.getCanonicalUri(G,{filterByScheme:M.filterByScheme})??this.getCanonicalUri(N,{filterByScheme:M.filterByScheme});F=M.supportSideBySide===l.PRIMARY?G:N}}if(f(F)||h(F))return;const K=F.resource;return!K||!M||!M.filterByScheme?K:this.filterUri(K,M.filterByScheme)}filterUri(F,M){if(Array.isArray(M)){if(M.some(K=>F.scheme===K))return F}else if(M===F.scheme)return F}}e.EditorResourceAccessor=new d;var b;(function(w){w[w.LEFT=0]="LEFT",w[w.RIGHT=1]="RIGHT"})(b=e.CloseDirection||(e.CloseDirection={}));class _{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(F){const M=this.instantiationService=F.get(R.IInstantiationService);for(const[K,G]of this.editorSerializerConstructors)this.createEditorSerializer(K,G,M);this.editorSerializerConstructors.clear()}createEditorSerializer(F,M,K){const G=K.createInstance(M);this.editorSerializerInstances.set(F,G)}registerFileEditorFactory(F){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=F}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(F,M){if(this.editorSerializerConstructors.has(F)||this.editorSerializerInstances.has(F))throw new Error(`A editor serializer with type ID '${F}' was already registered.`);return this.instantiationService?this.createEditorSerializer(F,M,this.instantiationService):this.editorSerializerConstructors.set(F,M),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(F),this.editorSerializerInstances.delete(F)})}getEditorSerializer(F){return this.editorSerializerInstances.get(typeof F=="string"?F:F.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new _);async function v(w,F){if(!w||!w.length)return[];const M=await Promise.all(w.map(async K=>{const G=k.URI.revive(K.fileUri);if(!G||(await F.activateProvider(G.scheme),!F.canHandleResource(G)))return;const N=typeof K.exists=="boolean"?K.exists:await F.exists(G);if(!N&&K.openOnlyIfExists)return;const z={selection:N?K.selection:void 0,pinned:!0,override:K.editorOverrideId};let O;return N?O={resource:G,options:z}:O={resource:G,options:z,forceUntitled:!0},O}));return(0,T.coalesce)(M)}e.pathsToEditors=v;var P;(function(w){w[w.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",w[w.SEQUENTIAL=1]="SEQUENTIAL"})(P=e.EditorsOrder||(e.EditorsOrder={}))}),define(me[209],ge([0,1,3,63,173,4,6,24,34,17,58,25,47,198]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",c.Codicon.window,(0,k.localize)(0,null));var h;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(h=e.Extensions||(e.Extensions={}));var p;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel"})(p=e.ViewContainerLocation||(e.ViewContainerLocation={}));function D(o){switch(o){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=D;function A(o){return`viewContainer.${o}.enabled`}e.getEnabledViewContainerContextKey=A;class E extends R.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new m.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new m.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,T.flatten)([...this.viewContainers.values()])}registerViewContainer(l,d,b){const _=this.get(l.id);if(_)return _;const v=l;return v.openCommandActionDescriptor=b?.donotRegisterOpenCommand?void 0:v.openCommandActionDescriptor??{id:v.id},(0,S.getOrSet)(this.viewContainers,d,[]).push(v),b?.isDefault&&this.defaultViewContainers.push(v),this._onDidRegister.fire({viewContainer:v,viewContainerLocation:d}),v}deregisterViewContainer(l){for(const d of this.viewContainers.keys()){const b=this.viewContainers.get(d),_=b?.indexOf(l);if(_!==-1){b?.splice(_,1),b.length===0&&this.viewContainers.delete(d),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:d});return}}}get(l){return this.all.filter(d=>d.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(d=>this.getViewContainers(d).filter(b=>b?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(d=>this.getViewContainerLocation(d)===l)}}y.Registry.add(h.ViewContainersRegistry,new E);var a;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function s(o,l){const d=o.group??a.More,b=l.group??a.More;return d!==b?d.localeCompare(b):(o.order??5)-(l.order??5)}class g extends R.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new m.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new m.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new m.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new m.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(l,d){this.registerViews2([{views:l,viewContainer:d}])}registerViews2(l){l.forEach(({views:d,viewContainer:b})=>this.addViews(d,b)),this._onViewsRegistered.fire(l)}deregisterViews(l,d){const b=this.removeViews(l,d);b.length&&this._onViewsDeregistered.fire({views:b,viewContainer:d})}moveViews(l,d){for(const b of this._views.keys())if(b!==d){const _=this.removeViews(l,b);_.length&&(this.addViews(_,d),this._onDidChangeContainer.fire({views:_,from:b,to:d}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const d of this._viewContainers){const b=(this._views.get(d)||[]).filter(_=>_.id===l)[0];if(b)return b}return null}getViewContainer(l){for(const d of this._viewContainers)if((this._views.get(d)||[]).filter(_=>_.id===l)[0])return d;return null}registerViewWelcomeContent(l,d){return this._viewWelcomeContents.add(l,d),this._onDidChangeViewWelcomeContent.fire(l),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(l,d),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,d){const b=new Map;for(const[_,v]of d)this._viewWelcomeContents.add(l,v),b.set(_,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(l,v),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),b}getViewWelcomeContent(l){const d=[];return this._viewWelcomeContents.forEach(l,b=>d.push(b)),d.sort(s)}addViews(l,d){let b=this._views.get(d);b||(b=[],this._views.set(d,b),this._viewContainers.push(d));for(const _ of l){if(this.getView(_.id)!==null)throw new Error((0,k.localize)(1,null,_.id));b.push(_)}}removeViews(l,d){const b=this._views.get(d);if(!b)return[];const _=[],v=[];for(const P of b)l.includes(P)?_.push(P):v.push(P);return _.length&&(v.length?this._views.set(d,v):(this._views.delete(d),this._viewContainers.splice(this._viewContainers.indexOf(d),1))),_}}y.Registry.add(h.ViewsRegistry,new g),e.IViewsService=(0,C.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,k.localize)(2,null));function t(o){return`view.${o}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,C.createDecorator)("viewDescriptorService");var u;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(u=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(l,d){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,l),this._hasResolve=!!d,this.resolve=async b=>{if(d&&!this.resolved){const _=await d(b);_&&(this.tooltip=this.tooltip??_.tooltip,this.command=this.command??_.command)}b.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(me[124],ge([0,1,3,18,174]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(S){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=S}onEvent(S){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=S}onRequest(S){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=S}sendResponse(S){S.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${S.command}`)):this.internalSend("response",S)}sendRequest(S,y,T,n){const I={command:S};if(y&&Object.keys(y).length>0&&(I.arguments=y),this.internalSend("request",I),typeof n=="number"){const c=setTimeout(()=>{clearTimeout(c);const f=this.pendingRequests.get(I.seq);if(f){this.pendingRequests.delete(I.seq);const h={type:"response",seq:0,request_seq:I.seq,success:!1,command:S,message:(0,k.localize)(0,null,n,S)};f(h)}},n)}return T&&this.pendingRequests.set(I.seq,T),I.seq}acceptMessage(S){this.messageCallback?this.messageCallback(S):(this.queue.push(S),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(S,y){return S.type!=="event"||y.type!=="event"}async processQueue(){let S;for(;this.queue.length;){if((!S||this.needsTaskBoundaryBetween(this.queue[0],S))&&await(0,L.timeout)(0),S=this.queue.shift(),!S)return;switch(S.type){case"event":this.eventCallback&&this.eventCallback(S);break;case"request":this.requestCallback&&this.requestCallback(S);break;case"response":const y=S,T=this.pendingRequests.get(y.request_seq);T&&(this.pendingRequests.delete(y.request_seq),T(y));break}}}internalSend(S,y){y.type=S,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const S=new Map;this.pendingRequests.forEach((y,T)=>S.set(T,y)),await(0,L.timeout)(500),S.forEach((y,T)=>{y({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(me[210],ge([0,1,9,2,8,25,10]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const S=/{([^}]+)}/g;function y(r,i,o){return r.replace(S,function(l,d){return i&&d.length>0&&d[0]!=="_"?l:o&&o.hasOwnProperty(d)?o[d]:l})}e.formatPII=y;function T(r){const i={};for(const o of Object.keys(r))o.startsWith("!")||(i[o]=r[o]);return i}e.filterExceptionsFromTelemetry=T;function n(r){return r.configuration.request==="attach"&&!I(r)&&(!r.parentSession||n(r.parentSession))}e.isSessionAttach=n;function I(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(i,"extensionhost")||(0,m.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function c(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=c;function f(r,i,o){let l,d=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,_=null;for(;_=b.exec(r);){let v=_.index+1,P=v+_[0].length;if(v<=i&&P>=o){l=_[0],d=v;break}}if(l){let v=/\w+/g,P=null;for(;(P=v.exec(l))&&!(P.index+1+d+P[0].length>=o););P&&(l=l.substring(0,v.lastIndex))}return l?{start:d,end:d+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function p(r){return!!(r&&r.match(h))}e.isUri=p;function D(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(p(r.path))return L.URI.parse(r.path);if((0,k.isAbsolute)(r.path))return L.URI.file(r.path)}return r.path}function A(r){if(typeof r.path=="object"){const i=L.URI.revive(r.path);if(i)return i.scheme===R.Schemas.file?i.fsPath:i.toString()}return r.path}function E(r,i){const o=i?D:A,l=(0,C.deepClone)(r);return s(l,(d,b)=>{d&&b&&(b.path=o(b))}),l}e.convertToDAPaths=E;function a(r,i){const o=i?D:A,l=(0,C.deepClone)(r);return s(l,(d,b)=>{!d&&b&&(b.path=o(b))}),l}e.convertToVSCPaths=a;function s(r,i){switch(r.type){case"event":const o=r;switch(o.event){case"output":i(!1,o.body.source);break;case"loadedSource":i(!1,o.body.source);break;case"breakpoint":i(!1,o.body.breakpoint.source);break;default:break}break;case"request":const l=r;switch(l.command){case"setBreakpoints":i(!0,l.arguments.source);break;case"breakpointLocations":i(!0,l.arguments.source);break;case"source":i(!0,l.arguments.source);break;case"gotoTargets":i(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(b=>i(!1,b));break;default:break}break;case"response":const d=r;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(b=>i(!1,b.source));break;case"loadedSources":d.body.sources.forEach(b=>i(!1,b));break;case"scopes":d.body.scopes.forEach(b=>i(!1,b.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(b=>i(!1,b.source));break;case"setBreakpoints":d.body.breakpoints.forEach(b=>i(!1,b.source));break;default:break}break}}function g(r){return r.filter(i=>!i.presentation?.hidden).sort((i,o)=>i.presentation?o.presentation?i.presentation.group?o.presentation.group?i.presentation.group!==o.presentation.group?i.presentation.group.localeCompare(o.presentation.group):t(i.presentation.order,o.presentation.order):-1:o.presentation.group?1:t(i.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=g;function t(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function u(r,i){const o=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(o!=="none"&&(await i.saveAll(),o==="allEditorsInActiveGroup")){const l=i.activeEditorPane;l&&await i.save({editor:l.input,groupId:l.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(me[211],ge([0,1,28,39,175,125,8,9,25,11,185,124]),function(J,e,m,L,k,C,R,S,y,T,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class c extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(E,a){this.outputStream=a,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,E.on("data",s=>this.handleData(s))}sendMessage(E){if(this.outputStream){const a=JSON.stringify(E);this.outputStream.write(`Content-Length: ${Buffer.byteLength(a,"utf8")}${c.TWO_CRLF}${a}`,"utf8")}}handleData(E){for(this.rawData=Buffer.concat([this.rawData,E]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const a=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,a.length>0)try{this.acceptMessage(JSON.parse(a))}catch(s){this._onError.fire(new Error((s.message||s)+`
`+a))}continue}}else{const a=this.rawData.indexOf(c.TWO_CRLF);if(a!==-1){const g=this.rawData.toString("utf8",0,a).split(c.HEADER_LINESEPARATOR);for(const t of g){const u=t.split(c.HEADER_FIELDSEPARATOR);u[0]==="Content-Length"&&(this.contentLength=Number(u[1]))}this.rawData=this.rawData.slice(a+c.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=c,c.TWO_CRLF=`\r
\r
`,c.HEADER_LINESEPARATOR=/\r?\n/,c.HEADER_FIELDSEPARATOR=/: */;class f extends c{startSession(){return new Promise((E,a)=>{let s=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),E(),s=!0}),this.socket.on("close",()=>{s?this._onError.fire(new Error("connection closed")):a(new Error("connection closed"))}),this.socket.on("error",g=>{s?this._onError.fire(g):a(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=f;class h extends f{constructor(E){super();this.adapterServer=E}createConnection(E){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",E)}}e.SocketDebugAdapter=h;class p extends f{constructor(E){super();this.adapterServer=E}createConnection(E){return C.createConnection(this.adapterServer.path,E)}}e.NamedPipeDebugAdapter=p;class D extends c{constructor(E,a,s){super();this.adapterExecutable=E,this.debugType=a,this.outputService=s}async startSession(){const E=this.adapterExecutable.command,a=this.adapterExecutable.args,s=this.adapterExecutable.options||{};try{if(E)if(R.isAbsolute(E)){if(!await m.Promises.exists(E))throw new Error(k.localize(0,null,E))}else E.indexOf("/")<0&&E.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let g=process.env;if(s.env&&Object.keys(s.env).length>0&&(g=y.mixin(y.deepClone(process.env),s.env)),E==="node")if(Array.isArray(a)&&a.length>0){const u=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:g,execArgv:u?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};s.cwd&&(r.cwd=s.cwd);const i=L.fork(a[0],a.slice(1),r);if(!i.pid)throw new Error(k.localize(2,null,a[0]));this.serverProcess=i}else throw new Error(k.localize(3,null));else{const u={env:g};s.cwd&&(u.cwd=s.cwd),this.serverProcess=L.spawn(E,a,u)}this.serverProcess.on("error",u=>{this._onError.fire(u)}),this.serverProcess.on("exit",(u,r)=>{this._onExit.fire(u)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",u=>{this._onError.fire(u)}),this.serverProcess.stdin.on("error",u=>{this._onError.fire(u)});const t=this.outputService;if(t){const u=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const i=t.getChannel(n.ExtensionsChannelId);i&&i.append(u(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),T.isWindows?new Promise((E,a)=>{const s=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,t,u){if(g)return a(g)});s.on("exit",E),s.on("error",a)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(E,a){if(!E)return;const s=Object.create(null);E.runtime&&(E.runtime.indexOf("./")===0?s.runtime=R.join(a,E.runtime):s.runtime=E.runtime),E.runtimeArgs&&(s.runtimeArgs=E.runtimeArgs),E.program&&(R.isAbsolute(E.program)?s.program=E.program:s.program=R.join(a,E.program)),E.args&&(s.args=E.args);const g=E;return g.win&&(s.win=D.extract(g.win,a)),g.winx86&&(s.winx86=D.extract(g.winx86,a)),g.windows&&(s.windows=D.extract(g.windows,a)),g.osx&&(s.osx=D.extract(g.osx,a)),g.linux&&(s.linux=D.extract(g.linux,a)),s}static platformAdapterExecutable(E,a){let s=Object.create(null);a=a.toLowerCase();for(const o of E)if(o.contributes){const l=o.contributes.debuggers;l&&l.length>0&&l.filter(d=>typeof d.type=="string"&&S.equalsIgnoreCase(d.type,a)).forEach(d=>{const b=D.extract(d,o.extensionLocation.fsPath);s=y.mixin(s,b,o.isBuiltin)})}let g;T.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=s.winx86||s.win||s.windows:T.isWindows?g=s.win||s.windows:T.isMacintosh?g=s.osx:T.isLinux&&(g=s.linux),g=g||s;let t=g.program||s.program;const u=g.args||s.args;let r=g.runtime||s.runtime;const i=g.runtimeArgs||s.runtimeArgs;if(r)return{type:"executable",command:r,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(u||[])};if(t)return{type:"executable",command:t,args:u||[]}}}e.ExecutableDebugAdapter=D}),define(me[212],ge([0,1,39,11,29,188]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function R(c,f){return new Promise((h,p)=>{let D="";const A=m.spawn(c,f);A.pid&&A.stdout.on("data",E=>{D+=E.toString()}),A.on("error",E=>{p(E)}),A.on("close",E=>{h(D)})})}let S;function y(c,f){if(!S)if(L.isWindows)S=new C.WindowsExternalTerminalService;else if(L.isMacintosh)S=new C.MacExternalTerminalService;else if(L.isLinux)S=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const h=f.getConfiguration("terminal");return S.runInTerminal(c.title,c.cwd,c.args,c.env||{},h.external||{})}e.runInExternalTerminal=y;function T(c){return c?L.isWindows?new Promise(async f=>{(await new Promise((p,D)=>{J(["windows-process-tree"],p,D)})).getProcessTree(c,p=>{f(p.children.length>0)})}):R("/usr/bin/pgrep",["-lP",String(c)]).then(f=>{const h=f.trim();return!(h.length===0||h.indexOf(" tmux")>=0)},f=>!0):Promise.resolve(!0)}e.hasChildProcesses=T;var n;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(n||(n={}));function I(c,f,h,p){c=c.trim().toLowerCase();let D;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?D=1:c.indexOf("cmd.exe")>=0?D=0:c.indexOf("bash")>=0?D=2:L.isWindows?D=0:D=2;let A,E=" ";switch(D){case 1:if(A=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),h){const s=(0,k.getDriveLetter)(h);s&&(E+=`${s}:; `),E+=`cd ${A(h)}; `}if(p)for(let s in p){const g=p[s];g===null?E+=`Remove-Item env:${s}; `:E+=`\${env:${s}}='${g}'; `}if(f.length>0){const s=A(f.shift());E+=s[0]==="'"?`& ${s} `:`${s} `;for(let g of f)E+=`${A(g)} `}break;case 0:if(A=s=>(s=s.replace(/\"/g,'""'),s.indexOf(" ")>=0||s.indexOf('"')>=0||s.length===0?`"${s}"`:s),h){const s=(0,k.getDriveLetter)(h);s&&(E+=`${s}: && `),E+=`cd ${A(h)} && `}if(p){E+='cmd /C "';for(let s in p){let g=p[s];g===null?E+=`set "${s}=" && `:(g=g.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),E+=`set "${s}=${g}" && `)}}for(let s of f)E+=`${A(s)} `;p&&(E+='"');break;case 2:A=s=>(s=s.replace(/(["'\\\$])/g,"\\$1"),s.indexOf(" ")>=0||s.indexOf(";")>=0||s.length===0?`"${s}"`:s);const a=s=>/[^\w@%\/+=,.:^-]/.test(s)?`'${s.replace(/'/g,"'\\''")}'`:s;if(h&&(E+=`cd ${A(h)} ; `),p){E+="/usr/bin/env";for(let s in p){const g=p[s];g===null?E+=` -u ${a(s)}`:E+=` ${a(`${s}=${g}`)}`}E+=" "}for(let s of f)E+=`${A(s)} `;break}return E}e.prepareCommand=I}),define(me[126],ge([0,1,30,102,10,8,11,63]),function(J,e,m,L,k,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(v){v[v.Markup=1]="Markup",v[v.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(v){v[v.Running=1]="Running",v[v.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(v){v[v.Pending=2]="Pending",v[v.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(v){v[v.WithHardKernelDependency=0]="WithHardKernelDependency",v[v.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",v[v.Pure=2]="Pure",v[v.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var c;(function(v){v.Always="always",v.Never="never",v.Optional="optional"})(c=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(v){v[v.ModelChange=1]="ModelChange",v[v.Move=2]="Move",v[v.ChangeLanguage=5]="ChangeLanguage",v[v.Initialize=6]="Initialize",v[v.ChangeCellMetadata=7]="ChangeCellMetadata",v[v.Output=8]="Output",v[v.OutputItem=9]="OutputItem",v[v.ChangeCellContent=10]="ChangeCellContent",v[v.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",v[v.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",v[v.ChangeCellMime=13]="ChangeCellMime",v[v.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(v){v[v.Handle=0]="Handle",v[v.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(v){v[v.Replace=1]="Replace",v[v.Output=2]="Output",v[v.Metadata=3]="Metadata",v[v.CellLanguage=4]="CellLanguage",v[v.DocumentMetadata=5]="DocumentMetadata",v[v.Move=6]="Move",v[v.OutputItems=7]="OutputItems",v[v.PartialMetadata=8]="PartialMetadata",v[v.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));var D;(function(v){v.scheme=k.Schemas.vscodeNotebookCell;const P=/^ch(\d{7,})/;function w(N,z){return N.with({scheme:v.scheme,fragment:`ch${z.toString().padStart(7,"0")}${N.scheme!==k.Schemas.file?N.scheme:""}`})}v.generate=w;function F(N){if(N.scheme!==v.scheme)return;const z=P.exec(N.fragment);return z?{handle:Number(z[1]),notebook:N.with({scheme:N.fragment.substr(z[0].length)||k.Schemas.file,fragment:null})}:void 0}v.parse=F;function M(N){if(N.scheme!==k.Schemas.vscodeNotebookCellMetadata)return;const z=P.exec(N.fragment);return z?{handle:Number(z[1]),notebook:N.with({scheme:N.fragment.substr(z[0].length)||k.Schemas.file,fragment:null})}:void 0}v.parseCellMetadataUri=M;function K(N,z,O){return N.with({scheme:O,fragment:`ch${z.toString().padStart(7,"0")}${N.scheme!==k.Schemas.file?N.scheme:""}`})}v.generateCellUri=K;function G(N,z){if(N.scheme!==z)return;const O=P.exec(N.fragment);return O?{handle:Number(O[1]),notebook:N.with({scheme:N.fragment.substr(O[0].length)||k.Schemas.file,fragment:null})}:void 0}v.parseCellUri=G})(D=e.CellUri||(e.CellUri={}));const A=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function E(v){return A.get(v)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=E;function a(v){return A.get(v)?.supportedByCore??!1}e.mimeTypeSupportedByCore=a;function s(v){return A.get(v)?.mergeable??!1}e.mimeTypeIsMergeable=s;function g(v,P){return R.isWindows&&(v=v.replace(/\//g,"\\"),P=P.replace(/\//g,"\\")),m.match(v,P)}function t(v,P,w){let F=0;for(let M=0;M<P.length;M++){if(g(P[M],v))return F;F++}for(let M=0;M<w.length;M++){if(g(w[M],v))return F;F++}return F}function u(v,P,w){return v.sort((F,M)=>t(F,P,w)-t(M,P,w))}e.sortMimeTypes=u;function r(v,P,w,F=(M,K)=>M===K){const M=[];function K(z,O,x){if(O===0&&x.length===0)return;const B=M[M.length-1];B&&B.start+B.deleteCount===z?(B.deleteCount+=O,B.toInsert.push(...x)):M.push({start:z,deleteCount:O,toInsert:x})}let G=0,N=0;for(;;){if(G===v.length){K(G,0,P.slice(N));break}if(N===P.length){K(G,v.length-G,[]);break}const z=v[G],O=P[N];if(F(z,O)){G+=1,N+=1;continue}w(O)?(K(G,1,[]),G+=1):(K(G,0,[O]),N+=1)}return M}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(v){v.default="default",v.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(v){const P=v;return!!((typeof P.include=="string"||m.isRelativePattern(P.include))&&(typeof P.exclude=="string"||m.isRelativePattern(P.exclude)))}e.isDocumentExcludePattern=o;function l(v,P,w){if(Array.isArray(v.viewType)&&v.viewType.indexOf(P)>=0||v.viewType===P)return!0;if(v.filenamePattern){let F=o(v.filenamePattern)?v.filenamePattern.include:v.filenamePattern,M=o(v.filenamePattern)?v.filenamePattern.exclude:void 0;if(m.match(F,(0,C.basename)(w.fsPath).toLowerCase()))return!(M&&m.match(M,(0,C.basename)(w.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class d{constructor(P){this.textModel=P}getElements(){const P=new Int32Array(this.textModel.cells.length);for(let w=0;w<this.textModel.cells.length;w++)P[w]=this.textModel.cells[w].getHashValue();return P}}e.CellSequence=d,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var b;(function(v){v[v.Left=1]="Left",v[v.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class _{static create(P){return`${_._prefix}${P}`}static parse(P){if(P.startsWith(_._prefix))return P.substr(_._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=_,_._prefix="notebook/"}),define(me[213],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState",k[k.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,m.createDecorator)("INotebookExecutionService")}),define(me[214],ge([0,1,177,4,63]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[215],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=m;function L(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=L}),define(me[127],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var m;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(m=e.TestResultState||(e.TestResultState={}));var L;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(I){I[I.Error=0]="Error",I[I.Info=1]="Info"})(k=e.TestMessageType||(e.TestMessageType={}));var C;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(I,c)=>{c.expand!==void 0&&(I.expand=c.expand),c.item!==void 0&&(I.item=I.item?Object.assign(I.item,c.item):c.item)};e.applyTestItemUpdate=R;var S;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(S=e.DetailType||(e.DetailType={}));var y;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire",I[I.AddTag=5]="AddTag",I[I.RemoveTag=6]="RemoveTag"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class T{add(c){}update(c){}remove(c,f){}complete(){}}e.IncrementalChangeCollector=T;class n{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const f=this.createChangeCollector();for(const h of c)switch(h[0]){case 0:{const p=h[1];if(p.parent){if(this.items.has(p.parent)){const D=this.items.get(p.parent);D.children.add(p.item.extId);const A=this.createItem(p,D);this.items.set(p.item.extId,A),f.add(A)}}else{const D=this.createItem(p);this.roots.add(D),this.items.set(p.item.extId,D),f.add(D)}p.expand===2&&this.busyControllerCount++;break}case 1:{const p=h[1],D=this.items.get(p.extId);if(!D)break;p.expand!==void 0&&(D.expand===2&&this.busyControllerCount--,p.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(D,p),f.update(D);break}case 2:{const p=this.items.get(h[1]);if(!p)break;p.parent?this.items.get(p.parent).children.delete(p.item.extId):this.roots.delete(p);const D=[[h[1]]];for(;D.length;)for(const A of D.pop()){const E=this.items.get(A);E&&(D.push(E.children),this.items.delete(A),f.remove(E,E!==p),E.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(h[1]);break;case 3:this.updatePendingRoots(h[1]);break;case 5:this._tags.set(h[1].id,h[1]);break;case 6:this._tags.delete(h[1]);break}f.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=n}),define(me[89],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var m;(function(C){C.Delimiter="\0"})(m=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class k{constructor(R,S=R.length){if(this.path=R,this.viewEnd=S,R.length===0||S<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(R,S,y=R.parent){if(R.id===S)return new k([S]);let T=[R.id];for(let n=y;n&&n.id!==S;n=n.parent)T.push(n.id);return T.push(S),new k(T.reverse())}static isRoot(R){return!R.includes("\0")}static fromString(R){return new k(R.split("\0"))}static join(R,S){return new k([...R.path,S])}static joinToString(R,S){return R.toString()+"\0"+S}static compare(R,S){return R===S?0:S.startsWith(R+"\0")?2:R.startsWith(S+"\0")?3:1}get parentId(){return this.viewEnd>1?new k(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new k(this.path,R)}compare(R){if(typeof R=="string")return k.compare(this.toString(),R);for(let S=0;S<R.viewEnd&&S<this.viewEnd;S++)if(R.path[S]!==this.path[S])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=k}),define(me[216],ge([0,1,8,38,13,25,11,79,178]),function(J,e,m,L,k,C,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(I,c,f){this._contributedVariables=new Map,this._context=I,this._labelService=c,f&&(this._envVariablesPromise=f.then(h=>this.prepareEnv(h)))}prepareEnv(I){if(R.isWindows){const c=Object.create(null);return Object.keys(I).forEach(f=>{c[f.toLowerCase()]=I[f]}),c}return I}resolveWithEnvironment(I,c,f){return this.recursiveResolve(this.prepareEnv(I),c?c.uri:void 0,f)}async resolveAsync(I,c){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,c)}async resolveAnyBase(I,c,f,h){const p=C.deepClone(c);return R.isWindows&&p.windows?Object.keys(p.windows).forEach(D=>p[D]=p.windows[D]):R.isMacintosh&&p.osx?Object.keys(p.osx).forEach(D=>p[D]=p.osx[D]):R.isLinux&&p.linux&&Object.keys(p.linux).forEach(D=>p[D]=p.linux[D]),delete p.windows,delete p.osx,delete p.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,p,f,h)}async resolveAnyAsync(I,c,f){return this.resolveAnyBase(I,c,f)}async resolveAnyMap(I,c,f){const h=new Map;return{newConfig:await this.resolveAnyBase(I,c,f,h),resolvedVariables:h}}resolveWithInteractionReplace(I,c,f,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,c,f,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,c){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,c)}recursiveResolve(I,c,f,h,p){if(k.isString(f))return this.resolveString(I,c,f,h,p);if(k.isArray(f))return f.map(D=>this.recursiveResolve(I,c,D,h,p));if(k.isObject(f)){let D=Object.create(null);return Object.keys(f).forEach(A=>{const E=this.resolveString(I,c,A,h,p);D[E]=this.recursiveResolve(I,c,f[A],h,p)}),D}return f}resolveString(I,c,f,h,p){return f.replace(T.VARIABLE_REGEXP,(A,E)=>{if(E.includes(T.VARIABLE_LHS))return A;let a=this.evaluateSingleVariable(I,A,E,c,h);return p&&p.set(E,a),a!==A&&k.isString(a)&&a.match(T.VARIABLE_REGEXP)&&(a=this.resolveString(I,c,a,h,p)),a})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,c,f,h,p){let D;const A=f.split(":");A.length>1&&(f=A[0],D=A[1]);const E=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error((0,y.localize)(0,null,c))},a=()=>{const g=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,c,m.basename(g)))},s=()=>{if(D){const g=this._context.getFolderUri(D);if(g)return g;throw new Error((0,y.localize)(2,null,c,D))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,c)):new Error((0,y.localize)(4,null,c))};switch(f){case"env":if(D){if(I){const g=I[R.isWindows?D.toLowerCase():D];if(k.isString(g))return g}return""}throw new Error((0,y.localize)(5,null,c));case"config":if(D){const g=this._context.getConfigurationValue(h,D);if(k.isUndefinedOrNull(g))throw new Error((0,y.localize)(6,null,c,D));if(k.isObject(g))throw new Error((0,y.localize)(7,null,c,D));return g}throw new Error((0,y.localize)(8,null,c));case"command":return this.resolveFromMap(c,D,p,"command");case"input":return this.resolveFromMap(c,D,p,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,S.normalizeDriveLetter)(this.fsPath(s()));case"cwd":return h||D?(0,S.normalizeDriveLetter)(this.fsPath(s())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(s()));case"lineNumber":const g=this._context.getLineNumber();if(g)return g;throw new Error((0,y.localize)(9,null,c));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,c));case"file":return E();case"fileWorkspaceFolder":return a();case"relativeFile":return h||D?m.relative(this.fsPath(s()),E()):E();case"relativeFileDirname":const u=m.dirname(E());if(h||D){const l=m.relative(this.fsPath(s()),u);return l.length===0?".":l}return u;case"fileDirname":return m.dirname(E());case"fileExtname":return m.extname(E());case"fileBasename":return m.basename(E());case"fileBasenameNoExtension":const r=m.basename(E());return r.slice(0,r.length-m.extname(r).length);case"fileDirnameBasename":return m.basename(m.dirname(E()));case"execPath":const i=this._context.getExecPath();return i||c;case"execInstallFolder":const o=this._context.getAppRoot();return o||c;case"pathSeparator":return m.sep;default:try{const l=D?`${f}:${D}`:f;return this.resolveFromMap(c,l,p,void 0)}catch(l){return c}}}}resolveFromMap(I,c,f,h){if(c&&f){const p=h===void 0?f[c]:f[h+":"+c];if(typeof p=="string")return p;throw new Error((0,y.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[128],ge([0,1,4,208]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var k;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var C;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var R;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(R=e.GroupLocation||(e.GroupLocation={}));var S;(function(p){p[p.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(S=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function T(p){const D=p;return(0,L.isEditorInput)(D?.editor)&&(0,L.isEditorInput)(D?.replacement)}e.isEditorReplacement=T;var n;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(p){p[p.GROUP_ACTIVE=0]="GROUP_ACTIVE",p[p.GROUP_INDEX=1]="GROUP_INDEX",p[p.GROUP_LOCKED=2]="GROUP_LOCKED",p[p.EDITOR_OPEN=3]="EDITOR_OPEN",p[p.EDITOR_CLOSE=4]="EDITOR_CLOSE",p[p.EDITOR_MOVE=5]="EDITOR_MOVE",p[p.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",p[p.EDITOR_LABEL=7]="EDITOR_LABEL",p[p.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",p[p.EDITOR_PIN=9]="EDITOR_PIN",p[p.EDITOR_STICKY=10]="EDITOR_STICKY",p[p.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var c;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(c=e.OpenEditorContext||(e.OpenEditorContext={}));function f(p){const D=p;return!!D&&typeof D.id=="number"&&Array.isArray(D.editors)}e.isEditorGroup=f;function h(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=h}),define(me[217],ge([0,1,4,128]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(C){const R=C;return typeof C=="number"||(0,L.isEditorGroup)(R)}e.isPreferredGroup=k}),define(me[15],ge([0,1,17,22,99,292,61,25,13,2,42,83,179,117,65,126,89,217,7]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(ae){function Ee(q){const{selectionStartLineNumber:Te,selectionStartColumn:Pe,positionLineNumber:Ze,positionColumn:Xe}=q,st=new E.Position(Te-1,Pe-1),wt=new E.Position(Ze-1,Xe-1);return new E.Selection(st,wt)}ae.to=Ee;function ce(q){const{anchor:Te,active:Pe}=q;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}ae.from=ce})(a=e.Selection||(e.Selection={}));var s;(function(ae){function Ee(q){if(!q)return;const{start:Te,end:Pe}=q;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}ae.from=Ee;function ce(q){if(!q)return;const{startLineNumber:Te,startColumn:Pe,endLineNumber:Ze,endColumn:Xe}=q;return new E.Range(Te-1,Pe-1,Ze-1,Xe-1)}ae.to=ce})(s=e.Range||(e.Range={}));var g;(function(ae){function Ee(ce){switch(ce){case 1:return E.StandardTokenType.Comment;case 0:return E.StandardTokenType.Other;case 4:return E.StandardTokenType.RegEx;case 2:return E.StandardTokenType.String}}ae.to=Ee})(g=e.TokenType||(e.TokenType={}));var t;(function(ae){function Ee(q){return new E.Position(q.lineNumber-1,q.column-1)}ae.to=Ee;function ce(q){return{lineNumber:q.line+1,column:q.character+1}}ae.from=ce})(t=e.Position||(e.Position={}));var u;(function(ae){function Ee(q){switch(q){case E.DiagnosticTag.Unnecessary:return 1;case E.DiagnosticTag.Deprecated:return 2}}ae.from=Ee;function ce(q){switch(q){case 1:return E.DiagnosticTag.Unnecessary;case 2:return E.DiagnosticTag.Deprecated;default:return}}ae.to=ce})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(ae){function Ee(q){let Te;return q.code&&((0,y.isString)(q.code)||(0,y.isNumber)(q.code)?Te=String(q.code):Te={value:String(q.code.value),target:q.code.target}),{...s.from(q.range),message:q.message,source:q.source,code:Te,severity:o.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(i.from),tags:Array.isArray(q.tags)?(0,m.coalesce)(q.tags.map(u.from)):void 0}}ae.from=Ee;function ce(q){const Te=new E.Diagnostic(s.to(q),q.message,o.to(q.severity));return Te.source=q.source,Te.code=(0,y.isString)(q.code)?q.code:q.code?.value,Te.relatedInformation=q.relatedInformation&&q.relatedInformation.map(i.to),Te.tags=q.tags&&(0,m.coalesce)(q.tags.map(u.to)),Te}ae.to=ce})(r=e.Diagnostic||(e.Diagnostic={}));var i;(function(ae){function Ee(q){return{...s.from(q.location.range),message:q.message,resource:q.location.uri}}ae.from=Ee;function ce(q){return new E.DiagnosticRelatedInformation(new E.Location(q.resource,s.to(q)),q.message)}ae.to=ce})(i=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var o;(function(ae){function Ee(q){switch(q){case E.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case E.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case E.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case E.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}ae.from=Ee;function ce(q){switch(q){case f.MarkerSeverity.Info:return E.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return E.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return E.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return E.DiagnosticSeverity.Hint;default:return E.DiagnosticSeverity.Error}}ae.to=ce})(o=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var l;(function(ae){function Ee(q){return typeof q=="number"&&q>=E.ViewColumn.One?q-1:q===E.ViewColumn.Beside?A.SIDE_GROUP:A.ACTIVE_GROUP}ae.from=Ee;function ce(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}ae.to=ce})(l=e.ViewColumn||(e.ViewColumn={}));function d(ae){return typeof ae.range!="undefined"}function b(ae){return ae.length===0?!0:!!d(ae[0])}e.isDecorationOptionsArr=b;var _;(function(ae){function Ee(Xe){return Xe.map(ae.from)}ae.fromMany=Ee;function ce(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function q(Xe){let st;if(ce(Xe)){const{language:gt,value:ft}=Xe;st={value:"```"+gt+`
`+ft+"\n```\n"}}else E.MarkdownString.isMarkdownString(Xe)?st={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons,supportHtml:Xe.supportHtml}:typeof Xe=="string"?st={value:Xe}:st={value:""};const wt=Object.create(null);st.uris=wt;const _t=gt=>{try{let ft=T.URI.parse(gt,!0);ft=ft.with({query:Te(ft.query,wt)}),wt[gt]=ft}catch(ft){}return""},dt=new C.Renderer;return dt.link=_t,dt.image=gt=>_t(k.parseHrefAndDimensions(gt).href),C(st.value,{renderer:dt}),st}ae.from=q;function Te(Xe,st){if(!Xe)return Xe;let wt;try{wt=(0,R.parse)(Xe)}catch(dt){}if(!wt)return Xe;let _t=!1;return wt=(0,S.cloneAndChange)(wt,dt=>{if(T.URI.isUri(dt)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return st[gt]=dt,_t=!0,gt}else return}),_t?JSON.stringify(wt):Xe}function Pe(Xe){const st=new E.MarkdownString(Xe.value,Xe.supportThemeIcons);return st.isTrusted=Xe.isTrusted,st.supportHtml=Xe.supportHtml,st}ae.to=Pe;function Ze(Xe){if(!!Xe)return typeof Xe=="string"?Xe:ae.from(Xe)}ae.fromStrict=Ze})(_=e.MarkdownString||(e.MarkdownString={}));function v(ae){return b(ae)?ae.map(Ee=>({range:s.from(Ee.range),hoverMessage:Array.isArray(Ee.hoverMessage)?_.fromMany(Ee.hoverMessage):Ee.hoverMessage?_.from(Ee.hoverMessage):void 0,renderOptions:Ee.renderOptions})):ae.map(Ee=>({range:s.from(Ee)}))}e.fromRangeOrRangeWithMessage=v;function P(ae){return typeof ae=="undefined"?ae:typeof ae=="string"?T.URI.file(ae):ae}e.pathOrURIToURI=P;var w;(function(ae){function Ee(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?P(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}ae.from=Ee})(w=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(ae){function Ee(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?P(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?w.from(ce.before):void 0,after:ce.after?w.from(ce.after):void 0}}ae.from=Ee})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var M;(function(ae){function Ee(ce){if(typeof ce=="undefined")return ce;switch(ce){case E.DecorationRangeBehavior.OpenOpen:return 0;case E.DecorationRangeBehavior.ClosedClosed:return 1;case E.DecorationRangeBehavior.OpenClosed:return 2;case E.DecorationRangeBehavior.ClosedOpen:return 3}}ae.from=Ee})(M=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var K;(function(ae){function Ee(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?M.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?F.from(ce.light):void 0,dark:ce.dark?F.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?P(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?w.from(ce.before):void 0,after:ce.after?w.from(ce.after):void 0}}ae.from=Ee})(K=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var G;(function(ae){function Ee(q){return{text:q.newText,eol:q.newEol&&te.from(q.newEol),range:s.from(q.range)}}ae.from=Ee;function ce(q){const Te=new E.TextEdit(s.to(q.range),q.text);return Te.newEol=typeof q.eol=="undefined"?void 0:te.to(q.eol),Te}ae.to=ce})(G=e.TextEdit||(e.TextEdit={}));var N;(function(ae){function Ee(q,Te,Pe){const Ze={edits:[]};if(q instanceof E.WorkspaceEdit)for(let Xe of q._allEntries())if(Xe._type===1)Ze.edits.push({_type:1,oldUri:Xe.from,newUri:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2){const st=Te?.getDocument(Xe.uri);Ze.edits.push({_type:2,resource:Xe.uri,edit:G.from(Xe.edit),modelVersionId:st?.version,metadata:Xe.metadata})}else Xe._type===3?Ze.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:Pe?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version}):Xe._type===5&&Ze.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:Pe?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(Ke.from)}});return Ze}ae.from=Ee;function ce(q){const Te=new E.WorkspaceEdit;for(const Pe of q.edits)Pe.edit?Te.replace(T.URI.revive(Pe.resource),s.to(Pe.edit.range),Pe.edit.text):Te.renameFile(T.URI.revive(Pe.oldUri),T.URI.revive(Pe.newUri),Pe.options);return Te}ae.to=ce})(N=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(ae){const Ee=Object.create(null);Ee[E.SymbolKind.File]=0,Ee[E.SymbolKind.Module]=1,Ee[E.SymbolKind.Namespace]=2,Ee[E.SymbolKind.Package]=3,Ee[E.SymbolKind.Class]=4,Ee[E.SymbolKind.Method]=5,Ee[E.SymbolKind.Property]=6,Ee[E.SymbolKind.Field]=7,Ee[E.SymbolKind.Constructor]=8,Ee[E.SymbolKind.Enum]=9,Ee[E.SymbolKind.Interface]=10,Ee[E.SymbolKind.Function]=11,Ee[E.SymbolKind.Variable]=12,Ee[E.SymbolKind.Constant]=13,Ee[E.SymbolKind.String]=14,Ee[E.SymbolKind.Number]=15,Ee[E.SymbolKind.Boolean]=16,Ee[E.SymbolKind.Array]=17,Ee[E.SymbolKind.Object]=18,Ee[E.SymbolKind.Key]=19,Ee[E.SymbolKind.Null]=20,Ee[E.SymbolKind.EnumMember]=21,Ee[E.SymbolKind.Struct]=22,Ee[E.SymbolKind.Event]=23,Ee[E.SymbolKind.Operator]=24,Ee[E.SymbolKind.TypeParameter]=25;function ce(Te){return typeof Ee[Te]=="number"?Ee[Te]:6}ae.from=ce;function q(Te){for(const Pe in Ee)if(Ee[Pe]===Te)return Number(Pe);return E.SymbolKind.Property}ae.to=q})(z=e.SymbolKind||(e.SymbolKind={}));var O;(function(ae){function Ee(q){switch(q){case E.SymbolTag.Deprecated:return 1}}ae.from=Ee;function ce(q){switch(q){case 1:return E.SymbolTag.Deprecated}}ae.to=ce})(O=e.SymbolTag||(e.SymbolTag={}));var x;(function(ae){function Ee(q){return{name:q.name,kind:z.from(q.kind),tags:q.tags&&q.tags.map(O.from),containerName:q.containerName,location:Q.from(q.location)}}ae.from=Ee;function ce(q){const Te=new E.SymbolInformation(q.name,z.to(q.kind),q.containerName,Q.to(q.location));return Te.tags=q.tags&&q.tags.map(O.to),Te}ae.to=ce})(x=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var B;(function(ae){function Ee(q){const Te={name:q.name||"!!MISSING: name!!",detail:q.detail,range:s.from(q.range),selectionRange:s.from(q.selectionRange),kind:z.from(q.kind),tags:q.tags?.map(O.from)??[]};return q.children&&(Te.children=q.children.map(Ee)),Te}ae.from=Ee;function ce(q){const Te=new E.DocumentSymbol(q.name,q.detail,z.to(q.kind),s.to(q.range),s.to(q.selectionRange));return(0,m.isNonEmptyArray)(q.tags)&&(Te.tags=q.tags.map(O.to)),q.children&&(Te.children=q.children.map(ce)),Te}ae.to=ce})(B=e.DocumentSymbol||(e.DocumentSymbol={}));var U;(function(ae){function Ee(q){const Te=new E.CallHierarchyItem(z.to(q.kind),q.name,q.detail||"",T.URI.revive(q.uri),s.to(q.range),s.to(q.selectionRange));return Te._sessionId=q._sessionId,Te._itemId=q._itemId,Te}ae.to=Ee;function ce(q,Te,Pe){if(Te=Te??q._sessionId,Pe=Pe??q._itemId,Te===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Pe,name:q.name,detail:q.detail,kind:z.from(q.kind),uri:q.uri,range:s.from(q.range),selectionRange:s.from(q.selectionRange),tags:q.tags?.map(O.from)}}ae.from=ce})(U=e.CallHierarchyItem||(e.CallHierarchyItem={}));var H;(function(ae){function Ee(ce){return new E.CallHierarchyIncomingCall(U.to(ce.from),ce.fromRanges.map(q=>s.to(q)))}ae.to=Ee})(H=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var W;(function(ae){function Ee(ce){return new E.CallHierarchyOutgoingCall(U.to(ce.to),ce.fromRanges.map(q=>s.to(q)))}ae.to=Ee})(W=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(ae){function Ee(q){return{range:q.range&&s.from(q.range),uri:q.uri}}ae.from=Ee;function ce(q){return new E.Location(T.URI.revive(q.uri),s.to(q.range))}ae.to=ce})(Q=e.location||(e.location={}));var Y;(function(ae){function Ee(q){const Te=q,Pe=q;return{originSelectionRange:Te.originSelectionRange?s.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Pe.uri,range:s.from(Te.targetRange?Te.targetRange:Pe.range),targetSelectionRange:Te.targetSelectionRange?s.from(Te.targetSelectionRange):void 0}}ae.from=Ee;function ce(q){return{targetUri:T.URI.revive(q.uri),targetRange:s.to(q.range),targetSelectionRange:q.targetSelectionRange?s.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?s.to(q.originSelectionRange):void 0}}ae.to=ce})(Y=e.DefinitionLink||(e.DefinitionLink={}));var he;(function(ae){function Ee(q){return{range:s.from(q.range),contents:_.fromMany(q.contents)}}ae.from=Ee;function ce(q){return new E.Hover(q.contents.map(_.to),s.to(q.range))}ae.to=ce})(he=e.Hover||(e.Hover={}));var _e;(function(ae){function Ee(q){return{range:s.from(q.range),expression:q.expression}}ae.from=Ee;function ce(q){return new E.EvaluatableExpression(s.to(q.range),q.expression)}ae.to=ce})(_e=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Se;(function(ae){function Ee(q){if(q instanceof E.InlineValueText)return{type:"text",range:s.from(q.range),text:q.text};if(q instanceof E.InlineValueVariableLookup)return{type:"variable",range:s.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof E.InlineValueEvaluatableExpression)return{type:"expression",range:s.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}ae.from=Ee;function ce(q){switch(q.type){case"text":return{range:s.to(q.range),text:q.text};case"variable":return{range:s.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:s.to(q.range),expression:q.expression}}}ae.to=ce})(Se=e.InlineValue||(e.InlineValue={}));var Re;(function(ae){function Ee(q){return{frameId:q.frameId,stoppedLocation:s.from(q.stoppedLocation)}}ae.from=Ee;function ce(q){return new E.InlineValueContext(q.frameId,s.to(q.stoppedLocation))}ae.to=ce})(Re=e.InlineValueContext||(e.InlineValueContext={}));var xe;(function(ae){function Ee(q){return{range:s.from(q.range),kind:q.kind}}ae.from=Ee;function ce(q){return new E.DocumentHighlight(s.to(q.range),q.kind)}ae.to=ce})(xe=e.DocumentHighlight||(e.DocumentHighlight={}));var Ue;(function(ae){function Ee(ce){switch(ce){case 1:return E.CompletionTriggerKind.TriggerCharacter;case 2:return E.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return E.CompletionTriggerKind.Invoke}}ae.to=Ee})(Ue=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(ae){function Ee(ce){return{triggerKind:Ue.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}ae.to=Ee})(je=e.CompletionContext||(e.CompletionContext={}));var V;(function(ae){function Ee(q){switch(q){case E.CompletionItemTag.Deprecated:return 1}}ae.from=Ee;function ce(q){switch(q){case 1:return E.CompletionItemTag.Deprecated}}ae.to=ce})(V=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(ae){const Ee=new Map([[E.CompletionItemKind.Method,0],[E.CompletionItemKind.Function,1],[E.CompletionItemKind.Constructor,2],[E.CompletionItemKind.Field,3],[E.CompletionItemKind.Variable,4],[E.CompletionItemKind.Class,5],[E.CompletionItemKind.Interface,7],[E.CompletionItemKind.Struct,6],[E.CompletionItemKind.Module,8],[E.CompletionItemKind.Property,9],[E.CompletionItemKind.Unit,12],[E.CompletionItemKind.Value,13],[E.CompletionItemKind.Constant,14],[E.CompletionItemKind.Enum,15],[E.CompletionItemKind.EnumMember,16],[E.CompletionItemKind.Keyword,17],[E.CompletionItemKind.Snippet,27],[E.CompletionItemKind.Text,18],[E.CompletionItemKind.Color,19],[E.CompletionItemKind.File,20],[E.CompletionItemKind.Reference,21],[E.CompletionItemKind.Folder,23],[E.CompletionItemKind.Event,10],[E.CompletionItemKind.Operator,11],[E.CompletionItemKind.TypeParameter,24],[E.CompletionItemKind.Issue,26],[E.CompletionItemKind.User,25]]);function ce(Pe){return Ee.get(Pe)??9}ae.from=ce;const q=new Map([[0,E.CompletionItemKind.Method],[1,E.CompletionItemKind.Function],[2,E.CompletionItemKind.Constructor],[3,E.CompletionItemKind.Field],[4,E.CompletionItemKind.Variable],[5,E.CompletionItemKind.Class],[7,E.CompletionItemKind.Interface],[6,E.CompletionItemKind.Struct],[8,E.CompletionItemKind.Module],[9,E.CompletionItemKind.Property],[12,E.CompletionItemKind.Unit],[13,E.CompletionItemKind.Value],[14,E.CompletionItemKind.Constant],[15,E.CompletionItemKind.Enum],[16,E.CompletionItemKind.EnumMember],[17,E.CompletionItemKind.Keyword],[27,E.CompletionItemKind.Snippet],[18,E.CompletionItemKind.Text],[19,E.CompletionItemKind.Color],[20,E.CompletionItemKind.File],[21,E.CompletionItemKind.Reference],[23,E.CompletionItemKind.Folder],[10,E.CompletionItemKind.Event],[11,E.CompletionItemKind.Operator],[24,E.CompletionItemKind.TypeParameter],[25,E.CompletionItemKind.User],[26,E.CompletionItemKind.Issue]]);function Te(Pe){return q.get(Pe)??E.CompletionItemKind.Property}ae.to=Te})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var re;(function(ae){function Ee(ce,q){const Te=new E.CompletionItem(ce.label);return Te.insertText=ce.insertText,Te.kind=ee.to(ce.kind),Te.tags=ce.tags?.map(V.to),Te.detail=ce.detail,Te.documentation=k.isMarkdownString(ce.documentation)?_.to(ce.documentation):ce.documentation,Te.sortText=ce.sortText,Te.filterText=ce.filterText,Te.preselect=ce.preselect,Te.commitCharacters=ce.commitCharacters,n.Range.isIRange(ce.range)?Te.range=s.to(ce.range):typeof ce.range=="object"&&(Te.range={inserting:s.to(ce.range.insert),replacing:s.to(ce.range.replace)}),Te.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Te.insertText=new E.SnippetString(ce.insertText):(Te.insertText=ce.insertText,Te.textEdit=Te.range instanceof E.Range?new E.TextEdit(Te.range,Te.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Te.additionalTextEdits=ce.additionalTextEdits.map(Pe=>G.to(Pe))),Te.command=q&&ce.command?q.fromInternal(ce.command):void 0,Te}ae.to=Ee})(re=e.CompletionItem||(e.CompletionItem={}));var le;(function(ae){function Ee(q){return{label:q.label,documentation:q.documentation?_.fromStrict(q.documentation):void 0}}ae.from=Ee;function ce(q){return{label:q.label,documentation:k.isMarkdownString(q.documentation)?_.to(q.documentation):q.documentation}}ae.to=ce})(le=e.ParameterInformation||(e.ParameterInformation={}));var Z;(function(ae){function Ee(q){return{label:q.label,documentation:q.documentation?_.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map(le.from):[],activeParameter:q.activeParameter}}ae.from=Ee;function ce(q){return{label:q.label,documentation:k.isMarkdownString(q.documentation)?_.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(le.to):[],activeParameter:q.activeParameter}}ae.to=ce})(Z=e.SignatureInformation||(e.SignatureInformation={}));var oe;(function(ae){function Ee(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(Z.from):[]}}ae.from=Ee;function ce(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(Z.to):[]}}ae.to=ce})(oe=e.SignatureHelp||(e.SignatureHelp={}));var ve;(function(ae){function Ee(q){return{text:q.text,position:t.from(q.position),kind:Me.from(q.kind??E.InlayHintKind.Other),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}ae.from=Ee;function ce(q){const Te=new E.InlayHint(q.text,t.to(q.position),Me.to(q.kind));return Te.whitespaceAfter=q.whitespaceAfter,Te.whitespaceBefore=q.whitespaceBefore,Te}ae.to=ce})(ve=e.InlayHint||(e.InlayHint={}));var Me;(function(ae){function Ee(q){return q}ae.from=Ee;function ce(q){return q}ae.to=ce})(Me=e.InlayHintKind||(e.InlayHintKind={}));var qe;(function(ae){function Ee(q){return{range:s.from(q.range),url:q.target,tooltip:q.tooltip}}ae.from=Ee;function ce(q){let Te;if(q.url)try{Te=typeof q.url=="string"?T.URI.parse(q.url,!0):T.URI.revive(q.url)}catch(Pe){}return new E.DocumentLink(s.to(q.range),Te)}ae.to=ce})(qe=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(ae){function Ee(q){const Te=new E.ColorPresentation(q.label);return q.textEdit&&(Te.textEdit=G.to(q.textEdit)),q.additionalTextEdits&&(Te.additionalTextEdits=q.additionalTextEdits.map(Pe=>G.to(Pe))),Te}ae.to=Ee;function ce(q){return{label:q.label,textEdit:q.textEdit?G.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Te=>G.from(Te)):void 0}}ae.from=ce})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var Je;(function(ae){function Ee(q){return new E.Color(q[0],q[1],q[2],q[3])}ae.to=Ee;function ce(q){return[q.red,q.green,q.blue,q.alpha]}ae.from=ce})(Je=e.Color||(e.Color={}));var Ce;(function(ae){function Ee(q){return{range:s.from(q.range)}}ae.from=Ee;function ce(q){return new E.SelectionRange(s.to(q.range))}ae.to=ce})(Ce=e.SelectionRange||(e.SelectionRange={}));var at;(function(ae){function Ee(ce){switch(ce){case 2:return E.TextDocumentSaveReason.AfterDelay;case 1:return E.TextDocumentSaveReason.Manual;case 3:case 4:return E.TextDocumentSaveReason.FocusOut}}ae.to=Ee})(at=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var X;(function(ae){function Ee(q){switch(q){case E.TextEditorLineNumbersStyle.Off:return 0;case E.TextEditorLineNumbersStyle.Relative:return 2;case E.TextEditorLineNumbersStyle.On:default:return 1}}ae.from=Ee;function ce(q){switch(q){case 0:return E.TextEditorLineNumbersStyle.Off;case 2:return E.TextEditorLineNumbersStyle.Relative;case 1:default:return E.TextEditorLineNumbersStyle.On}}ae.to=ce})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var te;(function(ae){function Ee(q){if(q===E.EndOfLine.CRLF)return 1;if(q===E.EndOfLine.LF)return 0}ae.from=Ee;function ce(q){if(q===1)return E.EndOfLine.CRLF;if(q===0)return E.EndOfLine.LF}ae.to=ce})(te=e.EndOfLine||(e.EndOfLine={}));var pe;(function(ae){function Ee(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case E.ProgressLocation.SourceControl:return 3;case E.ProgressLocation.Window:return 10;case E.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ae.from=Ee})(pe=e.ProgressLocation||(e.ProgressLocation={}));var ze;(function(ae){function Ee(ce){const q={start:ce.start+1,end:ce.end+1};return ce.kind&&(q.kind=tt.from(ce.kind)),q}ae.from=Ee})(ze=e.FoldingRange||(e.FoldingRange={}));var tt;(function(ae){function Ee(ce){if(ce)switch(ce){case E.FoldingRangeKind.Comment:return I.FoldingRangeKind.Comment;case E.FoldingRangeKind.Imports:return I.FoldingRangeKind.Imports;case E.FoldingRangeKind.Region:return I.FoldingRangeKind.Region}}ae.from=Ee})(tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ut;(function(ae){function Ee(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?s.from(ce.selection):void 0,override:typeof ce.override=="boolean"?c.EditorResolution.DISABLED:void 0}}ae.from=Ee})(ut=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var lt;(function(ae){function Ee(q){return q instanceof E.RelativePattern||typeof q=="string"?q:ce(q)?new E.RelativePattern(q.base,q.pattern):q}ae.from=Ee;function ce(q){const Te=q;return Te&&typeof Te.base=="string"&&typeof Te.pattern=="string"}})(lt=e.GlobPattern||(e.GlobPattern={}));var vt;(function(ae){function Ee(ce){if(ce){if(Array.isArray(ce))return ce.map(Ee);if(typeof ce=="string")return ce;{const q=ce;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:lt.from(q.pattern),exclusive:q.exclusive}}}else return}ae.from=Ee})(vt=e.LanguageSelector||(e.LanguageSelector={}));var Dt;(function(ae){function Ee(q){return{start:q.start,end:q.end}}ae.from=Ee;function ce(q){return new E.NotebookRange(q.start,q.end)}ae.to=ce})(Dt=e.NotebookRange||(e.NotebookRange={}));var ue;(function(ae){function Ee(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}ae.to=Ee;function ce(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}ae.from=ce})(ue=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ie;(function(ae){function Ee(q){switch(q){case E.NotebookCellKind.Markup:return p.CellKind.Markup;case E.NotebookCellKind.Code:default:return p.CellKind.Code}}ae.from=Ee;function ce(q){switch(q){case p.CellKind.Markup:return E.NotebookCellKind.Markup;case p.CellKind.Code:default:return E.NotebookCellKind.Code}}ae.to=ce})(Ie=e.NotebookCellKind||(e.NotebookCellKind={}));var Be;(function(ae){function Ee(q){const Te={metadata:q.metadata??Object.create(null),cells:[]};for(let Pe of q.cells)E.NotebookCellData.validate(Pe),Te.cells.push(Ke.from(Pe));return Te}ae.from=Ee;function ce(q){const Te=new E.NotebookData(q.cells.map(Ke.to));return(0,y.isEmptyObject)(q.metadata)||(Te.metadata=q.metadata),Te}ae.to=ce})(Be=e.NotebookData||(e.NotebookData={}));var Ke;(function(ae){function Ee(q){return{cellKind:Ie.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:ue.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(ot.from):[]}}ae.from=Ee;function ce(q){return new E.NotebookCellData(Ie.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(ot.to):void 0,q.metadata,q.internalMetadata?ue.to(q.internalMetadata):void 0)}ae.to=ce})(Ke=e.NotebookCellData||(e.NotebookCellData={}));var We;(function(ae){function Ee(q){return{mime:q.mime,valueBytes:L.VSBuffer.wrap(q.data)}}ae.from=Ee;function ce(q){return new E.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}ae.to=ce})(We=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ot;(function(ae){function Ee(q){return{outputId:q.id,items:q.items.map(We.from),metadata:q.metadata}}ae.from=Ee;function ce(q){const Te=q.items.map(We.to);return new E.NotebookCellOutput(Te,q.outputId,q.metadata)}ae.to=ce})(ot=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Le;(function(ae){function Ee(Pe){if(Pe!=null){if(Pe instanceof E.RelativePattern||typeof Pe=="string")return Pe;if(Te(Pe))return new E.RelativePattern(Pe.base,Pe.pattern);if(q(Pe))return{include:lt.from(Pe.include)||void 0,exclude:lt.from(Pe.exclude)||void 0}}}ae.from=Ee;function ce(Pe){return typeof Pe=="string"?Pe:Te(Pe)?{base:Pe.base,pattern:Pe.pattern}:{include:Pe.include,exclude:Pe.exclude}}ae.to=ce;function q(Pe){const Ze=Pe,Xe=lt.from(Ze.include);if(!(Xe&&Xe instanceof E.RelativePattern||typeof Xe=="string"))return!1;const st=lt.from(Ze.exclude);return!!(st&&st instanceof E.RelativePattern||typeof st=="string")}function Te(Pe){const Ze=Pe;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(Le=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ye;(function(ae){function Ee(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?w.from(ce.top):void 0}}ae.from=Ee})(ye=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ke;(function(ae){function Ee(ce,q,Te){const Pe=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===E.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Pe,Te),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}ae.from=Ee})(ke=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ne;(function(ae){function Ee(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{}}}ae.from=Ee})(ne=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var de;(function(ae){function Ee(q){return{uri:q.uri,provides:q.provides}}ae.from=Ee;function ce(q){return new E.NotebookRendererScript(T.URI.revive(q.uri),q.provides)}ae.to=ce})(de=e.NotebookRendererScript||(e.NotebookRendererScript={}));var be;(function(ae){function Ee(q){return{message:_.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location?Q.from(q.location):void 0}}ae.from=Ee;function ce(q){const Te=new E.TestMessage(typeof q.message=="string"?q.message:_.to(q.message));return Te.actualOutput=q.actual,Te.expectedOutput=q.expected,Te.location=q.location?Q.to(q.location):void 0,Te}ae.to=ce})(be=e.TestMessage||(e.TestMessage={}));var we;(function(ae){let Ee;(function(ce){ce.Delimiter="\0"})(Ee||(Ee={})),ae.namespace=(ce,q)=>ce+"\0"+q,ae.denamespace=ce=>{const q=ce.indexOf("\0");return{ctrlId:ce.slice(0,q),tagId:ce.slice(q+1)}}})(we=e.TestTag||(e.TestTag={}));var Fe;(function(ae){function Ee(Pe){const Ze=(0,h.getPrivateApiFor)(Pe).controllerId;return{extId:D.TestId.fromExtHostTestItem(Pe,Ze).toString(),label:Pe.label,uri:Pe.uri,tags:Pe.tags.map(Xe=>we.namespace(Ze,Xe.id)),range:s.from(Pe.range)||null,description:Pe.description||null,error:Pe.error&&_.fromStrict(Pe.error)||null}}ae.from=Ee;function ce(Pe){return{id:D.TestId.fromString(Pe.extId).localId,label:Pe.label,uri:T.URI.revive(Pe.uri),tags:(Pe.tags||[]).map(Ze=>{const{tagId:Xe}=we.denamespace(Ze);return new E.TestTag(Xe)}),range:s.to(Pe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Pe.description||void 0}}ae.toPlain=ce;function q(Pe){const Ze=D.TestId.fromString(Pe.extId),Xe=new h.TestItemImpl(Ze.controllerId,Ze.localId,Pe.label,T.URI.revive(Pe.uri));return Xe.range=s.to(Pe.range||void 0),Xe.description=Pe.description||void 0,Xe}function Te(Pe){let Ze;for(const Xe of Pe.tests){const st=q(Xe.item);(0,h.getPrivateApiFor)(st).parent=Ze,Ze=st}return Ze}ae.toItemFromContext=Te})(Fe=e.TestItem||(e.TestItem={})),function(ae){function Ee(q){return{id:q.id}}ae.from=Ee;function ce(q){return new E.TestTag(q.id)}ae.to=ce}(we=e.TestTag||(e.TestTag={}));var Ge;(function(ae){const Ee=(q,Te)=>{const Pe={...Fe.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(Xe=>Xe.type===0).map(be.to)})),children:q.children.map(Ze=>Te.get(Ze)).filter(y.isDefined).map(Ze=>Ee(Ze,Te))};for(const Ze of Pe.children)Ze.parent=Pe;return Pe};function ce(q){const Te=[],Pe=new Map;for(const Ze of q.items)Pe.set(Ze.item.extId,Ze),q.request.targets.some(Xe=>Xe.controllerId===Ze.controllerId&&Xe.testIds.includes(Ze.item.extId))&&Te.push(Ze);return{completedAt:q.completedAt,results:Te.map(Ze=>Ee(Ze,Pe))}}ae.to=ce})(Ge=e.TestResults||(e.TestResults={}));var He;(function(ae){function Ee(Pe){return{covered:Pe.covered,total:Pe.covered}}function ce(Pe){return"line"in Pe?t.from(Pe):s.from(Pe)}function q(Pe){return"branches"in Pe?{count:Pe.executionCount,location:ce(Pe.location),type:1,branches:Pe.branches.length?Pe.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ce(Ze.location)})):void 0}:{type:0,count:Pe.executionCount,location:ce(Pe.location)}}ae.fromDetailed=q;function Te(Pe){return{uri:Pe.uri,statement:Ee(Pe.statementCoverage),branch:Pe.branchCoverage&&Ee(Pe.branchCoverage),function:Pe.functionCoverage&&Ee(Pe.functionCoverage),details:Pe.detailedCoverage?.map(q)}}ae.fromFile=Te})(He=e.TestCoverage||(e.TestCoverage={}));var Ye;(function(ae){function Ee(ce){switch(ce){case 1:return E.CodeActionTriggerKind.Invoke;case 2:return E.CodeActionTriggerKind.Automatic}}ae.to=Ee})(Ye=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var it;(function(ae){function Ee(q){const Te=new E.TypeHierarchyItem(z.to(q.kind),q.name,q.detail||"",T.URI.revive(q.uri),s.to(q.range),s.to(q.selectionRange));return Te._sessionId=q._sessionId,Te._itemId=q._itemId,Te}ae.to=Ee;function ce(q,Te,Pe){if(Te=Te??q._sessionId,Pe=Pe??q._itemId,Te===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Pe,kind:z.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:s.from(q.range),selectionRange:s.from(q.selectionRange),tags:q.tags?.map(O.from)}}ae.from=ce})(it=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(me[218],ge([0,1,2,16,7,15,95]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class S{constructor(T,n,I,c={timeout:1500,errors:3}){this._logService=T,this._documents=n,this._mainThreadBulkEdits=I,this._thresholds=c,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(n,I,c)=>{const h={dispose:this._callbacks.push([n,I,T])};return Array.isArray(c)&&c.push(h),h}}async $participateInSave(T,n){const I=m.URI.revive(T);let c=!1;const f=setTimeout(()=>c=!0,this._thresholds.timeout),h=[];try{for(let p of[...this._callbacks]){if(c)break;const D=this._documents.getDocument(I),A=await this._deliverEventAsyncAndBlameBadListeners(p,{document:D,reason:C.TextDocumentSaveReason.to(n)});h.push(A)}}finally{clearTimeout(f)}return h}_deliverEventAsyncAndBlameBadListeners([T,n,I],c){const f=this._badListeners.get(T);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,T,n,c).then(()=>!0,h=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const p=this._badListeners.get(T);this._badListeners.set(T,p?p+1:1),typeof p=="number"&&p>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,n,I,c){const f=[],h=Date.now(),{document:p,reason:D}=c,{version:A}=p,E=Object.freeze({document:p,reason:D,waitUntil(a){if(Object.isFrozen(f))throw(0,L.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(a))}});try{n.apply(I,[E])}catch(a){return Promise.reject(a)}return Object.freeze(f),new Promise((a,s)=>{const g=setTimeout(()=>s(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(g),a(t)}).catch(t=>{clearTimeout(g),s(t)})}).then(a=>{const s={edits:[]};for(const g of a)if(Array.isArray(g)&&g.every(t=>t instanceof k.TextEdit))for(const{newText:t,newEol:u,range:r}of g)s.edits.push({_type:2,resource:p.uri,edit:{range:r&&C.Range.from(r),text:t,eol:u&&C.EndOfLine.from(u)}});if(s.edits.length!==0)return A===p.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(s):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=S}),define(me[54],ge([0,1,15,2,3,4]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class R{constructor(){this._onDidChangeTabs=new k.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new k.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[]}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(y){let T=-1;this._tabs=y.map((I,c)=>(I.isActive&&(T=c),Object.freeze({label:I.label,viewColumn:m.ViewColumn.to(I.viewColumn),resource:L.URI.revive(I.resource),viewId:I.editorId,isActive:I.isActive})));const n=this._activeTab;this._activeTab=T===-1?void 0:this._tabs[T],this._activeTab!==n&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}}e.ExtHostEditorTabs=R}),define(me[219],ge([0,1,3,30,2,15,7]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{constructor(n,I,c,f,h){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,c&&(this._config+=1),f&&(this._config+=2),h&&(this._config+=4);const p=(0,L.parse)(I),D=n(A=>{if(!c)for(let E of A.created){const a=k.URI.revive(E);p(a.fsPath)&&this._onDidCreate.fire(a)}if(!f)for(let E of A.changed){const a=k.URI.revive(E);p(a.fsPath)&&this._onDidChange.fire(a)}if(!h)for(let E of A.deleted){const a=k.URI.revive(E);p(a.fsPath)&&this._onDidDelete.fire(a)}});this._disposable=R.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,D)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class y{constructor(n,I,c){this._logService=I,this._extHostDocumentsAndEditors=c,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,I,c,f){return new S(this._onFileSystemEvent.event,n,I,c,f)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,I){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(c=>({oldUri:k.URI.revive(c.source),newUri:k.URI.revive(c.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(c=>k.URI.revive(c.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(c=>k.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,I){return(c,f,h)=>{const p=function(A){c.call(f,A)};return p.extension=n,I.event(p,void 0,h)}}async $onWillRunFileOperation(n,I,c,f){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(h=>({oldUri:k.URI.revive(h.source),newUri:k.URI.revive(h.target)}))},c,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(h=>k.URI.revive(h.target))},c,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(h=>k.URI.revive(h.target))},c,f)}}async _fireWillEvent(n,I,c,f){const h=new Set,p=[];if(await n.fireAsync(I,f,async(A,E)=>{const a=Date.now(),s=await Promise.resolve(A);s instanceof R.WorkspaceEdit&&(p.push(s),h.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-a>c&&this._logService.warn("SLOW file-participant",E.extension.identifier)}),f.isCancellationRequested||p.length===0)return;const D={edits:[]};for(let A of p){let{edits:E}=C.WorkspaceEdit.from(A,this._extHostDocumentsAndEditors);D.edits=D.edits.concat(E)}return{edit:D,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=y}),define(me[220],ge([0,1,10,25,2,15,7,126]),function(J,e,m,L,k,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(c,f,h,p){this.start=c,this.deletedCount=f,this.deletedItems=h,this.items=p}static asApiEvents(c){return c.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(h=>h.apiCell)}))}}class T{constructor(c,f,h){this.notebook=c,this._extHostDocument=f,this._cellData=h,this.handle=h.handle,this.uri=k.URI.revive(h.uri),this.cellKind=h.cellKind,this._outputs=h.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=h.internalMetadata??{},this._metadata=Object.freeze(h.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(h.internalMetadata??{}))}static asModelAddData(c,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:c}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const c=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return c.notebook.getCellIndex(c)},notebook:c.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return c._mime},set mime(h){c._mime=h},get outputs(){return c._outputs.slice(0)},get metadata(){return c._metadata},get executionSummary(){return c._previousResult}})}return this._apiCell}setOutputs(c){this._outputs=c.map(C.NotebookCellOutput.to)}setOutputItems(c,f,h){const p=h.map(C.NotebookCellOutputItem.to),D=this._outputs.find(A=>A.id===c);D&&(f||(D.items.length=0),D.items.push(...p))}setMetadata(c){this._metadata=Object.freeze(c)}setInternalMetadata(c){this._internalMetadata=c,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(c))}setMime(c){}}e.ExtHostCell=T;class n{constructor(c,f,h,p,D,A){this._proxy=c,this._textDocumentsAndEditors=f,this._textDocuments=h,this._emitter=p,this.uri=D,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=A.viewType,this._metadata=Object.freeze(A.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,A.cells]],!0),this._versionId=A.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const c=this;this._notebook={get uri(){return c.uri},get version(){return c._versionId},get notebookType(){return c._notebookType},get isDirty(){return c._isDirty},get isUntitled(){return c.uri.scheme===m.Schemas.untitled},get isClosed(){return c._disposed},get metadata(){return c._metadata},get cellCount(){return c._cells.length},cellAt(f){return f=c._validateIndex(f),c._cells[f].apiCell},getCells(f){return(f?c._getCells(f):c._cells).map(p=>p.apiCell)},save(){return c._save()}}}return this._notebook}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(c){c.metadata&&(this._metadata=Object.freeze({...this._metadata,...c.metadata}))}acceptDirty(c){this._isDirty=c}acceptModelChanged(c,f){this._versionId=c.versionId,this._isDirty=f;for(const h of c.rawEvents)h.kind===S.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1):h.kind===S.NotebookCellsChangeType.Move?this._moveCell(h.index,h.newIdx):h.kind===S.NotebookCellsChangeType.Output?this._setCellOutputs(h.index,h.outputs):h.kind===S.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems):h.kind===S.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(h.index,h.language):h.kind===S.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===S.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(h.index,h.metadata):h.kind===S.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(h.index,h.internalMetadata)}_validateIndex(c){return c=c|0,c<0?0:c>=this._cells.length?this._cells.length-1:c}_validateRange(c){let f=c.start|0,h=c.end|0;return f<0&&(f=0),h>this._cells.length&&(h=this._cells.length),c.with({start:f,end:h})}_getCells(c){c=this._validateRange(c);const f=[];for(let h=c.start;h<c.end;h++)f.push(this._cells[h]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(c,f){if(this._disposed)return;const h=[],p=[],D=[];c.reverse().forEach(A=>{const a=A[2].map(t=>{const u=new T(this,this._textDocumentsAndEditors,t);return f||p.push(T.asModelAddData(this.apiNotebook,t)),u}),s=new y(A[0],A[1],[],a),g=this._cells.splice(A[0],A[1],...a);for(const t of g)D.push(t.uri),s.deletedItems.push(t.apiCell);h.push(s)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:D}),f||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(h)}))}_moveCell(c,f){const h=this._cells.splice(c,1);this._cells.splice(f,0,...h);const p=[new y(c,1,h.map(D=>D.apiCell),[]),new y(f,0,[],h)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(p)}))}_setCellOutputs(c,f){const h=this._cells[c];h.setOutputs(f),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[h.apiCell]}))}_setCellOutputItems(c,f,h,p){const D=this._cells[c];D.setOutputItems(f,h,p),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[D.apiCell]}))}_changeCellLanguage(c,f){const h=this._cells[c];h.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(h.uri,f)}_changeCellMime(c,f){const h=this._cells[c];h.apiCell.mime=f}_changeCellMetadata(c,f){const h=this._cells[c],p=h.apiCell.metadata;h.setMetadata(f);const D=h.apiCell.metadata;(0,L.equals)(p,D)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:h.apiCell}))}_changeCellInternalMetadata(c,f){const h=this._cells[c],p=h.internalMetadata;if(h.setInternalMetadata(f),p.runState!==f.runState){const D=f.runState??R.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:h.apiCell,state:D}))}}getCellFromApiCell(c){return this._cells.find(f=>f.apiCell===c)}getCellFromIndex(c){return this._cells[c]}getCell(c){return this._cells.find(f=>f.handle===c)}getCellIndex(c){return this._cells.indexOf(c)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(me[129],ge([0,1,7,15,16]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:T})}replaceCells(y,T,n){this._throwIfFinalized(),!(y===T&&n.length===0)&&this._collectedEdits.push({editType:1,index:y,count:T-y,cells:n.map(L.NotebookCellData.from)})}}class R{constructor(y,T,n,I,c,f){this.id=y,this._proxy=T,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._visibleRanges=I,this._viewColumn=f}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(T){if(!Array.isArray(T)||!T.every(m.NotebookRange.isNotebookRange))throw(0,k.illegalArgument)("selections");y._selections=T,y._trySetSelections(T)},get visibleRanges(){return y._visibleRanges},revealRange(T,n){y._proxy.$tryRevealRange(y.id,L.NotebookRange.from(T),n??m.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(T){const n=new C(this.document.version);return T(n),y._applyEdit(n.finalize())},setDecorations(T,n){return y.setDecorations(T,n)}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(L.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const T=[];let n=-1;for(let I=0;I<y.cellEdits.length;I++){if(n<0){T.push(y.cellEdits[I]),n++;continue}const f=T[n],h=y.cellEdits[I];if(f.editType===1&&h.editType===1&&f.index===h.index){f.cells.push(...y.cellEdits[I].cells),f.count+=y.cellEdits[I].count;continue}T.push(y.cellEdits[I]),n++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,T)}setDecorations(y,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return T.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(T),y.key)}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(me[221],ge([0,1,15,118,166,21,59]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,c,f){const h=this._handles++,{title:p,location:D,cancellable:A}=c,E={label:(0,k.localize)(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(h,{location:m.ProgressLocation.from(D),title:p,source:E,cancellable:A},I),this._withProgress(h,f,!!A)}_withProgress(I,c,f){let h;f&&(h=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,h));const p=A=>{this._proxy.$progressEnd(A),this._mapHandleToCancellationSource.delete(A),h&&h.dispose()};let D;try{D=c(new T(this._proxy,I),f&&h?h.token:C.CancellationToken.None)}catch(A){throw p(I),A}return D.then(A=>p(I),A=>p(I)),D}$acceptProgressCanceled(I){const c=this._mapHandleToCancellationSource.get(I);c&&(c.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=S;function y(n,I){return n.message=I.message,typeof I.increment=="number"&&(typeof n.increment=="number"?n.increment+=I.increment:n.increment=I.increment),n}class T extends L.Progress{constructor(I,c){super(f=>this.throttledReport(f));this._proxy=I,this._handle=c}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}Ve([(0,R.throttle)(100,(n,I)=>y(n,I),()=>Object.create(null))],T.prototype,"throttledReport",null)}),define(me[130],ge([0,1,57,16,76,15,7]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class S{constructor(c,f,h){const p=S._Keys.nextId();c.$registerTextEditorDecorationType(f.identifier,p,C.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:p,dispose(){c.$removeTextEditorDecorationType(p)}})}}e.TextEditorDecorationType=S,S._Keys=new k.IdGenerator("TextEditorDecorationType");class y{constructor(c,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,f){this._throwIfFinalized();let h=null;if(c instanceof R.Position)h=new R.Range(c,c);else if(c instanceof R.Range)h=c;else throw new Error("Unrecognized location");this._pushEdit(h,f,!1)}insert(c,f){this._throwIfFinalized(),this._pushEdit(new R.Range(c,c),f,!0)}delete(c){this._throwIfFinalized();let f=null;if(c instanceof R.Range)f=c;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(c,f,h){const p=this._document.validateRange(c);this._collectedEdits.push({range:p,text:f,forceMoveMarkers:h})}setEndOfLine(c){if(this._throwIfFinalized(),c!==R.EndOfLine.LF&&c!==R.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=y;class T{constructor(c,f,h,p){this._proxy=c,this._id=f,this._accept(h),this._logService=p;const D=this;this.value={get tabSize(){return D._tabSize},set tabSize(A){D._setTabSize(A)},get insertSpaces(){return D._insertSpaces},set insertSpaces(A){D._setInsertSpaces(A)},get cursorStyle(){return D._cursorStyle},set cursorStyle(A){D._setCursorStyle(A)},get lineNumbers(){return D._lineNumbers},set lineNumbers(A){D._setLineNumbers(A)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const f=Math.floor(c);return f>0?f:null}if(typeof c=="string"){const f=parseInt(c,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(c){const f=this._validateTabSize(c);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const f=this._validateInsertSpaces(c);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(c)})))}assign(c){const f={};let h=!1;if(typeof c.tabSize!="undefined"){const p=this._validateTabSize(c.tabSize);p==="auto"?(h=!0,f.tabSize=p):typeof p=="number"&&this._tabSize!==p&&(this._tabSize=p,h=!0,f.tabSize=p)}if(typeof c.insertSpaces!="undefined"){const p=this._validateInsertSpaces(c.insertSpaces);p==="auto"?(h=!0,f.insertSpaces=p):this._insertSpaces!==p&&(this._insertSpaces=p,h=!0,f.insertSpaces=p)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,h=!0,f.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,h=!0,f.lineNumbers=C.TextEditorLineNumbersStyle.from(c.lineNumbers)),h&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(c){c.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=T;class n{constructor(c,f,h,p,D,A,E,a){this.id=c,this._proxy=f,this._logService=h,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=D,this._options=new T(this._proxy,this.id,A,h),this._visibleRanges=E,this._viewColumn=a;const s=this;this.value=Object.freeze({get document(){return p.getValue()},set document(g){throw(0,L.readonly)("document")},get selection(){return s._selections&&s._selections[0]},set selection(g){if(!(g instanceof R.Selection))throw(0,L.illegalArgument)("selection");s._selections=[g],s._trySetSelection()},get selections(){return s._selections},set selections(g){if(!Array.isArray(g)||g.some(t=>!(t instanceof R.Selection)))throw(0,L.illegalArgument)("selections");s._selections=g,s._trySetSelection()},get visibleRanges(){return s._visibleRanges},set visibleRanges(g){throw(0,L.readonly)("visibleRanges")},get options(){return s._options.value},set options(g){s._disposed||s._options.assign(g)},get viewColumn(){return s._viewColumn},set viewColumn(g){throw(0,L.readonly)("viewColumn")},edit(g,t={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new y(p.getValue(),t);return g(u),s._applyEdit(u)},insertSnippet(g,t,u={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=s._selections.map(i=>C.Range.from(i));else if(t instanceof R.Position){const{lineNumber:i,column:o}=C.Position.from(t);r=[{startLineNumber:i,startColumn:o,endLineNumber:i,endColumn:o}]}else if(t instanceof R.Range)r=[C.Range.from(t)];else{r=[];for(const i of t)if(i instanceof R.Range)r.push(C.Range.from(i));else{const{lineNumber:o,column:l}=C.Position.from(i);r.push({startLineNumber:o,startColumn:l,endLineNumber:o,endColumn:l})}}return f.$tryInsertSnippet(c,g.value,r,u)},setDecorations(g,t){const u=t.length===0;u&&!s._hasDecorationsForKey.has(g.key)||(u?s._hasDecorationsForKey.delete(g.key):s._hasDecorationsForKey.add(g.key),s._runOnProxy(()=>{if(C.isDecorationOptionsArr(t))return f.$trySetDecorations(c,g.key,C.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let i=0,o=t.length;i<o;i++){const l=t[i];r[4*i]=l.start.line+1,r[4*i+1]=l.start.character+1,r[4*i+2]=l.end.line+1,r[4*i+3]=l.end.character+1}return f.$trySetDecorationsFast(c,g.key,r)}}))},revealRange(g,t){s._runOnProxy(()=>f.$tryRevealRange(c,C.Range.from(g),t||R.TextEditorRevealType.Default))},show(g){f.$tryShowEditor(c,C.ViewColumn.from(g))},hide(){f.$tryHideEditor(c)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,m.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,m.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,m.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,m.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const f=c.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const h=f.edits.map(D=>D.range);h.sort((D,A)=>D.end.line===A.end.line?D.end.character===A.end.character?D.start.line===A.start.line?D.start.character-A.start.character:D.start.line-A.start.line:D.end.character-A.end.character:D.end.line-A.end.line);for(let D=0,A=h.length-1;D<A;D++){const E=h[D].end;if(h[D+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=f.edits.map(D=>({range:C.Range.from(D.range),text:D.text,forceMoveMarkers:D.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,p,{setEndOfLine:typeof f.setEndOfLine=="number"?C.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=n}),define(me[222],ge([0,1,169,23,2,3,6,209,18,7,13,17,15,21,206]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function p(E,a){if((0,n.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let s;return Array.isArray(E.highlights)&&(s=E.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),s=s.length?s:void 0),{label:E.label,highlights:s}}}class D{constructor(a,s,g){this._proxy=a,this.commands=s,this.logService=g,this.treeViews=new Map;function t(u){return u&&u.$treeViewId&&u.$treeItemHandle}s.registerArgumentProcessor({processArgument:u=>t(u)?this.convertArgument(u):Array.isArray(u)&&u.length>0?u.map(r=>t(r)?this.convertArgument(r):r):u})}registerTreeDataProvider(a,s,g){const t=this.createTreeView(a,{treeDataProvider:s},g);return{dispose:()=>t.dispose()}}createTreeView(a,s,g){if(!s||!s.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=s.dragAndDropController!==void 0,u=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!s.showCollapseAll,canSelectMany:!!s.canSelectMany,canDragAndDrop:t}),r=this.createExtHostTreeView(a,s,g);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(i){r.message=i},get title(){return r.title},set title(i){r.title=i},get description(){return r.description},set description(i){r.description=i},reveal:(i,o)=>r.reveal(i,o),dispose:async()=>{await u,this.treeViews.delete(a),r.dispose()}}}$getChildren(a,s){const g=this.treeViews.get(a);return g?g.getChildren(s):Promise.reject(new Error((0,m.localize)(0,null,a)))}async $onDrop(a,s,g){const t=this.treeViews.get(a);if(!t)return Promise.reject(new Error((0,m.localize)(1,null,a)));const u=h.TreeDataTransferConverter.toITreeDataTransfer(s);if(u.items.has(S.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await u.items.get(S.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(o=>t.getExtensionElement(o)).filter(o=>!!o);i.length>0?u.items.set(S.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):u.items.delete(S.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(u,g)}async $hasResolve(a){const s=this.treeViews.get(a);if(!s)throw new Error((0,m.localize)(2,null,a));return s.hasResolve}$resolve(a,s,g){const t=this.treeViews.get(a);if(!t)throw new Error((0,m.localize)(3,null,a));return t.resolveTreeItem(s,g)}$setExpanded(a,s,g){const t=this.treeViews.get(a);if(!t)throw new Error((0,m.localize)(4,null,a));t.setExpanded(s,g)}$setSelection(a,s){const g=this.treeViews.get(a);if(!g)throw new Error((0,m.localize)(5,null,a));g.setSelection(s)}$setVisible(a,s){const g=this.treeViews.get(a);if(!g)throw new Error((0,m.localize)(6,null,a));g.setVisible(s)}createExtHostTreeView(a,s,g){const t=new A(a,s,this._proxy,this.commands.converter,this.logService,g);return this.treeViews.set(a,t),t}convertArgument(a){const s=this.treeViews.get(a.$treeViewId);return s?s.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=D;class A extends R.Disposable{constructor(a,s,g,t,u,r){super();if(this.viewId=a,this.proxy=g,this.commands=t,this.logService=u,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,r.contributes&&r.contributes.views)for(const l in r.contributes.views)for(const d of r.contributes.views[l])d.id===a&&(this._title=d.name);this.dataProvider=s.treeDataProvider,this.dndController=s.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(l=>this._onDidChangeData.fire({message:!1,element:l}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let i,o;this._register(C.Event.debounce(this._onDidChangeData.event,(l,d)=>(l||(l={message:!1,elements:[]}),d.element!==!1&&(i||(i=new Promise(b=>o=b),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(d.element)?l.elements.push(...d.element):l.elements.push(d.element)),d.message&&(l.message=!0),l),200,!0)(({message:l,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=o;return i=null,this.refresh(d).then(()=>b())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,n.isUndefinedOrNull)(a))}async getChildren(a){const s=a?this.getExtensionElement(a):void 0;if(a&&!s)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let g=this.getChildrenNodes(a);return g||(g=await this.fetchChildrenNodes(s)),g?g.map(t=>t.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,s){s=s||{select:!0,focus:!1};const g=(0,n.isUndefinedOrNull)(s.select)?!0:s.select,t=(0,n.isUndefinedOrNull)(s.focus)?!1:s.focus,u=(0,n.isUndefinedOrNull)(s.expand)?!1:s.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(r=>this.resolveTreeNode(a,r[r.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:r.map(o=>o.item)},{select:g,focus:t,expand:u})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:g,focus:t,expand:u})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}setExpanded(a,s){const g=this.getExtensionElement(a);g&&(s?this._onDidExpandElement.fire(Object.freeze({element:g})):this._onDidCollapseElement.fire(Object.freeze({element:g})))}setSelection(a){(0,I.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(a,s){const g=this.getExtensionElement(s);if(!!g)return(0,y.asPromise)(()=>this.dndController?.onDrop(a,g))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,s){if(!this.dataProvider.resolveTreeItem)return;const g=this.elements.get(a);if(g){const t=this.nodes.get(g);if(t){const u=await this.dataProvider.resolveTreeItem(t.extensionItem,g,s)??t.extensionItem;return t.item.tooltip=this.getTooltip(u.tooltip),t.item.command=this.getCommand(t.disposableStore,u.command),t.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(s=>s?this.resolveUnknownParentChain(s).then(g=>this.resolveTreeNode(s,g[g.length-1]).then(t=>(g.push(t),g))):Promise.resolve([]))}resolveParent(a){const s=this.nodes.get(a);return s?Promise.resolve(s.parent?this.elements.get(s.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,s){const g=this.nodes.get(a);return g?Promise.resolve(g):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(t=>this.createHandle(a,t,s,!0)).then(t=>this.getChildren(s?s.item.handle:void 0).then(()=>{const u=this.getExtensionElement(t);if(u){const r=this.nodes.get(u);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(a){if(a){let s;if(typeof a=="string"){const g=this.getExtensionElement(a);s=g?this.nodes.get(g):void 0}else s=a;return s&&s.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const s=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const g=a?this.nodes.get(a):void 0,t=await this.dataProvider.getChildren(a);if(s.token.isCancellationRequested)return;const u=await Promise.all((0,I.coalesce)(t||[]).map(async r=>{const i=await this.dataProvider.getTreeItem(r);return i&&!s.token.isCancellationRequested?this.createAndRegisterTreeNode(r,i,g):null}));return s.token.isCancellationRequested?void 0:(0,I.coalesce)(u)}finally{s.dispose()}}refresh(a){if(a.some(g=>!g))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const g=this.getHandlesToRefresh(a);if(g.length)return this.refreshHandles(g)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const s=new Set,g=a.map(u=>this.nodes.get(u));for(const u of g)if(u&&!s.has(u.item.handle)){let r=u;for(;r&&r.parent&&g.findIndex(i=>r&&r.parent&&i&&i.item.handle===r.parent.item.handle)===-1;){const i=this.elements.get(r.parent.item.handle);r=i?this.nodes.get(i):void 0}r&&!r.parent&&s.add(u.item.handle)}const t=[];return s.forEach(u=>{const r=this.elements.get(u);if(r){const i=this.nodes.get(r);i&&(!i.parent||!s.has(i.parent.item.handle))&&t.push(u)}}),t}refreshHandles(a){const s={};return Promise.all(a.map(g=>this.refreshNode(g).then(t=>{t&&(s[g]=t.item)}))).then(()=>Object.keys(s).length?this.proxy.$refresh(this.viewId,s):void 0)}refreshNode(a){const s=this.getExtensionElement(a);if(s){const g=this.nodes.get(s);if(g)return this.clearChildren(s),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(t=>{if(t){const u=this.createTreeNode(s,t,g.parent);return this.updateNodeCache(s,u,g,g.parent),g.dispose(),u}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,s,g){const t=this.createTreeNode(a,s,g);if(s.id&&this.elements.has(t.item.handle))throw new Error((0,m.localize)(7,null,s.id));return this.addNodeToCache(a,t),this.addNodeToParentCache(t,g),t}getTooltip(a){return T.MarkdownString.isMarkdownString(a)?c.MarkdownString.from(a):a}getCommand(a,s){return s?this.commands.toInternal(s,a):void 0}createTreeNode(a,s,g){const t=new R.DisposableStore,u=this.createHandle(a,s,g),r=this.getLightIconPath(s);return{item:{handle:u,parentHandle:g?g.item.handle:void 0,label:p(s.label,this.extension),description:s.description,resourceUri:s.resourceUri,tooltip:this.getTooltip(s.tooltip),command:this.getCommand(t,s.command),contextValue:s.contextValue,icon:r,iconDark:this.getDarkIconPath(s)||r,themeIcon:this.getThemeIcon(s),collapsibleState:(0,n.isUndefinedOrNull)(s.collapsibleState)?T.TreeItemCollapsibleState.None:s.collapsibleState,accessibilityInformation:s.accessibilityInformation},extensionItem:s,parent:g,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(a){return a.iconPath instanceof T.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:s,label:g,resourceUri:t},u,r){if(s)return`${A.ID_HANDLE_PREFIX}/${s}`;const i=p(g,this.extension),o=u?u.item.handle:A.LABEL_HANDLE_PREFIX;let l=i?i.label:t?(0,L.basename)(t):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const d=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,b=this.getChildrenNodes(u)||[];let _,v=0;do{if(_=`${o}/${v}:${l}`,r||!this.elements.has(_)||d===_)break;v++}while(v<=b.length);return _}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof T.ThemeIcon))return typeof a.iconPath=="string"||k.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof T.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return k.URI.isUri(a)?a:k.URI.file(a)}addNodeToCache(a,s){this.elements.set(s.item.handle,a),this.nodes.set(a,s)}updateNodeCache(a,s,g,t){this.elements.delete(s.item.handle),this.nodes.delete(a),s.item.handle!==g.item.handle&&this.elements.delete(g.item.handle),this.addNodeToCache(a,s);const u=this.getChildrenNodes(t)||[],r=u.filter(i=>i.item.handle===g.item.handle)[0];r&&u.splice(u.indexOf(r),1,s)}addNodeToParentCache(a,s){s?(s.children||(s.children=[]),s.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const s=this.nodes.get(a);if(s){if(s.children)for(const g of s.children){const t=this.elements.get(g.item.handle);t&&this.clear(t)}s.children=void 0}}else this.clearAll()}clear(a){const s=this.nodes.get(a);if(s){if(s.children)for(const g of s.children){const t=this.elements.get(g.item.handle);t&&this.clear(t)}this.nodes.delete(a),this.elements.delete(s.item.handle),s.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}A.LABEL_HANDLE_PREFIX="0",A.ID_HANDLE_PREFIX="1"}),define(me[223],ge([0,1,18,3,6,13,65,15,127,89]),function(J,e,m,L,k,C,R,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class n extends k.Disposable{constructor(c){super();this.controllerId=c,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new R.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(c){this._resolveHandler=c;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){const f=this.diff[this.diff.length-1];if(f&&c[0]===1){if(f[0]===1&&f[1].extId===c[1].extId){(0,y.applyTestItemUpdate)(f[1],c[1]);return}if(f[0]===0&&f[1].item.extId===c[1].extId){(0,y.applyTestItemUpdate)(f[1],c[1]);return}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,f){const h=this.tree.get(c);if(!!h){if((h.expandLevels===void 0||f>h.expandLevels)&&(h.expandLevels=f),h.expand===1){const p=this.resolveChildren(h);return p.isOpen()?this.expandChildren(h,f-1):p.wait().then(()=>this.expandChildren(h,f-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.expandChildren(h,f-1)):this.expandChildren(h,f-1)}}dispose(){for(const c of this.tree.values())(0,R.getPrivateApiFor)(c.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(c,f){switch(f.op){case 2:this.pushDiff([4,c.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(c.fullId,f.id));break;case 0:this.upsertItem(f.item,c);break;case 4:for(const E of f.ops)this.onTestItemEvent(c,E);break;case 3:const{key:h,value:p,previous:D}=f,A=c.fullId.toString();switch(h){case"canResolveChildren":this.updateExpandability(c);break;case"tags":this.diffTagRefs(p,D,A);break;case"range":this.pushDiff([1,{extId:A,item:{range:S.Range.from(p)}}]);break;case"error":this.pushDiff([1,{extId:A,item:{error:S.MarkdownString.fromStrict(p)||null}}]);break;default:this.pushDiff([1,{extId:A,item:{[h]:p??null}}]);break}break;default:(0,C.assertNever)(f)}}upsertItem(c,f){if(!(c instanceof R.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${c.id} did not`);const h=T.TestId.fromExtHostTestItem(c,this.root.id,f?.actual),p=(0,R.getPrivateApiFor)(c);p.parent&&p.parent!==f?.actual&&p.parent.children.delete(c.id);let D=this.tree.get(h.toString());if(!D){D={fullId:h,actual:c,parent:f?h.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},c.tags.forEach(this.incrementTagRefs,this),this.tree.set(D.fullId.toString(),D),this.setItemParent(c,f),this.pushDiff([0,{parent:D.parent&&D.parent.toString(),controllerId:this.controllerId,expand:D.expand,item:S.TestItem.from(c)}]),this.connectItemAndChildren(c,D,f);return}if(D.actual===c){this.connectItem(c,D,f);return}const A=D.actual.children,E=D.actual,a=(0,R.diffTestItems)(E,c);(0,R.getPrivateApiFor)(E).listener=void 0,D.actual=c,D.expand=0;for(const[s,g]of a)this.onTestItemEvent(D,{op:3,key:s,value:g,previous:E[s]});this.connectItemAndChildren(c,D,f);for(const s of A)c.children.get(s.id)||this.removeItem(T.TestId.joinToString(h,s.id))}diffTagRefs(c,f,h){const p=new Set(f.map(D=>D.id));for(const D of c)p.delete(D.id)||this.incrementTagRefs(D);this.pushDiff([1,{extId:h,item:{tags:c.map(D=>S.TestTag.namespace(this.controllerId,D.id))}}]),p.forEach(this.decrementTagRefs,this)}incrementTagRefs(c){const f=this.tags.get(c.id);f?f.refCount++:(this.tags.set(c.id,{refCount:1}),this.pushDiff([5,{id:S.TestTag.namespace(this.controllerId,c.id),ctrlLabel:this.root.label}]))}decrementTagRefs(c){const f=this.tags.get(c);f&&!--f.refCount&&(this.tags.delete(c),this.pushDiff([6,S.TestTag.namespace(this.controllerId,c)]))}setItemParent(c,f){(0,R.getPrivateApiFor)(c).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(c,f,h){this.setItemParent(c,h);const p=(0,R.getPrivateApiFor)(c);p.parent=h?.actual,p.listener=D=>this.onTestItemEvent(f,D),this.updateExpandability(f)}connectItemAndChildren(c,f,h){this.connectItem(c,f,h);for(const p of c.children)this.upsertItem(p,f)}updateExpandability(c){let f;this._resolveHandler?c.resolveBarrier?f=c.resolveBarrier.isOpen()?3:2:f=c.actual.canResolveChildren?1:0:f=0,f!==c.expand&&(c.expand=f,this.pushDiff([1,{extId:c.fullId.toString(),expand:f}]),f===1&&c.expandLevels!==void 0&&this.resolveChildren(c))}expandChildren(c,f){if(f<0)return;const h=[];for(const p of c.actual.children){const D=this.expand(T.TestId.joinToString(c.fullId,p.id),f);(0,m.isThenable)(D)&&h.push(D)}if(h.length)return Promise.all(h).then(()=>{})}resolveChildren(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this._resolveHandler){const D=new m.Barrier;return D.open(),D}c.expand=2,this.pushExpandStateUpdate(c);const f=c.resolveBarrier=new m.Barrier,h=D=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),c.actual!==this.root&&(c.actual.error=D.stack||D.message||String(D))};let p;try{p=this._resolveHandler(c.actual===this.root?void 0:c.actual)}catch(D){h(D)}return(0,m.isThenable)(p)?p.catch(h).then(()=>{f.open(),this.updateExpandability(c)}):(f.open(),this.updateExpandability(c)),c.resolveBarrier}pushExpandStateUpdate(c){this.pushDiff([1,{extId:c.fullId.toString(),expand:c.expand}])}removeItem(c){const f=this.tree.get(c);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff([2,c]);const h=[f];for(;h.length;){const p=h.pop();if(!!p){(0,R.getPrivateApiFor)(p.actual).listener=void 0;for(const D of p.actual.tags)this.decrementTagRefs(D.id);this.tree.delete(p.fullId.toString());for(const D of p.actual.children)h.push(this.tree.get(T.TestId.joinToString(p.fullId,D.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.diffOpEmitter.fire(c)}}e.SingleUseTestCollection=n}),define(me[224],ge([0,1,4,184]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(L.IEnvironmentService)}),define(me[225],ge([0,1,26,3,8]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=C;class R{constructor(n){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let I of n.activationEvents)I==="onUri"&&(I=`onUri:${m.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(n)}}keepOnly(n){const I=new Set;n.forEach(c=>I.add(m.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>I.has(m.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,I){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const c=R._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(c.map(f=>f.identifier)),I.length>0){const f=new Set;I.forEach(h=>f.add(m.ExtensionIdentifier.toKey(h))),this._extensionDescriptions=this._extensionDescriptions.filter(h=>!f.has(m.ExtensionIdentifier.toKey(h.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(c)}static _findLoopingExtensions(n){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(D){this._nodesSet.has(D)||(this._nodesSet.add(D),this._nodesArr.push(D))}addArc(D,A){this.addNode(D),this.addNode(A),this._arcs.has(D)?this._arcs.get(D).push(A):this._arcs.set(D,[A])}getArcs(D){return this._arcs.has(D)?this._arcs.get(D):[]}hasOnlyGoodArcs(D,A){const E=I.getArcs(D);for(let a=0;a<E.length;a++)if(!A.has(E[a]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let D of n){const A=m.ExtensionIdentifier.toKey(D.identifier);if(c.set(A,D),D.extensionDependencies)for(let E of D.extensionDependencies){const a=m.ExtensionIdentifier.toKey(E);I.addArc(A,a)}}let f=new Set;I.getNodes().filter(D=>I.getArcs(D).length===0).forEach(D=>f.add(D));let h=I.getNodes().filter(D=>!f.has(D)),p;do{p=!1;for(let D=0;D<h.length;D++){const A=h[D];I.hasOnlyGoodArcs(A,f)&&(h.splice(D,1),D--,f.add(A),p=!0)}}while(p);return h.map(D=>c.get(D))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const I=this._activationMap.get(n);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const I=this._extensionsMap.get(m.ExtensionIdentifier.toKey(n));return I||void 0}}e.ExtensionDescriptionRegistry=R;var S;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(S||(S={}));function y(T,n){const I=T.isBuiltin?0:T.isUnderDevelopment?2:1,c=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(I!==c)return I-c;const f=k.posix.basename(T.extensionLocation.path),h=k.posix.basename(n.extensionLocation.path);return f<h?-1:f>h?1:0}}),define(me[226],ge([0,1,22]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var k;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(k=e.MessageType||(e.MessageType={}));function C(S){const y=m.VSBuffer.alloc(1);switch(S){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=C;function R(S,y){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=R}),define(me[35],ge([0,1,3,2,4,26,186]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");var S;(function(a){a[a.None=0]="None",a[a.LocalProcess=1]="LocalProcess",a[a.LocalWebWorker=2]="LocalWebWorker",a[a.Remote=3]="Remote"})(S=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class y{constructor(s){this.dependency=s}}e.MissingExtensionDependency=y;var T;(function(a){a[a.LocalProcess=0]="LocalProcess",a[a.LocalWebWorker=1]="LocalWebWorker",a[a.Remote=2]="Remote"})(T=e.ExtensionHostKind||(e.ExtensionHostKind={}));function n(a){switch(a){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=n;class I{constructor(s,g,t,u){this.codeLoadingTime=s,this.activateCallTime=g,this.activateResolvedTime=t,this.activationReason=u}}e.ActivationTimes=I;class c{constructor(s,g){this.description=s,this.value=g}}e.ExtensionPointContribution=c,e.ExtensionHostLogFileName="exthost";var f;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(f=e.ActivationKind||(e.ActivationKind={}));function h(a){a.enableProposedApi||p(a)}e.checkProposedApiEnabled=h;function p(a){throw new Error(`[${a.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.throwProposedApiError=p;function D(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,R.getGalleryExtensionId)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation}}e.toExtension=D;function A(a,s){return{identifier:new C.ExtensionIdentifier(a.identifier.id),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!s,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid}}e.toExtensionDescription=A;class E{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(s){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(s){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(s){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(s){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(s,g){return Promise.resolve()}_onWillActivateExtension(s){}_onDidActivateExtension(s,g,t,u,r){}_onDidActivateExtensionError(s,g){}_onExtensionRuntimeError(s,g){}_onExtensionHostExit(s){}}e.NullExtensionService=E}),define(me[227],ge([0,1,26,35,12]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class R{constructor(h,p,D,A){this.startup=h,this.codeLoadingTime=p,this.activateCallTime=D,this.activateResolvedTime=A}}e.ExtensionActivationTimes=R,R.NONE=new R(!1,-1,-1,-1);class S{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,p){return h===-1||p===-1?-1:p-h}build(){return new R(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class y{constructor(h,p,D,A,E,a){this.activationFailed=h,this.activationFailedError=p,this.activationTimes=D,this.module=A,this.exports=E,this.subscriptions=a}}e.ActivatedExtension=y;class T extends y{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class n extends y{constructor(){super(!1,null,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class I extends y{constructor(h){super(!0,h,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let c=class{constructor(h,p,D,A,E){this._logService=E,this._registry=h,this._resolvedExtensionsSet=new Set,p.forEach(a=>this._resolvedExtensionsSet.add(m.ExtensionIdentifier.toKey(a))),this._hostExtensionsMap=new Map,D.forEach(a=>this._hostExtensionsMap.set(m.ExtensionIdentifier.toKey(a),a)),this._host=A,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(h){const p=m.ExtensionIdentifier.toKey(h);return this._activatedExtensions.has(p)}getActivatedExtension(h){const p=m.ExtensionIdentifier.toKey(h),D=this._activatedExtensions.get(p);if(!D)throw new Error("Extension `"+h.value+"` is not known or not activated");return D}activateByEvent(h,p){if(this._alreadyActivatedEvents[h])return C;const D=this._registry.getExtensionDescriptionsForActivationEvent(h);return this._activateExtensions(D.map(A=>({id:A.identifier,reason:{startup:p,extensionId:A.identifier,activationEvent:h}}))).then(()=>{this._alreadyActivatedEvents[h]=!0})}activateById(h,p){const D=this._registry.getExtensionDescription(h);if(!D)throw new Error("Extension `"+h+"` is not known");return this._activateExtensions([{id:D.identifier,reason:p}])}_handleActivateRequest(h,p,D){if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(h.id))){p[m.ExtensionIdentifier.toKey(h.id)]=h;return}const A=this._registry.getExtensionDescription(h.id);if(!A){const s=new Error(`Cannot activate unknown extension '${h.id.value}'`);this._host.onExtensionActivationError(h.id,s,new L.MissingExtensionDependency(h.id.value)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(h.id),new I(s));return}const E=typeof A.extensionDependencies=="undefined"?[]:A.extensionDependencies;let a=!0;for(let s=0,g=E.length;s<g;s++){const t=E[s];if(this._resolvedExtensionsSet.has(m.ExtensionIdentifier.toKey(t)))continue;const u=this._activatedExtensions.get(m.ExtensionIdentifier.toKey(t));if(u&&!u.activationFailed)continue;if(u&&u.activationFailed){const l=A.displayName||A.identifier.value,d=this._registry.getExtensionDescription(t),b=d&&d.displayName||t,_=new Error(`Cannot activate the '${l}' extension because its dependency '${b}' failed to activate`);_.detail=u.activationFailedError,this._host.onExtensionActivationError(A.identifier,_,null),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(A.identifier),new I(_));return}if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(t))){a=!1,p[m.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(m.ExtensionIdentifier.toKey(t)),reason:h.reason};continue}const r=this._registry.getExtensionDescription(t);if(r){a=!1,p[m.ExtensionIdentifier.toKey(t)]={id:r.identifier,reason:h.reason};continue}const i=A.displayName||A.identifier.value,o=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(A.identifier,o,new L.MissingExtensionDependency(t)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(A.identifier),new I(o));return}a?p[m.ExtensionIdentifier.toKey(A.identifier)]=h:D.push(h)}_activateExtensions(h){if(h.length===0||(h=h.filter(E=>!this._activatedExtensions.has(m.ExtensionIdentifier.toKey(E.id))),h.length===0))return Promise.resolve(void 0);const p=Object.create(null),D=[];for(let E=0,a=h.length;E<a;E++)this._handleActivateRequest(h[E],p,D);for(let E=0,a=D.length;E<a;E++){const s=m.ExtensionIdentifier.toKey(D[E].id);p[s]&&delete p[s]}const A=Object.keys(p).map(E=>p[E]);return D.length===0?Promise.all(A.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(A).then(E=>this._activateExtensions(D))}_activateExtension(h,p){const D=m.ExtensionIdentifier.toKey(h);if(this._activatedExtensions.has(D))return Promise.resolve(void 0);const A=this._activatingExtensions.get(D);if(A)return A;const E=this._host.actualActivateExtension(h,p).then(void 0,a=>{const s=new Error;return a&&a.name&&(s.name=a.name),a&&a.message?s.message=`Activating extension '${h.value}' failed: ${a.message}.`:s.message=`Activating extension '${h.value}' failed: ${a}.`,a&&a.stack&&(s.stack=a.stack),this._host.onExtensionActivationError(h,s,null),this._logService.error(`Activating extension ${h.value} failed due to an error:`),this._logService.error(a),new I(a)}).then(a=>{this._activatedExtensions.set(D,a),this._activatingExtensions.delete(D)});return this._activatingExtensions.set(D,E),E}};c=Ve([$e(4,k.ILogService)],c),e.ExtensionsActivator=c}),define(me[228],ge([0,1,12,35,27,10,116]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let S=class extends m.LogService{constructor(T){if(T.logFile.scheme!==C.Schemas.file)throw new Error("Only file-logging supported");super(new R.SpdLogLogger(L.ExtensionHostLogFileName,T.logFile.fsPath,!0,T.logLevel))}$setLevel(T){this.setLevel(T)}};S=Ve([$e(0,k.IExtHostInitDataService)],S),e.ExtHostLogService=S}),define(me[229],ge([0,1,16]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,R)=>{this._actualOk=C,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,m.onUnexpectedError)(C))}then(C,R){return this._ensureActual().then(C,R)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=L}),define(me[55],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(T,n){this._proxyIdentifierBrand=void 0,this.isMain=T,this.sid=n,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const L=[];function k(y){const T=new m(!0,y);return L[T.nid]=T,T}e.createMainContextProxyIdentifier=k;function C(y){const T=new m(!1,y);return L[T.nid]=T,T}e.createExtHostContextProxyIdentifier=C;function R(y){return L[y].sid}e.getStringIdentifierForProxy=R;class S{constructor(T){this.value=T}}e.SerializableObjectWithBuffers=S}),define(me[5],ge([0,1,61,2,55]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var R;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var S;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(S=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var c;(function(a){a.name="$ident";function s(t,u){return Object.defineProperty(t,a.name,{value:u,enumerable:!0}),t}a.mixin=s;function g(t){return t[a.name]}a.of=g})(c=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(s){return s._id=f._n++,s}}e.IdObject=f,f._n=0;var h;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var D;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(D=e.WorkspaceEditType||(e.WorkspaceEditType={}));function A(a){if(a&&a.edits)for(const s of a.edits)typeof s.resource=="object"?s.resource=L.URI.revive(s.resource):(s.newUri=L.URI.revive(s.newUri),s.oldUri=L.URI.revive(s.oldUri)),s.metadata&&s.metadata.iconPath&&(s.metadata=(0,m.revive)(s.metadata));return a}e.reviveWorkspaceEditDto=A;var E;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,k.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,k.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,k.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[90],ge([0,1,5,3,4]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(S){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=S.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(S){this._onDidChangePassword.fire(S)}get(S,y){return this._proxy.$getPassword(S,y)}store(S,y,T){return this._proxy.$setPassword(S,y,T)}delete(S,y){return this._proxy.$deletePassword(S,y)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")}),define(me[67],ge([0,1,4,12,5,14]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(y,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(k.MainContext.MainThreadTelemetry)}report(y,T,n){const I=this.getUsageKey(y,T);this._reportedUsages.has(I)||(this._reportedUsages.add(I),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:y}))}getUsageKey(y,T){return`${y}-${T.identifier.value}`}};R=Ve([$e(0,C.IExtHostRpcService),$e(1,L.ILogService)],R),e.ExtHostApiDeprecationService=R,e.NullApiDeprecationService=Object.freeze(new class{report(S,y,T){}})}),define(me[230],ge([0,1,3,5,7,26]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,T,n,I={}){const c=C.ExtensionIdentifier.toKey(y.identifier),f=this._inFlightRequests.get(c)||[],h=[...n].sort().join(" ");let p=f.find(D=>D.scopes===h);if(p)return p.result;{const D=this._getSession(y,c,T,n,I);p={scopes:h,result:D},f.push(p),this._inFlightRequests.set(c,f);try{await D}finally{const A=f.findIndex(E=>E.scopes===h);A>-1&&(f.splice(A),this._inFlightRequests.set(c,f))}return D}}async _getSession(y,T,n,I,c={}){await this._proxy.$ensureProvider(n);const f=y.displayName||y.name;return this._proxy.$getSession(n,I,T,f,c)}async removeSession(y,T){const n=this._authenticationProviders.get(y);return n?n.provider.removeSession(T):this._proxy.$removeSession(y,T)}registerAuthenticationProvider(y,T,n,I){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:T,provider:n,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(f=>f.id===y)||this._providers.push({id:y,label:T});const c=n.onDidChangeSessions(f=>{this._proxy.$sendDidChangeSessions(y,{added:f.added??[],changed:f.changed??[],removed:f.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,T,I?.supportsMultipleAccounts??!1),new k.Disposable(()=>{c.dispose(),this._authenticationProviders.delete(y);const f=this._providers.findIndex(h=>h.id===y);f>-1&&this._providers.splice(f),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,T){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,T){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,T){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,T){return this._onDidChangeSessions.fire({provider:{id:y,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=R}),define(me[231],ge([0,1,5,14,15]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(S,y){this._extHostDocumentsAndEditors=y,this._proxy=S.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(S){const y=k.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};C=Ve([$e(0,L.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(me[232],ge([0,1,5]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(C){const R=C.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(S){return R.$writeText(S)}})}}e.ExtHostClipboard=L}),define(me[40],ge([0,1,13,7,15,25,5,17,12,61,42,51,2,6,4,14,65,22,55]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=class{constructor(i,o){this._commands=new Map,this._apiCommands=new Map,this._proxy=i.getProxy(R.MainContext.MainThreadCommands),this._logService=o,this.converter=new s(this,l=>{const d=this._apiCommands.get(l);return d?.result===t.Void?d:void 0},o),this._argumentProcessors=[{processArgument(l){return(0,T.revive)(l)}},{processArgument(l){return(0,C.cloneAndChange)(l,function(d){if(n.Range.isIRange(d))return k.Range.to(d);if(I.Position.isIPosition(d))return k.Position.to(d);if(n.Range.isIRange(d.range)&&c.URI.isUri(d.uri))return k.location.to(d);if(d instanceof A.VSBuffer)return d.buffer.buffer;if(!Array.isArray(d))return d})}}]}registerArgumentProcessor(i){this._argumentProcessors.push(i)}registerApiCommand(i){const o=this.registerCommand(!1,i.id,async(...l)=>{const d=i.args.map((_,v)=>{if(!_.validate(l[v]))throw new Error(`Invalid argument '${_.name}' when running '${i.id}', received: ${l[v]}`);return _.convert(l[v])}),b=await this.executeCommand(i.internalId,...d);return i.result.convert(b,l,this.converter)},void 0,{description:i.description,args:i.args,returns:i.result.description});return this._apiCommands.set(i.id,i),new L.Disposable(()=>{o.dispose(),this._apiCommands.delete(i.id)})}registerCommand(i,o,l,d,b){if(this._logService.trace("ExtHostCommands#registerCommand",o),!o.trim().length)throw new Error("invalid id");if(this._commands.has(o))throw new Error(`command '${o}' already exists`);return this._commands.set(o,{callback:l,thisArg:d,description:b}),i&&this._proxy.$registerCommand(o),new L.Disposable(()=>{this._commands.delete(o)&&i&&this._proxy.$unregisterCommand(o)})}executeCommand(i,...o){return this._logService.trace("ExtHostCommands#executeCommand",i),this._doExecuteCommand(i,o,!0)}async _doExecuteCommand(i,o,l){if(this._commands.has(i))return this._executeContributedCommand(i,o);{let d=!1;const b=(0,C.cloneAndChange)(o,function(_){if(_ instanceof L.Position)return k.Position.from(_);if(_ instanceof L.Range)return k.Range.from(_);if(_ instanceof L.Location)return k.location.from(_);if(L.NotebookRange.isNotebookRange(_))return k.NotebookRange.from(_);if(_ instanceof ArrayBuffer)return d=!0,A.VSBuffer.wrap(new Uint8Array(_));if(_ instanceof Uint8Array)return d=!0,A.VSBuffer.wrap(_);if(!Array.isArray(_))return _});try{const _=await this._proxy.$executeCommand(i,d?new E.SerializableObjectWithBuffers(b):b,l);return(0,T.revive)(_)}catch(_){if(_ instanceof Error&&_.message==="$executeCommand:retry")return this._doExecuteCommand(i,o,!1);throw _}}}async _executeContributedCommand(i,o){const l=this._commands.get(i);if(!l)throw new Error("Unknown command");let{callback:d,thisArg:b,description:_}=l;if(_)for(let v=0;v<_.args.length;v++)try{(0,m.validateConstraint)(o[v],_.args[v].constraint)}catch(P){throw new Error(`Running the contributed command: '${i}' failed. Illegal argument '${_.args[v].name}' - ${_.args[v].description}`)}try{return await d.apply(b,o)}catch(v){if(i===this.converter.delegatingCommandId){const P=this.converter.getActualCommand(...o);P&&(i=P.command)}throw this._logService.error(v,i),new Error(`Running the contributed command: '${i}' failed.`)}}$executeContributedCommand(i,...o){return this._logService.trace("ExtHostCommands#$executeContributedCommand",i),this._commands.has(i)?(o=o.map(l=>this._argumentProcessors.reduce((d,b)=>b.processArgument(d),l)),this._executeContributedCommand(i,o)):Promise.reject(new Error(`Contributed command '${i}' does not exist.`))}getCommands(i=!1){return this._logService.trace("ExtHostCommands#getCommands",i),this._proxy.$getCommands().then(o=>(i&&(o=o.filter(l=>l[0]!=="_")),o))}$getContributedCommandHandlerDescriptions(){const i=Object.create(null);for(let[o,l]of this._commands){let{description:d}=l;d&&(i[o]=d)}return Promise.resolve(i)}};a=Ve([$e(0,p.IExtHostRpcService),$e(1,y.ILogService)],a),e.ExtHostCommands=a,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class s{constructor(i,o,l){this._commands=i,this._lookupApiCommand=o,this._logService=l,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(i,o){if(!i)return;const l={$ident:void 0,id:i.command,title:i.title,tooltip:i.tooltip};if(!i.command)return l;const d=this._lookupApiCommand(i.command);if(d)l.id=d.internalId,l.arguments=d.args.map((b,_)=>b.convert(i.arguments&&i.arguments[_]));else if((0,S.isNonEmptyArray)(i.arguments)){const b=++this._cachIdPool;this._cache.set(b,i),o.add((0,f.toDisposable)(()=>{this._cache.delete(b),this._logService.trace("CommandsConverter#DISPOSE",b)})),l.$ident=b,l.id=this.delegatingCommandId,l.arguments=[b],this._logService.trace("CommandsConverter#CREATE",i.command,b)}return l}fromInternal(i){const o=R.ObjectIdentifier.of(i);return typeof o=="number"?this._cache.get(o):{command:i.id,title:i.title,arguments:i.arguments}}getActualCommand(...i){return this._cache.get(i[0])}_executeConvertedCommand(...i){const o=this.getActualCommand(...i);return this._logService.trace("CommandsConverter#EXECUTE",i[0],o?o.command:"MISSING"),o?this._commands.executeCommand(o.command,...o.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=s;class g{constructor(i,o,l,d){this.name=i,this.description=o,this.validate=l,this.convert=d}optional(){return new g(this.name,`(optional) ${this.description}`,i=>i==null||this.validate(i),i=>i===void 0?void 0:i===null?null:this.convert(i))}with(i,o){return new g(i??this.name,o??this.description,this.validate,this.convert)}}e.ApiCommandArgument=g,g.Uri=new g("uri","Uri of a text document",r=>c.URI.isUri(r),r=>r),g.Position=new g("position","A position in a text document",r=>L.Position.isPosition(r),k.Position.from),g.Range=new g("range","A range in a text document",r=>L.Range.isRange(r),k.Range.from),g.Selection=new g("selection","A selection in a text document",r=>L.Selection.isSelection(r),k.Selection.from),g.Number=new g("number","",r=>typeof r=="number",r=>r),g.String=new g("string","",r=>typeof r=="string",r=>r),g.CallHierarchyItem=new g("item","A call hierarchy item",r=>r instanceof L.CallHierarchyItem,k.CallHierarchyItem.from),g.TypeHierarchyItem=new g("item","A type hierarchy item",r=>r instanceof L.TypeHierarchyItem,k.TypeHierarchyItem.from),g.TestItem=new g("testItem","A VS Code TestItem",r=>r instanceof D.TestItemImpl,k.TestItem.from);class t{constructor(i,o){this.description=i,this.convert=o}}e.ApiCommandResult=t,t.Void=new t("no result",r=>r);class u{constructor(i,o,l,d,b){this.id=i,this.internalId=o,this.description=l,this.args=d,this.result=b}}e.ApiCommand=u}),define(me[233],ge([0,1,15,7,83,40,17,111]),function(J,e,m,L,k,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(m.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,f)=>{if((0,R.isFalsyOrEmpty)(c))return;class h extends L.SymbolInformation{static to(D){const A=new h(D.name,m.SymbolKind.to(D.kind),D.containerName||"",new L.Location(f[0],m.Range.to(D.range)));return A.detail=D.detail,A.range=A.location.range,A.selectionRange=m.Range.to(D.selectionRange),A.children=D.children?D.children.map(h.to):[],A}}return c.map(h.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(m.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(m.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(f=>L.Position.isPosition(f)),c=>c.map(m.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(f=>{let h;for(const p of f.reverse())h=new L.SelectionRange(m.Range.to(p),h);return h}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>{const f=[];if(Array.isArray(c))for(let h of c)f.push(...h[1].map(m.WorkspaceSymbol.to));return f})),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(m.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(m.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(m.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return m.WorkspaceEdit.to(c)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(m.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const f=(0,S.decodeSemanticTokensDto)(c);if(f.type==="full")return new L.SemanticTokens(f.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const f=(0,S.decodeSemanticTokensDto)(c);if(f.type==="full")return new L.SemanticTokens(f.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,f,h)=>{if(!c)return new L.CompletionList([]);const p=c.suggestions.map(D=>m.CompletionItem.to(D,h));return new L.CompletionList(p,c.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return m.SignatureHelp.to(c)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,f,h)=>n(p=>new L.CodeLens(m.Range.to(p.range),p.command&&h.fromInternal(p.command)))(c))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>L.Range.isRange(c),c=>L.Selection.isSelection(c)?m.Selection.from(c):m.Range.from(c)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,f,h)=>n(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(p.command)}else{const D=new L.CodeAction(p.title,p.kind?new L.CodeActionKind(p.kind):void 0);return p.edit&&(D.edit=m.WorkspaceEdit.to(p.edit)),p.command&&(D.command=h.fromInternal(p.command)),D.isPreferred=p.isPreferred,D}})(c))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(f=>new L.ColorInformation(m.Range.to(f.range),m.Color.to(f.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",c=>c instanceof L.Color,m.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:m.Range.from(c.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(m.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",c=>c.map(m.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(f=>m.NotebookExclusiveDocumentPattern.to(f))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(m.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[m.ViewColumn.from(c.viewColumn),m.TextEditorOpenOptions.from(c)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[m.ViewColumn.from(c.viewColumn),m.TextEditorOpenOptions.from(c)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[m.ViewColumn.from(c.viewColumn),m.TextEditorOpenOptions.from(c)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class T{static register(f){y.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=T;function n(c){return f=>{if(Array.isArray(f))return f.map(c)}}function I(c){if(!Array.isArray(c))return;const f=[];for(const h of c)k.isLocationLink(h)?f.push(m.DefinitionLink.to(h)):f.push(m.location.to(h));return f}}),define(me[234],ge([0,1,18,59,3,6,2,83,26,15,7,5]),function(J,e,m,L,k,C,R,S,y,T,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function c(f,h,p){const D=f.getProxy(I.MainContext.MainThreadComments);class A{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const o=this._commentControllers.get(i.handle);return o||i}else if(i&&i.$mid===7){const o=this._commentControllers.get(i.commentControlHandle);if(!o)return i;const l=o.getCommentThread(i.commentThreadHandle);return l||i}else if(i&&i.$mid===8){const o=this._commentControllers.get(i.thread.commentControlHandle);if(!o)return i;const l=o.getCommentThread(i.thread.commentThreadHandle);return l?{thread:l,text:i.text}:i}else if(i&&i.$mid===9){const o=this._commentControllers.get(i.thread.commentControlHandle);if(!o)return i;const l=o.getCommentThread(i.thread.commentThreadHandle);if(!l)return i;let d=i.commentUniqueId,b=l.getCommentByUniqueId(d);return b||i}else if(i&&i.$mid===10){const o=this._commentControllers.get(i.thread.commentControlHandle);if(!o)return i;const l=o.getCommentThread(i.thread.commentThreadHandle);if(!l)return i;let d=i.text,b=i.commentUniqueId,_=l.getCommentByUniqueId(b);return _?(_.body=d,_):i}return i}})}createCommentController(i,o,l){const d=A.handlePool++,b=new a(i,d,o,l);this._commentControllers.set(b.handle,b);const _=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(i.identifier))||[];return _.push(b),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(i.identifier),_),b.value}$createCommentThreadTemplate(i,o,l){const d=this._commentControllers.get(i);!d||d.$createCommentThreadTemplate(o,l)}async $updateCommentThreadTemplate(i,o,l){const d=this._commentControllers.get(i);!d||d.$updateCommentThreadTemplate(o,l)}$deleteCommentThread(i,o){const l=this._commentControllers.get(i);l&&l.$deleteCommentThread(o)}$provideCommentingRanges(i,o,l){const d=this._commentControllers.get(i);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const b=p.getDocument(R.URI.revive(o));return(0,m.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(b,l)).then(_=>_?_.map(v=>T.Range.from(v)):void 0)}$toggleReaction(i,o,l,d,b){const _=this._commentControllers.get(i);return!_||!_.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const v=_.getCommentThread(o);if(v){const P=v.getCommentByUniqueId(d.uniqueIdInThread);if(_!==void 0&&P&&_.reactionHandler)return _.reactionHandler(P,t(b))}return Promise.resolve(void 0)})}dispose(){}}A.handlePool=0;class E{constructor(i,o,l,d,b,_,v){this._commentControllerHandle=o,this._id=l,this._uri=d,this._range=b,this._comments=_,this.handle=E._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),D.$createCommentThread(o,this.handle,this._id,this._uri,T.Range.from(this._range),v),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=_,this._localDisposables.push({dispose:()=>{D.$deleteCommentThread(o,this.handle)}});const P=this;this.value={get uri(){return P.uri},get range(){return P.range},set range(w){P.range=w},get comments(){return P.comments},set comments(w){P.comments=w},get collapsibleState(){return P.collapsibleState},set collapsibleState(w){P.collapsibleState=w},get canReply(){return P.canReply},set canReply(w){P.canReply=w},get contextValue(){return P.contextValue},set contextValue(w){P.contextValue=w},get label(){return P.label},set label(w){P.label=w},dispose:()=>{P.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const i=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),o={};i("range")&&(o.range=T.Range.from(this._range)),i("label")&&(o.label=this.label),i("contextValue")&&(o.contextValue=this.contextValue),i("comments")&&(o.comments=this._comments.map(l=>s(this,l,this._commentsMap))),i("collapsibleState")&&(o.collapseState=u(this._collapseState)),i("canReply")&&(o.canReply=this.canReply),this.modifications={},D.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,o)}getCommentByUniqueId(i){for(let o of this._commentsMap){let l=o[0],d=o[1];if(i===d)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}E._handlePool=0,Ve([(0,L.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(i,o,l,d){this._extension=i,this._handle=o,this._id=l,this._label=d,this._threads=new Map,D.$registerCommentController(this.handle,l,d);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(_){b.options=_},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(_){b.commentingRangeProvider=_},get reactionHandler(){return b.reactionHandler},set reactionHandler(_){b.reactionHandler=_},createCommentThread(_,v,P){return b.createCommentThread(_,v,P).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{D.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,D.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,D.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,o,l,d){if(typeof i=="string"){const b=new E(this.id,this.handle,i,o,l,d,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new E(this.id,this.handle,void 0,i,o,l,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(i,o){const l=new E(this.id,this.handle,void 0,R.URI.revive(i),T.Range.to(o),[],this._extension.identifier);return l.collapsibleState=S.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(i,o){let l=this._threads.get(i);l&&(l.range=T.Range.to(o))}$deleteCommentThread(i){let o=this._threads.get(i);o&&o.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function s(r,i,o){let l=o.get(i);l||(l=++r.commentHandle,o.set(i,l));const d=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:l,body:T.MarkdownString.from(i.body),userName:i.author.name,userIconPath:d,label:i.label,commentReactions:i.reactions?i.reactions.map(b=>g(b)):void 0}}function g(r){return{label:r.label,iconPath:r.iconPath?T.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function t(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?R.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function u(r){if(r!==void 0)switch(r){case n.CommentThreadCollapsibleState.Expanded:return S.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return S.CommentThreadCollapsibleState.Collapsed}return S.CommentThreadCollapsibleState.Collapsed}return new A}e.createExtHostComments=c}),define(me[131],ge([0,1,2,5,7,4,14,12,17,9,8]),function(J,e,m,L,k,C,R,S,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class wn{constructor(f,h){this._logService=h,this._provider=new Map,this._proxy=f.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,h){const p=wn._handlePool++;this._provider.set(p,{provider:f,extensionId:h}),this._proxy.$registerDecorationProvider(p,h.value);const D=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(A=>{if(!A){this._proxy.$onDidChange(p,null);return}let E=(0,y.asArray)(A);if(E.length<=wn._maxEventSize){this._proxy.$onDidChange(p,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",h.value,E.length);const a=E.map(t=>({uri:t,rank:(0,T.count)(t.path,"/")})),s=(0,y.groupBy)(a,(t,u)=>t.rank-u.rank||(0,T.compare)(t.uri.path,u.uri.path));let g=[];e:for(let t of s){let u;for(let r of t){let i=(0,n.dirname)(r.uri.path);if(u!==i&&(u=i,g.push(r.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(p,g)});return new k.Disposable(()=>{D?.dispose(),this._proxy.$unregisterDecorationProvider(p),this._provider.delete(p)})}async $provideDecorations(f,h,p){if(!this._provider.has(f))return Object.create(null);const D=Object.create(null),{provider:A,extensionId:E}=this._provider.get(f);return await Promise.all(h.map(async a=>{try{const{uri:s,id:g}=a,t=await Promise.resolve(A.provideFileDecoration(m.URI.revive(s),p));if(!t)return;try{k.FileDecoration.validate(t),D[g]=[t.propagate,t.tooltip,t.badge,t.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${E.value}': ${u}`)}}catch(s){this._logService.error(s)}})),D}};I._handlePool=0,I._maxEventSize=250,I=Ve([$e(0,R.IExtHostRpcService),$e(1,S.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[235],ge([0,1,164,117,2,5,7,15,3,12,24,52,141]),function(J,e,m,L,k,C,R,S,y,T,n,I,c){"use strict";var f,h,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class D{constructor(a,s,g,t,u,r){this._name=a,this._owner=s,this._maxDiagnosticsPerFile=g,f.set(this,void 0),h.set(this,void 0),p.set(this,void 0),this._isDisposed=!1,nt(this,p,new c.SkipList((i,o)=>t.compare(i,o)),"f"),nt(this,f,u,"f"),nt(this,h,r,"f")}dispose(){this._isDisposed||(Oe(this,h,"f").fire([...Oe(this,p,"f").keys()]),Oe(this,f,"f")&&Oe(this,f,"f").$clear(this._owner),Oe(this,p,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,s){if(!a){this.clear();return}this._checkDisposed();let g=[];if(k.URI.isUri(a)){if(!s){this.delete(a);return}Oe(this,p,"f").set(a,s.slice()),g=[a]}else if(Array.isArray(a)){g=[];let u;a=[...a].sort(D._compareIndexedTuplesByUri);for(const r of a){const[i,o]=r;if((!u||i.toString()!==u.toString())&&(u&&Oe(this,p,"f").get(u).length===0&&Oe(this,p,"f").delete(u),u=i,g.push(i),Oe(this,p,"f").set(i,[])),o){const l=Oe(this,p,"f").get(i);l&&l.push(...o)}else{const l=Oe(this,p,"f").get(i);l&&(l.length=0)}}}if(Oe(this,h,"f").fire(g),!Oe(this,f,"f"))return;const t=[];for(let u of g){let r=[];const i=Oe(this,p,"f").get(u);if(i)if(i.length>this._maxDiagnosticsPerFile){r=[];const o=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(let d of i)if(d.severity===o[l]&&r.push(S.Diagnostic.from(d))===this._maxDiagnosticsPerFile)break e;r.push({severity:L.MarkerSeverity.Info,message:(0,m.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=i.map(o=>S.Diagnostic.from(o));t.push([u,r])}Oe(this,f,"f").$changeMany(this._owner,t)}delete(a){this._checkDisposed(),Oe(this,h,"f").fire([a]),Oe(this,p,"f").delete(a),Oe(this,f,"f")&&Oe(this,f,"f").$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),Oe(this,h,"f").fire([...Oe(this,p,"f").keys()]),Oe(this,p,"f").clear(),Oe(this,f,"f")&&Oe(this,f,"f").$clear(this._owner)}forEach(a,s){this._checkDisposed();for(let g of Oe(this,p,"f").keys())a.apply(s,[g,this.get(g),this])}get(a){this._checkDisposed();const s=Oe(this,p,"f").get(a);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(Oe(this,p,"f").get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,s){return a[0].toString()<s[0].toString()?-1:a[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=D,f=new WeakMap,h=new WeakMap,p=new WeakMap;let A=class Zt{constructor(a,s,g){this._logService=s,this._fileSystemInfoService=g,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,Zt._mapper),this._proxy=a.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(a){const s=new n.ResourceMap;for(const g of a)s.set(g,g);return{uris:Object.freeze(Array.from(s.values()))}}createDiagnosticCollection(a,s){const{_collections:g,_proxy:t,_onDidChangeDiagnostics:u,_logService:r,_fileSystemInfoService:i}=this,o=new class{$changeMany(b,_){t.$changeMany(b,_),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,b,_.length===0?"CLEARING":_)}$clear(b){t.$clear(b),r.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,b)}dispose(){t.dispose()}};let l;if(!s)s="_generated_diagnostic_collection_name_#"+Zt._idPool++,l=s;else if(!g.has(s))l=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do l=s+Zt._idPool++;while(g.has(l))}return new class extends D{constructor(){super(s,l,Zt._maxDiagnosticsPerFile,i.extUri,o,u);g.set(l,this)}dispose(){super.dispose(),g.delete(l)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const s=new Map,g=[];for(const t of this._collections.values())t.forEach((u,r)=>{let i=s.get(u.toString());typeof i=="undefined"&&(i=g.length,s.set(u.toString(),i),g.push([u,[]])),g[i][1]=g[i][1].concat(...r)});return g}}_getDiagnostics(a){let s=[];for(let g of this._collections.values())g.has(a)&&(s=s.concat(g.get(a)));return s}$acceptMarkersChange(a){if(!this._mirrorCollection){const s="_generated_mirror",g=new D(s,s,Zt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(s,g),this._mirrorCollection=g}for(const[s,g]of a)this._mirrorCollection.set(k.URI.revive(s),g.map(S.Diagnostic.to))}};A._idPool=0,A._maxDiagnosticsPerFile=1e3,A=Ve([$e(1,T.ILogService),$e(2,I.IExtHostFileSystemInfo)],A),e.ExtHostDiagnostics=A}),define(me[236],ge([0,1,2,5]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(R){this._proxy=R.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(R){return this._proxy.$showOpenDialog(R).then(S=>S?S.map(y=>m.URI.revive(y)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(S=>S?m.URI.revive(S):void 0)}}e.ExtHostDialogs=k}),define(me[237],ge([0,1,16,2,7,5,10,21,9]),function(J,e,m,L,k,C,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(I,c,f){this._documentsAndEditors=c,this._logService=f,this._documentContentProviders=new Map,this._proxy=I.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,c){if(Object.keys(R.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const f=T._handlePool++;this._documentContentProviders.set(f,c),this._proxy.$registerTextContentProvider(f,I);let h;return typeof c.onDidChange=="function"&&(h=c.onDidChange(p=>{if(p.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(p)&&this.$provideTextDocumentContent(f,p).then(D=>{if(!D&&typeof D!="string")return;const A=this._documentsAndEditors.getDocument(p);if(!A)return;const E=(0,y.splitLines)(D);if(!A.equalLines(E))return this._proxy.$onVirtualDocumentChange(p,D)},m.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(I,c){const f=this._documentContentProviders.get(I);return f?Promise.resolve(f.provideTextDocumentContent(L.URI.revive(c),S.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(me[238],ge([0,1,3,6,2,5,123,15,13,25,7]),function(J,e,m,L,k,C,R,S,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(f,h){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(p=>{for(const D of p)this._onDidRemoveDocument.fire(D.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(p=>{for(const D of p)this._onDidAddDocument.fire(D.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!f)return;const h=this._documentsAndEditors.getDocument(f);if(h)return h}getDocument(f){const h=this.getDocumentData(f);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${f}'`);return h.document}ensureDocumentData(f){const h=this._documentsAndEditors.getDocument(f);if(h)return Promise.resolve(h);let p=this._documentLoader.get(f.toString());return p||(p=this._proxy.$tryOpenDocument(f).then(D=>{this._documentLoader.delete(f.toString());const A=k.URI.revive(D);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(A))},D=>(this._documentLoader.delete(f.toString()),Promise.reject(D))),this._documentLoader.set(f.toString(),p)),p}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(h=>k.URI.revive(h))}$acceptModelModeChanged(f,h){const p=k.URI.revive(f),D=this._documentsAndEditors.getDocument(p);if(!D)throw new Error("unknown document");this._onDidRemoveDocument.fire(D.document),D._acceptLanguageId(h),this._onDidAddDocument.fire(D.document)}$acceptModelSaved(f){const h=k.URI.revive(f),p=this._documentsAndEditors.getDocument(h);if(!p)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(p.document)}$acceptDirtyStateChanged(f,h){const p=k.URI.revive(f),D=this._documentsAndEditors.getDocument(p);if(!D)throw new Error("unknown document");D._acceptIsDirty(h),this._onDidChangeDocument.fire({document:D.document,contentChanges:[],reason:void 0})}$acceptModelChanged(f,h,p){const D=k.URI.revive(f),A=this._documentsAndEditors.getDocument(D);if(!A)throw new Error("unknown document");A._acceptIsDirty(p),A.onEvents(h);let E;h.isUndoing?E=n.TextDocumentChangeReason.Undo:h.isRedoing&&(E=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:A.document,contentChanges:h.changes.map(a=>({range:S.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:E}))}setWordDefinitionFor(f,h){(0,R.setWordDefinitionFor)(f,h)}}e.ExtHostDocuments=I}),define(me[45],ge([0,1,57,3,6,2,4,5,123,14,130,15,12,24,10,94,139]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class A{constructor(s){this.value=s,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(s,g){this._extHostRpc=s,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const g=[],t=[],u=[];if(s.removedDocuments)for(const r of s.removedDocuments){const i=C.URI.revive(r),o=this._documents.get(i);o?.unref()&&(this._documents.delete(i),g.push(o.value))}if(s.addedDocuments)for(const r of s.addedDocuments){const i=C.URI.revive(r.uri);let o=this._documents.get(i);if(o&&i.scheme!==h.Schemas.vscodeNotebookCell&&i.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);o||(o=new A(new y.ExtHostDocumentData(this._extHostRpc.getProxy(S.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(i,o),t.push(o.value)),o.ref()}if(s.removedEditors)for(const r of s.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&u.push(i)}if(s.addedEditors)for(const r of s.addedEditors){const i=C.URI.revive(r.documentUri);m.ok(this._documents.has(i),`document '${i}' does not exist`),m.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const o=this._documents.get(i).value,l=new n.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(S.MainContext.MainThreadTextEditors),this._logService,new D.Lazy(()=>o.document),r.selections.map(I.Selection.to),r.options,r.visibleRanges.map(d=>I.Range.to(d)),typeof r.editorPosition=="number"?I.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,l)}s.newActiveEditor!==void 0&&(m.ok(s.newActiveEditor===null||this._editors.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this._activeEditorId=s.newActiveEditor),(0,k.dispose)(g),(0,k.dispose)(u),s.removedDocuments&&this._onDidRemoveDocuments.fire(g),s.addedDocuments&&this._onDidAddDocuments.fire(t),(s.removedEditors||s.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),s.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(s){return this._documents.get(s)?.value}allDocuments(){return p.Iterable.map(this._documents.values(),s=>s.value)}getEditor(s){return this._editors.get(s)}activeEditor(s){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return s?g:g?.value}allEditors(){return[...this._editors.values()]}};E=Ve([$e(0,T.IExtHostRpcService),$e(1,c.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[239],ge([0,1,2,5,6,7,15,148,9,22]),function(J,e,m,L,k,C,R,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const h=this._schemes.indexOf(f);h>=0&&(this._schemes.splice(h,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),h=[];let p,D,A=14,E=14;for(const a of f){let s=p?(0,y.commonPrefixLength)(p,a):0;for(s===0?D=1:D=E;s<a.length;s++)s+1===a.length?(A=E,E=9):E+=1,h.push([D,a.toUpperCase().charCodeAt(s),E]),h.push([D,a.toLowerCase().charCodeAt(s),E]),D=E;p=a,E=A}h.push([9,58,10]),h.push([10,47,12]),this._stateMachine=new S.StateMachine(h)}}provideDocumentLinks(f){this._initStateMachine();const h=[],p=S.LinkComputer.computeLinks({getLineContent(D){return f.lineAt(D-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const D of p){const A=R.DocumentLink.to(D);A.target&&h.push(A)}return h}}class I{constructor(f,h){this._extHostLanguageFeatures=h,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,h,p,D={}){if(this._registeredSchemes.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const A=this._handlePool++;this._linkProvider.add(h),this._registeredSchemes.add(h),this._fsProvider.set(A,p);let E=2;D.isCaseSensitive&&(E+=1024),D.isReadonly&&(E+=2048),typeof p.copy=="function"&&(E+=8),typeof p.open=="function"&&typeof p.close=="function"&&typeof p.read=="function"&&typeof p.write=="function"&&(E+=4),this._proxy.$registerFileSystemProvider(A,h,E).catch(s=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${h}`),console.error(s)});const a=p.onDidChangeFile(s=>{const g=[];for(const t of s){let{uri:u,type:r}=t;if(u.scheme!==h)continue;let i;switch(r){case C.FileChangeType.Changed:i=0;break;case C.FileChangeType.Created:i=1;break;case C.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}g.push({resource:u,type:i})}this._proxy.$onFileSystemChange(A,g)});return(0,k.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(h),this._registeredSchemes.delete(h),this._fsProvider.delete(A),this._proxy.$unregisterProvider(A)})}static _asIStat(f){const{type:h,ctime:p,mtime:D,size:A,permissions:E}=f;return{type:h,ctime:p,mtime:D,size:A,permissions:E}}$stat(f,h){return Promise.resolve(this._getFsProvider(f).stat(m.URI.revive(h))).then(p=>I._asIStat(p))}$readdir(f,h){return Promise.resolve(this._getFsProvider(f).readDirectory(m.URI.revive(h)))}$readFile(f,h){return Promise.resolve(this._getFsProvider(f).readFile(m.URI.revive(h))).then(p=>T.VSBuffer.wrap(p))}$writeFile(f,h,p,D){return Promise.resolve(this._getFsProvider(f).writeFile(m.URI.revive(h),p.buffer,D))}$delete(f,h,p){return Promise.resolve(this._getFsProvider(f).delete(m.URI.revive(h),p))}$rename(f,h,p,D){return Promise.resolve(this._getFsProvider(f).rename(m.URI.revive(h),m.URI.revive(p),D))}$copy(f,h,p,D){const A=this._getFsProvider(f);if(!A.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(A.copy(m.URI.revive(h),m.URI.revive(p),D))}$mkdir(f,h){return Promise.resolve(this._getFsProvider(f).createDirectory(m.URI.revive(h)))}$watch(f,h,p,D){const A=this._getFsProvider(f).watch(m.URI.revive(p),D);this._watches.set(h,A)}$unwatch(f,h){const p=this._watches.get(h);p&&(p.dispose(),this._watches.delete(h))}$open(f,h,p){const D=this._getFsProvider(f);if(!D.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(D.open(m.URI.revive(h),p))}$close(f,h){const p=this._getFsProvider(f);if(!p.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(p.close(h))}$read(f,h,p,D){const A=this._getFsProvider(f);if(!A.read)throw new Error('FileSystemProvider does not implement "read"');const E=T.VSBuffer.alloc(D);return Promise.resolve(A.read(h,p,E.buffer,0,D)).then(a=>E.slice(0,a))}$write(f,h,p,D){const A=this._getFsProvider(f);if(!A.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(A.write(h,p,D.buffer,0,D.byteLength))}_getFsProvider(f){const h=this._fsProvider.get(f);if(!h){const p=new Error;throw p.name="ENOPRO",p.message="no provider",p}return h}}e.ExtHostFileSystem=I}),define(me[91],ge([0,1,5,43,7,22,4,14,52]),function(J,e,m,L,k,C,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let T=class xt{constructor(I,c){const f=I.getProxy(m.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(h){return f.$stat(h).catch(xt._handleError)},readDirectory(h){return f.$readdir(h).catch(xt._handleError)},createDirectory(h){return f.$mkdir(h).catch(xt._handleError)},async readFile(h){return f.$readFile(h).then(p=>p.buffer).catch(xt._handleError)},writeFile(h,p){return f.$writeFile(h,C.VSBuffer.wrap(p)).catch(xt._handleError)},delete(h,p){return f.$delete(h,{recursive:!1,useTrash:!1,...p}).catch(xt._handleError)},rename(h,p,D){return f.$rename(h,p,{overwrite:!1,...D}).catch(xt._handleError)},copy(h,p,D){return f.$copy(h,p,{overwrite:!1,...D}).catch(xt._handleError)},isWritableFileSystem(h){const p=c.getCapabilities(h);if(typeof p=="number")return!(p&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new k.FileSystemError(String(I));if(I.name==="ENOPRO")throw k.FileSystemError.Unavailable(I.message);switch(I.name){case L.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(I.message);case L.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(I.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(I.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(I.message);case L.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(I.message);case L.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(I.message);default:throw new k.FileSystemError(I.message,I.name)}}};T=Ve([$e(0,S.IExtHostRpcService),$e(1,y.IExtHostFileSystemInfo)],T),e.ExtHostConsumerFileSystem=T,e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(me[240],ge([0,1,2,40]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(R,S,y,T){this._extHostNotebooks=S,this._textDocumentsAndEditors=y,this._commands=T;const n=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",I=>!0,I=>I),new L.ApiCommandArgument("resource","Interactive resource Uri",I=>!0,I=>I),new L.ApiCommandArgument("controllerId","Notebook controller Id",I=>!0,I=>I),new L.ApiCommandArgument("title","Interactive editor title",I=>!0,I=>I)],new L.ApiCommandResult("Notebook and input URI",I=>{if(I.notebookEditorId!==void 0){const c=this._extHostNotebooks.getEditorById(I.notebookEditorId);return{notebookUri:m.URI.revive(I.notebookUri),inputUri:m.URI.revive(I.inputUri),notebookEditor:c.apiEditor}}return{notebookUri:m.URI.revive(I.notebookUri),inputUri:m.URI.revive(I.inputUri)}}));this._commands.registerApiCommand(n)}$willAddInteractiveDocument(R,S,y,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:S,lines:[""],modeId:y,uri:R,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,S){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=k}),define(me[241],ge([0,1,6,5]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(R){this._handlePool=0,this._proxy=R.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const S=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(S,R),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(S)})}}e.ExtHostLabelService=k}),define(me[242],ge([0,1,2,25,15,7,5,9,42,17,13,145,6,111,76,87,46,16,3]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentSymbols(V,ee){const re=this._documents.getDocument(V),le=await this._provider.provideDocumentSymbols(re,ee);if(!(0,T.isFalsyOrEmpty)(le))return le[0]instanceof C.DocumentSymbol?le.map(k.DocumentSymbol.from):a._asDocumentSymbolTree(le)}static _asDocumentSymbolTree(V){V=V.slice(0).sort((le,Z)=>{let oe=le.location.range.start.compareTo(Z.location.range.start);return oe===0&&(oe=Z.location.range.end.compareTo(le.location.range.end)),oe});const ee=[],re=[];for(const le of V){const Z={name:le.name||"!!MISSING: name!!",kind:k.SymbolKind.from(le.kind),tags:le.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:le.containerName,range:k.Range.from(le.location.range),selectionRange:k.Range.from(le.location.range),children:[]};for(;;){if(re.length===0){re.push(Z),ee.push(Z);break}const oe=re[re.length-1];if(y.Range.containsRange(oe.range,Z.range)&&!y.Range.equalsRange(oe.range,Z.range)){oe.children&&oe.children.push(Z),re.push(Z);break}re.pop()}}return ee}}class s{constructor(V,ee,re){this._documents=V,this._commands=ee,this._provider=re,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(V,ee){const re=this._documents.getDocument(V),le=await this._provider.provideCodeLenses(re,ee);if(!le||ee.isCancellationRequested)return;const Z=this._cache.add(le),oe=new c.DisposableStore;this._disposables.set(Z,oe);const ve={cacheId:Z,lenses:[]};for(let Me=0;Me<le.length;Me++)ve.lenses.push({cacheId:[Z,Me],range:k.Range.from(le[Me].range),command:this._commands.toInternal(le[Me].command,oe)});return ve}async resolveCodeLens(V,ee){const re=V.cacheId&&this._cache.get(...V.cacheId);if(!re)return;let le;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?le=re:le=await this._provider.resolveCodeLens(re,ee),le||(le=re),ee.isCancellationRequested)return;const Z=V.cacheId&&this._disposables.get(V.cacheId[0]);if(!!Z)return V.command=this._commands.toInternal(le.command??s._badCmd,Z),V}releaseCodeLenses(V){this._disposables.get(V)?.dispose(),this._disposables.delete(V),this._cache.delete(V)}}s._badCmd={command:"missing",title:"!!MISSING: command!!"};function g(je){return Array.isArray(je)?je.map(k.DefinitionLink.from):je?[k.DefinitionLink.from(je)]:[]}class t{constructor(V,ee){this._documents=V,this._provider=ee}async provideDefinition(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.provideDefinition(le,Z,re);return g(oe)}}class u{constructor(V,ee){this._documents=V,this._provider=ee}async provideDeclaration(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.provideDeclaration(le,Z,re);return g(oe)}}class r{constructor(V,ee){this._documents=V,this._provider=ee}async provideImplementation(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.provideImplementation(le,Z,re);return g(oe)}}class i{constructor(V,ee){this._documents=V,this._provider=ee}async provideTypeDefinition(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.provideTypeDefinition(le,Z,re);return g(oe)}}class o{constructor(V,ee){this._documents=V,this._provider=ee}async provideHover(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.provideHover(le,Z,re);if(!(!oe||(0,T.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=le.getWordRangeAtPosition(Z)),oe.range||(oe.range=new C.Range(Z,Z)),k.Hover.from(oe)}}class l{constructor(V,ee){this._documents=V,this._provider=ee}async provideEvaluatableExpression(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.provideEvaluatableExpression(le,Z,re);if(oe)return k.EvaluatableExpression.from(oe)}}class d{constructor(V,ee){this._documents=V,this._provider=ee}async provideInlineValues(V,ee,re,le){const Z=this._documents.getDocument(V),oe=await this._provider.provideInlineValues(Z,k.Range.to(ee),k.InlineValueContext.to(re),le);if(Array.isArray(oe))return oe.map(ve=>k.InlineValue.from(ve))}}class b{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentHighlights(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.provideDocumentHighlights(le,Z,re);if(Array.isArray(oe))return oe.map(k.DocumentHighlight.from)}}class _{constructor(V,ee){this._documents=V,this._provider=ee}async provideLinkedEditingRanges(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.provideLinkedEditingRanges(le,Z,re);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,T.coalesce)(oe.ranges.map(k.Range.from)),wordPattern:oe.wordPattern}}}class v{constructor(V,ee){this._documents=V,this._provider=ee}async provideReferences(V,ee,re,le){const Z=this._documents.getDocument(V),oe=k.Position.to(ee),ve=await this._provider.provideReferences(Z,oe,re,le);if(Array.isArray(ve))return ve.map(k.location.from)}}class P{constructor(V,ee,re,le,Z,oe,ve){this._documents=V,this._commands=ee,this._diagnostics=re,this._provider=le,this._logService=Z,this._extension=oe,this._apiDeprecation=ve,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(V,ee,re,le){const Z=this._documents.getDocument(V),oe=I.Selection.isISelection(ee)?k.Selection.to(ee):k.Range.to(ee),ve=[];for(const at of this._diagnostics.getDiagnostics(V))if(oe.intersection(at.range)&&ve.push(at)>P._maxCodeActionsPerFile)break;const Me={diagnostics:ve,only:re.only?new C.CodeActionKind(re.only):void 0,triggerKind:k.CodeActionTriggerKind.to(re.trigger)},qe=await this._provider.provideCodeActions(Z,oe,Me,le);if(!(0,T.isNonEmptyArray)(qe)||le.isCancellationRequested)return;const Qe=this._cache.add(qe),Je=new c.DisposableStore;this._disposables.set(Qe,Je);const Ce=[];for(let at=0;at<qe.length;at++){const X=qe[at];!X||(P._isCommand(X)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ce.push({_isSynthetic:!0,title:X.title,command:this._commands.toInternal(X,Je)})):(Me.only&&(X.kind?Me.only.contains(X.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${X.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ce.push({cacheId:[Qe,at],title:X.title,command:X.command&&this._commands.toInternal(X.command,Je),diagnostics:X.diagnostics&&X.diagnostics.map(k.Diagnostic.from),edit:X.edit&&k.WorkspaceEdit.from(X.edit),kind:X.kind&&X.kind.value,isPreferred:X.isPreferred,disabled:X.disabled?.reason})))}return{cacheId:Qe,actions:Ce}}async resolveCodeAction(V,ee){const[re,le]=V,Z=this._cache.get(re,le);if(!Z||P._isCommand(Z)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(Z,ee)??Z;return oe?.edit?k.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(V){this._disposables.get(V)?.dispose(),this._disposables.delete(V),this._cache.delete(V)}static _isCommand(V){return typeof V.command=="string"&&typeof V.title=="string"}}P._maxCodeActionsPerFile=1e3;class w{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentFormattingEdits(V,ee,re){const le=this._documents.getDocument(V),Z=await this._provider.provideDocumentFormattingEdits(le,ee,re);if(Array.isArray(Z))return Z.map(k.TextEdit.from)}}class F{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentRangeFormattingEdits(V,ee,re,le){const Z=this._documents.getDocument(V),oe=k.Range.to(ee),ve=await this._provider.provideDocumentRangeFormattingEdits(Z,oe,re,le);if(Array.isArray(ve))return ve.map(k.TextEdit.from)}}class M{constructor(V,ee){this._documents=V,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,ee,re,le,Z){const oe=this._documents.getDocument(V),ve=k.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(oe,ve,re,le,Z);if(Array.isArray(Me))return Me.map(k.TextEdit.from)}}class K{constructor(V,ee){this._provider=V,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(V,ee){const re=R.IdObject.mixin({symbols:[]}),le=await this._provider.provideWorkspaceSymbols(V,ee);if((0,T.isNonEmptyArray)(le))for(const Z of le){if(!Z)continue;if(!Z.name){this._logService.warn("INVALID SymbolInformation, lacks name",Z);continue}const oe=R.IdObject.mixin(k.WorkspaceSymbol.from(Z));this._symbolCache.set(oe._id,Z),re.symbols.push(oe)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(V,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return V;const re=this._symbolCache.get(V._id);if(re){const le=await this._provider.resolveWorkspaceSymbol(re,ee);return le&&(0,L.mixin)(V,k.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(V){const ee=this._resultCache.get(V);if(ee){for(let[re,le]=ee;re<=le;re++)this._symbolCache.delete(re);this._resultCache.delete(V)}}}class G{constructor(V,ee,re){this._documents=V,this._provider=ee,this._logService=re}static supportsResolving(V){return typeof V.prepareRename=="function"}async provideRenameEdits(V,ee,re,le){const Z=this._documents.getDocument(V),oe=k.Position.to(ee);try{const ve=await this._provider.provideRenameEdits(Z,oe,re,le);return ve?k.WorkspaceEdit.from(ve):void 0}catch(ve){const Me=G._asMessage(ve);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(V,ee,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(V),Z=k.Position.to(ee);try{const oe=await this._provider.prepareRename(le,Z,re);let ve,Me;if(C.Range.isRange(oe)?(ve=oe,Me=le.getText(oe)):(0,n.isObject)(oe)&&(ve=oe.range,Me=oe.placeholder),!ve||!Me)return;if(ve.start.line>Z.line||ve.end.line<Z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(ve),text:Me}}catch(oe){const ve=G._asMessage(oe);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class N{constructor(V,ee){this.resultId=V,this.tokens=ee}}class z{constructor(V,ee){this._documents=V,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(V,ee,re){const le=this._documents.getDocument(V),Z=ee!==0?this._previousResults.get(ee):null;let oe=typeof Z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(le,Z.resultId,re):await this._provider.provideDocumentSemanticTokens(le,re);return Z&&this._previousResults.delete(ee),oe?(oe=z._fixProvidedSemanticTokens(oe),this._send(z._convertToEdits(Z,oe),oe)):null}async releaseDocumentSemanticColoring(V){this._previousResults.delete(V)}static _fixProvidedSemanticTokens(V){return z._isSemanticTokens(V)?z._isCorrectSemanticTokens(V)?V:new C.SemanticTokens(new Uint32Array(V.data),V.resultId):z._isSemanticTokensEdits(V)?z._isCorrectSemanticTokensEdits(V)?V:new C.SemanticTokensEdits(V.edits.map(ee=>new C.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),V.resultId):V}static _isSemanticTokens(V){return V&&!!V.data}static _isCorrectSemanticTokens(V){return V.data instanceof Uint32Array}static _isSemanticTokensEdits(V){return V&&Array.isArray(V.edits)}static _isCorrectSemanticTokensEdits(V){for(const ee of V.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(V,ee){if(!z._isSemanticTokens(ee)||!V||!V.tokens)return ee;const re=V.tokens,le=re.length,Z=ee.data,oe=Z.length;let ve=0;const Me=Math.min(le,oe);for(;ve<Me&&re[ve]===Z[ve];)ve++;if(ve===le&&ve===oe)return new C.SemanticTokensEdits([],ee.resultId);let qe=0;const Qe=Me-ve;for(;qe<Qe&&re[le-qe-1]===Z[oe-qe-1];)qe++;return new C.SemanticTokensEdits([{start:ve,deleteCount:le-ve-qe,data:Z.subarray(ve,oe-qe)}],ee.resultId)}_send(V,ee){if(z._isSemanticTokens(V)){const re=this._nextResultId++;return this._previousResults.set(re,new N(V.resultId,V.data)),(0,f.encodeSemanticTokensDto)({id:re,type:"full",data:V.data})}if(z._isSemanticTokensEdits(V)){const re=this._nextResultId++;return z._isSemanticTokens(ee)?this._previousResults.set(re,new N(ee.resultId,ee.data)):this._previousResults.set(re,new N(V.resultId)),(0,f.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(V.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class O{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentRangeSemanticTokens(V,ee,re){const le=this._documents.getDocument(V),Z=await this._provider.provideDocumentRangeSemanticTokens(le,k.Range.to(ee),re);return Z?this._send(Z):null}_send(V){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:V.data})}}e.DocumentRangeSemanticTokensAdapter=O;class x{constructor(V,ee,re,le,Z){this._documents=V,this._commands=ee,this._provider=re,this._apiDeprecation=le,this._extension=Z,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}async provideCompletionItems(V,ee,re,le){const Z=this._documents.getDocument(V),oe=k.Position.to(ee),ve=Z.getWordRangeAtPosition(oe)||new C.Range(oe,oe),Me=ve.with({end:oe}),qe=new D.StopWatch(!0),Qe=await this._provider.provideCompletionItems(Z,oe,le,k.CompletionContext.to(re));if(!Qe||le.isCancellationRequested)return;const Je=Array.isArray(Qe)?new C.CompletionList(Qe):Qe,Ce=x.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),at=new c.DisposableStore;this._disposables.set(Ce,at);const X=[],te={x:Ce,b:X,a:{replace:k.Range.from(ve),insert:k.Range.from(Me)},c:Je.isIncomplete||void 0,d:qe.elapsed()};for(let pe=0;pe<Je.items.length;pe++){const ze=Je.items[pe],tt=this._convertCompletionItem(ze,[Ce,pe],Me,ve);X.push(tt)}return te}async resolveCompletionItem(V,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...V);if(!re)return;const le=await this._provider.resolveCompletionItem(re,ee);if(!!le)return this._convertCompletionItem(le,V)}releaseCompletionItems(V){this._disposables.get(V)?.dispose(),this._disposables.delete(V),this._cache.delete(V)}_convertCompletionItem(V,ee,re,le){const Z=this._disposables.get(ee[0]);if(!Z)throw Error("DisposableStore is missing...");const oe={x:ee,a:V.label,b:V.kind!==void 0?k.CompletionItemKind.from(V.kind):void 0,n:V.tags&&V.tags.map(k.CompletionItemTag.from),c:V.detail,d:typeof V.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters,l:V.additionalTextEdits&&V.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(V.command,Z)};V.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=V.textEdit.newText):typeof V.insertText=="string"?oe.h=V.insertText:V.insertText instanceof C.SnippetString&&(oe.h=V.insertText.value,oe.i|=4);let ve;return V.textEdit?ve=V.textEdit.range:V.range&&(ve=V.range),C.Range.isRange(ve)?oe.j=k.Range.from(ve):ve&&(!re?.isEqual(ve.inserting)||!le?.isEqual(ve.replacing))&&(oe.j={insert:k.Range.from(ve.inserting),replace:k.Range.from(ve.replacing)}),oe}}class B{constructor(V,ee,re){this._documents=V,this._provider=ee,this._commands=re,this._cache=new p.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(V,ee,re,le){const Z=this._documents.getDocument(V),oe=k.Position.to(ee),ve=await this._provider.provideInlineCompletionItems(Z,oe,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:k.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text}:void 0,triggerKind:re.triggerKind},le);if(!ve||le.isCancellationRequested)return;const Me=(0,n.isArray)(ve)?{items:ve}:ve,qe=this._cache.add(Me.items);let Qe;return{pid:qe,items:Me.items.map((Je,Ce)=>{let at;return Je.command&&(Qe||(Qe=new c.DisposableStore,this._disposables.set(qe,Qe)),at=this._commands.toInternal(Je.command,Qe)),{text:Je.text,range:Je.range?k.Range.from(Je.range):void 0,command:at,idx:Ce}})}}disposeCompletions(V){this._cache.delete(V);const ee=this._disposables.get(V);ee&&ee.clear(),this._disposables.delete(V)}handleDidShowCompletionItem(V,ee){const re=this._cache.get(V,ee);re&&U.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class U{constructor(){this._onDidShowCompletionItemEmitter=new E.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(V){let ee=U.map.get(V);return ee||(ee=new U,U.map.set(V,ee)),ee}fireOnDidShowCompletionItem(V){this._onDidShowCompletionItemEmitter.fire(V)}}e.InlineCompletionController=U,U.map=new WeakMap;class H{constructor(V,ee){this._documents=V,this._provider=ee,this._cache=new p.Cache("SignatureHelp")}async provideSignatureHelp(V,ee,re,le){const Z=this._documents.getDocument(V),oe=k.Position.to(ee),ve=this.reviveContext(re),Me=await this._provider.provideSignatureHelp(Z,oe,le,ve);if(Me){const qe=this._cache.add([Me]);return{...k.SignatureHelp.from(Me),id:qe}}}reviveContext(V){let ee;if(V.activeSignatureHelp){const re=k.SignatureHelp.to(V.activeSignatureHelp),le=this._cache.get(V.activeSignatureHelp.id,0);le?(ee=le,ee.activeSignature=re.activeSignature,ee.activeParameter=re.activeParameter):ee=re}return{...V,activeSignatureHelp:ee}}releaseSignatureHelp(V){this._cache.delete(V)}}class W{constructor(V,ee){this._documents=V,this._provider=ee}async provideInlayHints(V,ee,re){const le=this._documents.getDocument(V),Z=await this._provider.provideInlayHints(le,k.Range.to(ee),re);return Z?{hints:Z.map(k.InlayHint.from)}:void 0}}class Q{constructor(V,ee){this._documents=V,this._provider=ee,this._cache=new p.Cache("DocumentLink")}async provideLinks(V,ee){const re=this._documents.getDocument(V),le=await this._provider.provideDocumentLinks(re,ee);if(!(!Array.isArray(le)||le.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.filter(Q._validateLink).map(k.DocumentLink.from)};{const Z=this._cache.add(le),oe={links:[],id:Z};for(let ve=0;ve<le.length;ve++){if(!Q._validateLink(le[ve]))continue;const Me=k.DocumentLink.from(le[ve]);Me.cacheId=[Z,ve],oe.links.push(Me)}return oe}}}static _validateLink(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...V);if(!re)return;const le=await this._provider.resolveDocumentLink(re,ee);if(!(!le||!Q._validateLink(le)))return k.DocumentLink.from(le)}releaseLinks(V){this._cache.delete(V)}}class Y{constructor(V,ee){this._documents=V,this._provider=ee}async provideColors(V,ee){const re=this._documents.getDocument(V),le=await this._provider.provideDocumentColors(re,ee);return Array.isArray(le)?le.map(oe=>({color:k.Color.from(oe.color),range:k.Range.from(oe.range)})):[]}async provideColorPresentations(V,ee,re){const le=this._documents.getDocument(V),Z=k.Range.to(ee.range),oe=k.Color.to(ee.color),ve=await this._provider.provideColorPresentations(oe,{document:le,range:Z},re);if(!!Array.isArray(ve))return ve.map(k.ColorPresentation.from)}}class he{constructor(V,ee){this._documents=V,this._provider=ee}async provideFoldingRanges(V,ee,re){const le=this._documents.getDocument(V),Z=await this._provider.provideFoldingRanges(le,ee,re);if(!!Array.isArray(Z))return Z.map(k.FoldingRange.from)}}class _e{constructor(V,ee,re){this._documents=V,this._provider=ee,this._logService=re}async provideSelectionRanges(V,ee,re){const le=this._documents.getDocument(V),Z=ee.map(k.Position.to),oe=await this._provider.provideSelectionRanges(le,Z,re);if(!(0,T.isNonEmptyArray)(oe))return[];if(oe.length!==Z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Me=0;Me<Z.length;Me++){const qe=[];ve.push(qe);let Qe=Z[Me],Je=oe[Me];for(;;){if(!Je.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(qe.push(k.SelectionRange.from(Je)),!Je.parent)break;Qe=Je.range,Je=Je.parent}}return ve}}class Se{constructor(V,ee){this._documents=V,this._provider=ee,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.prepareCallHierarchy(le,Z,re);if(!oe)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,oe)]}async provideCallsTo(V,ee,re){const le=this._itemFromCache(V,ee);if(!le)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyIncomingCalls(le,re);if(!!Z)return Z.map(oe=>({from:this._cacheAndConvertItem(V,oe.from),fromRanges:oe.fromRanges.map(ve=>k.Range.from(ve))}))}async provideCallsFrom(V,ee,re){const le=this._itemFromCache(V,ee);if(!le)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyOutgoingCalls(le,re);if(!!Z)return Z.map(oe=>({to:this._cacheAndConvertItem(V,oe.to),fromRanges:oe.fromRanges.map(ve=>k.Range.from(ve))}))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,ee){const re=this._cache.get(V),le=k.CallHierarchyItem.from(ee,V,re.size.toString(36));return re.set(le._itemId,ee),le}_itemFromCache(V,ee){return this._cache.get(V)?.get(ee)}}class Re{constructor(V,ee){this._documents=V,this._provider=ee,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.prepareTypeHierarchy(le,Z,re);if(!oe)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,oe)]}async provideSupertypes(V,ee,re){const le=this._itemFromCache(V,ee);if(!le)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySupertypes(le,re);if(!!Z)return Z.map(oe=>this._cacheAndConvertItem(V,oe))}async provideSubtypes(V,ee,re){const le=this._itemFromCache(V,ee);if(!le)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySubtypes(le,re);if(!!Z)return Z.map(oe=>this._cacheAndConvertItem(V,oe))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,ee){const re=this._cache.get(V),le=k.TypeHierarchyItem.from(ee,V,re.size.toString(36));return re.set(le._itemId,ee),le}_itemFromCache(V,ee){return this._cache.get(V)?.get(ee)}}class xe{constructor(V,ee){this.adapter=V,this.extension=ee}}class Ue{constructor(V,ee,re,le,Z,oe,ve){this._adapter=new Map,this._uriTransformer=ee,this._proxy=V.getProxy(R.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=le,this._diagnostics=Z,this._logService=oe,this._apiDeprecation=ve}_transformDocumentSelector(V){return(0,T.coalesce)((0,T.asArray)(V).map(ee=>this._doTransformDocumentSelector(ee)))}_doTransformDocumentSelector(V){if(typeof V=="string")return{$serialized:!0,language:V};if(V)return{$serialized:!0,language:V.language,scheme:this._transformScheme(V.scheme),pattern:typeof V.pattern=="undefined"?void 0:k.GlobPattern.from(V.pattern),exclusive:V.exclusive}}_transformScheme(V){return this._uriTransformer&&typeof V=="string"?this._uriTransformer.transformOutgoingScheme(V):V}_createDisposable(V){return new C.Disposable(()=>{this._adapter.delete(V),this._proxy.$unregister(V)})}_nextHandle(){return Ue._handlePool++}_withAdapter(V,ee,re,le,Z=!1){const oe=this._adapter.get(V);if(!oe)return Promise.resolve(le);if(oe.adapter instanceof ee){let ve;oe.extension&&(ve=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=re(oe.adapter,oe.extension),qe=oe.extension;return qe&&Promise.resolve(Me).then(()=>this._logService.trace(`[${qe.identifier.value}] provider DONE after ${Date.now()-ve}ms`),Qe=>{Z&&Qe instanceof A.CancellationError||(this._logService.error(`[${qe.identifier.value}] provider FAILED`),this._logService.error(Qe))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(V,ee){const re=this._nextHandle();return this._adapter.set(re,new xe(V,ee)),re}static _extLabel(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,ee,re,le){const Z=this._addNewAdapter(new a(this._documents,re),V),oe=le&&le.label||Ue._extLabel(V);return this._proxy.$registerDocumentSymbolProvider(Z,this._transformDocumentSelector(ee),oe),this._createDisposable(Z)}$provideDocumentSymbols(V,ee,re){return this._withAdapter(V,a,le=>le.provideDocumentSymbols(m.URI.revive(ee),re),void 0)}registerCodeLensProvider(V,ee,re){const le=this._nextHandle(),Z=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new xe(new s(this._documents,this._commands.converter,re),V)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(ee),Z);let oe=this._createDisposable(le);if(Z!==void 0){const ve=re.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Z));oe=C.Disposable.from(oe,ve)}return oe}$provideCodeLenses(V,ee,re){return this._withAdapter(V,s,le=>le.provideCodeLenses(m.URI.revive(ee),re),void 0)}$resolveCodeLens(V,ee,re){return this._withAdapter(V,s,le=>le.resolveCodeLens(ee,re),void 0)}$releaseCodeLenses(V,ee){this._withAdapter(V,s,re=>Promise.resolve(re.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(V,ee,re){const le=this._addNewAdapter(new t(this._documents,re),V);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDefinition(V,ee,re,le){return this._withAdapter(V,t,Z=>Z.provideDefinition(m.URI.revive(ee),re,le),[])}registerDeclarationProvider(V,ee,re){const le=this._addNewAdapter(new u(this._documents,re),V);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDeclaration(V,ee,re,le){return this._withAdapter(V,u,Z=>Z.provideDeclaration(m.URI.revive(ee),re,le),[])}registerImplementationProvider(V,ee,re){const le=this._addNewAdapter(new r(this._documents,re),V);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideImplementation(V,ee,re,le){return this._withAdapter(V,r,Z=>Z.provideImplementation(m.URI.revive(ee),re,le),[])}registerTypeDefinitionProvider(V,ee,re){const le=this._addNewAdapter(new i(this._documents,re),V);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideTypeDefinition(V,ee,re,le){return this._withAdapter(V,i,Z=>Z.provideTypeDefinition(m.URI.revive(ee),re,le),[])}registerHoverProvider(V,ee,re,le){const Z=this._addNewAdapter(new o(this._documents,re),V);return this._proxy.$registerHoverProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideHover(V,ee,re,le){return this._withAdapter(V,o,Z=>Z.provideHover(m.URI.revive(ee),re,le),void 0)}registerEvaluatableExpressionProvider(V,ee,re,le){const Z=this._addNewAdapter(new l(this._documents,re),V);return this._proxy.$registerEvaluatableExpressionProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideEvaluatableExpression(V,ee,re,le){return this._withAdapter(V,l,Z=>Z.provideEvaluatableExpression(m.URI.revive(ee),re,le),void 0)}registerInlineValuesProvider(V,ee,re,le){const Z=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new d(this._documents,re),V);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(ee),Z);let ve=this._createDisposable(oe);if(Z!==void 0){const Me=re.onDidChangeInlineValues(qe=>this._proxy.$emitInlineValuesEvent(Z));ve=C.Disposable.from(ve,Me)}return ve}$provideInlineValues(V,ee,re,le,Z){return this._withAdapter(V,d,oe=>oe.provideInlineValues(m.URI.revive(ee),re,le,Z),void 0)}registerDocumentHighlightProvider(V,ee,re){const le=this._addNewAdapter(new b(this._documents,re),V);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentHighlights(V,ee,re,le){return this._withAdapter(V,b,Z=>Z.provideDocumentHighlights(m.URI.revive(ee),re,le),void 0)}registerLinkedEditingRangeProvider(V,ee,re){const le=this._addNewAdapter(new _(this._documents,re),V);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideLinkedEditingRanges(V,ee,re,le){return this._withAdapter(V,_,async Z=>{const oe=await Z.provideLinkedEditingRanges(m.URI.revive(ee),re,le);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?Ue._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(V,ee,re){const le=this._addNewAdapter(new v(this._documents,re),V);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideReferences(V,ee,re,le,Z){return this._withAdapter(V,v,oe=>oe.provideReferences(m.URI.revive(ee),re,le,Z),void 0)}registerCodeActionProvider(V,ee,re,le){const Z=new c.DisposableStore,oe=this._addNewAdapter(new P(this._documents,this._commands.converter,this._diagnostics,re,this._logService,V,this._apiDeprecation),V);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(ee),{providedKinds:le?.providedCodeActionKinds?.map(ve=>ve.value),documentation:le?.documentation?.map(ve=>({kind:ve.kind.value,command:this._commands.converter.toInternal(ve.command,Z)}))},Ue._extLabel(V),Boolean(re.resolveCodeAction)),Z.add(this._createDisposable(oe)),Z}$provideCodeActions(V,ee,re,le,Z){return this._withAdapter(V,P,oe=>oe.provideCodeActions(m.URI.revive(ee),re,le,Z),void 0)}$resolveCodeAction(V,ee,re){return this._withAdapter(V,P,le=>le.resolveCodeAction(ee,re),void 0)}$releaseCodeActions(V,ee){this._withAdapter(V,P,re=>Promise.resolve(re.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(V,ee,re){const le=this._addNewAdapter(new w(this._documents,re),V);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(ee),V.identifier,V.displayName||V.name),this._createDisposable(le)}$provideDocumentFormattingEdits(V,ee,re,le){return this._withAdapter(V,w,Z=>Z.provideDocumentFormattingEdits(m.URI.revive(ee),re,le),void 0)}registerDocumentRangeFormattingEditProvider(V,ee,re){const le=this._addNewAdapter(new F(this._documents,re),V);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(ee),V.identifier,V.displayName||V.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(V,ee,re,le,Z){return this._withAdapter(V,F,oe=>oe.provideDocumentRangeFormattingEdits(m.URI.revive(ee),re,le,Z),void 0)}registerOnTypeFormattingEditProvider(V,ee,re,le){const Z=this._addNewAdapter(new M(this._documents,re),V);return this._proxy.$registerOnTypeFormattingSupport(Z,this._transformDocumentSelector(ee),le,V.identifier),this._createDisposable(Z)}$provideOnTypeFormattingEdits(V,ee,re,le,Z,oe){return this._withAdapter(V,M,ve=>ve.provideOnTypeFormattingEdits(m.URI.revive(ee),re,le,Z,oe),void 0)}registerWorkspaceSymbolProvider(V,ee){const re=this._addNewAdapter(new K(ee,this._logService),V);return this._proxy.$registerNavigateTypeSupport(re),this._createDisposable(re)}$provideWorkspaceSymbols(V,ee,re){return this._withAdapter(V,K,le=>le.provideWorkspaceSymbols(ee,re),{symbols:[]})}$resolveWorkspaceSymbol(V,ee,re){return this._withAdapter(V,K,le=>le.resolveWorkspaceSymbol(ee,re),void 0)}$releaseWorkspaceSymbols(V,ee){this._withAdapter(V,K,re=>re.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(V,ee,re){const le=this._addNewAdapter(new G(this._documents,re,this._logService),V);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(ee),G.supportsResolving(re)),this._createDisposable(le)}$provideRenameEdits(V,ee,re,le,Z){return this._withAdapter(V,G,oe=>oe.provideRenameEdits(m.URI.revive(ee),re,le,Z),void 0)}$resolveRenameLocation(V,ee,re,le){return this._withAdapter(V,G,Z=>Z.resolveRenameLocation(m.URI.revive(ee),re,le),void 0)}registerDocumentSemanticTokensProvider(V,ee,re,le){const Z=this._nextHandle(),oe=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Z,new xe(new z(this._documents,re),V)),this._proxy.$registerDocumentSemanticTokensProvider(Z,this._transformDocumentSelector(ee),le,oe);let ve=this._createDisposable(Z);if(oe){const Me=re.onDidChangeSemanticTokens(qe=>this._proxy.$emitDocumentSemanticTokensEvent(oe));ve=C.Disposable.from(ve,Me)}return ve}$provideDocumentSemanticTokens(V,ee,re,le){return this._withAdapter(V,z,Z=>Z.provideDocumentSemanticTokens(m.URI.revive(ee),re,le),null,!0)}$releaseDocumentSemanticTokens(V,ee){this._withAdapter(V,z,re=>re.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(V,ee,re,le){const Z=this._addNewAdapter(new O(this._documents,re),V);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Z,this._transformDocumentSelector(ee),le),this._createDisposable(Z)}$provideDocumentRangeSemanticTokens(V,ee,re,le){return this._withAdapter(V,O,Z=>Z.provideDocumentRangeSemanticTokens(m.URI.revive(ee),re,le),null,!0)}registerCompletionItemProvider(V,ee,re,le){const Z=this._addNewAdapter(new x(this._documents,this._commands.converter,re,this._apiDeprecation,V),V);return this._proxy.$registerSuggestSupport(Z,this._transformDocumentSelector(ee),le,x.supportsResolving(re),`${V.identifier.value}(${le.join("")})`),this._createDisposable(Z)}$provideCompletionItems(V,ee,re,le,Z){return this._withAdapter(V,x,oe=>oe.provideCompletionItems(m.URI.revive(ee),re,le,Z),void 0)}$resolveCompletionItem(V,ee,re){return this._withAdapter(V,x,le=>le.resolveCompletionItem(ee,re),void 0)}$releaseCompletionItems(V,ee){this._withAdapter(V,x,re=>re.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(V,ee,re){const le=this._addNewAdapter(new B(this._documents,re,this._commands.converter),V);return this._proxy.$registerInlineCompletionsSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideInlineCompletions(V,ee,re,le,Z){return this._withAdapter(V,B,oe=>oe.provideInlineCompletions(m.URI.revive(ee),re,le,Z),void 0)}$handleInlineCompletionDidShow(V,ee,re){this._withAdapter(V,B,async le=>{le.handleDidShowCompletionItem(ee,re)},void 0)}$freeInlineCompletionsList(V,ee){this._withAdapter(V,B,async re=>{re.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(V,ee,re,le){const Z=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,oe=this._addNewAdapter(new H(this._documents,re),V);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(ee),Z),this._createDisposable(oe)}$provideSignatureHelp(V,ee,re,le,Z){return this._withAdapter(V,H,oe=>oe.provideSignatureHelp(m.URI.revive(ee),re,le,Z),void 0)}$releaseSignatureHelp(V,ee){this._withAdapter(V,H,re=>re.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(V,ee,re){const le=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new W(this._documents,re),V);this._proxy.$registerInlayHintsProvider(Z,this._transformDocumentSelector(ee),le);let oe=this._createDisposable(Z);if(le!==void 0){const ve=re.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(le));oe=C.Disposable.from(oe,ve)}return oe}$provideInlayHints(V,ee,re,le){return this._withAdapter(V,W,Z=>Z.provideInlayHints(m.URI.revive(ee),re,le),void 0)}registerDocumentLinkProvider(V,ee,re){const le=this._addNewAdapter(new Q(this._documents,re),V);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(ee),typeof re.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(V,ee,re){return this._withAdapter(V,Q,le=>le.provideLinks(m.URI.revive(ee),re),void 0)}$resolveDocumentLink(V,ee,re){return this._withAdapter(V,Q,le=>le.resolveLink(ee,re),void 0)}$releaseDocumentLinks(V,ee){this._withAdapter(V,Q,re=>re.releaseLinks(ee),void 0)}registerColorProvider(V,ee,re){const le=this._addNewAdapter(new Y(this._documents,re),V);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentColors(V,ee,re){return this._withAdapter(V,Y,le=>le.provideColors(m.URI.revive(ee),re),[])}$provideColorPresentations(V,ee,re,le){return this._withAdapter(V,Y,Z=>Z.provideColorPresentations(m.URI.revive(ee),re,le),void 0)}registerFoldingRangeProvider(V,ee,re){const le=this._nextHandle(),Z=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new xe(new he(this._documents,re),V)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(ee),Z);let oe=this._createDisposable(le);if(Z!==void 0){const ve=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Z));oe=C.Disposable.from(oe,ve)}return oe}$provideFoldingRanges(V,ee,re,le){return this._withAdapter(V,he,Z=>Z.provideFoldingRanges(m.URI.revive(ee),re,le),void 0)}registerSelectionRangeProvider(V,ee,re){const le=this._addNewAdapter(new _e(this._documents,re,this._logService),V);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideSelectionRanges(V,ee,re,le){return this._withAdapter(V,_e,Z=>Z.provideSelectionRanges(m.URI.revive(ee),re,le),[])}registerCallHierarchyProvider(V,ee,re){const le=this._addNewAdapter(new Se(this._documents,re),V);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareCallHierarchy(V,ee,re,le){return this._withAdapter(V,Se,Z=>Promise.resolve(Z.prepareSession(m.URI.revive(ee),re,le)),void 0)}$provideCallHierarchyIncomingCalls(V,ee,re,le){return this._withAdapter(V,Se,Z=>Z.provideCallsTo(ee,re,le),void 0)}$provideCallHierarchyOutgoingCalls(V,ee,re,le){return this._withAdapter(V,Se,Z=>Z.provideCallsFrom(ee,re,le),void 0)}$releaseCallHierarchy(V,ee){this._withAdapter(V,Se,re=>Promise.resolve(re.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(V,ee,re){const le=this._addNewAdapter(new Re(this._documents,re),V);return this._proxy.$registerTypeHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareTypeHierarchy(V,ee,re,le){return this._withAdapter(V,Re,Z=>Promise.resolve(Z.prepareSession(m.URI.revive(ee),re,le)),void 0)}$provideTypeHierarchySupertypes(V,ee,re,le){return this._withAdapter(V,Re,Z=>Z.provideSupertypes(ee,re,le),void 0)}$provideTypeHierarchySubtypes(V,ee,re,le){return this._withAdapter(V,Re,Z=>Z.provideSubtypes(ee,re,le),void 0)}$releaseTypeHierarchy(V,ee){this._withAdapter(V,Re,re=>Promise.resolve(re.releaseSession(ee)),void 0)}static _serializeRegExp(V){return{pattern:V.source,flags:(0,S.regExpFlags)(V)}}static _serializeIndentationRule(V){return{decreaseIndentPattern:Ue._serializeRegExp(V.decreaseIndentPattern),increaseIndentPattern:Ue._serializeRegExp(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Ue._serializeRegExp(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Ue._serializeRegExp(V.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(V){return{beforeText:Ue._serializeRegExp(V.beforeText),afterText:V.afterText?Ue._serializeRegExp(V.afterText):void 0,previousLineText:V.previousLineText?Ue._serializeRegExp(V.previousLineText):void 0,action:V.action}}static _serializeOnEnterRules(V){return V.map(Ue._serializeOnEnterRule)}setLanguageConfiguration(V,ee,re){let{wordPattern:le}=re;if(le&&(0,S.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(ee,le):this._documents.setWordDefinitionFor(ee,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const Z=this._nextHandle(),oe={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?Ue._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?Ue._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?Ue._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Z,ee,oe),this._createDisposable(Z)}$setWordDefinitions(V){for(const ee of V)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=Ue,Ue._handlePool=0}),define(me[243],ge([0,1,5,15,7,49,18,6]),function(J,e,m,L,k,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(n,I,c){this._documents=I,this._commands=c,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=n.getProxy(m.MainContext.MainThreadLanguages)}$acceptLanguageIds(n){this._languageIds=n}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(n,I){await this._proxy.$changeLanguage(n,I);const c=this._documents.getDocumentData(n);if(!c)throw new Error(`document '${n.toString}' NOT found`);return c.document}async tokenAtPosition(n,I){const c=n.version,f=L.Position.from(I),h=await this._proxy.$tokensAtPosition(n.uri,f),p={type:k.StandardTokenType.Other,range:n.getWordRangeAtPosition(I)??new k.Range(I.line,I.character,I.line,I.character)};if(!h)return p;const D={range:L.Range.to(h.range),type:L.TokenType.to(h.type)};return!D.range.contains(I)||c!==n.version?p:D}createLanguageStatusItem(n,I,c){const f=this._handlePool++,h=this._proxy,p=this._ids,D=`${n.identifier.value}/${I}`;if(p.has(D))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);p.add(D);const A={selector:c,id:I,name:n.displayName??n.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let E,a=new S.DisposableStore;const s=()=>{E?.dispose(),E=(0,R.disposableTimeout)(()=>{a.clear(),this._proxy.$setLanguageStatus(f,{id:D,name:A.name??n.displayName??n.name,source:n.displayName??n.name,selector:A.selector,label:A.text,detail:A.detail??"",severity:A.severity===k.LanguageStatusSeverity.Error?C.default.Error:A.severity===k.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info,command:A.command&&this._commands.toInternal(A.command,a),accessibilityInfo:A.accessibilityInformation})},0)},g={dispose(){a.dispose(),E?.dispose(),h.$removeLanguageStatus(f),p.delete(D)},get id(){return A.id},get name(){return A.name},set name(t){A.name=t,s()},get selector(){return A.selector},set selector(t){A.selector=t,s()},get text(){return A.text},set text(t){A.text=t,s()},get detail(){return A.detail},set detail(t){A.detail=t,s()},get severity(){return A.severity},set severity(t){A.severity=t,s()},get accessibilityInformation(){return A.accessibilityInformation},set accessibilityInformation(t){A.accessibilityInformation=t,s()},get command(){return A.command},set command(t){A.command=t,s()}};return s(),g}}e.ExtHostLanguages=y}),define(me[244],ge([0,1,5,12,35]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(S){return S&&S.title}let R=class{constructor(y,T){this._logService=T,this._proxy=y.getProxy(m.MainContext.MainThreadMessageService)}showMessage(y,T,n,I,c){const f={extension:y};let h;typeof I=="string"||C(I)?h=[I,...c]:(f.modal=I?.modal,f.useCustom=I?.useCustom,f.detail=I?.detail,h=c),f.useCustom&&(0,k.checkProposedApiEnabled)(y);const p=[];for(let D=0;D<h.length;D++){const A=h[D];if(typeof A=="string")p.push({title:A,handle:D,isCloseAffordance:!1});else if(typeof A=="object"){let{title:E,isCloseAffordance:a}=A;p.push({title:E,isCloseAffordance:!!a,handle:D})}else this._logService.warn("Invalid message item:",A)}return this._proxy.$showMessage(T,n,f,p).then(D=>{if(typeof D=="number")return h[D]})}};R=Ve([$e(1,L.ILogService)],R),e.ExtHostMessageService=R}),define(me[245],ge([0,1,22,3,48,6,24,9,13,2,87,5,15,7,55,220,129]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class A{constructor(a,s,g,t,u){this._textDocumentsAndEditors=g,this._textDocuments=t,this._extensionStoragePaths=u,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=s.converter,s.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,o=r.cell.handle,d=this._documents.get(i)?.getCell(o);if(d)return d.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const s=this._editors.get(a);if(!s)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return s}getIdByEditor(a){for(const[s,g]of this._editors)if(g.apiEditor===a)return s}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,s){const g=this._documents.get(a);if(!g&&!s)throw new Error(`NO notebook document for '${a}'`);return g}_getProviderData(a){const s=this._notebookContentProviders.get(a);if(!s)throw new Error(`NO provider for '${a}'`);return s}registerNotebookContentProvider(a,s,g,t,u){if((0,S.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(s))throw new Error(`Notebook provider for '${s}' already registered`);this._notebookContentProviders.set(s,{extension:a,provider:g});let r;return g.onDidChangeNotebookContentOptions&&(r=g.onDidChangeNotebookContentOptions(()=>{const i=c.NotebookDocumentContentOptions.from(g.options);this._notebookProxy.$updateNotebookProviderOptions(s,i)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},s,c.NotebookDocumentContentOptions.from(t),A._convertNotebookRegistrationData(a,u)),new f.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(s),this._notebookProxy.$unregisterNotebookProvider(s)})}static _convertNotebookRegistrationData(a,s){if(!s)return;const g=s.filenamePattern.map(t=>c.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(s.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${s.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:s.displayName,filenamePattern:g,exclusive:s.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,s,g){const t=A._notebookStatusBarItemProviderHandlePool++,u=typeof g.onDidChangeCellStatusBarItems=="function"?A._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,u,s);let r;return u!==void 0&&(r=g.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(u))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,u),r&&r.dispose()})}async createNotebookDocument(a){const s=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&c.NotebookData.from(a.content)});return T.URI.revive(s)}async openNotebookDocument(a){const s=this._documents.get(a);if(s)return s.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(a),t=this._documents.get(T.URI.revive(g));return(0,y.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(a,s){T.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let g;typeof s=="object"?g={position:c.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus,selections:s.selections&&s.selections.map(c.NotebookRange.from),pinned:typeof s.preview=="boolean"?!s.preview:void 0}:g={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,g),u=t&&this._editors.get(t)?.apiEditor;if(u)return u;throw t?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,s,g,t){const u=this._notebookStatusBarItemProviders.get(a),r=T.URI.revive(s),i=this._documents.get(r);if(!i||!u)return;const o=i.getCellFromIndex(g);if(!o)return;const l=await u.provideCellStatusBarItems(o.apiCell,t);if(!l)return;const d=new C.DisposableStore,b=this._statusBarCache.add([d]),v=(Array.isArray(l)?l:[l]).map(P=>c.NotebookStatusBarItem.from(P,this._commandsConverter,d));return{cacheId:b,items:v}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,s,g,t,u){if((0,S.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,g),this._notebookProxy.$registerNotebookSerializer(r,{id:a.identifier,location:a.extensionLocation},s,c.NotebookDocumentContentOptions.from(t),A._convertNotebookRegistrationData(a,u)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(a,s,g){const t=this._notebookSerializer.get(a);if(!t)throw new Error("NO serializer found");const u=await t.deserializeNotebook(s.buffer,g);return new h.SerializableObjectWithBuffers(c.NotebookData.from(u))}async $notebookToData(a,s,g){const t=this._notebookSerializer.get(a);if(!t)throw new Error("NO serializer found");const u=await t.serializeNotebook(c.NotebookData.to(s.value),g);return m.VSBuffer.wrap(u)}async $openNotebook(a,s,g,t,u){const{provider:r}=this._getProviderData(a),i=await r.openNotebook(T.URI.revive(s),{backupId:g,untitledDocumentData:t?.buffer},u);return new h.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(c.NotebookCellData.from)})}async $saveNotebook(a,s,g){const t=this.getNotebookDocument(T.URI.revive(s)),{provider:u}=this._getProviderData(a);return await u.saveNotebook(t.apiNotebook,g),!0}async $saveNotebookAs(a,s,g,t){const u=this.getNotebookDocument(T.URI.revive(s)),{provider:r}=this._getProviderData(a);return await r.saveNotebookAs(T.URI.revive(g),u.apiNotebook,t),!0}async $backupNotebook(a,s,g){const t=this.getNotebookDocument(T.URI.revive(s)),u=this._getProviderData(a),r=this._extensionStoragePaths.workspaceValue(u.extension)??this._extensionStoragePaths.globalValue(u.extension),i=String((0,k.hash)([t.uri.toString(),this._backupIdPool++])),o=T.URI.joinPath(r,i),l=await u.provider.backupNotebook(t.apiNotebook,{destination:o},g);return t.updateBackup(l),l.id}_createExtHostEditor(a,s,g){if(this._editors.has(s))throw new Error(`editor with id ALREADY EXSIST: ${s}`);const t=new D.ExtHostNotebookEditor(s,this._notebookEditorsProxy,a,g.visibleRanges.map(c.NotebookRange.to),g.selections.map(c.NotebookRange.to),typeof g.viewColumn=="number"?c.ViewColumn.to(g.viewColumn):void 0);this._editors.set(s,t)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const g of a.value.removedDocuments){const t=T.URI.revive(g),u=this._documents.get(t);u&&(u.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:u.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(u.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===t.toString()&&this._editors.delete(r.id)}if(a.value.addedDocuments){const g=[];for(const t of a.value.addedDocuments){const u=T.URI.revive(t.uri);if(this._documents.has(u))throw new Error(`adding EXISTING notebook ${u} `);const r=this,i=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(o){r._onDidChangeNotebookCells.fire(o)},emitCellOutputsChange(o){r._onDidChangeCellOutputs.fire(o)},emitCellMetadataChange(o){r._onDidChangeCellMetadata.fire(o)},emitCellExecutionStateChange(o){r._onDidChangeCellExecutionState.fire(o)}},u,t);g.push(...t.cells.map(o=>p.ExtHostCell.asModelAddData(i.apiNotebook,o))),this._documents.get(u)?.dispose(),this._documents.set(u,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(a.value.addedEditors)for(const g of a.value.addedEditors){if(this._editors.has(g.id))return;const t=T.URI.revive(g.documentUri),u=this._documents.get(t);u&&this._createExtHostEditor(u,g.id,g)}const s=[];if(a.value.removedEditors)for(const g of a.value.removedEditors){const t=this._editors.get(g);t&&(this._editors.delete(g),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),s.push(t))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const g=new Set;this._visibleNotebookEditors.forEach(t=>g.add(t.id));for(const t of this._editors.values()){const u=g.has(t.id);t._acceptVisibility(u)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=A,A._notebookStatusBarItemProviderHandlePool=0}),define(me[246],ge([0,1,3,76,12,5,14,15]),function(J,e,m,L,k,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(I,c){const f=y._Keys.nextId();I.$registerNotebookEditorDecorationType(f,S.NotebookDecorationRenderOptions.from(c)),this.value={key:f,dispose(){I.$removeNotebookEditorDecorationType(f)}}}}y._Keys=new L.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(I,c,f){this._logService=I,this._extHostRpc=c,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new y(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,c){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,c);const f=this._notebooksAndEditors.getEditorById(I);c.visibleRanges&&f._acceptVisibleRanges(c.visibleRanges.ranges.map(S.NotebookRange.to)),c.selections&&f._acceptSelections(c.selections.selections.map(S.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const c in I)this._notebooksAndEditors.getEditorById(c)._acceptViewColumn(S.ViewColumn.to(I[c]))}};T=Ve([$e(0,k.ILogService),$e(1,R.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(me[247],ge([0,1,17,18,21,3,6,24,2,26,12,5,40,15,7,88,213,35,55]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let a=class{constructor(r,i,o,l,d){this._initData=i,this._extHostNotebook=o,this._commands=l,this._logService=d,this._activeExecutions=new S.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(I.MainContext.MainThreadNotebookKernels);const b=new c.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.ApiCommandArgument("options","Select kernel options",_=>!0,_=>{if(_&&"notebookEditor"in _&&"id"in _){const v=this._extHostNotebook.getIdByEditor(_.notebookEditor);return{id:_.id,extension:_.extension,notebookEditorId:v}}else if(_&&"notebookEditor"in _){const v=this._extHostNotebook.getIdByEditor(_.notebookEditor);if(v===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${_.notebookEditor.document.uri.toString()}`);return{notebookEditorId:v}}return _})],c.ApiCommandResult.Void);this._commands.registerApiCommand(b)}createNotebookController(r,i,o,l,d,b){for(let H of this._kernelData.values())if(H.controller.id===i&&T.ExtensionIdentifier.equals(r.identifier,H.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const _=this._handlePool++,v=this;this._logService.trace(`NotebookController[${_}], CREATED by ${r.identifier.value}, ${i}`);const P=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${r.identifier}'`);let w=!1;const F=new R.DisposableStore,M=new C.Emitter,K=new C.Emitter,G={id:`${r.identifier.value}/${i}`,notebookType:o,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:l||r.identifier.value,preloads:b?b.map(f.NotebookRendererScript.from):[]};let N=d??P,z;this._proxy.$addKernel(_,G).catch(H=>{console.log(H),w=!0});let O=0;const x=()=>{if(w)return;const H=++O;Promise.resolve().then(()=>{H===O&&this._proxy.$updateKernel(_,G)})},B=new S.ResourceMap,U={get id(){return i},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return G.label},set label(H){G.label=H??r.displayName??r.name,x()},get detail(){return G.detail??""},set detail(H){G.detail=H,x()},get description(){return G.description??""},set description(H){G.description=H,x()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(H){G.supportedLanguages=H,x()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(H){G.supportsExecutionOrder=H,x()},get rendererScripts(){return G.preloads?G.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return N},set executeHandler(H){N=H??P},get interruptHandler(){return z},set interruptHandler(H){z=H,G.supportsInterrupt=Boolean(H),x()},createNotebookCellExecution(H){if(w)throw new Error("notebook controller is DISPOSED");if(!B.has(H.notebook.uri))throw v._logService.trace(`NotebookController[${_}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(B.keys()).map(W=>W.toString())),new Error(`notebook controller is NOT associated to notebook: ${H.notebook.uri.toString()}`);return v._createNotebookCellExecution(H)},dispose:()=>{w||(this._logService.trace(`NotebookController[${_}], DISPOSED`),w=!0,this._kernelData.delete(_),F.dispose(),M.dispose(),K.dispose(),this._proxy.$removeKernel(_))},updateNotebookAffinity(H,W){v._proxy.$updateNotebookPriority(_,H.uri,W)},onDidReceiveMessage:K.event,postMessage(H,W){return(0,A.checkProposedApiEnabled)(r),v._proxy.$postMessage(_,W&&v._extHostNotebook.getIdByEditor(W),H)},asWebviewUri(H){return(0,A.checkProposedApiEnabled)(r),(0,p.asWebviewUri)(H,v._initData.remote)}};return this._kernelData.set(_,{extensionId:r.identifier,controller:U,onDidReceiveMessage:K,onDidChangeSelection:M,associatedNotebooks:B}),U}$acceptNotebookAssociation(r,i,o){const l=this._kernelData.get(r);if(l){const d=this._extHostNotebook.getNotebookDocument(y.URI.revive(i));o?l.associatedNotebooks.set(d.uri,!0):l.associatedNotebooks.delete(d.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,d.uri.toString(),o),l.onDidChangeSelection.fire({selected:o,notebook:d.apiNotebook})}}async $executeCells(r,i,o){const l=this._kernelData.get(r);if(!l)return;const d=this._extHostNotebook.getNotebookDocument(y.URI.revive(i)),b=[];for(let _ of o){const v=d.getCell(_);v&&b.push(v.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,d.uri.toString(),b.length),await l.controller.executeHandler.call(l.controller,b,d.apiNotebook,l.controller)}catch(_){this._logService.error(`NotebookController[${r}] execute cells FAILED`,_),console.error(_)}}async $cancelCells(r,i,o){const l=this._kernelData.get(r);if(!l)return;const d=this._extHostNotebook.getNotebookDocument(y.URI.revive(i));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,d.apiNotebook);else for(let b of o){const _=d.getCell(b);_&&this._activeExecutions.get(_.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,i,o){const l=this._kernelData.get(r);if(!l)return;const d=this._extHostNotebook.getEditorById(i);l.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:o}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const l=new g(o.notebook,o,this._proxy);this._activeExecutions.set(o.uri,l);const d=l.onDidChangeState(()=>{l.state===s.Resolved&&(l.dispose(),d.dispose(),this._activeExecutions.delete(o.uri))});return l.asApiObject()}};a=Ve([$e(4,n.ILogService)],a),e.ExtHostNotebookKernels=a;var s;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(s||(s={}));class g extends R.Disposable{constructor(r,i,o){super();this._document=r,this._cell=i,this._proxy=o,this._handle=g.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=s.Init,this._tokenSource=this._register(new k.CancellationTokenSource),this._collector=new t(10,l=>this.update(l)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const i=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new E.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===s.Init)throw new Error("Must call start before modifying cell output");if(this._state===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let i=this._cell;if(r&&(i=this._document.getCellFromApiCell(r)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(r){return r.map(i=>{const o=h.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return o===i.items?f.NotebookCellOutput.from(i):f.NotebookCellOutput.from({items:o,id:i.id,metadata:i.metadata})})}async updateOutputs(r,i,o){const l=this.cellIndexToHandle(i),d=this.validateAndConvertOutputs((0,m.asArray)(r));return this.updateSoon({editType:D.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:l,append:o,outputs:d})}async updateOutputItems(r,i,o){return r=h.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(r),!0),this.updateSoon({editType:D.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(f.NotebookCellOutputItem.from),outputId:i.id,append:o})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(o){r._executionOrder=o,r.update([{editType:D.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(o){if(r._state===s.Resolved||r._state===s.Started)throw new Error("Cannot call start again");r._state=s.Started,r._onDidChangeState.fire(),r.update({editType:D.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:o})},end(o,l){if(r._state===s.Resolved)throw new Error("Cannot call resolve twice");r._state=s.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:D.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:l,lastRunSuccess:o}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(o){return r.verifyStateForOutput(),r.updateOutputs([],o,!1)},appendOutput(o,l){return r.verifyStateForOutput(),r.updateOutputs(o,l,!0)},replaceOutput(o,l){return r.verifyStateForOutput(),r.updateOutputs(o,l,!1)},appendOutputItems(o,l){return r.verifyStateForOutput(),r.updateOutputItems(o,l,!0)},replaceOutputItems(o,l){return r.verifyStateForOutput(),r.updateOutputItems(o,l,!1)}})}}g.HANDLE=0;class t{constructor(r,i){this.delay=r,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>r.complete())}}}),define(me[248],ge([0,1,3,5,129]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class C{constructor(S,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,y,T){const n=this._extHostNotebook.getEditorById(S);this._rendererMessageEmitters.get(y)?.fire({editor:n.apiEditor,message:T})}createRendererMessaging(S,y){if(!S.contributes?.notebookRenderer?.some(c=>c.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);const T=!!S.enableProposedApi,n=new WeakMap;return{onDidReceiveMessage:(c,f,h)=>{const p=T?c:D=>{const A={};n.set(A,D.editor),c({editor:A,message:D.message})};return this.getOrCreateEmitterFor(y).event(p,f,h)},postMessage:(c,f)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(c)&&([c,f]=[f,c]);const h=T?f:n.get(f),p=h&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(h);return this.proxy.$postMessage(p?.id,y,c)}}}getOrCreateEmitterFor(S){let y=this._rendererMessageEmitters.get(S);return y||(y=new m.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,y),y)}}e.ExtHostNotebookRenderers=C}),define(me[68],ge([0,1,5,3,6,22,4,14]),function(J,e,m,L,k,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends k.Disposable{constructor(h,p,D,A,E){super();this._onDidAppend=this._register(new L.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=h,this._proxy=E,this._id=E.$register(this.name,p,D,A),this._disposed=!1,this._offset=0}get name(){return this._name}append(h){this.validate(),this._offset+=h?C.VSBuffer.fromString(h).byteLength:0}update(){this._id.then(h=>this._proxy.$update(h))}appendLine(h){this.validate(),this.append(h+`
`)}clear(){this.validate();const h=this._offset;this._id.then(p=>this._proxy.$clear(p,h))}show(h,p){this.validate(),this._id.then(D=>this._proxy.$reveal(D,!!(typeof h=="boolean"?h:p)))}hide(){this.validate(),this._id.then(h=>this._proxy.$close(h))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(h=>this._proxy.$dispose(h)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class T extends y{constructor(h,p,D){super(h,!1,void 0,p,D)}append(h){super.append(h),this._id.then(p=>this._proxy.$append(p,h)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=T;class n extends y{constructor(h,p,D){super(h,!0,p,void 0,D)}append(h){throw new Error("Not supported")}}class I{constructor(h,p){this.name=h,this._channel=p}append(h){this._channel.then(p=>p.append(h))}appendLine(h){this._channel.then(p=>p.appendLine(h))}clear(){this._channel.then(h=>h.clear())}show(h,p){this._channel.then(D=>D.show(h,p))}hide(){this._channel.then(h=>h.hide())}dispose(){this._channel.then(h=>h.dispose())}}e.LazyOutputChannel=I;let c=class{constructor(h){this._proxy=h.getProxy(m.MainContext.MainThreadOutputService)}$setVisibleChannel(h){}createOutputChannel(h,p){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");return new T(h,p.identifier.value,this._proxy)}createOutputChannelFromLogFile(h,p){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");if(!p)throw new Error("illegal argument `file`. must not be falsy");return new n(h,p,this._proxy)}};c=Ve([$e(0,S.IExtHostRpcService)],c),e.ExtHostOutputService=c,e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(me[249],ge([0,1,18,21,3,6,5,2,7,16,17,49,64]),function(J,e,m,L,k,C,R,S,y,T,n,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(h,p,D){const A=h.getProxy(R.MainContext.MainThreadQuickOpen);class E{constructor(l,d){this._sessions=new Map,this._instances=0,this._workspace=l,this._commands=d}showQuickPick(l,d,b,_=L.CancellationToken.None){this._onDidSelectItem=void 0;const v=Promise.resolve(l),P=++this._instances,w=A.$show(P,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},_),F={},M=w.then(()=>F);return Promise.race([M,v]).then(K=>{if(K!==F)return v.then(G=>{const N=[];for(let z=0;z<G.length;z++){const O=G[z];let x,B,U,H,W;typeof O=="string"?x=O:(x=O.label,B=O.description,U=O.detail,H=O.picked,W=O.alwaysShow),N.push({label:x,description:B,handle:z,detail:U,picked:H,alwaysShow:W})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{b.onDidSelectItem(G[z])}),A.$setItems(P,N),w.then(z=>{if(typeof z=="number")return G[z];if(Array.isArray(z))return z.map(O=>G[O])})})}).then(void 0,K=>{if(!(0,T.isPromiseCanceledError)(K))return A.$setError(P,K),Promise.reject(K)})}$onItemSelected(l){this._onDidSelectItem&&this._onDidSelectItem(l)}showInput(l,d=L.CancellationToken.None){return this._validateInput=l?l.validateInput:void 0,A.$input(l,typeof this._validateInput=="function",d).then(void 0,b=>{if(!(0,T.isPromiseCanceledError)(b))return Promise.reject(b)})}$validateInput(l){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(l)):Promise.resolve(void 0)}async showWorkspaceFolderPick(l,d=L.CancellationToken.None){const b=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!b)return;const _=await this._workspace.getWorkspaceFolders2();if(!!_)return _.find(v=>v.uri.toString()===b.uri.toString())}createQuickPick(l,d){const b=new r(l,d,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(l){const d=new i(l,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(l,d){const b=this._sessions.get(l);b&&b._fireDidChangeValue(d)}$onDidAccept(l){const d=this._sessions.get(l);d&&d._fireDidAccept()}$onDidChangeActive(l,d){const b=this._sessions.get(l);b instanceof r&&b._fireDidChangeActive(d)}$onDidChangeSelection(l,d){const b=this._sessions.get(l);b instanceof r&&b._fireDidChangeSelection(d)}$onDidTriggerButton(l,d){const b=this._sessions.get(l);b&&b._fireDidTriggerButton(d)}$onDidTriggerItemButton(l,d,b){const _=this._sessions.get(l);_ instanceof r&&_._fireDidTriggerItemButton(d,b)}$onDidHide(l){const d=this._sessions.get(l);d&&d._fireDidHide()}}class a{constructor(l,d){this._extensionId=l,this._onDidDispose=d,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(l){this._title=l,this.update({title:l})}get step(){return this._steps}set step(l){this._steps=l,this.update({step:l})}get totalSteps(){return this._totalSteps}set totalSteps(l){this._totalSteps=l,this.update({totalSteps:l})}get enabled(){return this._enabled}set enabled(l){this._enabled=l,this.update({enabled:l})}get busy(){return this._busy}set busy(l){this._busy=l,this.update({busy:l})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(l){this._ignoreFocusOut=l,this.update({ignoreFocusOut:l})}get value(){return this._value}set value(l){this._value=l,this.update({value:l})}get placeholder(){return this._placeholder}set placeholder(l){this._placeholder=l,this.update({placeholder:l})}get buttons(){return this._buttons}set buttons(l){this._buttons=l.slice(),this._handlesToButtons.clear(),l.forEach((d,b)=>{const _=d===y.QuickInputButtons.Back?-1:b;this._handlesToButtons.set(_,d)}),this.update({buttons:l.map((d,b)=>({...u(d),tooltip:d.tooltip,handle:d===y.QuickInputButtons.Back?-1:b}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(l){this._value=l,this._onDidChangeValueEmitter.fire(l)}_fireDidTriggerButton(l){const d=this._handlesToButtons.get(l);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),A.$dispose(this._id))}update(l){if(!this._disposed){for(const d of Object.keys(l)){const b=l[d];this._pendingUpdate[d]=b===void 0?null:b}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){A.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}a._nextId=1;function s(o){if(o instanceof y.ThemeIcon)return{id:o.id};const l=t(o),d=g(o);return{dark:typeof l=="string"?S.URI.file(l):l,light:typeof d=="string"?S.URI.file(d):d}}function g(o){return typeof o=="object"&&"light"in o?o.light:o}function t(o){return typeof o=="object"&&"dark"in o?o.dark:o}function u(o){const l=s(o.iconPath);let d,b;return"id"in l?b=c.ThemeIcon.asClassName(l):d=l,{iconPath:d,iconClass:b}}class r extends a{constructor(l,d,b){super(l,b);this.enableProposedApi=d,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this._onDidTriggerItemButtonEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(l){this._items=l.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),l.forEach((d,b)=>{this._handlesToItems.set(b,d),this._itemsToHandles.set(d,b)}),this.update({items:l.map((d,b)=>({label:d.label,description:d.description,handle:b,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,buttons:d.buttons&&this.enableProposedApi?d.buttons.map((_,v)=>({...u(_),tooltip:_.tooltip,handle:v})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(l){this._canSelectMany=l,this.update({canSelectMany:l})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(l){this._matchOnDescription=l,this.update({matchOnDescription:l})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(l){this._matchOnDetail=l,this.update({matchOnDetail:l})}get sortByLabel(){return this._sortByLabel}set sortByLabel(l){this._sortByLabel=l,this.update({sortByLabel:l})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(l){this._keepScrollPosition=l,this.update({keepScrollPosition:l})}get activeItems(){return this._activeItems}set activeItems(l){this._activeItems=l.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(l){this._selectedItems=l.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(l){const d=(0,n.coalesce)(l.map(b=>this._handlesToItems.get(b)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(l){const d=(0,n.coalesce)(l.map(b=>this._handlesToItems.get(b)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(l,d){const b=this._handlesToItems.get(l);if(!b||!b.buttons||!b.buttons.length)return;const _=b.buttons[d];_&&this._onDidTriggerItemButtonEmitter.fire({button:_,item:b})}}class i extends a{constructor(l,d){super(l,d);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(l){this._password=l,this.update({password:l})}get prompt(){return this._prompt}set prompt(l){this._prompt=l,this.update({prompt:l})}get validationMessage(){return this._validationMessage}set validationMessage(l){this._validationMessage=l,this.update({validationMessage:l,severity:l?I.default.Error:I.default.Ignore})}}return new E(p,D)}e.createExtHostQuickOpen=f}),define(me[250],ge([0,1,2,3,59,6,18,5,17,100,12,26,35,64,15]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function p(l){if(l)return typeof l.iconPath=="string"?m.URI.file(l.iconPath):m.URI.isUri(l.iconPath)||f.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function D(l,d){if(!l.iconPath&&!d.iconPath)return 0;if(l.iconPath){if(!d.iconPath)return 1}else return-1;const b=typeof l.iconPath=="string"?l.iconPath:m.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,_=typeof d.iconPath=="string"?d.iconPath:m.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,T.comparePaths)(b,_)}function A(l,d){let b=0;if(l.strikeThrough!==d.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==d.faded)return l.faded?1:-1;if(l.tooltip!==d.tooltip)return(l.tooltip||"").localeCompare(d.tooltip||"");if(b=D(l,d),b!==0)return b;if(l.light&&d.light)b=D(l.light,d.light);else{if(l.light)return 1;if(d.light)return-1}if(b!==0)return b;if(l.dark&&d.dark)b=D(l.dark,d.dark);else{if(l.dark)return 1;if(d.dark)return-1}return b}function E(l,d){if(l.command!==d.command)return l.command<d.command?-1:1;if(l.title!==d.title)return l.title<d.title?-1:1;if(l.tooltip!==d.tooltip){if(l.tooltip!==void 0&&d.tooltip!==void 0)return l.tooltip<d.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(l.arguments===d.arguments)return 0;if(l.arguments)if(d.arguments){if(l.arguments.length!==d.arguments.length)return l.arguments.length-d.arguments.length}else return 1;else return-1;for(let b=0;b<l.arguments.length;b++){const _=l.arguments[b],v=d.arguments[b];if(_!==v)return _<v?-1:1}return 0}function a(l,d){let b=(0,T.comparePaths)(l.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(b!==0)return b;if(l.command&&d.command)b=E(l.command,d.command);else{if(l.command)return 1;if(d.command)return-1}if(b!==0)return b;if(l.decorations&&d.decorations)b=A(l.decorations,d.decorations);else{if(l.decorations)return 1;if(d.decorations)return-1}return b}function s(l,d){for(let b=0;b<l.length;b++)if(l[b]!==d[b])return!1;return!0}function g(l,d){return l.command===d.command&&l.title===d.title&&l.tooltip===d.tooltip&&(l.arguments&&d.arguments?s(l.arguments,d.arguments):l.arguments===d.arguments)}function t(l,d){return(0,y.equals)(l,d,g)}class u{constructor(d,b,_){this._extension=d,this._proxy=b,this._sourceControlHandle=_,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(d){this._proxy.$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,c.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(d){if((0,c.checkProposedApiEnabled)(this._extension),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,d))}focus(){(0,c.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(d,b){(0,c.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,d,b)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=u;class r{constructor(d,b,_,v,P){this._proxy=d,this._commands=b,this._sourceControlHandle=_,this._id=v,this._label=P,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,b){const _=this._resourceStatesCommandsMap.get(d);return _?(0,R.asPromise)(()=>this._commands.executeCommand(_.command,..._.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(a),_=(0,y.sortedDiff)(this._resourceSnapshot,d,a).map(w=>{const F=w.toInsert.map(M=>{const K=this._resourceHandlePool++;this._resourceStatesMap.set(K,M);const G=M.resourceUri;let N;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const he=new C.DisposableStore;N=this._commands.converter.toInternal(M.command,he),this._resourceStatesDisposablesMap.set(K,he)}else this._resourceStatesCommandsMap.set(K,M.command);const z=p(M.decorations),O=M.decorations&&p(M.decorations.light)||z,x=M.decorations&&p(M.decorations.dark)||z,B=[O,x],U=M.decorations&&M.decorations.tooltip||"",H=M.decorations&&!!M.decorations.strikeThrough,W=M.decorations&&!!M.decorations.faded,Q=M.contextValue||"";return{rawResource:[K,G,B,U,H,W,Q,N],handle:K}});return{start:w.start,deleteCount:w.deleteCount,toInsert:F}}),v=_.map(({start:w,deleteCount:F,toInsert:M})=>[w,F,M.map(K=>K.rawResource)]),P=_.reverse();for(const{start:w,deleteCount:F,toInsert:M}of P){const K=M.map(N=>N.handle),G=this._handlesSnapshot.splice(w,F,...K);for(const N of G)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=d,v}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class i{constructor(d,b,_,v,P,w){this._proxy=b,this._commands=_,this._id=v,this._label=P,this._rootUri=w,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new u(d,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,v,P,w)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,this._proxy.$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,this._proxy.$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=d;const b=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:b})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&t(this._statusBarCommands,d))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=d;const b=(d||[]).map(_=>this._commands.converter.toInternal(_,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(d,b){const _=new r(this._proxy,this._commands,this.handle,d,b),v=L.Event.once(_.onDidDispose)(()=>this.createdResourceGroups.delete(_));return this.createdResourceGroups.set(_,v),this.eventuallyAddResourceGroups(),_}eventuallyAddResourceGroups(){const d=[],b=[];for(const[_,v]of this.createdResourceGroups){v.dispose();const P=_.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(_),this.eventuallyUpdateResourceStates()});L.Event.once(_.onDidDispose)(()=>{this.updatedResourceGroups.delete(_),P.dispose(),this._groups.delete(_.handle),this._proxy.$unregisterGroup(this.handle,_.handle)}),d.push([_.handle,_.id,_.label,_.features]);const w=_._takeResourceStateSnapshot();w.length>0&&b.push([_.handle,w]),this._groups.set(_.handle,_)}this._proxy.$registerGroups(this.handle,d,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(b=>{const _=b._takeResourceStateSnapshot();_.length!==0&&d.push([b.handle,_])}),d.length>0&&this._proxy.$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ve([(0,k.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),Ve([(0,k.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let o=class Bn{constructor(d,b,_){this._commands=b,this.logService=_,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=d.getProxy(S.MainContext.MainThreadSCM),this._telemetry=d.getProxy(S.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===3){const P=this._sourceControls.get(v.sourceControlHandle);if(!P)return v;const w=P.getResourceGroup(v.groupHandle);return w?w.getResourceState(v.handle):v}else if(v&&v.$mid===4){const P=this._sourceControls.get(v.sourceControlHandle);return P?P.getResourceGroup(v.groupHandle):v}else if(v&&v.$mid===5){const P=this._sourceControls.get(v.handle);return P||v}return v}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(d,b,_,v){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,b,_,v),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const P=Bn._handlePool++,w=new i(d,this._proxy,this._commands,b,_,v);this._sourceControls.set(P,w);const F=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(d.identifier))||[];return F.push(w),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(d.identifier),F),w}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const b=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(d.identifier)),_=b&&b[b.length-1];return _&&_.inputBox}$provideOriginalResource(d,b,_){const v=m.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,v.toString());const P=this._sourceControls.get(d);return!P||!P.quickDiffProvider||!P.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>P.quickDiffProvider.provideOriginalResource(v,_)).then(w=>w||null)}$onInputBoxValueChange(d,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const _=this._sourceControls.get(d);return _&&_.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(d,b,_,v){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,b,_);const P=this._sourceControls.get(d);if(!P)return Promise.resolve(void 0);const w=P.getResourceGroup(b);return w?w.$executeResourceCommand(_,v):Promise.resolve(void 0)}$validateInput(d,b,_){this.logService.trace("ExtHostSCM#$validateInput",d);const v=this._sourceControls.get(d);return!v||!v.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>v.inputBox.validateInput(b,_)).then(P=>{if(!P)return Promise.resolve(void 0);const w=h.MarkdownString.fromStrict(P.message);return w?Promise.resolve([w,P.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};o._handlePool=0,o=Ve([$e(2,n.ILogService)],o),e.ExtHostSCM=o});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[251],ge([0,1,7,5,167,6,15]),function(J,e,m,L,k,C,R){"use strict";var S,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class T{constructor(f,h,p,D,A=m.StatusBarAlignment.Left,E){S.set(this,void 0),y.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,nt(this,S,f,"f"),nt(this,y,h,"f"),this._entryId=T.ID_GEN++,this._extension=p,this._id=D,this._alignment=A,this._priority=E}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!T.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Oe(this,y,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Oe(this,y,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let h;this._name?h=this._name:h=(0,k.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=T.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const D=this._tooltip?R.MarkdownString.fromStrict(this._tooltip):void 0;Oe(this,S,"f").$setEntry(this._entryId,f,h,this._text,D,this._command?.internal,p,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=T,S=new WeakMap,y=new WeakMap,T.ID_GEN=0,T.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new m.ThemeColor("statusBarItem.warningForeground")]]);class n{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,k.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const h={message:f};return this._messages.unshift(h),this._update(),new m.Disposable(()=>{const p=this._messages.indexOf(h);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(f,h){this._proxy=f.getProxy(L.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new n(this)}createStatusBarEntry(f,h,p,D){return new T(this._proxy,this._commands,f,h,p,D)}setStatusBarMessage(f,h){const p=this._statusMessage.setMessage(f);let D;return typeof h=="number"?D=setTimeout(()=>p.dispose(),h):typeof h!="undefined"&&h.then(()=>p.dispose(),()=>p.dispose()),new m.Disposable(()=>{p.dispose(),clearTimeout(D)})}}e.ExtHostStatusBar=I}),define(me[92],ge([0,1,5,3,4]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(S){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=S.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(S,y){this._proxy.$registerExtensionStorageKeysToSync(S,y)}getValue(S,y,T){return this._proxy.$getValue(S,y).then(n=>n||T)}setValue(S,y,T){return this._proxy.$setValue(S,y,T)}$acceptValue(S,y,T){this._onDidChangeStorage.fire({shared:S,key:y,value:T})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(me[69],ge([0,1,4,27,12,91,2]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let S=class{constructor(T,n,I){this._logService=n,this._extHostFileSystem=I,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(T){return R.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,n=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(T){if(this._value)return R.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return R.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};S=Ve([$e(0,L.IExtHostInitDataService),$e(1,k.ILogService),$e(2,C.IExtHostConsumerFileSystem)],S),e.ExtensionStoragePaths=S}),define(me[33],ge([0,1,3,5,4,2,14,6,7,168,16,215,21,32,196,64,13]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class A{constructor(o,l,d,b){this._proxy=o,this._id=l,this._creationOptions=d,this._name=b,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(v=>this._pidPromiseComplete=v);const _=this;this.value={get name(){return _._name||""},get processId(){return _._pidPromise},get creationOptions(){return _._creationOptions},get exitStatus(){return _._exitStatus},get state(){return _._state},sendText(v,P=!0){_._checkDisposed(),_._proxy.$sendText(_._id,v,P)},show(v){_._checkDisposed(),_._proxy.$show(_._id,v)},hide(){_._checkDisposed(),_._proxy.$hide(_._id)},dispose(){_._disposed||(_._disposed=!0,_._proxy.$dispose(_._id))},get dimensions(){if(!(_._cols===void 0||_._rows===void 0))return{columns:_._cols,rows:_._rows}}}}async create(o,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:o.name,shellPath:(0,D.withNullAsUndefined)(o.shellPath),shellArgs:(0,D.withNullAsUndefined)(o.shellArgs),cwd:(0,D.withNullAsUndefined)(o.cwd),env:(0,D.withNullAsUndefined)(o.env),icon:(0,D.withNullAsUndefined)(u(o.iconPath)),color:p.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:(0,D.withNullAsUndefined)(o.message),strictEnv:(0,D.withNullAsUndefined)(o.strictEnv),hideFromUser:(0,D.withNullAsUndefined)(o.hideFromUser),isFeatureTerminal:(0,D.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,D.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this._serializeParentTerminal(o.location,l?.resolvedExtHostIdentifier)})}async createExtensionTerminal(o,l,d,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:d,color:p.ThemeColor.isThemeColor(b)?b.id:void 0,location:this._serializeParentTerminal(o,l)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(o,l){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in o?{viewColumn:o.viewColumn,preserveFocus:o.preserveFocus}:void 0:o}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(o){this._name=o}setExitCode(o){this._exitStatus=Object.freeze({code:o})}setDimensions(o,l){return o===this._cols&&l===this._rows||o===0||l===0?!1:(this._cols=o,this._rows=l,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(o){this._pidPromiseComplete?(this._pidPromiseComplete(o),this._pidPromiseComplete=void 0):this._pidPromise.then(l=>{l!==o&&(this._pidPromise=Promise.resolve(o))})}}e.ExtHostTerminal=A;class E{constructor(o){this._pty=o,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new m.Emitter,this._onProcessTitleChanged=new m.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new m.Emitter,this._onProcessShellTypeChanged=new m.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new m.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(o){return Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(o){this._pty.handleInput&&this._pty.handleInput(o)}resize(o,l){this._pty.setDimensions&&this._pty.setDimensions({columns:o,rows:l})}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(o){this._pty.onDidWrite(l=>this._onProcessData.fire(l)),this._pty.onDidClose&&this._pty.onDidClose((l=void 0)=>{this._onProcessExit.fire(l===void 0?void 0:l)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(l=>this._onProcessOverrideDimensions.fire(l&&{cols:l.columns,rows:l.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(l=>this._onProcessTitleChanged.fire(l)),this._pty.open(o||void 0),this._pty.setDimensions&&o&&this._pty.setDimensions(o),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=E;let a=1,s=class extends S.Disposable{constructor(o,l){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new m.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new m.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new m.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new m.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=l.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new h.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(o),this._register({dispose:()=>{for(const[d,b]of this._terminalProcesses)b.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(o=>o.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(o,l){const d=new A(this._proxy,(0,f.generateUuid)(),o,o.name),b=new E(o.pty);return d.createExtensionTerminal(o.location,this._serializeParentTerminal(o,l).resolvedExtHostIdentifier,u(o.iconPath),r(o.color)).then(_=>{const v=this._setupExtHostProcessListeners(_,b);this._terminalProcessDisposables[_]=v}),this._terminals.push(d),d.value}_serializeParentTerminal(o,l){if(l=l||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const d=o.location.parentTerminal;if(d){const b=this._terminals.find(_=>_.value===d);b&&(l.resolvedExtHostIdentifier=b._id)}}else o.location&&typeof o.location!="object"?l.location=o.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(o,l){if(!this._getTerminalById(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const b=new E(l),_=this._setupExtHostProcessListeners(o,b);this._terminalProcessDisposables[o]=_}async $acceptActiveTerminalChanged(o){const l=this._activeTerminal;if(o===null){this._activeTerminal=void 0,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const d=this._getTerminalById(o);d&&(this._activeTerminal=d,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(o,l){const d=this._getTerminalById(o);d&&this._onDidWriteTerminalData.fire({terminal:d.value,data:l})}async $acceptTerminalDimensions(o,l,d){const b=this._getTerminalById(o);b&&b.setDimensions(l,d)&&this._onDidChangeTerminalDimensions.fire({terminal:b.value,dimensions:b.value.dimensions})}async $acceptTerminalMaximumDimensions(o,l,d){this._terminalProcesses.get(o)?.resize(l,d)}async $acceptTerminalTitleChange(o,l){const d=this._getTerminalById(o);d&&(d.name=l)}async $acceptTerminalClosed(o,l){const d=this._getTerminalObjectIndexById(this._terminals,o);if(d!==null){const b=this._terminals.splice(d,1)[0];b.setExitCode(l),this._onDidCloseTerminal.fire(b.value)}}$acceptTerminalOpened(o,l,d,b){if(l){const P=this._getTerminalObjectIndexById(this._terminals,l);if(P!==null){this._terminals[P]._id=o,this._onDidOpenTerminal.fire(this.terminals[P]),this._terminals[P].isOpen=!0;return}}const _={name:b.name,shellPath:b.executable,shellArgs:b.args,cwd:typeof b.cwd=="string"?b.cwd:C.URI.revive(b.cwd),env:b.env,hideFromUser:b.hideFromUser},v=new A(this._proxy,o,_,d);this._terminals.push(v),this._onDidOpenTerminal.fire(v.value),v.isOpen=!0}async $acceptTerminalProcessId(o,l){const d=this._getTerminalById(o);d&&d._setProcessId(l)}async $startExtensionTerminal(o,l){const d=this._getTerminalById(o);if(!d)return{message:(0,T.localize)(0,null,o)};d.isOpen||await new Promise(_=>{const v=this.onDidOpenTerminal(async P=>{P===d.value&&(v.dispose(),_())})});const b=this._terminalProcesses.get(o);b?b.startSendingEvents(l):this._extensionTerminalAwaitingStart[o]={initialDimensions:l}}_setupExtHostProcessListeners(o,l){const d=new S.DisposableStore;d.add(l.onProcessReady(_=>this._proxy.$sendProcessReady(o,_.pid,_.cwd))),d.add(l.onProcessTitleChanged(_=>this._proxy.$sendProcessTitle(o,_))),this._bufferer.startBuffering(o,l.onProcessData),d.add(l.onProcessExit(_=>this._onProcessExit(o,_))),l.onProcessOverrideDimensions&&d.add(l.onProcessOverrideDimensions(_=>this._proxy.$sendOverrideDimensions(o,_))),this._terminalProcesses.set(o,l);const b=this._extensionTerminalAwaitingStart[o];return b&&l instanceof E&&(l.startSendingEvents(b.initialDimensions),delete this._extensionTerminalAwaitingStart[o]),d}$acceptProcessAckDataEvent(o,l){this._terminalProcesses.get(o)?.acknowledgeDataEvent(l)}$acceptProcessInput(o,l){this._terminalProcesses.get(o)?.input(l)}$acceptTerminalInteraction(o){const l=this._getTerminalById(o);l?.setInteractedWith()&&this._onDidChangeTerminalState.fire(l.value)}$acceptProcessResize(o,l,d){try{this._terminalProcesses.get(o)?.resize(l,d)}catch(b){if(b.code!=="EPIPE"&&b.code!=="ERR_IPC_CHANNEL_CLOSED")throw b}}$acceptProcessShutdown(o,l){this._terminalProcesses.get(o)?.shutdown(l)}$acceptProcessRequestInitialCwd(o){this._terminalProcesses.get(o)?.getInitialCwd().then(l=>this._proxy.$sendProcessInitialCwd(o,l))}$acceptProcessRequestCwd(o){this._terminalProcesses.get(o)?.getCwd().then(l=>this._proxy.$sendProcessCwd(o,l))}$acceptProcessRequestLatency(o){return o}registerLinkProvider(o){return this._linkProviders.add(o),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(o),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(o,l,d){if(this._profileProviders.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this._profileProviders.set(l,d),this._proxy.$registerProfileProvider(l,o.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(l),this._proxy.$unregisterProfileProvider(l)})}async $createContributedProfileTerminal(o,l){const d=new c.CancellationTokenSource().token,b=await this._profileProviders.get(o)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(!b||!("options"in b))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in b.options){this.createExtensionTerminal(b.options,l);return}this.createTerminalFromOptions(b.options,l)}}async $provideLinks(o,l){const d=this._getTerminalById(o);if(!d)return[];this._terminalLinkCache.delete(o);const b=this._terminalLinkCancellationSource.get(o);b&&b.dispose(!0);const _=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(o,_);const v=[],P={terminal:d.value,line:l},w=[];for(const K of this._linkProviders)w.push(new Promise(async G=>{_.token.onCancellationRequested(()=>G({provider:K,links:[]}));const N=await K.provideTerminalLinks(P,_.token)||[];_.token.isCancellationRequested||G({provider:K,links:N})}));const F=await Promise.all(w);if(_.token.isCancellationRequested)return[];const M=new Map;for(const K of F)K&&K.links.length>0&&v.push(...K.links.map(G=>{const N={id:a++,startIndex:G.startIndex,length:G.length,label:G.tooltip};return M.set(N.id,{provider:K.provider,link:G}),N}));return this._terminalLinkCache.set(o,M),v}$activateLink(o,l){const d=this._terminalLinkCache.get(o)?.get(l);!d||d.provider.handleTerminalLink(d.link)}_onProcessExit(o,l){this._bufferer.stopBuffering(o),this._terminalProcesses.delete(o),delete this._extensionTerminalAwaitingStart[o];const d=this._terminalProcessDisposables[o];d&&(d.dispose(),delete this._terminalProcessDisposables[o]),this._proxy.$sendProcessExit(o,l)}_getTerminalById(o){return this._getTerminalObjectById(this._terminals,o)}_getTerminalObjectById(o,l){const d=this._getTerminalObjectIndexById(o,l);return d!==null?o[d]:null}_getTerminalObjectIndexById(o,l){let d=null;return o.some((b,_)=>b._id===l?(d=_,!0):!1),d}getEnvironmentVariableCollection(o){let l=this._environmentVariableCollections.get(o.identifier.value);return l||(l=new g,this._setEnvironmentVariableCollection(o.identifier.value,l)),l}_syncEnvironmentVariableCollection(o,l){const d=(0,I.serializeEnvironmentVariableCollection)(l.map);this._proxy.$setEnvironmentVariableCollection(o,l.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(o){o.forEach(l=>{const d=l[0],b=new g(l[1]);this._setEnvironmentVariableCollection(d,b)})}$acceptDefaultProfile(o,l){this._defaultProfile=o,this._defaultAutomationProfile=l}_setEnvironmentVariableCollection(o,l){this._environmentVariableCollections.set(o,l),l.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(o,l)})}};s=Ve([$e(1,R.IExtHostRpcService)],s),e.BaseExtHostTerminalService=s;class g{constructor(o){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(o)}get persistent(){return this._persistent}set persistent(o){this._persistent=o,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(o,l){this._setIfDiffers(o,{value:l,type:y.EnvironmentVariableMutatorType.Replace})}append(o,l){this._setIfDiffers(o,{value:l,type:y.EnvironmentVariableMutatorType.Append})}prepend(o,l){this._setIfDiffers(o,{value:l,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(o,l){const d=this.map.get(o);(!d||d.value!==l.value||d.type!==l.type)&&(this.map.set(o,l),this._onDidChangeCollection.fire())}get(o){return this.map.get(o)}forEach(o,l){this.map.forEach((d,b)=>o.call(l,b,d,this))}delete(o){this.map.delete(o),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=g;let t=class extends s{constructor(o){super(!1,o)}createTerminal(o,l,d){throw new n.NotSupportedError}createTerminalFromOptions(o,l){throw new n.NotSupportedError}};t=Ve([$e(0,R.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function u(i){if(!(!i||typeof i=="string"))return"id"in i?{id:i.id,color:i.color}:i}function r(i){return p.ThemeColor.isThemeColor(i)?i:void 0}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[252],ge([0,1,17,22,21,3,75,48,6,25,13,32,5,14,65,15,7,223,127,89]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D,A,E,a){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let g=class{constructor(w,F){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=w.getProxy(c.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new u(this.proxy),F.registerArgumentProcessor({processArgument:M=>M?.$mid===13?p.TestItem.toItemFromContext(M):M})}createTestController(w,F){if(this.controllers.has(w))throw new Error(`Attempt to insert a duplicate controller with ID "${w}"`);const M=new y.DisposableStore,K=M.add(new A.SingleUseTestCollection(w));K.root.label=F;const G=new Map,N=this.proxy,z={items:K.root.children,get label(){return F},set label(x){F=x,K.root.label=x,N.$updateControllerLabel(w,F)},get id(){return w},createRunProfile:(x,B,U,H,W)=>{let Q=(0,S.hash)(x);for(;G.has(Q);)Q++;const Y=new _(this.proxy,w,Q,x,B,U,H,W);return G.set(Q,Y),Y},createTestItem(x,B,U){return new h.TestItemImpl(w,x,B,U)},createTestRun:(x,B,U=!0)=>this.runTracker.createTestRun(w,K,x,B,U),set resolveHandler(x){K.resolveHandler=x},get resolveHandler(){return K.resolveHandler},dispose:()=>{M.dispose()}};z.createRunConfiguration=z.createRunProfile,N.$registerTestController(w,F),M.add((0,y.toDisposable)(()=>N.$unregisterTestController(w)));const O={controller:z,collection:K,profiles:G};return this.controllers.set(w,O),M.add((0,y.toDisposable)(()=>this.controllers.delete(w))),M.add(K.onDidGenerateDiff(x=>N.$publishDiff(w,x))),z}createTestObserver(){return this.observer.checkout()}async runTests(w,F=k.CancellationToken.None){const M=r(w);if(!M)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const K=this.controllers.get(M.controllerId);if(!K)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:w.include?.map(G=>G.id)??[K.collection.root.id],profileGroup:v[M.kind],profileId:M.profileId,controllerId:M.controllerId}],exclude:w.exclude?.map(G=>G.id)},F)}$provideFileCoverage(w,F,M){return(0,m.mapFind)(this.runTracker.trackers,G=>G.id===w?G.getCoverage(F):void 0)?.provideFileCoverage(M)??Promise.resolve([])}$resolveFileCoverage(w,F,M,K){return(0,m.mapFind)(this.runTracker.trackers,N=>N.id===w?N.getCoverage(F):void 0)?.resolveFileCoverage(M,K)??Promise.resolve([])}$configureRunProfile(w,F){this.controllers.get(w)?.profiles.get(F)?.configureHandler?.()}$publishTestResults(w){this.results=Object.freeze(w.map(F=>(0,T.deepFreeze)(p.TestResults.to(F))).concat(this.results).sort((F,M)=>M.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(w,F){const M=this.controllers.get(a.TestId.fromString(w).controllerId)?.collection;M&&(await M.expand(w,F<0?Infinity:F),M.flushDiff())}$acceptDiff(w){this.observer.applyDiff(w)}async $runControllerTests(w,F){const M=this.controllers.get(w.controllerId);if(!M)return;const{collection:K,profiles:G}=M,N=G.get(w.profileId);if(!N)return;const z=w.testIds.map(U=>K.tree.get(U)).filter(n.isDefined),O=w.excludeExtIds.map(U=>M.collection.tree.get(U)).filter(n.isDefined).filter(U=>z.some(H=>H.fullId.compare(U.fullId)===2));if(!z.length)return;const x=new D.TestRunRequest(z.some(U=>U.actual instanceof h.TestItemRootImpl)?void 0:z.map(U=>U.actual),O.map(U=>U.actual),N),B=this.runTracker.prepareForMainThreadTestRun(x,i.fromInternal(w,M.collection),F);try{await N.runHandler(x,F)}finally{B.isRunning&&!F.isCancellationRequested&&await C.Event.toPromise(B.onEnd),B.dispose()}}$cancelExtensionTestRun(w){w===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(w)}};g=Ve([$e(0,f.IExtHostRpcService)],g),e.ExtHostTesting=g;class t extends y.Disposable{constructor(w,F,M){super();this.dto=w,this.proxy=F,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new k.CancellationTokenSource(M)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:K}of this.tasks.values())K.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(w){return this.tasks.get(w)?.coverage}createRun(w){const F=this.dto.id,M=this.dto.controllerId,K=(0,I.generateUuid)(),G=new o(this.proxy,F,K),N=B=>(U,...H)=>{if(O){console.warn(`Setting the state of test "${U.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(U)||(this.ensureTestIsKnown(U),B(U,...H))},z=(B,U)=>{const H=U instanceof Array?U.map(p.TestMessage.from):[p.TestMessage.from(U)];if(B.uri&&B.range){const W={range:p.Range.from(B.range),uri:B.uri};for(const Q of H)Q.location=Q.location||W}this.proxy.$appendTestMessagesInRun(F,K,a.TestId.fromExtHostTestItem(B,M).toString(),H)};let O=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:w,get coverageProvider(){return G.coverageProvider},set coverageProvider(B){G.coverageProvider=B},enqueued:N(B=>{this.proxy.$updateTestStateInRun(F,K,a.TestId.fromExtHostTestItem(B,M).toString(),1)}),skipped:N(B=>{this.proxy.$updateTestStateInRun(F,K,a.TestId.fromExtHostTestItem(B,M).toString(),5)}),started:N(B=>{this.proxy.$updateTestStateInRun(F,K,a.TestId.fromExtHostTestItem(B,M).toString(),2)}),errored:N((B,U,H)=>{z(B,U),this.proxy.$updateTestStateInRun(F,K,a.TestId.fromExtHostTestItem(B,M).toString(),6,H)}),failed:N((B,U,H)=>{z(B,U),this.proxy.$updateTestStateInRun(F,K,a.TestId.fromExtHostTestItem(B,M).toString(),4,H)}),passed:N((B,U)=>{this.proxy.$updateTestStateInRun(F,K,a.TestId.fromExtHostTestItem(B,this.dto.controllerId).toString(),3,U)}),appendOutput:(B,U,H)=>{O||(H&&(this.dto.isIncluded(H)?this.ensureTestIsKnown(H):H=void 0),this.proxy.$appendOutputToRun(F,K,L.VSBuffer.fromString(B),U&&p.location.from(U),H&&a.TestId.fromExtHostTestItem(H,M).toString()))},end:()=>{O||(O=!0,this.proxy.$finishedTestRunTask(F,K),this.tasks.delete(K),this.isRunning||this.dispose())}};return this.tasks.set(K,{run:x,coverage:G}),this.proxy.$startedTestRunTask(F,{id:K,name:w,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(w){if(!(w instanceof h.TestItemImpl))throw new h.InvalidTestItemError(w.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(w,this.dto.controllerId).toString()))return;const F=[],M=this.dto.colllection.root;for(;;){const K=p.TestItem.from(w);if(F.unshift(K),this.sharedTestIds.has(K.extId)||(this.sharedTestIds.add(K.extId),w===M))break;w=w.parent||M}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,F)}}class u{constructor(w){this.proxy=w,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(w,F,M){return this.getTracker(w,F,M)}cancelRunById(w){for(const F of this.tracked.values())if(F.id===w){F.dispose();return}}cancelAllRuns(){for(const w of this.tracked.values())w.dispose()}createTestRun(w,F,M,K,G){const N=this.tracked.get(M);if(N)return N.createRun(K);const z=i.fromPublic(w,F,M,G),O=r(M);this.proxy.$startedExtensionTestRun({controllerId:w,profile:O&&{group:v[O.kind],id:O.profileId},exclude:M.exclude?.map(B=>B.id)??[],id:z.id,include:M.include?.map(B=>B.id)??[F.root.id],persist:G});const x=this.getTracker(M,z);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),x.createRun(K)}getTracker(w,F,M){const K=new t(F,this.proxy,M);return this.tracked.set(w,K),K.onEnd(()=>this.tracked.delete(w)),K}}e.TestRunCoordinator=u;const r=P=>{if(!!P.profile){if(!(P.profile instanceof _))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class i{constructor(w,F,M,K,G,N){this.controllerId=w,this.id=F,this.isPersisted=G,this.colllection=N,this.includePrefix=M.map(z=>z+"\0"),this.excludePrefix=K.map(z=>z+"\0")}static fromPublic(w,F,M,K){return new i(w,(0,I.generateUuid)(),M.include?.map(G=>a.TestId.fromExtHostTestItem(G,w).toString())??[w],M.exclude?.map(G=>a.TestId.fromExtHostTestItem(G,w).toString())??[],K,F)}static fromInternal(w,F){return new i(w.controllerId,w.runId,w.testIds,w.excludeExtIds,!0,F)}isIncluded(w){const F=a.TestId.fromExtHostTestItem(w,this.controllerId).toString()+"\0";for(const M of this.excludePrefix)if(F===M||F.startsWith(M))return!1;for(const M of this.includePrefix)if(F===M||F.startsWith(M))return!0;return!1}}e.TestRunDto=i;class o{constructor(w,F,M){this.proxy=w,this.runId=F,this.taskId=M}set coverageProvider(w){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!w||(this._coverageProvider=w,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(w){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(w))());try{return(await this.fileCoverage)?.map(p.TestCoverage.fromFile)??[]}catch(F){throw this.fileCoverage=void 0,F}}async resolveFileCoverage(w,F){const M=await this.fileCoverage;let K=M?.[w];return!this._coverageProvider||!M||!K?[]:(K.detailedCoverage||(K=M[w]=await this._coverageProvider.resolveFileCoverage?.(K,F)??K),K.detailedCoverage?.map(p.TestCoverage.fromDetailed)??[])}}class l extends E.IncrementalChangeCollector{constructor(w){super();this.emitter=w,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(w){this.added.add(w)}update(w){Object.assign(w.revived,p.TestItem.toPlain(w.item)),this.added.has(w)||this.updated.add(w)}remove(w){if(this.added.has(w)){this.added.delete(w);return}if(this.updated.delete(w),w.parent&&this.alreadyRemoved.has(w.parent)){this.alreadyRemoved.add(w.item.extId);return}this.removed.add(w)}getChangeEvent(){const{added:w,updated:F,removed:M}=this;return{get added(){return[...w].map(K=>K.revived)},get updated(){return[...F].map(K=>K.revived)},get removed(){return[...M].map(K=>K.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class d extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(w){return this.items.get(w)}getMirroredTestDataByReference(w){return this.items.get(w.id)}createItem(w,F){return{...w,revived:p.TestItem.toPlain(w.item),depth:F?F.depth+1:0,children:new Set}}createChangeCollector(){return new l(this.changeEmitter)}}e.MirroredTestCollection=d;class b{constructor(w){this.proxy=w}checkout(){this.current||(this.current=this.createObserverData());const w=this.current;return w.observers++,{onDidChangeTest:w.tests.onDidChangeTests,get tests(){return[...w.tests.rootTests].map(F=>F.revived)},dispose:(0,R.once)(()=>{--w.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(w){return this.current?.tests.getMirroredTestDataByReference(w)}applyDiff(w){this.current?.tests.apply(w)}createObserverData(){const w=new d;return this.proxy.$subscribeToDiffs(),{observers:0,tests:w}}}class _{constructor(w,F,M,K,G,N,z=!1,O=void 0){this.controllerId=F,this.profileId=M,this._label=K,this.kind=G,this.runHandler=N,this._isDefault=z,this._tag=O,s.set(this,void 0),nt(this,s,w,"f");const x=v[G];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${G}`);Oe(this,s,"f").$publishTestRunProfile({profileId:M,controllerId:F,tag:O?p.TestTag.namespace(this.controllerId,O.id):null,label:K,group:x,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(w){w!==this._label&&(this._label=w,Oe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:w}))}get isDefault(){return this._isDefault}set isDefault(w){w!==this._isDefault&&(this._isDefault=w,Oe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:w}))}get tag(){return this._tag}set tag(w){w?.id!==this._tag?.id&&(this._tag=w,Oe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:w?p.TestTag.namespace(this.controllerId,w.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(w){w!==this._configureHandler&&(this._configureHandler=w,Oe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!w}))}dispose(){Oe(this,s,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=_,s=new WeakMap;const v={[D.TestRunProfileKind.Coverage]:8,[D.TestRunProfileKind.Debug]:4,[D.TestRunProfileKind.Run]:2}}),define(me[253],ge([0,1,3,17,5,130,15,7]),function(J,e,m,L,k,C,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(n,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const I=this._extHostDocumentsAndEditors.allEditors();return n?I:I.map(c=>c.value)}async showTextDocument(n,I,c){let f;typeof I=="number"?f={position:R.ViewColumn.from(I),preserveFocus:c}:typeof I=="object"?f={position:R.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?R.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:f={preserveFocus:!1};const h=await this._proxy.$tryShowTextDocument(n.uri,f),p=h&&this._extHostDocumentsAndEditors.getEditor(h);if(p)return p.value;throw h?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,I){return new C.TextEditorDecorationType(this._proxy,n,I).value}$acceptEditorPropertiesChanged(n,I){const c=this._extHostDocumentsAndEditors.getEditor(n);if(!c)throw new Error("unknown text editor");if(I.options&&c._acceptOptions(I.options),I.selections){const f=I.selections.selections.map(R.Selection.to);c._acceptSelections(f)}if(I.visibleRanges){const f=L.coalesce(I.visibleRanges.map(R.Range.to));c._acceptVisibleRanges(f)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...I.options,lineNumbers:R.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const f=S.TextEditorSelectionChangeKind.fromValue(I.selections.source),h=I.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:h,kind:f})}if(I.visibleRanges){const f=L.coalesce(I.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:f})}}$acceptEditorPositionData(n){for(const I in n){const c=this._extHostDocumentsAndEditors.getEditor(I);if(!c)throw new Error("Unknown text editor");const f=R.ViewColumn.to(n[I]);c.value.viewColumn!==f&&(c._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:f}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=y}),define(me[254],ge([0,1,2,4,5,6,7]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class S{constructor(n,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(k.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===11){const f=c.uri===void 0?void 0:m.URI.revive(c.uri);return this._itemsBySourceAndUriMap.get(c.source)?.get(y(f))?.get(c.handle)}return c}})}async $getTimeline(n,I,c,f,h){return this._providers.get(n)?.provideTimeline(m.URI.revive(I),c,f,h)}registerTimelineProvider(n,I,c,f){const h=new C.DisposableStore,p=this.convertTimelineItem(I.id,f,h).bind(this);let D;I.onDidChange&&(D=I.onDidChange(E=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...E,id:I.id}),this));const A=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:n,onDidChange:void 0,async provideTimeline(E,a,s,g){g?.resetCache&&(h.clear(),A.get(I.id)?.clear());const t=await I.provideTimeline(E,a,s);if(t==null)return;const u=p(E,g);return{...t,source:I.id,items:t.items.map(u)}},dispose(){for(const E of A.values())E.get(I.id)?.clear();D?.dispose(),h.dispose()}})}convertTimelineItem(n,I,c){return(f,h)=>{let p;if(h?.cacheResults){let D=this._itemsBySourceAndUriMap.get(n);D===void 0&&(D=new Map,this._itemsBySourceAndUriMap.set(n,D));const A=y(f);p=D.get(A),p===void 0&&(p=new Map,D.set(A,p))}return D=>{const{iconPath:A,...E}=D,a=`${n}|${D.id??D.timestamp}`;p?.set(a,D);let s,g,t;return D.iconPath&&(A instanceof R.ThemeIcon?t={id:A.id,color:A.color}:m.URI.isUri(A)?(s=A,g=A):{light:s,dark:g}=A),{...E,id:E.id??void 0,handle:a,source:n,command:D.command?I.toInternal(D.command,c):void 0,icon:s,iconDark:g,themeIcon:t,accessibilityInformation:D.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,C.toDisposable)(()=>{for(const c of this._itemsBySourceAndUriMap.values())c.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=S;function y(T){return T?.toString()}}),define(me[255],ge([0,1,6,10,2,5]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(y){this._openers=new Map,this._proxy=y.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,T,n,I){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const c=I.schemes.find(f=>!R.supportedSchemes.has(f));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,n),this._proxy.$registerUriOpener(T,I.schemes,y,I.label),(0,m.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(y,T,n){const I=this._openers.get(y);if(!I)throw new Error(`Unknown opener with id: ${y}`);const c=k.URI.revive(T);return I.canOpenExternalUri(c,n)}async $openUri(y,T,n){const I=this._openers.get(y);if(!I)throw new Error(`Unknown opener id: '${y}'`);return I.openExternalUri(k.URI.revive(T.resolvedUri),{sourceUri:k.URI.revive(T.sourceUri)},n)}}e.ExtHostUriOpeners=R,R.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(me[256],ge([0,1,5,2,6,16,26]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class S{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(T,n){if(this.handles.has(R.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const I=S.HandlePool++;return this.handles.add(R.ExtensionIdentifier.toKey(T)),this.handlers.set(I,n),this._proxy.$registerUriHandler(I,T),(0,k.toDisposable)(()=>{this.handles.delete(R.ExtensionIdentifier.toKey(T)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(T,n){const I=this.handlers.get(T);if(!I)return Promise.resolve(void 0);try{I.handleUri(L.URI.revive(n))}catch(c){(0,C.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(T){return L.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=S,S.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[70],ge([0,1,3,2,180,205,88,5]),function(J,e,m,L,k,C,R,S){"use strict";var y,T,n,I,c,f,h,p,D,A,E,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class s{constructor(d,b,_,v,P,w,F){y.set(this,void 0),T.set(this,void 0),n.set(this,void 0),I.set(this,void 0),c.set(this,void 0),f.set(this,void 0),h.set(this,""),p.set(this,void 0),D.set(this,!1),A.set(this,!1),E.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new m.Emitter),this._onDidDispose=Oe(this,a,"f").event,nt(this,y,d,"f"),nt(this,T,b,"f"),nt(this,p,_,"f"),nt(this,I,v,"f"),nt(this,c,P,"f"),nt(this,f,w,"f"),nt(this,E,g(w),"f"),nt(this,n,F,"f")}dispose(){nt(this,D,!0,"f"),Oe(this,a,"f").fire(),Oe(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return nt(this,A,!0,"f"),(0,R.asWebviewUri)(d,Oe(this,I,"f").remote)}get cspSource(){return R.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,h,"f")}set html(d){this.assertNotDisposed(),Oe(this,h,"f")!==d&&(nt(this,h,d,"f"),!Oe(this,A,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(nt(this,A,!0,"f"),Oe(this,n,"f").report("Webview vscode-resource: uris",Oe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,T,"f").$setHtml(Oe(this,y,"f"),d))}get options(){return this.assertNotDisposed(),Oe(this,p,"f")}set options(d){this.assertNotDisposed(),Oe(this,T,"f").$setOptions(Oe(this,y,"f"),r(Oe(this,f,"f"),Oe(this,c,"f"),d)),nt(this,p,d,"f")}async postMessage(d){if(Oe(this,D,"f"))return!1;const b=(0,C.serializeWebviewMessage)(d,{serializeBuffersForPostMessage:Oe(this,E,"f")});return Oe(this,T,"f").$postMessage(Oe(this,y,"f"),b.message,...b.buffers)}assertNotDisposed(){if(Oe(this,D,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=s,y=new WeakMap,T=new WeakMap,n=new WeakMap,I=new WeakMap,c=new WeakMap,f=new WeakMap,h=new WeakMap,p=new WeakMap,D=new WeakMap,A=new WeakMap,E=new WeakMap,a=new WeakMap;function g(l){try{const d=(0,k.normalizeVersion)((0,k.parseVersion)(l.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=g;class t{constructor(d,b,_,v,P){this.initData=b,this.workspace=_,this._logService=v,this._deprecationService=P,this._webviews=new Map,this._webviewProxy=d.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(d,b,..._){const v=this.getWebview(d);if(v){const{message:P}=(0,C.deserializeWebviewMessage)(b,_);v._onMessageEmitter.fire(P)}}$onMissingCsp(d,b){this._logService.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,b,_){const v=new s(d,this._webviewProxy,i(b),this.initData,this.workspace,_,this._deprecationService);return this._webviews.set(d,v),v._onDidDispose(()=>{this._webviews.delete(d)}),v}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=t;function u(l){return{id:l.identifier,location:l.extensionLocation}}e.toExtensionData=u;function r(l,d,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||o(l,d)}}e.serializeWebviewOptions=r;function i(l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots?.map(d=>L.URI.from(d))}}e.reviveOptions=i;function o(l,d){return[...(d?.getWorkspaceFolders()||[]).map(b=>b.uri),l.extensionLocation]}}),define(me[257],ge([0,1,21,48,6,10,23,2,15,70,87,5,7]),function(J,e,m,L,k,C,R,S,y,T,n,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,u){this.document=t,this._storagePath=u,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,u){await this.getEdit(t).undo(),u||this.disposeBackup()}async redo(t,u){await this.getEdit(t).redo(),u||this.disposeBackup()}disposeEdits(t){for(const u of t)this._edits.delete(u)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=s(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const u=this._edits.get(t,0);if(!u)throw new Error("No edit found");return u}}class h{constructor(){this._documents=new Map}get(t,u){return this._documents.get(this.key(t,u))}add(t,u,r){const i=this.key(t,u.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${u.uri}`);const o=new f(u,r);return this._documents.set(i,o),o}delete(t,u){const r=this.key(t,u.uri);this._documents.delete(r)}key(t,u){return`${t}@@@${u}`}}var p;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(p||(p={}));class D{constructor(){this._providers=new Map}addTextProvider(t,u,r){return this.add(0,t,u,r)}addCustomProvider(t,u,r){return this.add(1,t,u,r)}get(t){return this._providers.get(t)}add(t,u,r,i){if(this._providers.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this._providers.set(u,{type:t,extension:r,provider:i}),new c.Disposable(()=>this._providers.delete(u))}}class A{constructor(t,u,r,i,o){this._extHostDocuments=u,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=o,this._editorProviders=new D,this._documents=new h,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,u,r,i){const o=new k.DisposableStore;return E(r)?(o.add(this._editorProviders.addTextProvider(u,t,r)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(t),u,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(t))):(o.add(this._editorProviders.addCustomProvider(u,t,r)),this.supportEditing(r)&&o.add(r.onDidChangeCustomDocument(l=>{const d=this.getCustomDocumentEntry(u,l.document.uri);if(a(l)){const b=d.addEdit(l);this._proxy.$onDidEdit(l.document.uri,u,b,l.label)}else this._proxy.$onContentChange(l.document.uri,u)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(t),u,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(t))),c.Disposable.from(o,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(u)}))}async $createCustomDocument(t,u,r,i,o){const l=this._editorProviders.get(u);if(!l)throw new Error(`No provider found for '${u}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${u}'`);const d=S.URI.revive(t),b=await l.provider.openCustomDocument(d,{backupId:r,untitledDocumentData:i?.buffer},o);let _;return this.supportEditing(l.provider)&&this._extensionStoragePaths&&(_=this._extensionStoragePaths.workspaceValue(l.extension)??this._extensionStoragePaths.globalValue(l.extension)),this._documents.add(u,b,_),{editable:this.supportEditing(l.provider)}}async $disposeCustomDocument(t,u){const r=this._editorProviders.get(u);if(!r)throw new Error(`No provider found for '${u}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${u}'`);const i=S.URI.revive(t),{document:o}=this.getCustomDocumentEntry(u,i);this._documents.delete(u,o),o.dispose()}async $resolveWebviewEditor(t,u,r,i,o,l){const d=this._editorProviders.get(r);if(!d)throw new Error(`No provider found for '${r}'`);const b=y.ViewColumn.to(o),_=this._extHostWebview.createNewWebview(u,i.webviewOptions,d.extension),v=this._extHostWebviewPanels.createNewWebviewPanel(u,r,i.title,b,i.panelOptions,_),P=S.URI.revive(t);switch(d.type){case 1:{const{document:w}=this.getCustomDocumentEntry(r,P);return d.provider.resolveCustomEditor(w,v,l)}case 0:{const w=this._extHostDocuments.getDocument(P);return d.provider.resolveCustomTextEditor(w,v,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,u,r){this.getCustomDocumentEntry(u,t).disposeEdits(r)}async $onMoveCustomEditor(t,u,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const o=this._extHostWebviewPanels.getWebviewPanel(t);if(!o)throw new Error("No webview found");const l=S.URI.revive(u),d=this._extHostDocuments.getDocument(l);await i.provider.moveCustomTextEditor(d,o,m.CancellationToken.None)}async $undo(t,u,r,i){return this.getCustomDocumentEntry(u,t).undo(r,i)}async $redo(t,u,r,i){return this.getCustomDocumentEntry(u,t).redo(r,i)}async $revert(t,u,r){const i=this.getCustomDocumentEntry(u,t);await this.getCustomEditorProvider(u).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(t,u,r){const i=this.getCustomDocumentEntry(u,t);await this.getCustomEditorProvider(u).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(t,u,r,i){const o=this.getCustomDocumentEntry(u,t);return this.getCustomEditorProvider(u).saveCustomDocumentAs(o.document,S.URI.revive(r),i)}async $backup(t,u,r){const i=this.getCustomDocumentEntry(u,t),l=await this.getCustomEditorProvider(u).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(l),l.id}getCustomDocumentEntry(t,u){const r=this._documents.get(t,S.URI.revive(u));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(t){const r=this._editorProviders.get(t)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=A;function E(g){return typeof g.resolveCustomTextEditor=="function"}function a(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function s(g){const t=g.scheme===C.Schemas.file||g.scheme===C.Schemas.untitled?g.fsPath:g.toString();return(0,L.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[258],ge([0,1,3,6,2,32,15,70,5,7]),function(J,e,m,L,k,C,R,S,y,T){"use strict";var n,I,c,f,h,p,D,A,E,a,s,g,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends L.Disposable{constructor(l,d,b,_,v,P,w){super();n.set(this,void 0),I.set(this,void 0),c.set(this,void 0),f.set(this,void 0),h.set(this,void 0),p.set(this,void 0),D.set(this,void 0),A.set(this,void 0),E.set(this,!0),a.set(this,!0),s.set(this,!1),g.set(this,this._register(new m.Emitter)),this.onDidDispose=Oe(this,g,"f").event,t.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,nt(this,n,l,"f"),nt(this,I,d,"f"),nt(this,c,b,"f"),nt(this,h,P,"f"),nt(this,A,v,"f"),nt(this,p,_,"f"),nt(this,f,w,"f")}dispose(){Oe(this,s,"f")||(nt(this,s,!0,"f"),Oe(this,g,"f").fire(),Oe(this,I,"f").$disposeWebview(Oe(this,n,"f")),Oe(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,f,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,c,"f")}get title(){return this.assertNotDisposed(),Oe(this,p,"f")}set title(l){this.assertNotDisposed(),Oe(this,p,"f")!==l&&(nt(this,p,l,"f"),Oe(this,I,"f").$setTitle(Oe(this,n,"f"),l))}get iconPath(){return this.assertNotDisposed(),Oe(this,D,"f")}set iconPath(l){this.assertNotDisposed(),Oe(this,D,"f")!==l&&(nt(this,D,l,"f"),Oe(this,I,"f").$setIconPath(Oe(this,n,"f"),k.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Oe(this,h,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,A,"f")=="number"&&Oe(this,A,"f")<0))return Oe(this,A,"f")}get active(){return this.assertNotDisposed(),Oe(this,a,"f")}get visible(){return this.assertNotDisposed(),Oe(this,E,"f")}_updateViewState(l){Oe(this,s,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(nt(this,a,l.active,"f"),nt(this,E,l.visible,"f"),nt(this,A,l.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(l,d){this.assertNotDisposed(),Oe(this,I,"f").$reveal(Oe(this,n,"f"),{viewColumn:l?R.ViewColumn.from(l):void 0,preserveFocus:!!d})}assertNotDisposed(){if(Oe(this,s,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,I=new WeakMap,c=new WeakMap,f=new WeakMap,h=new WeakMap,p=new WeakMap,D=new WeakMap,A=new WeakMap,E=new WeakMap,a=new WeakMap,s=new WeakMap,g=new WeakMap,t=new WeakMap;class r{constructor(l,d,b){this.webviews=d,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=l.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(l,d,b,_,v={}){const P=typeof _=="object"?_.viewColumn:_,w={viewColumn:R.ViewColumn.from(P),preserveFocus:typeof _=="object"&&!!_.preserveFocus},F=(0,S.shouldSerializeBuffersForPostMessage)(l),M=r.newHandle();this._proxy.$createWebviewPanel((0,S.toExtensionData)(l),M,d,{title:b,panelOptions:i(v),webviewOptions:(0,S.serializeWebviewOptions)(l,this.workspace,v),serializeBuffersForPostMessage:F},w);const K=this.webviews.createNewWebview(M,v,l);return this.createNewWebviewPanel(M,d,b,P,v,K)}$onDidChangeWebviewPanelViewStates(l){const d=Object.keys(l);d.sort((b,_)=>{const v=l[b],P=l[_];return v.active?1:P.active?-1:+v.visible-+P.visible});for(const b of d){const _=this.getWebviewPanel(b);if(!_)continue;const v=l[b];_._updateViewState({active:v.active,visible:v.visible,viewColumn:R.ViewColumn.to(v.position)})}}async $onDidDisposeWebviewPanel(l){this.getWebviewPanel(l)?.dispose(),this._webviewPanels.delete(l),this.webviews.deleteWebview(l)}registerWebviewPanelSerializer(l,d,b){if(this._serializers.has(d))throw new Error(`Serializer for '${d}' already registered`);return this._serializers.set(d,{serializer:b,extension:l}),this._proxy.$registerSerializer(d,{serializeBuffersForPostMessage:(0,S.shouldSerializeBuffersForPostMessage)(l)}),new T.Disposable(()=>{this._serializers.delete(d),this._proxy.$unregisterSerializer(d)})}async $deserializeWebviewPanel(l,d,b,_){const v=this._serializers.get(d);if(!v)throw new Error(`No serializer found for '${d}'`);const{serializer:P,extension:w}=v,F=this.webviews.createNewWebview(l,b.webviewOptions,w),M=this.createNewWebviewPanel(l,d,b.title,_,b.panelOptions,F);await P.deserializeWebviewPanel(M,b.state)}createNewWebviewPanel(l,d,b,_,v,P){const w=new u(l,this._proxy,d,b,_,v,P);return this._webviewPanels.set(l,w),w}getWebviewPanel(l){return this._webviewPanels.get(l)}}e.ExtHostWebviewPanels=r;function i(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[259],ge([0,1,3,6,70,5,7]),function(J,e,m,L,k,C,R){"use strict";var S,y,T,n,I,c,f,h,p,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class A extends L.Disposable{constructor(s,g,t,u,r,i){super();S.set(this,void 0),y.set(this,void 0),T.set(this,void 0),n.set(this,void 0),I.set(this,!1),c.set(this,void 0),f.set(this,void 0),h.set(this,void 0),p.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Oe(this,p,"f").event,D.set(this,this._register(new m.Emitter)),this.onDidDispose=Oe(this,D,"f").event,nt(this,T,t,"f"),nt(this,f,u,"f"),nt(this,S,s,"f"),nt(this,y,g,"f"),nt(this,n,r,"f"),nt(this,c,i,"f")}dispose(){Oe(this,I,"f")||(nt(this,I,!0,"f"),Oe(this,D,"f").fire(),Oe(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,f,"f")}set title(s){this.assertNotDisposed(),Oe(this,f,"f")!==s&&(nt(this,f,s,"f"),Oe(this,y,"f").$setWebviewViewTitle(Oe(this,S,"f"),s))}get description(){return this.assertNotDisposed(),Oe(this,h,"f")}set description(s){this.assertNotDisposed(),Oe(this,h,"f")!==s&&(nt(this,h,s,"f"),Oe(this,y,"f").$setWebviewViewDescription(Oe(this,S,"f"),s))}get visible(){return Oe(this,c,"f")}get webview(){return Oe(this,n,"f")}get viewType(){return Oe(this,T,"f")}_setVisible(s){s===Oe(this,c,"f")||Oe(this,I,"f")||(nt(this,c,s,"f"),Oe(this,p,"f").fire())}show(s){this.assertNotDisposed(),Oe(this,y,"f").$show(Oe(this,S,"f"),!!s)}assertNotDisposed(){if(Oe(this,I,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,y=new WeakMap,T=new WeakMap,n=new WeakMap,I=new WeakMap,c=new WeakMap,f=new WeakMap,h=new WeakMap,p=new WeakMap,D=new WeakMap;class E{constructor(s,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=s.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,g,t,u){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:t,extension:s}),this._proxy.$registerWebviewViewProvider((0,k.toExtensionData)(s),g,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new R.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(s,g,t,u,r){const i=this._viewProviders.get(g);if(!i)throw new Error(`No view provider found for '${g}'`);const{provider:o,extension:l}=i,d=this._extHostWebview.createNewWebview(s,{},l),b=new A(s,this._proxy,g,t,d,!0);this._webviewViews.set(s,b),await o.resolveWebviewView(b,{state:u},r)}async $onDidChangeWebviewViewVisibility(s,g){this.getWebviewView(s)._setVisible(g)}async $disposeWebviewView(s){const g=this.getWebviewView(s);this._webviewViews.delete(s),g.dispose(),this._extHostWebview.deleteWebview(s)}getWebviewView(s){const g=this._webviewViews.get(s);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=E}),define(me[132],ge([0,1,3,5,2,10,9,4,14]),function(J,e,m,L,k,C,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class $n{constructor(I){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$n.InitialState,this._proxy=I.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,c){let f;if(typeof I=="string"){f=I;try{I=k.URI.parse(I)}catch(h){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,R.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,f,c)}async asExternalUri(I,c){if((0,R.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(I,c);return k.URI.from(f)}};T.InitialState={focused:!0},T=Ve([$e(0,y.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,S.createDecorator)("IExtHostWindow")}),define(me[260],ge([0,1,8,80,32,40,6,5,2,14]),function(J,e,m,L,k,C,R,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let n=class extends R.Disposable{constructor(c,f){super();const h=c.getProxy(S.MainContext.MainThreadDownloadService);f.registerCommand(!1,"_workbench.downloadResource",async p=>{const D=y.URI.file((0,m.join)((0,L.tmpdir)(),(0,k.generateUuid)()));return await h.$download(p,D),D})}};n=Ve([$e(0,T.IExtHostRpcService),$e(1,C.IExtHostCommands)],n),e.ExtHostDownloadService=n}),define(me[261],ge([0,1,2,8,152,28,68,27,14,6,12,116,43]),function(J,e,m,L,k,C,R,S,y,T,n,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class f{constructor(A,E,a){this.name=A,this.file=E,this.appender=a}static async create(A,E){const a=await(0,I.createRotatingLogger)(A,E,30*c.ByteSize.MB,1);return a.clearFormatters(),new f(A,E,a)}append(A){this.appender.critical(A)}flush(){this.appender.flush()}}class h extends R.AbstractExtHostOutputChannel{constructor(A,E,a,s){super(A,!1,m.URI.file(E.file),a,s);this._appender=E}append(A){super.append(A),this._appender.append(A),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(A,E){this._appender.flush(),super.show(A,E)}clear(){this._appender.flush(),super.clear()}}let p=class extends R.ExtHostOutputService{constructor(A,E,a){super(A);this.logService=E,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new T.MutableDisposable,this._logsLocation=a.logsLocation}$setVisibleChannel(A){if(A){const E=this._channels.get(A);E&&(this._visibleChannelDisposable.value=E.onDidAppend(()=>E.update()))}}createOutputChannel(A,E){if(A=A.trim(),!A)throw new Error("illegal argument `name`. must not be falsy");const a=this._doCreateOutChannel(A,E);return a.then(s=>s._id.then(g=>this._channels.set(g,s))),new R.LazyOutputChannel(A,a)}async _doCreateOutChannel(A,E){try{const a=(0,L.join)(this._logsLocation.fsPath,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await C.SymlinkSupport.existsDirectory(a)||await C.Promises.mkdir(a,{recursive:!0});const g=`${this._namePool++}-${A.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=m.URI.file((0,L.join)(a,`${g}.log`)),u=await f.create(g,t.fsPath);return new h(A,u,E.identifier.value,this._proxy)}catch(a){return this.logService.error(a),new R.ExtHostPushOutputChannel(A,E.identifier.value,this._proxy)}}};p=Ve([$e(0,y.IExtHostRpcService),$e(1,n.ILogService),$e(2,S.IExtHostInitDataService)],p),e.ExtHostOutputService2=p}),define(me[262],ge([0,1,50,293,2,69,6,10,18]),function(J,e,m,L,k,C,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class T extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(g){const t=await super._getWorkspaceStorageURI(g);if(t.scheme!==S.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const u=t.fsPath;let r=0;do{let i;r===0?i=u:i=/[/\\]$/.test(u)?`${u.substr(0,u.length-1)}-${r}`:`${u}-${r}`,await n(i);const o=L.join(i,"vscode.lock"),l=await h(this._logService,o,!1);if(l)return this._workspaceStorageLock=l,process.on("exit",()=>{l.dispose()}),k.URI.file(i);r++}while(r<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=T;async function n(s){try{await m.promises.stat(s);return}catch{}try{await m.promises.mkdir(s,{recursive:!0})}catch{}}const I=1e3,c=10*60*1e3;class f extends R.Disposable{constructor(g,t){super();this.logService=g,this.filename=t,this._timer=this._register(new y.IntervalTimer),this._timer.cancelAndSet(async()=>{const u=await p(g,t);(!u||u.pid!==process.pid)&&(g.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await m.promises.utimes(t,new Date,new Date)}catch(r){g.error(r),g.info(`Lock '${t}': Could not update mtime.`)}},I)}dispose(){super.dispose();try{m.unlinkSync(this.filename)}catch(g){}}async setWillRelease(g){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${g} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+g};await m.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function h(s,g,t){try{const r={pid:process.pid,willReleaseAt:0};await m.promises.writeFile(g,JSON.stringify(r),{flag:"wx"})}catch(r){s.error(r)}const u=await p(s,g);return!u||u.pid!==process.pid?t?(s.info(`Lock '${g}': Could not acquire lock, giving up.`),null):(s.info(`Lock '${g}': Could not acquire lock, checking if the file is stale.`),E(s,g)):(s.info(`Lock '${g}': Lock acquired.`),new f(s,g))}async function p(s,g){let t;try{t=await m.promises.readFile(g)}catch(u){return s.error(u),null}try{return JSON.parse(String(t))}catch(u){return s.error(u),null}}async function D(s,g){let t;try{t=await m.promises.stat(g)}catch(u){return s.error(u),0}return t.mtime.getTime()}function A(s){try{return process.kill(s,0),!0}catch(g){return!1}}async function E(s,g){const t=await p(s,g);if(!t)return s.info(`Lock '${g}': Could not read pid of lock holder.`),a(s,g);if(t.willReleaseAt){let l=t.willReleaseAt-Date.now();if(l<5e3){for(l>0?s.info(`Lock '${g}': The lockfile is scheduled to be released in ${l} ms.`):s.info(`Lock '${g}': The lockfile is scheduled to have been released.`);l>0;){if(await(0,y.timeout)(Math.min(100,l)),await D(s,g)===0)return a(s,g);l=t.willReleaseAt-Date.now()}return a(s,g)}}if(!A(t.pid))return s.info(`Lock '${g}': The pid ${t.pid} appears to be gone.`),a(s,g);const u=await D(s,g),r=Date.now()-u;if(r<=c)return s.info(`Lock '${g}': The lock does not look stale, elapsed: ${r} ms, giving up.`),null;s.info(`Lock '${g}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const i=await D(s,g),o=Date.now()-i;return o<=c?(s.info(`Lock '${g}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null):(s.info(`Lock '${g}': The lock looks stale even after waiting for 2s.`),a(s,g))}async function a(s,g){s.info(`Lock '${g}': Deleting a stale lock.`);try{await m.promises.unlink(g)}catch(t){}return h(s,g,!0)}}),define(me[263],ge([0,1,32,14,33]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends k.BaseExtHostTerminalService{constructor(S){super(!0,S)}createTerminal(S,y,T){return this.createTerminalFromOptions({name:S,shellPath:y,shellArgs:T})}createTerminalFromOptions(S,y){const T=new k.ExtHostTerminal(this._proxy,(0,m.generateUuid)(),S,S.name);return this._terminals.push(T),T.create(S,this._serializeParentTerminal(S,y)),T.value}};C=Ve([$e(0,L.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(me[264],ge([0,1,5,14,6,27,2,39,23,28,7,11,53,3,194,77,12]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class A{constructor(d,b,_){this.remoteAddress=d,this.localAddress=b,this._dispose=_,this._onDispose=new f.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function E(l){const d=l.trim().split(`
`),b=[];return d.forEach(v=>{const P=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(v);P&&P.length>=3&&b.push({pid:parseInt(P[1],10),socket:parseInt(P[2],10)})}),b.reduce((v,P)=>(v[P.socket]=P,v),{})}e.getSockets=E;function a(...l){const d=[].concat(...l.map(g));return[...new Map(d.filter(b=>b.st==="0A").map(b=>{const _=b.local_address.split(":");return{socket:parseInt(b.inode,10),ip:s(_[0]),port:parseInt(_[1],16)}}).map(b=>[b.ip+":"+b.port,b])).values()]}e.loadListeningPorts=a;function s(l){let d="";if(l.length===8)for(let b=l.length-2;b>=0;b-=2)d+=parseInt(l.substr(b,2),16),b!==0&&(d+=".");else for(let b=l.length-4;b>=0;b-=4)d+=parseInt(l.substr(b,4),16).toString(16),b!==0&&(d+=":");return d}e.parseIpAddress=s;function g(l){const d=l.trim().split(`
`),b=d.shift().trim().split(/\s+/).filter(v=>v!=="rx_queue"&&v!=="tm->when");return d.map(v=>v.trim().split(/\s+/).reduce((P,w,F)=>(P[b[F]||F]=w,P),{}))}e.loadConnectionTable=g;function t(l){return!!l.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||l.indexOf("out/vs/server/main.js")!==-1||l.indexOf("_productName=VSCode")!==-1}function u(l){const d=l.trim().split(`
`),b=[];return d.forEach(_=>{const v=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(_);v&&v.length>=4&&b.push({pid:parseInt(v[1],10),ppid:parseInt(v[2]),cmd:v[3]})}),b}e.getRootProcesses=u;async function r(l,d,b){const _=b.reduce((P,w)=>(P[w.pid]=w,P),{}),v=[];return l.forEach(({socket:P,ip:w,port:F})=>{const M=d[P]?d[P].pid:void 0,K=M?_[M]?.cmd:void 0;M&&K&&!t(K)&&v.push({host:w,port:F,detail:K,pid:M})}),v}e.findPorts=r;function i(l,d,b){const _=new Map,v=u(d);for(const P of l){const w=b.get(P.port);if(w){_.set(P.port,w);continue}const F=v.find(M=>M.cmd.includes(`${P.port}`));if(F){let M=F,K;do K=v.find(G=>G.ppid===M.pid),K&&(M=K);while(K);_.set(P.port,{host:P.ip,port:P.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else _.set(P.port,{host:P.ip,port:P.port,ppid:Number.MAX_VALUE})}return _}e.tryFindRootPorts=i;let o=class extends k.Disposable{constructor(d,b,_){super();this.logService=_,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new f.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=d.getProxy(m.MainContext.MainThreadTunnelService),I.isLinux&&b.remote.isRemote&&b.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(d,b){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${b.remoteAddress.host}:${b.remoteAddress.port}.`);const _=await this._proxy.$openTunnel(b,d.displayName);if(_){const v=new A(_.remoteAddress,_.localAddress,()=>this._proxy.$closeTunnel(_.remoteAddress));return this._register(v),v}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(d){return Math.max(d*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(d,b){const _=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(_,{selector:d,provider:b}),this._proxy.$registerPortsAttributesProvider(d,_),new n.Disposable(()=>{this._portAttributesProviders.delete(_),this._proxy.$unregisterPortsAttributesProvider(_)})}async $providePortAttributes(d,b,_,v,P){const w=[];for(const M of d){const K=this._portAttributesProviders.get(M);if(!K)return[];w.push(...await Promise.all(b.map(async G=>K.provider.providePortAttributes(G,_,v,P))))}const F=w.filter(M=>!!M);return F.length>0?F.map(M=>({autoForwardAction:M.autoForwardAction,port:M.port})):[]}async $registerCandidateFinder(d){if(d&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=d;let b=new p.MovingAverage,_;for(;this._candidateFindingEnabled;){const v=new Date().getTime(),P=(await this.findCandidatePorts()).filter(F=>(0,h.isLocalhost)(F.host)||(0,h.isAllInterfaces)(F.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${P.map(F=>F.port).join(", ")}`);const w=new Date().getTime()-v;b.update(w),(!_||JSON.stringify(_)!==JSON.stringify(P))&&(_=P,await this._proxy.$onFoundNewCandidates(_)),await new Promise(F=>setTimeout(()=>F(),this.calculateDelay(b.value)))}}async setTunnelExtensionFunctions(d){return d?(d.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this._showCandidatePort=d.showCandidatePort,this._proxy.$setCandidateFilter()),d.tunnelFactory&&(this._forwardPortProvider=d.tunnelFactory,this._proxy.$setTunnelProvider(d.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,k.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(d,b){if(this._extensionTunnels.has(d.host)){const _=this._extensionTunnels.get(d.host);_.has(d.port)&&(b&&_.get(d.port).disposeListener.dispose(),await _.get(d.port).tunnel.dispose(),_.delete(d.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(d,b){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const _=this._forwardPortProvider(d,b);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),_!==void 0){const v=await _;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(d.remoteAddress.host)||this._extensionTunnels.set(d.remoteAddress.host,new Map);const P=this._register(v.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(v.remoteAddress))));return this._extensionTunnels.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:v,disposeListener:P}),c.TunnelDto.fromApiTunnel(v)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(_){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(d){const b=await Promise.all(d.map(v=>this._showCandidatePort(v.host,v.port,v.detail??""))),_=d.filter((v,P)=>b[P]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(v=>v.port).join(", ")} to ${_.map(v=>v.port).join(", ")}`),_}async findCandidatePorts(){let d="",b="";try{d=await T.Promises.readFile("/proc/net/tcp","utf8"),b=await T.Promises.readFile("/proc/net/tcp6","utf8")}catch(z){}const _=a(d,b),v=await new Promise(z=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(O,x,B)=>{z(x)})}),P=E(v),w=await T.Promises.readdir("/proc"),F=[];for(let z of w)try{const O=Number(z),x=y.joinPath(R.URI.file("/proc"),z);if((await T.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(O)){const U=await T.Promises.readlink(y.joinPath(x,"cwd").fsPath),H=await T.Promises.readFile(y.joinPath(x,"cmdline").fsPath,"utf8");F.push({pid:O,cwd:U,cmd:H})}}catch(O){}const M=[],K=_.filter(z=>{const O=P[z.socket];return O||M.push(z),O}),G=r(K,P,F);let N;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const z=await new Promise(O=>{(0,S.exec)("ps -F -A -l | grep root",(x,B,U)=>{O(B)})});this._foundRootPorts=i(M,z,this._foundRootPorts),N=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${N.join(", ")}`)}return G.then(z=>N?z.concat(N):z)}};o=Ve([$e(0,L.IExtHostRpcService),$e(1,C.IExtHostInitDataService),$e(2,D.ILogService)],o),e.ExtHostTunnelService=o}),define(me[265],ge([0,1,18,22,21,16,3,6,103,229,55]),function(J,e,m,L,k,C,R,S,y,T,n){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function c(v,P){try{return JSON.stringify(v,P)}catch(w){return"null"}}const f="$$ref$$",h={[f]:-1};class p{constructor(P,w){this.jsonString=P,this.referencedBuffers=w}}function D(v,P=null,w=!1){const F=[];return{jsonString:(w?c:JSON.stringify)(v,(K,G)=>{if(typeof G=="undefined")return h;if(typeof G=="object"){if(G instanceof L.VSBuffer){const N=F.push(G)-1;return{[f]:N}}if(P)return P(K,G)}return G}),referencedBuffers:F}}e.stringifyJsonWithBufferRefs=D;function A(v,P,w){return JSON.parse(v,(F,M)=>{if(M){const K=M[f];if(typeof K=="number")return P[K];if(w&&M.$mid===1)return w.transformIncoming(M)}return M})}e.parseJsonAndRestoreBufferRefs=A;function E(v,P){return JSON.stringify(v,P)}function a(v){return v?(P,w)=>w&&w.$mid===1?v.transformOutgoing(w):w:null}var s;(function(v){v[v.LocalSide=0]="LocalSide",v[v.OtherSide=1]="OtherSide"})(s=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(v){v[v.Responsive=0]="Responsive",v[v.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},u=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends S.Disposable{constructor(P,w=null,F=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=P,this._logger=w,this._uriTransformer=F,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let M=0,K=n.ProxyIdentifier.count;M<K;M++)this._locals[M]=null,this._proxies[M]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(M=>this._receiveOneMessage(M))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(P=>{this._pendingRPCReplies[P].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(P){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(P){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(P){this._responsiveState!==P&&(this._responsiveState=P,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(P){return this._uriTransformer?(0,y.transformIncomingURIs)(P,this._uriTransformer):P}getProxy(P){const{nid:w,sid:F}=P;return this._proxies[w]||(this._proxies[w]=this._createProxy(w,F)),this._proxies[w]}_createProxy(P,w){let F={get:(M,K)=>(typeof K=="string"&&!M[K]&&K.charCodeAt(0)===36&&(M[K]=(...G)=>this._remoteCall(P,K,G)),K===r?w:M[K])};return new Proxy(Object.create(null),F)}set(P,w){return this._locals[P.nid]=w,w}assertRegistered(P){for(let w=0,F=P.length;w<F;w++){const M=P[w];if(!this._locals[M.nid])throw new Error(`Missing actor ${M.sid} (isMain: ${M.isMain})`)}}_receiveOneMessage(P){if(this._isDisposed)return;const w=P.byteLength,F=o.read(P,0),M=F.readUInt8(),K=F.readUInt32();switch(M){case 1:case 2:{let{rpcId:G,method:N,args:z}=d.deserializeRequestJSONArgs(F);this._uriTransformer&&(z=(0,y.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(w,K,G,N,z,M===2);break}case 3:case 4:{let{rpcId:G,method:N,args:z}=d.deserializeRequestMixedArgs(F);this._uriTransformer&&(z=(0,y.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(w,K,G,N,z,M===4);break}case 5:{this._logger&&this._logger.logIncoming(w,K,0,"ack"),this._onDidReceiveAcknowledge(K);break}case 6:{this._receiveCancel(w,K);break}case 7:{this._receiveReply(w,K,void 0);break}case 9:{let G=d.deserializeReplyOKJSON(F);this._uriTransformer&&(G=(0,y.transformIncomingURIs)(G,this._uriTransformer)),this._receiveReply(w,K,G);break}case 10:{const G=d.deserializeReplyOKJSONWithBuffers(F,this._uriTransformer);this._receiveReply(w,K,G);break}case 8:{let G=d.deserializeReplyOKVSBuffer(F);this._receiveReply(w,K,G);break}case 11:{let G=d.deserializeReplyErrError(F);this._uriTransformer&&(G=(0,y.transformIncomingURIs)(G,this._uriTransformer)),this._receiveReplyErr(w,K,G);break}case 12:{this._receiveReplyErr(w,K,void 0);break}default:console.error("received unexpected message"),console.error(P)}}_receiveRequest(P,w,F,M,K,G){this._logger&&this._logger.logIncoming(P,w,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(F)}.${M}(`,K);const N=String(w);let z,O;if(G){const B=new k.CancellationTokenSource;K.push(B.token),z=this._invokeHandler(F,M,K),O=()=>B.cancel()}else z=this._invokeHandler(F,M,K),O=t;this._cancelInvokedHandlers[N]=O;const x=d.serializeAcknowledged(w);this._logger&&this._logger.logOutgoing(x.byteLength,w,1,"ack"),this._protocol.send(x),z.then(B=>{delete this._cancelInvokedHandlers[N];const U=d.serializeReplyOK(w,B,this._uriReplacer);this._logger&&this._logger.logOutgoing(U.byteLength,w,1,"reply:",B),this._protocol.send(U)},B=>{delete this._cancelInvokedHandlers[N];const U=d.serializeReplyErr(w,B);this._logger&&this._logger.logOutgoing(U.byteLength,w,1,"replyErr:",B),this._protocol.send(U)})}_receiveCancel(P,w){this._logger&&this._logger.logIncoming(P,w,1,"receiveCancel");const F=String(w);this._cancelInvokedHandlers[F]&&this._cancelInvokedHandlers[F]()}_receiveReply(P,w,F){this._logger&&this._logger.logIncoming(P,w,0,"receiveReply:",F);const M=String(w);if(!this._pendingRPCReplies.hasOwnProperty(M))return;const K=this._pendingRPCReplies[M];delete this._pendingRPCReplies[M],K.resolveOk(F)}_receiveReplyErr(P,w,F){this._logger&&this._logger.logIncoming(P,w,0,"receiveReplyErr:",F);const M=String(w);if(!this._pendingRPCReplies.hasOwnProperty(M))return;const K=this._pendingRPCReplies[M];delete this._pendingRPCReplies[M];let G;F&&(F.$isError?(G=new Error,G.name=F.name,G.message=F.message,G.stack=F.stack):G=F),K.resolveErr(G)}_invokeHandler(P,w,F){try{return Promise.resolve(this._doInvokeHandler(P,w,F))}catch(M){return Promise.reject(M)}}_doInvokeHandler(P,w,F){const M=this._locals[P];if(!M)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(P));let K=M[w];if(typeof K!="function")throw new Error("Unknown method "+w+" on actor "+(0,n.getStringIdentifierForProxy)(P));return K.apply(M,F)}_remoteCall(P,w,F){if(this._isDisposed)return Promise.reject(C.canceled());let M=null;if(F.length>0&&k.CancellationToken.isCancellationToken(F[F.length-1])&&(M=F.pop()),M&&M.isCancellationRequested)return Promise.reject(C.canceled());const K=d.serializeRequestArguments(F,this._uriReplacer),G=++this._lastMessageId,N=String(G),z=new T.LazyPromise;M&&M.onCancellationRequested(()=>{const x=d.serializeCancel(G);this._logger&&this._logger.logOutgoing(x.byteLength,G,0,"cancel"),this._protocol.send(d.serializeCancel(G))}),this._pendingRPCReplies[N]=z,this._onWillSendRequest(G);const O=d.serializeRequest(G,P,w,K,!!M);return this._logger&&this._logger.logOutgoing(O.byteLength,G,0,`request: ${(0,n.getStringIdentifierForProxy)(P)}.${w}(`,F),this._protocol.send(O),z}}e.RPCProtocol=i,I=u,i.UNRESPONSIVE_TIME=3*1e3;class o{constructor(P,w){this._buff=P,this._offset=w}static alloc(P,w,F){let M=new o(L.VSBuffer.alloc(F+1+4),0);return M.writeUInt8(P),M.writeUInt32(w),M}static read(P,w){return new o(P,w)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(P){this._buff.writeUInt8(P,this._offset),this._offset+=1}readUInt8(){const P=this._buff.readUInt8(this._offset);return this._offset+=1,P}writeUInt32(P){this._buff.writeUInt32BE(P,this._offset),this._offset+=4}readUInt32(){const P=this._buff.readUInt32BE(this._offset);return this._offset+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this._buff.writeUInt8(P.byteLength,this._offset),this._offset+=1,this._buff.set(P,this._offset),this._offset+=P.byteLength}readShortString(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const F=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,F}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readLongString(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,F}writeBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readVSBuffer(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const w=this._buff.slice(this._offset,this._offset+P);return this._offset+=P,w}static sizeMixedArray(P){let w=0;w+=1;for(let F=0,M=P.length;F<M;F++){const K=P[F];switch(w+=1,K.type){case 1:w+=this.sizeLongString(K.value);break;case 2:w+=this.sizeVSBuffer(K.value);break;case 3:w+=this.sizeUInt32,w+=this.sizeLongString(K.value);for(let G=0;G<K.buffers.length;++G)w+=this.sizeVSBuffer(K.buffers[G]);break;case 4:break}}return w}writeMixedArray(P){this._buff.writeUInt8(P.length,this._offset),this._offset+=1;for(let w=0,F=P.length;w<F;w++){const M=P[w];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let K=0;K<M.buffers.length;++K)this.writeBuffer(M.buffers[K]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this._buff.readUInt8(this._offset);this._offset+=1;let w=new Array(P);for(let F=0;F<P;F++)switch(this.readUInt8()){case 1:w[F]=this.readLongString();break;case 2:w[F]=this.readVSBuffer();break;case 3:const K=this.readUInt32(),G=this.readLongString(),N=[];for(let z=0;z<K;++z)N.push(this.readVSBuffer());w[F]=new n.SerializableObjectWithBuffers(A(G,N,null));break;case 4:w[F]=void 0;break}return w}}o.sizeUInt32=4;var l;(function(v){v[v.Simple=0]="Simple",v[v.Mixed=1]="Mixed"})(l||(l={}));class d{static _useMixedArgSerialization(P){for(let w=0,F=P.length;w<F;w++)if(P[w]instanceof L.VSBuffer||P[w]instanceof n.SerializableObjectWithBuffers||typeof P[w]=="undefined")return!0;return!1}static serializeRequestArguments(P,w){if(this._useMixedArgSerialization(P)){const F=[];for(let M=0,K=P.length;M<K;M++){const G=P[M];if(G instanceof L.VSBuffer)F[M]={type:2,value:G};else if(typeof G=="undefined")F[M]={type:4};else if(G instanceof n.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:z}=D(G.value,w);F[M]={type:3,value:L.VSBuffer.fromString(N),buffers:z}}else F[M]={type:1,value:L.VSBuffer.fromString(E(G,w))}}return{type:1,args:F}}return{type:0,args:E(P,w)}}static serializeRequest(P,w,F,M,K){switch(M.type){case 0:return this._requestJSONArgs(P,w,F,M.args,K);case 1:return this._requestMixedArgs(P,w,F,M.args,K)}}static _requestJSONArgs(P,w,F,M,K){const G=L.VSBuffer.fromString(F),N=L.VSBuffer.fromString(M);let z=0;z+=o.sizeUInt8(),z+=o.sizeShortString(G),z+=o.sizeLongString(N);let O=o.alloc(K?2:1,P,z);return O.writeUInt8(w),O.writeShortString(G),O.writeLongString(N),O.buffer}static deserializeRequestJSONArgs(P){const w=P.readUInt8(),F=P.readShortString(),M=P.readLongString();return{rpcId:w,method:F,args:JSON.parse(M)}}static _requestMixedArgs(P,w,F,M,K){const G=L.VSBuffer.fromString(F);let N=0;N+=o.sizeUInt8(),N+=o.sizeShortString(G),N+=o.sizeMixedArray(M);let z=o.alloc(K?4:3,P,N);return z.writeUInt8(w),z.writeShortString(G),z.writeMixedArray(M),z.buffer}static deserializeRequestMixedArgs(P){const w=P.readUInt8(),F=P.readShortString(),M=P.readMixedArray(),K=new Array(M.length);for(let G=0,N=M.length;G<N;G++){const z=M[G];typeof z=="string"?K[G]=JSON.parse(z):K[G]=z}return{rpcId:w,method:F,args:K}}static serializeAcknowledged(P){return o.alloc(5,P,0).buffer}static serializeCancel(P){return o.alloc(6,P,0).buffer}static serializeReplyOK(P,w,F){if(typeof w=="undefined")return this._serializeReplyOKEmpty(P);if(w instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(P,w);if(w instanceof n.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:K}=D(w.value,F,!0);return this._serializeReplyOKJSONWithBuffers(P,M,K)}else return this._serializeReplyOKJSON(P,c(w,F))}static _serializeReplyOKEmpty(P){return o.alloc(7,P,0).buffer}static _serializeReplyOKVSBuffer(P,w){let F=0;F+=o.sizeVSBuffer(w);let M=o.alloc(8,P,F);return M.writeVSBuffer(w),M.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static _serializeReplyOKJSON(P,w){const F=L.VSBuffer.fromString(w);let M=0;M+=o.sizeLongString(F);let K=o.alloc(9,P,M);return K.writeLongString(F),K.buffer}static _serializeReplyOKJSONWithBuffers(P,w,F){const M=L.VSBuffer.fromString(w);let K=0;K+=o.sizeUInt32,K+=o.sizeLongString(M);for(const N of F)K+=o.sizeVSBuffer(N);let G=o.alloc(10,P,K);G.writeUInt32(F.length),G.writeLongString(M);for(const N of F)G.writeBuffer(N);return G.buffer}static deserializeReplyOKJSON(P){const w=P.readLongString();return JSON.parse(w)}static deserializeReplyOKJSONWithBuffers(P,w){const F=P.readUInt32(),M=P.readLongString(),K=[];for(let G=0;G<F;++G)K.push(P.readVSBuffer());return new n.SerializableObjectWithBuffers(A(M,K,w))}static serializeReplyErr(P,w){return w?this._serializeReplyErrEror(P,w):this._serializeReplyErrEmpty(P)}static _serializeReplyErrEror(P,w){const F=L.VSBuffer.fromString(c(C.transformErrorForSerialization(w),null));let M=0;M+=o.sizeLongString(F);let K=o.alloc(11,P,M);return K.writeLongString(F),K.buffer}static deserializeReplyErrError(P){const w=P.readLongString();return JSON.parse(w)}static _serializeReplyErrEmpty(P){return o.alloc(12,P,0).buffer}}var b;(function(v){v[v.RequestJSONArgs=1]="RequestJSONArgs",v[v.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",v[v.RequestMixedArgs=3]="RequestMixedArgs",v[v.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",v[v.Acknowledged=5]="Acknowledged",v[v.Cancel=6]="Cancel",v[v.ReplyOKEmpty=7]="ReplyOKEmpty",v[v.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",v[v.ReplyOKJSON=9]="ReplyOKJSON",v[v.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",v[v.ReplyErrError=11]="ReplyErrError",v[v.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var _;(function(v){v[v.String=1]="String",v[v.VSBuffer=2]="VSBuffer",v[v.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",v[v.Undefined=4]="Undefined"})(_||(_={}))}),define(me[266],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(me[267],ge([0,1,10,8,11,2,4,86,44,224,266]),function(J,e,m,L,k,C,R,S,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,R.createDecorator)("pathService");let I=class Wn{constructor(f,h,p,D){this.localUserHome=f,this.remoteAgentService=h,this.environmentService=p,this.contextService=D,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||k.OS)(),this.resolveUserHome=(async()=>{const A=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=A?.userHome||f})()}get defaultUriScheme(){return Wn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,h){if(f.remoteAuthority)return m.Schemas.vscodeRemote;const p=(0,S.getVirtualWorkspaceScheme)(h.getWorkspace());if(p)return p;const D=h.getWorkspace().folders[0];if(D)return D.uri.scheme;const A=h.getWorkspace().configuration;return A?A.scheme:m.Schemas.file}async userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?L.win32:L.posix)}async fileURI(f){let h="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const D=f.indexOf("/",2);D===-1?(h=f.substring(2),f="/"):(h=f.substring(2,D),f=f.substring(D)||"/")}return C.URI.from({scheme:m.Schemas.file,authority:h,path:f,query:"",fragment:""})}};I=Ve([$e(1,n.IRemoteAgentService),$e(2,T.IWorkbenchEnvironmentService),$e(3,y.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(me[71],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(R,S){this.line=R,this.character=S}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,S){return new m(0,0)}with(R){return new m(0,0)}}e.Position=m;class L{constructor(R,S,y,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(R,S),this.end=new m(y,T)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new L(0,0,0,0)}with(R){return new L(0,0,0,0)}}e.Range=L;var k;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,17,30,25,29,9,4,8,16,71,13]),function(J,e,m,L,k,C,R,S,y,T,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const c="\u27EA ",f=" characters skipped \u27EB",h=(c.length+f.length+5)*2;e.ISearchService=(0,S.createDecorator)("searchService");var p;(function(x){x[x.file=0]="file",x[x.text=1]="text"})(p=e.SearchProviderType||(e.SearchProviderType={}));var D;(function(x){x[x.File=1]="File",x[x.Text=2]="Text"})(D=e.QueryType||(e.QueryType={}));function A(x){return!!x.preview}e.resultIsMatch=A;function E(x){return!!x.resource}e.isFileMatch=E;function a(x){return!!x.message}e.isProgressMessage=a;var s;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(s=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(B){this.resource=B,this.results=[]}}e.FileMatch=g;class t{constructor(B,U,H){this.ranges=U;const W=Array.isArray(U)?U:[U];if(H&&H.matchLines===1&&u(W)){B=(0,R.getNLines)(B,H.matchLines);let Q="",Y=0,he=0;const _e=Math.floor(H.charsPerLine/5),Se=[];for(const Re of W){const xe=Math.max(Re.startColumn-_e,0),Ue=Re.startColumn+H.charsPerLine;if(xe>he+_e+h){const je=c+(xe-he)+f;Q+=je+B.slice(xe,Ue),Y+=xe-(he+je.length)}else Q+=B.slice(he,Ue);Se.push(new i(0,Re.startColumn-Y,Re.endColumn-Y)),he=Ue}this.preview={text:Q,matches:Array.isArray(this.ranges)?Se:Se[0]}}else{const Q=Array.isArray(U)?U[0].startLineNumber:U.startLineNumber;this.preview={text:B,matches:(0,m.mapArrayOrNot)(U,Y=>new r(Y.startLineNumber-Q,Y.startColumn,Y.endLineNumber-Q,Y.endColumn))}}}}e.TextSearchMatch=t;function u(x){const B=x[0].startLineNumber;for(const U of x)if(U.startLineNumber!==B||U.endLineNumber!==B)return!1;return!0}class r{constructor(B,U,H,W){this.startLineNumber=B,this.startColumn=U,this.endLineNumber=H,this.endColumn=W}}e.SearchRange=r;class i extends r{constructor(B,U,H){super(B,U,B,H)}}e.OneLineRange=i;var o;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(o=e.SearchSortOrder||(e.SearchSortOrder={}));function l(x,B=!0){const U=x&&x.files&&x.files.exclude,H=B&&x&&x.search&&x.search.exclude;if(!U&&!H)return;if(!U||!H)return U||H;let W=Object.create(null);return W=k.mixin(W,k.deepClone(U)),W=k.mixin(W,k.deepClone(H),!0),W}e.getExcludes=l;function d(x,B){return x.excludePattern&&L.match(x.excludePattern,B)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&L.match(x.includePattern,B)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(U=>{const H=U.folder.fsPath;if(C.isEqualOrParent(B,H)){const W=y.relative(H,B);return!U.includePattern||!!L.match(U.includePattern,W)}else return!1}):!1:!0}e.pathIncludedInQuery=d;var b;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(B,U){super(B);this.code=U}}e.SearchError=_;function v(x){const B=x.message;if((0,T.isPromiseCanceledError)(x))return new _(B,b.canceled);try{const U=JSON.parse(B);return new _(U.message,U.code)}catch(U){return new _(B,b.other)}}e.deserializeSearchError=v;function P(x){const B={message:x.message,code:x.code};return new Error(JSON.stringify(B))}e.serializeSearchError=P;function w(x){return x.type==="error"?!0:x.type==="success"}e.isSerializedSearchComplete=w;function F(x){return x.type==="success"}e.isSerializedSearchSuccess=F;function M(x){return!!x.path}e.isSerializedFileMatch=M;function K(x,B){const U=x.searchPath?x.searchPath:x.relativePath;return(0,R.fuzzyContains)(U,B)}e.isFilePatternMatch=K;class G{constructor(B){this.path=B,this.results=[]}addMatch(B){this.results.push(B)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=G;function N(x,B){const U={...x||{},...B||{}};return Object.keys(U).filter(H=>{const W=U[H];return typeof W=="boolean"&&W})}e.resolvePatternsForProvider=N;class z{constructor(B,U){this._parsedIncludeExpression=null,this._excludeExpression={...B.excludePattern||{},...U.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let H=B.includePattern;U.includePattern&&(H?H={...H,...U.includePattern}:H=U.includePattern),H&&(this._parsedIncludeExpression=L.parse(H))}includedInQuerySync(B,U,H){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(B,U,H)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(B,U,H))}includedInQuery(B,U,H){const W=this._parsedExcludeExpression(B,U,H),Q=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(B,U,H):!0;return(0,I.isPromise)(W)?W.then(Y=>Y?!1:Q()):Q()}hasSiblingExcludeClauses(){return O(this._excludeExpression)}}e.QueryGlobTester=z;function O(x){for(const B in x)if(typeof x[B]!="boolean")return!0;return!1}}),define(me[36],ge([0,1,17,18,21,3,24,10,77,23,9,13,2,170,4,12,190,44,52,27,14,7,31,5]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D,A,E,a,s,g,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(P,w,F){return new T.ExtUri(M=>d(M,F)).isEqual(P,w)}function i(P,w,F){return r(P.uri,w.uri,F)?0:(0,n.compare)(P.uri.toString(),w.uri.toString())}function o(P,w,F){return P.index!==w.index?P.index<w.index?-1:1:r(P.uri,w.uri,F)?(0,n.compare)(P.name,w.name):(0,n.compare)(P.uri.toString(),w.uri.toString())}function l(P,w,F,M){const K=P.slice(0).sort((N,z)=>F(N,z,M)),G=w.slice(0).sort((N,z)=>F(N,z,M));return(0,m.delta)(K,G,(N,z)=>F(N,z,M))}function d(P,w){const F=w.getCapabilities(P.scheme);return!(F&&F&1024)}class b extends A.Workspace{constructor(w,F,M,K,G,N){super(w,M.map(z=>new A.WorkspaceFolder(z)),K,N);this._name=F,this._isUntitled=G,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(N),M.forEach(z=>{this._workspaceFolders.push(z),this._structure.set(z.uri,z)})}static toExtHostWorkspace(w,F,M,K){if(!w)return{workspace:null,added:[],removed:[]};const{id:G,name:N,folders:z,configuration:O,isUntitled:x}=w,B=[],U=F;F?z.forEach((Y,he)=>{const _e=c.URI.revive(Y.uri),Se=b._findFolder(M||F,_e,K);Se?(Se.name=Y.name,Se.index=Y.index,B.push(Se)):B.push({uri:_e,name:Y.name,index:he})}):B.push(...z.map(({uri:Y,name:he,index:_e})=>({uri:c.URI.revive(Y),name:he,index:_e}))),B.sort((Y,he)=>Y.index<he.index?-1:1);const H=new b(G,N,B,O?c.URI.revive(O):null,!!x,Y=>d(Y,K)),{added:W,removed:Q}=l(U?U.workspaceFolders:[],H.workspaceFolders,i,K);return{workspace:H,added:W,removed:Q}}static _findFolder(w,F,M){for(let K=0;K<w.folders.length;K++){const G=w.workspaceFolders[K];if(r(G.uri,F,M))return G}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(w,F){return F&&this._structure.get(w)&&(w=(0,T.dirname)(w)),this._structure.findSubstr(w)}resolveWorkspaceFolder(w){return this._structure.get(w)}}let _=class{constructor(w,F,M,K){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=K,this._extHostFileSystemInfo=M,this._requestIdProvider=new y.Counter,this._barrier=new L.Barrier,this._proxy=w.getProxy(u.MainContext.MainThreadWorkspace),this._messageService=w.getProxy(u.MainContext.MainThreadMessageService);const G=F.workspace;this._confirmedWorkspace=G?new b(G.id,G.name,[],G.configuration?c.URI.revive(G.configuration):null,!!G.isUntitled,N=>d(N,M)):void 0}$initializeWorkspace(w,F){this._trusted=F,this.$acceptWorkspaceData(w),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:S.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(w,F,M,...K){const G=[];if(Array.isArray(K)&&K.forEach(B=>{c.URI.isUri(B.uri)&&!G.some(U=>r(U.uri,B.uri,this._extHostFileSystemInfo))&&G.push({uri:B.uri,name:B.name||(0,T.basenameOrAuthority)(B.uri)})}),this._unconfirmedWorkspace||[F,M].some(B=>typeof B!="number"||B<0)||M===0&&G.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(F+M>N.length)return!1;const z=N.slice(0);z.splice(F,M,...G.map(B=>({uri:B.uri,name:B.name||(0,T.basenameOrAuthority)(B.uri),index:void 0})));for(let B=0;B<z.length;B++){const U=z[B];if(z.some((H,W)=>W!==B&&r(U.uri,H.uri,this._extHostFileSystemInfo)))return!1}z.forEach((B,U)=>B.index=U);const{added:O,removed:x}=l(N,z,o,this._extHostFileSystemInfo);if(O.length===0&&x.length===0)return!1;if(this._proxy){const B=w.displayName||w.name;this._proxy.$updateWorkspaceFolders(B,F,M,G).then(void 0,U=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(D.Severity.Error,(0,f.localize)(0,null,B,U.toString()),{extension:w},[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(w,F){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(w,F)}async getWorkspaceFolder2(w,F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(w,F)}async resolveWorkspaceFolder(w){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(w)}getPath(){if(!this._actualWorkspace)return;const{folders:w}=this._actualWorkspace;if(w.length!==0)return w[0].uri.fsPath}getRelativePath(w,F){let M,K="";if(typeof w=="string"?(M=c.URI.file(w),K=w):typeof w!="undefined"&&(M=w,K=w.fsPath),!M)return K;const G=this.getWorkspaceFolder(M,!0);if(!G)return K;typeof F=="undefined"&&this._actualWorkspace&&(F=this._actualWorkspace.folders.length>1);let N=(0,T.relativePath)(G.uri,M);return F&&G.name&&(N=`${G.name}/${N}`),N}trySetWorkspaceFolders(w){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:w,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(w){const{workspace:F,added:M,removed:K}=b.toExtHostWorkspace(w,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=F||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:M,removed:K}))}findFiles(w,F,M,K,G=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${K.value}, entryPoint: findFiles`);let N;if(F===null?N=!1:F&&(typeof F=="string"?N=F:N=F.pattern),G&&G.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:O}=v(w);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(z),(0,I.withUndefinedAsNull)(O),(0,I.withUndefinedAsNull)(N),(0,I.withUndefinedAsNull)(M),G).then(x=>Array.isArray(x)?x.map(B=>c.URI.revive(B)):[])}async findTextInFiles(w,F,M,K,G=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${K.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),z=typeof F.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:O,folder:x}=v(F.include),B=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,U={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:z,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:O,excludePattern:B},H=!1;if(this._activeSearchCallbacks[N]=W=>{if(H)return;const Q=c.URI.revive(W.resource);W.results.forEach(Y=>{(0,t.resultIsMatch)(Y)?M({uri:Q,preview:{text:Y.preview.text,matches:(0,m.mapArrayOrNot)(Y.preview.matches,he=>new g.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))},ranges:(0,m.mapArrayOrNot)(Y.ranges,he=>new g.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))}):M({uri:Q,text:Y.text,lineNumber:Y.lineNumber})})},G.isCancellationRequested)return{};try{const W=await this._proxy.$startTextSearch(w,(0,I.withUndefinedAsNull)(x),U,N,G);return delete this._activeSearchCallbacks[N],W||{}}catch(W){throw delete this._activeSearchCallbacks[N],W}}$handleTextSearchResult(w,F){this._activeSearchCallbacks[F]&&this._activeSearchCallbacks[F](w)}saveAll(w){return this._proxy.$saveAll(w)}resolveProxy(w){return this._proxy.$resolveProxy(w)}get trusted(){return this._trusted}requestWorkspaceTrust(w){return this._proxy.$requestWorkspaceTrust(w)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};_=Ve([$e(0,s.IExtHostRpcService),$e(1,a.IExtHostInitDataService),$e(2,E.IExtHostFileSystemInfo),$e(3,p.ILogService)],_),e.ExtHostWorkspace=_,e.IExtHostWorkspace=(0,h.createDecorator)("IExtHostWorkspace");function v(P){let w,F;return P&&(typeof P=="string"?w=P:(w=P.pattern,F=P.baseFolder||c.URI.file(P.base))),{includePattern:w,folder:F}}}),define(me[37],ge([0,1,25,3,36,5,7,193,85,13,18,4,14,12,2]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function p(u,r){if(r){const i=r.split(".");let o=u;for(let l=0;o&&l<i.length;l++)o=o[i[l]];return o}}function D(u){return u instanceof h.URI}function A(u){return u&&u.uri instanceof h.URI&&u.languageId&&typeof u.languageId=="string"}function E(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function a(u){return u&&u.uri instanceof h.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function s(u){if(D(u))return{resource:u};if(A(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(E(u))return{overrideIdentifier:u.languageId};if(a(u))return{resource:u.uri};if(u===null)return{resource:null}}let g=class{constructor(r,i,o){this._proxy=r.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=o,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(r,i))}};g=Ve([$e(0,c.IExtHostRpcService),$e(1,k.IExtHostWorkspace),$e(2,f.ILogService)],g),e.ExtHostConfiguration=g;class t{constructor(r,i,o,l){this._onDidChangeConfiguration=new L.Emitter,this._proxy=r,this._logService=l,this._extHostWorkspace=i,this._configuration=S.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=S.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,o))}getConfiguration(r,i,o){const l=s(i)||{},d=this._toReadonlyValue(r?p(this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,l,o?.identifier);function b(v){if(v==null)return null;if(typeof v=="boolean")return v?1:4;switch(v){case R.ConfigurationTarget.Global:return 1;case R.ConfigurationTarget.Workspace:return 4;case R.ConfigurationTarget.WorkspaceFolder:return 5}}const _={has(v){return typeof p(d,v)!="undefined"},get:(v,P)=>{this._validateConfigurationAccess(r?`${r}.${v}`:v,l,o?.identifier);let w=p(d,v);if(typeof w=="undefined")w=P;else{let F;const M=(K,G)=>{let N;const z=()=>{F=F||(0,m.deepClone)(d),N=N||p(F,G)};return(0,T.isObject)(K)?new Proxy(K,{get:(O,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return z(),()=>N;if(F)return N=N||p(F,G),N[x];const B=O[x];return typeof x=="string"?M(B,`${G}.${x}`):B},set:(O,x,B)=>(z(),N&&(N[x]=B),!0),deleteProperty:(O,x)=>(z(),N&&delete N[x],!0),defineProperty:(O,x,B)=>(z(),N&&Object.defineProperty(N,x,B),!0)}):K};w=M(w,v)}return w},update:(v,P,w,F)=>{v=r?`${r}.${v}`:v;const M=b(w);return P!==void 0?this._proxy.$updateConfigurationOption(M,v,P,l,F):this._proxy.$removeConfigurationOption(M,v,l,F)},inspect:v=>{v=r?`${r}.${v}`:v;const P=(0,m.deepClone)(this._configuration.inspect(v,l,this._extHostWorkspace.workspace));if(P)return{key:v,defaultValue:P.default?.value,globalValue:P.user?.value,workspaceValue:P.workspace?.value,workspaceFolderValue:P.workspaceFolder?.value,defaultLanguageValue:P.default?.override,globalLanguageValue:P.user?.override,workspaceLanguageValue:P.workspace?.override,workspaceFolderLanguageValue:P.workspaceFolder?.override,languageIds:P.overrideIdentifiers}}};return typeof d=="object"&&(0,m.mixin)(_,d,!1),Object.freeze(_)}_toReadonlyValue(r){const i=o=>(0,T.isObject)(o)?new Proxy(o,{get:(l,d)=>i(l[d]),set:(l,d,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(l,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(l,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return i(r)}_validateConfigurationAccess(r,i,o){const l=y.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),d=o?`[${o.value}] `:"";if(l===4){typeof i?.resource=="undefined"&&this._logService.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){i?.resource&&this._logService.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const o=new S.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(l,d)=>o.affectsConfiguration(l,s(d))})}_toMap(r){return r.reduce((i,o)=>(i.set(o[0],o[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[72],ge([0,1,2,18,3,5,7,36,45,37,21,33,14,27,4,10,11,12,67,214,16]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D,A,E,a,s){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(G){function N(O){if(O!=null)return O}G.from=N;function z(O){if(O!=null)return O}G.to=z})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function(G){function N(O){if(O!=null)return O}G.from=N;function z(O){if(O!=null)return O}G.to=z})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(G){function N(O){if(O!=null)return O}G.from=N;function z(O){if(O!=null)return O}G.to=z})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(G){function N(x){if(x){const B=x;return B&&!!B.process}else return!1}G.is=N;function z(x){if(x==null)return;const B={process:x.process,args:x.args};return x.options&&(B.options=r.from(x.options)),B}G.from=z;function O(x){if(x!=null)return new R.ProcessExecution(x.process,x.args,x.options)}G.to=O})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(G){function N(O){if(O!=null)return O}G.from=N;function z(O){if(O!=null)return O}G.to=z})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var l;(function(G){function N(x){if(x){const B=x;return B&&(!!B.commandLine||!!B.command)}else return!1}G.is=N;function z(x){if(x==null)return;const B={};return x.commandLine!==void 0?B.commandLine=x.commandLine:(B.command=x.command,B.args=x.args),x.options&&(B.options=o.from(x.options)),B}G.from=z;function O(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new R.ShellExecution(x.commandLine,x.options):new R.ShellExecution(x.command,x.args?x.args:[],x.options)}G.to=O})(l=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var d;(function(G){function N(x){if(x){let B=x;return B&&B.customExecution==="customExecution"}else return!1}G.is=N;function z(x){return{customExecution:"customExecution"}}G.from=z;function O(x,B){return B.get(x)}G.to=O})(d=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(G){function N(z,O){let x;return z.scope!==void 0&&typeof z.scope!="number"?x=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===R.TaskScope.Workspace&&O&&O.workspaceFile?x=O.workspaceFile:x=a.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:x}}G.from=N})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var _;(function(G){function N(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}G.from=N})(_=e.TaskGroupDTO||(e.TaskGroupDTO={}));var v;(function(G){function N(x,B){if(x==null)return[];const U=[];for(let H of x){const W=z(H,B);W&&U.push(W)}return U}G.fromMany=N;function z(x,B){if(x==null)return;let U;x.execution instanceof R.ProcessExecution?U=i.from(x.execution):x.execution instanceof R.ShellExecution?U=l.from(x.execution):x.execution&&x.execution instanceof R.CustomExecution&&(U=d.from(x.execution));const H=t.from(x.definition);let W;return x.scope?typeof x.scope=="number"?W=x.scope:W=x.scope.uri:W=R.TaskScope.Workspace,!H||!W?void 0:{_id:x._id,definition:H,name:x.name,source:{extensionId:B.identifier.value,label:x.source,scope:W},execution:U,isBackground:x.isBackground,group:_.from(x.group),presentationOptions:u.from(x.presentationOptions),problemMatchers:x.problemMatchers,hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}G.from=z;async function O(x,B,U){if(x==null)return;let H;i.is(x.execution)?H=i.to(x.execution):l.is(x.execution)?H=l.to(x.execution):d.is(x.execution)&&(H=d.to(x._id,U));const W=t.to(x.definition);let Q;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?Q=x.source.scope:Q=await B.resolveWorkspaceFolder(m.URI.revive(x.source.scope)):Q=R.TaskScope.Workspace),!W||!Q)return;const Y=new R.Task(W,Q,x.name,x.source.label,H,x.problemMatchers);return x.isBackground!==void 0&&(Y.isBackground=x.isBackground),x.group!==void 0&&(Y.group=R.TaskGroup.from(x.group._id),Y.group&&(Y.group=new R.TaskGroup(Y.group.id,Y.group.label),x.group.isDefault&&(Y.group.isDefault=x.group.isDefault))),x.presentationOptions&&(Y.presentationOptions=u.to(x.presentationOptions)),x._id&&(Y._id=x._id),x.detail&&(Y.detail=x.detail),Y}G.to=O})(v=e.TaskDTO||(e.TaskDTO={}));var P;(function(G){function N(O){return O}G.from=N;function z(O){if(!!O)return Object.assign(Object.create(null),O)}G.to=z})(P=e.TaskFilterDTO||(e.TaskFilterDTO={}));class w{constructor(N,z,O){this._id=z,this._task=O,g.set(this,void 0),nt(this,g,N,"f")}get task(){return this._task}terminate(){Oe(this,g,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}g=new WeakMap;var F;(function(G){function N(z){return{id:z._id,task:void 0}}G.from=N})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let M=class{constructor(N,z,O,x,B,U,H,W){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=N.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=O,this._editorService=x,this._configurationService=B,this._terminalService=U,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=H,this._deprecationService=W,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,z,O){if(!O)return new R.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:z,provider:O,extension:N}),this._proxy.$registerTaskProvider(x,z),new R.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem(N,z){this._proxy.$registerTaskSystem(N,z)}fetchTasks(N){return this._proxy.$fetchTasks(P.from(N)).then(async z=>{const O=[];for(let x of z){const B=await v.to(x,this._workspaceProvider,this._providedCustomExecutions2);B&&O.push(B)}return O})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(z=>N.push(z)),N}terminateTask(N){if(!(N instanceof w))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,z,O){const x=this._providedCustomExecutions2.get(N.id);if(x){if(this._activeCustomExecutions2.get(N.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(N.id,x),this._terminalService.attachPtyToTerminal(z,await x.callback(O))}this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const z=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const z=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:z,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const z=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:N.exitCode})}$provideTasks(N,z){const O=this._handlers.get(N);if(!O)return Promise.reject(new Error("no handler found"));const x=[],B=(0,L.asPromise)(()=>O.provider.provideTasks(n.CancellationToken.None)).then(U=>this.provideTasksInternal(z,x,O,U));return new Promise(U=>{B.then(H=>{Promise.all(x).then(()=>{U(H)})})})}async $resolveTask(N,z){const O=this._handlers.get(N);if(!O)return Promise.reject(new Error("no handler found"));if(z.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${O.type}].`);const x=await v.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const B=await O.provider.resolveTask(x,n.CancellationToken.None);if(!B)return;this.checkDeprecation(B,O);const U=v.from(B,O.extension);if(!U)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(U.execution)&&await this.addCustomExecution(U,B,!0),await this.resolveTaskInternal(U)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,z,O){const x=await this._proxy.$createTaskId(N);!O&&!this._providedCustomExecutions2.has(x)&&this._notProvidedCustomExecutions.add(x),this._providedCustomExecutions2.set(x,z.execution)}async getTaskExecution(N,z){if(typeof N=="string"){const B=this._taskExecutionPromises.get(N);if(!B)throw new Error("Unexpected: The specified task is missing an execution");return B}let O=this._taskExecutionPromises.get(N.id);if(O)return O;const x=new Promise(async(B,U)=>{const H=z||await v.to(N.task,this._workspaceProvider,this._providedCustomExecutions2);H?B(new w(this,N.id,H)):U("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(N.id,x),x.then(B=>(this._taskExecutions.set(N.id,B),B),B=>Promise.reject(B))}checkDeprecation(N,z){N._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));let O=this._notProvidedCustomExecutions.values(),x=O.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=O.next()}};M=Ve([$e(0,c.IExtHostRpcService),$e(1,f.IExtHostInitDataService),$e(2,S.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,A.ILogService),$e(7,E.IExtHostApiDeprecationService)],M),e.ExtHostTaskBase=M;let K=class extends M{constructor(N,z,O,x,B,U,H,W){super(N,z,O,x,B,U,H,W);this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:D.PlatformToString(0)})}async executeTask(N,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const O=v.from(z,N);if(O===void 0)throw new Error("Task is not valid");if(d.is(O.execution))await this.addCustomExecution(O,z,!1);else throw new s.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution(O),z);return this._proxy.$executeTask(O).catch(B=>{throw new Error(B)}),x}provideTasksInternal(N,z,O,x){const B=[];if(x)for(let U of x){this.checkDeprecation(U,O),(!U.definition||!N[U.definition.type])&&this._logService.warn(`The task [${U.source}, ${U.name}] uses an undefined task type. The task will be ignored in the future.`);const H=v.from(U,O.extension);H&&d.is(H.execution)?(B.push(H),z.push(this.addCustomExecution(H,U,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:B,extension:O.extension}}async resolveTaskInternal(N){if(d.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,z,O){}};K=Ve([$e(0,c.IExtHostRpcService),$e(1,f.IExtHostInitDataService),$e(2,S.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,A.ILogService),$e(7,E.IExtHostApiDeprecationService)],K),e.WorkerExtHostTask=K,e.IExtHostTask=(0,h.createDecorator)("IExtHostTask")}),define(me[268],ge([0,1,17,58,30,79,24,10,8,23,9,13,2,146,176,120,44,128,267,31]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D,A,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let s=class{constructor(b,_,v,P){this.configurationService=b,this.workspaceContextService=_,this.editorGroupsService=v,this.pathService=P}text(b,_,v={}){b=this.getContentPattern(b,v);const P=this.configurationService.getValue(),w=_&&_.some(M=>!this.configurationService.getValue({resource:M}).search.useRipgrep);return{...this.commonQuery(_?.map(D.toWorkspaceFolder),v),type:2,contentPattern:b,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:P.search.usePCRE2||w||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles}}getContentPattern(b,_){const v=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const P={...b,wordSeparators:v.editor.wordSeparators};return this.isCaseSensitive(b,_)&&(P.isCaseSensitive=!0),this.isMultiline(b)&&(P.isMultiline=!0),P}file(b,_={}){return{...this.commonQuery(b,_),type:1,filePattern:_.filePattern?_.filePattern.trim():_.filePattern,exists:_.exists,sortByScore:_.sortByScore,cacheKey:_.cacheKey}}handleIncludeExclude(b,_){return b?(b=Array.isArray(b)?b.map(i):i(b),_?this.parseSearchPaths(b):{pattern:t(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],_={}){const v=this.handleIncludeExclude(_.includePattern,_.expandPatterns),P=this.handleIncludeExclude(_.excludePattern,_.expandPatterns),w=b.length>1,F=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(G=>this.getFolderQueryForSearchPath(G,_,P)):b.map(G=>this.getFolderQueryForRoot(G,_,P,w))).filter(G=>!!G),M={_reason:_._reason,folderQueries:F,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:_.extraFileResources,excludePattern:P.pattern,includePattern:v.pattern,onlyOpenEditors:_.onlyOpenEditors,maxResults:_.maxResults};if(_.onlyOpenEditors){const N=m.coalesce(m.flatten(this.editorGroupsService.groups.map(O=>O.editors.map(x=>x.resource)))).filter(O=>(0,a.pathIncludedInQuery)(M,O.fsPath)),z=this.commonQueryFromFileList(N);return{...M,...z}}const K=_.extraFileResources&&_.extraFileResources.filter(G=>(0,a.pathIncludedInQuery)(M,G.fsPath));return M.extraFileResources=K&&K.length?K:void 0,M}commonQueryFromFileList(b){const _=[],v=new R.ResourceMap,P={};let w=!1;return b.forEach(F=>{if(F.scheme===S.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(F)){const K=this.workspaceContextService.getWorkspaceFolder(F)?.uri??F.with({path:y.dirname(F.fsPath)});let G=v.get(K);G||(w=!0,G={folder:K,includePattern:{}},_.push(G),v.set(K,G));const N=y.relative(K.fsPath,F.fsPath);(0,I.assertIsDefined)(G.includePattern)[N.replace(/\\/g,"/")]=!0}else F.fsPath&&(w=!0,P[F.fsPath]=!0)}),{folderQueries:_,includePattern:P,usingSearchPaths:!0,excludePattern:w?void 0:{"**/*":!0}}}isCaseSensitive(b,_){if(_.isSmartCase){if(b.isRegExp){if(n.containsUppercaseCharacter(b.pattern,!0))return!0}else if(n.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,f.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const _=z=>y.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),P=(Array.isArray(b)?b:u(b)).map(z=>{const O=this.pathService.resolvedUserHome;return O?(0,C.untildify)(z,O.scheme===S.Schemas.file?O.fsPath:O.path):z}),w=L.groupBy(P,z=>_(z)?"searchPaths":"exprSegments"),F=(w.exprSegments||[]).map(z=>n.rtrim(z,"/")).map(z=>n.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),r(z))),M={},K=this.expandSearchPathPatterns(w.searchPaths||[]);K&&K.length&&(M.searchPaths=K);const G=m.flatten(F),N=t(...G);return N&&(M.pattern=N),M}getExcludesForFolder(b,_){return _.disregardExcludeSettings?void 0:(0,a.getExcludes)(b,!_.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const _=m.flatten(b.map(P=>{let{pathPortion:w,globPortion:F}=g(P);F&&(F=o(F));const M=this.expandOneSearchPath(w);return m.flatten(M.map(K=>this.resolveOneSearchPathPattern(K,F)))})),v=new Map;return _.forEach(P=>{const w=P.searchPath.toString(),F=v.get(w);F?P.pattern&&(F.pattern=F.pattern||{},F.pattern[P.pattern]=!0):v.set(w,{searchPath:P.searchPath,pattern:P.pattern?t(P.pattern):void 0})}),Array.from(v.values())}expandOneSearchPath(b){if(y.isAbsolute(b)){const _=this.workspaceContextService.getWorkspace().folders;return _[0]&&_[0].uri.scheme!==S.Schemas.file?[{searchPath:_[0].uri.with({path:b})}]:[{searchPath:c.URI.file(y.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const _=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=i(b),b.startsWith("../")||b===".."){const P=y.posix.resolve(_.path,b);return[{searchPath:_.with({path:P})}]}const v=o(b);return[{searchPath:_,pattern:v}]}else{if(b==="./"||b===".\\")return[];{const _=b.replace(/^\.[\/\\]/,""),P=this.workspaceContextService.getWorkspace().folders.map(w=>{const F=_.match(new RegExp(`^${n.escapeRegExpCharacters(w.name)}(?:/(.*)|$)`));return F?{match:F,folder:w}:null}).filter(I.isDefined);if(P.length)return P.map(w=>{const F=w.match[1];return{searchPath:w.folder.uri,pattern:F&&o(F)}});{const w=b.match(/\.[\/\\](.+)[\/\\]?/),F=w?w[1]:b,M=h.localize(0,null,F);throw new Error(M)}}}}resolveOneSearchPathPattern(b,_){const v=b.pattern&&_?`${b.pattern}/${_}`:b.pattern||_,P=[{searchPath:b.searchPath,pattern:v}];return v&&!v.endsWith("**")&&P.push({searchPath:b.searchPath,pattern:v+"/**"}),P}getFolderQueryForSearchPath(b,_,v){const P=this.getFolderQueryForRoot((0,D.toWorkspaceFolder)(b.searchPath),_,v,!1);return P?{...P,includePattern:b.pattern}:null}getFolderQueryForRoot(b,_,v,P){let w;const F=c.URI.isUri(b)?b:b.uri;if(v.searchPaths){const z=v.searchPaths.filter(O=>(0,T.isEqual)(O.searchPath,F))[0];if(z&&!z.pattern)return null;z&&(w=z.pattern)}const M=this.configurationService.getValue({resource:F}),G={...this.getExcludesForFolder(M,_)||{},...w||{}},N=c.URI.isUri(b)?(0,T.basename)(b):b.name;return{folder:F,folderName:P?N:void 0,excludePattern:Object.keys(G).length>0?G:void 0,fileEncoding:M.files&&M.files.encoding,disregardIgnoreFiles:typeof _.disregardIgnoreFiles=="boolean"?_.disregardIgnoreFiles:!M.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof _.disregardGlobalIgnoreFiles=="boolean"?_.disregardGlobalIgnoreFiles:!M.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof _.ignoreSymlinks=="boolean"?_.ignoreSymlinks:!M.search.followSymlinks}}};s=Ve([$e(0,p.IConfigurationService),$e(1,D.IWorkspaceContextService),$e(2,A.IEditorGroupsService),$e(3,E.IPathService)],s),e.QueryBuilder=s;function g(d){const b=d.match(/[\*\{\}\(\)\[\]\?]/);if(b){const _=b.index,v=d.substr(0,_).match(/[/|\\][^/\\]*$/);if(v){let P=d.substr(0,v.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:d.substr((v.index||0)+1)}}}return{pathPortion:d}}function t(...d){return d.length?d.reduce((b,_)=>(b[_]=!0,b),Object.create(null)):void 0}function u(d){return k.splitGlobAware(d,",").map(b=>b.trim()).filter(b=>!!b.length)}function r(d){return[`**/${d}/**`,`**/${d}`].map(_=>_.replace(/\*\*\/\*\*/g,"**"))}function i(d){return d.replace(/\\/g,"/")}function o(d){return i(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(d,b){d=m.distinct(d,P=>P.toString());const _=[],v=b.getWorkspace();return d&&d.forEach(P=>{let w;if(b.getWorkbenchState()===2)w=(0,T.relativePath)(v.folders[0].uri,P),w&&w!=="."&&(w="./"+w);else{const F=b.getWorkspaceFolder(P);if(F){const M=F.name;if(v.folders.filter(G=>G.name===M).length===1){const G=(0,T.relativePath)(F.uri,P);G===""?w=`./${F.name}`:w=`./${F.name}/${G}`}else w=P.fsPath}}w&&_.push(w)}),_}e.resolveResourcesForSearchIncludes=l}),define(me[269],ge([0,1,23,2,21,16,4,268,31,44]),function(J,e,m,L,k,C,R,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function I(p,D){const A=D.activationEvents;if(!A)return Promise.resolve(void 0);const E=[],a=[];for(const i of A)if(/^workspaceContains:/.test(i)){const o=i.substr("workspaceContains:".length);o.indexOf("*")>=0||o.indexOf("?")>=0||p.forceUsingSearch?a.push(o):E.push(o)}if(E.length===0&&a.length===0)return Promise.resolve(void 0);let s;const g=new Promise((i,o)=>{s=i}),t=i=>s({activationEvent:i}),u=Promise.all(E.map(i=>c(p,i,t))).then(()=>{}),r=f(p,D.identifier,a,t);return Promise.all([u,r]).then(()=>{s(void 0)}),g}e.checkActivateWorkspaceContainsExtension=I;async function c(p,D,A){for(const E of p.folders)if(await p.exists(m.joinPath(L.URI.revive(E),D))){A(`workspaceContains:${D}`);return}}async function f(p,D,A,E){if(A.length===0)return Promise.resolve(void 0);const a=new k.CancellationTokenSource,s=p.checkExists(p.folders,A,a.token),g=setTimeout(async()=>{a.cancel(),E(`workspaceContainsTimeout:${A.join(",")}`)},n);let t=!1;try{t=await s}catch(u){C.isPromiseCanceledError(u)||C.onUnexpectedError(u)}a.dispose(),clearTimeout(g),t&&E(`workspaceContains:${A.join(",")}`)}function h(p,D,A,E){const a=p.get(R.IInstantiationService),s=p.get(y.ISearchService),t=a.createInstance(S.QueryBuilder).file(D.map(u=>(0,T.toWorkspaceFolder)(L.URI.revive(u))),{_reason:"checkExists",includePattern:A,exists:!0});return s.fileSearch(t,E).then(u=>!!u.limitHit,u=>C.isPromiseCanceledError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=h});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[41],ge([0,1,165,8,73,23,18,6,24,2,12,5,37,227,92,36,35,225,16,26,22,200,7,121,4,27,69,14,84,53,33,3,269,90,202]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D,A,E,a,s,g,t,u,r,i,o,l,d,b,_,v,P,w,F){"use strict";var M,K,G;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let N=class Hn extends S.Disposable{constructor(B,U,H,W,Q,Y,he,_e,Se,Re){super();this._onDidChangeRemoteConnectionData=this._register(new v.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=U,this._extHostContext=H,this._initData=he,this._extHostWorkspace=W,this._extHostConfiguration=Q,this._logService=Y,this._extHostTunnelService=Se,this._extHostTerminalService=Re,this._disposables=new S.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._registry=new A.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new h.ExtHostStorage(this._extHostContext),this._secretState=new w.ExtHostSecretState(this._extHostContext),this._storagePath=_e,this._instaService=B.createChild(new d.ServiceCollection([h.IExtHostStorage,this._storage],[w.IExtHostSecretState,this._secretState]));const xe=new Set;this._initData.hostExtensions.forEach(Ue=>xe.add(a.ExtensionIdentifier.toKey(Ue))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ue,je,V)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ue,E.transformErrorForSerialization(je),V)},actualActivateExtension:async(Ue,je)=>{if(xe.has(a.ExtensionIdentifier.toKey(Ue)))return await this._mainThreadExtensionsProxy.$activateExtension(Ue,je),new f.HostExtension;const V=this._registry.getExtensionDescription(Ue);return this._activateExtension(V,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(B){E.onUnexpectedError(B)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let B=[];try{B=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch(U){}await Promise.all(B)}isActivated(B){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(B):!1}_activateByEvent(B,U){return this._activator.activateByEvent(B,U)}_activateById(B,U){return this._activator.activateById(B,U)}activateByIdWithErrors(B,U){return this._activateById(B,U).then(()=>{const H=this._activator.getActivatedExtension(B);if(H.activationFailed)return Promise.reject(H.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(B=>this._registry)}getExtensionExports(B){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(B).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const B=y.TernarySearchTree.forPaths(),U=this._registry.getAllExtensionDescriptions().map(H=>{if(!!this._getEntryPoint(H))return this._hostUtils.realpath(H.extensionLocation.fsPath).then(W=>B.set(T.URI.file(W).fsPath,H))});this._extensionPathIndex=Promise.all(U).then(()=>B)}return this._extensionPathIndex}_deactivate(B){let U=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(B))return U;const H=this._activator.getActivatedExtension(B);if(!H)return U;try{typeof H.module.deactivate=="function"&&(U=Promise.resolve(H.module.deactivate()).then(void 0,W=>(this._logService.error(W),Promise.resolve(void 0))))}catch(W){this._logService.error(W)}try{(0,S.dispose)(H.subscriptions)}catch(W){this._logService.error(W)}return U}async _activateExtension(B,U){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier),this._doActivateExtension(B,U).then(H=>{const W=H.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(B.identifier,W.codeLoadingTime,W.activateCallTime,W.activateResolvedTime,U),this._logExtensionActivationTimes(B,U,"success",W),H},H=>{throw this._logExtensionActivationTimes(B,U,"failure"),H})}_logExtensionActivationTimes(B,U,H,W){const Q=z(B,U);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Q,...W||{},outcome:H})}_doActivateExtension(B,U){const H=z(B,U);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",H);const W=this._getEntryPoint(B);if(!W)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${B.identifier.value} ${JSON.stringify(U)}`),this._logService.flush();const Q=new f.ExtensionActivationTimesBuilder(U.startup);return Promise.all([this._loadCommonJSModule(B.identifier,(0,C.joinPath)(B.extensionLocation,W),Q),this._loadExtensionContext(B)]).then(Y=>(k.mark(`code/extHost/willActivateExtension/${B.identifier.value}`),Hn._callActivate(this._logService,B.identifier,Y[0],Y[1],Q))).then(Y=>(k.mark(`code/extHost/didActivateExtension/${B.identifier.value}`),Y))}_loadExtensionContext(B){const U=new g.ExtensionGlobalMemento(B,this._storage),H=new g.ExtensionMemento(B.identifier.value,!1,this._storage),W=new F.ExtensionSecrets(B,this._secretState),Q=B.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Y=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${B.identifier.value}`),Promise.all([U.whenReady,H.whenReady,this._storagePath.whenReady]).then(()=>{const he=this;let _e;return Object.freeze({globalState:U,workspaceState:H,secrets:W,subscriptions:[],get extensionUri(){return B.extensionLocation},get extensionPath(){return B.extensionLocation.fsPath},asAbsolutePath(Se){return L.join(B.extensionLocation.fsPath,Se)},get storagePath(){return he._storagePath.workspaceValue(B)?.fsPath},get globalStoragePath(){return he._storagePath.globalValue(B).fsPath},get logPath(){return L.join(he._initData.logsLocation.fsPath,B.identifier.value)},get logUri(){return T.URI.joinPath(he._initData.logsLocation,B.identifier.value)},get storageUri(){return he._storagePath.workspaceValue(B)},get globalStorageUri(){return he._storagePath.globalValue(B)},get extensionMode(){return Q},get extension(){return _e===void 0&&(_e=new O(he,B.identifier,B,Y)),_e},get extensionRuntime(){return(0,D.checkProposedApiEnabled)(B),he.extensionRuntime},get environmentVariableCollection(){return he._extHostTerminalService.getEnvironmentVariableCollection(B)}})})}static _callActivate(B,U,H,W,Q){return H=H||{activate:void 0,deactivate:void 0},this._callActivateOptional(B,U,H,W,Q).then(Y=>new f.ActivatedExtension(!1,null,Q.build(),H,Y,W.subscriptions))}static _callActivateOptional(B,U,H,W,Q){if(typeof H.activate=="function")try{Q.activateCallStart(),B.trace(`ExtensionService#_callActivateOptional ${U.value}`);const Y=typeof global=="object"?global:self,he=H.activate.apply(Y,[W]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(he).then(_e=>(Q.activateResolveStop(),_e))}catch(Y){return Promise.reject(Y)}else return Promise.resolve(H)}_activateOneStartupFinished(B,U){this._activateById(B.identifier,{startup:!1,extensionId:B.identifier,activationEvent:U}).then(void 0,H=>{this._logService.error(H)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const B of this._registry.getAllExtensionDescriptions())if(B.activationEvents)for(const U of B.activationEvents)U==="onStartupFinished"&&this._activateOneStartupFinished(B,U)}_handleEagerExtensions(){const B=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const U=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],H=this._handleWorkspaceContainsEagerExtensions(U),W=Promise.all([B,H]).then(()=>{});return Promise.race([W,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),W}_handleWorkspaceContainsEagerExtensions(B){return B.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(U=>this._handleWorkspaceContainsEagerExtension(B,U))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(B,U){if(this.isActivated(U.identifier))return;const H=!this._initData.remote.isRemote&&!!this._initData.remote.authority,W={folders:B.map(Y=>Y.uri),forceUsingSearch:H,exists:Y=>this._hostUtils.exists(Y.fsPath),checkExists:(Y,he,_e)=>this._mainThreadWorkspaceProxy.$checkExists(Y,he,_e)},Q=await(0,P.checkActivateWorkspaceContainsExtension)(W,U);if(!!Q)return this._activateById(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:Q.activationEvent}).then(void 0,Y=>this._logService.error(Y))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(B){throw console.error(B),B}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:B,extensionTestsLocationURI:U}=this._initData.environment;if(!B||!U)throw new Error(m.localize(0,null));const H=await this._loadCommonJSModule(null,U,new f.ExtensionActivationTimesBuilder(!1));if(!H||typeof H.run!="function")throw new Error(m.localize(1,null,U.toString()));return new Promise((W,Q)=>{const Y=(Se,Re)=>{Se?Q(Se):W(typeof Re=="number"&&Re>0?1:0)},he=(0,C.originalFSPath)(U),_e=H.run(he,Y);_e&&_e.then&&_e.then(()=>{W(0)}).catch(Se=>{Q(Se.toString())})})}async $extensionTestsExit(B){this._logService.info(`extension host terminating: test runner requested exit with code ${B}`),this._logService.info(`exiting with code ${B}`),this._logService.flush(),this._hostUtils.exit(B)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(B,U){return this._resolvers[B]=U,(0,S.toDisposable)(()=>{delete this._resolvers[B]})}async _activateAndGetResolver(B){const U=B.indexOf("+");if(U===-1)throw new Error("Not an authority that can be resolved!");const H=B.substr(0,U);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${H}`,!1),{authorityPrefix:H,resolver:this._resolvers[H]}}async $resolveAuthority(B,U){const{authorityPrefix:H,resolver:W}=await this._activateAndGetResolver(B);if(!W)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${H}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(W)),k.mark(`code/extHost/willResolveAuthority/${H}`);const Q=await W.resolve(B,{resolveAttempt:U});k.mark(`code/extHost/didResolveAuthorityOK/${H}`);const Y={authority:B,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},he={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted};return{type:"ok",value:{authority:Y,options:he,tunnelInformation:{environmentTunnels:Q.environmentTunnels}}}}catch(Q){if(k.mark(`code/extHost/didResolveAuthorityError/${H}`),Q instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(B,U){const{authorityPrefix:H,resolver:W}=await this._activateAndGetResolver(B);if(!W)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${H}`);const Q=T.URI.revive(U);if(typeof W.getCanonicalURI=="undefined")return Q;const Y=await(0,R.asPromise)(()=>W.getCanonicalURI(Q));return Y||Q}$startExtensionHost(B){return this._registry.keepOnly(B),this._startExtensionHost()}$activateByEvent(B,U){return U===1?this._activateByEvent(B,!1):this._readyToRunExtensions.wait().then(H=>this._activateByEvent(B,!1))}async $activate(B,U){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(B)?(await this._activateById(B,U),!0):!1}async $deltaExtensions(B,U){B.forEach(W=>W.extensionLocation=T.URI.revive(W.extensionLocation));const H=await this.getExtensionPathIndex();return await Promise.all(U.map(async W=>{const Q=this._registry.getExtensionDescription(W);if(!Q)return;const Y=await this._hostUtils.realpath(Q.extensionLocation.fsPath);H.delete(T.URI.file(Y).fsPath)})),await Promise.all(B.map(async W=>{const Q=await this._hostUtils.realpath(W.extensionLocation.fsPath);H.set(T.URI.file(Q).fsPath,W)})),this._registry.deltaExtensions(B,U),Promise.resolve(void 0)}async $test_latency(B){return B}async $test_up(B){return B.byteLength}async $test_down(B){let U=s.VSBuffer.alloc(B),H=Math.random()%256;for(let W=0;W<B;W++)U.writeUInt8(H,W);return U}async $updateRemoteConnectionData(B){this._remoteConnectionData=B,this._onDidChangeRemoteConnectionData.fire()}};N=Ve([$e(0,r.IInstantiationService),$e(1,e.IHostUtils),$e(2,l.IExtHostRpcService),$e(3,p.IExtHostWorkspace),$e(4,c.IExtHostConfiguration),$e(5,n.ILogService),$e(6,i.IExtHostInitDataService),$e(7,o.IExtensionStoragePaths),$e(8,b.IExtHostTunnelService),$e(9,_.IExtHostTerminalService)],N),e.AbstractExtHostExtensionService=N;function z(x,B){return{id:x.identifier.value,name:x.name,extensionVersion:x.version,publisherDisplayName:x.publisher,activationEvents:x.activationEvents?x.activationEvents.join(","):null,isBuiltin:x.isBuiltin,reason:B.activationEvent,reasonId:B.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class O{constructor(B,U,H,W){M.set(this,void 0),K.set(this,void 0),G.set(this,void 0),nt(this,M,B,"f"),nt(this,K,U,"f"),nt(this,G,H.identifier,"f"),this.id=H.identifier.value,this.extensionUri=H.extensionLocation,this.extensionPath=L.normalize((0,C.originalFSPath)(H.extensionLocation)),this.packageJSON=H,this.extensionKind=W}get isActive(){return Oe(this,M,"f").isActivated(Oe(this,G,"f"))}get exports(){if(this.packageJSON.api!=="none")return Oe(this,M,"f").getExtensionExports(Oe(this,G,"f"))}activate(){return Oe(this,M,"f").activateByIdWithErrors(Oe(this,G,"f"),{startup:!1,extensionId:Oe(this,K,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=O,M=new WeakMap,K=new WeakMap,G=new WeakMap}),define(me[56],ge([0,1,8,2,3,18,5,7,124,36,41,45,216,37,210,14,4,13,38,54]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D,A,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,D.createDecorator)("IExtHostDebugService");let s=class{constructor(d,b,_,v,P,w){this._workspaceService=b,this._extensionService=_,this._editorsService=v,this._configurationService=P,this._editorTabs=w,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=d.getProxy(R.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(F=>{F.onDidChange(M=>{this.registerAllDebugTypes(F)}),this.registerAllDebugTypes(F)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(d,b){const _=d;if(typeof _.sourceReference=="number"&&_.sourceReference>0){let v=`debug:${encodeURIComponent(_.path||"")}`,P="?";return b&&(v+=`${P}session=${encodeURIComponent(b.id)}`,P="&"),v+=`${P}ref=${_.sourceReference}`,L.URI.parse(v)}else{if(_.path)return L.URI.file(_.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(d){const b=[];for(const _ of d.getAllExtensionDescriptions())if(_.contributes){const v=_.contributes.debuggers;if(v&&v.length>0)for(const P of v)(0,h.isDebuggerMainContribution)(P)&&b.push(P.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const d=[];return this._breakpoints.forEach(b=>d.push(b)),d}addBreakpoints(d){this.startBreakpoints();const b=d.filter(P=>{const w=P.id;return this._breakpoints.has(w)?!1:(this._breakpoints.set(w,P),!0)});this.fireBreakpointChanges(b,[],[]);const _=[],v=new Map;for(const P of b)if(P instanceof S.SourceBreakpoint){let w=v.get(P.location.uri.toString());w||(w={type:"sourceMulti",uri:P.location.uri,lines:[]},v.set(P.location.uri.toString(),w),_.push(w)),w.lines.push({id:P.id,enabled:P.enabled,condition:P.condition,hitCondition:P.hitCondition,logMessage:P.logMessage,line:P.location.range.start.line,character:P.location.range.start.character})}else P instanceof S.FunctionBreakpoint&&_.push({type:"function",id:P.id,enabled:P.enabled,hitCondition:P.hitCondition,logMessage:P.logMessage,condition:P.condition,functionName:P.functionName});return this._debugServiceProxy.$registerBreakpoints(_)}removeBreakpoints(d){this.startBreakpoints();const b=d.filter(w=>this._breakpoints.delete(w.id));this.fireBreakpointChanges([],b,[]);const _=b.filter(w=>w instanceof S.SourceBreakpoint).map(w=>w.id),v=b.filter(w=>w instanceof S.FunctionBreakpoint).map(w=>w.id),P=b.filter(w=>w instanceof S.DataBreakpoint).map(w=>w.id);return this._debugServiceProxy.$unregisterBreakpoints(_,v,P)}startDebugging(d,b,_){return this._debugServiceProxy.$startDebugging(d?d.uri:void 0,b,{parentSessionID:_.parentSession?_.parentSession.id:void 0,lifecycleManagedByParent:_.lifecycleManagedByParent,repl:_.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:_.noDebug,compact:_.compact,debugUI:_.debugUI,suppressSaveBeforeStart:_.suppressSaveBeforeStart})}stopDebugging(d){return this._debugServiceProxy.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,b,_){if(!b)return new S.Disposable(()=>{});const v=this._configProviderHandleCounter++;return this._configProviders.push({type:d,handle:v,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(d,_,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,v),new S.Disposable(()=>{this._configProviders=this._configProviders.filter(P=>P.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(d,b,_){if(!_)return new S.Disposable(()=>{});if(!this.definesDebugType(d,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:v,factory:_}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,v),new S.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(P=>P.factory!==_),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(d,b){if(!b)return new S.Disposable(()=>{});const _=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:d,handle:_,factory:b}),new S.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(v=>v.factory!==b)})}async $runInTerminal(d,b){return Promise.resolve(void 0)}async $substituteVariables(d,b){if(!this._variableResolver){const[P,w]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(P||[],this._editorsService,w)}let _;const v=await this.getFolder(d);return v&&(_={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(_,b)}createDebugAdapter(d,b){if(d.type==="implementation")return new i(d.implementation)}createSignService(){}async $startDASession(d,b){const _=this,v=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(v.type),v).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const w=this.convertToDto(P),F=this.createDebugAdapter(w,v);if(!F)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const M=F;return this._debugAdapters.set(d,M),this.getDebugAdapterTrackers(v).then(K=>(K&&this._debugAdaptersTrackers.set(d,K),M.onMessage(async G=>{if(G.type==="request"&&G.command==="handshake"){const N=G,z={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const O=await this._signService.sign(N.arguments.value);z.body={signature:O},M.sendResponse(z)}else throw new Error("no signer")}catch(O){z.success=!1,z.message=O.message,M.sendResponse(z)}}else K&&K.onDidSendMessage&&K.onDidSendMessage(G),G=(0,h.convertToVSCPaths)(G,!0),_._debugServiceProxy.$acceptDAMessage(d,G)}),M.onError(G=>{K&&K.onError&&K.onError(G),this._debugServiceProxy.$acceptDAError(d,G.name,G.message,G.stack)}),M.onExit(G=>{K&&K.onExit&&K.onExit((0,A.withNullAsUndefined)(G),void 0),this._debugServiceProxy.$acceptDAExit(d,(0,A.withNullAsUndefined)(G),void 0)}),K&&K.onWillStartSession&&K.onWillStartSession(),M.startSession()))})}$sendDAMessage(d,b){b=(0,h.convertToDAPaths)(b,!1);const _=this._debugAdaptersTrackers.get(d);_&&_.onWillReceiveMessage&&_.onWillReceiveMessage(b);const v=this._debugAdapters.get(d);v&&v.sendMessage(b)}$stopDASession(d){const b=this._debugAdaptersTrackers.get(d);this._debugAdaptersTrackers.delete(d),b&&b.onWillStopSession&&b.onWillStopSession();const _=this._debugAdapters.get(d);return this._debugAdapters.delete(d),_?_.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const b=[],_=[],v=[];if(d.added)for(const P of d.added){const w=P.id;if(w&&!this._breakpoints.has(w)){let F;if(P.type==="function")F=new S.FunctionBreakpoint(P.functionName,P.enabled,P.condition,P.hitCondition,P.logMessage);else if(P.type==="data")F=new S.DataBreakpoint(P.label,P.dataId,P.canPersist,P.enabled,P.hitCondition,P.condition,P.logMessage);else{const M=L.URI.revive(P.uri);F=new S.SourceBreakpoint(new S.Location(M,new S.Position(P.line,P.character)),P.enabled,P.condition,P.hitCondition,P.logMessage)}F._id=w,this._breakpoints.set(w,F),b.push(F)}}if(d.removed)for(const P of d.removed){const w=this._breakpoints.get(P);w&&(this._breakpoints.delete(P),_.push(w))}if(d.changed){for(const P of d.changed)if(P.id){const w=this._breakpoints.get(P.id);if(w){if(w instanceof S.FunctionBreakpoint&&P.type==="function"){const F=w;F.enabled=P.enabled,F.condition=P.condition,F.hitCondition=P.hitCondition,F.logMessage=P.logMessage,F.functionName=P.functionName}else if(w instanceof S.SourceBreakpoint&&P.type==="source"){const F=w;F.enabled=P.enabled,F.condition=P.condition,F.hitCondition=P.hitCondition,F.logMessage=P.logMessage,F.location=new S.Location(L.URI.revive(P.uri),new S.Position(P.line,P.character))}v.push(w)}}}this.fireBreakpointChanges(b,_,v)}$provideDebugConfigurations(d,b,_){return(0,C.asPromise)(async()=>{const v=this.getConfigProviderByHandle(d);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const P=await this.getFolder(b);return v.provideDebugConfigurations(P,_)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(d,b,_,v){return(0,C.asPromise)(async()=>{const P=this.getConfigProviderByHandle(d);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const w=await this.getFolder(b);return P.resolveDebugConfiguration(w,_,v)})}$resolveDebugConfigurationWithSubstitutedVariables(d,b,_,v){return(0,C.asPromise)(async()=>{const P=this.getConfigProviderByHandle(d);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const w=await this.getFolder(b);return P.resolveDebugConfigurationWithSubstitutedVariables(w,_,v)})}async $provideDebugAdapter(d,b){const _=this.getAdapterDescriptorFactoryByHandle(d);if(!_)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.getSession(b);return this.getAdapterDescriptor(_,v).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.convertToDto(P)})}async $acceptDebugSessionStarted(d){const b=await this.getSession(d);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(d){const b=await this.getSession(d);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(d){this._activeDebugSession=d?await this.getSession(d):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(d,b){const _=await this.getSession(d);_&&_._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(d,b){const v={session:await this.getSession(d),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(v)}convertToDto(d){if(d instanceof S.DebugAdapterExecutable)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof S.DebugAdapterServer)return{type:"server",port:d.port,host:d.host};if(d instanceof S.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:d.path};if(d instanceof S.DebugAdapterInlineImplementation)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(d){const b=this._adapterFactories.filter(_=>_.type===d);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(d){const b=this._adapterFactories.filter(_=>_.handle===d);if(b.length>0)return b[0].factory}getConfigProviderByHandle(d){const b=this._configProviders.filter(_=>_.handle===d);if(b.length>0)return b[0].provider}definesDebugType(d,b){if(d.contributes){const _=d.contributes.debuggers;if(_&&_.length>0){for(const v of _)if(v.label&&v.type&&v.type===b)return!0}}return!1}getDebugAdapterTrackers(d){const _=d.configuration.type,v=this._trackerFactories.filter(P=>P.type===_||P.type==="*").map(P=>(0,C.asPromise)(()=>P.factory.createDebugAdapterTracker(d)).then(w=>w,w=>null));return Promise.race([Promise.all(v).then(P=>{const w=P.filter(F=>!!F);if(w.length>0)return new r(w)}),new Promise((P,w)=>{const F=setTimeout(()=>{clearTimeout(F),w(new Error("timeout"))},1e3)})]).catch(P=>{})}async getAdapterDescriptor(d,b){const _=b.configuration.debugServer;if(typeof _=="number")return Promise.resolve(new S.DebugAdapterServer(_));if(d){const P=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>d.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,P))).then(w=>{if(w)return w})}const v=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,v))}daExecutableFromPackage(d,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(d,b,_){(d.length>0||b.length>0||_.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:d,removed:b,changed:_}))}async getSession(d){if(d)if(typeof d=="string"){const b=this._debugSessions.get(d);if(b)return b}else{let b=this._debugSessions.get(d.id);if(!b){const _=await this.getFolder(d.folderUri),v=d.parent?this._debugSessions.get(d.parent):void 0;b=new g(this._debugServiceProxy,d.id,d.type,d.name,_,d.configuration,v),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(d){if(d){const b=L.URI.revive(d);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};s=Ve([$e(0,p.IExtHostRpcService),$e(1,T.IExtHostWorkspace),$e(2,n.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,f.IExtHostConfiguration),$e(5,a.IExtHostEditorTabs)],s),e.ExtHostDebugServiceBase=s;class g{constructor(d,b,_,v,P,w,F){this._debugServiceProxy=d,this._id=b,this._type=_,this._name=v,this._workspaceFolder=P,this._configuration=w,this._parentSession=F}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(d){this._name=d,this._debugServiceProxy.$setDebugSessionName(this._id,d)}get parentSession(){return this._parentSession}_acceptNameChanged(d){this._name=d}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(d,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,d,b)}getDebugProtocolBreakpoint(d){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,d.id)}}e.ExtHostDebugSession=g;class t{constructor(d){this.value=Object.freeze({append(b){d.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=t;class u extends c.AbstractVariableResolverService{constructor(d,b,_,v,P){function w(){if(b){const F=b.activeEditor();if(F)return F.document.uri;const M=v.tabs.filter(K=>K.isActive);if(M.length>0){const K=M[0].resource;return K&&(K.primary||K.secondary)?K.primary??K.secondary:M[0].resource}}}super({getFolderUri:F=>{const M=d.filter(K=>K.name===F);if(M&&M.length>0)return M[0].uri},getWorkspaceFolderCount:()=>d.length,getConfigurationValue:(F,M)=>_.getConfiguration(void 0,F).get(M),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const F=w();if(F)return m.normalize(F.fsPath)},getWorkspaceFolderPathForFile:()=>{if(P){const F=w();if(F){const M=P.getWorkspaceFolder(F);if(M)return m.normalize(M.uri.fsPath)}}},getSelectedText:()=>{if(b){const F=b.activeEditor();if(F&&!F.selection.isEmpty)return F.document.getText(F.selection)}},getLineNumber:()=>{if(b){const F=b.activeEditor();if(F)return String(F.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=u;class r{constructor(d){this.trackers=d}onWillStartSession(){this.trackers.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(d):void 0)}onWillStopSession(){this.trackers.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.trackers.forEach(b=>b.onError?b.onError(d):void 0)}onExit(d,b){this.trackers.forEach(_=>_.onExit?_.onExit(d,b):void 0)}}class i extends y.AbstractDebugAdapter{constructor(d){super();this.implementation=d,d.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.implementation.handleMessage(d)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends s{constructor(d,b,_,v,P,w){super(d,b,_,v,P,w)}createVariableResolver(d,b,_){return new u(d,b,_,this._editorTabs)}};o=Ve([$e(0,p.IExtHostRpcService),$e(1,T.IExtHostWorkspace),$e(2,n.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,f.IExtHostConfiguration),$e(5,a.IExtHostEditorTabs)],o),e.WorkerExtHostDebugService=o}),define(me[270],ge([0,1,73,2,5,37,35,26,14,27,4,41,38,12]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(a,s,g,t,u,r,i){this._apiFactory=a,this._extensionRegistry=s,this._instaService=g,this._extHostConfiguration=t,this._extHostExtensionService=u,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const s=await this._extHostExtensionService.getExtensionPathIndex();this.register(new p(this._apiFactory,s,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(D)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(A,s,this._initData.environment.appUriScheme))}register(a){if(Array.isArray(a.nodeModuleName))for(let s of a.nodeModuleName)this._factories.set(s,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(s=>a.alternativeModuleName(s))}};h=Ve([$e(2,n.IInstantiationService),$e(3,C.IExtHostConfiguration),$e(4,I.IExtHostExtensionService),$e(5,T.IExtHostInitDataService),$e(6,f.ILogService)],h),e.RequireInterceptor=h;class p{constructor(a,s,g,t,u){this._apiFactory=a,this._extensionPaths=s,this._extensionRegistry=g,this._configProvider=t,this._logService=u,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(a,s){const g=this._extensionPaths.findSubstr(s.fsPath);if(g){let t=this._extApiImpl.get(S.ExtensionIdentifier.toKey(g.identifier));return t||(t=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(S.ExtensionIdentifier.toKey(g.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((u,r)=>t+=`	${r} -> ${u.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${s.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let D=class{constructor(a,s){this.nodeModuleName="keytar";const{environment:g}=s,t=a.getProxy(k.MainContext.MainThreadKeytar);if(g.appRoot){let u=g.appRoot.fsPath;c.platform==="win32"&&(u=u.replace(/\\/g,"/")),u[u.length-1]==="/"&&(u=u.substr(0,u.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${u}/node_modules.asar/keytar`),this.alternativeNames.add(`${u}/node_modules/keytar`)}this._impl={getPassword:(u,r)=>t.$getPassword(u,r),setPassword:(u,r,i)=>t.$setPassword(u,r,i),deletePassword:(u,r)=>t.$deletePassword(u,r),findPassword:u=>t.$findPassword(u),findCredentials(u){return t.$findCredentials(u)}}}load(a,s){return this._impl}alternativeModuleName(a){const s=a.length;if(s<=7||!this.alternativeNames)return;const g=s-7;if((a.charAt(g)==="/"||a.charAt(g)==="\\")&&a.endsWith("keytar")&&(a=a.replace(/\\/g,"/"),this.alternativeNames.has(a)))return"keytar"}};D=Ve([$e(0,y.IExtHostRpcService),$e(1,T.IExtHostInitDataService)],D);let A=class{constructor(a,s,g){this._extensionPaths=a,this._appUriScheme=s,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(k.MainContext.MainThreadTelemetry);const t=g.getProxy(k.MainContext.MainThreadWindow);this._impl=(u,r)=>{const i=L.URI.parse(u);return r?this.callOriginal(u,r):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,u,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,u,{}):this.callOriginal(u,r)}}load(a,s,g){const t=this._extensionPaths.findSubstr(s.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=g(a),this._impl}callOriginal(a,s){return this.sendNoForwardTelemetry(),this._original(a,s)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};A=Ve([$e(2,y.IExtHostRpcService)],A)}),define(me[271],ge([0,1,171,11,7,211,36,41,45,37,33,14,56,195,18,212,54]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let A=class extends c.ExtHostDebugServiceBase{constructor(s,g,t,u,r,i,o){super(s,g,t,u,r,o);this._terminalService=i,this._integratedTerminalInstances=new E}createDebugAdapter(s,g){switch(s.type){case"server":return new C.SocketDebugAdapter(s);case"pipeServer":return new C.NamedPipeDebugAdapter(s);case"executable":return new C.ExecutableDebugAdapter(s,g.type)}return super.createDebugAdapter(s,g)}daExecutableFromPackage(s,g){const t=C.ExecutableDebugAdapter.platformAdapterExecutable(g.getAllExtensionDescriptions(),s.type);if(t)return new k.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new f.SignService}async $runInTerminal(s,g){if(s.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(w=>{this._integratedTerminalInstances.onTerminalClosed(w)}));const t=await this._configurationService.getConfigProvider(),u=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),i=s.title||m.localize(0,null),o=JSON.stringify({shell:u,shellArgs:r});let l=await this._integratedTerminalInstances.checkout(o,i),d,b=!1;if(l)d=s.cwd;else{const w={shellPath:u,shellArgs:r,cwd:s.cwd,name:i,iconPath:new k.ThemeIcon("debug")};b=!0,l=this._terminalService.createTerminalFromOptions(w,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(l,o)}l.show(!0);const _=await l.processId;b?await new Promise(w=>setTimeout(w,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0||u.indexOf("cmd.exe")>=0?l.sendText("cls"):u.indexOf("bash")>=0?l.sendText("clear"):L.isWindows?l.sendText("cls"):l.sendText("clear"));const v=(0,p.prepareCommand)(u,s.args,d,s.env);l.sendText(v);const P=this.onDidTerminateDebugSession(w=>{w.id===g&&(this._integratedTerminalInstances.free(l),P.dispose())});return _}else if(s.kind==="external")return(0,p.runInExternalTerminal)(s,await this._configurationService.getConfigProvider());return super.$runInTerminal(s,g)}createVariableResolver(s,g,t){return new c.ExtHostVariableResolverService(s,g,t,this._editorTabs,this._workspaceService)}};A=Ve([$e(0,I.IExtHostRpcService),$e(1,R.IExtHostWorkspace),$e(2,S.IExtHostExtensionService),$e(3,y.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,n.IExtHostTerminalService),$e(6,D.IExtHostEditorTabs)],A),e.ExtHostDebugService=A;class E{constructor(){this._terminalInstances=new Map}async checkout(s,g){const u=[...this._terminalInstances.entries()].map(([r,i])=>(0,h.createCancelablePromise)(async o=>{if(r.name!==g||i.lastUsedAt!==-1&&await(0,p.hasChildProcesses)(await r.processId))return null;const l=Date.now();return i.lastUsedAt+E.minUseDelay>l||o.isCancellationRequested||i.config!==s?null:(i.lastUsedAt=l,r)}));return await(0,h.firstParallel)(u,r=>!!r)}insert(s,g){this._terminalInstances.set(s,{lastUsedAt:Date.now(),config:g})}free(s){const g=this._terminalInstances.get(s);g&&(g.lastUsedAt=-1)}onTerminalClosed(s){this._terminalInstances.delete(s)}}E.minUseDelay=1e3}),define(me[272],ge([0,1,8,2,113,36,56,45,37,44,33,14,27,72,10,12,67,54,23,80]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D,A,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let s=class extends f.ExtHostTaskBase{constructor(t,u,r,i,o,l,d,b,_){super(t,u,r,i,o,l,d,b);this.workspaceService=r,this.editorTabs=_,u.remote.isRemote&&u.remote.authority?this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:u.remote.authority,platform:process.platform}):this.registerTaskSystem(h.Schemas.file,{scheme:h.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,u){const r=u;if(!u.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const i=f.TaskHandleDTO.from(r,this.workspaceService),o=await this._proxy.$getTaskExecution(i);if(o.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.getTaskExecution(o,u);return this._proxy.$executeTask(i).catch(()=>{}),l}else{const i=f.TaskDTO.from(u,t);if(i===void 0)return Promise.reject(new Error("Task is not valid"));f.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,u,!1);const o=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),u);return this._proxy.$executeTask(i).catch(()=>{}),o}}provideTasksInternal(t,u,r,i){const o=[];if(i)for(let l of i){this.checkDeprecation(l,r),(!l.definition||!t[l.definition.type])&&this._logService.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const d=f.TaskDTO.from(l,r.extension);d&&(o.push(d),f.CustomExecutionDTO.is(d.execution)&&u.push(this.addCustomExecution(d,l,!0)))}return{tasks:o,extension:r.extension}}async resolveTaskInternal(t){return t}async getVariableResolver(t){if(this._variableResolver===void 0){const u=await this._configurationService.getConfigProvider();this._variableResolver=new R.ExtHostVariableResolverService(t,this._editorService,u,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(t){let u=t&&t.length>0?t[0]:void 0;if(!u){const r=L.URI.file((0,a.homedir)());u=new T.WorkspaceFolder({uri:r,name:E.basename(r),index:0})}return{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,u){const r=L.URI.revive(t),i={process:void 0,variables:Object.create(null)},o=await this._workspaceProvider.resolveWorkspaceFolder(r),l=await this._workspaceProvider.getWorkspaceFolders2()??[],d=await this.getVariableResolver(l),b=o?{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(l);for(let _ of u.variables)i.variables[_]=await d.resolveAsync(b,_);if(u.process!==void 0){let _;if(u.process.path!==void 0){_=u.process.path.split(m.delimiter);for(let v=0;v<_.length;v++)_[v]=await d.resolveAsync(b,_[v])}i.process=await k.win32.findExecutable(await d.resolveAsync(b,u.process.name),u.process.cwd!==void 0?await d.resolveAsync(b,u.process.cwd):void 0,_)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(t,u,r){return k.win32.findExecutable(t,u,r)}};s=Ve([$e(0,I.IExtHostRpcService),$e(1,c.IExtHostInitDataService),$e(2,C.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,y.IExtHostConfiguration),$e(5,n.IExtHostTerminalService),$e(6,p.ILogService),$e(7,D.IExtHostApiDeprecationService),$e(8,A.IExtHostEditorTabs)],s),e.ExtHostTask=s}),define(me[273],ge([0,1,18,16,73,6,2,5,265,12,82,84,27,189,14,66,41,33]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(s,g,t,u){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new y.RPCProtocol(s,null,u),g=E._transform(g,this._rpcProtocol);const r=new I.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());r.set(c.IExtHostInitDataService,{_serviceBrand:void 0,...g}),r.set(h.IExtHostRpcService,new h.ExtHostRpcService(this._rpcProtocol)),r.set(p.IURITransformerService,new p.URITransformerService(u)),r.set(D.IHostUtils,t);const i=new f.InstantiationService(r,!0),o=i.invokeFunction(_=>_.get(A.IExtHostTerminalService));this._disposables.add(o),this._logService=i.invokeFunction(_=>_.get(T.ILogService)),k.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",g),this._extensionService=i.invokeFunction(_=>_.get(D.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const l=new WeakMap;this._extensionService.getExtensionPathIndex().then(_=>{Error.prepareStackTrace=(v,P)=>{let w="",F,M;for(const K of P)w+=`
	at ${K.toString()}`,M=K.getFileName(),!F&&M&&(F=_.findSubstr(M));return l.set(v,F),`${v.name||"Error"}: ${v.message||""}${w}`}});const d=this._rpcProtocol.getProxy(S.MainContext.MainThreadExtensionService),b=this._rpcProtocol.getProxy(S.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(_=>{const v=L.transformErrorForSerialization(_),P=l.get(_);P?d.$onExtensionRuntimeError(P.identifier,v):b.$onUnexpectedError(v)})}terminate(s){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${s}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,m.timeout)(4e3),g]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(s,g){s.extensions.forEach(u=>u.extensionLocation=R.URI.revive(g.transformIncomingURIs(u.extensionLocation))),s.environment.appRoot=R.URI.revive(g.transformIncomingURIs(s.environment.appRoot));const t=s.environment.extensionDevelopmentLocationURI;return t&&(s.environment.extensionDevelopmentLocationURI=t.map(u=>R.URI.revive(g.transformIncomingURIs(u)))),s.environment.extensionTestsLocationURI=R.URI.revive(g.transformIncomingURIs(s.environment.extensionTestsLocationURI)),s.environment.globalStorageHome=R.URI.revive(g.transformIncomingURIs(s.environment.globalStorageHome)),s.environment.workspaceStorageHome=R.URI.revive(g.transformIncomingURIs(s.environment.workspaceStorageHome)),s.logsLocation=R.URI.revive(g.transformIncomingURIs(s.logsLocation)),s.logFile=R.URI.revive(g.transformIncomingURIs(s.logFile)),s.workspace=g.transformIncomingURIs(s.workspace),s}}e.ExtensionHostMain=E}),define(me[274],ge([0,1,8,21,62,30,23,46,31]),function(J,e,m,L,k,C,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(c,f,h){this.config=c,this.provider=f,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&C.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&C.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const f=this.config.folderQueries||[];return new Promise((h,p)=>{const D=A=>{this.resultCount++,c(A)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(A=>{const E=A.toString(),a=m.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,a)||this.matchFile(D,{base:A,basename:a})}),Promise.all(f.map(A=>this.searchInFolder(A,D))).then(A=>{h({limitHit:this.isLimitHit,stats:A[0]||void 0})},A=>{p(new Error((0,k.toErrorMessage)(A)))})})}async searchInFolder(c,f){const h=new L.CancellationTokenSource,p=this.getSearchOptionsForFolder(c),D=this.initDirectoryTree(),A=new y.QueryGlobTester(this.config,c),E=!A.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(h),a=S.StopWatch.create();const s=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},p,h.token),g=a.elapsed(),t=S.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(s&&s.forEach(u=>{const r=m.posix.relative(c.folder.path,u.path);if(E){const i=m.basename(u.path);this.matchFile(f,{base:c.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(D,c.folder,r,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(D,A,f),{providerTime:g,postProcessTime:t.elapsed()})}finally{h.dispose(),this.activeCancellationTokens.delete(h)}}getSearchOptionsForFolder(c){const f=(0,y.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),h=(0,y.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:h,includes:f,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},f,h,p){if(h===this.filePattern){const A=m.basename(this.filePattern);this.matchFile(p,{base:f,relativePath:this.filePattern,basename:A})}function D(A){const E=m.basename(A),a=m.dirname(A);let s=c[a];s||(s=c[a]=[],D(a)),s.push({base:f,relativePath:A,basename:E})}D(h)}matchDirectoryTree({rootEntries:c,pathToEntries:f},h,p){const D=this,A=this.filePattern;function E(a){const s=C.hasSiblingFn(()=>a.map(g=>g.basename));for(let g=0,t=a.length;g<t;g++){const u=a[g],{relativePath:r,basename:i}=u;if(!h.includedInQuerySync(r,i,A!==i?s:void 0))continue;const o=f[r];if(o)E(o);else{if(r===A)continue;D.matchFile(p,u)}if(D.isLimitHit)break}}E(c)}matchFile(c,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(f))}}class n{constructor(){this.sessions=new Map}fileSearch(c,f,h,p){const D=this.getSessionTokenSource(c.cacheKey),A=new T(c,f,D&&D.token);let E=0;const a=s=>{E+=s.length,h(s.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(A,n.BATCH_SIZE,a,p).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:s.stats}}))}clearCache(c){const f=this.getSessionTokenSource(c);f&&f.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new L.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:R.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,f,h,p){p.onCancellationRequested(()=>{c.cancel()});const D=E=>{E&&(A.push(E),f>0&&A.length>=f&&(h(A),A=[]))};let A=[];return c.search(D).then(E=>(A.length&&h(A),E),E=>(A.length&&h(A),Promise.reject(E)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(me[133],ge([0,1,17,21,62,30,10,8,23,13,2,31]),function(J,e,m,L,k,C,R,S,y,T,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(a,s,g,t){this.query=a,this.provider=s,this.fileUtils=g,this.processType=t,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,s){const g=this.query.folderQueries||[],t=new L.CancellationTokenSource;return s.onCancellationRequested(()=>t.cancel()),new Promise((u,r)=>{this.collector=new h(a);let i=!1;const o=(l,d)=>{if(!i&&!this.isLimitHit){const b=this.resultSize(l);D(l)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const _=this.resultSize(l);this.resultCount+=_,(_>0||!D(l))&&this.collector.add(l,d)}};Promise.all(g.map((l,d)=>this.searchInFolder(l,b=>o(b,d),t.token))).then(l=>{t.dispose(),this.collector.flush();const d=l.some(b=>!!b&&!!b.limitHit);u({limitHit:this.isLimitHit||d,messages:(0,m.flatten)(l.map(b=>b?.message?(0,T.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:this.processType}})},l=>{t.dispose();const d=(0,k.toErrorMessage)(l);r(new Error(d))})})}resultSize(a){return D(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,s){const g=Array.isArray(a.ranges)?a.ranges:[a.ranges],t=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:g.slice(0,s),preview:{matches:t.slice(0,s),text:a.preview.text},uri:a.uri}}async searchInFolder(a,s,g){const t=new I.QueryGlobTester(this.query,a),u=[],r={report:l=>{if(!this.validateProviderResult(l))return;const d=a.folder.scheme===R.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(l.uri))):void 0,b=y.relativePath(a.folder,l.uri);if(b){const _=t.includedInQuery(b,S.basename(b),d);(0,T.isPromise)(_)?u.push(_.then(v=>{v&&s(l)})):_&&s(l)}}},i=this.getSearchOptionsForFolder(a),o=await this.provider.provideTextSearchResults(f(this.query.contentPattern),i,r,g);return u.length&&await Promise.all(u),o}validateProviderResult(a){if(D(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const s=(0,I.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),g=(0,I.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),t={folder:n.URI.from(a.folder),excludes:g,includes:s,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=c;function f(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class h{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new A(512,s=>this.sendItems(s))}add(a,s){this._currentFileMatch&&(this._currentFolderIdx!==s||!y.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=s,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(p(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=h;function p(E){return D(E)?{preview:{matches:(0,m.mapArrayOrNot)(E.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:E.preview.text},ranges:(0,m.mapArrayOrNot)(E.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function D(E){return!!E.preview}e.extensionResultIsMatch=D;class A{constructor(a,s){this.maxBatchSize=a,this.cb=s,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,s){!a||this.addItemToBatch(a,s)}addItems(a,s){!a||this.addItemsToBatch(a,s)}addItemToBatch(a,s){this.batch.push(a),this.batchSize+=s,this.onUpdate()}addItemsToBatch(a,s){this.batch=this.batch.concat(a),this.batchSize+=s,this.onUpdate()}onUpdate(){this.totalNumberCompleted<A.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},A.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=A,A.TIMEOUT=4e3,A.START_BATCH_AFTER_COUNT=50}),define(me[74],ge([0,1,6,5,4,274,14,66,12,2,133]),function(J,e,m,L,k,C,R,S,y,T,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let I=class{constructor(p,D,A){this.extHostRpc=p,this._uriTransformer=D,this._logService=A,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}registerTextSearchProvider(p,D){if(this._textSearchUsedSchemes.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this._textSearchUsedSchemes.add(p);const A=this._handlePool++;return this._textSearchProvider.set(A,D),this._proxy.$registerTextSearchProvider(A,this._transformScheme(p)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(p),this._textSearchProvider.delete(A),this._proxy.$unregisterProvider(A)})}registerFileSearchProvider(p,D){if(this._fileSearchUsedSchemes.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this._fileSearchUsedSchemes.add(p);const A=this._handlePool++;return this._fileSearchProvider.set(A,D),this._proxy.$registerFileSearchProvider(A,this._transformScheme(p)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(p),this._fileSearchProvider.delete(A),this._proxy.$unregisterProvider(A)})}$provideFileSearchResults(p,D,A,E){const a=c(A),s=this._fileSearchProvider.get(p);if(s)return this._fileSearchManager.fileSearch(a,s,g=>{this._proxy.$handleFileMatch(p,D,g.map(t=>t.resource))},E);throw new Error("unknown provider: "+p)}$clearCache(p){return this._fileSearchManager.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,D,A,E){const a=this._textSearchProvider.get(p);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const s=c(A);return this.createTextSearchManager(s,a).search(t=>this._proxy.$handleTextMatch(p,D,t),E)}$enableExtensionHostSearch(){}createTextSearchManager(p,D){return new n.TextSearchManager(p,D,{readdir:A=>Promise.resolve([]),toCanonicalName:A=>A},"textSearchProvider")}};I=Ve([$e(0,R.IExtHostRpcService),$e(1,S.IURITransformerService),$e(2,y.ILogService)],I),e.ExtHostSearch=I;function c(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(f),extraFileResources:h.extraFileResources&&h.extraFileResources.map(p=>T.URI.revive(p))}}e.reviveQuery=c;function f(h){return{...h,folder:T.URI.revive(h.folder)}}}),define(me[275],ge([0,1,21,16,3,49,2,114,109,147,81,43,5,233,232,40,234,37,235,236,237,218,238,45,41,239,219,242,243,244,68,221,249,250,251,92,33,253,222,15,7,256,70,132,36,35,58,207,241,86,131,72,56,74,12,66,14,27,245,204,53,67,230,254,203,69,91,259,257,258,231,52,252,255,90,54,122,247,71,248,10,191,246,201,240]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D,A,E,a,s,g,t,u,r,i,o,l,d,b,_,v,P,w,F,M,K,G,N,z,O,x,B,U,H,W,Q,Y,he,_e,Se,Re,xe,Ue,je,V,ee,re,le,Z,oe,ve,Me,qe,Qe,Je,Ce,at,X,te,pe,ze,tt,ut,lt,vt,Dt,ue,Ie,Be,Ke,We,ot,Le,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ke(ne){const de=ne.get(re.IExtHostInitDataService),be=ne.get(ze.IExtHostFileSystemInfo),we=ne.get(Ce.IExtHostConsumerFileSystem),Fe=ne.get(r.IExtHostExtensionService),Ge=ne.get(H.IExtHostWorkspace),He=ne.get(Dt.IExtHostTelemetry),Ye=ne.get(A.IExtHostConfiguration),it=ne.get(V.IURITransformerService),ae=ne.get(ee.IExtHostRpcService),Ee=ne.get(M.IExtHostStorage),ce=ne.get(Je.IExtensionStoragePaths),q=ne.get(je.ILogService),Te=ne.get(oe.IExtHostTunnelService),Pe=ne.get(ve.IExtHostApiDeprecationService),Ze=ne.get(U.IExtHostWindow),Xe=ne.get(lt.IExtHostSecretState),st=ne.get(vt.IExtHostEditorTabs);ae.set(c.ExtHostContext.ExtHostFileSystemInfo,be),ae.set(c.ExtHostContext.ExtHostLogService,q),ae.set(c.ExtHostContext.ExtHostWorkspace,Ge),ae.set(c.ExtHostContext.ExtHostConfiguration,Ye),ae.set(c.ExtHostContext.ExtHostExtensionService,Fe),ae.set(c.ExtHostContext.ExtHostStorage,Ee),ae.set(c.ExtHostContext.ExtHostTunnelService,Te),ae.set(c.ExtHostContext.ExtHostWindow,Ze),ae.set(c.ExtHostContext.ExtHostSecretState,Xe),ae.set(c.ExtHostContext.ExtHostTelemetry,He),ae.set(c.ExtHostContext.ExtHostEditorTabs,st);const wt=ae.set(c.ExtHostContext.ExtHostDecorations,ne.get(Se.IExtHostDecorations)),_t=ae.set(c.ExtHostContext.ExtHostDocumentsAndEditors,ne.get(u.IExtHostDocumentsAndEditors)),dt=ae.set(c.ExtHostContext.ExtHostCommands,ne.get(p.IExtHostCommands)),gt=ae.set(c.ExtHostContext.ExtHostTerminalService,ne.get(K.IExtHostTerminalService)),ft=ae.set(c.ExtHostContext.ExtHostDebugService,ne.get(xe.IExtHostDebugService)),Tt=ae.set(c.ExtHostContext.ExtHostSearch,ne.get(Ue.IExtHostSearch)),yt=ae.set(c.ExtHostContext.ExtHostTask,ne.get(Re.IExtHostTask)),Bt=ae.set(c.ExtHostContext.ExtHostOutputService,ne.get(_.IExtHostOutputService)),$t=ae.set(c.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(ae)),It=ae.set(c.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(ae,_t)),Wt=ae.set(c.ExtHostContext.ExtHostDocumentContentProviders,new s.ExtHostDocumentContentProvider(ae,_t,q)),en=ae.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(q,It,ae.getProxy(c.MainContext.MainThreadBulkEdits))),bt=ae.set(c.ExtHostContext.ExtHostNotebook,new le.ExtHostNotebookController(ae,dt,_t,It,ce)),Qt=ae.set(c.ExtHostContext.ExtHostNotebookDocuments,new Le.ExtHostNotebookDocuments(q,bt)),jt=ae.set(c.ExtHostContext.ExtHostNotebookEditors,new ot.ExtHostNotebookEditors(q,ae,bt)),tn=ae.set(c.ExtHostContext.ExtHostNotebookKernels,new ue.ExtHostNotebookKernels(ae,de,bt,dt,q)),nn=ae.set(c.ExtHostContext.ExtHostNotebookRenderers,new Be.ExtHostNotebookRenderers(ae,bt)),Pt=ae.set(c.ExtHostContext.ExtHostEditors,new G.ExtHostEditors(ae,_t)),Xt=ae.set(c.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(ae.getProxy(c.MainContext.MainThreadTreeViews),dt,q)),bn=ae.set(c.ExtHostContext.ExtHostEditorInsets,new Y.ExtHostEditorInsets(ae.getProxy(c.MainContext.MainThreadEditorInsets),Pt,de)),Ht=ae.set(c.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(ae,q,be)),zt=ae.set(c.ExtHostContext.ExtHostLanguages,new d.ExtHostLanguages(ae,It,dt.converter)),pt=ae.set(c.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(ae,it,It,dt,Ht,q,Pe)),rn=ae.set(c.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(ae,pt)),Ot=ae.set(c.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(ae,q,_t)),Nt=ae.set(c.ExtHostContext.ExtHostQuickOpen,(0,P.createExtHostQuickOpen)(ae,Ge,dt)),Yt=ae.set(c.ExtHostContext.ExtHostSCM,new w.ExtHostSCM(ae,dt,q)),En=ae.set(c.ExtHostContext.ExtHostComments,(0,D.createExtHostComments)(ae,dt,It)),fn=ae.set(c.ExtHostContext.ExtHostProgress,new v.ExtHostProgress(ae.getProxy(c.MainContext.MainThreadProgress))),_n=ae.set(c.ExtHostContext.ExtHosLabelService,new he.ExtHostLabelService(ae)),mn=ae.set(c.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(ae)),sn=ae.set(c.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(ae)),on=ae.set(c.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(ae,dt)),qt=ae.set(c.ExtHostContext.ExtHostWebviews,new B.ExtHostWebviews(ae,{remote:de.remote},Ge,q,Pe)),an=ae.set(c.ExtHostContext.ExtHostWebviewPanels,new te.ExtHostWebviewPanels(ae,qt,Ge)),Sn=ae.set(c.ExtHostContext.ExtHostCustomEditors,new X.ExtHostCustomEditors(ae,It,ce,qt,an)),yn=ae.set(c.ExtHostContext.ExtHostWebviewViews,new at.ExtHostWebviewViews(ae,qt)),Gt=ae.set(c.ExtHostContext.ExtHostTesting,new tt.ExtHostTesting(ae,dt)),Jt=ae.set(c.ExtHostContext.ExtHostUriOpeners,new ut.ExtHostUriOpeners(ae));ae.set(c.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(ae,bt,_t,dt));const Dn=(0,Q.values)(c.ExtHostContext);ae.assertRegistered(Dn);const Cn=new pe.ExtHostBulkEdits(ae,_t),ln=new h.ExtHostClipboard(ae),cn=new b.ExtHostMessageService(ae,q),Vt=new a.ExtHostDialogs(ae),Ft=new F.ExtHostStatusBar(ae,dt.converter);return f.ExtHostApiCommands.register(dt),function(Ne,Rt,Kt){const Et=function(){let ie=!Ne.isUnderDevelopment;function fe(Ae){ie||(q.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Ae(ct){if(Array.isArray(ct))ct.forEach(Ae);else if(typeof ct=="string")fe(ct);else{const St=ct;typeof St.scheme=="undefined"&&fe(ct),!Ne.enableProposedApi&&typeof St.exclusive=="boolean"&&(0,W.throwProposedApiError)(Ne)}return ct}}(),kn={getSession(ie,fe,Ae){return Ae?.forceNewSession&&(0,W.checkProposedApiEnabled)(Ne),sn.getSession(Ne,ie,fe,Ae)},get onDidChangeSessions(){return sn.onDidChangeSessions},registerAuthenticationProvider(ie,fe,Ae,ct){return sn.registerAuthenticationProvider(ie,fe,Ae,ct)}},In={registerCommand(ie,fe,Ae){return dt.registerCommand(!0,ie,fe,Ae)},registerTextEditorCommand(ie,fe,Ae){return dt.registerCommand(!0,ie,(...ct)=>{const St=Pt.getActiveTextEditor();if(!St){q.warn("Cannot execute "+ie+" because there is no active text editor.");return}return St.edit(kt=>{fe.apply(Ae,[St,kt,...ct])}).then(kt=>{kt||q.warn("Edits from command "+ie+" were not applied.")},kt=>{q.warn("An error occurred while running command "+ie,kt)})})},registerDiffInformationCommand:(ie,fe,Ae)=>((0,W.checkProposedApiEnabled)(Ne),dt.registerCommand(!0,ie,async(...ct)=>{const St=_t.activeEditor(!0);if(!St){q.warn("Cannot execute "+ie+" because there is no active text editor.");return}const kt=await Pt.getDiffInformation(St.id);fe.apply(Ae,[kt,...ct])})),executeCommand(ie,...fe){return dt.executeCommand(ie,...fe)},getCommands(ie=!1){return dt.getCommands(ie)}},gn={get machineId(){return de.telemetryInfo.machineId},get sessionId(){return de.telemetryInfo.sessionId},get language(){return de.environment.appLanguage},get appName(){return de.environment.appName},get appRoot(){return de.environment.appRoot?.fsPath??""},get appHost(){return de.environment.appHost},get uriScheme(){return de.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return gt.getDefaultShell(!1)},get isTelemetryEnabled(){return He.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return He.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ie=Date.now()-new Date(de.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,fe){return Ze.openUri(ie,{allowTunneling:!!de.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===de.environment.appUriScheme)return $t.createAppUri(ie);try{return await Ze.asExternalUri(ie,{allowTunneling:!!de.remote.authority})}catch(fe){if((0,We.matchesScheme)(ie,Ke.Schemas.http)||(0,We.matchesScheme)(ie,Ke.Schemas.https))return ie;throw fe}},get remoteName(){return(0,_e.getRemoteName)(de.remote.authority)},get remoteAuthority(){return(0,W.checkProposedApiEnabled)(Ne),de.remote.authority},get uiKind(){return de.uiKind}};de.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=de.remote.isRemote?O.ExtensionKind.Workspace:O.ExtensionKind.UI,Pn={createTestController(ie,fe){return Gt.createTestController(ie,fe)},createTestObserver(){return(0,W.checkProposedApiEnabled)(Ne),Gt.createTestObserver()},runTests(ie){return(0,W.checkProposedApiEnabled)(Ne),Gt.runTests(ie)},get onDidChangeTestResults(){return(0,W.checkProposedApiEnabled)(Ne),Gt.onResultsChanged},get testResults(){return(0,W.checkProposedApiEnabled)(Ne),Gt.results}},Tn={getExtension(ie){const fe=Rt.getExtensionDescription(ie);if(fe)return new r.Extension(Fe,Ne.identifier,fe,pn)},get all(){return Rt.getAllExtensionDescriptions().map(ie=>new r.Extension(Fe,Ne.identifier,ie,pn))},get onDidChange(){return Rt.onDidChange}},un={createDiagnosticCollection(ie){return Ht.createDiagnosticCollection(Ne.identifier,ie)},get onDidChangeDiagnostics(){return Ht.onDidChangeDiagnostics},getDiagnostics:ie=>Ht.getDiagnostics(ie),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(ie,fe){return zt.changeLanguage(ie.uri,fe)},match(ie,fe){return(0,n.score)(z.LanguageSelector.from(ie),fe.uri,fe.languageId,!0)},registerCodeActionsProvider(ie,fe,Ae){return pt.registerCodeActionProvider(Ne,Et(ie),fe,Ae)},registerCodeLensProvider(ie,fe){return pt.registerCodeLensProvider(Ne,Et(ie),fe)},registerDefinitionProvider(ie,fe){return pt.registerDefinitionProvider(Ne,Et(ie),fe)},registerDeclarationProvider(ie,fe){return pt.registerDeclarationProvider(Ne,Et(ie),fe)},registerImplementationProvider(ie,fe){return pt.registerImplementationProvider(Ne,Et(ie),fe)},registerTypeDefinitionProvider(ie,fe){return pt.registerTypeDefinitionProvider(Ne,Et(ie),fe)},registerHoverProvider(ie,fe){return pt.registerHoverProvider(Ne,Et(ie),fe,Ne.identifier)},registerEvaluatableExpressionProvider(ie,fe){return pt.registerEvaluatableExpressionProvider(Ne,Et(ie),fe,Ne.identifier)},registerInlineValuesProvider(ie,fe){return pt.registerInlineValuesProvider(Ne,Et(ie),fe,Ne.identifier)},registerDocumentHighlightProvider(ie,fe){return pt.registerDocumentHighlightProvider(Ne,Et(ie),fe)},registerLinkedEditingRangeProvider(ie,fe){return pt.registerLinkedEditingRangeProvider(Ne,Et(ie),fe)},registerReferenceProvider(ie,fe){return pt.registerReferenceProvider(Ne,Et(ie),fe)},registerRenameProvider(ie,fe){return pt.registerRenameProvider(Ne,Et(ie),fe)},registerDocumentSymbolProvider(ie,fe,Ae){return pt.registerDocumentSymbolProvider(Ne,Et(ie),fe,Ae)},registerWorkspaceSymbolProvider(ie){return pt.registerWorkspaceSymbolProvider(Ne,ie)},registerDocumentFormattingEditProvider(ie,fe){return pt.registerDocumentFormattingEditProvider(Ne,Et(ie),fe)},registerDocumentRangeFormattingEditProvider(ie,fe){return pt.registerDocumentRangeFormattingEditProvider(Ne,Et(ie),fe)},registerOnTypeFormattingEditProvider(ie,fe,Ae,...ct){return pt.registerOnTypeFormattingEditProvider(Ne,Et(ie),fe,[Ae].concat(ct))},registerDocumentSemanticTokensProvider(ie,fe,Ae){return pt.registerDocumentSemanticTokensProvider(Ne,Et(ie),fe,Ae)},registerDocumentRangeSemanticTokensProvider(ie,fe,Ae){return pt.registerDocumentRangeSemanticTokensProvider(Ne,Et(ie),fe,Ae)},registerSignatureHelpProvider(ie,fe,Ae,...ct){return typeof Ae=="object"?pt.registerSignatureHelpProvider(Ne,Et(ie),fe,Ae):pt.registerSignatureHelpProvider(Ne,Et(ie),fe,typeof Ae=="undefined"?[]:[Ae,...ct])},registerCompletionItemProvider(ie,fe,...Ae){return pt.registerCompletionItemProvider(Ne,Et(ie),fe,Ae)},registerInlineCompletionItemProvider(ie,fe){return(0,W.checkProposedApiEnabled)(Ne),pt.registerInlineCompletionsProvider(Ne,Et(ie),fe)},registerDocumentLinkProvider(ie,fe){return pt.registerDocumentLinkProvider(Ne,Et(ie),fe)},registerColorProvider(ie,fe){return pt.registerColorProvider(Ne,Et(ie),fe)},registerFoldingRangeProvider(ie,fe){return pt.registerFoldingRangeProvider(Ne,Et(ie),fe)},registerSelectionRangeProvider(ie,fe){return pt.registerSelectionRangeProvider(Ne,ie,fe)},registerCallHierarchyProvider(ie,fe){return pt.registerCallHierarchyProvider(Ne,ie,fe)},registerTypeHierarchyProvider(ie,fe){return pt.registerTypeHierarchyProvider(Ne,ie,fe)},setLanguageConfiguration:(ie,fe)=>pt.setLanguageConfiguration(Ne,ie,fe),getTokenInformationAtPosition(ie,fe){return(0,W.checkProposedApiEnabled)(Ne),zt.tokenAtPosition(ie,fe)},registerInlayHintsProvider(ie,fe){return(0,W.checkProposedApiEnabled)(Ne),pt.registerInlayHintsProvider(Ne,ie,fe)},createLanguageStatusItem(ie,fe){return(0,W.checkProposedApiEnabled)(Ne),zt.createLanguageStatusItem(Ne,ie,fe)}},An={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(ie,fe,Ae){const ct=await(R.URI.isUri(ie)?Promise.resolve(vn.openTextDocument(ie)):Promise.resolve(ie));return Pt.showTextDocument(ct,fe,Ae)},createTextEditorDecorationType(ie){return Pt.createTextEditorDecorationType(Ne,ie)},onDidChangeActiveTextEditor(ie,fe,Ae){return Pt.onDidChangeActiveTextEditor(ie,fe,Ae)},onDidChangeVisibleTextEditors(ie,fe,Ae){return Pt.onDidChangeVisibleTextEditors(ie,fe,Ae)},onDidChangeTextEditorSelection(ie,fe,Ae){return Pt.onDidChangeTextEditorSelection(ie,fe,Ae)},onDidChangeTextEditorOptions(ie,fe,Ae){return Pt.onDidChangeTextEditorOptions(ie,fe,Ae)},onDidChangeTextEditorVisibleRanges(ie,fe,Ae){return Pt.onDidChangeTextEditorVisibleRanges(ie,fe,Ae)},onDidChangeTextEditorViewColumn(ie,fe,Ae){return Pt.onDidChangeTextEditorViewColumn(ie,fe,Ae)},onDidCloseTerminal(ie,fe,Ae){return gt.onDidCloseTerminal(ie,fe,Ae)},onDidOpenTerminal(ie,fe,Ae){return gt.onDidOpenTerminal(ie,fe,Ae)},onDidChangeActiveTerminal(ie,fe,Ae){return gt.onDidChangeActiveTerminal(ie,fe,Ae)},onDidChangeTerminalDimensions(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),gt.onDidChangeTerminalDimensions(ie,fe,Ae)},onDidChangeTerminalState(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),gt.onDidChangeTerminalState(ie,fe,Ae)},onDidWriteTerminalData(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),gt.onDidWriteTerminalData(ie,fe,Ae)},get state(){return Ze.state},onDidChangeWindowState(ie,fe,Ae){return Ze.onDidChangeWindowState(ie,fe,Ae)},showInformationMessage(ie,...fe){return cn.showMessage(Ne,C.default.Info,ie,fe[0],fe.slice(1))},showWarningMessage(ie,...fe){return cn.showMessage(Ne,C.default.Warning,ie,fe[0],fe.slice(1))},showErrorMessage(ie,...fe){return cn.showMessage(Ne,C.default.Error,ie,fe[0],fe.slice(1))},showQuickPick(ie,fe,Ae){return Nt.showQuickPick(ie,!!Ne.enableProposedApi,fe,Ae)},showWorkspaceFolderPick(ie){return Nt.showWorkspaceFolderPick(ie)},showInputBox(ie,fe){return Nt.showInput(ie,fe)},showOpenDialog(ie){return Vt.showOpenDialog(ie)},showSaveDialog(ie){return Vt.showSaveDialog(ie)},createStatusBarItem(ie,fe,Ae){let ct,St,kt;return typeof ie=="string"?(ct=ie,St=fe,kt=Ae):(St=ie,kt=fe),Ft.createStatusBarEntry(Ne,ct,St,kt)},setStatusBarMessage(ie,fe){return Ft.setStatusBarMessage(ie,fe)},withScmProgress(ie){return Pe.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),fn.withProgress(Ne,{location:O.ProgressLocation.SourceControl},(fe,Ae)=>ie({report(ct){}}))},withProgress(ie,fe){return fn.withProgress(Ne,ie,fe)},createOutputChannel(ie){return Bt.createOutputChannel(ie,Ne)},createWebviewPanel(ie,fe,Ae,ct){return an.createWebviewPanel(Ne,ie,fe,Ae,ct)},createWebviewTextEditorInset(ie,fe,Ae,ct){return(0,W.checkProposedApiEnabled)(Ne),bn.createWebviewEditorInset(ie,fe,Ae,ct,Ne)},createTerminal(ie,fe,Ae){return typeof ie=="object"?("location"in ie&&(0,W.checkProposedApiEnabled)(Ne),"pty"in ie?gt.createExtensionTerminal(ie):gt.createTerminalFromOptions(ie)):gt.createTerminal(ie,fe,Ae)},registerTerminalLinkProvider(ie){return gt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,fe){return gt.registerProfileProvider(Ne,ie,fe)},registerTreeDataProvider(ie,fe){return Xt.registerTreeDataProvider(ie,fe,Ne)},createTreeView(ie,fe){return Xt.createTreeView(ie,fe,Ne)},registerWebviewPanelSerializer:(ie,fe)=>an.registerWebviewPanelSerializer(Ne,ie,fe),registerCustomEditorProvider:(ie,fe,Ae={})=>Sn.registerCustomEditorProvider(Ne,ie,fe,Ae),registerFileDecorationProvider(ie){return wt.registerFileDecorationProvider(ie,Ne.identifier)},registerUriHandler(ie){return $t.registerUriHandler(Ne.identifier,ie)},createQuickPick(){return Nt.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return Nt.createInputBox(Ne.identifier)},get activeColorTheme(){return mn.activeColorTheme},onDidChangeActiveColorTheme(ie,fe,Ae){return mn.onDidChangeActiveColorTheme(ie,fe,Ae)},registerWebviewViewProvider(ie,fe,Ae){return yn.registerWebviewViewProvider(Ne,ie,fe,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,W.checkProposedApiEnabled)(Ne),bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),bt.onDidChangeActiveNotebookEditor(ie,fe,Ae)},get visibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Ne),bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Ne),bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),jt.onDidChangeNotebookEditorSelection(ie,fe,Ae)},onDidChangeNotebookEditorVisibleRanges(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),jt.onDidChangeNotebookEditorVisibleRanges(ie,fe,Ae)},showNotebookDocument(ie,fe){return(0,W.checkProposedApiEnabled)(Ne),bt.showNotebookDocument(ie,fe)},registerExternalUriOpener(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),Jt.registerExternalUriOpener(Ne.identifier,ie,fe,Ae)},get tabs(){return(0,W.checkProposedApiEnabled)(Ne),st.tabs},get activeTab(){return(0,W.checkProposedApiEnabled)(Ne),st.activeTab},get onDidChangeTabs(){return(0,W.checkProposedApiEnabled)(Ne),st.onDidChangeTabs},get onDidChangeActiveTab(){return(0,W.checkProposedApiEnabled)(Ne),st.onDidChangeActiveTab},getInlineCompletionItemController(ie){return(0,W.checkProposedApiEnabled)(Ne),l.InlineCompletionController.get(ie)}},vn={get rootPath(){return Pe.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ge.getPath()},set rootPath(ie){throw L.readonly()},getWorkspaceFolder(ie){return Ge.getWorkspaceFolder(ie)},get workspaceFolders(){return Ge.getWorkspaceFolders()},get name(){return Ge.name},set name(ie){throw L.readonly()},get workspaceFile(){return Ge.workspaceFile},set workspaceFile(ie){throw L.readonly()},updateWorkspaceFolders:(ie,fe,...Ae)=>Ge.updateWorkspaceFolders(Ne,ie,fe||0,...Ae),onDidChangeWorkspaceFolders:function(ie,fe,Ae){return Ge.onDidChangeWorkspace(ie,fe,Ae)},asRelativePath:(ie,fe)=>Ge.getRelativePath(ie,fe),findFiles:(ie,fe,Ae,ct)=>Ge.findFiles(z.GlobPattern.from(ie),z.GlobPattern.from(fe),Ae,Ne.identifier,ct),findTextInFiles:(ie,fe,Ae,ct)=>{let St,kt;return typeof fe=="object"?(St=fe,kt=Ae):(St={},kt=fe,ct=Ae),Ge.findTextInFiles(ie,St||{},kt,Ne.identifier,ct)},saveAll:ie=>Ge.saveAll(ie),applyEdit(ie){return Cn.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,fe,Ae,ct)=>Ot.createFileSystemWatcher(z.GlobPattern.from(ie),fe,Ae,ct),get textDocuments(){return It.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw L.readonly()},openTextDocument(ie){let fe;const Ae=ie;if(typeof ie=="string")fe=Promise.resolve(R.URI.file(ie));else if(R.URI.isUri(ie))fe=Promise.resolve(ie);else if(!Ae||typeof Ae=="object")fe=It.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(ct=>It.ensureDocumentData(ct).then(St=>St.document))},onDidOpenTextDocument:(ie,fe,Ae)=>It.onDidAddDocument(ie,fe,Ae),onDidCloseTextDocument:(ie,fe,Ae)=>It.onDidRemoveDocument(ie,fe,Ae),onDidChangeTextDocument:(ie,fe,Ae)=>It.onDidChangeDocument(ie,fe,Ae),onDidSaveTextDocument:(ie,fe,Ae)=>It.onDidSaveDocument(ie,fe,Ae),onWillSaveTextDocument:(ie,fe,Ae)=>en.getOnWillSaveTextDocumentEvent(Ne)(ie,fe,Ae),get notebookDocuments(){return bt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,fe){let Ae;if(R.URI.isUri(ie))Ae=ie,await bt.openNotebookDocument(ie);else if(typeof ie=="string")Ae=R.URI.revive(await bt.createNotebookDocument({viewType:ie,content:fe}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(ie,fe,Ae,ct){return bt.registerNotebookSerializer(Ne,ie,fe,Ae,Ne.enableProposedApi?ct:void 0)},registerNotebookContentProvider:(ie,fe,Ae,ct)=>((0,W.checkProposedApiEnabled)(Ne),bt.registerNotebookContentProvider(Ne,ie,fe,Ae,Ne.enableProposedApi?ct:void 0)),onDidChangeConfiguration:(ie,fe,Ae)=>Kt.onDidChangeConfiguration(ie,fe,Ae),getConfiguration(ie,fe){return fe=arguments.length===1?void 0:fe,Kt.getConfiguration(ie,fe,Ne)},registerTextDocumentContentProvider(ie,fe){return Wt.registerTextDocumentContentProvider(ie,fe)},registerTaskProvider:(ie,fe)=>(Pe.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Ne,ie,fe)),registerFileSystemProvider(ie,fe,Ae){return rn.registerFileSystemProvider(Ne.identifier,ie,fe,Ae)},get fs(){return we.value},registerFileSearchProvider:(ie,fe)=>((0,W.checkProposedApiEnabled)(Ne),Tt.registerFileSearchProvider(ie,fe)),registerTextSearchProvider:(ie,fe)=>((0,W.checkProposedApiEnabled)(Ne),Tt.registerTextSearchProvider(ie,fe)),registerRemoteAuthorityResolver:(ie,fe)=>((0,W.checkProposedApiEnabled)(Ne),Fe.registerRemoteAuthorityResolver(ie,fe)),registerResourceLabelFormatter:ie=>((0,W.checkProposedApiEnabled)(Ne),_n.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,fe,Ae)=>Ot.onDidCreateFile(ie,fe,Ae),onDidDeleteFiles:(ie,fe,Ae)=>Ot.onDidDeleteFile(ie,fe,Ae),onDidRenameFiles:(ie,fe,Ae)=>Ot.onDidRenameFile(ie,fe,Ae),onWillCreateFiles:(ie,fe,Ae)=>Ot.getOnWillCreateFileEvent(Ne)(ie,fe,Ae),onWillDeleteFiles:(ie,fe,Ae)=>Ot.getOnWillDeleteFileEvent(Ne)(ie,fe,Ae),onWillRenameFiles:(ie,fe,Ae)=>Ot.getOnWillRenameFileEvent(Ne)(ie,fe,Ae),openTunnel:ie=>((0,W.checkProposedApiEnabled)(Ne),Te.openTunnel(Ne,ie).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,W.checkProposedApiEnabled)(Ne),Te.getTunnels()},onDidChangeTunnels:(ie,fe,Ae)=>((0,W.checkProposedApiEnabled)(Ne),Te.onDidChangeTunnels(ie,fe,Ae)),registerPortAttributesProvider:(ie,fe)=>((0,W.checkProposedApiEnabled)(Ne),Te.registerPortsAttributesProvider(ie,fe)),registerTimelineProvider:(ie,fe)=>((0,W.checkProposedApiEnabled)(Ne),on.registerTimelineProvider(ie,fe,Ne.identifier,dt.converter)),get isTrusted(){return Ge.trusted},requestWorkspaceTrust:ie=>((0,W.checkProposedApiEnabled)(Ne),Ge.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,fe,Ae)=>Ge.onDidGrantWorkspaceTrust(ie,fe,Ae)},Rn={get inputBox(){return Pe.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),Yt.getLastInputBox(Ne)},createSourceControl(ie,fe,Ae){return Yt.createSourceControl(Ne,ie,fe,Ae)}},Ln={createCommentController(ie,fe){return En.createCommentController(Ne,ie,fe)}},Fn={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},onDidStartDebugSession(ie,fe,Ae){return ft.onDidStartDebugSession(ie,fe,Ae)},onDidTerminateDebugSession(ie,fe,Ae){return ft.onDidTerminateDebugSession(ie,fe,Ae)},onDidChangeActiveDebugSession(ie,fe,Ae){return ft.onDidChangeActiveDebugSession(ie,fe,Ae)},onDidReceiveDebugSessionCustomEvent(ie,fe,Ae){return ft.onDidReceiveDebugSessionCustomEvent(ie,fe,Ae)},onDidChangeBreakpoints(ie,fe,Ae){return ft.onDidChangeBreakpoints(ie,fe,Ae)},registerDebugConfigurationProvider(ie,fe,Ae){return ft.registerDebugConfigurationProvider(ie,fe,Ae||O.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,fe){return ft.registerDebugAdapterDescriptorFactory(Ne,ie,fe)},registerDebugAdapterTrackerFactory(ie,fe){return ft.registerDebugAdapterTrackerFactory(ie,fe)},startDebugging(ie,fe,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?ft.startDebugging(ie,fe,{parentSession:Ae}):ft.startDebugging(ie,fe,Ae||{})},stopDebugging(ie){return ft.stopDebugging(ie)},addBreakpoints(ie){return ft.addBreakpoints(ie)},removeBreakpoints(ie){return ft.removeBreakpoints(ie)},asDebugSourceUri(ie,fe){return ft.asDebugSourceUri(ie,fe)}},Mn={registerTaskProvider:(ie,fe)=>yt.registerTaskProvider(Ne,ie,fe),fetchTasks:ie=>yt.fetchTasks(ie),executeTask:ie=>yt.executeTask(Ne,ie),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(ie,fe,Ae)=>yt.onDidStartTask(ie,fe,Ae),onDidEndTask:(ie,fe,Ae)=>yt.onDidEndTask(ie,fe,Ae),onDidStartTaskProcess:(ie,fe,Ae)=>yt.onDidStartTaskProcess(ie,fe,Ae),onDidEndTaskProcess:(ie,fe,Ae)=>yt.onDidEndTaskProcess(ie,fe,Ae)},On={createNotebookController(ie,fe,Ae,ct,St){return tn.createNotebookController(Ne,ie,fe,Ae,ct,Ne.enableProposedApi?St:void 0)},registerNotebookCellStatusBarItemProvider:(ie,fe)=>bt.registerNotebookCellStatusBarItemProvider(Ne,ie,fe),get onDidSaveNotebookDocument(){return(0,W.checkProposedApiEnabled)(Ne),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ie){return(0,W.checkProposedApiEnabled)(Ne),jt.createNotebookEditorDecorationType(ie)},createRendererMessaging(ie){return nn.createRendererMessaging(Ne,ie)},onDidChangeNotebookDocumentMetadata(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),Qt.onDidChangeNotebookDocumentMetadata(ie,fe,Ae)},onDidChangeNotebookCells(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),bt.onDidChangeNotebookCells(ie,fe,Ae)},onDidChangeNotebookCellExecutionState(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),bt.onDidChangeNotebookCellExecutionState(ie,fe,Ae)},onDidChangeCellOutputs(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),bt.onDidChangeCellOutputs(ie,fe,Ae)},onDidChangeCellMetadata(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),bt.onDidChangeCellMetadata(ie,fe,Ae)},createConcatTextDocument(ie,fe){return(0,W.checkProposedApiEnabled)(Ne),new Qe.ExtHostNotebookConcatDocument(bt,It,ie,fe)}};return{version:de.version,authentication:kn,commands:In,comments:Ln,debug:Fn,env:gn,extensions:Tn,languages:un,notebooks:On,scm:Rn,tasks:Mn,tests:Pn,window:An,workspace:vn,Breakpoint:O.Breakpoint,CallHierarchyIncomingCall:O.CallHierarchyIncomingCall,CallHierarchyItem:O.CallHierarchyItem,CallHierarchyOutgoingCall:O.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:O.CodeAction,CodeActionKind:O.CodeActionKind,CodeActionTriggerKind:O.CodeActionTriggerKind,CodeLens:O.CodeLens,Color:O.Color,ColorInformation:O.ColorInformation,ColorPresentation:O.ColorPresentation,ColorThemeKind:O.ColorThemeKind,CommentMode:O.CommentMode,CommentThreadCollapsibleState:O.CommentThreadCollapsibleState,CompletionItem:O.CompletionItem,CompletionItemKind:O.CompletionItemKind,CompletionItemTag:O.CompletionItemTag,CompletionList:O.CompletionList,CompletionTriggerKind:O.CompletionTriggerKind,ConfigurationTarget:O.ConfigurationTarget,CustomExecution:O.CustomExecution,DebugAdapterExecutable:O.DebugAdapterExecutable,DebugAdapterInlineImplementation:O.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:O.DebugAdapterNamedPipeServer,DebugAdapterServer:O.DebugAdapterServer,DebugConfigurationProviderTriggerKind:O.DebugConfigurationProviderTriggerKind,DebugConsoleMode:O.DebugConsoleMode,DecorationRangeBehavior:O.DecorationRangeBehavior,Diagnostic:O.Diagnostic,DiagnosticRelatedInformation:O.DiagnosticRelatedInformation,DiagnosticSeverity:O.DiagnosticSeverity,DiagnosticTag:O.DiagnosticTag,Disposable:O.Disposable,DocumentHighlight:O.DocumentHighlight,DocumentHighlightKind:O.DocumentHighlightKind,DocumentLink:O.DocumentLink,DocumentSymbol:O.DocumentSymbol,EndOfLine:O.EndOfLine,EnvironmentVariableMutatorType:O.EnvironmentVariableMutatorType,EvaluatableExpression:O.EvaluatableExpression,InlineValueText:O.InlineValueText,InlineValueVariableLookup:O.InlineValueVariableLookup,InlineValueEvaluatableExpression:O.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:O.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:O.ExtensionKind,ExtensionMode:O.ExtensionMode,ExternalUriOpenerPriority:O.ExternalUriOpenerPriority,FileChangeType:O.FileChangeType,FileDecoration:O.FileDecoration,FileSystemError:O.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:O.FoldingRange,FoldingRangeKind:O.FoldingRangeKind,FunctionBreakpoint:O.FunctionBreakpoint,InlineCompletionItem:O.InlineSuggestion,InlineCompletionList:O.InlineSuggestions,Hover:O.Hover,IndentAction:T.IndentAction,Location:O.Location,MarkdownString:O.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:O.ParameterInformation,PortAutoForwardAction:O.PortAutoForwardAction,Position:O.Position,ProcessExecution:O.ProcessExecution,ProgressLocation:O.ProgressLocation,QuickInputButtons:O.QuickInputButtons,Range:O.Range,RelativePattern:O.RelativePattern,Selection:O.Selection,SelectionRange:O.SelectionRange,SemanticTokens:O.SemanticTokens,SemanticTokensBuilder:O.SemanticTokensBuilder,SemanticTokensEdit:O.SemanticTokensEdit,SemanticTokensEdits:O.SemanticTokensEdits,SemanticTokensLegend:O.SemanticTokensLegend,ShellExecution:O.ShellExecution,ShellQuoting:O.ShellQuoting,SignatureHelp:O.SignatureHelp,SignatureHelpTriggerKind:O.SignatureHelpTriggerKind,SignatureInformation:O.SignatureInformation,SnippetString:O.SnippetString,SourceBreakpoint:O.SourceBreakpoint,StandardTokenType:O.StandardTokenType,StatusBarAlignment:O.StatusBarAlignment,SymbolInformation:O.SymbolInformation,SymbolKind:O.SymbolKind,SymbolTag:O.SymbolTag,Task:O.Task,TaskGroup:O.TaskGroup,TaskPanelKind:O.TaskPanelKind,TaskRevealKind:O.TaskRevealKind,TaskScope:O.TaskScope,TerminalLink:O.TerminalLink,TerminalLocation:O.TerminalLocation,TerminalProfile:O.TerminalProfile,TextDocumentSaveReason:O.TextDocumentSaveReason,TextEdit:O.TextEdit,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:O.TextEditorLineNumbersStyle,TextEditorRevealType:O.TextEditorRevealType,TextEditorSelectionChangeKind:O.TextEditorSelectionChangeKind,TextDocumentChangeReason:O.TextDocumentChangeReason,ThemeColor:O.ThemeColor,ThemeIcon:O.ThemeIcon,TreeItem:O.TreeItem,TreeItemCollapsibleState:O.TreeItemCollapsibleState,TypeHierarchyItem:O.TypeHierarchyItem,UIKind:c.UIKind,Uri:R.URI,ViewColumn:O.ViewColumn,WorkspaceEdit:O.WorkspaceEdit,InlayHint:O.InlayHint,InlayHintKind:O.InlayHintKind,RemoteAuthorityResolverError:O.RemoteAuthorityResolverError,ResolvedAuthority:O.ResolvedAuthority,SourceControlInputBoxValidationType:O.SourceControlInputBoxValidationType,ExtensionRuntime:O.ExtensionRuntime,TimelineItem:O.TimelineItem,NotebookRange:O.NotebookRange,NotebookCellKind:O.NotebookCellKind,NotebookCellExecutionState:O.NotebookCellExecutionState,NotebookCellData:O.NotebookCellData,NotebookData:O.NotebookData,NotebookRendererScript:O.NotebookRendererScript,NotebookCellStatusBarAlignment:O.NotebookCellStatusBarAlignment,NotebookEditorRevealType:O.NotebookEditorRevealType,NotebookCellOutput:O.NotebookCellOutput,NotebookCellOutputItem:O.NotebookCellOutputItem,NotebookCellStatusBarItem:O.NotebookCellStatusBarItem,NotebookControllerAffinity:O.NotebookControllerAffinity,PortAttributes:O.PortAttributes,LinkedEditingRanges:O.LinkedEditingRanges,TestResultState:O.TestResultState,TestRunRequest:O.TestRunRequest,TestMessage:O.TestMessage,TestTag:O.TestTag,TestRunProfileKind:O.TestRunProfileKind,TextSearchCompleteMessageType:Ie.TextSearchCompleteMessageType,CoveredCount:O.CoveredCount,FileCoverage:O.FileCoverage,StatementCoverage:O.StatementCoverage,BranchCoverage:O.BranchCoverage,FunctionCoverage:O.FunctionCoverage,WorkspaceTrustState:O.WorkspaceTrustState,LanguageStatusSeverity:O.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=ke}),define(me[276],ge([0,1,82,68,36,131,37,40,45,33,72,56,74,92,53,67,132,91,52,90,122,54]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D,A,E,a,s,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,m.registerSingleton)(S.IExtHostCommands,S.ExtHostCommands),(0,m.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration),(0,m.registerSingleton)(A.IExtHostConsumerFileSystem,A.ExtHostConsumerFileSystem),(0,m.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,m.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,m.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(E.IExtHostFileSystemInfo,E.ExtHostFileSystemInfo),(0,m.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,m.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,m.registerSingleton)(f.IExtHostStorage,f.ExtHostStorage),(0,m.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,m.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,m.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,m.registerSingleton)(D.IExtHostWindow,D.ExtHostWindow),(0,m.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace),(0,m.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,m.registerSingleton)(s.IExtHostTelemetry,s.ExtHostTelemetry),(0,m.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs)}),define(me[93],ge([0,1,17,12,31,71]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function R(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=R;function S(I,c,f,h){const p=(0,m.mapArrayOrNot)(f,y),D=new k.TextSearchMatch(c,p,h),A=D.preview.matches;return{ranges:(0,m.mapArrayOrNot)(p,T),uri:I,preview:{text:D.preview.text,matches:(0,m.mapArrayOrNot)(A,T)}}}e.createTextSearchResult=S;function y(I){return new k.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function T(I){return new C.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let n=class{constructor(c,f){this.prefix=c,this.logService=f}appendLine(c){this.logService.debug(`${this.prefix}#search`,c)}};n=Ve([$e(1,L.ILogService)],n),e.OutputChannel=n}),define(me[277],ge([0,1,96,22]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(u=>u===t)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,R=512,S=512*8,y=512*128;class T{constructor(u){this.iconvLiteDecoder=u}static async create(u){let r;if(u!==e.UTF8)r=(await new Promise((o,l)=>{J(["iconv-lite-umd"],o,l)})).getDecoder(f(u));else{const i=new TextDecoder;r={write(o){return i.decode(o,{stream:!0})},end(){return i.decode()}}}return new T(r)}write(u){return this.iconvLiteDecoder.write(u)}end(){return this.iconvLiteDecoder.end()}}function n(t,u){const r=u.minBytesRequiredForDetection??u.guessEncoding?S:R;return new Promise((i,o)=>{const l=(0,m.newWriteableStream)(P=>P.join("")),d=[];let b=0,_;const v=async()=>{try{const P=await g({buffer:L.VSBuffer.concat(d),bytesRead:b},u.guessEncoding);P.encoding=await u.overwriteEncoding(P.encoding),_=await T.create(P.encoding);const w=_.write(L.VSBuffer.concat(d).buffer);l.write(w),d.length=0,b=0,i({stream:l,detected:P})}catch(P){o(P)}};(0,m.listenStream)(t,{onData:async P=>{_?l.write(_.write(P.buffer)):(d.push(P),b+=P.byteLength,b>=r&&(t.pause(),await v(),setTimeout(()=>t.resume())))},onError:P=>l.error(P),onEnd:async()=>{_||await v(),l.end(_?.end())}})})}e.toDecodeStream=n;async function I(t,u,r){const o=(await new Promise((b,_)=>{J(["iconv-lite-umd"],b,_)})).getEncoder(f(u),r);let l=!1,d=!1;return{read(){if(d)return null;const b=t.read();if(typeof b!="string"){if(d=!0,!l&&r?.addBOM)switch(u){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const _=o.end();return _&&_.length>0?(l=!0,L.VSBuffer.wrap(_)):null}return l=!0,L.VSBuffer.wrap(o.write(b))}}}e.toEncodeReadable=I;async function c(t){return(await new Promise((r,i)=>{J(["iconv-lite-umd"],r,i)})).encodingExists(f(t))}e.encodingExists=c;function f(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=f;function h(t,u){if(!t||u<e.UTF16be_BOM.length)return null;const r=t.readUInt8(0),i=t.readUInt8(1);if(r===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(u<e.UTF8_BOM.length)return null;const o=t.readUInt8(2);return r===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=h;const p=["ascii","utf-16","utf-32"];async function D(t){const u=await new Promise((d,b)=>{J(["jschardet"],d,b)}),r=t.slice(0,y),i=a(r.buffer),o=u.detect(i);if(!o||!o.encoding)return null;const l=o.encoding.toLowerCase();return 0<=p.indexOf(l)?null:E(o.encoding)}const A={ibm866:"cp866",big5:"cp950"};function E(t){const u=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return A[u]||u}function a(t){let u="";for(let r=0;r<t.length;r++)u+=String.fromCharCode(t[r]);return u}function s(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const u=t.match(/windows(\d+)/);return u?"windows-"+u[1]:t}}e.toCanonicalName=s;function g({buffer:t,bytesRead:u},r){let i=h(t,u),o=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let l=!0,d=!0,b=!1;for(let _=0;_<u&&_<C;_++){const v=_%2==1,P=t.readUInt8(_)===0;if(P&&(b=!0),l&&(v&&!P||!v&&P)&&(l=!1),d&&(v&&P||!v&&!P)&&(d=!1),P&&!l&&!d)break}b&&(l?i=e.UTF16le:d?i=e.UTF16be:o=!0)}return r&&!o&&!i&&t?D(t.slice(0,u)).then(l=>({seemsBinary:!1,encoding:l})):{seemsBinary:o,encoding:i}}e.detectEncodingFromBuffer=g,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[134],ge([0,1,277,28,133]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends k.TextSearchManager{constructor(S,y,T=L,n="searchProcess"){super(S,y,{readdir:I=>T.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,m.toCanonicalName)(I)},n)}}e.NativeTextSearchManager=C}),define(me[278],ge([0,1,279,294,295,2,296]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function S(I,c,f,h,p,D){const A=D.environment.useHostProxy,E=typeof A=="boolean"?A:!D.remote.isRemote,a=(0,R.createProxyResolver)({resolveProxy:g=>I.resolveProxy(g),getHttpProxySetting:()=>c.getConfiguration("http").get("proxy"),log:(g,t,...u)=>{switch(g){case R.LogLevel.Trace:h.trace(t,...u);break;case R.LogLevel.Debug:h.debug(t,...u);break;case R.LogLevel.Info:h.info(t,...u);break;case R.LogLevel.Warning:h.warn(t,...u);break;case R.LogLevel.Error:h.error(t,...u);break;case R.LogLevel.Critical:h.critical(t,...u);break;case R.LogLevel.Off:break;default:r(g,t,u);break}function r(i,o,...l){h.error("Unknown log level",i),h.error(o,...l)}},getLogLevel:()=>h.getLevel(),proxyResolveTelemetry:g=>{p.$publicLog2("resolveProxy",g)},useHostProxy:E,env:process.env}),s=y(c,a);return n(f,s)}e.connectProxyResolver=S;function y(I,c){const f={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(p=>{f.config=I.getConfiguration("http").get("proxySupport")||"off"});const h={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(p=>{h.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},m,(0,R.createHttpPatch)(m,c,{config:"off"},h,!0)),on:Object.assign({},m,(0,R.createHttpPatch)(m,c,{config:"on"},h,!0)),override:Object.assign({},m,(0,R.createHttpPatch)(m,c,{config:"override"},h,!0)),onRequest:Object.assign({},m,(0,R.createHttpPatch)(m,c,f,h,!0)),default:Object.assign(m,(0,R.createHttpPatch)(m,c,f,h,!1))},https:{off:Object.assign({},L,(0,R.createHttpPatch)(L,c,{config:"off"},h,!0)),on:Object.assign({},L,(0,R.createHttpPatch)(L,c,{config:"on"},h,!0)),override:Object.assign({},L,(0,R.createHttpPatch)(L,c,{config:"override"},h,!0)),onRequest:Object.assign({},L,(0,R.createHttpPatch)(L,c,f,h,!0)),default:Object.assign(L,(0,R.createHttpPatch)(L,c,f,h,!1))},tls:Object.assign(k,(0,R.createTlsPatch)(k))}}const T=new Map;function n(I,c){return I.getExtensionPathIndex().then(f=>{const h=J.__$__nodeRequire("module"),p=h._load;h._load=function(A,E,a){if(A==="tls")return c.tls;if(A!=="http"&&A!=="https")return p.apply(this,arguments);const s=c[A],g=f.findSubstr(C.URI.file(E.filename).fsPath);let t=T.get(g);if(t||T.set(g,t={}),!t[A]){let u=s.default;g&&g.enableProposedApi&&(u=s[g.proxySupport]||s.onRequest),t[A]={...u}}return t[A]}})}}),define(me[280],ge([0,1,39,8,78,29,11,9,93,281]),function(J,e,m,L,k,C,R,S,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const n=T.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(a,s,g,t){const u=c(a,s,g,t),r=s.folder.fsPath;return{cmd:m.spawn(n,u.args,{cwd:r}),rgDiskPath:n,siblingClauses:u.siblingClauses,rgArgs:u,cwd:r}}e.spawnRipgrepCmd=I;function c(a,s,g,t){const u=["--files","--hidden","--case-sensitive"];h([s],g,!1).forEach(i=>{const o=(0,y.anchorGlob)(i);if(u.push("-g",o),R.isMacintosh){const l=(0,k.normalizeNFD)(o);l!==o&&u.push("-g",l)}});const r=f([s],t,void 0,!1);return r.globArgs.forEach(i=>{const o=`!${(0,y.anchorGlob)(i)}`;if(u.push("-g",o),R.isMacintosh){const l=(0,k.normalizeNFD)(o);l!==o&&u.push("-g",l)}}),s.disregardIgnoreFiles!==!1?u.push("--no-ignore"):u.push("--no-ignore-parent"),s.ignoreSymlinks||u.push("--follow"),a.exists&&u.push("--quiet"),u.push("--no-config"),s.disregardGlobalIgnoreFiles&&u.push("--no-ignore-global"),{args:u,siblingClauses:r.siblingClauses}}function f(a,s,g,t=!0){const u=[];let r={};return a.forEach(i=>{const o=Object.assign({},i.excludePattern||{},s||{}),l=p(o,t?i.folder.fsPath:void 0,g);u.push(...l.globArgs),l.siblingClauses&&(r=Object.assign(r,l.siblingClauses))}),{globArgs:u,siblingClauses:r}}e.foldersToRgExcludeGlobs=f;function h(a,s,g=!0){const t=[];return a.forEach(u=>{const r=Object.assign({},s||{},u.includePattern||{}),i=p(r,g?u.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=h;function p(a,s,g){const t=[],u={};return Object.keys(a).forEach(r=>{if(g&&g.has(r)||!r)return;const i=a[r];r=A(s?D(s,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof i=="boolean"&&i?(r.startsWith("\\\\")&&(r+="**"),t.push(E(r))):i&&i.when&&(u[r]=i)}),{globArgs:t,siblingClauses:u}}function D(a,s){return L.isAbsolute(s)?s:L.join(a,s)}e.getAbsoluteGlob=D;function A(a){return a=S.rtrim(a,"\\"),S.rtrim(a,"/")}function E(a){return C.getRoot(a).toLowerCase()==="c:/"?a.replace(/^c:[/\\]/i,"/"):a}e.fixDriveC=E}),define(me[282],ge([0,1,39,50,8,104,17,62,30,78,29,11,46,9,13,28,31,280,101]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const a=new Set;process.on("exit",()=>{a.forEach(r=>r())});class s{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&y.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,E.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&y.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(o=>{const l=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),d=o.folder.fsPath;i.folderQueries.map(b=>b.folder.fsPath).filter(b=>b!==d).forEach(b=>{(0,n.isEqualOrParent)(b,d)&&(l[k.relative(d,b)]=!0)}),this.folderExcludePatterns.set(d,new t(l,d))})}cancel(){this.isCanceled=!0}walk(i,o,l,d,b){if(this.fileWalkSW=c.StopWatch.create(!1),this.isCanceled)return b(null,this.isLimitHit);o.forEach(_=>{const v=k.basename(_.fsPath);this.globalExcludePattern&&this.globalExcludePattern(_.fsPath,v)||this.matchFile(l,{relativePath:_.fsPath,searchPath:void 0})}),this.cmdSW=c.StopWatch.create(!1),this.parallel(i,(_,v)=>{this.call(this.cmdTraversal,this,_,l,d,P=>{if(P){const w=(0,S.toErrorMessage)(P);console.error(w),this.errors.push(w),v(P,void 0)}else v(null,void 0)})},(_,v)=>{this.fileWalkSW.stop();const P=_?R.coalesce(_)[0]:null;b(P,this.isLimitHit)})}parallel(i,o,l){const d=new Array(i.length),b=new Array(i.length);let _=!1,v=0;if(i.length===0)return l(null,[]);i.forEach((P,w)=>{o(P,(F,M)=>{if(F?(_=!0,d[w]=null,b[w]=F):(d[w]=M,b[w]=null),++v===i.length)return l(_?b:null,d)})})}call(i,o,...l){try{i.apply(o,l)}catch(d){l[l.length-1](d)}}cmdTraversal(i,o,l,d){const b=i.folder.fsPath,_=I.isMacintosh;let v;const P=()=>v&&v.kill();a.add(P);let w=O=>{a.delete(P),w=()=>{},d(O)},F="";const M=this.initDirectoryTree();let K;const G=(0,A.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);v=G.cmd,K=!Object.keys(G.siblingClauses).length;const N=G.rgArgs.args.map(O=>O.match(/^-/)?O:`'${O}'`).join(" ");let z=`${G.rgDiskPath} ${N}
 - cwd: ${G.cwd}`;G.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify(G.rgArgs.siblingClauses)}`),l({message:z}),this.cmdResultCount=0,this.collectStdout(v,"utf8",l,(O,x,B)=>{if(O){w(O);return}if(this.isLimitHit){w();return}const H=(F+(_?T.normalizeNFC(x||""):x)).split(`
`);if(B){const W=H.length;H[W-1]=H[W-1].trim(),H[W-1]||H.pop()}else F=H.pop()||"";if(H.length&&H[0].indexOf(`
`)!==-1){w(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=H.length,K){for(const W of H)if(this.matchFile(o,{base:b,relativePath:W,searchPath:this.getSearchPath(i,W)}),this.isLimitHit){P();break}(B||this.isLimitHit)&&w();return}this.addDirectoryEntries(i,M,b,H,o),B&&(this.matchDirectoryTree(M,b,o),w())})}spawnFindCmd(i){const o=this.folderExcludePatterns.get(i.folder.fsPath),l=o.getBasenameTerms(),d=o.getPathTerms(),b=["-L","."];if(l.length||d.length){b.push("-not","(","(");for(const _ of l)b.push("-name",_),b.push("-o");for(const _ of d)b.push("-path",_),b.push("-o");b.pop(),b.push(")","-prune",")")}return b.push("-type","f"),m.spawn("find",b,{cwd:i.folder.fsPath})}readStdout(i,o,l){let d="";this.collectStdout(i,o,()=>{},(b,_,v)=>{if(b){l(b);return}d+=_,v&&l(null,d)})}collectStdout(i,o,l,d){let b=(P,w,F)=>{(P||F)&&(b=()=>{},this.cmdSW&&this.cmdSW.stop()),d(P,w,F)},_=!1;i.stdout?(this.forwardData(i.stdout,o,b),i.stdout.once("data",()=>_=!0)):l({message:"stdout is null"});let v;i.stderr?v=this.collectData(i.stderr):l({message:"stderr is null"}),i.on("error",P=>{b(P)}),i.on("close",P=>{let w;!_&&(w=this.decodeData(v,o))&&u(w)?b(new Error(`command failed with error code ${P}: ${this.decodeData(v,o)}`)):(this.exists&&P===0&&(this.isLimitHit=!0),b(null,"",!0))})}forwardData(i,o,l){const d=new C.StringDecoder(o);return i.on("data",b=>{l(null,d.write(b))}),d}collectData(i){const o=[];return i.on("data",l=>{o.push(l)}),o}decodeData(i,o){const l=new C.StringDecoder(o);return i.map(d=>l.write(d)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:o},l,d,b){d.indexOf(this.filePattern)!==-1&&this.matchFile(b,{base:l,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const _=v=>{const P=k.basename(v),w=k.dirname(v);let F=o[w];F||(F=o[w]=[],_(w)),F.push({base:l,relativePath:v,basename:P,searchPath:this.getSearchPath(i,v)})};d.forEach(_)}matchDirectoryTree({rootEntries:i,pathToEntries:o},l,d){const b=this,_=this.folderExcludePatterns.get(l),v=this.filePattern;function P(w){b.directoriesWalked++;const F=y.hasSiblingFn(()=>w.map(M=>M.basename));for(let M=0,K=w.length;M<K;M++){const G=w[M],{relativePath:N,basename:z}=G;if(_.test(N,z,v!==z?F:void 0))continue;const O=o[N];if(O)P(O);else{if(b.filesWalked++,N===v)continue;b.matchFile(d,G)}if(b.isLimitHit)break}}P(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,o,l,d,b){const _=i.folder,v=y.hasSiblingFn(()=>l);this.parallel(l,(P,w)=>{if(this.isCanceled||this.isLimitHit)return w(null);const F=o?[o,P].join(k.sep):P;if(this.folderExcludePatterns.get(i.folder.fsPath).test(F,P,this.config.filePattern!==P?v:void 0))return w(null);const M=[_.fsPath,F].join(k.sep);L.lstat(M,(K,G)=>{if(K||this.isCanceled||this.isLimitHit)return w(null);this.statLinkIfNeeded(M,G,(N,z)=>N||this.isCanceled||this.isLimitHit?w(null):z.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(M,G,(O,x)=>O||this.isCanceled||this.isLimitHit||(x=x||"",this.walkedPaths[x])?w(null):(this.walkedPaths[x]=!0,p.Promises.readdir(M).then(B=>{if(this.isCanceled||this.isLimitHit)return w(null);this.doWalk(i,F,B,d,U=>w(U||null))},B=>{w(null)})))):(this.filesWalked++,F===this.filePattern||this.maxFilesize&&h.isNumber(z.size)&&z.size>this.maxFilesize||this.matchFile(d,{base:_.fsPath,relativePath:F,searchPath:this.getSearchPath(i,F)}),w(null,void 0)))})},P=>{const w=P&&R.coalesce(P);return b(w&&w.length>0?w[0]:void 0)})}matchFile(i,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,k.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(o))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,D.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,o,l){return o.isSymbolicLink()?L.stat(i,l):l(null,o)}realPathIfNeeded(i,o,l){return o.isSymbolicLink()?L.realpath(i,(d,b)=>d?l(d):l(null,b)):l(null,i)}getSearchPath(i,o){return i.folderName?k.join(i.folderName,o):o}}e.FileWalker=s;class g{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new s(i)}search(i,o,l){this.walker.walk(this.folderQueries,this.extraFiles,i,o,(d,b)=>{l(d,{limitHit:b,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class t{constructor(i,o){this.expression=i,this.root=o,this.init(i)}init(i){let o,l;Object.keys(i).filter(d=>i[d]).forEach(d=>{k.isAbsolute(d)?(o=o||y.getEmptyExpression(),o[d]=i[d]):(l=l||y.getEmptyExpression(),l[d]=i[d])}),this.absoluteParsedExpr=o&&y.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=l&&y.parse(l,{trimForExclusions:!0})}test(i,o,l){return this.relativeParsedExpr&&this.relativeParsedExpr(i,o,l)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,i),o,l)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getPathTerms(this.relativeParsedExpr)),i}}function u(r){const i=r.trim().split(`
`),o=i[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return f.uppercaseFirstLetter(i[i.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=u}),define(me[135],ge([0,1,39,297,104,17,58,30,8,9,2,31,71,298,281,93]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const D=h.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class A{constructor(_){this.outputChannel=_}provideTextSearchResults(_,v,P,w){return this.outputChannel.appendLine(`provideTextSearchResults ${_.pattern}, ${JSON.stringify({...v,folder:v.folder.toString()})}`),new Promise((F,M)=>{w.onCancellationRequested(()=>U());const K=u(_,v),G=v.folder.fsPath,N=K.map(he=>he.match(/^-/)?he:`'${he}'`).join(" ");this.outputChannel.appendLine(`${D} ${N}
 - cwd: ${G}`);let z=m.spawn(D,K,{cwd:G});z.on("error",he=>{console.error(he),this.outputChannel.appendLine("Error: "+(he&&he.message)),M((0,I.serializeSearchError)(new I.SearchError(he&&he.message,I.SearchErrorCode.rgProcessError)))});let O=!1;const x=new s(v.maxResults,G,v.previewOptions);x.on("result",he=>{O=!0,W="",P.report(he)});let B=!1;const U=()=>{B=!0,z&&z.kill(),x&&x.cancel()};let H=!1;x.on("hitLimit",()=>{H=!0,U()});let W="";z.stdout.on("data",he=>{x.handleData(he),O||(W+=he)});let Q=!1;z.stdout.once("data",()=>Q=!0);let Y="";z.stderr.on("data",he=>{const _e=he.toString();this.outputChannel.appendLine(_e),Y+=_e}),z.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(O?"Got result from parser":"No result from parser"),W&&this.outputChannel.appendLine(`Got data without result: ${W}`),this.outputChannel.appendLine(""),B)F({limitHit:H});else{x.flush(),z=null;let he;Y&&!Q&&(he=E(Y))?M((0,I.serializeSearchError)(new I.SearchError(he.message,he.code))):F({limitHit:H})}})})}}e.RipgrepTextSearchEngine=A;function E(b){const _=b.split(`
`),v=_[0].trim();if(_.some(w=>w.startsWith("regex parse error")))return new I.SearchError(a(_),I.SearchErrorCode.regexParseError);const P=v.match(/grep config error: unknown encoding: (.*)/);if(P)return new I.SearchError(`Unknown encoding: ${P[1]}`,I.SearchErrorCode.unknownEncoding);if(v.startsWith("error parsing glob"))return new I.SearchError(v.charAt(0).toUpperCase()+v.substr(1),I.SearchErrorCode.globParseError);if(v.startsWith("the literal"))return new I.SearchError(v.charAt(0).toUpperCase()+v.substr(1),I.SearchErrorCode.invalidLiteral);if(v.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(v,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=E;function a(b){const _=["Regex parse error"],v=b.filter(P=>P.startsWith("PCRE2:"));if(v.length>=1){const P=v[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const w=P.split(":")[1];_.push(":"+w)}}return _.join("")}e.buildRegexParseError=a;class s extends L.EventEmitter{constructor(_,v,P){super();this.maxResults=_,this.rootFolder=v,this.previewOptions=P,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(_,v){return super.on(_,v),this}handleData(_){if(this.isDone)return;const v=typeof _=="string"?_:this.stringDecoder.write(_);this.handleDecodedData(v)}handleDecodedData(_){let v=_.indexOf(`
`);const P=this.remainder+_;if(v>=0)v+=this.remainder.length;else{this.remainder=P;return}let w=0;for(;v>=0;)this.handleLine(P.substring(w,v).trim()),w=v+1,v=P.indexOf(`
`,w);this.remainder=P.substring(w)}handleLine(_){if(this.isDone||!_)return;let v;try{v=JSON.parse(_)}catch(P){throw new Error(`malformed line from rg: ${_}`)}if(v.type==="match"){const P=g(v.data.path),w=n.URI.file(y.join(this.rootFolder,P)),F=this.createTextSearchMatch(v.data,w);this.onResult(F),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(v.type==="context"){const P=g(v.data.path),w=n.URI.file(y.join(this.rootFolder,P));this.createTextSearchContext(v.data,w).forEach(M=>this.onResult(M))}}createTextSearchMatch(_,v){const P=_.line_number-1,w=g(_.lines),F=Buffer.from(w);let M=0,K=0,G=P;_.submatches.length===0&&_.submatches.push(w.length?{start:0,end:1,match:{text:w[0]}}:{start:0,end:0,match:{text:""}});const N=(0,C.coalesce)(_.submatches.map((z,O)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const x=g(z.match),B=F.slice(M,z.start).toString().length,U=K+B,H=t(x),W=G,Q=H.numLines+W,Y=H.numLines>0?H.lastLineLength:H.lastLineLength+U;return M=z.end,K=Y,G=Q,new c.Range(W,U,Q,Y)}));return(0,p.createTextSearchResult)(v,w,N,this.previewOptions)}createTextSearchContext(_,v){const P=g(_.lines),w=_.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((F,M)=>({text:F,uri:v,lineNumber:w+M}))}onResult(_){this.emit("result",_)}}e.RipgrepParser=s;function g(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const _=/\n/g;let v=0,P=-1,w;for(;w=_.exec(b);)v++,P=w.index;const F=P>=0?b.length-P-1:b.length;return{numLines:v,lastLineLength:F}}function u(b,_){const v=["--hidden"];v.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:w}=(0,R.groupBy)(_.includes,M=>M.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(w&&w.length){const M=new Set;w.forEach(K=>{M.add(K)}),v.push("-g","!*"),M.forEach(K=>{r(K).map(p.anchorGlob).forEach(G=>{v.push("-g",G)})})}P&&P.length&&P.forEach(M=>{v.push("-g",M)}),_.excludes.map(p.anchorGlob).forEach(M=>v.push("-g",`!${M}`)),_.maxFileSize&&v.push("--max-filesize",_.maxFileSize+""),_.useIgnoreFiles?v.push("--no-ignore-parent"):v.push("--no-ignore"),_.followSymlinks&&v.push("--follow"),_.encoding&&_.encoding!=="utf8"&&v.push("--encoding",_.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,T.escapeRegExpCharacters)(b.pattern),b.isRegExp=!0),_.usePCRE2&&v.push("--pcre2"),v.push("--crlf"),b.isRegExp&&(b.pattern=i(b.pattern),v.push("--auto-hybrid-regex"));let F;if(b.isWordMatch){const K=(0,T.createRegExp)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");v.push("--regexp",K)}else if(b.isRegExp){let M=l(b.pattern);M=d(M),v.push("--regexp",M)}else F=b.pattern,v.push("--fixed-strings");return v.push("--no-config"),_.useGlobalIgnoreFiles||v.push("--no-ignore-global"),v.push("--json"),b.isMultiline&&v.push("--multiline"),_.beforeContext&&v.push("--before-context",_.beforeContext+""),_.afterContext&&v.push("--after-context",_.afterContext+""),v.push("--"),F&&v.push(F),v.push("."),v}function r(b){const _=(0,S.splitGlobAware)(b,"/");return _.map((v,P)=>_.slice(0,P+1).join("/"))}e.spreadGlobComponents=r;function i(b){const _=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(_);)b=b.replace(_,"$1\\x{$2}");const v=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(v);)b=b.replace(v,"$1\\x{$2}");return b}e.unicodeEscapesToPCRE2=i;const o=b=>b.type==="Assertion"&&b.kind==="lookbehind";function l(b){let _;try{_=new f.RegExpParser().parsePattern(b)}catch{return b}let v="",P=0;const w=(K,G,N)=>{v+=b.slice(P,K)+N,P=G},F=[];return new f.RegExpVisitor({onCharacterEnter(K){if(K.raw!=="\\n")return;const G=F[0];if(!G)w(K.start,K.end,"\\r?\\n");else if(!F.some(o))if(G.type==="CharacterClass")if(G.negate){const N=b.slice(G.start+2,K.start)+b.slice(K.end,G.end-1);w(G.start,G.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=b.slice(G.start+1,K.start)+b.slice(K.end,G.end-1);w(G.start,G.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else G.type==="Quantifier"&&w(K.start,K.end,"(?:\\r?\\n)")},onQuantifierEnter(K){F.unshift(K)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(K){F.unshift(K)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(K){F.unshift(K)},onCharacterClassLeave(){F.shift()},onAssertionEnter(K){o(K)&&F.push(K)},onAssertionLeave(K){F[0]===K&&F.shift()}}).visit(_),v+=b.slice(P),v}e.fixRegexNewline=l;function d(b){return b.replace(/\n/g,"\\r?\\n")}e.fixNewline=d}),define(me[283],ge([0,1,21,135,118,10]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class R{constructor(T){this.outputChannel=T,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(T,n,I,c){const f=new L.RipgrepTextSearchEngine(this.outputChannel);if(n.folder.scheme===C.Schemas.userData){const h={...n,folder:n.folder.with({scheme:C.Schemas.file})},p=new k.Progress(D=>I.report({...D,uri:D.uri.with({scheme:n.folder.scheme})}));return this.withToken(c,D=>f.provideTextSearchResults(T,h,p,D))}else return this.withToken(c,h=>f.provideTextSearchResults(T,n,I,h))}async withToken(T,n){const I=S(T);this.inProgress.add(I);const c=await n(I.token);return this.inProgress.delete(I),c}dispose(){this.inProgress.forEach(T=>T.cancel())}}e.RipgrepSearchProvider=R;function S(y){const T=new m.CancellationTokenSource;return y.onCancellationRequested(()=>T.cancel()),T}}),define(me[284],ge([0,1,28,135,134]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(y){this.query=y}search(y,T,n){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(f){n({message:f})}},c=new k.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(I),m);return new Promise((f,h)=>c.search(p=>{T(p.map(R))},y).then(p=>f({limitHit:p.limitHit,type:"success",stats:p.stats}),h))}}e.TextSearchEngineAdapter=C;function R(S){return{path:S.resource&&S.resource.fsPath,results:S.results,numMatches:(S.results||[]).reduce((y,T)=>{if(T.ranges){const n=T;return y+(Array.isArray(n.ranges)?n.ranges.length:1)}else return y+1},0)}}}),define(me[285],ge([0,1,50,299,17,18,16,3,101,8,46,2,43,31,282,284]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,L.gracefulify(m);class D{constructor(t="searchProcess"){this.processType=t,this.caches=Object.create(null)}fileSearch(t){let u;const r=a(t),i=new S.Emitter({onFirstListenerDidAdd:()=>{u=(0,C.createCancelablePromise)(o=>this.doFileSearchWithEngine(h.Engine,r,l=>i.fire(l),o)),u.then(o=>i.fire(o),o=>i.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{u.cancel()}});return i.event}textSearch(t){let u;const r=a(t),i=new S.Emitter({onFirstListenerDidAdd:()=>{u=(0,C.createCancelablePromise)(o=>this.ripgrepTextSearch(r,l=>i.fire(l),o)),u.then(o=>i.fire(o),o=>i.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{u.cancel()}});return i.event}ripgrepTextSearch(t,u,r){return t.maxFileSize=(0,c.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new p.TextSearchEngineAdapter(t).search(r,u,u)}doFileSearch(t,u,r){return this.doFileSearchWithEngine(h.Engine,t,u,r)}doFileSearchWithEngine(t,u,r,i,o=D.BATCH_SIZE){let l=0;const d=_=>{Array.isArray(_)?(l+=_.length,r(_.map(v=>this.rawMatchToSearchItem(v)))):_.relativePath?(l++,r(this.rawMatchToSearchItem(_))):r(_)};if(u.sortByScore){let _=this.trySortedSearchFromCache(u,d,i);if(!_){const v=u.maxResults?Object.assign({},u,{maxResults:null}):u,P=new t(v);_=this.doSortedSearch(P,u,r,d,i)}return new Promise((v,P)=>{_.then(([w,F])=>{const M=F.map(K=>this.rawMatchToSearchItem(K));this.sendProgress(M,r,o),v(w)},P)})}const b=new t(u);return this.doSearch(b,d,o,i).then(_=>({limitHit:_.limitHit,type:"success",stats:{detailStats:_.stats,type:this.processType,fromCache:!1,resultCount:l,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,T.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,u,r,i,o){const l=new S.Emitter;let d=(0,C.createCancelablePromise)(_=>{let v=[];const P=w=>{Array.isArray(w)?v=w:(i(w),l.fire(w))};return this.doSearch(t,P,-1,_).then(w=>[w,v])}),b;if(u.cacheKey){b=this.getOrCreateCache(u.cacheKey);const _={promise:d,event:l.event,resolved:!1};b.resultsToSearchCache[u.filePattern||""]=_,d.then(()=>{_.resolved=!0},v=>{delete b.resultsToSearchCache[u.filePattern||""]}),d=this.preventCancellation(d)}return d.then(([_,v])=>{const P=b?b.scorerCache:Object.create(null),w=(typeof u.maxResults!="number"||u.maxResults>0)&&n.StopWatch.create(!1);return this.sortResults(u,v,P,o).then(F=>{const M=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:_.stats,sortingTime:M,fromCache:!1,type:this.processType,workspaceFolderCount:u.folderQueries.length,resultCount:F.length},messages:_.messages,limitHit:_.limitHit||typeof u.maxResults=="number"&&v.length>u.maxResults},F]})})}getOrCreateCache(t){const u=this.caches[t];return u||(this.caches[t]=new A)}trySortedSearchFromCache(t,u,r){const i=t.cacheKey&&this.caches[t.cacheKey];if(!i)return;const o=this.getResultsFromCache(i,t.filePattern||"",u,r);if(o)return o.then(([l,d,b])=>{const _=n.StopWatch.create(!1);return this.sortResults(t,d,i.scorerCache,r).then(v=>{const P=_.elapsed(),w={fromCache:!0,detailStats:b,type:this.processType,resultCount:d.length,sortingTime:P};return[{type:"success",limitHit:l.limitHit||typeof t.maxResults=="number"&&d.length>t.maxResults,stats:w},v]})})}sortResults(t,u,r,i){const o=(0,y.prepareQuery)(t.filePattern||""),l=(b,_)=>(0,y.compareItemsByFuzzyScore)(b,_,o,!0,E,r),d=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return k.topAsync(u,l,d,1e4,i)}sendProgress(t,u,r){if(r&&r>0)for(let i=0;i<t.length;i+=r)u(t.slice(i,i+r));else u(t)}getResultsFromCache(t,u,r,i){const o=n.StopWatch.create(!1),l=u.indexOf(T.sep)>=0;let d;for(const P in t.resultsToSearchCache)if(u.startsWith(P)){if(l&&P.indexOf(T.sep)<0&&P!=="")continue;const w=t.resultsToSearchCache[P];d={promise:this.preventCancellation(w.promise),event:w.event,resolved:w.resolved};break}if(!d)return null;const b=o.elapsed(),_=n.StopWatch.create(!1),v=d.event(r);return i&&i.onCancellationRequested(()=>{v.dispose()}),d.promise.then(([P,w])=>{if(i&&i.isCancellationRequested)throw(0,R.canceled)();const F=[],M=(0,y.prepareQuery)(u).normalizedLowercase;for(const K of w)!(0,f.isFilePatternMatch)(K,M)||F.push(K);return[P,F,{cacheWasResolved:d.resolved,cacheLookupTime:b,cacheFilterTime:_.elapsed(),cacheEntryCount:w.length}]})}doSearch(t,u,r,i){return new Promise((o,l)=>{let d=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(b=>{b&&(r?(d.push(b),r>0&&d.length>=r&&(u(d),d=[])):u(b))},b=>{u(b)},(b,_)=>{d.length&&u(d),b?l(b):o(_)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(u,r){return t.then(u,r)}catch(u){return this.then(void 0,u)}finally(u){return t.finally(u)}}}}e.SearchService=D,D.BATCH_SIZE=512;class A{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(g){return(0,T.basename)(g.relativePath)}getItemDescription(g){return(0,T.dirname)(g.relativePath)}getItemPath(g){return g.relativePath}};function a(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(s),extraFileResources:g.extraFileResources&&g.extraFileResources.map(t=>I.URI.revive(t))}}function s(g){return{...g,folder:I.URI.revive(g.folder)}}}),define(me[286],ge([0,1,6,10,2,28,12,27,14,74,66,31,285,283,93,134]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let D=class extends T.ExtHostSearch{constructor(E,a,s,g){super(E,s,g);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const t=new h.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new f.RipgrepSearchProvider(t)),a.remote.isRemote&&a.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const E=new h.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new f.RipgrepSearchProvider(E)),this.registerInternalFileSearchProvider(L.Schemas.file,new c.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(E,a){const s=this._handlePool++;return this._internalFileSearchProvider=a,this._internalFileSearchHandle=s,this._proxy.$registerFileSearchProvider(s,this._transformScheme(E)),(0,m.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(s)})}$provideFileSearchResults(E,a,s,g){const t=(0,T.reviveQuery)(s);return E===this._internalFileSearchHandle?this.doInternalFileSearch(E,a,t,g):super.$provideFileSearchResults(E,a,s,g)}doInternalFileSearch(E,a,s,g){const t=u=>{if((0,I.isSerializedFileMatch)(u)&&(u=[u]),Array.isArray(u)){this._proxy.$handleFileMatch(E,a,u.map(r=>k.URI.file(r.path)));return}u.message&&this._logService.debug("ExtHostSearch",u.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(s,t,g)}$clearCache(E){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(E),super.$clearCache(E)}createTextSearchManager(E,a){return new p.NativeTextSearchManager(E,a,void 0,"textSearchProvider")}};D=Ve([$e(0,y.IExtHostRpcService),$e(1,S.IExtHostInitDataService),$e(2,n.IURITransformerService),$e(3,R.ILogService)],D),e.NativeExtHostSearch=D}),define(me[136],ge([0,1,300,125,80,22,16,3,6,8,11,32,106,107,301]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{constructor(d){this.socket=d,this._errorListener=b=>{if(b){if(b.code==="EPIPE")return;(0,R.onUnexpectedError)(b)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(d){const b=_=>d(C.VSBuffer.wrap(_));return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(d){const b=_=>{d({type:0,hadError:_,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(d){return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(d){if(!this.socket.destroyed)try{this.socket.write(d.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,R.onUnexpectedError)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,R.onUnexpectedError)(b)}}end(){this.socket.end()}drain(){return new Promise((d,b)=>{if(this.socket.bufferSize===0){d();return}const _=()=>{this.socket.off("close",_),this.socket.off("end",_),this.socket.off("error",_),this.socket.off("timeout",_),this.socket.off("drain",_),d()};this.socket.on("close",_),this.socket.on("end",_),this.socket.on("error",_),this.socket.on("timeout",_),this.socket.on("drain",_)})}}e.NodeSocket=p;var D;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(D||(D={}));var A;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(A||(A={}));class E extends y.Disposable{constructor(d,b,_,v){super();this._onDidZlibFlush=this._register(new S.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=d,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=b,this._recordInflateBytes=v,b?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",P=>{console.error(P),(0,R.onUnexpectedError)(P),this._onClose.fire({type:0,hadError:!0,error:P})}),this._zlibInflate.on("data",P=>{this._pendingInflateData.push(P)}),_&&(this._zlibInflate.write(_.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",P=>{console.error(P),(0,R.onUnexpectedError)(P),this._onClose.fire({type:0,hadError:!0,error:P})}),this._zlibDeflate.on("data",P=>{this._pendingDeflateData.push(P)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new f.ChunkStream,this._register(this.socket.onData(P=>this._acceptChunk(P))),this._register(this.socket.onClose(P=>this._onClose.fire(P)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){this._totalOutgoingDataBytes+=d.byteLength,this._zlibDeflate?(this._zlibDeflate.write(d.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let b=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,b=b.slice(0,b.length-4),this._isEnded||this._write(C.VSBuffer.wrap(b),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(d,!1)}_write(d,b){let _=2;d.byteLength<126?_+=0:d.byteLength<2**16?_+=2:_+=8;const v=C.VSBuffer.alloc(_);if(b?v.writeUInt8(194,0):v.writeUInt8(130,0),d.byteLength<126)v.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){v.writeUInt8(126,1);let P=1;v.writeUInt8(d.byteLength>>>8&255,++P),v.writeUInt8(d.byteLength>>>0&255,++P)}else{v.writeUInt8(127,1);let P=1;v.writeUInt8(0,++P),v.writeUInt8(0,++P),v.writeUInt8(0,++P),v.writeUInt8(0,++P),v.writeUInt8(d.byteLength>>>24&255,++P),v.writeUInt8(d.byteLength>>>16&255,++P),v.writeUInt8(d.byteLength>>>8&255,++P),v.writeUInt8(d.byteLength>>>0&255,++P)}this._totalOutgoingWireBytes+=v.byteLength+d.byteLength,this.socket.write(C.VSBuffer.concat([v,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._totalIncomingWireBytes+=d.byteLength,this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const b=this._incomingData.peek(this._state.readLen),v=(b.readUInt8(0)&128)>>>7,P=b.readUInt8(1),w=(P&128)>>>7,F=P&127;this._state.state=2,this._state.readLen=2+(w?4:0)+(F===126?2:0)+(F===127?8:0),this._state.fin=v,this._state.mask=0}else if(this._state.state===2){const b=this._incomingData.read(this._state.readLen),_=b.readUInt8(1),v=(_&128)>>>7;let P=_&127,w=1;P===126?P=b.readUInt8(++w)*2**8+b.readUInt8(++w):P===127&&(P=b.readUInt8(++w)*0+b.readUInt8(++w)*0+b.readUInt8(++w)*0+b.readUInt8(++w)*0+b.readUInt8(++w)*2**24+b.readUInt8(++w)*2**16+b.readUInt8(++w)*2**8+b.readUInt8(++w));let F=0;v&&(F=b.readUInt8(++w)*2**24+b.readUInt8(++w)*2**16+b.readUInt8(++w)*2**8+b.readUInt8(++w)),this._state.state=3,this._state.readLen=P,this._state.mask=F}else if(this._state.state===3){const b=this._incomingData.read(this._state.readLen);a(b,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(b.buffer)),this._zlibInflate.write(b.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const _=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=_.length,this._onData.fire(C.VSBuffer.wrap(_))})):(this._totalIncomingDataBytes+=b.byteLength,this._onData.fire(b))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await S.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=E;function a(l,d){if(d===0)return;let b=l.byteLength>>>2;for(let M=0;M<b;M++){const K=l.readUInt32BE(M*4);l.writeUInt32BE(K^d,M*4)}let _=b*4,v=l.byteLength-_;const P=d>>>24&255,w=d>>>16&255,F=d>>>8&255;v>=1&&l.writeUInt8(l.readUInt8(_)^P,_),v>=2&&l.writeUInt8(l.readUInt8(_+1)^w,_+1),v>=3&&l.writeUInt8(l.readUInt8(_+2)^F,_+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const s={[2]:107,[1]:103};function g(){const l=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let d;return e.XDG_RUNTIME_DIR?d=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):d=(0,T.join)((0,k.tmpdir)(),`vscode-ipc-${l}.sock`),u(d),d}e.createRandomIPCHandle=g;function t(l,d,b){const _=(0,m.createHash)("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${_}-${b}-${d}-sock`;let v;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?v=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${_.substr(0,8)}-${b}-${d}.sock`):v=(0,T.join)(l,`${b}-${d}.sock`),u(v),v}e.createStaticIPCHandle=t;function u(l){const d=s[n.platform];typeof d=="number"&&l.length>=d&&console.warn(`WARNING: IPC handle "${l}" is longer than ${d} chars, try a shorter --user-data-dir`)}class r extends c.IPCServer{constructor(d){super(r.toClientConnectionEvent(d));this.server=d}static toClientConnectionEvent(d){const b=S.Event.fromNodeEventEmitter(d,"connection");return S.Event.map(b,_=>({protocol:new f.Protocol(new p(_)),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(_,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function i(l){return new Promise((d,b)=>{const _=(0,L.createServer)();_.on("error",b),_.listen(l,()=>{_.removeListener("error",b),d(new r(_))})})}e.serve=i;function o(l,d){return new Promise((b,_)=>{const v=(0,L.createConnection)(l,()=>{v.removeListener("error",_),b(f.Client.fromSocket(new p(v),d))});v.once("error",_)})}e.connect=o}),define(me[287],ge([0,1,136,279,50,40,2,199,12]),function(J,e,m,L,k,C,R,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class T{constructor(c,f,h){this._commands=c,this.logService=f,this._ipcHandlePath=h,this._server=L.createServer((p,D)=>this.onRequest(p,D)),this.setup().catch(p=>(f.error(p),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",c=>this.logService.error(c))}catch(c){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(c,f){const h=[];c.setEncoding("utf8"),c.on("data",p=>h.push(p)),c.on("end",()=>{const p=JSON.parse(h.join(""));switch(p.type){case"open":this.open(p,f);break;case"openExternal":this.openExternal(p,f);break;case"status":this.getStatus(p,f);break;case"extensionManagement":this.manageExtensions(p,f).catch(this.logService.error);break;default:f.writeHead(404),f.write(`Unknown message type: ${p.type}`,D=>{D&&this.logService.error(D)}),f.end();break}})}open(c,f){let{fileURIs:h,folderURIs:p,forceNewWindow:D,diffMode:A,addMode:E,forceReuseWindow:a,gotoLineMode:s,waitMarkerFilePath:g}=c;const t=[];if(Array.isArray(p))for(const u of p)try{t.push({folderUri:R.URI.parse(u)})}catch(r){}if(Array.isArray(h))for(const u of h)try{(0,S.hasWorkspaceFileExtension)(u)?t.push({workspaceUri:R.URI.parse(u)}):t.push({fileUri:R.URI.parse(u)})}catch(r){}if(t.length){const u=g?R.URI.file(g):void 0,i={forceNewWindow:D,diffMode:A,addMode:E,gotoLineMode:s,forceReuseWindow:a,preferNewWindow:!a&&!u&&!E,waitMarkerFileURI:u};this._commands.executeCommand("_remoteCLI.windowOpen",t,i)}f.writeHead(200),f.end()}async openExternal(c,f){for(const h of c.uris){const p=R.URI.parse(h),D=p.scheme==="file"?p:h;await this._commands.executeCommand("_remoteCLI.openExternal",D)}f.writeHead(200),f.end()}async manageExtensions(c,f){try{const h=A=>A?.map(E=>/\.vsix$/i.test(E)?R.URI.parse(E):E),p={list:c.list,install:h(c.install),uninstall:h(c.uninstall),force:c.force},D=await this._commands.executeCommand("_remoteCLI.manageExtensions",p);f.writeHead(200),f.write(D)}catch(h){f.writeHead(500),f.write(String(h),p=>{p&&this.logService.error(p)})}f.end()}async getStatus(c,f){try{const h=await this._commands.executeCommand("_remoteCLI.getSystemStatus");f.writeHead(200),f.write(h),f.end()}catch(h){f.writeHead(500),f.write(String(h),p=>{p&&this.logService.error(p)}),f.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=T;let n=class extends T{constructor(c,f){super(c,f,(0,m.createRandomIPCHandle)())}};n=Ve([$e(0,C.IExtHostCommands),$e(1,y.ILogService)],n),e.CLIServer=n}),define(me[288],ge([0,1,73,275,270,5,278,41,260,2,10,7,287,105]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends k.RequireInterceptor{_installInterceptor(){const A=this,E=J.__$__nodeRequire("module"),a=E._load;E._load=function(g,t,u){for(let r of A._alternatives){let i=r(g);if(i){g=i;break}}return A._factories.has(g)?A._factories.get(g).load(g,T.URI.file((0,f.realpathSync)(t.filename)),r=>a.apply(this,[r,t,u])):a.apply(this,arguments)}}}class p extends S.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const A=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(c.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(h,A,this._registry).install(),m.mark("code/extHost/didInitAPI");const a=await this._extHostConfiguration.getConfigProvider();await(0,R.connectProxyResolver)(this._extHostWorkspace,a,this,this._logService,this._mainThreadTelemetryProxy,this._initData),m.mark("code/extHost/didInitProxyResolver");const s=process.send,g=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?s.apply(process,t):(g.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(A){return A.main}_loadCommonJSModule(A,E,a){if(E.scheme!==n.Schemas.file)throw new Error(`Cannot load URI: '${E}', must be of file-scheme`);let s=null;a.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${E.toString(!0)}`),this._logService.flush();try{A&&m.mark(`code/extHost/willLoadExtensionCode/${A.value}`),s=J.__$__nodeRequire(E.fsPath)}catch(g){return Promise.reject(g)}finally{A&&m.mark(`code/extHost/didLoadExtensionCode/${A.value}`),a.codeLoadingStop()}return Promise.resolve(s)}async $setRemoteEnvironment(A){if(!!this._initData.remote.isRemote)for(const E in A){const a=A[E];a===null?delete process.env[E]:process.env[E]=a}}}e.ExtHostExtensionService=p}),define(me[289],ge([0,1,82,261,263,272,271,286,288,228,264,56,41,68,74,72,33,53,12,69,262]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D,A,E,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(c.IExtHostExtensionService,y.ExtHostExtensionService),(0,m.registerSingleton)(E.ILogService,T.ExtHostLogService),(0,m.registerSingleton)(a.IExtensionStoragePaths,s.ExtensionStoragePaths),(0,m.registerSingleton)(I.IExtHostDebugService,R.ExtHostDebugService),(0,m.registerSingleton)(f.IExtHostOutputService,L.ExtHostOutputService2),(0,m.registerSingleton)(h.IExtHostSearch,S.NativeExtHostSearch),(0,m.registerSingleton)(p.IExtHostTask,C.ExtHostTask),(0,m.registerSingleton)(D.IExtHostTerminalService,k.ExtHostTerminalService),(0,m.registerSingleton)(A.IExtHostTunnelService,n.ExtHostTunnelService)}),define(me[290],ge([0,1,125,302,73,16,107,136,192,226,273,22,103,28,105,18,114,276,289]),function(J,e,m,L,k,C,R,S,y,T,n,I,c,f,h,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let o=0;o<process.execArgv.length;o++)process.execArgv[o]==="--inspect-port=0"&&(process.execArgv.splice(o,1),o--)}();const A=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const i=J.__$__nodeRequire("module"),o=i._load;i._load=function(l){if(l==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return o.apply(this,arguments)}})();const E=process.exit.bind(process);function a(i){process.exit=function(o){if(i)E(o);else{const l=new Error("An extension called process.exit() and this was prevented.");console.warn(l.stack)}},process.crash=function(){const o=new Error("An extension called process.crash() and this was prevented.");console.warn(o.stack)}}let s=function(i){E()};function g(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,o)=>{let l=null,d=setTimeout(()=>{s("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const b=108e5,_=3e5,v=new p.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (1)"),b),P=new p.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (2)"),_);process.on("message",(F,M)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){const K=I.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let G;if(F.skipWebSocketFrames)G=new S.NodeSocket(M);else{const N=I.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));G=new S.WebSocketNodeSocket(new S.NodeSocket(M),F.permessageDeflate,N,!1)}l?(v.cancel(),P.cancel(),l.beginAcceptReconnection(G,K),l.endAcceptReconnection()):(clearTimeout(d),l=new R.PersistentProtocol(G,K),l.onDidDispose(()=>s("renderer disconnected")),i(l),l.onSocketClose(()=>{v.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(P.isScheduled())return;v.isScheduled()&&P.schedule()}});const w={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(w)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((o,l)=>{const d=m.createConnection(i,()=>{d.removeListener("error",l),o(new R.PersistentProtocol(new S.NodeSocket(d)))});d.once("error",l),d.on("close",()=>{s("renderer closed the socket")})})}}async function t(){const i=await g();return new class{constructor(){this._onMessage=new R.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(o=>{(0,T.isMessageOfType)(o,2)?(this._terminating=!0,s("received terminate message from renderer")):this._onMessage.fire(o)})}send(o){this._terminating||i.send(o)}drain(){return i.drain()}}}function u(i){return new Promise(o=>{const l=i.onMessage(d=>{l.dispose();const b=JSON.parse(d.toString()),_=b.commit,v=y.default.commit;_&&v&&_!==v&&E(55);const P=[];process.on("unhandledRejection",(M,K)=>{P.push(K),setTimeout(()=>{const G=P.indexOf(K);G>=0&&K.catch(N=>{P.splice(G,1),(0,C.isPromiseCanceledError)(N)||(console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),(0,C.onUnexpectedError)(M))})},1e3)}),process.on("rejectionHandled",M=>{const K=P.indexOf(M);K>=0&&P.splice(K,1)}),process.on("uncaughtException",function(M){(0,C.onUnexpectedError)(M)});let w=0;setInterval(function(){try{process.kill(b.parentPid,0),w=0}catch(M){M&&M.code==="EPERM"?(w++,w>=3&&s(`parent process ${b.parentPid} does not exist anymore (3 x EPERM): ${M.message} (code: ${M.code}) (errno: ${M.errno})`)):s(`parent process ${b.parentPid} does not exist anymore: ${M.message} (code: ${M.code}) (errno: ${M.errno})`)}},1e3);let F;try{F=J.__$__nodeRequire("native-watchdog"),F.start(b.parentPid)}catch(M){(0,C.onUnexpectedError)(M)}i.send((0,T.createMessageOfType)(0)),o({protocol:i,initData:b})});i.send((0,T.createMessageOfType)(1))})}async function r(){k.mark("code/extHost/willConnectToRenderer");const i=await t();k.mark("code/extHost/didConnectToRenderer");const o=await u(i);k.mark("code/extHost/didWaitForInitData");const{initData:l}=o;a(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=A.useHostProxy!==void 0?A.useHostProxy!=="false":void 0,l.environment.skipWorkspaceStorageLock=(0,D.boolean)(A.skipWorkspaceStorageLock,!1);const d=new class{exit(P){E(P)}exists(P){return f.Promises.exists(P)}realpath(P){return(0,h.realpath)(P)}};let b=null;if(l.remote.authority&&A.uriTransformerPath)try{const P=J.__$__nodeRequire(A.uriTransformerPath)(l.remote.authority);b=new c.URITransformer(P)}catch(v){console.error(v)}const _=new n.ExtensionHostMain(o.protocol,l,d,b);s=v=>_.terminate(v)}e.startExtensionHostProcess=r}),define(me[303],ge([0,1,290]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/da10782b86bd9d895ccb20be4514b19728036951/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
